/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern0 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern10 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !shift_count_operand (operands[2], E_QImode))
    return -1;
  return 0;
}

int
pattern13 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_V1QImode:
      return pattern12 (x1, 
E_V1QImode); /* [-1, 0] */

    case E_V2QImode:
      if (pattern12 (x1, 
E_V2QImode) != 0)
        return -1;
      return 1;

    case E_V4QImode:
      if (pattern12 (x1, 
E_V4QImode) != 0)
        return -1;
      return 2;

    case E_V8QImode:
      if (pattern12 (x1, 
E_V8QImode) != 0)
        return -1;
      return 3;

    case E_V16QImode:
      if (pattern12 (x1, 
E_V16QImode) != 0)
        return -1;
      return 4;

    case E_V1HImode:
      if (pattern12 (x1, 
E_V1HImode) != 0)
        return -1;
      return 5;

    case E_V2HImode:
      if (pattern12 (x1, 
E_V2HImode) != 0)
        return -1;
      return 6;

    case E_V4HImode:
      if (pattern12 (x1, 
E_V4HImode) != 0)
        return -1;
      return 7;

    case E_V8HImode:
      if (pattern12 (x1, 
E_V8HImode) != 0)
        return -1;
      return 8;

    case E_V1SImode:
      if (!register_operand (x2, E_V1SImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V1SImode)
        return -1;
      return 9;

    case E_V2SImode:
      if (!register_operand (x2, E_V2SImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V2SImode)
        return -1;
      return 10;

    case E_V4SImode:
      if (!register_operand (x2, E_V4SImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V4SImode)
        return -1;
      return 11;

    case E_V1DImode:
      if (!register_operand (x2, E_V1DImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V1DImode)
        return -1;
      return 12;

    case E_V2DImode:
      if (!register_operand (x2, E_V2DImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V2DImode)
        return -1;
      return 13;

    case E_V1TImode:
      if (!register_operand (x2, E_V1TImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V1TImode)
        return -1;
      return 14;

    case E_TImode:
      if (!register_operand (x2, E_TImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_TImode)
        return -1;
      return 15;

    default:
      return -1;
    }
}

int
pattern31 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  x5 = XEXP (x1, 1);
  operands[3] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      return pattern30 (x1, 
E_DImode); /* [-1, 0] */

    case E_SImode:
      if (pattern30 (x1, 
E_SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern35 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_CCRAWmode)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 33
      || GET_MODE (x3) != E_CCRAWmode)
    return -1;
  return 0;
}

int
pattern37 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || GET_CODE (x1) != UNSPEC
      || XVECLEN (x1, 0) != 1
      || XINT (x1, 1) != 0)
    return -1;
  return 0;
}

int
pattern39 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != CLOBBER)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 33
      || GET_MODE (x2) != E_CCmode)
    return -1;
  return 0;
}

int
pattern44 (rtx x1, int i1, int i2, rtx_code i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != SET)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != i3
      || XVECLEN (x2, 0) != i2
      || XINT (x2, 1) != i1)
    return -1;
  return 0;
}

int
pattern48 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x1) != E_V8HImode
          || !register_operand (operands[1], E_V16QImode))
        return -1;
      return 0;

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x1) != E_V4SImode
          || !register_operand (operands[1], E_V8HImode))
        return -1;
      return 1;

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x1) != E_V2DImode
          || !register_operand (operands[1], E_V4SImode))
        return -1;
      return 2;

    case E_TImode:
      if (!register_operand (operands[0], E_TImode)
          || GET_MODE (x1) != E_TImode
          || !register_operand (operands[1], E_V2DImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern59 (rtx x1, int *pnum_clobbers, int i1, int i2, int i3, int i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + i4])
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + i3])
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + i2])
    return -1;
  x5 = XVECEXP (x1, 0, 3);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  return 0;
}

int
pattern65 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[2] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_V1QImode:
      return pattern0 (x1, 
E_V1QImode); /* [-1, 0] */

    case E_V2QImode:
      if (pattern0 (x1, 
E_V2QImode) != 0)
        return -1;
      return 1;

    case E_V4QImode:
      if (pattern0 (x1, 
E_V4QImode) != 0)
        return -1;
      return 2;

    case E_V8QImode:
      if (pattern0 (x1, 
E_V8QImode) != 0)
        return -1;
      return 3;

    case E_V16QImode:
      if (pattern0 (x1, 
E_V16QImode) != 0)
        return -1;
      return 4;

    case E_V1HImode:
      if (pattern0 (x1, 
E_V1HImode) != 0)
        return -1;
      return 5;

    case E_V2HImode:
      if (pattern0 (x1, 
E_V2HImode) != 0)
        return -1;
      return 6;

    case E_V4HImode:
      if (pattern0 (x1, 
E_V4HImode) != 0)
        return -1;
      return 7;

    case E_V8HImode:
      if (pattern0 (x1, 
E_V8HImode) != 0)
        return -1;
      return 8;

    case E_V1SImode:
      if (pattern0 (x1, 
E_V1SImode) != 0)
        return -1;
      return 9;

    case E_V2SImode:
      if (pattern0 (x1, 
E_V2SImode) != 0)
        return -1;
      return 10;

    case E_V4SImode:
      if (pattern0 (x1, 
E_V4SImode) != 0)
        return -1;
      return 11;

    case E_V1DImode:
      if (pattern0 (x1, 
E_V1DImode) != 0)
        return -1;
      return 12;

    case E_V2DImode:
      if (pattern0 (x1, 
E_V2DImode) != 0)
        return -1;
      return 13;

    case E_V1SFmode:
      if (pattern0 (x1, 
E_V1SFmode) != 0)
        return -1;
      return 14;

    case E_V2SFmode:
      if (pattern0 (x1, 
E_V2SFmode) != 0)
        return -1;
      return 15;

    case E_V4SFmode:
      if (pattern0 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 16;

    case E_V1DFmode:
      if (pattern0 (x1, 
E_V1DFmode) != 0)
        return -1;
      return 17;

    case E_V2DFmode:
      if (pattern0 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 18;

    case E_V1TFmode:
      if (pattern0 (x1, 
E_V1TFmode) != 0)
        return -1;
      return 19;

    case E_V1TImode:
      if (pattern0 (x1, 
E_V1TImode) != 0)
        return -1;
      return 20;

    case E_TImode:
      if (pattern0 (x1, 
E_TImode) != 0)
        return -1;
      return 21;

    case E_DImode:
      if (pnum_clobbers == NULL
          || pattern64 (x1, 
E_DImode) != 0)
        return -1;
      return 22;

    case E_HImode:
      if (pnum_clobbers == NULL
          || pattern64 (x1, 
E_HImode) != 0)
        return -1;
      return 23;

    case E_QImode:
      if (pnum_clobbers == NULL
          || pattern64 (x1, 
E_QImode) != 0)
        return -1;
      return 24;

    default:
      return -1;
    }
}

int
pattern104 (rtx x1, int *pnum_clobbers, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern109 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern116 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  x5 = XEXP (x1, 1);
  operands[3] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      return pattern115 (x1, 
E_DImode); /* [-1, 0] */

    case E_SImode:
      if (pattern115 (x1, 
E_SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern122 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 33
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 1);
  operands[2] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      return pattern121 (x5, 
E_DImode); /* [-1, 0] */

    case E_SImode:
      if (pattern121 (x5, 
E_SImode) != 0)
        return -1;
      return 1;

    case E_HImode:
      if (pattern121 (x5, 
E_HImode) != 0)
        return -1;
      return 2;

    case E_QImode:
      if (pattern121 (x5, 
E_QImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern130 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern136 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern142 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i2)
      || !register_operand (operands[2], i2)
      || !register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern148 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != E_DImode)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != ASHIFT
      || GET_MODE (x6) != E_DImode)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != SUBREG
      || maybe_ne (SUBREG_BYTE (x7), 0)
      || GET_MODE (x7) != E_DImode)
    return -1;
  x8 = XEXP (x6, 1);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
    return -1;
  x9 = XEXP (x5, 1);
  if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
    return -1;
  x10 = XEXP (x3, 1);
  if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x11 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x11) != SET)
    return -1;
  x12 = XEXP (x11, 1);
  if (GET_CODE (x12) != i1
      || GET_MODE (x12) != E_DImode)
    return -1;
  x13 = XEXP (x12, 0);
  if (GET_CODE (x13) != SIGN_EXTEND
      || GET_MODE (x13) != E_DImode
      || GET_MODE (x4) != E_DImode)
    return -1;
  x14 = XEXP (x7, 0);
  operands[1] = x14;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x15 = XEXP (x11, 0);
  operands[0] = x15;
  if (!register_operand (operands[0], E_DImode))
    return -1;
  x16 = XEXP (x13, 0);
  if (!rtx_equal_p (x16, operands[1]))
    return -1;
  return 0;
}

int
pattern161 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_MODE (x6) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[0], i1))
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 1);
  if (GET_MODE (x8) != i1)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_MODE (x9) != i1)
    return -1;
  x10 = XEXP (x8, 1);
  if (GET_MODE (x10) != i1)
    return -1;
  return 0;
}

int
pattern171 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern174 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != LABEL_REF)
    return -1;
  x2 = XEXP (x1, 0);
  operands[3] = x2;
  return pattern172 (); /* [-1, 1] */
}

int
pattern177 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_DImode
          || !register_operand (operands[1], E_DImode))
        return -1;
      return 0;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_SImode
          || !memory_operand (operands[2], E_HImode)
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern188 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_DImode:
      if (!register_operand (operands[1], E_DImode)
          || !general_operand (operands[2], E_DImode))
        return -1;
      return 0;

    case E_SImode:
      if (!register_operand (operands[1], E_SImode)
          || !general_operand (operands[2], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern196 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  switch (GET_CODE (operands[2]))
    {
    case CONST_INT:
      if (!const_int_operand (operands[2], E_VOIDmode))
        return -1;
      x4 = XVECEXP (x1, 0, 2);
      x5 = XEXP (x4, 0);
      operands[3] = x5;
      if (!immediate_operand (operands[3], E_VOIDmode))
        return -1;
      x6 = XVECEXP (x1, 0, 3);
      x7 = XEXP (x6, 0);
      operands[4] = x7;
      if (!scratch_operand (operands[4], E_VOIDmode))
        return -1;
      return 0;

    case REG:
    case SUBREG:
      if (!register_operand (operands[2], E_VOIDmode))
        return -1;
      x4 = XVECEXP (x1, 0, 2);
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case SUBREG:
        case MEM:
          operands[3] = x5;
          if (!memory_operand (operands[3], E_VOIDmode))
            return -1;
          x6 = XVECEXP (x1, 0, 3);
          x7 = XEXP (x6, 0);
          operands[4] = x7;
          if (!scratch_operand (operands[4], E_VOIDmode))
            return -1;
          return 1;

        case CONST:
          if (GET_MODE (x5) != E_BLKmode)
            return -1;
          x8 = XEXP (x5, 0);
          if (GET_CODE (x8) != UNSPEC
              || XVECLEN (x8, 0) != 1
              || XINT (x8, 1) != 17
              || GET_MODE (x8) != E_BLKmode)
            return -1;
          x9 = XVECEXP (x8, 0, 0);
          if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x6 = XVECEXP (x1, 0, 3);
          x7 = XEXP (x6, 0);
          operands[3] = x7;
          return 2;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern227 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern237 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1
      || !s390_alc_comparison (operands[3], i1)
      || !nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1)
      || !scratch_operand (operands[0], i1))
    return -1;
  return 0;
}

int
pattern241 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern248 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern254 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1)
      || !nonimmediate_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 1);
  if (!rtx_equal_p (x6, operands[2]))
    return -1;
  return 0;
}

int
pattern265 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !const_int_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1)
      || !nonzero_shift_count_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern274 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern279 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !nonsym_memory_operand (operands[1], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern287 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1)
      || !s390_slb_comparison (operands[3], i1)
      || !register_operand (operands[0], i1))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 1);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) != i1)
    return -1;
  return 0;
}

 int
recog_2 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_BLKmode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[2] = x3;
  if (!memory_operand (operands[2], E_BLKmode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[0] = x4;
  x5 = XVECEXP (x2, 0, 1);
  operands[1] = x5;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V1QImode:
      if (!register_operand (operands[0], E_V1QImode)
          || !
#line 567 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 73; /* vstlv1qi */

    case E_V2QImode:
      if (!register_operand (operands[0], E_V2QImode)
          || !
#line 567 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 74; /* vstlv2qi */

    case E_V4QImode:
      if (!register_operand (operands[0], E_V4QImode)
          || !
#line 567 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 75; /* vstlv4qi */

    case E_V8QImode:
      if (!register_operand (operands[0], E_V8QImode)
          || !
#line 567 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 76; /* vstlv8qi */

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || !
#line 567 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 77; /* vstlv16qi */

    case E_V1HImode:
      if (!register_operand (operands[0], E_V1HImode)
          || !
#line 567 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 78; /* vstlv1hi */

    case E_V2HImode:
      if (!register_operand (operands[0], E_V2HImode)
          || !
#line 567 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 79; /* vstlv2hi */

    case E_V4HImode:
      if (!register_operand (operands[0], E_V4HImode)
          || !
#line 567 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 80; /* vstlv4hi */

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || !
#line 567 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 81; /* vstlv8hi */

    case E_V1SImode:
      if (!register_operand (operands[0], E_V1SImode)
          || !
#line 567 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 82; /* vstlv1si */

    case E_V2SImode:
      if (!register_operand (operands[0], E_V2SImode)
          || !
#line 567 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 83; /* vstlv2si */

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || !
#line 567 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 84; /* vstlv4si */

    case E_V1DImode:
      if (!register_operand (operands[0], E_V1DImode)
          || !
#line 567 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 85; /* vstlv1di */

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || !
#line 567 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 86; /* vstlv2di */

    case E_V1SFmode:
      if (!register_operand (operands[0], E_V1SFmode)
          || !
#line 567 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 87; /* vstlv1sf */

    case E_V2SFmode:
      if (!register_operand (operands[0], E_V2SFmode)
          || !
#line 567 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 88; /* vstlv2sf */

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || !
#line 567 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 89; /* vstlv4sf */

    case E_V1DFmode:
      if (!register_operand (operands[0], E_V1DFmode)
          || !
#line 567 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 90; /* vstlv1df */

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || !
#line 567 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 91; /* vstlv2df */

    default:
      return -1;
    }
}

 int
recog_17 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  switch (XINT (x3, 1))
    {
    case 62:
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          if (!register_operand (operands[0], E_V16QImode)
              || GET_MODE (x3) != E_V16QImode
              || !memory_operand (operands[1], E_QImode)
              || !
#line 179 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 5; /* vec_insert_and_zerov16qi */

        case E_V8HImode:
          if (!register_operand (operands[0], E_V8HImode)
              || GET_MODE (x3) != E_V8HImode
              || !memory_operand (operands[1], E_HImode)
              || !
#line 179 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 6; /* vec_insert_and_zerov8hi */

        case E_V4SImode:
          if (!register_operand (operands[0], E_V4SImode)
              || GET_MODE (x3) != E_V4SImode
              || !memory_operand (operands[1], E_SImode)
              || !
#line 179 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 7; /* vec_insert_and_zerov4si */

        case E_V2DImode:
          if (!register_operand (operands[0], E_V2DImode)
              || GET_MODE (x3) != E_V2DImode
              || !memory_operand (operands[1], E_DImode)
              || !
#line 179 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 8; /* vec_insert_and_zerov2di */

        case E_V2DFmode:
          if (!register_operand (operands[0], E_V2DFmode)
              || GET_MODE (x3) != E_V2DFmode
              || !memory_operand (operands[1], E_DFmode)
              || !
#line 179 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 9; /* vec_insert_and_zerov2df */

        case E_V4SFmode:
          if (!register_operand (operands[0], E_V4SFmode)
              || GET_MODE (x3) != E_V4SFmode
              || !memory_operand (operands[1], E_SFmode)
              || !(
#line 179 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 27 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE)))
            return -1;
          return 10; /* vec_insert_and_zerov4sf */

        default:
          return -1;
        }

    case 74:
      switch (pattern47 (x3))
        {
        case 0:
          if (!
#line 553 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 70; /* vec_extendv16qi */

        case 1:
          if (!
#line 553 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 71; /* vec_extendv8hi */

        case 2:
          if (!
#line 553 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 72; /* vec_extendv4si */

        default:
          return -1;
        }

    case 78:
      switch (pattern48 (x3))
        {
        case 0:
          if (!
#line 620 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 94; /* vec_unpackhv16qi */

        case 1:
          if (!
#line 620 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 95; /* vec_unpackhv8hi */

        case 2:
          if (!
#line 620 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 96; /* vec_unpackhv4si */

        case 3:
          if (!(
#line 620 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 54 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 97; /* vec_unpackhv2di */

        default:
          return -1;
        }

    case 79:
      switch (pattern48 (x3))
        {
        case 0:
          if (!
#line 629 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 98; /* vec_unpackh_lv16qi */

        case 1:
          if (!
#line 629 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 99; /* vec_unpackh_lv8hi */

        case 2:
          if (!
#line 629 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 100; /* vec_unpackh_lv4si */

        case 3:
          if (!(
#line 629 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 54 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 101; /* vec_unpackh_lv2di */

        default:
          return -1;
        }

    case 80:
      switch (pattern48 (x3))
        {
        case 0:
          if (!
#line 641 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 102; /* vec_unpacklv16qi */

        case 1:
          if (!
#line 641 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 103; /* vec_unpacklv8hi */

        case 2:
          if (!
#line 641 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 104; /* vec_unpacklv4si */

        case 3:
          if (!(
#line 641 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 54 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 105; /* vec_unpacklv2di */

        default:
          return -1;
        }

    case 81:
      switch (pattern48 (x3))
        {
        case 0:
          if (!
#line 650 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 106; /* vec_unpackl_lv16qi */

        case 1:
          if (!
#line 650 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 107; /* vec_unpackl_lv8hi */

        case 2:
          if (!
#line 650 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 108; /* vec_unpackl_lv4si */

        case 3:
          if (!(
#line 650 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 54 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 109; /* vec_unpackl_lv2di */

        default:
          return -1;
        }

    case 116:
      switch (pattern47 (x3))
        {
        case 0:
          if (!
#line 1502 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 377; /* vistrv16qi */

        case 1:
          if (!
#line 1502 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 378; /* vistrv8hi */

        case 2:
          if (!
#line 1502 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 379; /* vistrv4si */

        default:
          return -1;
        }

    case 127:
      if (GET_MODE (x3) != E_V2DFmode
          || !register_operand (operands[0], E_V2DFmode))
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V4SFmode)
          || !
#line 1854 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 403; /* vflls */

    case 136:
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          if (!register_operand (operands[0], E_V16QImode)
              || GET_MODE (x3) != E_V16QImode
              || !register_operand (operands[1], E_V8HImode)
              || !
#line 2283 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE3))
            return -1;
          return 515; /* vgemv16qi */

        case E_V8HImode:
          if (!register_operand (operands[0], E_V8HImode)
              || GET_MODE (x3) != E_V8HImode
              || !register_operand (operands[1], E_V16QImode)
              || !
#line 2292 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE3))
            return -1;
          return 516; /* vgemv8hi */

        case E_V4SImode:
          if (!register_operand (operands[0], E_V4SImode)
              || GET_MODE (x3) != E_V4SImode
              || !register_operand (operands[1], E_V16QImode)
              || !
#line 2292 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE3))
            return -1;
          return 517; /* vgemv4si */

        case E_V2DImode:
          if (!register_operand (operands[0], E_V2DImode)
              || GET_MODE (x3) != E_V2DImode
              || !register_operand (operands[1], E_V16QImode)
              || !
#line 2292 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE3))
            return -1;
          return 518; /* vgemv2di */

        case E_V1TImode:
          if (!register_operand (operands[0], E_V1TImode)
              || GET_MODE (x3) != E_V1TImode
              || !register_operand (operands[1], E_V16QImode)
              || !
#line 2292 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE3))
            return -1;
          return 519; /* vgemv1ti */

        case E_TImode:
          if (!register_operand (operands[0], E_TImode)
              || GET_MODE (x3) != E_TImode
              || !register_operand (operands[1], E_V16QImode)
              || !
#line 2292 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE3))
            return -1;
          return 520; /* vgemti */

        default:
          return -1;
        }

    case 137:
      if (GET_MODE (x3) != E_FPRX2mode
          || !register_operand (operands[0], E_FPRX2mode))
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      if (!general_operand (operands[1], E_TFmode)
          || !
#line 939 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
        return -1;
      return 677; /* tf_to_fprx2 */

    case 37:
      return recog_1 (x1, insn, pnum_clobbers);

    case 40:
      switch (pattern49 (x3))
        {
        case 0:
          if (!(
#line 3095 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 87 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1539; /* floorv4sf2 */

        case 1:
          if (!
#line 3095 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1544; /* floorv2df2 */

        case 2:
          if (!(
#line 3095 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 87 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1549; /* floorv1tf2 */

        case 3:
          if ((
#line 3095 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 88 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return 1554; /* floortf2_vr */
          if (!(
#line 5843 "../../gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 758 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          return 2112; /* floortf2_fpr */

        case 4:
          if (!(
#line 5843 "../../gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 758 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          return 2117; /* floorfprx22 */

        case 5:
          if (!
#line 5843 "../../gcc/config/s390/s390.md"
(TARGET_Z196))
            return -1;
          return 2122; /* floordf2 */

        case 6:
          if (!
#line 5843 "../../gcc/config/s390/s390.md"
(TARGET_Z196))
            return -1;
          return 2127; /* floorsf2 */

        case 7:
          if (!
#line 5869 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          return 2136; /* floortd2 */

        case 8:
          if (!
#line 5869 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          return 2141; /* floordd2 */

        default:
          return -1;
        }

    case 41:
      switch (pattern49 (x3))
        {
        case 0:
          if (!(
#line 3095 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 87 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1540; /* btruncv4sf2 */

        case 1:
          if (!
#line 3095 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1545; /* btruncv2df2 */

        case 2:
          if (!(
#line 3095 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 87 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1550; /* btruncv1tf2 */

        case 3:
          if ((
#line 3095 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 88 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return 1555; /* btrunctf2_vr */
          if (!(
#line 5843 "../../gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 758 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          return 2113; /* btrunctf2_fpr */

        case 4:
          if (!(
#line 5843 "../../gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 758 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          return 2118; /* btruncfprx22 */

        case 5:
          if (!
#line 5843 "../../gcc/config/s390/s390.md"
(TARGET_Z196))
            return -1;
          return 2123; /* btruncdf2 */

        case 6:
          if (!
#line 5843 "../../gcc/config/s390/s390.md"
(TARGET_Z196))
            return -1;
          return 2128; /* btruncsf2 */

        case 7:
          if (!
#line 5869 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          return 2137; /* btrunctd2 */

        case 8:
          if (!
#line 5869 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          return 2142; /* btruncdd2 */

        default:
          return -1;
        }

    case 42:
      switch (pattern49 (x3))
        {
        case 0:
          if (!(
#line 3095 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 87 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1541; /* roundv4sf2 */

        case 1:
          if (!
#line 3095 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1546; /* roundv2df2 */

        case 2:
          if (!(
#line 3095 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 87 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1551; /* roundv1tf2 */

        case 3:
          if ((
#line 3095 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 88 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return 1556; /* roundtf2_vr */
          if (!(
#line 5843 "../../gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 758 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          return 2114; /* roundtf2_fpr */

        case 4:
          if (!(
#line 5843 "../../gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 758 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          return 2119; /* roundfprx22 */

        case 5:
          if (!
#line 5843 "../../gcc/config/s390/s390.md"
(TARGET_Z196))
            return -1;
          return 2124; /* rounddf2 */

        case 6:
          if (!
#line 5843 "../../gcc/config/s390/s390.md"
(TARGET_Z196))
            return -1;
          return 2129; /* roundsf2 */

        case 7:
          if (!
#line 5869 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          return 2138; /* roundtd2 */

        case 8:
          if (!
#line 5869 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          return 2143; /* rounddd2 */

        default:
          return -1;
        }

    case 43:
      switch (pattern49 (x3))
        {
        case 0:
          if (!(
#line 3095 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 87 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1542; /* ceilv4sf2 */

        case 1:
          if (!
#line 3095 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1547; /* ceilv2df2 */

        case 2:
          if (!(
#line 3095 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 87 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1552; /* ceilv1tf2 */

        case 3:
          if ((
#line 3095 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 88 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return 1557; /* ceiltf2_vr */
          if (!(
#line 5843 "../../gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 758 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          return 2115; /* ceiltf2_fpr */

        case 4:
          if (!(
#line 5843 "../../gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 758 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          return 2120; /* ceilfprx22 */

        case 5:
          if (!
#line 5843 "../../gcc/config/s390/s390.md"
(TARGET_Z196))
            return -1;
          return 2125; /* ceildf2 */

        case 6:
          if (!
#line 5843 "../../gcc/config/s390/s390.md"
(TARGET_Z196))
            return -1;
          return 2130; /* ceilsf2 */

        case 7:
          if (!
#line 5869 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          return 2139; /* ceiltd2 */

        case 8:
          if (!
#line 5869 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          return 2144; /* ceildd2 */

        default:
          return -1;
        }

    case 44:
      switch (pattern49 (x3))
        {
        case 0:
          if (!(
#line 3095 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 87 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1543; /* nearbyintv4sf2 */

        case 1:
          if (!
#line 3095 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1548; /* nearbyintv2df2 */

        case 2:
          if (!(
#line 3095 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 87 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1553; /* nearbyintv1tf2 */

        case 3:
          if ((
#line 3095 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 88 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return 1558; /* nearbyinttf2_vr */
          if (!(
#line 5843 "../../gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 758 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          return 2116; /* nearbyinttf2_fpr */

        case 4:
          if (!(
#line 5843 "../../gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 758 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          return 2121; /* nearbyintfprx22 */

        case 5:
          if (!
#line 5843 "../../gcc/config/s390/s390.md"
(TARGET_Z196))
            return -1;
          return 2126; /* nearbyintdf2 */

        case 6:
          if (!
#line 5843 "../../gcc/config/s390/s390.md"
(TARGET_Z196))
            return -1;
          return 2131; /* nearbyintsf2 */

        case 7:
          if (!
#line 5869 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          return 2140; /* nearbyinttd2 */

        case 8:
          if (!
#line 5869 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          return 2145; /* nearbyintdd2 */

        default:
          return -1;
        }

    case 45:
      switch (pattern49 (x3))
        {
        case 0:
          if (!(
#line 3112 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 87 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1559; /* rintv4sf2 */

        case 1:
          if (!
#line 3112 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1560; /* rintv2df2 */

        case 2:
          if (!(
#line 3112 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 87 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1561; /* rintv1tf2 */

        case 3:
          if ((
#line 3112 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 88 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return 1562; /* rinttf2_vr */
          if (!
#line 758 "../../gcc/config/s390/s390.md"
(!TARGET_VXE))
            return -1;
          return 2132; /* rinttf2_fpr */

        case 4:
          if (!
#line 758 "../../gcc/config/s390/s390.md"
(TARGET_VXE))
            return -1;
          return 2133; /* rintfprx22 */

        case 5:
          return 2134; /* rintdf2 */

        case 6:
          return 2135; /* rintsf2 */

        case 7:
          if (!
#line 5879 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          return 2146; /* rinttd2 */

        case 8:
          if (!
#line 5879 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          return 2147; /* rintdd2 */

        default:
          return -1;
        }

    case 30:
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      switch (pattern80 (x3))
        {
        case 0:
          return 1848; /* *get_tp_31 */

        case 1:
          if (!
#line 2178 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return -1;
          return 1849; /* *get_tp_64 */

        default:
          return -1;
        }

    case 5:
      if (GET_MODE (x3) != E_SImode
          || !nonimmediate_operand (operands[0], E_SImode))
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_VOIDmode))
        return -1;
      return 1898; /* *cc_to_int */

    case 4:
      if (pnum_clobbers == NULL
          || GET_MODE (x3) != E_SImode
          || !register_operand (operands[0], E_SImode))
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_CCUmode))
        return -1;
      *pnum_clobbers = 1;
      return 1919; /* cmpint */

    case 20:
      if (GET_MODE (x3) != E_BLKmode)
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      if (!rtx_equal_p (x4, operands[0]))
        return -1;
      return 2592; /* mem_thread_fence_1 */

    case 21:
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (GET_MODE (x3) != E_DImode)
            return -1;
          if (register_operand (operands[0], E_DImode)
              && memory_operand (operands[1], E_DImode)
              && 
#line 11232 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
            return 2593; /* atomic_loaddi_1 */
          if (!memory_operand (operands[0], E_DImode)
              || !register_operand (operands[1], E_DImode)
              || !
#line 11279 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
            return -1;
          return 2595; /* atomic_storedi_1 */

        case E_TImode:
          if (GET_MODE (x3) != E_TImode)
            return -1;
          if (register_operand (operands[0], E_TImode)
              && memory_operand (operands[1], E_TImode)
              && 
#line 11246 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return 2594; /* atomic_loadti_1 */
          if (!memory_operand (operands[0], E_TImode)
              || !register_operand (operands[1], E_TImode)
              || !
#line 11293 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return -1;
          return 2596; /* atomic_storeti_1 */

        default:
          return -1;
        }

    case 15:
      x4 = XVECEXP (x3, 0, 0);
      if (GET_CODE (x4) != LABEL_REF
          || !register_operand (operands[0], E_VOIDmode))
        return -1;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!
#line 11744 "../../gcc/config/s390/s390.md"
(GET_MODE (operands[0]) == Pmode))
        return -1;
      return 2619; /* main_base_64 */

    case 14:
      x4 = XVECEXP (x3, 0, 0);
      if (GET_CODE (x4) != LABEL_REF
          || !register_operand (operands[0], E_VOIDmode))
        return -1;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!
#line 11764 "../../gcc/config/s390/s390.md"
(GET_MODE (operands[0]) == Pmode))
        return -1;
      return 2621; /* reload_base_64 */

    case 33:
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (!memory_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || !memory_operand (operands[1], E_DImode))
            return -1;
          return 2629; /* stack_protect_setdi */

        case E_SImode:
          if (!memory_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !memory_operand (operands[1], E_SImode))
            return -1;
          return 2630; /* stack_protect_setsi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_48 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          if (pattern0 (x3, 
E_V16QImode) != 0
              || !
#line 1154 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 716; /* mulv16qi3 */

        case E_V8HImode:
          if (pattern0 (x3, 
E_V8HImode) != 0
              || !
#line 1154 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 717; /* mulv8hi3 */

        case E_V4SImode:
          if (pattern0 (x3, 
E_V4SImode) != 0
              || !
#line 1154 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 718; /* mulv4si3 */

        case E_V2DImode:
          if (pattern0 (x3, 
E_V2DImode) != 0
              || !(
#line 1154 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 52 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 719; /* mulv2di3 */

        case E_V1TImode:
          if (pattern0 (x3, 
E_V1TImode) != 0
              || !(
#line 1154 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 52 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 720; /* mulv1ti3 */

        case E_TImode:
          if (pattern0 (x3, 
E_TImode) != 0
              || !(
#line 1154 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 52 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 721; /* multi3 */

        case E_V4SFmode:
          if (pattern0 (x3, 
E_V4SFmode) != 0
              || !(
#line 1893 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 87 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1235; /* mulv4sf3 */

        case E_V2DFmode:
          if (pattern0 (x3, 
E_V2DFmode) != 0
              || !
#line 1893 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1236; /* mulv2df3 */

        case E_V1TFmode:
          if (pattern0 (x3, 
E_V1TFmode) != 0
              || !(
#line 1893 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 87 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1237; /* mulv1tf3 */

        case E_TFmode:
          if (!register_operand (operands[0], E_TFmode)
              || GET_MODE (x3) != E_TFmode)
            return -1;
          if (register_operand (operands[1], E_TFmode)
              && register_operand (operands[2], E_TFmode)
              && (
#line 1893 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 88 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return 1238; /* multf3_vr */
          if (!nonimmediate_operand (operands[1], E_TFmode)
              || !general_operand (operands[2], E_TFmode)
              || !(
#line 7580 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 751 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          return 2325; /* multf3_fpr */

        case E_FPRX2mode:
          if (pattern176 (x3, 
E_FPRX2mode) != 0
              || !(
#line 7580 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 751 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          return 2326; /* mulfprx23 */

        case E_DFmode:
          if (pattern176 (x3, 
E_DFmode) != 0
              || !
#line 7580 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 2327; /* muldf3 */

        case E_SFmode:
          if (pattern176 (x3, 
E_SFmode) != 0
              || !
#line 7580 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 2328; /* mulsf3 */

        case E_TDmode:
          if (pattern176 (x3, 
E_TDmode) != 0
              || !(
#line 7580 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 752 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          return 2329; /* multd3 */

        case E_DDmode:
          if (pattern176 (x3, 
E_DDmode) != 0
              || !(
#line 7580 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 752 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          return 2330; /* muldd3 */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      if (GET_MODE (x4) != E_TImode)
        return -1;
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != SIGN_EXTEND
          || GET_MODE (x5) != E_TImode
          || !register_operand (operands[0], E_TImode)
          || GET_MODE (x3) != E_TImode)
        return -1;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      x7 = XEXP (x5, 0);
      operands[2] = x7;
      if (nonimmediate_operand (operands[2], E_DImode)
          && register_operand (operands[1], E_DImode)
          && 
#line 7433 "../../gcc/config/s390/s390.md"
(TARGET_Z14))
        return 2315; /* mulditi3 */
      if (!register_operand (operands[2], E_DImode)
          || !nonimmediate_operand (operands[1], E_DImode)
          || !
#line 7446 "../../gcc/config/s390/s390.md"
(TARGET_Z14))
        return -1;
      return 2316; /* mulditi3_2 */

    case ZERO_EXTEND:
      if (pattern113 (x3, 
E_DImode, 
E_TImode) != 0
          || !
#line 782 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
        return -1;
      return 2323; /* umulditi3 */

    default:
      return -1;
    }
}

 int
recog_57 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 33)
    return -1;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      return recog_25 (x1, insn, pnum_clobbers);

    case VEC_SELECT:
      if (GET_MODE (x4) != E_DImode)
        return -1;
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) != PARALLEL
          || XVECLEN (x5, 0) != 1)
        return -1;
      x6 = XVECEXP (x5, 0, 0);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x7 = XEXP (x3, 1);
      if (GET_CODE (x7) != VEC_SELECT
          || GET_MODE (x7) != E_DImode)
        return -1;
      x8 = XEXP (x7, 1);
      if (GET_CODE (x8) != PARALLEL
          || XVECLEN (x8, 0) != 1)
        return -1;
      x9 = XVECEXP (x8, 0, 0);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x10 = XEXP (x4, 0);
      operands[0] = x10;
      if (!register_operand (operands[0], E_V2DImode))
        return -1;
      x11 = XEXP (x7, 0);
      operands[1] = x11;
      if (!register_operand (operands[1], E_V2DImode))
        return -1;
      switch (GET_MODE (x2))
        {
        case E_CCSmode:
          if (GET_MODE (x3) != E_CCSmode
              || !
#line 2229 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1348; /* *vec_cmpv2di_lane0_ccs */

        case E_CCUmode:
          if (GET_MODE (x3) != E_CCUmode
              || !
#line 2229 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1349; /* *vec_cmpv2di_lane0_ccu */

        case E_CCZmode:
          if (GET_MODE (x3) != E_CCZmode
              || !
#line 2229 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1350; /* *vec_cmpv2di_lane0_ccz */

        default:
          return -1;
        }

    case AND:
      x10 = XEXP (x4, 0);
      switch (GET_CODE (x10))
        {
        case REG:
        case SUBREG:
        case MEM:
          operands[0] = x10;
          x5 = XEXP (x4, 1);
          operands[1] = x5;
          x7 = XEXP (x3, 1);
          operands[2] = x7;
          switch (GET_MODE (x4))
            {
            case E_QImode:
              if (memory_operand (operands[0], E_QImode)
                  && immediate_operand (operands[1], E_QImode)
                  && immediate_operand (operands[2], E_QImode)
                  && 
#line 1020 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, s390_tm_ccmode (operands[1], operands[2], false))))
                return 1739; /* *tmqi_mem */
              break;

            case E_DImode:
              if (nonimmediate_operand (operands[0], E_DImode)
                  && immediate_operand (operands[1], E_DImode)
                  && immediate_operand (operands[2], E_DImode)
                  && 
#line 1034 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH
   && s390_match_ccmode (insn, s390_tm_ccmode (operands[1], operands[2], true))
   && s390_single_part (operands[1], DImode, HImode, 0) >= 0))
                return 1740; /* *tmdi_reg */
              break;

            case E_SImode:
              if (nonimmediate_operand (operands[0], E_SImode)
                  && immediate_operand (operands[1], E_SImode)
                  && immediate_operand (operands[2], E_SImode)
                  && 
#line 1050 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, s390_tm_ccmode (operands[1], operands[2], true))
   && s390_single_part (operands[1], SImode, HImode, 0) >= 0))
                return 1741; /* *tmsi_reg */
              break;

            default:
              break;
            }
          if (pnum_clobbers == NULL)
            return -1;
          operands[1] = x10;
          if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          operands[2] = x5;
          switch (pattern155 (x4))
            {
            case 0:
              if (!
#line 7939 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH
   && s390_match_ccmode(insn, CCTmode)
   /* Do not steal TM patterns.  */
   && s390_single_part (operands[2], DImode, HImode, 0) < 0))
                return -1;
              *pnum_clobbers = 1;
              return 2347; /* *anddi3_cconly */

            case 1:
              if (!
#line 8067 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCTmode)
   /* Do not steal TM patterns.  */
   && s390_single_part (operands[2], SImode, HImode, 0) < 0))
                return -1;
              *pnum_clobbers = 1;
              return 2358; /* *andsi3_cconly */

            default:
              return -1;
            }

        case NOT:
          if (pnum_clobbers == NULL)
            return -1;
          x7 = XEXP (x3, 1);
          if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          switch (pattern134 (x4))
            {
            case 0:
              if (!(
#line 8602 "../../gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              *pnum_clobbers = 1;
              return 2383; /* *andcdi_cconly */

            case 1:
              if (!
#line 8602 "../../gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)))
                return -1;
              *pnum_clobbers = 1;
              return 2385; /* *andcsi_cconly */

            case 2:
              if (!(
#line 8642 "../../gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              *pnum_clobbers = 1;
              return 2395; /* *nordi_cconly */

            case 3:
              if (!
#line 8642 "../../gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)))
                return -1;
              *pnum_clobbers = 1;
              return 2397; /* *norsi_cconly */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SIGN_EXTEND:
      x10 = XEXP (x4, 0);
      operands[1] = x10;
      x7 = XEXP (x3, 1);
      operands[0] = x7;
      switch (GET_MODE (x4))
        {
        case E_DImode:
          switch (GET_MODE (operands[1]))
            {
            case E_SImode:
              if (!nonimmediate_operand (operands[1], E_SImode)
                  || !register_operand (operands[0], E_DImode)
                  || !
#line 1304 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSRmode) && TARGET_ZARCH))
                return -1;
              return 1765; /* *cmpdi_ccs_sign */

            case E_HImode:
              if (!memory_operand (operands[1], E_HImode))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_DImode:
                  if (!register_operand (operands[0], E_DImode)
                      || !(
#line 1344 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSRmode) && TARGET_Z10) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return -1;
                  return 1768; /* *cmpdi_ccs_signhi_rl */

                case E_SImode:
                  if (!register_operand (operands[0], E_SImode)
                      || !
#line 1344 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSRmode) && TARGET_Z10))
                    return -1;
                  return 1769; /* *cmpdi_ccs_signhi_rl */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case E_SImode:
          if (!memory_operand (operands[1], E_HImode)
              || !register_operand (operands[0], E_SImode)
              || !
#line 1320 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSRmode)))
            return -1;
          return 1766; /* *cmpsi_ccs_sign */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      x7 = XEXP (x3, 1);
      operands[0] = x7;
      x10 = XEXP (x4, 0);
      if (GET_CODE (x10) == MEM
          && GET_MODE (x10) == E_HImode)
        {
          x12 = XEXP (x10, 0);
          operands[1] = x12;
          switch (GET_MODE (x4))
            {
            case E_SImode:
              if (register_operand (operands[0], E_SImode))
                {
                  if (larl_operand (operands[1], E_SImode)
                      && 
#line 1382 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCURmode) && TARGET_Z10))
                    return 1772; /* *cmpsi_ccu_zerohi_rlsi */
                  if (larl_operand (operands[1], E_DImode)
                      && 
#line 1395 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCURmode) && TARGET_Z10))
                    return 1774; /* *cmpsi_ccu_zerohi_rldi */
                }
              break;

            case E_DImode:
              if (larl_operand (operands[1], E_DImode)
                  && register_operand (operands[0], E_DImode)
                  && (
#line 1395 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCURmode) && TARGET_Z10) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return 1773; /* *cmpdi_ccu_zerohi_rldi */
              break;

            default:
              break;
            }
        }
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x4) != E_DImode)
        return -1;
      operands[1] = x10;
      if (!nonimmediate_operand (operands[1], E_SImode)
          || !
#line 1407 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCURmode) && TARGET_ZARCH))
        return -1;
      return 1775; /* *cmpdi_ccu_zero */

    case IOR:
      if (pnum_clobbers == NULL)
        return -1;
      x7 = XEXP (x3, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x10 = XEXP (x4, 0);
      switch (GET_CODE (x10))
        {
        case AND:
          if (GET_MODE (x10) != E_DImode)
            return -1;
          x5 = XEXP (x4, 1);
          if (GET_CODE (x5) != AND
              || GET_MODE (x5) != E_DImode
              || GET_MODE (x4) != E_DImode)
            return -1;
          x12 = XEXP (x10, 0);
          operands[1] = x12;
          if (!nonimmediate_operand (operands[1], E_DImode))
            return -1;
          x13 = XEXP (x10, 1);
          operands[2] = x13;
          if (!contiguous_bitmask_operand (operands[2], E_DImode))
            return -1;
          x14 = XEXP (x5, 0);
          operands[3] = x14;
          if (!nonimmediate_operand (operands[3], E_DImode))
            return -1;
          x15 = XEXP (x5, 1);
          operands[4] = x15;
          if (!const_int_operand (operands[4], E_DImode)
              || !
#line 4540 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && s390_match_ccmode (insn, CCSmode)
   && INTVAL (operands[2]) == ~INTVAL (operands[4])))
            return -1;
          *pnum_clobbers = 1;
          return 1965; /* *insv_z10_noshift_cconly */

        case REG:
        case SUBREG:
        case MEM:
          operands[1] = x10;
          x5 = XEXP (x4, 1);
          operands[2] = x5;
          switch (pattern155 (x4))
            {
            case 0:
              if (!
#line 8353 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCTmode) && TARGET_ZARCH))
                return -1;
              *pnum_clobbers = 1;
              return 2369; /* *iordi3_cconly */

            case 1:
              if (!
#line 8435 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCTmode)))
                return -1;
              *pnum_clobbers = 1;
              return 2372; /* *iorsi3_cconly */

            default:
              return -1;
            }

        case NOT:
          switch (pattern134 (x4))
            {
            case 0:
              if (!(
#line 8602 "../../gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              *pnum_clobbers = 1;
              return 2384; /* *orcdi_cconly */

            case 1:
              if (!
#line 8602 "../../gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)))
                return -1;
              *pnum_clobbers = 1;
              return 2386; /* *orcsi_cconly */

            case 2:
              if (!(
#line 8642 "../../gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              *pnum_clobbers = 1;
              return 2396; /* *nanddi_cconly */

            case 3:
              if (!
#line 8642 "../../gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)))
                return -1;
              *pnum_clobbers = 1;
              return 2398; /* *nandsi_cconly */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case PLUS:
      return recog_26 (x1, insn, pnum_clobbers);

    case MINUS:
      return recog_27 (x1, insn, pnum_clobbers);

    case XOR:
      if (pnum_clobbers == NULL)
        return -1;
      x7 = XEXP (x3, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x10 = XEXP (x4, 0);
      operands[1] = x10;
      x5 = XEXP (x4, 1);
      operands[2] = x5;
      switch (pattern155 (x4))
        {
        case 0:
          if (!
#line 8778 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCTmode) && TARGET_ZARCH))
            return -1;
          *pnum_clobbers = 1;
          return 2407; /* *xordi3_cconly */

        case 1:
          if (!
#line 8845 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCTmode)))
            return -1;
          *pnum_clobbers = 1;
          return 2410; /* *xorsi3_cconly */

        default:
          return -1;
        }

    case NOT:
      if (pnum_clobbers == NULL)
        return -1;
      x10 = XEXP (x4, 0);
      if (GET_CODE (x10) != XOR)
        return -1;
      x7 = XEXP (x3, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x12 = XEXP (x10, 0);
      operands[1] = x12;
      x13 = XEXP (x10, 1);
      operands[2] = x13;
      switch (GET_MODE (x4))
        {
        case E_DImode:
          if (GET_MODE (x10) != E_DImode
              || !register_operand (operands[1], E_DImode)
              || !register_operand (operands[2], E_DImode)
              || !(
#line 9056 "../../gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 2418; /* *nxordi_cconly */

        case E_SImode:
          if (GET_MODE (x10) != E_SImode
              || !register_operand (operands[1], E_SImode)
              || !register_operand (operands[2], E_SImode)
              || !
#line 9056 "../../gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)))
            return -1;
          *pnum_clobbers = 1;
          return 2419; /* *nxorsi_cconly */

        default:
          return -1;
        }

    case NEG:
      if (pnum_clobbers == NULL)
        return -1;
      x10 = XEXP (x4, 0);
      switch (GET_CODE (x10))
        {
        case REG:
        case SUBREG:
          operands[1] = x10;
          x7 = XEXP (x3, 1);
          if (x7 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
            {
              switch (GET_MODE (x4))
                {
                case E_DImode:
                  if (register_operand (operands[1], E_DImode)
                      && (
#line 9126 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCAmode)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    {
                      *pnum_clobbers = 1;
                      return 2426; /* *negdi2_cconly */
                    }
                  break;

                case E_SImode:
                  if (register_operand (operands[1], E_SImode)
                      && 
#line 9126 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCAmode)))
                    {
                      *pnum_clobbers = 1;
                      return 2427; /* *negsi2_cconly */
                    }
                  break;

                default:
                  break;
                }
            }
          operands[2] = x7;
          switch (pattern135 (x4))
            {
            case 0:
              if (!(
#line 9247 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 758 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              *pnum_clobbers = 1;
              return 2435; /* *negtf2_cconly */

            case 1:
              if (!(
#line 9247 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 758 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              *pnum_clobbers = 1;
              return 2436; /* *negfprx22_cconly */

            case 2:
              if (!
#line 9247 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
                return -1;
              *pnum_clobbers = 1;
              return 2437; /* *negdf2_cconly */

            case 3:
              if (!
#line 9247 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
                return -1;
              *pnum_clobbers = 1;
              return 2438; /* *negsf2_cconly */

            default:
              return -1;
            }

        case ABS:
          x12 = XEXP (x10, 0);
          operands[1] = x12;
          x7 = XEXP (x3, 1);
          if (x7 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
            {
              switch (GET_MODE (x4))
                {
                case E_DImode:
                  if (GET_MODE (x10) == E_DImode
                      && register_operand (operands[1], E_DImode)
                      && (
#line 9474 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCAmode)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    {
                      *pnum_clobbers = 1;
                      return 2479; /* *negabsdi2_cconly */
                    }
                  break;

                case E_SImode:
                  if (GET_MODE (x10) == E_SImode
                      && register_operand (operands[1], E_SImode)
                      && 
#line 9474 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCAmode)))
                    {
                      *pnum_clobbers = 1;
                      return 2480; /* *negabssi2_cconly */
                    }
                  break;

                default:
                  break;
                }
            }
          operands[2] = x7;
          switch (GET_MODE (x4))
            {
            case E_TFmode:
              if (GET_MODE (x10) != E_TFmode
                  || !register_operand (operands[1], E_TFmode)
                  || !const0_operand (operands[2], E_TFmode)
                  || !(
#line 9511 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 758 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              *pnum_clobbers = 1;
              return 2487; /* *negabstf2_cconly */

            case E_FPRX2mode:
              if (GET_MODE (x10) != E_FPRX2mode
                  || !register_operand (operands[1], E_FPRX2mode)
                  || !const0_operand (operands[2], E_FPRX2mode)
                  || !(
#line 9511 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 758 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              *pnum_clobbers = 1;
              return 2488; /* *negabsfprx22_cconly */

            case E_DFmode:
              if (GET_MODE (x10) != E_DFmode
                  || !register_operand (operands[1], E_DFmode)
                  || !const0_operand (operands[2], E_DFmode)
                  || !
#line 9511 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
                return -1;
              *pnum_clobbers = 1;
              return 2489; /* *negabsdf2_cconly */

            case E_SFmode:
              if (GET_MODE (x10) != E_SFmode
                  || !register_operand (operands[1], E_SFmode)
                  || !const0_operand (operands[2], E_SFmode)
                  || !
#line 9511 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
                return -1;
              *pnum_clobbers = 1;
              return 2490; /* *negabssf2_cconly */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ABS:
      if (pnum_clobbers == NULL)
        return -1;
      x10 = XEXP (x4, 0);
      operands[1] = x10;
      x7 = XEXP (x3, 1);
      if (x7 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
        {
          switch (GET_MODE (x4))
            {
            case E_DImode:
              if (register_operand (operands[1], E_DImode)
                  && (
#line 9327 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCAmode)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                {
                  *pnum_clobbers = 1;
                  return 2453; /* *absdi2_cconly */
                }
              break;

            case E_SImode:
              if (register_operand (operands[1], E_SImode)
                  && 
#line 9327 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCAmode)))
                {
                  *pnum_clobbers = 1;
                  return 2454; /* *abssi2_cconly */
                }
              break;

            default:
              break;
            }
        }
      operands[2] = x7;
      switch (pattern135 (x4))
        {
        case 0:
          if (!(
#line 9372 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 758 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          *pnum_clobbers = 1;
          return 2461; /* *abstf2_cconly */

        case 1:
          if (!(
#line 9372 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 758 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          *pnum_clobbers = 1;
          return 2462; /* *absfprx22_cconly */

        case 2:
          if (!
#line 9372 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
            return -1;
          *pnum_clobbers = 1;
          return 2463; /* *absdf2_cconly */

        case 3:
          if (!
#line 9372 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
            return -1;
          *pnum_clobbers = 1;
          return 2464; /* *abssf2_cconly */

        default:
          return -1;
        }

    case ASHIFTRT:
      if (pnum_clobbers == NULL)
        return -1;
      x7 = XEXP (x3, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x10 = XEXP (x4, 0);
      operands[1] = x10;
      x5 = XEXP (x4, 1);
      operands[2] = x5;
      if (!shift_count_operand (operands[2], E_QImode))
        return -1;
      switch (GET_MODE (x4))
        {
        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          if ((
#line 45 "../../gcc/config/s390/subst.md"
(s390_match_ccmode(insn, CCSmode)) && 
#line 9734 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH)))
            {
              *pnum_clobbers = 1;
              return 2517; /* *ashrdi3_31_cconly */
            }
          if (!(
#line 45 "../../gcc/config/s390/subst.md"
(s390_match_ccmode(insn, CCSmode)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 2520; /* *ashrdi3_cconly */

        case E_SImode:
          if (!register_operand (operands[1], E_SImode)
              || !
#line 45 "../../gcc/config/s390/subst.md"
(s390_match_ccmode(insn, CCSmode)))
            return -1;
          *pnum_clobbers = 1;
          return 2523; /* *ashrsi3_cconly */

        default:
          return -1;
        }

    case POPCOUNT:
      if (pnum_clobbers == NULL
          || GET_MODE (x4) != E_DImode)
        return -1;
      x7 = XEXP (x3, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x10 = XEXP (x4, 0);
      operands[1] = x10;
      if (!register_operand (operands[1], E_DImode)
          || !
#line 12102 "../../gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)))
        return -1;
      *pnum_clobbers = 1;
      return 2641; /* *popcountdi_z15_cconly */

    default:
      return -1;
    }
}

 int
recog_73 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !register_operand (operands[1], E_V4SFmode)
          || !(
#line 1924 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 87 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      return 1243; /* sqrtv4sf2 */

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x3) != E_V2DFmode
          || !register_operand (operands[1], E_V2DFmode)
          || !
#line 1924 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1244; /* sqrtv2df2 */

    case E_V1TFmode:
      if (!register_operand (operands[0], E_V1TFmode)
          || GET_MODE (x3) != E_V1TFmode
          || !register_operand (operands[1], E_V1TFmode)
          || !(
#line 1924 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 87 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      return 1245; /* sqrtv1tf2 */

    case E_TFmode:
      if (!register_operand (operands[0], E_TFmode)
          || GET_MODE (x3) != E_TFmode)
        return -1;
      if (register_operand (operands[1], E_TFmode)
          && (
#line 1924 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 88 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return 1246; /* sqrttf2_vr */
      if (!general_operand (operands[1], E_TFmode)
          || !(
#line 9552 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 758 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
        return -1;
      return 2501; /* sqrttf2_fpr */

    case E_FPRX2mode:
      if (!register_operand (operands[0], E_FPRX2mode)
          || GET_MODE (x3) != E_FPRX2mode
          || !general_operand (operands[1], E_FPRX2mode)
          || !(
#line 9552 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 758 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
        return -1;
      return 2502; /* sqrtfprx22 */

    case E_DFmode:
      if (!register_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode
          || !general_operand (operands[1], E_DFmode)
          || !
#line 9552 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
        return -1;
      return 2503; /* sqrtdf2 */

    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode
          || !general_operand (operands[1], E_SFmode)
          || !
#line 9552 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
        return -1;
      return 2504; /* sqrtsf2 */

    default:
      return -1;
    }
}

 int
recog_80 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x2))
    {
    case CLOBBER:
      x3 = XEXP (x2, 0);
      operands[2] = x3;
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 0);
      switch (GET_MODE (x5))
        {
        case E_CCVEQmode:
          x6 = XEXP (x4, 1);
          if (GET_MODE (x6) != E_CCVEQmode)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V16QImode:
              if (!register_operand (operands[0], E_V16QImode)
                  || !register_operand (operands[1], E_V16QImode)
                  || !scratch_operand (operands[2], E_V16QImode)
                  || !
#line 1981 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 413; /* *vec_cmpeqv16qi_cconly */

            case E_V8HImode:
              if (!register_operand (operands[0], E_V8HImode)
                  || !register_operand (operands[1], E_V8HImode)
                  || !scratch_operand (operands[2], E_V8HImode)
                  || !
#line 1981 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 416; /* *vec_cmpeqv8hi_cconly */

            case E_V4SImode:
              if (!register_operand (operands[0], E_V4SImode)
                  || !register_operand (operands[1], E_V4SImode)
                  || !scratch_operand (operands[2], E_V4SImode)
                  || !
#line 1981 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 419; /* *vec_cmpeqv4si_cconly */

            case E_V2DImode:
              if (!register_operand (operands[0], E_V2DImode)
                  || !register_operand (operands[1], E_V2DImode)
                  || !scratch_operand (operands[2], E_V2DImode)
                  || !
#line 1981 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 422; /* *vec_cmpeqv2di_cconly */

            case E_V1TImode:
              if (!register_operand (operands[0], E_V1TImode)
                  || !register_operand (operands[1], E_V1TImode)
                  || !scratch_operand (operands[2], E_V1TImode)
                  || !(
#line 1981 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 51 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
                return -1;
              return 425; /* *vec_cmpeqv1ti_cconly */

            case E_TImode:
              if (!register_operand (operands[0], E_TImode)
                  || !register_operand (operands[1], E_TImode)
                  || !scratch_operand (operands[2], E_TImode)
                  || !(
#line 1981 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 51 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
                return -1;
              return 428; /* *vec_cmpeqti_cconly */

            case E_V4SFmode:
              if (!register_operand (operands[0], E_V4SFmode)
                  || !register_operand (operands[1], E_V4SFmode)
                  || !scratch_operand (operands[2], E_V4SImode)
                  || !(
#line 2064 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 87 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 449; /* *vec_cmpeqv4sf_cconly */

            case E_V2DFmode:
              if (!register_operand (operands[0], E_V2DFmode)
                  || !register_operand (operands[1], E_V2DFmode)
                  || !scratch_operand (operands[2], E_V2DImode)
                  || !
#line 2064 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 450; /* *vec_cmpeqv2df_cconly */

            case E_V1TFmode:
              if (!register_operand (operands[0], E_V1TFmode)
                  || !register_operand (operands[1], E_V1TFmode)
                  || !scratch_operand (operands[2], E_V1TImode)
                  || !(
#line 2064 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 87 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 451; /* *vec_cmpeqv1tf_cconly */

            case E_TFmode:
              if (!register_operand (operands[0], E_TFmode)
                  || !register_operand (operands[1], E_TFmode)
                  || !scratch_operand (operands[2], E_TImode)
                  || !(
#line 2064 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 88 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 452; /* *vec_cmpeqtf_cconly */

            default:
              return -1;
            }

        case E_CCVIHmode:
          x6 = XEXP (x4, 1);
          switch (pattern234 (x6, 
E_CCVIHmode))
            {
            case 0:
              if (!
#line 1981 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 414; /* *vec_cmphv16qi_cconly */

            case 1:
              if (!
#line 1981 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 417; /* *vec_cmphv8hi_cconly */

            case 2:
              if (!
#line 1981 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 420; /* *vec_cmphv4si_cconly */

            case 3:
              if (!
#line 1981 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 423; /* *vec_cmphv2di_cconly */

            case 4:
              if (!(
#line 1981 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 51 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
                return -1;
              return 426; /* *vec_cmphv1ti_cconly */

            case 5:
              if (!(
#line 1981 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 51 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
                return -1;
              return 429; /* *vec_cmphti_cconly */

            default:
              return -1;
            }

        case E_CCVIHUmode:
          x6 = XEXP (x4, 1);
          switch (pattern234 (x6, 
E_CCVIHUmode))
            {
            case 0:
              if (!
#line 1981 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 415; /* *vec_cmphlv16qi_cconly */

            case 1:
              if (!
#line 1981 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 418; /* *vec_cmphlv8hi_cconly */

            case 2:
              if (!
#line 1981 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 421; /* *vec_cmphlv4si_cconly */

            case 3:
              if (!
#line 1981 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 424; /* *vec_cmphlv2di_cconly */

            case 4:
              if (!(
#line 1981 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 51 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
                return -1;
              return 427; /* *vec_cmphlv1ti_cconly */

            case 5:
              if (!(
#line 1981 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 51 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
                return -1;
              return 430; /* *vec_cmphlti_cconly */

            default:
              return -1;
            }

        case E_CCVFHmode:
          x6 = XEXP (x4, 1);
          switch (pattern235 (x6, 
E_CCVFHmode))
            {
            case 0:
              if (!(
#line 2064 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 87 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 453; /* *vec_cmphv4sf_cconly */

            case 1:
              if (!
#line 2064 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 454; /* *vec_cmphv2df_cconly */

            case 2:
              if (!(
#line 2064 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 87 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 455; /* *vec_cmphv1tf_cconly */

            case 3:
              if (!(
#line 2064 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 88 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 456; /* *vec_cmphtf_cconly */

            default:
              return -1;
            }

        case E_CCVFHEmode:
          x6 = XEXP (x4, 1);
          switch (pattern235 (x6, 
E_CCVFHEmode))
            {
            case 0:
              if (!(
#line 2064 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 87 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 457; /* *vec_cmphev4sf_cconly */

            case 1:
              if (!
#line 2064 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 458; /* *vec_cmphev2df_cconly */

            case 2:
              if (!(
#line 2064 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 87 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 459; /* *vec_cmphev1tf_cconly */

            case 3:
              if (!(
#line 2064 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 88 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 460; /* *vec_cmphetf_cconly */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SET:
      x3 = XEXP (x2, 0);
      operands[2] = x3;
      x7 = XEXP (x2, 1);
      switch (GET_CODE (x7))
        {
        case EQ:
          if (pattern236 (x1, 
E_CCVEQmode) != 0)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V16QImode:
              if (pattern273 (x7, 
E_V16QImode) != 0
                  || !
#line 2030 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 431; /* *vec_cmpeqv16qi_cc */

            case E_V8HImode:
              if (pattern273 (x7, 
E_V8HImode) != 0
                  || !
#line 2030 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 432; /* *vec_cmpeqv8hi_cc */

            case E_V4SImode:
              if (pattern273 (x7, 
E_V4SImode) != 0
                  || !
#line 2030 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 433; /* *vec_cmpeqv4si_cc */

            case E_V2DImode:
              if (pattern273 (x7, 
E_V2DImode) != 0
                  || !
#line 2030 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 434; /* *vec_cmpeqv2di_cc */

            case E_V1TImode:
              if (pattern273 (x7, 
E_V1TImode) != 0
                  || !(
#line 2030 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 51 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
                return -1;
              return 435; /* *vec_cmpeqv1ti_cc */

            case E_TImode:
              if (pattern273 (x7, 
E_TImode) != 0
                  || !(
#line 2030 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 51 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
                return -1;
              return 436; /* *vec_cmpeqti_cc */

            case E_V4SFmode:
              if (pattern274 (x7, 
E_V4SImode, 
E_V4SFmode) != 0
                  || !(
#line 2113 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 87 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 461; /* *vec_cmpeqv4sf_cc */

            case E_V2DFmode:
              if (pattern274 (x7, 
E_V2DImode, 
E_V2DFmode) != 0
                  || !
#line 2113 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 462; /* *vec_cmpeqv2df_cc */

            case E_V1TFmode:
              if (pattern274 (x7, 
E_V1TImode, 
E_V1TFmode) != 0
                  || !(
#line 2113 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 87 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 463; /* *vec_cmpeqv1tf_cc */

            case E_TFmode:
              if (pattern274 (x7, 
E_TImode, 
E_TFmode) != 0
                  || !(
#line 2113 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 88 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 464; /* *vec_cmpeqtf_cc */

            default:
              return -1;
            }

        case GT:
          x8 = XEXP (x7, 0);
          if (!rtx_equal_p (x8, operands[0]))
            return -1;
          x9 = XEXP (x7, 1);
          if (!rtx_equal_p (x9, operands[1]))
            return -1;
          x4 = XVECEXP (x1, 0, 0);
          x5 = XEXP (x4, 0);
          switch (GET_MODE (x5))
            {
            case E_CCVIHmode:
              x6 = XEXP (x4, 1);
              if (GET_MODE (x6) != E_CCVIHmode)
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_V16QImode:
                  if (pattern273 (x7, 
E_V16QImode) != 0
                      || !
#line 2040 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                    return -1;
                  return 437; /* *vec_cmphv16qi_cc */

                case E_V8HImode:
                  if (pattern273 (x7, 
E_V8HImode) != 0
                      || !
#line 2040 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                    return -1;
                  return 438; /* *vec_cmphv8hi_cc */

                case E_V4SImode:
                  if (pattern273 (x7, 
E_V4SImode) != 0
                      || !
#line 2040 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                    return -1;
                  return 439; /* *vec_cmphv4si_cc */

                case E_V2DImode:
                  if (pattern273 (x7, 
E_V2DImode) != 0
                      || !
#line 2040 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                    return -1;
                  return 440; /* *vec_cmphv2di_cc */

                case E_V1TImode:
                  if (pattern273 (x7, 
E_V1TImode) != 0
                      || !(
#line 2040 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 51 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
                    return -1;
                  return 441; /* *vec_cmphv1ti_cc */

                case E_TImode:
                  if (pattern273 (x7, 
E_TImode) != 0
                      || !(
#line 2040 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 51 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
                    return -1;
                  return 442; /* *vec_cmphti_cc */

                default:
                  return -1;
                }

            case E_CCVFHmode:
              x6 = XEXP (x4, 1);
              if (GET_MODE (x6) != E_CCVFHmode)
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_V4SFmode:
                  if (pattern274 (x7, 
E_V4SImode, 
E_V4SFmode) != 0
                      || !(
#line 2124 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 87 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                    return -1;
                  return 465; /* *vec_cmphv4sf_cc */

                case E_V2DFmode:
                  if (pattern274 (x7, 
E_V2DImode, 
E_V2DFmode) != 0
                      || !
#line 2124 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                    return -1;
                  return 466; /* *vec_cmphv2df_cc */

                case E_V1TFmode:
                  if (pattern274 (x7, 
E_V1TImode, 
E_V1TFmode) != 0
                      || !(
#line 2124 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 87 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                    return -1;
                  return 467; /* *vec_cmphv1tf_cc */

                case E_TFmode:
                  if (pattern274 (x7, 
E_TImode, 
E_TFmode) != 0
                      || !(
#line 2124 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 88 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                    return -1;
                  return 468; /* *vec_cmphtf_cc */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case GTU:
          if (pattern236 (x1, 
E_CCVIHUmode) != 0)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V16QImode:
              if (pattern273 (x7, 
E_V16QImode) != 0
                  || !
#line 2050 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 443; /* *vec_cmphlv16qi_cc */

            case E_V8HImode:
              if (pattern273 (x7, 
E_V8HImode) != 0
                  || !
#line 2050 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 444; /* *vec_cmphlv8hi_cc */

            case E_V4SImode:
              if (pattern273 (x7, 
E_V4SImode) != 0
                  || !
#line 2050 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 445; /* *vec_cmphlv4si_cc */

            case E_V2DImode:
              if (pattern273 (x7, 
E_V2DImode) != 0
                  || !
#line 2050 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 446; /* *vec_cmphlv2di_cc */

            case E_V1TImode:
              if (pattern273 (x7, 
E_V1TImode) != 0
                  || !(
#line 2050 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 51 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
                return -1;
              return 447; /* *vec_cmphlv1ti_cc */

            case E_TImode:
              if (pattern273 (x7, 
E_TImode) != 0
                  || !(
#line 2050 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 51 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
                return -1;
              return 448; /* *vec_cmphlti_cc */

            default:
              return -1;
            }

        case GE:
          if (pattern236 (x1, 
E_CCVFHEmode) != 0)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V4SFmode:
              if (pattern274 (x7, 
E_V4SImode, 
E_V4SFmode) != 0
                  || !(
#line 2135 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 87 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 469; /* *vec_cmphev4sf_cc */

            case E_V2DFmode:
              if (pattern274 (x7, 
E_V2DImode, 
E_V2DFmode) != 0
                  || !
#line 2135 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 470; /* *vec_cmphev2df_cc */

            case E_V1TFmode:
              if (pattern274 (x7, 
E_V1TImode, 
E_V1TFmode) != 0
                  || !(
#line 2135 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 87 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 471; /* *vec_cmphev1tf_cc */

            case E_TFmode:
              if (pattern274 (x7, 
E_TImode, 
E_TFmode) != 0
                  || !(
#line 2135 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 88 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 472; /* *vec_cmphetf_cc */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case USE:
      if (!memory_operand (operands[0], E_BLKmode)
          || !memory_operand (operands[1], E_BLKmode))
        return -1;
      x3 = XEXP (x2, 0);
      operands[2] = x3;
      if (!const_int_operand (operands[2], E_VOIDmode)
          || !
#line 1500 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCUmode)
   && INTVAL (operands[2]) >= 1 && INTVAL (operands[2]) <= 256))
        return -1;
      return 1780; /* *clc */

    default:
      return -1;
    }
}

 int
recog_115 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x3) != CLOBBER)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != MEM
      || pattern98 (x4) != 0)
    return -1;
  x6 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x6) != USE)
    return -1;
  x7 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x7) != USE)
    return -1;
  x8 = XVECEXP (x1, 0, 5);
  if (GET_CODE (x8) != CLOBBER)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != REG
      || REGNO (x9) != 33
      || GET_MODE (x9) != E_CCmode)
    return -1;
  x10 = XEXP (x2, 0);
  operands[0] = x10;
  x11 = XEXP (x3, 0);
  operands[1] = x11;
  switch (pattern258 (x1))
    {
    case 0:
      if (!(
#line 3698 "../../gcc/config/s390/s390.md"
(TARGET_64BIT || !TARGET_ZARCH) && 
#line 778 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
        return -1;
      return 1894; /* *cpymem_long */

    case 1:
      if (!(
#line 3698 "../../gcc/config/s390/s390.md"
(TARGET_64BIT || !TARGET_ZARCH) && 
#line 778 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
        return -1;
      return 1895; /* *cpymem_long */

    case 2:
      if (!
#line 3711 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT && TARGET_ZARCH))
        return -1;
      return 1896; /* *cpymem_long_31z */

    default:
      return -1;
    }
}

 int
recog_117 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37, x38, x39, x40;
  int res ATTRIBUTE_UNUSED;
  if (pattern6 (x1, 
39, 
E_TImode, 
17, 
38) != 0
      || pattern298 (x1, 
41, 
E_TImode, 
19, 
40, 
18) != 0
      || pattern299 (x1, 
43, 
E_TImode, 
21, 
42, 
20) != 0
      || pattern300 (x1, 
E_TImode, 
45, 
23, 
44, 
22) != 0)
    return -1;
  x2 = XVECEXP (x1, 0, 18);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 24
      || GET_MODE (x3) != E_TImode)
    return -1;
  x4 = XVECEXP (x1, 0, 19);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 46
      || GET_MODE (x5) != E_TImode)
    return -1;
  x6 = XVECEXP (x1, 0, 20);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 25
      || GET_MODE (x7) != E_TImode)
    return -1;
  x8 = XVECEXP (x1, 0, 21);
  if (GET_CODE (x8) != CLOBBER)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != REG
      || REGNO (x9) != 47
      || GET_MODE (x9) != E_TImode)
    return -1;
  x10 = XVECEXP (x1, 0, 22);
  if (GET_CODE (x10) != CLOBBER)
    return -1;
  x11 = XEXP (x10, 0);
  if (GET_CODE (x11) != REG
      || REGNO (x11) != 26
      || GET_MODE (x11) != E_TImode)
    return -1;
  x12 = XVECEXP (x1, 0, 23);
  if (GET_CODE (x12) != CLOBBER)
    return -1;
  x13 = XEXP (x12, 0);
  if (GET_CODE (x13) != REG
      || REGNO (x13) != 48
      || GET_MODE (x13) != E_TImode)
    return -1;
  x14 = XVECEXP (x1, 0, 24);
  if (GET_CODE (x14) != CLOBBER)
    return -1;
  x15 = XEXP (x14, 0);
  if (GET_CODE (x15) != REG
      || REGNO (x15) != 27
      || GET_MODE (x15) != E_TImode)
    return -1;
  x16 = XVECEXP (x1, 0, 25);
  if (GET_CODE (x16) != CLOBBER)
    return -1;
  x17 = XEXP (x16, 0);
  if (GET_CODE (x17) != REG
      || REGNO (x17) != 49
      || GET_MODE (x17) != E_TImode)
    return -1;
  x18 = XVECEXP (x1, 0, 26);
  if (GET_CODE (x18) != CLOBBER)
    return -1;
  x19 = XEXP (x18, 0);
  if (GET_CODE (x19) != REG
      || REGNO (x19) != 28
      || GET_MODE (x19) != E_TImode)
    return -1;
  x20 = XVECEXP (x1, 0, 27);
  if (GET_CODE (x20) != CLOBBER)
    return -1;
  x21 = XEXP (x20, 0);
  if (GET_CODE (x21) != REG
      || REGNO (x21) != 50
      || GET_MODE (x21) != E_TImode)
    return -1;
  x22 = XVECEXP (x1, 0, 28);
  if (GET_CODE (x22) != CLOBBER)
    return -1;
  x23 = XEXP (x22, 0);
  if (GET_CODE (x23) != REG
      || REGNO (x23) != 29
      || GET_MODE (x23) != E_TImode)
    return -1;
  x24 = XVECEXP (x1, 0, 29);
  if (GET_CODE (x24) != CLOBBER)
    return -1;
  x25 = XEXP (x24, 0);
  if (GET_CODE (x25) != REG
      || REGNO (x25) != 51
      || GET_MODE (x25) != E_TImode)
    return -1;
  x26 = XVECEXP (x1, 0, 30);
  if (GET_CODE (x26) != CLOBBER)
    return -1;
  x27 = XEXP (x26, 0);
  if (GET_CODE (x27) != REG
      || REGNO (x27) != 30
      || GET_MODE (x27) != E_TImode)
    return -1;
  x28 = XVECEXP (x1, 0, 31);
  if (GET_CODE (x28) != CLOBBER)
    return -1;
  x29 = XEXP (x28, 0);
  if (GET_CODE (x29) != REG
      || REGNO (x29) != 52
      || GET_MODE (x29) != E_TImode)
    return -1;
  x30 = XVECEXP (x1, 0, 32);
  if (GET_CODE (x30) != CLOBBER)
    return -1;
  x31 = XEXP (x30, 0);
  if (GET_CODE (x31) != REG
      || REGNO (x31) != 31
      || GET_MODE (x31) != E_TImode)
    return -1;
  x32 = XVECEXP (x1, 0, 33);
  if (GET_CODE (x32) != CLOBBER)
    return -1;
  x33 = XEXP (x32, 0);
  if (GET_CODE (x33) != REG
      || REGNO (x33) != 53
      || GET_MODE (x33) != E_TImode)
    return -1;
  x34 = XVECEXP (x1, 0, 0);
  x35 = XEXP (x34, 1);
  x36 = XVECEXP (x35, 0, 0);
  operands[0] = x36;
  if (!const_int_operand (operands[0], E_VOIDmode))
    return -1;
  x37 = XVECEXP (x1, 0, 1);
  x38 = XEXP (x37, 0);
  operands[1] = x38;
  if (!memory_operand (operands[1], E_BLKmode))
    return -1;
  x39 = XEXP (x37, 1);
  x40 = XVECEXP (x39, 0, 0);
  if (!rtx_equal_p (x40, operands[0])
      || !
#line 12384 "../../gcc/config/s390/s390.md"
(TARGET_VX && INTVAL (operands[0]) >= 0 && INTVAL (operands[0]) <= 0xffff))
    return -1;
  return 2654; /* tbegin_1_z13 */
}

 int
recog_120 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case UNSPEC:
      return recog_63 (x1, insn, pnum_clobbers);

    case VEC_SELECT:
      return recog_59 (x1, insn, pnum_clobbers);

    case IOR:
      return recog_58 (x1, insn, pnum_clobbers);

    case NOT:
      return recog_55 (x1, insn, pnum_clobbers);

    case COMPARE:
      return recog_57 (x1, insn, pnum_clobbers);

    case BSWAP:
      return recog_69 (x1, insn, pnum_clobbers);

    case VEC_CONCAT:
      return recog_77 (x1, insn, pnum_clobbers);

    case VEC_DUPLICATE:
      return recog_66 (x1, insn, pnum_clobbers);

    case DIV:
      return recog_72 (x1, insn, pnum_clobbers);

    case UDIV:
      switch (pattern1 (x1))
        {
        case 0:
          if (!
#line 1172 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 726; /* udivv4si3 */

        case 1:
          if (!
#line 1172 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 727; /* udivv2di3 */

        case 2:
          if (!
#line 1172 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 728; /* udivv1ti3 */

        case 3:
          if (!
#line 1172 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 729; /* udivti3 */

        default:
          return -1;
        }

    case MOD:
      switch (pattern1 (x1))
        {
        case 0:
          if (!
#line 1181 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 730; /* modv4si3 */

        case 1:
          if (!
#line 1181 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 731; /* modv2di3 */

        case 2:
          if (!
#line 1181 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 732; /* modv1ti3 */

        case 3:
          if (!
#line 1181 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 733; /* modti3 */

        default:
          return -1;
        }

    case UMOD:
      switch (pattern1 (x1))
        {
        case 0:
          if (!
#line 1190 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 734; /* umodv4si3 */

        case 1:
          if (!
#line 1190 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 735; /* umodv2di3 */

        case 2:
          if (!
#line 1190 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 736; /* umodv1ti3 */

        case 3:
          if (!
#line 1190 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 737; /* umodti3 */

        default:
          return -1;
        }

    case NEG:
      return recog_56 (x1, insn, pnum_clobbers);

    case ABS:
      return recog_60 (x1, insn, pnum_clobbers);

    case XOR:
      return recog_61 (x1, insn, pnum_clobbers);

    case CLZ:
      switch (pattern2 (x1))
        {
        case 0:
          if (!
#line 1444 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 931; /* clzv1qi2 */

        case 1:
          if (!
#line 1444 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 932; /* clzv2qi2 */

        case 2:
          if (!
#line 1444 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 933; /* clzv4qi2 */

        case 3:
          if (!
#line 1444 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 934; /* clzv8qi2 */

        case 4:
          if (!
#line 1444 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 935; /* clzv16qi2 */

        case 5:
          if (!
#line 1444 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 936; /* clzv1hi2 */

        case 6:
          if (!
#line 1444 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 937; /* clzv2hi2 */

        case 7:
          if (!
#line 1444 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 938; /* clzv4hi2 */

        case 8:
          if (!
#line 1444 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 939; /* clzv8hi2 */

        case 9:
          if (!
#line 1444 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 940; /* clzv1si2 */

        case 10:
          if (!
#line 1444 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 941; /* clzv2si2 */

        case 11:
          if (!
#line 1444 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 942; /* clzv4si2 */

        case 12:
          if (!
#line 1444 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 943; /* clzv1di2 */

        case 13:
          if (!
#line 1444 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 944; /* clzv2di2 */

        case 14:
          if (!
#line 1444 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 945; /* clzv1sf2 */

        case 15:
          if (!
#line 1444 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 946; /* clzv2sf2 */

        case 16:
          if (!
#line 1444 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 947; /* clzv4sf2 */

        case 17:
          if (!
#line 1444 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 948; /* clzv1df2 */

        case 18:
          if (!
#line 1444 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 949; /* clzv2df2 */

        case 19:
          if (!
#line 1444 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 950; /* clzv1tf2 */

        case 20:
          if (!(
#line 1444 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 30 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 951; /* clzv1ti2 */

        case 21:
          if (!(
#line 1444 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 30 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 952; /* clzti2 */

        case 22:
          if (!
#line 9611 "../../gcc/config/s390/s390.md"
(TARGET_Z17 && TARGET_64BIT))
            return -1;
          return 2505; /* *clzg */

        default:
          return -1;
        }

    case CTZ:
      return recog_79 (x1, insn, pnum_clobbers);

    case ROTATE:
      return recog_67 (x1, insn, pnum_clobbers);

    case ASHIFT:
      return recog_64 (x1, insn, pnum_clobbers);

    case ASHIFTRT:
      return recog_62 (x1, insn, pnum_clobbers);

    case LSHIFTRT:
      return recog_65 (x1, insn, pnum_clobbers);

    case SMIN:
      switch (pattern3 (x1))
        {
        case 0:
          if (!
#line 1640 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1107; /* *sminv1qi3 */

        case 1:
          if (!
#line 1640 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1108; /* *sminv2qi3 */

        case 2:
          if (!
#line 1640 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1109; /* *sminv4qi3 */

        case 3:
          if (!
#line 1640 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1110; /* *sminv8qi3 */

        case 4:
          if (!
#line 1640 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1111; /* *sminv16qi3 */

        case 5:
          if (!
#line 1640 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1112; /* *sminv1hi3 */

        case 6:
          if (!
#line 1640 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1113; /* *sminv2hi3 */

        case 7:
          if (!
#line 1640 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1114; /* *sminv4hi3 */

        case 8:
          if (!
#line 1640 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1115; /* *sminv8hi3 */

        case 9:
          if (!
#line 1640 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1116; /* *sminv1si3 */

        case 10:
          if (!
#line 1640 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1117; /* *sminv2si3 */

        case 11:
          if (!
#line 1640 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1118; /* *sminv4si3 */

        case 12:
          if (!
#line 1640 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1119; /* *sminv1di3 */

        case 13:
          if (!
#line 1640 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1120; /* *sminv2di3 */

        case 14:
          if (!(
#line 1640 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 69 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 1121; /* *sminv1ti3 */

        case 15:
          if (!(
#line 1640 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 69 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 1122; /* *sminti3 */

        case 16:
          if (!
#line 2059 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 1289; /* *sminv4sf3_vxe */

        case 17:
          if (
#line 2059 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return 1290; /* *sminv2df3_vxe */
          if (!
#line 2068 "../../gcc/config/s390/vector.md"
(TARGET_VX && !TARGET_VXE))
            return -1;
          return 1293; /* *sminv2df3_vx */

        case 18:
          if (!
#line 2059 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 1291; /* *sminv1tf3_vxe */

        case 19:
          if (!
#line 2059 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 1292; /* *smintf3_vxe */

        default:
          return -1;
        }

    case SMAX:
      switch (pattern3 (x1))
        {
        case 0:
          if (!
#line 1665 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1123; /* *smaxv1qi3 */

        case 1:
          if (!
#line 1665 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1124; /* *smaxv2qi3 */

        case 2:
          if (!
#line 1665 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1125; /* *smaxv4qi3 */

        case 3:
          if (!
#line 1665 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1126; /* *smaxv8qi3 */

        case 4:
          if (!
#line 1665 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1127; /* *smaxv16qi3 */

        case 5:
          if (!
#line 1665 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1128; /* *smaxv1hi3 */

        case 6:
          if (!
#line 1665 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1129; /* *smaxv2hi3 */

        case 7:
          if (!
#line 1665 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1130; /* *smaxv4hi3 */

        case 8:
          if (!
#line 1665 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1131; /* *smaxv8hi3 */

        case 9:
          if (!
#line 1665 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1132; /* *smaxv1si3 */

        case 10:
          if (!
#line 1665 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1133; /* *smaxv2si3 */

        case 11:
          if (!
#line 1665 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1134; /* *smaxv4si3 */

        case 12:
          if (!
#line 1665 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1135; /* *smaxv1di3 */

        case 13:
          if (!
#line 1665 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1136; /* *smaxv2di3 */

        case 14:
          if (!(
#line 1665 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 69 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 1137; /* *smaxv1ti3 */

        case 15:
          if (!(
#line 1665 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 69 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 1138; /* *smaxti3 */

        case 16:
          if (!
#line 2023 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 1284; /* *smaxv4sf3_vxe */

        case 17:
          if (
#line 2023 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return 1285; /* *smaxv2df3_vxe */
          if (!
#line 2032 "../../gcc/config/s390/vector.md"
(TARGET_VX && !TARGET_VXE))
            return -1;
          return 1288; /* *smaxv2df3_vx */

        case 18:
          if (!
#line 2023 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 1286; /* *smaxv1tf3_vxe */

        case 19:
          if (!
#line 2023 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 1287; /* *smaxtf3_vxe */

        default:
          return -1;
        }

    case UMIN:
      switch (pattern4 (x1))
        {
        case 0:
          if (!
#line 1690 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1139; /* *uminv1qi3 */

        case 1:
          if (!
#line 1690 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1140; /* *uminv2qi3 */

        case 2:
          if (!
#line 1690 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1141; /* *uminv4qi3 */

        case 3:
          if (!
#line 1690 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1142; /* *uminv8qi3 */

        case 4:
          if (!
#line 1690 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1143; /* *uminv16qi3 */

        case 5:
          if (!
#line 1690 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1144; /* *uminv1hi3 */

        case 6:
          if (!
#line 1690 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1145; /* *uminv2hi3 */

        case 7:
          if (!
#line 1690 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1146; /* *uminv4hi3 */

        case 8:
          if (!
#line 1690 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1147; /* *uminv8hi3 */

        case 9:
          if (!
#line 1690 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1148; /* *uminv1si3 */

        case 10:
          if (!
#line 1690 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1149; /* *uminv2si3 */

        case 11:
          if (!
#line 1690 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1150; /* *uminv4si3 */

        case 12:
          if (!
#line 1690 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1151; /* *uminv1di3 */

        case 13:
          if (!
#line 1690 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1152; /* *uminv2di3 */

        case 14:
          if (!(
#line 1690 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 69 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 1153; /* *uminv1ti3 */

        case 15:
          if (!(
#line 1690 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 69 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 1154; /* *uminti3 */

        default:
          return -1;
        }

    case UMAX:
      switch (pattern4 (x1))
        {
        case 0:
          if (!
#line 1715 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1155; /* *umaxv1qi3 */

        case 1:
          if (!
#line 1715 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1156; /* *umaxv2qi3 */

        case 2:
          if (!
#line 1715 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1157; /* *umaxv4qi3 */

        case 3:
          if (!
#line 1715 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1158; /* *umaxv8qi3 */

        case 4:
          if (!
#line 1715 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1159; /* *umaxv16qi3 */

        case 5:
          if (!
#line 1715 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1160; /* *umaxv1hi3 */

        case 6:
          if (!
#line 1715 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1161; /* *umaxv2hi3 */

        case 7:
          if (!
#line 1715 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1162; /* *umaxv4hi3 */

        case 8:
          if (!
#line 1715 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1163; /* *umaxv8hi3 */

        case 9:
          if (!
#line 1715 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1164; /* *umaxv1si3 */

        case 10:
          if (!
#line 1715 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1165; /* *umaxv2si3 */

        case 11:
          if (!
#line 1715 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1166; /* *umaxv4si3 */

        case 12:
          if (!
#line 1715 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1167; /* *umaxv1di3 */

        case 13:
          if (!
#line 1715 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1168; /* *umaxv2di3 */

        case 14:
          if (!(
#line 1715 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 69 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 1169; /* *umaxv1ti3 */

        case 15:
          if (!(
#line 1715 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 69 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 1170; /* *umaxti3 */

        default:
          return -1;
        }

    case SQRT:
      return recog_73 (x1, insn, pnum_clobbers);

    case FMA:
      return recog_76 (x1, insn, pnum_clobbers);

    case IF_THEN_ELSE:
      return recog_78 (x1, insn, pnum_clobbers);

    case FLOAT_EXTEND:
      return recog_70 (x1, insn, pnum_clobbers);

    case FLOAT:
      return recog_75 (x1, insn, pnum_clobbers);

    case UNSIGNED_FLOAT:
      return recog_71 (x1, insn, pnum_clobbers);

    case FIX:
      switch (pattern5 (x1))
        {
        case 0:
          if (!
#line 3032 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1535; /* fix_truncv2dfv2di2 */

        case 1:
          if (!(
#line 3032 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 99 "../../gcc/config/s390/vector.md"
(TARGET_VXE2)))
            return -1;
          return 1536; /* fix_truncv4sfv4si2 */

        default:
          return -1;
        }

    case UNSIGNED_FIX:
      switch (pattern5 (x1))
        {
        case 0:
          if (!
#line 3064 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1537; /* fixuns_truncv2dfv2di2 */

        case 1:
          if (!(
#line 3064 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 99 "../../gcc/config/s390/vector.md"
(TARGET_VXE2)))
            return -1;
          return 1538; /* fixuns_truncv4sfv4si2 */

        default:
          return -1;
        }

    case ZERO_EXTRACT:
      x3 = XEXP (x2, 2);
      if (GET_CODE (x3) != CONST_INT)
        return -1;
      operands[3] = x3;
      if (const_int_operand (operands[3], E_VOIDmode))
        {
          res = recog_34 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      if (pnum_clobbers == NULL
          || XWINT (x3, 0) != 0L)
        return -1;
      switch (pattern34 (x1))
        {
        case 0:
          if (!(
#line 4415 "../../gcc/config/s390/s390.md"
(!TARGET_Z10) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 1952; /* *pre_z10_extzvdi */

        case 1:
          if (!
#line 4415 "../../gcc/config/s390/s390.md"
(!TARGET_Z10))
            return -1;
          *pnum_clobbers = 1;
          return 1953; /* *pre_z10_extzvsi */

        default:
          return -1;
        }

    case SIGN_EXTRACT:
      if (pnum_clobbers == NULL)
        return -1;
      x3 = XEXP (x2, 2);
      if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      switch (pattern34 (x1))
        {
        case 0:
          if (!
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return -1;
          *pnum_clobbers = 1;
          return 1954; /* *pre_z10_extvdi */

        case 1:
          *pnum_clobbers = 1;
          return 1955; /* *pre_z10_extvsi */

        default:
          return -1;
        }

    case FLOAT_TRUNCATE:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x5 = XEXP (x2, 0);
      operands[1] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (!register_operand (operands[0], E_SFmode)
              || GET_MODE (x2) != E_SFmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_DFmode:
              if (!register_operand (operands[1], E_DFmode)
                  || !
#line 5701 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 2096; /* truncdfsf2 */

            case E_TFmode:
              if (pnum_clobbers == NULL
                  || !register_operand (operands[1], E_TFmode)
                  || !
#line 5719 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
                return -1;
              *pnum_clobbers = 1;
              return 2098; /* trunctfsf2_fpr */

            default:
              return -1;
            }

        case E_DFmode:
          if (pnum_clobbers == NULL
              || !register_operand (operands[0], E_DFmode)
              || GET_MODE (x2) != E_DFmode
              || !register_operand (operands[1], E_TFmode)
              || !
#line 5719 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
            return -1;
          *pnum_clobbers = 1;
          return 2097; /* trunctfdf2_fpr */

        case E_SDmode:
          if (!register_operand (operands[0], E_SDmode)
              || GET_MODE (x2) != E_SDmode
              || !register_operand (operands[1], E_DDmode)
              || !
#line 5750 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          return 2100; /* truncddsd2 */

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case PLUS:
    case MINUS:
    case MULT:
    case AND:
    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case LTGT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case UNORDERED:
    case ORDERED:
    case UNEQ:
    case UNGE:
    case UNGT:
    case UNLE:
    case UNLT:
    case SIGN_EXTEND:
    case ZERO_EXTEND:
    case HIGH:
      return recog_68 (x1, insn, pnum_clobbers);

    case CALL:
      x5 = XEXP (x2, 0);
      if (GET_CODE (x5) != MEM
          || GET_MODE (x5) != E_QImode)
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x6 = XEXP (x2, 1);
      if (!const_int_operand (x6, E_VOIDmode))
        return -1;
      x7 = XEXP (x5, 0);
      switch (GET_CODE (x7))
        {
        case REG:
          if (REGNO (x7) != 1)
            return -1;
          operands[1] = x6;
          if (!
#line 10805 "../../gcc/config/s390/s390.md"
(SIBLING_CALL_P (insn)
   && GET_MODE (XEXP (XEXP (XEXP (PATTERN (insn), 1), 0), 0)) == Pmode))
            return -1;
          return 2570; /* *sibcall_value_br */

        case CONST:
        case SYMBOL_REF:
          operands[1] = x7;
          if (!bras_sym_operand (operands[1], E_VOIDmode))
            return -1;
          operands[2] = x6;
          if (
#line 10835 "../../gcc/config/s390/s390.md"
(SIBLING_CALL_P (insn) && TARGET_SMALL_EXEC))
            return 2571; /* *sibcall_value_brc */
          if (!
#line 10844 "../../gcc/config/s390/s390.md"
(SIBLING_CALL_P (insn)))
            return -1;
          return 2572; /* *sibcall_value_brcl */

        default:
          return -1;
        }

    case UNSPEC_VOLATILE:
      return recog_74 (x1, insn, pnum_clobbers);

    case POPCOUNT:
      if (pnum_clobbers == NULL
          || GET_MODE (x2) != E_DImode)
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_DImode))
        return -1;
      x5 = XEXP (x2, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_DImode)
          || !
#line 12110 "../../gcc/config/s390/s390.md"
(TARGET_Z15))
        return -1;
      *pnum_clobbers = 1;
      return 2642; /* *popcountdi_z15 */

    case COPYSIGN:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x5 = XEXP (x2, 0);
      operands[1] = x5;
      x6 = XEXP (x2, 1);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_TFmode:
          if (pattern0 (x2, 
E_TFmode) != 0
              || !(
#line 12277 "../../gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 751 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          return 2647; /* copysigntf3_fpr */

        case E_FPRX2mode:
          if (pattern0 (x2, 
E_FPRX2mode) != 0
              || !(
#line 12277 "../../gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 751 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          return 2648; /* copysignfprx23 */

        case E_DFmode:
          if (pattern0 (x2, 
E_DFmode) != 0
              || !
#line 12277 "../../gcc/config/s390/s390.md"
(TARGET_Z196))
            return -1;
          return 2649; /* copysigndf3 */

        case E_SFmode:
          if (pattern0 (x2, 
E_SFmode) != 0
              || !
#line 12277 "../../gcc/config/s390/s390.md"
(TARGET_Z196))
            return -1;
          return 2650; /* copysignsf3 */

        case E_TDmode:
          if (pattern0 (x2, 
E_TDmode) != 0
              || !(
#line 12277 "../../gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 752 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          return 2651; /* copysigntd3 */

        case E_DDmode:
          if (pattern0 (x2, 
E_DDmode) != 0
              || !(
#line 12277 "../../gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 752 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          return 2652; /* copysigndd3 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}
