/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern1 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SImode:
      return pattern0 (x3, 
E_V4SImode); /* [-1, 0] */

    case E_V2DImode:
      if (pattern0 (x3, 
E_V2DImode) != 0)
        return -1;
      return 1;

    case E_V1TImode:
      if (pattern0 (x3, 
E_V1TImode) != 0)
        return -1;
      return 2;

    case E_TImode:
      if (pattern0 (x3, 
E_TImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern14 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (XVECLEN (x2, 0) != 2
      || XINT (x2, 1) != 19)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != IF_THEN_ELSE)
    return -1;
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x3, 2);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x6) != SET)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != PC)
    return -1;
  return 0;
}

int
pattern18 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], i2))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], i1))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern24 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], E_V16QImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !register_operand (operands[1], E_V16QImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode
          || !register_operand (operands[1], E_V8HImode))
        return -1;
      return 1;

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !register_operand (operands[1], E_V4SImode))
        return -1;
      return 2;

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode
          || !register_operand (operands[1], E_V2DImode))
        return -1;
      return 3;

    case E_V1TImode:
      if (!register_operand (operands[0], E_V1TImode)
          || GET_MODE (x3) != E_V1TImode
          || !register_operand (operands[1], E_V1TImode))
        return -1;
      return 4;

    case E_TImode:
      if (!register_operand (operands[0], E_TImode)
          || GET_MODE (x3) != E_TImode
          || !register_operand (operands[1], E_TImode))
        return -1;
      return 5;

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !register_operand (operands[1], E_V4SFmode))
        return -1;
      return 6;

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x3) != E_V2DFmode
          || !register_operand (operands[1], E_V2DFmode))
        return -1;
      return 7;

    case E_V1TFmode:
      if (!register_operand (operands[0], E_V1TFmode)
          || GET_MODE (x3) != E_V1TFmode
          || !register_operand (operands[1], E_V1TFmode))
        return -1;
      return 8;

    case E_TFmode:
      if (!register_operand (operands[0], E_TFmode)
          || GET_MODE (x3) != E_TFmode
          || !register_operand (operands[1], E_TFmode))
        return -1;
      return 9;

    default:
      return -1;
    }
}

int
pattern43 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_BLKmode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != USE)
    return -1;
  x5 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x5) != CLOBBER)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 33
      || GET_MODE (x6) != E_CCmode)
    return -1;
  x7 = XEXP (x2, 0);
  operands[0] = x7;
  if (!memory_operand (operands[0], E_BLKmode))
    return -1;
  x8 = XEXP (x3, 1);
  operands[1] = x8;
  if (!memory_operand (operands[1], E_BLKmode))
    return -1;
  x9 = XEXP (x4, 0);
  operands[2] = x9;
  if (!const_int_operand (operands[2], E_VOIDmode))
    return -1;
  x10 = XEXP (x3, 0);
  if (!rtx_equal_p (x10, operands[0]))
    return -1;
  return 0;
}

int
pattern51 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern57 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1
      || !register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  if (!register_operand (operands[1], i2))
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  operands[2] = x3;
  if (!const_mask_operand (operands[2], E_QImode))
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  operands[3] = x4;
  if (!const_mask_operand (operands[3], E_QImode))
    return -1;
  return 0;
}

int
pattern61 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !nonzero_shift_count_operand (operands[3], i1)
      || !contiguous_bitmask_nowrap_operand (operands[2], i1)
      || !nonimmediate_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern69 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_TDmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_TDmode)
        return -1;
      x4 = XEXP (x3, 0);
      switch (GET_MODE (x4))
        {
        case E_TFmode:
          return 0;

        case E_FPRX2mode:
          return 1;

        case E_DFmode:
          return 2;

        case E_SFmode:
          return 3;

        default:
          return -1;
        }

    case E_DDmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_DDmode)
        return -1;
      x4 = XEXP (x3, 0);
      switch (GET_MODE (x4))
        {
        case E_TFmode:
          return 4;

        case E_FPRX2mode:
          return 5;

        case E_DFmode:
          return 6;

        case E_SFmode:
          return 7;

        default:
          return -1;
        }

    case E_SDmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_SDmode)
        return -1;
      x4 = XEXP (x3, 0);
      switch (GET_MODE (x4))
        {
        case E_TFmode:
          return 8;

        case E_FPRX2mode:
          return 9;

        case E_DFmode:
          return 10;

        case E_SFmode:
          return 11;

        default:
          return -1;
        }

    case E_TFmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_TFmode)
        return -1;
      x4 = XEXP (x3, 0);
      switch (GET_MODE (x4))
        {
        case E_TDmode:
          return 12;

        case E_DDmode:
          return 13;

        case E_SDmode:
          return 14;

        default:
          return -1;
        }

    case E_FPRX2mode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_FPRX2mode)
        return -1;
      x4 = XEXP (x3, 0);
      switch (GET_MODE (x4))
        {
        case E_TDmode:
          return 15;

        case E_DDmode:
          return 16;

        case E_SDmode:
          return 17;

        default:
          return -1;
        }

    case E_DFmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_DFmode)
        return -1;
      x4 = XEXP (x3, 0);
      switch (GET_MODE (x4))
        {
        case E_TDmode:
          return 18;

        case E_DDmode:
          return 19;

        case E_SDmode:
          return 20;

        default:
          return -1;
        }

    case E_SFmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_SFmode)
        return -1;
      x4 = XEXP (x3, 0);
      switch (GET_MODE (x4))
        {
        case E_TDmode:
          return 21;

        case E_DDmode:
          return 22;

        case E_SDmode:
          return 23;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern108 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern114 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PARALLEL)
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  switch (XVECLEN (x3, 0))
    {
    case 8:
      x5 = XVECEXP (x3, 0, 0);
      if (GET_CODE (x5) != CONST_INT)
        return -1;
      x6 = XVECEXP (x3, 0, 1);
      if (GET_CODE (x6) != CONST_INT)
        return -1;
      x7 = XVECEXP (x3, 0, 2);
      if (GET_CODE (x7) != CONST_INT)
        return -1;
      x8 = XVECEXP (x3, 0, 3);
      if (GET_CODE (x8) != CONST_INT)
        return -1;
      x9 = XVECEXP (x3, 0, 4);
      if (GET_CODE (x9) != CONST_INT)
        return -1;
      x10 = XVECEXP (x3, 0, 5);
      if (GET_CODE (x10) != CONST_INT)
        return -1;
      x11 = XVECEXP (x3, 0, 6);
      if (GET_CODE (x11) != CONST_INT)
        return -1;
      x12 = XVECEXP (x3, 0, 7);
      if (GET_CODE (x12) != CONST_INT
          || !register_operand (operands[0], E_V8HImode)
          || GET_MODE (x1) != E_V8HImode
          || GET_MODE (x2) != E_V8QImode
          || !register_operand (operands[1], E_V16QImode))
        return -1;
      switch (XWINT (x5, 0))
        {
        case 0L:
          if (XWINT (x6, 0) != 1L
              || XWINT (x7, 0) != 2L
              || XWINT (x8, 0) != 3L
              || XWINT (x9, 0) != 4L
              || XWINT (x10, 0) != 5L
              || XWINT (x11, 0) != 6L
              || XWINT (x12, 0) != 7L)
            return -1;
          return 0;

        case 8L:
          if (XWINT (x6, 0) != 9L
              || XWINT (x7, 0) != 10L
              || XWINT (x8, 0) != 11L
              || XWINT (x9, 0) != 12L
              || XWINT (x10, 0) != 13L
              || XWINT (x11, 0) != 14L
              || XWINT (x12, 0) != 15L)
            return -1;
          return 1;

        default:
          return -1;
        }

    case 4:
      x5 = XVECEXP (x3, 0, 0);
      if (GET_CODE (x5) != CONST_INT)
        return -1;
      x6 = XVECEXP (x3, 0, 1);
      if (GET_CODE (x6) != CONST_INT)
        return -1;
      x7 = XVECEXP (x3, 0, 2);
      if (GET_CODE (x7) != CONST_INT)
        return -1;
      x8 = XVECEXP (x3, 0, 3);
      if (GET_CODE (x8) != CONST_INT
          || !register_operand (operands[0], E_V4SImode)
          || GET_MODE (x1) != E_V4SImode
          || GET_MODE (x2) != E_V4HImode
          || !register_operand (operands[1], E_V8HImode))
        return -1;
      switch (XWINT (x5, 0))
        {
        case 0L:
          if (XWINT (x6, 0) != 1L
              || XWINT (x7, 0) != 2L
              || XWINT (x8, 0) != 3L)
            return -1;
          return 2;

        case 4L:
          if (XWINT (x6, 0) != 5L
              || XWINT (x7, 0) != 6L
              || XWINT (x8, 0) != 7L)
            return -1;
          return 3;

        default:
          return -1;
        }

    case 2:
      x5 = XVECEXP (x3, 0, 0);
      if (GET_CODE (x5) != CONST_INT)
        return -1;
      x6 = XVECEXP (x3, 0, 1);
      if (GET_CODE (x6) != CONST_INT
          || !register_operand (operands[0], E_V2DImode)
          || GET_MODE (x1) != E_V2DImode
          || GET_MODE (x2) != E_V2SImode
          || !register_operand (operands[1], E_V4SImode))
        return -1;
      switch (XWINT (x5, 0))
        {
        case 0L:
          if (XWINT (x6, 0) != 1L)
            return -1;
          return 4;

        case 2L:
          if (XWINT (x6, 0) != 3L)
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern154 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!nonimmediate_operand (operands[0], E_QImode)
          || GET_MODE (x1) != E_QImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V1QImode:
          return 0;

        case E_V2QImode:
          return 1;

        case E_V4QImode:
          return 2;

        case E_V8QImode:
          return 3;

        case E_V16QImode:
          return 4;

        default:
          return -1;
        }

    case E_HImode:
      if (!nonimmediate_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V1HImode:
          return 5;

        case E_V2HImode:
          return 6;

        case E_V4HImode:
          return 7;

        case E_V8HImode:
          return 8;

        default:
          return -1;
        }

    case E_SImode:
      if (!nonimmediate_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V1SImode:
          return 9;

        case E_V2SImode:
          return 10;

        case E_V4SImode:
          return 11;

        default:
          return -1;
        }

    case E_DImode:
      if (!nonimmediate_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V1DImode:
          return 12;

        case E_V2DImode:
          return 13;

        default:
          return -1;
        }

    case E_SFmode:
      if (!nonimmediate_operand (operands[0], E_SFmode)
          || GET_MODE (x1) != E_SFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V1SFmode:
          return 14;

        case E_V2SFmode:
          return 15;

        case E_V4SFmode:
          return 16;

        default:
          return -1;
        }

    case E_DFmode:
      if (!nonimmediate_operand (operands[0], E_DFmode)
          || GET_MODE (x1) != E_DFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V1DFmode:
          return 17;

        case E_V2DFmode:
          return 18;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern187 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1
      || !s390_alc_comparison (operands[3], i1)
      || !nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern190 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !memory_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern195 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_CODE (operands[1]))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (!s_operand (operands[0], E_DImode)
              || GET_MODE (x1) != E_DImode
              || !immediate_operand (operands[1], E_DImode))
            return -1;
          return 0;

        case E_SImode:
          if (!s_operand (operands[0], E_SImode)
              || GET_MODE (x1) != E_SImode
              || !immediate_operand (operands[1], E_SImode))
            return -1;
          return 1;

        case E_HImode:
          if (!s_operand (operands[0], E_HImode)
              || GET_MODE (x1) != E_HImode
              || !immediate_operand (operands[1], E_HImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case SUBREG:
    case MEM:
      if (!memory_operand (operands[1], E_VOIDmode)
          || !memory_operand (operands[0], E_VOIDmode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern215 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern224 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[1], i1)
      || GET_MODE (x1) != i1
      || !general_operand (operands[2], i1)
      || !scratch_operand (operands[0], i1))
    return -1;
  return 0;
}

int
pattern232 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 1
      || XINT (x3, 1) != 5
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 33
      || GET_MODE (x4) != E_CCRAWmode)
    return -1;
  x5 = XVECEXP (x1, 0, 0);
  x6 = XEXP (x5, 1);
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 1);
  operands[1] = x8;
  if (!const_int_operand (operands[1], E_VOIDmode))
    return -1;
  x9 = XEXP (x6, 1);
  x10 = XEXP (x9, 0);
  operands[2] = x10;
  x11 = XEXP (x2, 0);
  operands[3] = x11;
  if (!register_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern246 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !nonzero_shift_count_operand (operands[2], i1)
      || !contiguous_bitmask_nowrap_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern255 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  operands[3] = x4;
  if (!const0_operand (operands[3], i1)
      || !register_operand (operands[0], i1))
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 1);
  if (GET_MODE (x6) != i1)
    return -1;
  return 0;
}

int
pattern266 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  if (!nonimmediate_operand (operands[0], E_V8HImode))
    return -1;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  if (!nonimmediate_operand (operands[1], E_V8HImode))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  operands[2] = x7;
  if (!scratch_operand (operands[2], E_V2DImode))
    return -1;
  x8 = XVECEXP (x1, 0, 2);
  x9 = XEXP (x8, 0);
  operands[3] = x9;
  if (!scratch_operand (operands[3], E_V4SImode))
    return -1;
  return 0;
}

int
pattern277 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !s390_alc_comparison (operands[3], i1)
      || !nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1)
      || !register_operand (operands[0], i1))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 1);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) != i1)
    return -1;
  return 0;
}

int
pattern289 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern297 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x4, 0);
  if (GET_MODE (x6) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x7 = XEXP (x6, 1);
  if (GET_MODE (x7) != i1
      || !register_operand (operands[2], i2)
      || !nonimmediate_operand (operands[3], i1))
    return -1;
  x8 = XVECEXP (x1, 0, 1);
  x9 = XEXP (x8, 1);
  if (GET_MODE (x9) != i1)
    return -1;
  x10 = XEXP (x9, 1);
  if (GET_MODE (x10) != i1)
    return -1;
  return 0;
}

 int
recog_6 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern23 (x1))
    {
    case 0:
      if (!
#line 1049 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 207; /* vec_sllv16qiv16qi */

    case 1:
      if (!
#line 1049 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 217; /* vec_sllv16qiv8hi */

    case 2:
      if (!
#line 1049 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 227; /* vec_sllv16qiv4si */

    case 3:
      if (!
#line 1049 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 208; /* vec_sllv8hiv16qi */

    case 4:
      if (!
#line 1049 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 218; /* vec_sllv8hiv8hi */

    case 5:
      if (!
#line 1049 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 228; /* vec_sllv8hiv4si */

    case 6:
      if (!
#line 1049 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 209; /* vec_sllv4siv16qi */

    case 7:
      if (!
#line 1049 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 219; /* vec_sllv4siv8hi */

    case 8:
      if (!
#line 1049 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 229; /* vec_sllv4siv4si */

    case 9:
      if (!
#line 1049 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 210; /* vec_sllv2div16qi */

    case 10:
      if (!
#line 1049 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 220; /* vec_sllv2div8hi */

    case 11:
      if (!
#line 1049 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 230; /* vec_sllv2div4si */

    case 12:
      if (!
#line 1049 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 211; /* vec_sllv1tiv16qi */

    case 13:
      if (!
#line 1049 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 221; /* vec_sllv1tiv8hi */

    case 14:
      if (!
#line 1049 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 231; /* vec_sllv1tiv4si */

    case 15:
      if (!
#line 1049 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 212; /* vec_slltiv16qi */

    case 16:
      if (!
#line 1049 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 222; /* vec_slltiv8hi */

    case 17:
      if (!
#line 1049 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 232; /* vec_slltiv4si */

    case 18:
      if (!
#line 1049 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 213; /* vec_sllv4sfv16qi */

    case 19:
      if (!
#line 1049 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 223; /* vec_sllv4sfv8hi */

    case 20:
      if (!
#line 1049 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 233; /* vec_sllv4sfv4si */

    case 21:
      if (!
#line 1049 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 214; /* vec_sllv2dfv16qi */

    case 22:
      if (!
#line 1049 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 224; /* vec_sllv2dfv8hi */

    case 23:
      if (!
#line 1049 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 234; /* vec_sllv2dfv4si */

    case 24:
      if (!
#line 1049 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 215; /* vec_sllv1tfv16qi */

    case 25:
      if (!
#line 1049 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 225; /* vec_sllv1tfv8hi */

    case 26:
      if (!
#line 1049 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 235; /* vec_sllv1tfv4si */

    case 27:
      if (!
#line 1049 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 216; /* vec_slltfv16qi */

    case 28:
      if (!
#line 1049 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 226; /* vec_slltfv8hi */

    case 29:
      if (!
#line 1049 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 236; /* vec_slltfv4si */

    default:
      return -1;
    }
}

 int
recog_23 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case NOT:
      x4 = XEXP (x2, 0);
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x6 = XEXP (x3, 0);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V1QImode:
          if (pattern130 (x2, 
E_V1QImode) != 0
              || !
#line 1274 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 794; /* notandv1qi3 */

        case E_V2QImode:
          if (pattern130 (x2, 
E_V2QImode) != 0
              || !
#line 1274 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 795; /* notandv2qi3 */

        case E_V4QImode:
          if (pattern130 (x2, 
E_V4QImode) != 0
              || !
#line 1274 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 796; /* notandv4qi3 */

        case E_V8QImode:
          if (pattern130 (x2, 
E_V8QImode) != 0
              || !
#line 1274 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 797; /* notandv8qi3 */

        case E_V16QImode:
          if (pattern130 (x2, 
E_V16QImode) != 0
              || !
#line 1274 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 798; /* notandv16qi3 */

        case E_V1HImode:
          if (pattern130 (x2, 
E_V1HImode) != 0
              || !
#line 1274 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 799; /* notandv1hi3 */

        case E_V2HImode:
          if (pattern130 (x2, 
E_V2HImode) != 0
              || !
#line 1274 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 800; /* notandv2hi3 */

        case E_V4HImode:
          if (pattern130 (x2, 
E_V4HImode) != 0
              || !
#line 1274 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 801; /* notandv4hi3 */

        case E_V8HImode:
          if (pattern130 (x2, 
E_V8HImode) != 0
              || !
#line 1274 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 802; /* notandv8hi3 */

        case E_V1SImode:
          if (pattern130 (x2, 
E_V1SImode) != 0
              || !
#line 1274 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 803; /* notandv1si3 */

        case E_V2SImode:
          if (pattern130 (x2, 
E_V2SImode) != 0
              || !
#line 1274 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 804; /* notandv2si3 */

        case E_V4SImode:
          if (pattern130 (x2, 
E_V4SImode) != 0
              || !
#line 1274 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 805; /* notandv4si3 */

        case E_V1DImode:
          if (pattern130 (x2, 
E_V1DImode) != 0
              || !
#line 1274 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 806; /* notandv1di3 */

        case E_V2DImode:
          if (pattern130 (x2, 
E_V2DImode) != 0
              || !
#line 1274 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 807; /* notandv2di3 */

        case E_V1SFmode:
          if (pattern130 (x2, 
E_V1SFmode) != 0
              || !
#line 1274 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 808; /* notandv1sf3 */

        case E_V2SFmode:
          if (pattern130 (x2, 
E_V2SFmode) != 0
              || !
#line 1274 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 809; /* notandv2sf3 */

        case E_V4SFmode:
          if (pattern130 (x2, 
E_V4SFmode) != 0
              || !
#line 1274 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 810; /* notandv4sf3 */

        case E_V1DFmode:
          if (pattern130 (x2, 
E_V1DFmode) != 0
              || !
#line 1274 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 811; /* notandv1df3 */

        case E_V2DFmode:
          if (pattern130 (x2, 
E_V2DFmode) != 0
              || !
#line 1274 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 812; /* notandv2df3 */

        case E_V1TFmode:
          if (pattern130 (x2, 
E_V1TFmode) != 0
              || !
#line 1274 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 813; /* notandv1tf3 */

        case E_V1TImode:
          if (pattern130 (x2, 
E_V1TImode) != 0
              || !
#line 1274 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 814; /* notandv1ti3 */

        case E_TImode:
          if (pattern130 (x2, 
E_TImode) != 0
              || !
#line 1274 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 815; /* notandti3 */

        case E_DImode:
          if (pnum_clobbers == NULL
              || pattern130 (x2, 
E_DImode) != 0
              || !(
#line 8652 "../../gcc/config/s390/s390.md"
(TARGET_Z15) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 2400; /* *nanddi */

        case E_SImode:
          if (pnum_clobbers == NULL
              || pattern130 (x2, 
E_SImode) != 0
              || !
#line 8652 "../../gcc/config/s390/s390.md"
(TARGET_Z15))
            return -1;
          *pnum_clobbers = 1;
          return 2402; /* *nandsi */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      switch (GET_MODE (operands[0]))
        {
        case E_V1QImode:
          if (pattern81 (x2, 
E_V1QImode) != 0
              || !
#line 1294 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 838; /* ior_notv1qi3 */

        case E_V2QImode:
          if (pattern81 (x2, 
E_V2QImode) != 0
              || !
#line 1294 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 839; /* ior_notv2qi3 */

        case E_V4QImode:
          if (pattern81 (x2, 
E_V4QImode) != 0
              || !
#line 1294 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 840; /* ior_notv4qi3 */

        case E_V8QImode:
          if (pattern81 (x2, 
E_V8QImode) != 0
              || !
#line 1294 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 841; /* ior_notv8qi3 */

        case E_V16QImode:
          if (pattern81 (x2, 
E_V16QImode) != 0
              || !
#line 1294 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 842; /* ior_notv16qi3 */

        case E_V1HImode:
          if (pattern81 (x2, 
E_V1HImode) != 0
              || !
#line 1294 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 843; /* ior_notv1hi3 */

        case E_V2HImode:
          if (pattern81 (x2, 
E_V2HImode) != 0
              || !
#line 1294 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 844; /* ior_notv2hi3 */

        case E_V4HImode:
          if (pattern81 (x2, 
E_V4HImode) != 0
              || !
#line 1294 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 845; /* ior_notv4hi3 */

        case E_V8HImode:
          if (pattern81 (x2, 
E_V8HImode) != 0
              || !
#line 1294 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 846; /* ior_notv8hi3 */

        case E_V1SImode:
          if (pattern81 (x2, 
E_V1SImode) != 0
              || !
#line 1294 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 847; /* ior_notv1si3 */

        case E_V2SImode:
          if (pattern81 (x2, 
E_V2SImode) != 0
              || !
#line 1294 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 848; /* ior_notv2si3 */

        case E_V4SImode:
          if (pattern81 (x2, 
E_V4SImode) != 0
              || !
#line 1294 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 849; /* ior_notv4si3 */

        case E_V1DImode:
          if (pattern81 (x2, 
E_V1DImode) != 0
              || !
#line 1294 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 850; /* ior_notv1di3 */

        case E_V2DImode:
          if (pattern81 (x2, 
E_V2DImode) != 0
              || !
#line 1294 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 851; /* ior_notv2di3 */

        case E_V1SFmode:
          if (pattern81 (x2, 
E_V1SFmode) != 0
              || !
#line 1294 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 852; /* ior_notv1sf3 */

        case E_V2SFmode:
          if (pattern81 (x2, 
E_V2SFmode) != 0
              || !
#line 1294 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 853; /* ior_notv2sf3 */

        case E_V4SFmode:
          if (pattern81 (x2, 
E_V4SFmode) != 0
              || !
#line 1294 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 854; /* ior_notv4sf3 */

        case E_V1DFmode:
          if (pattern81 (x2, 
E_V1DFmode) != 0
              || !
#line 1294 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 855; /* ior_notv1df3 */

        case E_V2DFmode:
          if (pattern81 (x2, 
E_V2DFmode) != 0
              || !
#line 1294 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 856; /* ior_notv2df3 */

        case E_V1TFmode:
          if (pattern81 (x2, 
E_V1TFmode) != 0
              || !
#line 1294 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 857; /* ior_notv1tf3 */

        case E_V1TImode:
          if (pattern81 (x2, 
E_V1TImode) != 0
              || !
#line 1294 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 858; /* ior_notv1ti3 */

        case E_TImode:
          if (pattern81 (x2, 
E_TImode) != 0
              || !
#line 1294 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 859; /* ior_notti3 */

        case E_DImode:
          if (pattern82 (x2, pnum_clobbers, 
E_DImode) != 0
              || !(
#line 8612 "../../gcc/config/s390/s390.md"
(TARGET_Z15) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 2388; /* *orcdi */

        case E_SImode:
          if (pattern82 (x2, pnum_clobbers, 
E_SImode) != 0
              || !
#line 8612 "../../gcc/config/s390/s390.md"
(TARGET_Z15))
            return -1;
          *pnum_clobbers = 1;
          return 2390; /* *orcsi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_28 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_DImode))
    return -1;
  x4 = XEXP (x2, 1);
  operands[1] = x4;
  if (!const_int_operand (operands[1], E_VOIDmode))
    return -1;
  x5 = XEXP (x2, 2);
  operands[2] = x5;
  if (!const_int_operand (operands[2], E_VOIDmode))
    return -1;
  x6 = XEXP (x1, 1);
  if (GET_MODE (x6) != E_DImode)
    return -1;
  x7 = XEXP (x6, 0);
  operands[3] = x7;
  if (!register_operand (operands[3], E_DImode))
    return -1;
  x8 = XEXP (x6, 1);
  operands[4] = x8;
  if (!nonzero_shift_count_operand (operands[4], E_DImode))
    return -1;
  if (
#line 4334 "../../gcc/config/s390/s390.md"
(TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[1]), INTVAL (operands[2]), 64)
   && 64 - UINTVAL (operands[4]) >= UINTVAL (operands[1])))
    return 1930; /* *extzvdi_nocc_lshiftrt */
  if (pnum_clobbers == NULL
      || !
#line 4334 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[1]), INTVAL (operands[2]), 64)
   && 64 - UINTVAL (operands[4]) >= UINTVAL (operands[1])))
    return -1;
  *pnum_clobbers = 1;
  return 1931; /* *extzvdi_clobbercc_lshiftrt */
}

 int
recog_30 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  operands[4] = x5;
  x6 = XEXP (x3, 1);
  operands[1] = x6;
  x7 = XEXP (x3, 2);
  operands[2] = x7;
  x8 = XEXP (x4, 0);
  switch (GET_CODE (x8))
    {
    case REG:
    case SUBREG:
      return recog_29 (x1, insn, pnum_clobbers);

    case NOT:
      x9 = XEXP (x8, 0);
      operands[3] = x9;
      switch (GET_MODE (operands[0]))
        {
        case E_V1QImode:
          if (pattern207 (x3, 
E_V1QImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V1QImode)
              && 
#line 2596 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1441; /* *vec_sel0v1qi */
          if (!all_ones_operand (operands[4], E_V1QImode)
              || !
#line 2620 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1479; /* *vec_sel1v1qi */

        case E_V2QImode:
          if (pattern207 (x3, 
E_V2QImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V2QImode)
              && 
#line 2596 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1442; /* *vec_sel0v2qi */
          if (!all_ones_operand (operands[4], E_V2QImode)
              || !
#line 2620 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1480; /* *vec_sel1v2qi */

        case E_V4QImode:
          if (pattern207 (x3, 
E_V4QImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V4QImode)
              && 
#line 2596 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1443; /* *vec_sel0v4qi */
          if (!all_ones_operand (operands[4], E_V4QImode)
              || !
#line 2620 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1481; /* *vec_sel1v4qi */

        case E_V8QImode:
          if (pattern207 (x3, 
E_V8QImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V8QImode)
              && 
#line 2596 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1444; /* *vec_sel0v8qi */
          if (!all_ones_operand (operands[4], E_V8QImode)
              || !
#line 2620 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1482; /* *vec_sel1v8qi */

        case E_V16QImode:
          if (pattern207 (x3, 
E_V16QImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V16QImode)
              && 
#line 2596 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1445; /* *vec_sel0v16qi */
          if (!all_ones_operand (operands[4], E_V16QImode)
              || !
#line 2620 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1483; /* *vec_sel1v16qi */

        case E_V1HImode:
          if (pattern207 (x3, 
E_V1HImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V1HImode)
              && 
#line 2596 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1446; /* *vec_sel0v1hi */
          if (!all_ones_operand (operands[4], E_V1HImode)
              || !
#line 2620 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1484; /* *vec_sel1v1hi */

        case E_V2HImode:
          if (pattern207 (x3, 
E_V2HImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V2HImode)
              && 
#line 2596 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1447; /* *vec_sel0v2hi */
          if (!all_ones_operand (operands[4], E_V2HImode)
              || !
#line 2620 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1485; /* *vec_sel1v2hi */

        case E_V4HImode:
          if (pattern207 (x3, 
E_V4HImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V4HImode)
              && 
#line 2596 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1448; /* *vec_sel0v4hi */
          if (!all_ones_operand (operands[4], E_V4HImode)
              || !
#line 2620 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1486; /* *vec_sel1v4hi */

        case E_V8HImode:
          if (pattern207 (x3, 
E_V8HImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V8HImode)
              && 
#line 2596 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1449; /* *vec_sel0v8hi */
          if (!all_ones_operand (operands[4], E_V8HImode)
              || !
#line 2620 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1487; /* *vec_sel1v8hi */

        case E_V1SImode:
          if (pattern207 (x3, 
E_V1SImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V1SImode)
              && 
#line 2596 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1450; /* *vec_sel0v1si */
          if (!all_ones_operand (operands[4], E_V1SImode)
              || !
#line 2620 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1488; /* *vec_sel1v1si */

        case E_V2SImode:
          if (pattern207 (x3, 
E_V2SImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V2SImode)
              && 
#line 2596 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1451; /* *vec_sel0v2si */
          if (!all_ones_operand (operands[4], E_V2SImode)
              || !
#line 2620 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1489; /* *vec_sel1v2si */

        case E_V4SImode:
          if (pattern207 (x3, 
E_V4SImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V4SImode)
              && 
#line 2596 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1452; /* *vec_sel0v4si */
          if (!all_ones_operand (operands[4], E_V4SImode)
              || !
#line 2620 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1490; /* *vec_sel1v4si */

        case E_V1DImode:
          if (pattern207 (x3, 
E_V1DImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V1DImode)
              && 
#line 2596 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1453; /* *vec_sel0v1di */
          if (!all_ones_operand (operands[4], E_V1DImode)
              || !
#line 2620 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1491; /* *vec_sel1v1di */

        case E_V2DImode:
          if (pattern207 (x3, 
E_V2DImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V2DImode)
              && 
#line 2596 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1454; /* *vec_sel0v2di */
          if (!all_ones_operand (operands[4], E_V2DImode)
              || !
#line 2620 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1492; /* *vec_sel1v2di */

        case E_V1SFmode:
          if (pattern208 (x3, 
E_V1SFmode, 
E_V1SImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V1SImode)
              && 
#line 2596 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1455; /* *vec_sel0v1sf */
          if (!all_ones_operand (operands[4], E_V1SImode)
              || !
#line 2620 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1493; /* *vec_sel1v1sf */

        case E_V2SFmode:
          if (pattern208 (x3, 
E_V2SFmode, 
E_V2SImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V2SImode)
              && 
#line 2596 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1456; /* *vec_sel0v2sf */
          if (!all_ones_operand (operands[4], E_V2SImode)
              || !
#line 2620 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1494; /* *vec_sel1v2sf */

        case E_V4SFmode:
          if (pattern208 (x3, 
E_V4SFmode, 
E_V4SImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V4SImode)
              && 
#line 2596 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1457; /* *vec_sel0v4sf */
          if (!all_ones_operand (operands[4], E_V4SImode)
              || !
#line 2620 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1495; /* *vec_sel1v4sf */

        case E_V1DFmode:
          if (pattern208 (x3, 
E_V1DFmode, 
E_V1DImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V1DImode)
              && 
#line 2596 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1458; /* *vec_sel0v1df */
          if (!all_ones_operand (operands[4], E_V1DImode)
              || !
#line 2620 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1496; /* *vec_sel1v1df */

        case E_V2DFmode:
          if (pattern208 (x3, 
E_V2DFmode, 
E_V2DImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V2DImode)
              && 
#line 2596 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1459; /* *vec_sel0v2df */
          if (!all_ones_operand (operands[4], E_V2DImode)
              || !
#line 2620 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1497; /* *vec_sel1v2df */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_42 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 2);
  if (GET_CODE (x3) != CONST_INT)
    return -1;
  operands[2] = x3;
  if (const_int_operand (operands[2], E_VOIDmode))
    {
      res = recog_41 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  if (XWINT (x3, 0) != 0L)
    return -1;
  x4 = XEXP (x2, 0);
  operands[0] = x4;
  if (!memory_operand (operands[0], E_QImode))
    return -1;
  x5 = XEXP (x1, 1);
  operands[2] = x5;
  switch (GET_MODE (x2))
    {
    case E_DImode:
      if (!register_operand (operands[2], E_DImode)
          || !(
#line 4861 "../../gcc/config/s390/s390.md"
(EXTRACT_ARGS_IN_RANGE (INTVAL (operands[1]), 0, 64)
   && INTVAL (operands[1]) > 0
   && INTVAL (operands[1]) <= GET_MODE_BITSIZE (SImode)
   && INTVAL (operands[1]) % BITS_PER_UNIT == 0) && 
#line 783 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
        return -1;
      return 2006; /* *insvdi_mem_reg */

    case E_SImode:
      if (!register_operand (operands[2], E_SImode)
          || !(
#line 4861 "../../gcc/config/s390/s390.md"
(EXTRACT_ARGS_IN_RANGE (INTVAL (operands[1]), 0, 64)
   && INTVAL (operands[1]) > 0
   && INTVAL (operands[1]) <= GET_MODE_BITSIZE (SImode)
   && INTVAL (operands[1]) % BITS_PER_UNIT == 0) && 
#line 783 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH)))
        return -1;
      return 2007; /* *insvsi_mem_reg */

    default:
      return -1;
    }
}

 int
recog_47 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V1QImode:
      if (pattern64 (x3, 
E_V1QImode) != 0
          || !
#line 1145 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 700; /* subv1qi3 */

    case E_V2QImode:
      if (pattern64 (x3, 
E_V2QImode) != 0
          || !
#line 1145 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 701; /* subv2qi3 */

    case E_V4QImode:
      if (pattern64 (x3, 
E_V4QImode) != 0
          || !
#line 1145 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 702; /* subv4qi3 */

    case E_V8QImode:
      if (pattern64 (x3, 
E_V8QImode) != 0
          || !
#line 1145 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 703; /* subv8qi3 */

    case E_V16QImode:
      if (pattern64 (x3, 
E_V16QImode) != 0
          || !
#line 1145 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 704; /* subv16qi3 */

    case E_V1HImode:
      if (pattern64 (x3, 
E_V1HImode) != 0
          || !
#line 1145 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 705; /* subv1hi3 */

    case E_V2HImode:
      if (pattern64 (x3, 
E_V2HImode) != 0
          || !
#line 1145 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 706; /* subv2hi3 */

    case E_V4HImode:
      if (pattern64 (x3, 
E_V4HImode) != 0
          || !
#line 1145 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 707; /* subv4hi3 */

    case E_V8HImode:
      if (pattern64 (x3, 
E_V8HImode) != 0
          || !
#line 1145 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 708; /* subv8hi3 */

    case E_V1SImode:
      if (pattern64 (x3, 
E_V1SImode) != 0
          || !
#line 1145 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 709; /* subv1si3 */

    case E_V2SImode:
      if (pattern64 (x3, 
E_V2SImode) != 0
          || !
#line 1145 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 710; /* subv2si3 */

    case E_V4SImode:
      if (pattern64 (x3, 
E_V4SImode) != 0
          || !
#line 1145 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 711; /* subv4si3 */

    case E_V1DImode:
      if (pattern64 (x3, 
E_V1DImode) != 0
          || !
#line 1145 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 712; /* subv1di3 */

    case E_V2DImode:
      if (pattern64 (x3, 
E_V2DImode) != 0
          || !
#line 1145 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 713; /* subv2di3 */

    case E_V1TImode:
      if (pattern64 (x3, 
E_V1TImode) != 0
          || !
#line 1145 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 714; /* subv1ti3 */

    case E_TImode:
      if (GET_MODE (x3) != E_TImode
          || !general_operand (operands[2], E_TImode))
        return -1;
      if (nonimmediate_operand (operands[0], E_TImode)
          && nonimmediate_operand (operands[1], E_TImode)
          && 
#line 1145 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 715; /* *subti3 */
      if (pnum_clobbers == NULL
          || !register_operand (operands[0], E_TImode)
          || !register_operand (operands[1], E_TImode)
          || !
#line 6619 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
        return -1;
      *pnum_clobbers = 1;
      return 2244; /* *subti3 */

    case E_V4SFmode:
      if (pattern0 (x3, 
E_V4SFmode) != 0
          || !(
#line 1877 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 87 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      return 1231; /* subv4sf3 */

    case E_V2DFmode:
      if (pattern0 (x3, 
E_V2DFmode) != 0
          || !
#line 1877 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1232; /* subv2df3 */

    case E_V1TFmode:
      if (pattern0 (x3, 
E_V1TFmode) != 0
          || !(
#line 1877 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 87 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      return 1233; /* subv1tf3 */

    case E_TFmode:
      if (!register_operand (operands[0], E_TFmode)
          || GET_MODE (x3) != E_TFmode
          || !register_operand (operands[1], E_TFmode))
        return -1;
      if (register_operand (operands[2], E_TFmode)
          && (
#line 1877 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 88 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return 1234; /* subtf3_vr */
      if (pnum_clobbers == NULL
          || !general_operand (operands[2], E_TFmode)
          || !(
#line 6935 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 751 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
        return -1;
      *pnum_clobbers = 1;
      return 2268; /* subtf3_fpr */

    case E_FPRX2mode:
      if (pnum_clobbers == NULL
          || pattern85 (x3, 
E_FPRX2mode) != 0
          || !(
#line 6935 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 751 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
        return -1;
      *pnum_clobbers = 1;
      return 2269; /* subfprx23 */

    case E_DFmode:
      if (pnum_clobbers == NULL
          || pattern85 (x3, 
E_DFmode) != 0
          || !
#line 6935 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
        return -1;
      *pnum_clobbers = 1;
      return 2270; /* subdf3 */

    case E_SFmode:
      if (pnum_clobbers == NULL
          || pattern85 (x3, 
E_SFmode) != 0
          || !
#line 6935 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
        return -1;
      *pnum_clobbers = 1;
      return 2271; /* subsf3 */

    case E_TDmode:
      if (pnum_clobbers == NULL
          || pattern85 (x3, 
E_TDmode) != 0
          || !(
#line 6935 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 752 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
        return -1;
      *pnum_clobbers = 1;
      return 2272; /* subtd3 */

    case E_DDmode:
      if (pnum_clobbers == NULL
          || pattern85 (x3, 
E_DDmode) != 0
          || !(
#line 6935 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 752 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
        return -1;
      *pnum_clobbers = 1;
      return 2273; /* subdd3 */

    default:
      return -1;
    }
}

 int
recog_59 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      x4 = XEXP (x2, 1);
      switch (GET_CODE (x4))
        {
        case PARALLEL:
          switch (XVECLEN (x4, 0))
            {
            case 1:
              x5 = XEXP (x1, 0);
              if (GET_CODE (x5) == MEM)
                {
                  res = recog_19 (x1, insn, pnum_clobbers);
                  if (res >= 0)
                    return res;
                }
              operands[0] = x5;
              operands[1] = x3;
              x6 = XVECEXP (x4, 0, 0);
              operands[2] = x6;
              if (!nonmemory_operand (operands[2], E_SImode))
                return -1;
              switch (pattern154 (x2))
                {
                case 0:
                  if (!nonmemory_operand (operands[1], E_V1QImode)
                      || !
#line 568 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 581; /* *vec_extractv1qi */

                case 1:
                  if (!nonmemory_operand (operands[1], E_V2QImode)
                      || !
#line 568 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 582; /* *vec_extractv2qi */

                case 2:
                  if (!nonmemory_operand (operands[1], E_V4QImode)
                      || !
#line 568 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 583; /* *vec_extractv4qi */

                case 3:
                  if (!nonmemory_operand (operands[1], E_V8QImode)
                      || !
#line 568 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 584; /* *vec_extractv8qi */

                case 4:
                  if (!nonmemory_operand (operands[1], E_V16QImode)
                      || !
#line 568 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 585; /* *vec_extractv16qi */

                case 5:
                  if (!nonmemory_operand (operands[1], E_V1HImode)
                      || !
#line 568 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 586; /* *vec_extractv1hi */

                case 6:
                  if (!nonmemory_operand (operands[1], E_V2HImode)
                      || !
#line 568 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 587; /* *vec_extractv2hi */

                case 7:
                  if (!nonmemory_operand (operands[1], E_V4HImode)
                      || !
#line 568 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 588; /* *vec_extractv4hi */

                case 8:
                  if (!nonmemory_operand (operands[1], E_V8HImode)
                      || !
#line 568 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 589; /* *vec_extractv8hi */

                case 9:
                  if (!nonmemory_operand (operands[1], E_V1SImode)
                      || !
#line 568 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 590; /* *vec_extractv1si */

                case 10:
                  if (!nonmemory_operand (operands[1], E_V2SImode)
                      || !
#line 568 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 591; /* *vec_extractv2si */

                case 11:
                  if (!nonmemory_operand (operands[1], E_V4SImode)
                      || !
#line 568 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 592; /* *vec_extractv4si */

                case 12:
                  if (!nonmemory_operand (operands[1], E_V1DImode)
                      || !
#line 568 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 593; /* *vec_extractv1di */

                case 13:
                  if (!nonmemory_operand (operands[1], E_V2DImode)
                      || !
#line 568 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 594; /* *vec_extractv2di */

                case 14:
                  if (!nonmemory_operand (operands[1], E_V1SFmode)
                      || !
#line 568 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 595; /* *vec_extractv1sf */

                case 15:
                  if (!nonmemory_operand (operands[1], E_V2SFmode)
                      || !
#line 568 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 596; /* *vec_extractv2sf */

                case 16:
                  if (!nonmemory_operand (operands[1], E_V4SFmode)
                      || !
#line 568 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 597; /* *vec_extractv4sf */

                case 17:
                  if (!nonmemory_operand (operands[1], E_V1DFmode)
                      || !
#line 568 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 598; /* *vec_extractv1df */

                case 18:
                  if (!nonmemory_operand (operands[1], E_V2DFmode)
                      || !
#line 568 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 599; /* *vec_extractv2df */

                default:
                  return -1;
                }

            case 8:
              if (pattern59 (x4, pnum_clobbers, 
4, 
5, 
6, 
7) != 0)
                return -1;
              x7 = XVECEXP (x4, 0, 4);
              if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
                return -1;
              x8 = XVECEXP (x4, 0, 5);
              if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
                return -1;
              x9 = XVECEXP (x4, 0, 6);
              if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
                return -1;
              x10 = XVECEXP (x4, 0, 7);
              if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              x5 = XEXP (x1, 0);
              operands[0] = x5;
              if (!nonimmediate_operand (operands[0], E_V8HImode)
                  || GET_MODE (x2) != E_V8HImode)
                return -1;
              operands[1] = x3;
              if (!nonimmediate_operand (operands[1], E_V8HImode)
                  || !
#line 1046 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              *pnum_clobbers = 2;
              return 679; /* eltswapv8hi */

            case 4:
              if (pattern59 (x4, pnum_clobbers, 
0, 
1, 
2, 
3) != 0)
                return -1;
              x5 = XEXP (x1, 0);
              operands[0] = x5;
              operands[1] = x3;
              switch (GET_MODE (operands[0]))
                {
                case E_V4SImode:
                  if (!nonimmediate_operand (operands[0], E_V4SImode)
                      || GET_MODE (x2) != E_V4SImode
                      || !nonimmediate_operand (operands[1], E_V4SImode)
                      || !
#line 1085 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  *pnum_clobbers = 1;
                  return 680; /* eltswapv4si */

                case E_V4SFmode:
                  if (!nonimmediate_operand (operands[0], E_V4SFmode)
                      || GET_MODE (x2) != E_V4SFmode
                      || !nonimmediate_operand (operands[1], E_V4SFmode)
                      || !
#line 1085 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  *pnum_clobbers = 1;
                  return 681; /* eltswapv4sf */

                default:
                  return -1;
                }

            case 2:
              x6 = XVECEXP (x4, 0, 0);
              if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
                return -1;
              x11 = XVECEXP (x4, 0, 1);
              if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              x5 = XEXP (x1, 0);
              operands[0] = x5;
              operands[1] = x3;
              switch (GET_MODE (operands[0]))
                {
                case E_V2DImode:
                  if (!nonimmediate_operand (operands[0], E_V2DImode)
                      || GET_MODE (x2) != E_V2DImode
                      || !nonimmediate_operand (operands[1], E_V2DImode)
                      || !
#line 1115 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 682; /* eltswapv2di */

                case E_V2DFmode:
                  if (!nonimmediate_operand (operands[0], E_V2DFmode)
                      || GET_MODE (x2) != E_V2DFmode
                      || !nonimmediate_operand (operands[1], E_V2DFmode)
                      || !
#line 1115 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 683; /* eltswapv2df */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case PLUS:
          if (GET_MODE (x4) != E_SImode)
            return -1;
          x12 = XEXP (x4, 1);
          if (GET_CODE (x12) != PARALLEL
              || XVECLEN (x12, 0) != 1)
            return -1;
          x5 = XEXP (x1, 0);
          operands[0] = x5;
          operands[1] = x3;
          x13 = XEXP (x4, 0);
          operands[2] = x13;
          if (!nonmemory_operand (operands[2], E_SImode))
            return -1;
          x14 = XVECEXP (x12, 0, 0);
          operands[3] = x14;
          if (!const_int_operand (operands[3], E_SImode))
            return -1;
          switch (pattern154 (x2))
            {
            case 0:
              if (!register_operand (operands[1], E_V1QImode)
                  || !
#line 585 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 600; /* *vec_extractv1qi_plus */

            case 1:
              if (!register_operand (operands[1], E_V2QImode)
                  || !
#line 585 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 601; /* *vec_extractv2qi_plus */

            case 2:
              if (!register_operand (operands[1], E_V4QImode)
                  || !
#line 585 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 602; /* *vec_extractv4qi_plus */

            case 3:
              if (!register_operand (operands[1], E_V8QImode)
                  || !
#line 585 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 603; /* *vec_extractv8qi_plus */

            case 4:
              if (!register_operand (operands[1], E_V16QImode)
                  || !
#line 585 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 604; /* *vec_extractv16qi_plus */

            case 5:
              if (!register_operand (operands[1], E_V1HImode)
                  || !
#line 585 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 605; /* *vec_extractv1hi_plus */

            case 6:
              if (!register_operand (operands[1], E_V2HImode)
                  || !
#line 585 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 606; /* *vec_extractv2hi_plus */

            case 7:
              if (!register_operand (operands[1], E_V4HImode)
                  || !
#line 585 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 607; /* *vec_extractv4hi_plus */

            case 8:
              if (!register_operand (operands[1], E_V8HImode)
                  || !
#line 585 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 608; /* *vec_extractv8hi_plus */

            case 9:
              if (!register_operand (operands[1], E_V1SImode)
                  || !
#line 585 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 609; /* *vec_extractv1si_plus */

            case 10:
              if (!register_operand (operands[1], E_V2SImode)
                  || !
#line 585 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 610; /* *vec_extractv2si_plus */

            case 11:
              if (!register_operand (operands[1], E_V4SImode)
                  || !
#line 585 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 611; /* *vec_extractv4si_plus */

            case 12:
              if (!register_operand (operands[1], E_V1DImode)
                  || !
#line 585 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 612; /* *vec_extractv1di_plus */

            case 13:
              if (!register_operand (operands[1], E_V2DImode)
                  || !
#line 585 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 613; /* *vec_extractv2di_plus */

            case 14:
              if (!register_operand (operands[1], E_V1SFmode)
                  || !
#line 585 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 614; /* *vec_extractv1sf_plus */

            case 15:
              if (!register_operand (operands[1], E_V2SFmode)
                  || !
#line 585 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 615; /* *vec_extractv2sf_plus */

            case 16:
              if (!register_operand (operands[1], E_V4SFmode)
                  || !
#line 585 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 616; /* *vec_extractv4sf_plus */

            case 17:
              if (!register_operand (operands[1], E_V1DFmode)
                  || !
#line 585 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 617; /* *vec_extractv1df_plus */

            case 18:
              if (!register_operand (operands[1], E_V2DFmode)
                  || !
#line 585 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 618; /* *vec_extractv2df_plus */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case BSWAP:
      x4 = XEXP (x2, 1);
      if (GET_CODE (x4) != PARALLEL
          || XVECLEN (x4, 0) != 1)
        return -1;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      x15 = XEXP (x3, 0);
      operands[1] = x15;
      x6 = XVECEXP (x4, 0, 0);
      operands[2] = x6;
      if (!const_int_operand (operands[2], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (pattern166 (x2, 
E_V8HImode, 
E_HImode) != 0
              || !
#line 2195 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2 && UINTVAL (operands[2]) < GET_MODE_NUNITS (V8HImode)))
            return -1;
          return 491; /* *vec_extract_bswap_vecv8hi */

        case E_SImode:
          if (pattern166 (x2, 
E_V4SImode, 
E_SImode) != 0
              || !
#line 2195 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2 && UINTVAL (operands[2]) < GET_MODE_NUNITS (V4SImode)))
            return -1;
          return 492; /* *vec_extract_bswap_vecv4si */

        case E_SFmode:
          if (pattern166 (x2, 
E_V4SFmode, 
E_SFmode) != 0
              || !(
#line 2195 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2 && UINTVAL (operands[2]) < GET_MODE_NUNITS (V4SFmode)) && 
#line 44 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 493; /* *vec_extract_bswap_vecv4sf */

        case E_DImode:
          if (pattern166 (x2, 
E_V2DImode, 
E_DImode) != 0
              || !
#line 2195 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2 && UINTVAL (operands[2]) < GET_MODE_NUNITS (V2DImode)))
            return -1;
          return 494; /* *vec_extract_bswap_vecv2di */

        case E_DFmode:
          if (pattern166 (x2, 
E_V2DFmode, 
E_DFmode) != 0
              || !
#line 2195 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2 && UINTVAL (operands[2]) < GET_MODE_NUNITS (V2DFmode)))
            return -1;
          return 495; /* *vec_extract_bswap_vecv2df */

        default:
          return -1;
        }

    case VEC_CONCAT:
      return recog_20 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_65 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  switch (GET_CODE (x2))
    {
    case REG:
    case SUBREG:
      operands[0] = x2;
      x3 = XEXP (x1, 1);
      switch (pattern11 (x3))
        {
        case 0:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1524 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V1QImode)) - 1)
  ))
            return 991; /* *lshrv1qi3 */
          if (register_operand (operands[2], E_V1QImode)
              && 
#line 1574 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1073; /* vlshrv1qi3 */
          break;

        case 1:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1524 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V2QImode)) - 1)
  ))
            return 995; /* *lshrv2qi3 */
          if (register_operand (operands[2], E_V2QImode)
              && 
#line 1574 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1074; /* vlshrv2qi3 */
          break;

        case 2:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1524 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V4QImode)) - 1)
  ))
            return 999; /* *lshrv4qi3 */
          if (register_operand (operands[2], E_V4QImode)
              && 
#line 1574 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1075; /* vlshrv4qi3 */
          break;

        case 3:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1524 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V8QImode)) - 1)
  ))
            return 1003; /* *lshrv8qi3 */
          if (register_operand (operands[2], E_V8QImode)
              && 
#line 1574 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1076; /* vlshrv8qi3 */
          break;

        case 4:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1524 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V16QImode)) - 1)
  ))
            return 1007; /* *lshrv16qi3 */
          if (register_operand (operands[2], E_V16QImode)
              && 
#line 1574 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1077; /* vlshrv16qi3 */
          break;

        case 5:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1524 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V1HImode)) - 1)
  ))
            return 1011; /* *lshrv1hi3 */
          if (register_operand (operands[2], E_V1HImode)
              && 
#line 1574 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1078; /* vlshrv1hi3 */
          break;

        case 6:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1524 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V2HImode)) - 1)
  ))
            return 1015; /* *lshrv2hi3 */
          if (register_operand (operands[2], E_V2HImode)
              && 
#line 1574 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1079; /* vlshrv2hi3 */
          break;

        case 7:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1524 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V4HImode)) - 1)
  ))
            return 1019; /* *lshrv4hi3 */
          if (register_operand (operands[2], E_V4HImode)
              && 
#line 1574 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1080; /* vlshrv4hi3 */
          break;

        case 8:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1524 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V8HImode)) - 1)
  ))
            return 1023; /* *lshrv8hi3 */
          if (register_operand (operands[2], E_V8HImode)
              && 
#line 1574 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1081; /* vlshrv8hi3 */
          break;

        case 9:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1524 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V1SImode)) - 1)
  ))
            return 1027; /* *lshrv1si3 */
          if (register_operand (operands[2], E_V1SImode)
              && 
#line 1574 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1082; /* vlshrv1si3 */
          break;

        case 10:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1524 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V2SImode)) - 1)
  ))
            return 1031; /* *lshrv2si3 */
          if (register_operand (operands[2], E_V2SImode)
              && 
#line 1574 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1083; /* vlshrv2si3 */
          break;

        case 11:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1524 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V4SImode)) - 1)
  ))
            return 1035; /* *lshrv4si3 */
          if (register_operand (operands[2], E_V4SImode)
              && 
#line 1574 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1084; /* vlshrv4si3 */
          break;

        case 12:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1524 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V1DImode)) - 1)
  ))
            return 1039; /* *lshrv1di3 */
          if (register_operand (operands[2], E_V1DImode)
              && 
#line 1574 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1085; /* vlshrv1di3 */
          break;

        case 13:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1524 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V2DImode)) - 1)
  ))
            return 1043; /* *lshrv2di3 */
          if (register_operand (operands[2], E_V2DImode)
              && 
#line 1574 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1086; /* vlshrv2di3 */
          break;

        case 14:
          if (
#line 9693 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
            return 2511; /* *lshrdi3_31 */
          if (
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return 2513; /* *lshrdi3 */
          break;

        case 15:
          return 2515; /* *lshrsi3 */

        default:
          break;
        }
      break;

    case ZERO_EXTRACT:
      res = recog_28 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    default:
      break;
    }
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 32]
      || GET_CODE (x2) != ZERO_EXTRACT
      || GET_MODE (x2) != E_DImode)
    return -1;
  x5 = XEXP (x2, 2);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XEXP (x2, 0);
  operands[0] = x6;
  if (!memory_operand (operands[0], E_QImode))
    return -1;
  x7 = XEXP (x2, 1);
  operands[1] = x7;
  if (!const_int_operand (operands[1], E_VOIDmode))
    return -1;
  x8 = XEXP (x3, 0);
  operands[2] = x8;
  if (!register_operand (operands[2], E_DImode)
      || !
#line 4882 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[1]), 0, 64)
   && INTVAL (operands[1]) > 0
   && INTVAL (operands[1]) <= GET_MODE_BITSIZE (SImode)
   && INTVAL (operands[1]) % BITS_PER_UNIT == 0))
    return -1;
  return 2008; /* *insvdi_mem_reghigh */
}

 int
recog_79 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern2 (x1))
    {
    case 0:
      if (!
#line 1453 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 953; /* ctzv1qi2 */

    case 1:
      if (!
#line 1453 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 954; /* ctzv2qi2 */

    case 2:
      if (!
#line 1453 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 955; /* ctzv4qi2 */

    case 3:
      if (!
#line 1453 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 956; /* ctzv8qi2 */

    case 4:
      if (!
#line 1453 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 957; /* ctzv16qi2 */

    case 5:
      if (!
#line 1453 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 958; /* ctzv1hi2 */

    case 6:
      if (!
#line 1453 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 959; /* ctzv2hi2 */

    case 7:
      if (!
#line 1453 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 960; /* ctzv4hi2 */

    case 8:
      if (!
#line 1453 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 961; /* ctzv8hi2 */

    case 9:
      if (!
#line 1453 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 962; /* ctzv1si2 */

    case 10:
      if (!
#line 1453 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 963; /* ctzv2si2 */

    case 11:
      if (!
#line 1453 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 964; /* ctzv4si2 */

    case 12:
      if (!
#line 1453 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 965; /* ctzv1di2 */

    case 13:
      if (!
#line 1453 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 966; /* ctzv2di2 */

    case 14:
      if (!
#line 1453 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 967; /* ctzv1sf2 */

    case 15:
      if (!
#line 1453 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 968; /* ctzv2sf2 */

    case 16:
      if (!
#line 1453 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 969; /* ctzv4sf2 */

    case 17:
      if (!
#line 1453 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 970; /* ctzv1df2 */

    case 18:
      if (!
#line 1453 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 971; /* ctzv2df2 */

    case 19:
      if (!
#line 1453 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 972; /* ctzv1tf2 */

    case 20:
      if (!(
#line 1453 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 30 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
        return -1;
      return 973; /* ctzv1ti2 */

    case 21:
      if (!(
#line 1453 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 30 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
        return -1;
      return 974; /* ctzti2 */

    case 22:
      if (!
#line 9640 "../../gcc/config/s390/s390.md"
(TARGET_Z17 && TARGET_64BIT))
        return -1;
      return 2507; /* ctzdi2 */

    default:
      return -1;
    }
}

 int
recog_87 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      switch (GET_CODE (x6))
        {
        case ZERO_EXTEND:
          if (GET_MODE (x6) != E_DImode)
            return -1;
          x7 = XEXP (x3, 1);
          if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || GET_MODE (x4) != E_DImode
              || !register_operand (operands[1], E_DImode))
            return -1;
          x8 = XEXP (x6, 0);
          operands[2] = x8;
          if (!general_operand (operands[2], E_SImode))
            return -1;
          x9 = XVECEXP (x1, 0, 1);
          switch (GET_CODE (x9))
            {
            case SET:
              x10 = XEXP (x9, 1);
              if (GET_CODE (x10) != MINUS
                  || GET_MODE (x10) != E_DImode)
                return -1;
              x11 = XEXP (x10, 1);
              if (GET_CODE (x11) != ZERO_EXTEND
                  || GET_MODE (x11) != E_DImode)
                return -1;
              x12 = XEXP (x9, 0);
              operands[0] = x12;
              if (!register_operand (operands[0], E_DImode))
                return -1;
              x13 = XEXP (x10, 0);
              if (!rtx_equal_p (x13, operands[1]))
                return -1;
              x14 = XEXP (x11, 0);
              if (!rtx_equal_p (x14, operands[2])
                  || !
#line 6673 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCLmode) && TARGET_ZARCH))
                return -1;
              return 2246; /* *subdi3_zero_cc */

            case CLOBBER:
              x12 = XEXP (x9, 0);
              operands[0] = x12;
              if (!scratch_operand (operands[0], E_DImode)
                  || !
#line 6686 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCLmode) && TARGET_ZARCH))
                return -1;
              return 2247; /* *subdi3_zero_cconly */

            default:
              return -1;
            }

        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case MEM:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          operands[2] = x6;
          x7 = XEXP (x3, 1);
          switch (GET_CODE (x7))
            {
            case REG:
            case SUBREG:
              if (!rtx_equal_p (x7, operands[1]))
                return -1;
              switch (pattern226 (x1))
                {
                case 0:
                  x15 = XEXP (x2, 0);
                  if (GET_MODE (x15) != E_CCL2mode
                      || GET_MODE (x3) != E_CCL2mode)
                    return -1;
                  switch (pattern245 (x1))
                    {
                    case 0:
                      if (!
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                        return -1;
                      return 2253; /* subdi3_borrow_cc */

                    case 1:
                      return 2254; /* subsi3_borrow_cc */

                    default:
                      return -1;
                    }

                case 1:
                  if (!(
#line 6800 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL2mode)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return -1;
                  return 2255; /* *subdi3_borrow_cconly */

                case 2:
                  if (!
#line 6800 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL2mode)))
                    return -1;
                  return 2256; /* *subsi3_borrow_cconly */

                default:
                  return -1;
                }

            case CONST_INT:
            case CONST_WIDE_INT:
            case CONST_DOUBLE:
            case CONST_VECTOR:
              if (x7 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
                {
                  switch (pattern226 (x1))
                    {
                    case 0:
                      switch (pattern245 (x1))
                        {
                        case 0:
                          if ((
#line 6818 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCLmode)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                            return 2257; /* *subdi3_cc */
                          break;

                        case 1:
                          if (
#line 6818 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCLmode)))
                            return 2258; /* *subsi3_cc */
                          break;

                        default:
                          break;
                        }
                      break;

                    case 1:
                      if ((
#line 6852 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCLmode)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                        return 2261; /* *subdi3_cconly */
                      break;

                    case 2:
                      if (
#line 6852 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCLmode)))
                        return 2262; /* *subsi3_cconly */
                      break;

                    default:
                      break;
                    }
                }
              operands[3] = x7;
              x9 = XVECEXP (x1, 0, 1);
              switch (GET_CODE (x9))
                {
                case SET:
                  x10 = XEXP (x9, 1);
                  if (GET_CODE (x10) != MINUS)
                    return -1;
                  x12 = XEXP (x9, 0);
                  operands[0] = x12;
                  x13 = XEXP (x10, 0);
                  if (!rtx_equal_p (x13, operands[1]))
                    return -1;
                  x11 = XEXP (x10, 1);
                  if (!rtx_equal_p (x11, operands[2]))
                    return -1;
                  switch (GET_MODE (x4))
                    {
                    case E_TFmode:
                      if (pattern276 (x10, 
E_TFmode) != 0
                          || !(
#line 6955 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 751 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                        return -1;
                      return 2274; /* *subtf3_cc */

                    case E_FPRX2mode:
                      if (pattern276 (x10, 
E_FPRX2mode) != 0
                          || !(
#line 6955 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 751 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                        return -1;
                      return 2275; /* *subfprx23_cc */

                    case E_DFmode:
                      if (pattern276 (x10, 
E_DFmode) != 0
                          || !
#line 6955 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
                        return -1;
                      return 2276; /* *subdf3_cc */

                    case E_SFmode:
                      if (pattern276 (x10, 
E_SFmode) != 0
                          || !
#line 6955 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
                        return -1;
                      return 2277; /* *subsf3_cc */

                    case E_TDmode:
                      if (pattern276 (x10, 
E_TDmode) != 0
                          || !(
#line 6955 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 752 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
                        return -1;
                      return 2278; /* *subtd3_cc */

                    case E_DDmode:
                      if (pattern276 (x10, 
E_DDmode) != 0
                          || !(
#line 6955 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 752 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
                        return -1;
                      return 2279; /* *subdd3_cc */

                    default:
                      return -1;
                    }

                case CLOBBER:
                  x12 = XEXP (x9, 0);
                  operands[0] = x12;
                  switch (GET_MODE (x4))
                    {
                    case E_TFmode:
                      if (pattern256 (
E_TFmode) != 0
                          || !(
#line 6971 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 751 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                        return -1;
                      return 2280; /* *subtf3_cconly */

                    case E_FPRX2mode:
                      if (pattern256 (
E_FPRX2mode) != 0
                          || !(
#line 6971 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 751 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                        return -1;
                      return 2281; /* *subfprx23_cconly */

                    case E_DFmode:
                      if (pattern256 (
E_DFmode) != 0
                          || !
#line 6971 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
                        return -1;
                      return 2282; /* *subdf3_cconly */

                    case E_SFmode:
                      if (pattern256 (
E_SFmode) != 0
                          || !
#line 6971 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
                        return -1;
                      return 2283; /* *subsf3_cconly */

                    case E_TDmode:
                      if (pattern256 (
E_TDmode) != 0
                          || !(
#line 6971 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 752 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
                        return -1;
                      return 2284; /* *subtd3_cconly */

                    case E_DDmode:
                      if (pattern256 (
E_DDmode) != 0
                          || !(
#line 6971 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 752 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
                        return -1;
                      return 2285; /* *subdd3_cconly */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SIGN_EXTEND:
      switch (pattern144 (x1, 
MINUS))
        {
        case 0:
          if (pattern286 (x1, 
E_DImode, 
E_TImode) != 0
              || !(
#line 6913 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCOmode)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 2266; /* *subvdi3_ccoverflow */

        case 1:
          if (pattern286 (x1, 
E_SImode, 
E_DImode) != 0
              || !
#line 6913 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCOmode)))
            return -1;
          return 2267; /* *subvsi3_ccoverflow */

        default:
          return -1;
        }

    case MINUS:
      x9 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x9) != SET)
        return -1;
      x10 = XEXP (x9, 1);
      if (GET_CODE (x10) != MINUS)
        return -1;
      x13 = XEXP (x10, 0);
      if (GET_CODE (x13) != MINUS)
        return -1;
      x16 = XEXP (x5, 0);
      operands[1] = x16;
      x17 = XEXP (x5, 1);
      operands[2] = x17;
      x6 = XEXP (x4, 1);
      operands[3] = x6;
      x12 = XEXP (x9, 0);
      operands[0] = x12;
      x18 = XEXP (x13, 0);
      if (!rtx_equal_p (x18, operands[1]))
        return -1;
      x19 = XEXP (x13, 1);
      if (!rtx_equal_p (x19, operands[2]))
        return -1;
      x11 = XEXP (x10, 1);
      if (!rtx_equal_p (x11, operands[3]))
        return -1;
      x7 = XEXP (x3, 1);
      switch (GET_CODE (x7))
        {
        case CONST_INT:
          if (XWINT (x7, 0) != 0L)
            return -1;
          switch (GET_MODE (x4))
            {
            case E_DImode:
              if (pattern287 (x1, 
E_DImode) != 0
                  || !(
#line 7145 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCLmode)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              return 2298; /* *subdi3_slb_cc */

            case E_SImode:
              if (pattern287 (x1, 
E_SImode) != 0
                  || !
#line 7145 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCLmode)))
                return -1;
              return 2299; /* *subsi3_slb_cc */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
        case MEM:
          if (!rtx_equal_p (x7, operands[1]))
            return -1;
          x15 = XEXP (x2, 0);
          if (GET_MODE (x15) != E_CCL2mode
              || GET_MODE (x3) != E_CCL2mode)
            return -1;
          switch (GET_MODE (x4))
            {
            case E_DImode:
              if (pattern287 (x1, 
E_DImode) != 0
                  || !
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                return -1;
              return 2302; /* subdi3_slb_borrow1_cc */

            case E_SImode:
              if (pattern287 (x1, 
E_SImode) != 0)
                return -1;
              return 2303; /* subsi3_slb_borrow1_cc */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_109 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case BSWAP:
      return recog_105 (x1, insn, pnum_clobbers);

    case UNSPEC:
      return recog_103 (x1, insn, pnum_clobbers);

    case COMPARE:
      return recog_102 (x1, insn, pnum_clobbers);

    case VEC_SELECT:
      switch (pattern36 (x1))
        {
        case 0:
          if (!
#line 1015 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 678; /* *eltswapv16qi */

        case 1:
          if (!
#line 1085 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 680; /* eltswapv4si */

        case 2:
          if (!
#line 1085 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 681; /* eltswapv4sf */

        default:
          return -1;
        }

    case FLOAT_TRUNCATE:
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      res = recog_89 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (pnum_clobbers == NULL)
        return -1;
      switch (pattern70 (x1))
        {
        case 0:
          if (!(
#line 5894 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 758 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 2148; /* *trunctftd2 */

        case 1:
          if (!(
#line 5894 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 758 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 2149; /* *truncfprx2td2 */

        case 2:
          if (!
#line 5894 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 2150; /* *truncdftd2 */

        case 3:
          if (!
#line 5894 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 2151; /* *truncsftd2 */

        case 4:
          if (!(
#line 5894 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 758 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 2152; /* *trunctfdd2 */

        case 5:
          if (!(
#line 5894 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 758 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 2153; /* *truncfprx2dd2 */

        case 6:
          if (!
#line 5894 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 2154; /* *truncdfdd2 */

        case 7:
          if (!
#line 5894 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 2155; /* *truncsfdd2 */

        case 8:
          if (!(
#line 5894 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 758 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 2156; /* *trunctfsd2 */

        case 9:
          if (!(
#line 5894 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 758 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 2157; /* *truncfprx2sd2 */

        case 10:
          if (!
#line 5894 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 2158; /* *truncdfsd2 */

        case 11:
          if (!
#line 5894 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 2159; /* *truncsfsd2 */

        case 12:
          if (!(
#line 5903 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 758 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 2160; /* *trunctdtf2 */

        case 13:
          if (!(
#line 5903 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 758 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 2164; /* *truncddtf2 */

        case 14:
          if (!(
#line 5903 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 758 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 2168; /* *truncsdtf2 */

        case 15:
          if (!(
#line 5903 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 758 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 2161; /* *trunctdfprx22 */

        case 16:
          if (!(
#line 5903 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 758 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 2165; /* *truncddfprx22 */

        case 17:
          if (!(
#line 5903 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 758 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 2169; /* *truncsdfprx22 */

        case 18:
          if (!
#line 5903 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 2162; /* *trunctddf2 */

        case 19:
          if (!
#line 5903 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 2166; /* *truncdddf2 */

        case 20:
          if (!
#line 5903 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 2170; /* *truncsddf2 */

        case 21:
          if (!
#line 5903 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 2163; /* *trunctdsf2 */

        case 22:
          if (!
#line 5903 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 2167; /* *truncddsf2 */

        case 23:
          if (!
#line 5903 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 2171; /* *truncsdsf2 */

        default:
          return -1;
        }

    case IF_THEN_ELSE:
      x4 = XEXP (x2, 0);
      if (GET_CODE (x4) != PC)
        return -1;
      x5 = XEXP (x3, 0);
      switch (GET_CODE (x5))
        {
        case NE:
        case EQ:
        case GE:
        case GT:
        case LE:
        case LT:
          res = recog_92 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        default:
          break;
        }
      if (!s390_unsigned_integer_comparison (x5, E_VOIDmode))
        return -1;
      operands[0] = x5;
      switch (pattern118 (x1))
        {
        case 0:
          if (!(
#line 1672 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && !TARGET_AVOID_CMP_AND_BRANCH) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 1809; /* *cmp_and_br_unsigned_di */

        case 1:
          if (!
#line 1672 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && !TARGET_AVOID_CMP_AND_BRANCH))
            return -1;
          return 1810; /* *cmp_and_br_unsigned_si */

        case 2:
          if (!(
#line 1730 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && !TARGET_AVOID_CMP_AND_BRANCH) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 1813; /* *icmp_and_br_unsigned_di */

        case 3:
          if (!
#line 1730 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && !TARGET_AVOID_CMP_AND_BRANCH))
            return -1;
          return 1814; /* *icmp_and_br_unsigned_si */

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case PLUS:
    case MINUS:
    case MULT:
    case AND:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case SIGN_EXTEND:
    case ZERO_EXTEND:
    case HIGH:
      return recog_106 (x1, insn, pnum_clobbers);

    case ZERO_EXTRACT:
      x6 = XEXP (x3, 2);
      if (GET_CODE (x6) != CONST_INT)
        return -1;
      operands[3] = x6;
      if (const_int_operand (operands[3], E_VOIDmode))
        {
          res = recog_101 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      if (XWINT (x6, 0) != 0L)
        return -1;
      switch (pattern72 (x1))
        {
        case 0:
          if (!(
#line 4415 "../../gcc/config/s390/s390.md"
(!TARGET_Z10) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 1952; /* *pre_z10_extzvdi */

        case 1:
          if (!
#line 4415 "../../gcc/config/s390/s390.md"
(!TARGET_Z10))
            return -1;
          return 1953; /* *pre_z10_extzvsi */

        default:
          return -1;
        }

    case LSHIFTRT:
      if (GET_MODE (x3) != E_DImode)
        return -1;
      x4 = XEXP (x2, 0);
      if (GET_CODE (x4) != ZERO_EXTRACT
          || GET_MODE (x4) != E_DImode
          || pattern90 (x1) != 0
          || !register_operand (operands[0], E_DImode))
        return -1;
      x7 = XEXP (x4, 1);
      operands[1] = x7;
      if (!const_int_operand (operands[1], E_VOIDmode))
        return -1;
      x8 = XEXP (x4, 2);
      operands[2] = x8;
      if (!const_int_operand (operands[2], E_VOIDmode))
        return -1;
      x5 = XEXP (x3, 0);
      operands[3] = x5;
      if (!register_operand (operands[3], E_DImode))
        return -1;
      x9 = XEXP (x3, 1);
      operands[4] = x9;
      if (!nonzero_shift_count_operand (operands[4], E_DImode)
          || !
#line 4334 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[1]), INTVAL (operands[2]), 64)
   && 64 - UINTVAL (operands[4]) >= UINTVAL (operands[1])))
        return -1;
      return 1931; /* *extzvdi_clobbercc_lshiftrt */

    case IOR:
      return recog_104 (x1, insn, pnum_clobbers);

    case NE:
      x9 = XEXP (x3, 1);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || pattern38 (x1) != 0)
        return -1;
      x5 = XEXP (x3, 0);
      switch (GET_CODE (x5))
        {
        case ZERO_EXTRACT:
          if (GET_MODE (x5) != E_DImode)
            return -1;
          x10 = XEXP (x5, 1);
          if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
              || !register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode)
            return -1;
          x11 = XEXP (x5, 0);
          operands[1] = x11;
          if (!register_operand (operands[1], E_DImode))
            return -1;
          x12 = XEXP (x5, 2);
          operands[2] = x12;
          if (!const_int_operand (operands[2], E_VOIDmode)
              || !
#line 4367 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (1, INTVAL (operands[2]), 64)))
            return -1;
          return 1937; /* *extract1bitdi_clobbercc */

        case REG:
        case SUBREG:
          operands[1] = x5;
          if (!register_operand (operands[1], E_CCZ1mode)
              || !register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode)
            return -1;
          return 2308; /* sne */

        default:
          return -1;
        }

    case SIGN_EXTRACT:
      x6 = XEXP (x3, 2);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      switch (pattern72 (x1))
        {
        case 0:
          if (!
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return -1;
          return 1954; /* *pre_z10_extvdi */

        case 1:
          return 1955; /* *pre_z10_extvsi */

        default:
          return -1;
        }

    case XOR:
      return recog_108 (x1, insn, pnum_clobbers);

    case UNSIGNED_FIX:
      x13 = XVECEXP (x1, 0, 1);
      if (pattern37 (x13, pnum_clobbers) != 0)
        return -1;
      switch (pattern150 (x1))
        {
        case 0:
          if (
#line 5521 "../../gcc/config/s390/s390.md"
(TARGET_VX && TARGET_HARD_FLOAT))
            {
              *pnum_clobbers = 1;
              return 2044; /* *fixuns_truncdfdi2_z13 */
            }
          if (!(
#line 5536 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
    && (!TARGET_VX || DImode != DImode || DFmode != DFmode)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 2050; /* *fixuns_truncdfdi2_z196 */

        case 1:
          if (!(
#line 5536 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
    && (!TARGET_VX || DImode != DImode || TFmode != DFmode)) && (((
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH) && 
#line 751 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))))
            return -1;
          *pnum_clobbers = 1;
          return 2046; /* *fixuns_trunctfdi2_z196 */

        case 2:
          if (!(
#line 5536 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
    && (!TARGET_VX || DImode != DImode || FPRX2mode != DFmode)) && (((
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH) && 
#line 751 "../../gcc/config/s390/s390.md"
(TARGET_VXE)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))))
            return -1;
          *pnum_clobbers = 1;
          return 2048; /* *fixuns_truncfprx2di2_z196 */

        case 3:
          if (!(
#line 5536 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
    && (!TARGET_VX || DImode != DImode || SFmode != DFmode)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 2052; /* *fixuns_truncsfdi2_z196 */

        case 4:
          if (!(
#line 5536 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
    && (!TARGET_VX || DImode != DImode || TDmode != DFmode)) && (((
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH) && 
#line 752 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))))
            return -1;
          *pnum_clobbers = 1;
          return 2054; /* *fixuns_trunctddi2_z196 */

        case 5:
          if (!(
#line 5536 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
    && (!TARGET_VX || DImode != DImode || DDmode != DFmode)) && (((
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH) && 
#line 752 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))))
            return -1;
          *pnum_clobbers = 1;
          return 2056; /* *fixuns_truncdddi2_z196 */

        case 6:
          if (!(
#line 5521 "../../gcc/config/s390/s390.md"
(TARGET_VX && TARGET_HARD_FLOAT) && 
#line 767 "../../gcc/config/s390/s390.md"
(TARGET_VXE2)))
            return -1;
          *pnum_clobbers = 1;
          return 2045; /* *fixuns_truncsfsi2_z13 */

        case 7:
          if (!
#line 5536 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
    && (!TARGET_VX || SImode != DImode || SFmode != DFmode)))
            return -1;
          *pnum_clobbers = 1;
          return 2053; /* *fixuns_truncsfsi2_z196 */

        case 8:
          if (!(
#line 5536 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
    && (!TARGET_VX || SImode != DImode || TFmode != DFmode)) && 
#line 751 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          *pnum_clobbers = 1;
          return 2047; /* *fixuns_trunctfsi2_z196 */

        case 9:
          if (!(
#line 5536 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
    && (!TARGET_VX || SImode != DImode || FPRX2mode != DFmode)) && 
#line 751 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          *pnum_clobbers = 1;
          return 2049; /* *fixuns_truncfprx2si2_z196 */

        case 10:
          if (!
#line 5536 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
    && (!TARGET_VX || SImode != DImode || DFmode != DFmode)))
            return -1;
          *pnum_clobbers = 1;
          return 2051; /* *fixuns_truncdfsi2_z196 */

        case 11:
          if (!(
#line 5536 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
    && (!TARGET_VX || SImode != DImode || TDmode != DFmode)) && 
#line 752 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          *pnum_clobbers = 1;
          return 2055; /* *fixuns_trunctdsi2_z196 */

        case 12:
          if (!(
#line 5536 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
    && (!TARGET_VX || SImode != DImode || DDmode != DFmode)) && 
#line 752 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          *pnum_clobbers = 1;
          return 2057; /* *fixuns_truncddsi2_z196 */

        default:
          return -1;
        }

    case FIX:
      x13 = XVECEXP (x1, 0, 1);
      if (pattern37 (x13, pnum_clobbers) != 0)
        return -1;
      switch (pattern151 (x1))
        {
        case 0:
          if (
#line 5559 "../../gcc/config/s390/s390.md"
(TARGET_VX && TARGET_HARD_FLOAT))
            {
              *pnum_clobbers = 1;
              return 2058; /* *fix_truncdfdi2_bfp_z13 */
            }
          if (!(
#line 5572 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
    && (!TARGET_VX || DImode != DImode || DFmode != DFmode)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 2064; /* *fix_truncdfdi2_bfp */

        case 1:
          if (!(
#line 5572 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
    && (!TARGET_VX || DImode != DImode || TFmode != DFmode)) && (((
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH) && 
#line 758 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))))
            return -1;
          *pnum_clobbers = 1;
          return 2060; /* *fix_trunctfdi2_bfp */

        case 2:
          if (!(
#line 5572 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
    && (!TARGET_VX || DImode != DImode || FPRX2mode != DFmode)) && (((
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH) && 
#line 758 "../../gcc/config/s390/s390.md"
(TARGET_VXE)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))))
            return -1;
          *pnum_clobbers = 1;
          return 2062; /* *fix_truncfprx2di2_bfp */

        case 3:
          if (!(
#line 5572 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
    && (!TARGET_VX || DImode != DImode || SFmode != DFmode)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 2066; /* *fix_truncsfdi2_bfp */

        case 4:
          if (!
#line 5606 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 1;
          return 2068; /* fix_trunctddi2_dfp */

        case 5:
          if (!
#line 5606 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 1;
          return 2069; /* fix_truncdddi2_dfp */

        case 6:
          if ((
#line 5559 "../../gcc/config/s390/s390.md"
(TARGET_VX && TARGET_HARD_FLOAT) && 
#line 767 "../../gcc/config/s390/s390.md"
(TARGET_VXE2)))
            {
              *pnum_clobbers = 1;
              return 2059; /* *fix_truncsfsi2_bfp_z13 */
            }
          if (!
#line 5572 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
    && (!TARGET_VX || SImode != DImode || SFmode != DFmode)))
            return -1;
          *pnum_clobbers = 1;
          return 2067; /* *fix_truncsfsi2_bfp */

        case 7:
          if (!(
#line 5572 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
    && (!TARGET_VX || SImode != DImode || TFmode != DFmode)) && 
#line 758 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          *pnum_clobbers = 1;
          return 2061; /* *fix_trunctfsi2_bfp */

        case 8:
          if (!(
#line 5572 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
    && (!TARGET_VX || SImode != DImode || FPRX2mode != DFmode)) && 
#line 758 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          *pnum_clobbers = 1;
          return 2063; /* *fix_truncfprx2si2_bfp */

        case 9:
          if (!
#line 5572 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
    && (!TARGET_VX || SImode != DImode || DFmode != DFmode)))
            return -1;
          *pnum_clobbers = 1;
          return 2065; /* *fix_truncdfsi2_bfp */

        default:
          return -1;
        }

    case FLOAT_EXTEND:
      if (pnum_clobbers == NULL)
        return -1;
      switch (pattern70 (x1))
        {
        case 0:
          if (!(
#line 5968 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 758 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 2172; /* *extendtftd2 */

        case 1:
          if (!(
#line 5968 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 758 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 2173; /* *extendfprx2td2 */

        case 2:
          if (!
#line 5968 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 2174; /* *extenddftd2 */

        case 3:
          if (!
#line 5968 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 2175; /* *extendsftd2 */

        case 4:
          if (!(
#line 5968 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 758 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 2176; /* *extendtfdd2 */

        case 5:
          if (!(
#line 5968 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 758 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 2177; /* *extendfprx2dd2 */

        case 6:
          if (!
#line 5968 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 2178; /* *extenddfdd2 */

        case 7:
          if (!
#line 5968 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 2179; /* *extendsfdd2 */

        case 8:
          if (!(
#line 5968 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 758 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 2180; /* *extendtfsd2 */

        case 9:
          if (!(
#line 5968 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 758 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 2181; /* *extendfprx2sd2 */

        case 10:
          if (!
#line 5968 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 2182; /* *extenddfsd2 */

        case 11:
          if (!
#line 5968 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 2183; /* *extendsfsd2 */

        case 12:
          if (!(
#line 5976 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 758 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 2184; /* *extendtdtf2 */

        case 13:
          if (!(
#line 5976 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 758 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 2188; /* *extendddtf2 */

        case 14:
          if (!(
#line 5976 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 758 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 2192; /* *extendsdtf2 */

        case 15:
          if (!(
#line 5976 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 758 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 2185; /* *extendtdfprx22 */

        case 16:
          if (!(
#line 5976 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 758 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 2189; /* *extendddfprx22 */

        case 17:
          if (!(
#line 5976 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 758 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          *pnum_clobbers = 2;
          return 2193; /* *extendsdfprx22 */

        case 18:
          if (!
#line 5976 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 2186; /* *extendtddf2 */

        case 19:
          if (!
#line 5976 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 2190; /* *extenddddf2 */

        case 20:
          if (!
#line 5976 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 2194; /* *extendsddf2 */

        case 21:
          if (!
#line 5976 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 2187; /* *extendtdsf2 */

        case 22:
          if (!
#line 5976 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 2191; /* *extendddsf2 */

        case 23:
          if (!
#line 5976 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 2195; /* *extendsdsf2 */

        default:
          return -1;
        }

    case NOT:
      if (pattern38 (x1) != 0)
        return -1;
      x5 = XEXP (x3, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          operands[1] = x5;
          switch (pattern193 (x3))
            {
            case 0:
              if (!(
#line 8661 "../../gcc/config/s390/s390.md"
(TARGET_Z15) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              return 2403; /* *notdi */

            case 1:
              if (!
#line 8661 "../../gcc/config/s390/s390.md"
(TARGET_Z15))
                return -1;
              return 2404; /* *notsi */

            default:
              return -1;
            }

        case XOR:
          x11 = XEXP (x5, 0);
          operands[1] = x11;
          x10 = XEXP (x5, 1);
          operands[2] = x10;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (pattern227 (x3, 
E_DImode) != 0
                  || !(
#line 9066 "../../gcc/config/s390/s390.md"
(TARGET_Z15) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              return 2420; /* *nxordi */

            case E_SImode:
              if (pattern227 (x3, 
E_SImode) != 0
                  || !
#line 9066 "../../gcc/config/s390/s390.md"
(TARGET_Z15))
                return -1;
              return 2421; /* *nxorsi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NEG:
      return recog_107 (x1, insn, pnum_clobbers);

    case ABS:
      if (pattern38 (x1) != 0)
        return -1;
      x5 = XEXP (x3, 0);
      switch (GET_CODE (x5))
        {
        case SIGN_EXTEND:
          if (pattern180 (x3) != 0
              || !
#line 9304 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return -1;
          return 2450; /* *absdi2_sign */

        case REG:
        case SUBREG:
          switch (pattern181 (x3))
            {
            case 0:
              if (!
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                return -1;
              return 2455; /* absdi2 */

            case 1:
              return 2456; /* abssi2 */

            case 2:
              if (!(
#line 9392 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 758 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              return 2471; /* *abstf2 */

            case 3:
              if (!(
#line 9392 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 758 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              return 2472; /* *absfprx22 */

            case 4:
              if (!
#line 9392 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 2473; /* *absdf2 */

            case 5:
              if (!
#line 9392 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 2474; /* *abssf2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ASHIFTRT:
      x13 = XVECEXP (x1, 0, 1);
      if (pattern39 (x13) != 0)
        return -1;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x5 = XEXP (x3, 0);
      operands[1] = x5;
      x9 = XEXP (x3, 1);
      operands[2] = x9;
      if (!shift_count_operand (operands[2], E_QImode))
        return -1;
      switch (pattern193 (x3))
        {
        case 0:
          if (
#line 9734 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
            return 2516; /* *ashrdi3_31 */
          if (!
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return -1;
          return 2519; /* *ashrdi3 */

        case 1:
          return 2522; /* *ashrsi3 */

        default:
          return -1;
        }

    case CALL:
      x5 = XEXP (x3, 0);
      if (GET_CODE (x5) != MEM
          || GET_MODE (x5) != E_QImode)
        return -1;
      x13 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x13) != CLOBBER)
        return -1;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x11 = XEXP (x5, 0);
      operands[1] = x11;
      x9 = XEXP (x3, 1);
      operands[2] = x9;
      x14 = XEXP (x13, 0);
      operands[3] = x14;
      if (!register_operand (operands[3], E_VOIDmode))
        return -1;
      if (bras_sym_operand (operands[1], E_VOIDmode))
        {
          if (const_int_operand (operands[2], E_SImode)
              && 
#line 10975 "../../gcc/config/s390/s390.md"
(!SIBLING_CALL_P (insn)
   && TARGET_SMALL_EXEC
   && GET_MODE (operands[3]) == Pmode))
            return 2580; /* *bras_r */
          if (const_int_operand (operands[2], E_VOIDmode)
              && 
#line 10988 "../../gcc/config/s390/s390.md"
(!SIBLING_CALL_P (insn)

   && GET_MODE (operands[3]) == Pmode))
            return 2581; /* *brasl_r */
        }
      if (!const_int_operand (operands[2], E_VOIDmode))
        return -1;
      if (address_operand (operands[1], E_VOIDmode)
          && 
#line 11002 "../../gcc/config/s390/s390.md"
(!TARGET_INDIRECT_BRANCH_NOBP_CALL
   && !SIBLING_CALL_P (insn)
   && GET_MODE (operands[3]) == Pmode))
        return 2582; /* *basr_r */
      if (!register_operand (operands[1], E_VOIDmode))
        return -1;
      if (
#line 11026 "../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_CALL
   && TARGET_CPU_Z10
   && !SIBLING_CALL_P (insn)
   && GET_MODE (operands[3]) == Pmode))
        return 2583; /* *basr_r_via_thunk_z10 */
      if (pnum_clobbers == NULL)
        return -1;
      if ((
#line 11049 "../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_CALL
   && !TARGET_CPU_Z10
   && !SIBLING_CALL_P (insn)
   && GET_MODE (operands[3]) == Pmode) && 
#line 778 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
        {
          *pnum_clobbers = 1;
          return 2584; /* *basr_r_via_thunk */
        }
      if (!(
#line 11049 "../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_CALL
   && !TARGET_CPU_Z10
   && !SIBLING_CALL_P (insn)
   && GET_MODE (operands[3]) == Pmode) && 
#line 778 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
        return -1;
      *pnum_clobbers = 1;
      return 2585; /* *basr_r_via_thunk */

    case POPCOUNT:
      if (pattern40 (x1) != 0
          || !
#line 12110 "../../gcc/config/s390/s390.md"
(TARGET_Z15))
        return -1;
      return 2642; /* *popcountdi_z15 */

    case UNSPEC_VOLATILE:
      if (XVECLEN (x3, 0) != 1
          || XINT (x3, 1) != 16
          || GET_MODE (x3) != E_CCRAWmode)
        return -1;
      x4 = XEXP (x2, 0);
      if (GET_CODE (x4) != REG
          || REGNO (x4) != 33
          || GET_MODE (x4) != E_CCRAWmode)
        return -1;
      x13 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x13) != SET)
        return -1;
      x15 = XEXP (x13, 1);
      if (pattern152 (x15, 
E_BLKmode, 
17, 
UNSPEC_VOLATILE, 
1) != 0)
        return -1;
      x16 = XVECEXP (x3, 0, 0);
      operands[0] = x16;
      if (!const_int_operand (operands[0], E_VOIDmode))
        return -1;
      x14 = XEXP (x13, 0);
      operands[1] = x14;
      if (!memory_operand (operands[1], E_BLKmode))
        return -1;
      x17 = XVECEXP (x15, 0, 0);
      if (!rtx_equal_p (x17, operands[0]))
        return -1;
      if (pnum_clobbers != NULL)
        {
          if (
#line 12384 "../../gcc/config/s390/s390.md"
(TARGET_VX && INTVAL (operands[0]) >= 0 && INTVAL (operands[0]) <= 0xffff))
            {
              *pnum_clobbers = 32;
              return 2654; /* tbegin_1_z13 */
            }
          if (
#line 12412 "../../gcc/config/s390/s390.md"
(TARGET_HTM && INTVAL (operands[0]) >= 0 && INTVAL (operands[0]) <= 0xffff))
            {
              *pnum_clobbers = 16;
              return 2655; /* tbegin_1 */
            }
        }
      if (!
#line 12423 "../../gcc/config/s390/s390.md"
(TARGET_HTM && INTVAL (operands[0]) >= 0 && INTVAL (operands[0]) <= 0xffff))
        return -1;
      return 2656; /* tbegin_nofloat_1 */

    default:
      return -1;
    }
}
