/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern2 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V1QImode:
      if (!register_operand (operands[0], E_V1QImode)
          || GET_MODE (x3) != E_V1QImode
          || !register_operand (operands[1], E_V1QImode))
        return -1;
      return 0;

    case E_V2QImode:
      if (!register_operand (operands[0], E_V2QImode)
          || GET_MODE (x3) != E_V2QImode
          || !register_operand (operands[1], E_V2QImode))
        return -1;
      return 1;

    case E_V4QImode:
      if (!register_operand (operands[0], E_V4QImode)
          || GET_MODE (x3) != E_V4QImode
          || !register_operand (operands[1], E_V4QImode))
        return -1;
      return 2;

    case E_V8QImode:
      if (!register_operand (operands[0], E_V8QImode)
          || GET_MODE (x3) != E_V8QImode
          || !register_operand (operands[1], E_V8QImode))
        return -1;
      return 3;

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !register_operand (operands[1], E_V16QImode))
        return -1;
      return 4;

    case E_V1HImode:
      if (!register_operand (operands[0], E_V1HImode)
          || GET_MODE (x3) != E_V1HImode
          || !register_operand (operands[1], E_V1HImode))
        return -1;
      return 5;

    case E_V2HImode:
      if (!register_operand (operands[0], E_V2HImode)
          || GET_MODE (x3) != E_V2HImode
          || !register_operand (operands[1], E_V2HImode))
        return -1;
      return 6;

    case E_V4HImode:
      if (!register_operand (operands[0], E_V4HImode)
          || GET_MODE (x3) != E_V4HImode
          || !register_operand (operands[1], E_V4HImode))
        return -1;
      return 7;

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode
          || !register_operand (operands[1], E_V8HImode))
        return -1;
      return 8;

    case E_V1SImode:
      if (!register_operand (operands[0], E_V1SImode)
          || GET_MODE (x3) != E_V1SImode
          || !register_operand (operands[1], E_V1SImode))
        return -1;
      return 9;

    case E_V2SImode:
      if (!register_operand (operands[0], E_V2SImode)
          || GET_MODE (x3) != E_V2SImode
          || !register_operand (operands[1], E_V2SImode))
        return -1;
      return 10;

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !register_operand (operands[1], E_V4SImode))
        return -1;
      return 11;

    case E_V1DImode:
      if (!register_operand (operands[0], E_V1DImode)
          || GET_MODE (x3) != E_V1DImode
          || !register_operand (operands[1], E_V1DImode))
        return -1;
      return 12;

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode
          || !register_operand (operands[1], E_V2DImode))
        return -1;
      return 13;

    case E_V1SFmode:
      if (!register_operand (operands[0], E_V1SFmode)
          || GET_MODE (x3) != E_V1SFmode
          || !register_operand (operands[1], E_V1SFmode))
        return -1;
      return 14;

    case E_V2SFmode:
      if (!register_operand (operands[0], E_V2SFmode)
          || GET_MODE (x3) != E_V2SFmode
          || !register_operand (operands[1], E_V2SFmode))
        return -1;
      return 15;

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !register_operand (operands[1], E_V4SFmode))
        return -1;
      return 16;

    case E_V1DFmode:
      if (!register_operand (operands[0], E_V1DFmode)
          || GET_MODE (x3) != E_V1DFmode
          || !register_operand (operands[1], E_V1DFmode))
        return -1;
      return 17;

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x3) != E_V2DFmode
          || !register_operand (operands[1], E_V2DFmode))
        return -1;
      return 18;

    case E_V1TFmode:
      if (!register_operand (operands[0], E_V1TFmode)
          || GET_MODE (x3) != E_V1TFmode
          || !register_operand (operands[1], E_V1TFmode))
        return -1;
      return 19;

    case E_V1TImode:
      if (!register_operand (operands[0], E_V1TImode)
          || GET_MODE (x3) != E_V1TImode
          || !register_operand (operands[1], E_V1TImode))
        return -1;
      return 20;

    case E_TImode:
      if (!register_operand (operands[0], E_TImode)
          || GET_MODE (x3) != E_TImode
          || !register_operand (operands[1], E_TImode))
        return -1;
      return 21;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode
          || !register_operand (operands[1], E_DImode))
        return -1;
      return 22;

    default:
      return -1;
    }
}

int
pattern50 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_TImode
      || !register_operand (operands[0], E_TImode))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  if (!register_operand (operands[1], i1))
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  operands[2] = x3;
  if (!register_operand (operands[2], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  operands[3] = x4;
  if (!register_operand (operands[3], E_TImode))
    return -1;
  return 0;
}

int
pattern56 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x2) != CONST_INT)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  operands[1] = x3;
  x4 = XVECEXP (x1, 0, 1);
  operands[2] = x4;
  switch (XWINT (x2, 0))
    {
    case 0L:
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          return pattern19 (x1, 
E_V16QImode); /* [-1, 0] */

        case E_V8HImode:
          if (pattern19 (x1, 
E_V8HImode) != 0)
            return -1;
          return 1;

        case E_V4SImode:
          if (pattern19 (x1, 
E_V4SImode) != 0)
            return -1;
          return 2;

        default:
          return -1;
        }

    case 2L:
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          if (pattern19 (x1, 
E_V16QImode) != 0)
            return -1;
          return 3;

        case E_V8HImode:
          if (pattern19 (x1, 
E_V8HImode) != 0)
            return -1;
          return 4;

        case E_V4SImode:
          if (pattern19 (x1, 
E_V4SImode) != 0)
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern70 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 18)
    return -1;
  x5 = XEXP (x2, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 16)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x6) != USE)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 0
      || GET_MODE (x7) != E_SImode)
    return -1;
  return pattern69 (x2); /* [-1, 23] */
}

int
pattern77 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1)
      || GET_MODE (x1) != i1
      || !scratch_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern83 (rtx x1, int *pnum_clobbers, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern84 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !memory_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern91 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !nonzero_shift_count_operand (operands[3], i1)
      || !contiguous_bitmask_nowrap_operand (operands[2], i1)
      || !nonimmediate_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern100 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[3], i2)
      || !const0_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern106 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[2], i1)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern111 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  operands[2] = x3;
  switch (GET_MODE (operands[1]))
    {
    case E_TImode:
      if (!register_operand (operands[1], E_TImode)
          || !register_operand (operands[2], E_TImode))
        return -1;
      return 0;

    case E_TFmode:
      if (!register_operand (operands[1], E_TFmode)
          || !register_operand (operands[2], E_TFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern120 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (!rtx_equal_p (x4, operands[0]))
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != USE
      || !memory_operand (operands[0], E_BLKmode)
      || GET_MODE (x3) != E_BLKmode)
    return -1;
  x6 = XEXP (x3, 1);
  operands[1] = x6;
  if (!memory_operand (operands[1], E_BLKmode))
    return -1;
  x7 = XEXP (x5, 0);
  operands[2] = x7;
  if (!const_int_operand (operands[2], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern127 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[2], i1)
      || GET_CODE (x1) != SET)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != COMPARE)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 33)
    return -1;
  x4 = XEXP (x2, 1);
  operands[1] = x4;
  if (!const0_operand (operands[1], i1))
    return -1;
  x5 = XEXP (x2, 0);
  if (!rtx_equal_p (x5, operands[0]))
    return -1;
  return 0;
}

int
pattern135 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_TFmode:
      if (!register_operand (operands[1], E_TFmode)
          || !const0_operand (operands[2], E_TFmode))
        return -1;
      return 0;

    case E_FPRX2mode:
      if (!register_operand (operands[1], E_FPRX2mode)
          || !const0_operand (operands[2], E_FPRX2mode))
        return -1;
      return 1;

    case E_DFmode:
      if (!register_operand (operands[1], E_DFmode)
          || !const0_operand (operands[2], E_DFmode))
        return -1;
      return 2;

    case E_SFmode:
      if (!register_operand (operands[1], E_SFmode)
          || !const0_operand (operands[2], E_SFmode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern145 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1)
      || !register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern149 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_DImode))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x4) != E_DImode
      || !immediate_operand (operands[2], E_DImode))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_DFmode:
      if (!register_operand (operands[1], E_DFmode))
        return -1;
      return 0;

    case E_TFmode:
      if (!register_operand (operands[1], E_TFmode))
        return -1;
      return 1;

    case E_FPRX2mode:
      if (!register_operand (operands[1], E_FPRX2mode))
        return -1;
      return 2;

    case E_SFmode:
      if (!register_operand (operands[1], E_SFmode))
        return -1;
      return 3;

    case E_TDmode:
      if (!register_operand (operands[1], E_TDmode))
        return -1;
      return 4;

    case E_DDmode:
      if (!register_operand (operands[1], E_DDmode))
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern159 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[0], i1))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 1);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) != i1)
    return -1;
  return 0;
}

int
pattern168 (rtx x1, int *pnum_clobbers, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || !register_operand (operands[1], E_V4SFmode))
        return -1;
      return 0;

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || !register_operand (operands[1], E_V2DFmode))
        return -1;
      return 1;

    case E_V1TFmode:
      if (!register_operand (operands[0], E_V1TFmode)
          || !register_operand (operands[1], E_V1TFmode))
        return -1;
      return 2;

    case E_TFmode:
      if (!register_operand (operands[0], E_TFmode)
          || !register_operand (operands[1], E_TFmode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern179 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x2))
    {
    case SET:
      x3 = XEXP (x2, 1);
      if (GET_CODE (x3) != i1)
        return -1;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x5 = XEXP (x3, 0);
      if (!rtx_equal_p (x5, operands[1]))
        return -1;
      x6 = XVECEXP (x1, 0, 0);
      x7 = XEXP (x6, 1);
      x8 = XEXP (x7, 0);
      switch (GET_MODE (x8))
        {
        case E_TFmode:
          return pattern178 (x3, 
E_TFmode); /* [-1, 0] */

        case E_FPRX2mode:
          if (pattern178 (x3, 
E_FPRX2mode) != 0)
            return -1;
          return 1;

        case E_DFmode:
          if (pattern178 (x3, 
E_DFmode) != 0)
            return -1;
          return 2;

        case E_SFmode:
          if (pattern178 (x3, 
E_SFmode) != 0)
            return -1;
          return 3;

        default:
          return -1;
        }

    case CLOBBER:
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x6 = XVECEXP (x1, 0, 0);
      x7 = XEXP (x6, 1);
      x8 = XEXP (x7, 0);
      switch (GET_MODE (x8))
        {
        case E_TFmode:
          if (!register_operand (operands[1], E_TFmode)
              || !const0_operand (operands[2], E_TFmode)
              || !scratch_operand (operands[0], E_TFmode))
            return -1;
          return 4;

        case E_FPRX2mode:
          if (!register_operand (operands[1], E_FPRX2mode)
              || !const0_operand (operands[2], E_FPRX2mode)
              || !scratch_operand (operands[0], E_FPRX2mode))
            return -1;
          return 5;

        case E_DFmode:
          if (!register_operand (operands[1], E_DFmode)
              || !const0_operand (operands[2], E_DFmode)
              || !scratch_operand (operands[0], E_DFmode))
            return -1;
          return 6;

        case E_SFmode:
          if (!register_operand (operands[1], E_SFmode)
              || !const0_operand (operands[2], E_SFmode)
              || !scratch_operand (operands[0], E_SFmode))
            return -1;
          return 7;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern210 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern216 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      return pattern215 (x1, 
E_DImode); /* [-1, 0] */

    case E_SImode:
      if (pattern215 (x1, 
E_SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern228 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern236 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 1);
  x7 = XEXP (x6, 0);
  if (!rtx_equal_p (x7, operands[0]))
    return -1;
  x8 = XEXP (x6, 1);
  if (!rtx_equal_p (x8, operands[1]))
    return -1;
  return 0;
}

int
pattern243 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !const_int_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern251 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !general_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern258 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  x6 = XEXP (x2, 1);
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XVECEXP (x1, 0, 3);
  x10 = XEXP (x9, 0);
  if (!rtx_equal_p (x10, operands[2]))
    return -1;
  x11 = XVECEXP (x1, 0, 4);
  x12 = XEXP (x11, 0);
  if (!rtx_equal_p (x12, operands[3]))
    return -1;
  switch (SUBREG_BYTE (x7))
    {
    case 0:
      if (maybe_ne (SUBREG_BYTE (x4), 0))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_TImode:
          return pattern257 (x2, 
E_TImode, 
E_DImode); /* [-1, 0] */

        case E_DImode:
          if (pattern257 (x2, 
E_DImode, 
E_SImode) != 0)
            return -1;
          return 1;

        default:
          return -1;
        }

    case 4:
      if (GET_MODE (x7) != E_SImode
          || maybe_ne (SUBREG_BYTE (x4), 4)
          || GET_MODE (x4) != E_SImode
          || !register_operand (operands[0], E_TImode)
          || !register_operand (operands[1], E_TImode)
          || !register_operand (operands[2], E_TImode)
          || !register_operand (operands[3], E_TImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern283 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !nonimmediate_operand (operands[1], i1))
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_MODE (x6) != i2
      || !general_operand (operands[2], i1)
      || pattern282 (x1, 
i1, 
i2) != 0)
    return -1;
  return 0;
}

int
pattern293 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_BLKmode)
    return -1;
  x4 = XEXP (x3, 1);
  operands[1] = x4;
  if (!memory_operand (operands[1], E_BLKmode))
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 0);
  operands[2] = x6;
  x7 = XEXP (x3, 0);
  if (!rtx_equal_p (x7, operands[0]))
    return -1;
  x8 = PATTERN (peep2_next_insn (1));
  x9 = XVECEXP (x8, 0, 0);
  x10 = XEXP (x9, 1);
  if (GET_CODE (x10) != i1
      || GET_MODE (x10) != E_BLKmode)
    return -1;
  x11 = XEXP (x9, 0);
  operands[3] = x11;
  x12 = XEXP (x10, 1);
  operands[4] = x12;
  if (!memory_operand (operands[4], E_BLKmode))
    return -1;
  x13 = XVECEXP (x8, 0, 1);
  x14 = XEXP (x13, 0);
  operands[5] = x14;
  x15 = XEXP (x10, 0);
  if (!rtx_equal_p (x15, operands[3]))
    return -1;
  return 0;
}

 int
recog_7 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pattern25 (x1, 
E_CCZmode) != 0
      || !const_int_operand (operands[1], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_TFmode:
      if (!register_operand (operands[0], E_TFmode)
          || !(
#line 3805 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 748 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
        return -1;
      return 1899; /* *TDC_insn_tf */

    case E_FPRX2mode:
      if (!register_operand (operands[0], E_FPRX2mode)
          || !(
#line 3805 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 748 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
        return -1;
      return 1900; /* *TDC_insn_fprx2 */

    case E_DFmode:
      if (!register_operand (operands[0], E_DFmode)
          || !
#line 3805 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
        return -1;
      return 1901; /* *TDC_insn_df */

    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || !
#line 3805 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
        return -1;
      return 1902; /* *TDC_insn_sf */

    case E_TDmode:
      if (!register_operand (operands[0], E_TDmode)
          || !(
#line 3805 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 749 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
        return -1;
      return 1903; /* *TDC_insn_td */

    case E_DDmode:
      if (!register_operand (operands[0], E_DDmode)
          || !(
#line 3805 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 749 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
        return -1;
      return 1904; /* *TDC_insn_dd */

    case E_SDmode:
      if (!register_operand (operands[0], E_SDmode)
          || !(
#line 3805 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 750 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
        return -1;
      return 1905; /* *TDC_insn_sd */

    default:
      return -1;
    }
}

 int
recog_12 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || pattern35 (x1) != 0)
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  x4 = XVECEXP (x2, 0, 1);
  operands[2] = x4;
  if (!const_int_operand (operands[2], E_HImode))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V4SFmode:
      if (!register_operand (operands[1], E_V4SFmode)
          || !(
#line 1927 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && CONST_OK_FOR_CONSTRAINT_P (INTVAL (operands[2]), 'J', "J")) && 
#line 87 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      *pnum_clobbers = 1;
      return 405; /* *vftciv4sf_cconly */

    case E_V2DFmode:
      if (!register_operand (operands[1], E_V2DFmode)
          || !
#line 1927 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && CONST_OK_FOR_CONSTRAINT_P (INTVAL (operands[2]), 'J', "J")))
        return -1;
      *pnum_clobbers = 1;
      return 406; /* *vftciv2df_cconly */

    case E_V1TFmode:
      if (!register_operand (operands[1], E_V1TFmode)
          || !(
#line 1927 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && CONST_OK_FOR_CONSTRAINT_P (INTVAL (operands[2]), 'J', "J")) && 
#line 87 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      *pnum_clobbers = 1;
      return 407; /* *vftciv1tf_cconly */

    case E_TFmode:
      if (!register_operand (operands[1], E_TFmode)
          || !(
#line 1927 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && CONST_OK_FOR_CONSTRAINT_P (INTVAL (operands[2]), 'J', "J")) && 
#line 88 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      *pnum_clobbers = 1;
      return 408; /* *vftcitf_cconly */

    default:
      return -1;
    }
}

 int
recog_18 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  switch (XINT (x3, 1))
    {
    case 73:
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x3, 0, 1);
      operands[2] = x5;
      x6 = XVECEXP (x3, 0, 2);
      operands[3] = x6;
      if (!register_operand (operands[3], E_V16QImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HImode:
          if (pattern19 (x3, 
E_V8HImode) != 0
              || !
#line 402 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 33; /* vec_zpermv8hi */

        case E_V4SImode:
          if (pattern19 (x3, 
E_V4SImode) != 0
              || !
#line 402 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 34; /* vec_zpermv4si */

        case E_V4SFmode:
          if (pattern19 (x3, 
E_V4SFmode) != 0
              || !(
#line 402 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 44 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 35; /* vec_zpermv4sf */

        case E_V2DImode:
          if (pattern19 (x3, 
E_V2DImode) != 0
              || !
#line 402 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 36; /* vec_zpermv2di */

        case E_V2DFmode:
          if (pattern19 (x3, 
E_V2DFmode) != 0
              || !
#line 402 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 37; /* vec_zpermv2df */

        case E_V16QImode:
          if (pattern19 (x3, 
E_V16QImode) != 0
              || !
#line 771 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 647; /* vec_permv16qi */

        default:
          return -1;
        }

    case 83:
      if (pattern50 (x3, 
E_TImode) != 0
          || !
#line 677 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 116; /* vacq */

    case 84:
      if (pattern50 (x3, 
E_TImode) != 0
          || !
#line 690 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 117; /* vacccq */

    case 90:
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x3, 0, 1);
      operands[2] = x5;
      x6 = XVECEXP (x3, 0, 2);
      operands[3] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HImode:
          if (pattern53 (x3, 
E_V8HImode, 
E_V16QImode) != 0
              || !
#line 870 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 144; /* vec_gfmsum_accumv16qi */

        case E_V4SImode:
          if (pattern53 (x3, 
E_V4SImode, 
E_V8HImode) != 0
              || !
#line 870 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 145; /* vec_gfmsum_accumv8hi */

        case E_V2DImode:
          if (pattern53 (x3, 
E_V2DImode, 
E_V4SImode) != 0
              || !
#line 870 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 146; /* vec_gfmsum_accumv4si */

        default:
          return -1;
        }

    case 91:
      if (pattern50 (x3, 
E_V2DImode) != 0
          || !
#line 880 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 147; /* vec_gfmsum_accum_128 */

    case 54:
      switch (pattern52 (x3))
        {
        case 0:
          if (!
#line 902 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 148; /* vec_vmalv16qi */

        case 1:
          if (!
#line 902 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 149; /* vec_vmalv8hi */

        case 2:
          if (!
#line 902 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 150; /* vec_vmalv4si */

        case 3:
          if (!(
#line 902 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 52 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 151; /* vec_vmalv2di */

        case 4:
          if (!(
#line 902 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 52 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 152; /* vec_vmalv1ti */

        case 5:
          if (!(
#line 902 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 52 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 153; /* vec_vmalti */

        default:
          return -1;
        }

    case 55:
      switch (pattern52 (x3))
        {
        case 0:
          if (!
#line 915 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 154; /* vec_vmahv16qi */

        case 1:
          if (!
#line 915 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 155; /* vec_vmahv8hi */

        case 2:
          if (!
#line 915 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 156; /* vec_vmahv4si */

        case 3:
          if (!(
#line 915 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 52 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 157; /* vec_vmahv2di */

        case 4:
          if (!(
#line 915 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 52 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 158; /* vec_vmahv1ti */

        case 5:
          if (!(
#line 915 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 52 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 159; /* vec_vmahti */

        default:
          return -1;
        }

    case 56:
      switch (pattern52 (x3))
        {
        case 0:
          if (!
#line 926 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 160; /* vec_vmalhv16qi */

        case 1:
          if (!
#line 926 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 161; /* vec_vmalhv8hi */

        case 2:
          if (!
#line 926 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 162; /* vec_vmalhv4si */

        case 3:
          if (!(
#line 926 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 52 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 163; /* vec_vmalhv2di */

        case 4:
          if (!(
#line 926 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 52 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 164; /* vec_vmalhv1ti */

        case 5:
          if (!(
#line 926 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 52 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 165; /* vec_vmalhti */

        default:
          return -1;
        }

    case 57:
      switch (pattern54 (x3))
        {
        case 0:
          if (!
#line 939 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 166; /* vec_vmaev16qi */

        case 1:
          if (!
#line 939 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 167; /* vec_vmaev8hi */

        case 2:
          if (!
#line 939 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 168; /* vec_vmaev4si */

        case 3:
          if (!(
#line 939 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 54 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 169; /* vec_vmaev2di */

        default:
          return -1;
        }

    case 58:
      switch (pattern54 (x3))
        {
        case 0:
          if (!
#line 950 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 170; /* vec_vmalev16qi */

        case 1:
          if (!
#line 950 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 171; /* vec_vmalev8hi */

        case 2:
          if (!
#line 950 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 172; /* vec_vmalev4si */

        case 3:
          if (!(
#line 950 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 54 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 173; /* vec_vmalev2di */

        default:
          return -1;
        }

    case 59:
      switch (pattern54 (x3))
        {
        case 0:
          if (!
#line 963 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 174; /* vec_vmaov16qi */

        case 1:
          if (!
#line 963 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 175; /* vec_vmaov8hi */

        case 2:
          if (!
#line 963 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 176; /* vec_vmaov4si */

        case 3:
          if (!(
#line 963 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 54 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 177; /* vec_vmaov2di */

        default:
          return -1;
        }

    case 60:
      switch (pattern54 (x3))
        {
        case 0:
          if (!
#line 974 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 178; /* vec_vmalov16qi */

        case 1:
          if (!
#line 974 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 179; /* vec_vmalov8hi */

        case 2:
          if (!
#line 974 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 180; /* vec_vmalov4si */

        case 3:
          if (!(
#line 974 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 54 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 181; /* vec_vmalov2di */

        default:
          return -1;
        }

    case 99:
      switch (pattern55 (x3))
        {
        case 0:
          if (!
#line 1072 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 237; /* vec_sldv16qi */

        case 1:
          if (!
#line 1072 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 238; /* vec_sldv8hi */

        case 2:
          if (!
#line 1072 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 239; /* vec_sldv4si */

        case 3:
          if (!
#line 1072 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 240; /* vec_sldv2di */

        case 4:
          if (!
#line 1072 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 241; /* vec_sldv1ti */

        case 5:
          if (!
#line 1072 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 242; /* vec_sldti */

        case 6:
          if (!
#line 1072 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 243; /* vec_sldv2df */

        case 7:
          if (!(
#line 1072 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 34 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 244; /* vec_sldv4sf */

        case 8:
          if (!(
#line 1072 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 34 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 245; /* vec_sldv1tf */

        case 9:
          if (!(
#line 1072 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 35 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 246; /* vec_sldtf */

        default:
          return -1;
        }

    case 100:
      switch (pattern55 (x3))
        {
        case 0:
          if (!
#line 1095 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
            return -1;
          return 247; /* vec_sldbv16qi */

        case 1:
          if (!
#line 1095 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
            return -1;
          return 248; /* vec_sldbv8hi */

        case 2:
          if (!
#line 1095 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
            return -1;
          return 249; /* vec_sldbv4si */

        case 3:
          if (!
#line 1095 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
            return -1;
          return 250; /* vec_sldbv2di */

        case 4:
          if (!
#line 1095 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
            return -1;
          return 251; /* vec_sldbv1ti */

        case 5:
          if (!
#line 1095 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
            return -1;
          return 252; /* vec_sldbti */

        case 6:
          if (!
#line 1095 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
            return -1;
          return 253; /* vec_sldbv2df */

        case 7:
          if (!(
#line 1095 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2) && 
#line 34 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 254; /* vec_sldbv4sf */

        case 8:
          if (!(
#line 1095 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2) && 
#line 34 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 255; /* vec_sldbv1tf */

        case 9:
          if (!(
#line 1095 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2) && 
#line 35 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 256; /* vec_sldbtf */

        default:
          return -1;
        }

    case 101:
      switch (pattern55 (x3))
        {
        case 0:
          if (!
#line 1107 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
            return -1;
          return 257; /* vec_srdbv16qi */

        case 1:
          if (!
#line 1107 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
            return -1;
          return 258; /* vec_srdbv8hi */

        case 2:
          if (!
#line 1107 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
            return -1;
          return 259; /* vec_srdbv4si */

        case 3:
          if (!
#line 1107 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
            return -1;
          return 260; /* vec_srdbv2di */

        case 4:
          if (!
#line 1107 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
            return -1;
          return 261; /* vec_srdbv1ti */

        case 5:
          if (!
#line 1107 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
            return -1;
          return 262; /* vec_srdbti */

        case 6:
          if (!
#line 1107 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
            return -1;
          return 263; /* vec_srdbv2df */

        case 7:
          if (!(
#line 1107 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2) && 
#line 34 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 264; /* vec_srdbv4sf */

        case 8:
          if (!(
#line 1107 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2) && 
#line 34 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 265; /* vec_srdbv1tf */

        case 9:
          if (!(
#line 1107 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2) && 
#line 35 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 266; /* vec_srdbtf */

        default:
          return -1;
        }

    case 107:
      if (pattern50 (x3, 
E_TImode) != 0
          || !
#line 1179 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 343; /* vsbiq */

    case 108:
      if (pattern50 (x3, 
E_TImode) != 0
          || !
#line 1192 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 344; /* vsbcbiq */

    case 110:
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x3, 0, 1);
      operands[2] = x5;
      x6 = XVECEXP (x3, 0, 2);
      operands[3] = x6;
      if (!const_mask_operand (operands[3], E_QImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          if (pattern19 (x3, 
E_V16QImode) != 0
              || !
#line 1284 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 359; /* vfaev16qi */

        case E_V8HImode:
          if (pattern19 (x3, 
E_V8HImode) != 0
              || !
#line 1284 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 360; /* vfaev8hi */

        case E_V4SImode:
          if (pattern19 (x3, 
E_V4SImode) != 0
              || !
#line 1284 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 361; /* vfaev4si */

        default:
          return -1;
        }

    case 112:
      switch (pattern56 (x3))
        {
        case 0:
          if (!
#line 1384 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 365; /* vfeev16qi */

        case 1:
          if (!
#line 1384 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 366; /* vfeev8hi */

        case 2:
          if (!
#line 1384 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 367; /* vfeev4si */

        case 3:
          if (!
#line 1395 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 368; /* vfeezv16qi */

        case 4:
          if (!
#line 1395 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 369; /* vfeezv8hi */

        case 5:
          if (!
#line 1395 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 370; /* vfeezv4si */

        default:
          return -1;
        }

    case 114:
      switch (pattern56 (x3))
        {
        case 0:
          if (!
#line 1443 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 371; /* vfenev16qi */

        case 1:
          if (!
#line 1443 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 372; /* vfenev8hi */

        case 2:
          if (!
#line 1443 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 373; /* vfenev4si */

        case 3:
          if (!
#line 1456 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 374; /* vfenezv16qi */

        case 4:
          if (!
#line 1456 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 375; /* vfenezv8hi */

        case 5:
          if (!
#line 1456 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 376; /* vfenezv4si */

        default:
          return -1;
        }

    case 122:
      if (pattern57 (x3, 
E_V2DFmode, 
E_V2DImode) != 0
          || !
#line 1712 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && UINTVAL (operands[3]) != 2 && UINTVAL (operands[3]) <= 7))
        return -1;
      return 392; /* vcdgb */

    case 123:
      if (pattern57 (x3, 
E_V2DFmode, 
E_V2DImode) != 0
          || !
#line 1744 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && UINTVAL (operands[3]) != 2 && UINTVAL (operands[3]) <= 7))
        return -1;
      return 393; /* vcdlgb */

    case 124:
      if (pattern57 (x3, 
E_V2DImode, 
E_V2DFmode) != 0
          || !
#line 1775 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && UINTVAL (operands[3]) != 2 && UINTVAL (operands[3]) <= 7))
        return -1;
      return 394; /* vcgdb */

    case 125:
      if (pattern57 (x3, 
E_V2DImode, 
E_V2DFmode) != 0
          || !
#line 1808 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && UINTVAL (operands[3]) != 2 && UINTVAL (operands[3]) <= 7))
        return -1;
      return 395; /* vclgdb */

    case 126:
      return recog_15 (x1, insn, pnum_clobbers);

    case 128:
      if (pattern57 (x3, 
E_V4SFmode, 
E_V2DFmode) != 0
          || !
#line 1889 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 404; /* vflrd */

    case 132:
      switch (pattern58 (x3))
        {
        case 0:
          if (!
#line 2146 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE))
            return -1;
          return 473; /* vfminv4sf */

        case 1:
          if (!
#line 2146 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE))
            return -1;
          return 474; /* vfminv2df */

        case 2:
          if (!
#line 2146 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE))
            return -1;
          return 475; /* vfminv1tf */

        case 3:
          if (!
#line 2146 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE))
            return -1;
          return 476; /* vfmintf */

        default:
          return -1;
        }

    case 133:
      switch (pattern58 (x3))
        {
        case 0:
          if (!
#line 2156 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE))
            return -1;
          return 477; /* vfmaxv4sf */

        case 1:
          if (!
#line 2156 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE))
            return -1;
          return 478; /* vfmaxv2df */

        case 2:
          if (!
#line 2156 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE))
            return -1;
          return 479; /* vfmaxv1tf */

        case 3:
          if (!
#line 2156 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE))
            return -1;
          return 480; /* vfmaxtf */

        default:
          return -1;
        }

    case 92:
      return recog_14 (x1, insn, pnum_clobbers);

    case 140:
      if (GET_MODE (x3) != E_V8HImode
          || !register_operand (operands[0], E_V8HImode))
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V4SFmode))
        return -1;
      x5 = XVECEXP (x3, 0, 1);
      operands[2] = x5;
      if (!register_operand (operands[2], E_V4SFmode))
        return -1;
      x6 = XVECEXP (x3, 0, 2);
      operands[3] = x6;
      if (!const_mask_operand (operands[3], E_QImode)
          || !
#line 2245 "../../gcc/config/s390/vx-builtins.md"
(TARGET_NNPA))
        return -1;
      return 503; /* vcrnfs_v8hi */

    case 134:
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x3, 0, 1);
      operands[2] = x5;
      x6 = XVECEXP (x3, 0, 2);
      operands[3] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          if (pattern51 (x3, 
E_V16QImode) != 0
              || !
#line 2274 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE3))
            return -1;
          return 506; /* vblendv16qi */

        case E_V8HImode:
          if (pattern51 (x3, 
E_V8HImode) != 0
              || !
#line 2274 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE3))
            return -1;
          return 507; /* vblendv8hi */

        case E_V4SImode:
          if (pattern51 (x3, 
E_V4SImode) != 0
              || !
#line 2274 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE3))
            return -1;
          return 508; /* vblendv4si */

        case E_V2DImode:
          if (pattern51 (x3, 
E_V2DImode) != 0
              || !
#line 2274 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE3))
            return -1;
          return 509; /* vblendv2di */

        case E_V2DFmode:
          if (pattern153 (x3, 
E_V2DImode, 
E_V2DFmode) != 0
              || !
#line 2274 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE3))
            return -1;
          return 510; /* vblendv2df */

        case E_V1TImode:
          if (pattern51 (x3, 
E_V1TImode) != 0
              || !
#line 2274 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE3))
            return -1;
          return 511; /* vblendv1ti */

        case E_TImode:
          if (pattern51 (x3, 
E_TImode) != 0
              || !
#line 2274 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE3))
            return -1;
          return 512; /* vblendti */

        case E_V4SFmode:
          if (pattern153 (x3, 
E_V4SImode, 
E_V4SFmode) != 0
              || !(
#line 2274 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE3) && 
#line 47 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 513; /* vblendv4sf */

        case E_V1TFmode:
          if (pattern153 (x3, 
E_V1TImode, 
E_V1TFmode) != 0
              || !(
#line 2274 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE3) && 
#line 47 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 514; /* vblendv1tf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_49 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V2HImode:
          if (!register_operand (operands[0], E_V2HImode)
              || GET_MODE (x3) != E_V2HImode
              || !register_operand (operands[1], E_V2QImode)
              || !
#line 2668 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1507; /* extendv2qiv2hi2 */

        case E_V2SImode:
          if (!register_operand (operands[0], E_V2SImode)
              || GET_MODE (x3) != E_V2SImode
              || !register_operand (operands[1], E_V2HImode)
              || !
#line 2668 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1509; /* extendv2hiv2si2 */

        case E_V2DImode:
          if (!register_operand (operands[0], E_V2DImode)
              || GET_MODE (x3) != E_V2DImode
              || !register_operand (operands[1], E_V2SImode)
              || !
#line 2668 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1511; /* extendv2siv2di2 */

        case E_V4HImode:
          if (!register_operand (operands[0], E_V4HImode)
              || GET_MODE (x3) != E_V4HImode
              || !register_operand (operands[1], E_V4QImode)
              || !
#line 2668 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1513; /* extendv4qiv4hi2 */

        case E_V4SImode:
          if (!register_operand (operands[0], E_V4SImode)
              || GET_MODE (x3) != E_V4SImode
              || !register_operand (operands[1], E_V4HImode)
              || !
#line 2668 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1515; /* extendv4hiv4si2 */

        default:
          return -1;
        }

    case VEC_SELECT:
      switch (pattern114 (x3))
        {
        case 0:
          if (!
#line 2700 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1517; /* vec_unpacks_hi_v16qi */

        case 1:
          if (!
#line 2711 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1518; /* vec_unpacks_lo_v16qi */

        case 2:
          if (!
#line 2749 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1521; /* vec_unpacks_hi_v8hi */

        case 3:
          if (!
#line 2759 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1522; /* vec_unpacks_lo_v8hi */

        case 4:
          if (!
#line 2795 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1525; /* vec_unpacks_hi_v4si */

        case 5:
          if (!
#line 2805 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1526; /* vec_unpacks_lo_v4si */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_54 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case GTU:
      res = recog_38 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case PLUS:
    case MINUS:
    case MULT:
    case AND:
    case SIGN_EXTEND:
    case ZERO_EXTEND:
    case HIGH:
      res = recog_53 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    default:
      break;
    }
  if (pnum_clobbers == NULL)
    return -1;
  operands[1] = x2;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!register_operand (operands[0], E_DImode))
        return -1;
      if (s390_alc_comparison (operands[1], E_DImode)
          && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
        {
          *pnum_clobbers = 1;
          return 2304; /* *sconddi */
        }
      if (!s390_slb_comparison (operands[1], E_DImode)
          || !
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
        return -1;
      *pnum_clobbers = 1;
      return 2306; /* *sconddi_neg */

    case E_SImode:
      if (!register_operand (operands[0], E_SImode))
        return -1;
      if (s390_alc_comparison (operands[1], E_SImode))
        {
          *pnum_clobbers = 1;
          return 2305; /* *scondsi */
        }
      if (!s390_slb_comparison (operands[1], E_SImode))
        return -1;
      *pnum_clobbers = 1;
      return 2307; /* *scondsi_neg */

    default:
      return -1;
    }
}

 int
recog_58 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case AND:
      return recog_22 (x1, insn, pnum_clobbers);

    case NOT:
      return recog_23 (x1, insn, pnum_clobbers);

    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      switch (pattern65 (x3, pnum_clobbers))
        {
        case 0:
          if (
#line 1284 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 816; /* iorv1qi3 */
          break;

        case 1:
          if (
#line 1284 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 817; /* iorv2qi3 */
          break;

        case 2:
          if (
#line 1284 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 818; /* iorv4qi3 */
          break;

        case 3:
          if (
#line 1284 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 819; /* iorv8qi3 */
          break;

        case 4:
          if (
#line 1284 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 820; /* iorv16qi3 */
          break;

        case 5:
          if (
#line 1284 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 821; /* iorv1hi3 */
          break;

        case 6:
          if (
#line 1284 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 822; /* iorv2hi3 */
          break;

        case 7:
          if (
#line 1284 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 823; /* iorv4hi3 */
          break;

        case 8:
          if (
#line 1284 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 824; /* iorv8hi3 */
          break;

        case 9:
          if (
#line 1284 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 825; /* iorv1si3 */
          break;

        case 10:
          if (
#line 1284 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 826; /* iorv2si3 */
          break;

        case 11:
          if (
#line 1284 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 827; /* iorv4si3 */
          break;

        case 12:
          if (
#line 1284 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 828; /* iorv1di3 */
          break;

        case 13:
          if (
#line 1284 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 829; /* iorv2di3 */
          break;

        case 14:
          if (
#line 1284 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 830; /* iorv1sf3 */
          break;

        case 15:
          if (
#line 1284 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 831; /* iorv2sf3 */
          break;

        case 16:
          if (
#line 1284 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 832; /* iorv4sf3 */
          break;

        case 17:
          if (
#line 1284 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 833; /* iorv1df3 */
          break;

        case 18:
          if (
#line 1284 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 834; /* iorv2df3 */
          break;

        case 19:
          if (
#line 1284 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 835; /* iorv1tf3 */
          break;

        case 20:
          if (
#line 1284 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 836; /* iorv1ti3 */
          break;

        case 21:
          if (
#line 1284 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 837; /* iorti3 */
          break;

        case 22:
          if (
#line 8370 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
            {
              *pnum_clobbers = 1;
              return 2370; /* *iordi3 */
            }
          break;

        case 23:
          if (
#line 8507 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
            {
              *pnum_clobbers = 1;
              return 2375; /* *iorhi3_zarch */
            }
          if (
#line 8523 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
            {
              *pnum_clobbers = 1;
              return 2376; /* *iorhi3_esa */
            }
          break;

        case 24:
          if (
#line 8550 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
            {
              *pnum_clobbers = 1;
              return 2377; /* *iorqi3_zarch */
            }
          if (
#line 8568 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
            {
              *pnum_clobbers = 1;
              return 2378; /* *iorqi3_esa */
            }
          break;

        default:
          break;
        }
      if (pnum_clobbers == NULL
          || !nonimmediate_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      if (GET_CODE (x4) == SUBREG
          && pattern131 (x3) == 0
          && 
#line 4792 "../../gcc/config/s390/s390.md"
(TARGET_Z10))
        {
          *pnum_clobbers = 1;
          return 2002; /* *rosbg_sidi_srl */
        }
      operands[1] = x4;
      if (!nonimmediate_operand (operands[1], E_SImode))
        return -1;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      if (!general_operand (operands[2], E_SImode))
        return -1;
      if (
#line 8451 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
        {
          *pnum_clobbers = 1;
          return 2373; /* *iorsi3_zarch */
        }
      if (!
#line 8479 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
        return -1;
      *pnum_clobbers = 1;
      return 2374; /* *iorsi3_esa */

    case IOR:
      switch (pattern29 (x3))
        {
        case 0:
          if (!
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1583; /* *vevalv1qi_iorior */

        case 1:
          if (!
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1592; /* *vevalv2qi_iorior */

        case 2:
          if (!
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1601; /* *vevalv4qi_iorior */

        case 3:
          if (!
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1610; /* *vevalv8qi_iorior */

        case 4:
          if (!
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1619; /* *vevalv16qi_iorior */

        case 5:
          if (!
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1628; /* *vevalv1hi_iorior */

        case 6:
          if (!
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1637; /* *vevalv2hi_iorior */

        case 7:
          if (!
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1646; /* *vevalv4hi_iorior */

        case 8:
          if (!
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1655; /* *vevalv8hi_iorior */

        case 9:
          if (!
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1664; /* *vevalv1si_iorior */

        case 10:
          if (!
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1673; /* *vevalv2si_iorior */

        case 11:
          if (!
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1682; /* *vevalv4si_iorior */

        case 12:
          if (!
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1691; /* *vevalv1di_iorior */

        case 13:
          if (!
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1700; /* *vevalv2di_iorior */

        case 14:
          if (!
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1709; /* *vevalv1ti_iorior */

        case 15:
          if (!
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1718; /* *vevalti_iorior */

        default:
          return -1;
        }

    case XOR:
      switch (pattern29 (x3))
        {
        case 0:
          if (!
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1584; /* *vevalv1qi_iorxor */

        case 1:
          if (!
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1593; /* *vevalv2qi_iorxor */

        case 2:
          if (!
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1602; /* *vevalv4qi_iorxor */

        case 3:
          if (!
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1611; /* *vevalv8qi_iorxor */

        case 4:
          if (!
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1620; /* *vevalv16qi_iorxor */

        case 5:
          if (!
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1629; /* *vevalv1hi_iorxor */

        case 6:
          if (!
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1638; /* *vevalv2hi_iorxor */

        case 7:
          if (!
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1647; /* *vevalv4hi_iorxor */

        case 8:
          if (!
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1656; /* *vevalv8hi_iorxor */

        case 9:
          if (!
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1665; /* *vevalv1si_iorxor */

        case 10:
          if (!
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1674; /* *vevalv2si_iorxor */

        case 11:
          if (!
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1683; /* *vevalv4si_iorxor */

        case 12:
          if (!
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1692; /* *vevalv1di_iorxor */

        case 13:
          if (!
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1701; /* *vevalv2di_iorxor */

        case 14:
          if (!
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1710; /* *vevalv1ti_iorxor */

        case 15:
          if (!
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1719; /* *vevalti_iorxor */

        default:
          return -1;
        }

    case ASHIFT:
      x6 = XEXP (x4, 0);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
        case MEM:
          switch (pattern31 (x3, pnum_clobbers))
            {
            case 0:
              if (!(
#line 4753 "../../gcc/config/s390/s390.md"
(TARGET_Z10) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              *pnum_clobbers = 1;
              return 1994; /* *rosbg_di_sll */

            case 1:
              if (!
#line 4753 "../../gcc/config/s390/s390.md"
(TARGET_Z10))
                return -1;
              *pnum_clobbers = 1;
              return 1996; /* *rosbg_si_sll */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          x7 = XEXP (x4, 1);
          if (GET_CODE (x7) != CONST_INT)
            return -1;
          x5 = XEXP (x3, 1);
          if (GET_CODE (x5) != ZERO_EXTEND)
            return -1;
          x8 = XEXP (x6, 0);
          switch (GET_CODE (x8))
            {
            case MOD:
              if (pattern132 (x3, 
DIV) != 0
                  || pattern203 (x3) != 0)
                return -1;
              x9 = XEXP (x5, 0);
              x10 = XEXP (x9, 0);
              if (!rtx_equal_p (x10, operands[1]))
                return -1;
              x11 = XEXP (x8, 1);
              switch (GET_CODE (x11))
                {
                case CONST_INT:
                case CONST_WIDE_INT:
                case CONST_POLY_INT:
                case CONST_FIXED:
                case CONST_DOUBLE:
                case CONST_VECTOR:
                case CONST:
                case REG:
                case SUBREG:
                case MEM:
                case LABEL_REF:
                case SYMBOL_REF:
                case HIGH:
                  operands[2] = x11;
                  if (!general_operand (operands[2], E_DImode))
                    return -1;
                  x12 = XEXP (x9, 1);
                  if (!rtx_equal_p (x12, operands[2])
                      || !
#line 7670 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                    return -1;
                  return 2335; /* divmodtidi3 */

                case SIGN_EXTEND:
                  if (GET_MODE (x11) != E_DImode)
                    return -1;
                  x12 = XEXP (x9, 1);
                  if (GET_CODE (x12) != SIGN_EXTEND
                      || GET_MODE (x12) != E_DImode)
                    return -1;
                  x13 = XEXP (x11, 0);
                  operands[2] = x13;
                  if (!nonimmediate_operand (operands[2], E_SImode))
                    return -1;
                  x14 = XEXP (x12, 0);
                  if (!rtx_equal_p (x14, operands[2])
                      || !
#line 7688 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                    return -1;
                  return 2336; /* divmodtisi3 */

                default:
                  return -1;
                }

            case TRUNCATE:
              x9 = XEXP (x5, 0);
              if (GET_CODE (x9) != TRUNCATE)
                return -1;
              x15 = XEXP (x8, 0);
              switch (GET_CODE (x15))
                {
                case UMOD:
                  x16 = XEXP (x15, 1);
                  if (GET_CODE (x16) != ZERO_EXTEND)
                    return -1;
                  x10 = XEXP (x9, 0);
                  if (GET_CODE (x10) != UDIV)
                    return -1;
                  x17 = XEXP (x10, 1);
                  if (GET_CODE (x17) != ZERO_EXTEND)
                    return -1;
                  x18 = XEXP (x15, 0);
                  operands[1] = x18;
                  x19 = XEXP (x16, 0);
                  operands[2] = x19;
                  x20 = XEXP (x10, 0);
                  if (!rtx_equal_p (x20, operands[1]))
                    return -1;
                  x21 = XEXP (x17, 0);
                  if (!rtx_equal_p (x21, operands[2]))
                    return -1;
                  switch (XWINT (x7, 0))
                    {
                    case 64L:
                      if (pattern269 (x3, 
E_TImode, 
E_DImode) != 0
                          || !
#line 7749 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                        return -1;
                      return 2337; /* udivmodtidi3 */

                    case 32L:
                      if (pattern269 (x3, 
E_DImode, 
E_SImode) != 0
                          || !
#line 7869 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
                        return -1;
                      return 2339; /* udivmoddisi3 */

                    default:
                      return -1;
                    }

                case MOD:
                  if (GET_MODE (x15) != E_DImode)
                    return -1;
                  x16 = XEXP (x15, 1);
                  if (GET_CODE (x16) != SIGN_EXTEND
                      || GET_MODE (x16) != E_DImode
                      || XWINT (x7, 0) != 32L)
                    return -1;
                  x10 = XEXP (x9, 0);
                  if (GET_CODE (x10) != DIV
                      || GET_MODE (x10) != E_DImode)
                    return -1;
                  x17 = XEXP (x10, 1);
                  if (GET_CODE (x17) != SIGN_EXTEND
                      || GET_MODE (x17) != E_DImode
                      || !register_operand (operands[0], E_DImode)
                      || GET_MODE (x3) != E_DImode
                      || GET_MODE (x4) != E_DImode
                      || GET_MODE (x6) != E_DImode
                      || GET_MODE (x8) != E_SImode)
                    return -1;
                  x18 = XEXP (x15, 0);
                  operands[1] = x18;
                  if (!register_operand (operands[1], E_DImode))
                    return -1;
                  x19 = XEXP (x16, 0);
                  operands[2] = x19;
                  if (!nonimmediate_operand (operands[2], E_SImode)
                      || GET_MODE (x5) != E_DImode
                      || GET_MODE (x9) != E_SImode)
                    return -1;
                  x20 = XEXP (x10, 0);
                  if (!rtx_equal_p (x20, operands[1]))
                    return -1;
                  x21 = XEXP (x17, 0);
                  if (!rtx_equal_p (x21, operands[2])
                      || !
#line 7808 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
                    return -1;
                  return 2338; /* divmoddisi3 */

                default:
                  return -1;
                }

            case CLZ:
              if (pnum_clobbers == NULL
                  || pattern132 (x3, 
XOR) != 0)
                return -1;
              x9 = XEXP (x5, 0);
              x12 = XEXP (x9, 1);
              if (GET_CODE (x12) != LSHIFTRT)
                return -1;
              x22 = XEXP (x12, 1);
              if (GET_CODE (x22) != SUBREG
                  || maybe_ne (SUBREG_BYTE (x22), 4)
                  || GET_MODE (x22) != E_SImode)
                return -1;
              x23 = XEXP (x22, 0);
              if (GET_CODE (x23) != CLZ
                  || GET_MODE (x23) != E_DImode
                  || pattern203 (x3) != 0)
                return -1;
              x14 = XEXP (x12, 0);
              operands[2] = x14;
              if (!const_int_operand (operands[2], E_DImode))
                return -1;
              x10 = XEXP (x9, 0);
              if (!rtx_equal_p (x10, operands[1]))
                return -1;
              x24 = XEXP (x23, 0);
              if (!rtx_equal_p (x24, operands[1])
                  || !
#line 9627 "../../gcc/config/s390/s390.md"
(UINTVAL (operands[2]) == HOST_WIDE_INT_1U << 63
   && TARGET_EXTIMM && TARGET_ZARCH))
                return -1;
              *pnum_clobbers = 1;
              return 2506; /* clztidi2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case LSHIFTRT:
      switch (pattern31 (x3, pnum_clobbers))
        {
        case 0:
          if (!(
#line 4772 "../../gcc/config/s390/s390.md"
(TARGET_Z10) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 1998; /* *rosbg_di_srl */

        case 1:
          if (!
#line 4772 "../../gcc/config/s390/s390.md"
(TARGET_Z10))
            return -1;
          *pnum_clobbers = 1;
          return 2000; /* *rosbg_si_srl */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_69 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case VEC_SELECT:
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) != PARALLEL
          || XVECLEN (x5, 0) != 1)
        return -1;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      x7 = XVECEXP (x5, 0, 0);
      operands[2] = x7;
      if (!const_int_operand (operands[2], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (pattern169 (x3, 
E_V8HImode, 
E_HImode) != 0
              || !
#line 2208 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2 && UINTVAL (operands[2]) < GET_MODE_NUNITS (V8HImode)))
            return -1;
          return 496; /* *vec_extract_bswap_elemv8hi */

        case E_SImode:
          if (pattern169 (x3, 
E_V4SImode, 
E_SImode) != 0
              || !
#line 2208 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2 && UINTVAL (operands[2]) < GET_MODE_NUNITS (V4SImode)))
            return -1;
          return 497; /* *vec_extract_bswap_elemv4si */

        case E_SFmode:
          if (pattern169 (x3, 
E_V4SFmode, 
E_SFmode) != 0
              || !(
#line 2208 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2 && UINTVAL (operands[2]) < GET_MODE_NUNITS (V4SFmode)) && 
#line 44 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 498; /* *vec_extract_bswap_elemv4sf */

        case E_DImode:
          if (pattern169 (x3, 
E_V2DImode, 
E_DImode) != 0
              || !
#line 2208 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2 && UINTVAL (operands[2]) < GET_MODE_NUNITS (V2DImode)))
            return -1;
          return 499; /* *vec_extract_bswap_elemv2di */

        case E_DFmode:
          if (pattern169 (x3, 
E_V2DFmode, 
E_DFmode) != 0
              || !
#line 2208 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2 && UINTVAL (operands[2]) < GET_MODE_NUNITS (V2DFmode)))
            return -1;
          return 500; /* *vec_extract_bswap_elemv2df */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HImode:
          if (!memory_operand (operands[0], E_V8HImode)
              || GET_MODE (x3) != E_V8HImode
              || !register_operand (operands[1], E_V8HImode)
              || !
#line 3380 "../../gcc/config/s390/vector.md"
(TARGET_VXE2))
            return -1;
          return 1574; /* *vstbrv8hi */

        case E_V4SImode:
          if (!memory_operand (operands[0], E_V4SImode)
              || GET_MODE (x3) != E_V4SImode
              || !register_operand (operands[1], E_V4SImode)
              || !
#line 3380 "../../gcc/config/s390/vector.md"
(TARGET_VXE2))
            return -1;
          return 1575; /* *vstbrv4si */

        case E_V2DImode:
          if (!memory_operand (operands[0], E_V2DImode)
              || GET_MODE (x3) != E_V2DImode
              || !register_operand (operands[1], E_V2DImode)
              || !
#line 3380 "../../gcc/config/s390/vector.md"
(TARGET_VXE2))
            return -1;
          return 1576; /* *vstbrv2di */

        case E_V1TImode:
          if (!memory_operand (operands[0], E_V1TImode)
              || GET_MODE (x3) != E_V1TImode
              || !register_operand (operands[1], E_V1TImode)
              || !
#line 3380 "../../gcc/config/s390/vector.md"
(TARGET_VXE2))
            return -1;
          return 1577; /* *vstbrv1ti */

        case E_TImode:
          if (!memory_operand (operands[0], E_TImode)
              || GET_MODE (x3) != E_TImode
              || !register_operand (operands[1], E_TImode)
              || !
#line 3380 "../../gcc/config/s390/vector.md"
(TARGET_VXE2))
            return -1;
          return 1578; /* *vstbrti */

        case E_DImode:
          if (!nonimmediate_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || !nonimmediate_operand (operands[1], E_DImode)
              || !
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return -1;
          return 2637; /* bswapdi2 */

        case E_SImode:
          if (!nonimmediate_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !nonimmediate_operand (operands[1], E_SImode))
            return -1;
          return 2638; /* bswapsi2 */

        case E_HImode:
          if (!nonimmediate_operand (operands[0], E_HImode)
              || GET_MODE (x3) != E_HImode
              || !nonimmediate_operand (operands[1], E_HImode))
            return -1;
          return 2639; /* bswaphi2 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_72 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SImode:
      if (pattern0 (x3, 
E_V4SImode) != 0
          || !
#line 1163 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
        return -1;
      return 722; /* divv4si3 */

    case E_V2DImode:
      if (pattern0 (x3, 
E_V2DImode) != 0
          || !
#line 1163 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
        return -1;
      return 723; /* divv2di3 */

    case E_V1TImode:
      if (pattern0 (x3, 
E_V1TImode) != 0
          || !
#line 1163 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
        return -1;
      return 724; /* divv1ti3 */

    case E_TImode:
      if (pattern0 (x3, 
E_TImode) != 0
          || !
#line 1163 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
        return -1;
      return 725; /* divti3 */

    case E_V4SFmode:
      if (pattern0 (x3, 
E_V4SFmode) != 0
          || !(
#line 1909 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 87 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      return 1239; /* divv4sf3 */

    case E_V2DFmode:
      if (pattern0 (x3, 
E_V2DFmode) != 0
          || !
#line 1909 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1240; /* divv2df3 */

    case E_V1TFmode:
      if (pattern0 (x3, 
E_V1TFmode) != 0
          || !(
#line 1909 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 87 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      return 1241; /* divv1tf3 */

    case E_TFmode:
      if (!register_operand (operands[0], E_TFmode)
          || GET_MODE (x3) != E_TFmode
          || !register_operand (operands[1], E_TFmode))
        return -1;
      if (register_operand (operands[2], E_TFmode)
          && (
#line 1909 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 88 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return 1242; /* divtf3_vr */
      if (!general_operand (operands[2], E_TFmode)
          || !(
#line 7885 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 751 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
        return -1;
      return 2340; /* divtf3_fpr */

    case E_FPRX2mode:
      if (pattern85 (x3, 
E_FPRX2mode) != 0
          || !(
#line 7885 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 751 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
        return -1;
      return 2341; /* divfprx23 */

    case E_DFmode:
      if (pattern85 (x3, 
E_DFmode) != 0
          || !
#line 7885 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
        return -1;
      return 2342; /* divdf3 */

    case E_SFmode:
      if (pattern85 (x3, 
E_SFmode) != 0
          || !
#line 7885 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
        return -1;
      return 2343; /* divsf3 */

    case E_TDmode:
      if (pattern85 (x3, 
E_TDmode) != 0
          || !(
#line 7885 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 752 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
        return -1;
      return 2344; /* divtd3 */

    case E_DDmode:
      if (pattern85 (x3, 
E_DDmode) != 0
          || !(
#line 7885 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 752 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
        return -1;
      return 2345; /* divdd3 */

    default:
      return -1;
    }
}

 int
recog_82 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PLUS)
    return -1;
  x4 = XEXP (x2, 0);
  operands[0] = x4;
  x5 = XEXP (x3, 0);
  if (!rtx_equal_p (x5, operands[1]))
    return -1;
  x6 = XEXP (x3, 1);
  if (!rtx_equal_p (x6, operands[2]))
    return -1;
  x7 = XVECEXP (x1, 0, 0);
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) == E_CCL1mode)
    {
      x9 = XEXP (x7, 1);
      if (GET_MODE (x9) == E_CCL1mode)
        {
          x10 = XEXP (x9, 1);
          if (rtx_equal_p (x10, operands[1]))
            {
              x11 = XEXP (x9, 0);
              switch (GET_MODE (x11))
                {
                case E_DImode:
                  if (pattern275 (x3, 
E_DImode) == 0
                      && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                    return 2205; /* adddi3_carry1_cc */
                  break;

                case E_SImode:
                  if (pattern275 (x3, 
E_SImode) == 0)
                    return 2206; /* addsi3_carry1_cc */
                  break;

                default:
                  break;
                }
            }
        }
    }
  x9 = XEXP (x7, 1);
  x11 = XEXP (x9, 0);
  switch (GET_MODE (x11))
    {
    case E_DImode:
      if (pattern254 (x1, 
E_DImode) != 0
          || !(
#line 6283 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL1mode)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
        return -1;
      return 2209; /* *adddi3_carry2_cc */

    case E_SImode:
      if (pattern254 (x1, 
E_SImode) != 0
          || !
#line 6283 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL1mode)))
        return -1;
      return 2210; /* *addsi3_carry2_cc */

    case E_TFmode:
      if (pattern255 (x1, 
E_TFmode) != 0
          || !(
#line 6510 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 751 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
        return -1;
      return 2232; /* *addtf3_cc */

    case E_FPRX2mode:
      if (pattern255 (x1, 
E_FPRX2mode) != 0
          || !(
#line 6510 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 751 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
        return -1;
      return 2233; /* *addfprx23_cc */

    case E_DFmode:
      if (pattern255 (x1, 
E_DFmode) != 0
          || !
#line 6510 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
        return -1;
      return 2234; /* *adddf3_cc */

    case E_SFmode:
      if (pattern255 (x1, 
E_SFmode) != 0
          || !
#line 6510 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
        return -1;
      return 2235; /* *addsf3_cc */

    case E_TDmode:
      if (pattern255 (x1, 
E_TDmode) != 0
          || !(
#line 6510 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 752 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
        return -1;
      return 2236; /* *addtd3_cc */

    case E_DDmode:
      if (pattern255 (x1, 
E_DDmode) != 0
          || !(
#line 6510 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 752 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
        return -1;
      return 2237; /* *adddd3_cc */

    default:
      return -1;
    }
}

 int
recog_93 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case ZERO_EXTRACT:
      if (GET_MODE (x3) != E_DImode)
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      if (pattern89 (x4) != 0)
        return -1;
      x5 = XEXP (x3, 0);
      operands[0] = x5;
      if (!nonimmediate_operand (operands[0], E_DImode))
        return -1;
      x6 = XEXP (x3, 1);
      operands[1] = x6;
      if (!const_int_operand (operands[1], E_VOIDmode))
        return -1;
      x7 = XEXP (x3, 2);
      operands[2] = x7;
      if (!const_int_operand (operands[2], E_VOIDmode))
        return -1;
      x8 = XEXP (x2, 1);
      if (GET_MODE (x8) != E_DImode)
        return -1;
      x9 = XEXP (x8, 1);
      operands[3] = x9;
      if (!nonimmediate_operand (operands[3], E_DImode))
        return -1;
      x10 = XEXP (x8, 0);
      if (!rtx_equal_p (x10, operands[0])
          || !
#line 4833 "../../gcc/config/s390/s390.md"
(TARGET_Z10
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[1]), INTVAL (operands[2]), 64)
   && INTVAL (operands[1]) + INTVAL (operands[2]) == 64))
        return -1;
      return 2004; /* *insv_rnsbg_noshift */

    case SUBREG:
    case MEM:
      if (pnum_clobbers == NULL)
        return -1;
      operands[0] = x3;
      if (!memory_operand (operands[0], E_BLKmode))
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != USE)
        return -1;
      x8 = XEXP (x2, 1);
      if (GET_MODE (x8) != E_BLKmode)
        return -1;
      x9 = XEXP (x8, 1);
      operands[1] = x9;
      if (!memory_operand (operands[1], E_BLKmode))
        return -1;
      x11 = XEXP (x4, 0);
      operands[2] = x11;
      if (!const_int_operand (operands[2], E_VOIDmode))
        return -1;
      x10 = XEXP (x8, 0);
      if (!rtx_equal_p (x10, operands[0])
          || !
#line 8265 "../../gcc/config/s390/s390.md"
(INTVAL (operands[2]) >= 1 && INTVAL (operands[2]) <= 256))
        return -1;
      *pnum_clobbers = 1;
      return 2367; /* *nc */

    default:
      return -1;
    }
}

 int
recog_98 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (pattern38 (x1) != 0)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_TImode:
          if (pattern214 (x3, 
E_TImode) != 0
              || !
#line 6072 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return -1;
          return 2196; /* *addti3 */

        case E_DImode:
          if (pattern121 (x3, 
E_DImode) != 0)
            return -1;
          if (
#line 6163 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
            return 2201; /* *adddi3_31z */
          if (!
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return -1;
          return 2203; /* *adddi3 */

        case E_SImode:
          if (pattern121 (x3, 
E_SImode) != 0)
            return -1;
          return 2204; /* *addsi3 */

        case E_TFmode:
          if (pattern214 (x3, 
E_TFmode) != 0
              || !(
#line 6490 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 751 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          return 2226; /* addtf3_fpr */

        case E_FPRX2mode:
          if (pattern214 (x3, 
E_FPRX2mode) != 0
              || !(
#line 6490 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 751 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          return 2227; /* addfprx23 */

        case E_DFmode:
          if (pattern214 (x3, 
E_DFmode) != 0
              || !
#line 6490 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 2228; /* adddf3 */

        case E_SFmode:
          if (pattern214 (x3, 
E_SFmode) != 0
              || !
#line 6490 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 2229; /* addsf3 */

        case E_TDmode:
          if (pattern214 (x3, 
E_TDmode) != 0
              || !(
#line 6490 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 752 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          return 2230; /* addtd3 */

        case E_DDmode:
          if (pattern214 (x3, 
E_DDmode) != 0
              || !(
#line 6490 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 752 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          return 2231; /* adddd3 */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      x6 = XEXP (x4, 0);
      operands[2] = x6;
      x5 = XEXP (x3, 1);
      operands[1] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || GET_MODE (x4) != E_DImode
              || !register_operand (operands[1], E_DImode))
            return -1;
          if (general_operand (operands[2], E_SImode)
              && 
#line 6112 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return 2197; /* *adddi3_sign */
          if (!memory_operand (operands[2], E_HImode)
              || !
#line 6398 "../../gcc/config/s390/s390.md"
(TARGET_Z14))
            return -1;
          return 2221; /* *adddi3_sign */

        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || GET_MODE (x4) != E_SImode
              || !memory_operand (operands[2], E_HImode)
              || !register_operand (operands[1], E_SImode))
            return -1;
          return 2202; /* *addsi3_sign */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      if (GET_MODE (x4) != E_DImode
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      x6 = XEXP (x4, 0);
      operands[2] = x6;
      if (!general_operand (operands[2], E_SImode))
        return -1;
      x5 = XEXP (x3, 1);
      operands[1] = x5;
      if (!register_operand (operands[1], E_DImode)
          || !
#line 6151 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
        return -1;
      return 2200; /* *adddi3_zero */

    case PLUS:
      x6 = XEXP (x4, 0);
      operands[3] = x6;
      x7 = XEXP (x4, 1);
      operands[1] = x7;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (pattern247 (x3, 
E_DImode) != 0
              || !
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return -1;
          return 2296; /* *adddi3_alc */

        case E_SImode:
          if (pattern247 (x3, 
E_SImode) != 0)
            return -1;
          return 2297; /* *addsi3_alc */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_105 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != USE)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 0);
  operands[0] = x4;
  x5 = XEXP (x2, 0);
  if (!permute_pattern_operand (x5, E_V16QImode))
    return -1;
  x6 = XEXP (x3, 1);
  x7 = XEXP (x6, 0);
  switch (GET_CODE (x7))
    {
    case UNSPEC:
      switch (XVECLEN (x7, 0))
        {
        case 1:
          if (XINT (x7, 1) != 62)
            return -1;
          x8 = XVECEXP (x7, 0, 0);
          operands[1] = x8;
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_V8HImode:
              if (pattern223 (x6, 
E_HImode, 
E_V8HImode) != 0
                  || !
#line 191 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
                return -1;
              return 11; /* *vec_insert_and_zero_bswapv8hi */

            case E_V4SImode:
              if (pattern223 (x6, 
E_SImode, 
E_V4SImode) != 0
                  || !
#line 191 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
                return -1;
              return 12; /* *vec_insert_and_zero_bswapv4si */

            case E_V4SFmode:
              if (pattern223 (x6, 
E_SFmode, 
E_V4SFmode) != 0
                  || !(
#line 191 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2) && 
#line 44 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 13; /* *vec_insert_and_zero_bswapv4sf */

            case E_V2DImode:
              if (pattern223 (x6, 
E_DImode, 
E_V2DImode) != 0
                  || !
#line 191 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
                return -1;
              return 14; /* *vec_insert_and_zero_bswapv2di */

            case E_V2DFmode:
              if (pattern223 (x6, 
E_DFmode, 
E_V2DFmode) != 0
                  || !
#line 191 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
                return -1;
              return 15; /* *vec_insert_and_zero_bswapv2df */

            default:
              return -1;
            }

        case 3:
          if (XINT (x7, 1) != 92)
            return -1;
          x9 = XVECEXP (x7, 0, 2);
          if (GET_CODE (x9) != BSWAP)
            return -1;
          x8 = XVECEXP (x7, 0, 0);
          operands[1] = x8;
          x10 = XVECEXP (x7, 0, 1);
          operands[2] = x10;
          if (!const_int_operand (operands[2], E_SImode))
            return -1;
          x11 = XEXP (x9, 0);
          operands[3] = x11;
          operands[4] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_V8HImode:
              if (pattern260 (x6, 
E_V8HImode, 
E_HImode) != 0
                  || !
#line 2183 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2 && UINTVAL (operands[2]) < GET_MODE_NUNITS (V8HImode)))
                return -1;
              return 486; /* *vec_set_bswap_vecv8hi */

            case E_V4SImode:
              if (pattern260 (x6, 
E_V4SImode, 
E_SImode) != 0
                  || !
#line 2183 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2 && UINTVAL (operands[2]) < GET_MODE_NUNITS (V4SImode)))
                return -1;
              return 487; /* *vec_set_bswap_vecv4si */

            case E_V4SFmode:
              if (pattern260 (x6, 
E_V4SFmode, 
E_SFmode) != 0
                  || !(
#line 2183 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2 && UINTVAL (operands[2]) < GET_MODE_NUNITS (V4SFmode)) && 
#line 44 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 488; /* *vec_set_bswap_vecv4sf */

            case E_V2DImode:
              if (pattern260 (x6, 
E_V2DImode, 
E_DImode) != 0
                  || !
#line 2183 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2 && UINTVAL (operands[2]) < GET_MODE_NUNITS (V2DImode)))
                return -1;
              return 489; /* *vec_set_bswap_vecv2di */

            case E_V2DFmode:
              if (pattern260 (x6, 
E_V2DFmode, 
E_DFmode) != 0
                  || !
#line 2183 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2 && UINTVAL (operands[2]) < GET_MODE_NUNITS (V2DFmode)))
                return -1;
              return 490; /* *vec_set_bswap_vecv2df */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      x12 = XEXP (x7, 0);
      operands[1] = x12;
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HImode:
          if (pattern190 (x6, 
E_HImode, 
E_V8HImode) != 0
              || !
#line 642 "../../gcc/config/s390/vector.md"
(TARGET_VXE2))
            return -1;
          return 633; /* *vec_splats_bswap_vecv8hi */

        case E_V4SImode:
          if (pattern190 (x6, 
E_SImode, 
E_V4SImode) != 0
              || !
#line 642 "../../gcc/config/s390/vector.md"
(TARGET_VXE2))
            return -1;
          return 634; /* *vec_splats_bswap_vecv4si */

        case E_V4SFmode:
          if (pattern190 (x6, 
E_SFmode, 
E_V4SFmode) != 0
              || !(
#line 642 "../../gcc/config/s390/vector.md"
(TARGET_VXE2) && 
#line 44 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 635; /* *vec_splats_bswap_vecv4sf */

        case E_V2DImode:
          if (pattern190 (x6, 
E_DImode, 
E_V2DImode) != 0
              || !
#line 642 "../../gcc/config/s390/vector.md"
(TARGET_VXE2))
            return -1;
          return 636; /* *vec_splats_bswap_vecv2di */

        case E_V2DFmode:
          if (pattern190 (x6, 
E_DFmode, 
E_V2DFmode) != 0
              || !
#line 642 "../../gcc/config/s390/vector.md"
(TARGET_VXE2))
            return -1;
          return 637; /* *vec_splats_bswap_vecv2df */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x7;
      operands[2] = x5;
      switch (pattern164 (x6))
        {
        case 0:
          if (!
#line 3360 "../../gcc/config/s390/vector.md"
(TARGET_VXE2))
            return -1;
          return 1565; /* *bswapv8hi */

        case 1:
          if (!
#line 3360 "../../gcc/config/s390/vector.md"
(TARGET_VXE2))
            return -1;
          return 1566; /* *bswapv4si */

        case 2:
          if (!
#line 3360 "../../gcc/config/s390/vector.md"
(TARGET_VXE2))
            return -1;
          return 1567; /* *bswapv4sf */

        case 3:
          if (!
#line 3360 "../../gcc/config/s390/vector.md"
(TARGET_VXE2))
            return -1;
          return 1568; /* *bswapv2di */

        case 4:
          if (!
#line 3360 "../../gcc/config/s390/vector.md"
(TARGET_VXE2))
            return -1;
          return 1569; /* *bswapv2df */

        case 5:
          if (!
#line 3360 "../../gcc/config/s390/vector.md"
(TARGET_VXE2))
            return -1;
          return 1570; /* *bswapv1ti */

        case 6:
          if (!
#line 3360 "../../gcc/config/s390/vector.md"
(TARGET_VXE2))
            return -1;
          return 1571; /* *bswapv1tf */

        case 7:
          if (!
#line 3360 "../../gcc/config/s390/vector.md"
(TARGET_VXE2))
            return -1;
          return 1572; /* *bswapti */

        case 8:
          if (!
#line 3360 "../../gcc/config/s390/vector.md"
(TARGET_VXE2))
            return -1;
          return 1573; /* *bswaptf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_114 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x2))
    {
    case CLOBBER:
      x3 = XVECEXP (x1, 0, 1);
      switch (GET_CODE (x3))
        {
        case CLOBBER:
          x4 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x4) != SET)
            return -1;
          x5 = XEXP (x4, 1);
          if (GET_CODE (x5) != COMPARE
              || GET_MODE (x5) != E_CCUmode)
            return -1;
          x6 = XEXP (x5, 0);
          if (GET_CODE (x6) != MEM
              || GET_MODE (x6) != E_BLKmode)
            return -1;
          x7 = XEXP (x5, 1);
          if (GET_CODE (x7) != MEM
              || GET_MODE (x7) != E_BLKmode)
            return -1;
          x8 = XEXP (x4, 0);
          if (GET_CODE (x8) != REG
              || REGNO (x8) != 33
              || GET_MODE (x8) != E_CCUmode)
            return -1;
          x9 = XVECEXP (x1, 0, 3);
          if (pattern97 (x9, 
E_SImode, 
0, 
USE) != 0)
            return -1;
          x10 = XEXP (x2, 0);
          operands[0] = x10;
          x11 = XEXP (x3, 0);
          operands[1] = x11;
          x12 = XEXP (x6, 0);
          operands[2] = x12;
          x13 = XEXP (x7, 0);
          operands[3] = x13;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (pattern292 (
E_DImode) != 0
                  || !
#line 778 "../../gcc/config/s390/s390.md"
(TARGET_64BIT))
                return -1;
              return 1888; /* *cmpstrdi */

            case E_SImode:
              if (pattern292 (
E_SImode) != 0
                  || !
#line 778 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT))
                return -1;
              return 1889; /* *cmpstrsi */

            default:
              return -1;
            }

        case SET:
          x11 = XEXP (x3, 0);
          if (GET_CODE (x11) != MEM
              || GET_MODE (x11) != E_BLKmode)
            return -1;
          x9 = XVECEXP (x1, 0, 3);
          if (pattern97 (x9, 
E_CCmode, 
33, 
CLOBBER) != 0)
            return -1;
          switch (pattern126 (x1))
            {
            case 0:
              if (!
#line 778 "../../gcc/config/s390/s390.md"
(TARGET_64BIT))
                return -1;
              return 1890; /* *movstr */

            case 1:
              if (!
#line 778 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT))
                return -1;
              return 1891; /* *movstr */

            case 2:
              if (!(
#line 3958 "../../gcc/config/s390/s390.md"
(TARGET_64BIT || !TARGET_ZARCH) && 
#line 778 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
                return -1;
              return 1908; /* *setmem_long */

            case 3:
              if (!(
#line 3958 "../../gcc/config/s390/s390.md"
(TARGET_64BIT || !TARGET_ZARCH) && 
#line 778 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
                return -1;
              return 1909; /* *setmem_long */

            case 4:
              if (!
#line 3986 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT && TARGET_ZARCH))
                return -1;
              return 1912; /* *setmem_long_31z */

            case 5:
              if (!(
#line 3971 "../../gcc/config/s390/s390.md"
((TARGET_64BIT || !TARGET_ZARCH)) && 
#line 778 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
                return -1;
              return 1910; /* *setmem_long_and */

            case 6:
              if (!(
#line 3971 "../../gcc/config/s390/s390.md"
((TARGET_64BIT || !TARGET_ZARCH)) && 
#line 778 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
                return -1;
              return 1911; /* *setmem_long_and */

            case 7:
              if (!
#line 3998 "../../gcc/config/s390/s390.md"
((!TARGET_64BIT && TARGET_ZARCH)))
                return -1;
              return 1913; /* *setmem_long_and_31z */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SET:
      x9 = XVECEXP (x1, 0, 3);
      if (GET_CODE (x9) != CLOBBER)
        return -1;
      x14 = XEXP (x2, 1);
      switch (GET_CODE (x14))
        {
        case SUBREG:
        case MEM:
          if (pattern74 (x1) != 0)
            return -1;
          switch (pattern194 (x1))
            {
            case 0:
              if (!(
#line 3594 "../../gcc/config/s390/s390.md"
((GET_MODE (operands[2]) == Pmode || GET_MODE (operands[2]) == VOIDmode)) && 
#line 778 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
                return -1;
              return 1892; /* *cpymem_short */

            case 1:
              if (!(
#line 3594 "../../gcc/config/s390/s390.md"
((GET_MODE (operands[2]) == Pmode || GET_MODE (operands[2]) == VOIDmode)) && 
#line 778 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
                return -1;
              return 1893; /* *cpymem_short */

            default:
              return -1;
            }

        case COMPARE:
          if (pattern73 (x1) != 0)
            return -1;
          switch (pattern194 (x1))
            {
            case 0:
              if (!(
#line 4043 "../../gcc/config/s390/s390.md"
((GET_MODE (operands[2]) == Pmode || GET_MODE (operands[2]) == VOIDmode)) && 
#line 778 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
                return -1;
              return 1914; /* *cmpmem_short */

            case 1:
              if (!(
#line 4043 "../../gcc/config/s390/s390.md"
((GET_MODE (operands[2]) == Pmode || GET_MODE (operands[2]) == VOIDmode)) && 
#line 778 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
                return -1;
              return 1915; /* *cmpmem_short */

            default:
              return -1;
            }

        case FLOAT_TRUNCATE:
          switch (pattern75 (x1))
            {
            case 0:
              if (!(
#line 5894 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 758 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              return 2148; /* *trunctftd2 */

            case 1:
              if (!(
#line 5894 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 758 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              return 2149; /* *truncfprx2td2 */

            case 2:
              if (!
#line 5894 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 2150; /* *truncdftd2 */

            case 3:
              if (!
#line 5894 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 2151; /* *truncsftd2 */

            case 4:
              if (!(
#line 5894 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 758 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              return 2152; /* *trunctfdd2 */

            case 5:
              if (!(
#line 5894 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 758 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              return 2153; /* *truncfprx2dd2 */

            case 6:
              if (!
#line 5894 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 2154; /* *truncdfdd2 */

            case 7:
              if (!
#line 5894 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 2155; /* *truncsfdd2 */

            case 8:
              if (!(
#line 5894 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 758 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              return 2156; /* *trunctfsd2 */

            case 9:
              if (!(
#line 5894 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 758 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              return 2157; /* *truncfprx2sd2 */

            case 10:
              if (!
#line 5894 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 2158; /* *truncdfsd2 */

            case 11:
              if (!
#line 5894 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 2159; /* *truncsfsd2 */

            case 12:
              if (!(
#line 5903 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 758 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              return 2160; /* *trunctdtf2 */

            case 13:
              if (!(
#line 5903 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 758 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              return 2164; /* *truncddtf2 */

            case 14:
              if (!(
#line 5903 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 758 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              return 2168; /* *truncsdtf2 */

            case 15:
              if (!(
#line 5903 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 758 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              return 2161; /* *trunctdfprx22 */

            case 16:
              if (!(
#line 5903 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 758 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              return 2165; /* *truncddfprx22 */

            case 17:
              if (!(
#line 5903 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 758 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              return 2169; /* *truncsdfprx22 */

            case 18:
              if (!
#line 5903 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 2162; /* *trunctddf2 */

            case 19:
              if (!
#line 5903 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 2166; /* *truncdddf2 */

            case 20:
              if (!
#line 5903 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 2170; /* *truncsddf2 */

            case 21:
              if (!
#line 5903 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 2163; /* *trunctdsf2 */

            case 22:
              if (!
#line 5903 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 2167; /* *truncddsf2 */

            case 23:
              if (!
#line 5903 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 2171; /* *truncsdsf2 */

            default:
              return -1;
            }

        case FLOAT_EXTEND:
          switch (pattern75 (x1))
            {
            case 0:
              if (!(
#line 5968 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 758 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              return 2172; /* *extendtftd2 */

            case 1:
              if (!(
#line 5968 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 758 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              return 2173; /* *extendfprx2td2 */

            case 2:
              if (!
#line 5968 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 2174; /* *extenddftd2 */

            case 3:
              if (!
#line 5968 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 2175; /* *extendsftd2 */

            case 4:
              if (!(
#line 5968 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 758 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              return 2176; /* *extendtfdd2 */

            case 5:
              if (!(
#line 5968 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 758 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              return 2177; /* *extendfprx2dd2 */

            case 6:
              if (!
#line 5968 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 2178; /* *extenddfdd2 */

            case 7:
              if (!
#line 5968 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 2179; /* *extendsfdd2 */

            case 8:
              if (!(
#line 5968 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 758 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              return 2180; /* *extendtfsd2 */

            case 9:
              if (!(
#line 5968 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 758 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              return 2181; /* *extendfprx2sd2 */

            case 10:
              if (!
#line 5968 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 2182; /* *extenddfsd2 */

            case 11:
              if (!
#line 5968 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 2183; /* *extendsfsd2 */

            case 12:
              if (!(
#line 5976 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 758 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              return 2184; /* *extendtdtf2 */

            case 13:
              if (!(
#line 5976 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 758 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              return 2188; /* *extendddtf2 */

            case 14:
              if (!(
#line 5976 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 758 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              return 2192; /* *extendsdtf2 */

            case 15:
              if (!(
#line 5976 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 758 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              return 2185; /* *extendtdfprx22 */

            case 16:
              if (!(
#line 5976 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 758 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              return 2189; /* *extendddfprx22 */

            case 17:
              if (!(
#line 5976 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 758 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              return 2193; /* *extendsdfprx22 */

            case 18:
              if (!
#line 5976 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 2186; /* *extendtddf2 */

            case 19:
              if (!
#line 5976 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 2190; /* *extenddddf2 */

            case 20:
              if (!
#line 5976 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 2194; /* *extendsddf2 */

            case 21:
              if (!
#line 5976 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 2187; /* *extendtdsf2 */

            case 22:
              if (!
#line 5976 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 2191; /* *extendddsf2 */

            case 23:
              if (!
#line 5976 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
                return -1;
              return 2195; /* *extendsdsf2 */

            default:
              return -1;
            }

        case IF_THEN_ELSE:
          switch (pattern78 (x1))
            {
            case 0:
              if (!
#line 10071 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                return -1;
              return 2541; /* *brxg_64bit */

            case 1:
              if (!
#line 10157 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
                return -1;
              return 2543; /* *brx_31bit */

            case 2:
              if (!
#line 10114 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                return -1;
              return 2542; /* *brx_64bit */

            case 3:
              return 2544; /* doloop_si64 */

            case 4:
              if (!
#line 10255 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                return -1;
              return 2545; /* doloop_di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_5 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  switch (pattern9 (x1))
    {
    case 0:
      if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_147 (insn, operands);

    case 1:
      if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_156 (insn, operands);

    case 2:
      if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_165 (insn, operands);

    case 3:
      if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_174 (insn, operands);

    case 4:
      if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_183 (insn, operands);

    case 5:
      if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_192 (insn, operands);

    case 6:
      if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_201 (insn, operands);

    case 7:
      if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_210 (insn, operands);

    case 8:
      if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_219 (insn, operands);

    case 9:
      if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_228 (insn, operands);

    case 10:
      if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_237 (insn, operands);

    case 11:
      if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_246 (insn, operands);

    case 12:
      if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_255 (insn, operands);

    case 13:
      if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_264 (insn, operands);

    case 14:
      if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_273 (insn, operands);

    case 15:
      if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_282 (insn, operands);

    case 16:
      if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_148 (insn, operands);

    case 17:
      if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_157 (insn, operands);

    case 18:
      if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_166 (insn, operands);

    case 19:
      if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_175 (insn, operands);

    case 20:
      if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_184 (insn, operands);

    case 21:
      if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_193 (insn, operands);

    case 22:
      if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_202 (insn, operands);

    case 23:
      if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_211 (insn, operands);

    case 24:
      if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_220 (insn, operands);

    case 25:
      if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_229 (insn, operands);

    case 26:
      if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_238 (insn, operands);

    case 27:
      if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_247 (insn, operands);

    case 28:
      if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_256 (insn, operands);

    case 29:
      if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_265 (insn, operands);

    case 30:
      if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_274 (insn, operands);

    case 31:
      if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_283 (insn, operands);

    case 32:
      if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_149 (insn, operands);

    case 33:
      if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_158 (insn, operands);

    case 34:
      if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_167 (insn, operands);

    case 35:
      if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_176 (insn, operands);

    case 36:
      if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_185 (insn, operands);

    case 37:
      if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_194 (insn, operands);

    case 38:
      if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_203 (insn, operands);

    case 39:
      if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_212 (insn, operands);

    case 40:
      if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_221 (insn, operands);

    case 41:
      if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_230 (insn, operands);

    case 42:
      if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_239 (insn, operands);

    case 43:
      if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_248 (insn, operands);

    case 44:
      if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_257 (insn, operands);

    case 45:
      if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_266 (insn, operands);

    case 46:
      if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_275 (insn, operands);

    case 47:
      if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
        return NULL;
      return gen_split_284 (insn, operands);

    default:
      return NULL;
    }
}
