/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern3 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V1QImode:
      return pattern0 (x3, 
E_V1QImode); /* [-1, 0] */

    case E_V2QImode:
      if (pattern0 (x3, 
E_V2QImode) != 0)
        return -1;
      return 1;

    case E_V4QImode:
      if (pattern0 (x3, 
E_V4QImode) != 0)
        return -1;
      return 2;

    case E_V8QImode:
      if (pattern0 (x3, 
E_V8QImode) != 0)
        return -1;
      return 3;

    case E_V16QImode:
      if (pattern0 (x3, 
E_V16QImode) != 0)
        return -1;
      return 4;

    case E_V1HImode:
      if (pattern0 (x3, 
E_V1HImode) != 0)
        return -1;
      return 5;

    case E_V2HImode:
      if (pattern0 (x3, 
E_V2HImode) != 0)
        return -1;
      return 6;

    case E_V4HImode:
      if (pattern0 (x3, 
E_V4HImode) != 0)
        return -1;
      return 7;

    case E_V8HImode:
      if (pattern0 (x3, 
E_V8HImode) != 0)
        return -1;
      return 8;

    case E_V1SImode:
      if (pattern0 (x3, 
E_V1SImode) != 0)
        return -1;
      return 9;

    case E_V2SImode:
      if (pattern0 (x3, 
E_V2SImode) != 0)
        return -1;
      return 10;

    case E_V4SImode:
      if (pattern0 (x3, 
E_V4SImode) != 0)
        return -1;
      return 11;

    case E_V1DImode:
      if (pattern0 (x3, 
E_V1DImode) != 0)
        return -1;
      return 12;

    case E_V2DImode:
      if (pattern0 (x3, 
E_V2DImode) != 0)
        return -1;
      return 13;

    case E_V1TImode:
      if (pattern0 (x3, 
E_V1TImode) != 0)
        return -1;
      return 14;

    case E_TImode:
      if (pattern0 (x3, 
E_TImode) != 0)
        return -1;
      return 15;

    case E_V4SFmode:
      if (pattern0 (x3, 
E_V4SFmode) != 0)
        return -1;
      return 16;

    case E_V2DFmode:
      if (pattern0 (x3, 
E_V2DFmode) != 0)
        return -1;
      return 17;

    case E_V1TFmode:
      if (pattern0 (x3, 
E_V1TFmode) != 0)
        return -1;
      return 18;

    case E_TFmode:
      if (pattern0 (x3, 
E_TFmode) != 0)
        return -1;
      return 19;

    default:
      return -1;
    }
}

int
pattern26 (rtx x1, int i1, int i2, int i3, int i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V4SFmode)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != VEC_SELECT
      || GET_MODE (x3) != E_V4HImode)
    return -1;
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != PARALLEL
      || XVECLEN (x4, 0) != 4)
    return -1;
  x5 = XVECEXP (x4, 0, 0);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + i4])
    return -1;
  x6 = XVECEXP (x4, 0, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + i3])
    return -1;
  x7 = XVECEXP (x4, 0, 2);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + i2])
    return -1;
  x8 = XVECEXP (x4, 0, 3);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  x9 = XEXP (x1, 0);
  operands[0] = x9;
  if (!register_operand (operands[0], E_V4SFmode))
    return -1;
  x10 = XEXP (x3, 0);
  operands[1] = x10;
  if (!register_operand (operands[1], E_V8HImode))
    return -1;
  x11 = XVECEXP (x2, 0, 1);
  operands[2] = x11;
  if (!const_mask_operand (operands[2], E_QImode))
    return -1;
  return 0;
}

int
pattern33 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x2, 0);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern32 (x1, 
E_V8HImode, 
E_V8QImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern32 (x1, 
E_V4SImode, 
E_V4HImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern32 (x1, 
E_V2DImode, 
E_V2SImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern40 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 33
      || GET_MODE (x5) != E_CCmode)
    return -1;
  x6 = XEXP (x2, 0);
  operands[0] = x6;
  if (!register_operand (operands[0], E_DImode))
    return -1;
  x7 = XEXP (x3, 0);
  operands[1] = x7;
  if (!register_operand (operands[1], E_DImode))
    return -1;
  return 0;
}

int
pattern49 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x1) != E_V4SFmode
          || !register_operand (operands[1], E_V4SFmode))
        return -1;
      return 0;

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x1) != E_V2DFmode
          || !register_operand (operands[1], E_V2DFmode))
        return -1;
      return 1;

    case E_V1TFmode:
      if (!register_operand (operands[0], E_V1TFmode)
          || GET_MODE (x1) != E_V1TFmode
          || !register_operand (operands[1], E_V1TFmode))
        return -1;
      return 2;

    case E_TFmode:
      if (!register_operand (operands[0], E_TFmode)
          || GET_MODE (x1) != E_TFmode
          || !register_operand (operands[1], E_TFmode))
        return -1;
      return 3;

    case E_FPRX2mode:
      if (!register_operand (operands[0], E_FPRX2mode)
          || GET_MODE (x1) != E_FPRX2mode
          || !register_operand (operands[1], E_FPRX2mode))
        return -1;
      return 4;

    case E_DFmode:
      if (!register_operand (operands[0], E_DFmode)
          || GET_MODE (x1) != E_DFmode
          || !register_operand (operands[1], E_DFmode))
        return -1;
      return 5;

    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x1) != E_SFmode
          || !register_operand (operands[1], E_SFmode))
        return -1;
      return 6;

    case E_TDmode:
      if (!register_operand (operands[0], E_TDmode)
          || GET_MODE (x1) != E_TDmode
          || !register_operand (operands[1], E_TDmode))
        return -1;
      return 7;

    case E_DDmode:
      if (!register_operand (operands[0], E_DDmode)
          || GET_MODE (x1) != E_DDmode
          || !register_operand (operands[1], E_DDmode))
        return -1;
      return 8;

    default:
      return -1;
    }
}

int
pattern72 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 33
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  if (!s_operand (operands[1], E_QImode))
    return -1;
  x8 = XEXP (x6, 1);
  operands[2] = x8;
  if (!nonzero_shift_count_operand (operands[2], E_VOIDmode))
    return -1;
  return pattern71 (x6); /* [-1, 1] */
}

int
pattern80 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode
          || !register_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern87 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_DFmode:
      if (!nonimmediate_operand (operands[1], E_DFmode))
        return -1;
      return 0;

    case E_SFmode:
      if (!nonimmediate_operand (operands[1], E_SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern95 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  x5 = XEXP (x1, 1);
  operands[3] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      return pattern94 (x1, 
E_DImode); /* [-1, 0] */

    case E_SImode:
      if (pattern94 (x1, 
E_SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern101 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  x4 = XEXP (x2, 1);
  operands[4] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V1QImode:
      return pattern99 (x1, 
E_V1QImode); /* [-1, 0] */

    case E_V2QImode:
      if (pattern99 (x1, 
E_V2QImode) != 0)
        return -1;
      return 1;

    case E_V4QImode:
      if (pattern99 (x1, 
E_V4QImode) != 0)
        return -1;
      return 2;

    case E_V8QImode:
      if (pattern99 (x1, 
E_V8QImode) != 0)
        return -1;
      return 3;

    case E_V16QImode:
      if (pattern99 (x1, 
E_V16QImode) != 0)
        return -1;
      return 4;

    case E_V1HImode:
      if (pattern99 (x1, 
E_V1HImode) != 0)
        return -1;
      return 5;

    case E_V2HImode:
      if (pattern99 (x1, 
E_V2HImode) != 0)
        return -1;
      return 6;

    case E_V4HImode:
      if (pattern99 (x1, 
E_V4HImode) != 0)
        return -1;
      return 7;

    case E_V8HImode:
      if (pattern99 (x1, 
E_V8HImode) != 0)
        return -1;
      return 8;

    case E_V1SImode:
      if (pattern99 (x1, 
E_V1SImode) != 0)
        return -1;
      return 9;

    case E_V2SImode:
      if (pattern99 (x1, 
E_V2SImode) != 0)
        return -1;
      return 10;

    case E_V4SImode:
      if (pattern99 (x1, 
E_V4SImode) != 0)
        return -1;
      return 11;

    case E_V1DImode:
      if (pattern99 (x1, 
E_V1DImode) != 0)
        return -1;
      return 12;

    case E_V2DImode:
      if (pattern99 (x1, 
E_V2DImode) != 0)
        return -1;
      return 13;

    case E_V1SFmode:
      if (pattern100 (x1, 
E_V1SFmode, 
E_V1SImode) != 0)
        return -1;
      return 14;

    case E_V2SFmode:
      if (pattern100 (x1, 
E_V2SFmode, 
E_V2SImode) != 0)
        return -1;
      return 15;

    case E_V4SFmode:
      if (pattern100 (x1, 
E_V4SFmode, 
E_V4SImode) != 0)
        return -1;
      return 16;

    case E_V1DFmode:
      if (pattern100 (x1, 
E_V1DFmode, 
E_V1DImode) != 0)
        return -1;
      return 17;

    case E_V2DFmode:
      if (pattern100 (x1, 
E_V2DFmode, 
E_V2DImode) != 0)
        return -1;
      return 18;

    default:
      return -1;
    }
}

int
pattern133 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern137 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern143 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_CCRAWmode)
    return -1;
  x4 = XEXP (x2, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 33
      || GET_MODE (x4) != E_CCRAWmode)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != SET)
    return -1;
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != UNSPEC
      || XVECLEN (x6, 0) != 2
      || XINT (x6, 1) != i1)
    return -1;
  x7 = XEXP (x5, 0);
  operands[0] = x7;
  x8 = XVECEXP (x6, 0, 0);
  if (!rtx_equal_p (x8, operands[1]))
    return -1;
  x9 = XVECEXP (x6, 0, 1);
  if (!rtx_equal_p (x9, operands[2]))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V8HImode:
      return pattern142 (x6, 
E_V16QImode, 
E_V8HImode); /* [-1, 0] */

    case E_V4SImode:
      if (pattern142 (x6, 
E_V8HImode, 
E_V4SImode) != 0)
        return -1;
      return 1;

    case E_V2DImode:
      if (pattern142 (x6, 
E_V4SImode, 
E_V2DImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern153 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i2)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern158 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[2] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      return pattern64 (x1, 
E_DImode); /* [-1, 0] */

    case E_SImode:
      if (pattern64 (x1, 
E_SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern165 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != VEC_SELECT
      || GET_MODE (x5) != i3)
    return -1;
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != PARALLEL
      || XVECLEN (x6, 0) != 1
      || GET_MODE (x3) != i2)
    return -1;
  x7 = XEXP (x5, 0);
  operands[1] = x7;
  if (!register_operand (operands[1], i1))
    return -1;
  x8 = XVECEXP (x6, 0, 0);
  operands[3] = x8;
  if (!const_mask_operand (operands[3], E_QImode)
      || !address_operand (operands[2], E_SImode))
    return -1;
  x9 = XEXP (x1, 1);
  x10 = XEXP (x9, 1);
  x11 = XVECEXP (x10, 0, 0);
  if (!rtx_equal_p (x11, operands[3]))
    return -1;
  return 0;
}

int
pattern176 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern180 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_DImode
      || !register_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  return 0;
}

int
pattern185 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i2
      || !memory_operand (operands[1], i2)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern191 (rtx x1, rtx_code i1, rtx_code i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x2))
    {
    case SET:
      x3 = XEXP (x2, 1);
      if (GET_CODE (x3) != i2)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != i1)
        return -1;
      x5 = XEXP (x2, 0);
      operands[0] = x5;
      x6 = XEXP (x4, 0);
      if (!rtx_equal_p (x6, operands[1]))
        return -1;
      return 0;

    case CLOBBER:
      x5 = XEXP (x2, 0);
      operands[0] = x5;
      x7 = XVECEXP (x1, 0, 0);
      x8 = XEXP (x7, 1);
      x9 = XEXP (x8, 0);
      switch (GET_MODE (x9))
        {
        case E_DImode:
          return 1;

        case E_SImode:
          return 2;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern202 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !const_int_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1)
      || !nonzero_shift_count_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern212 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 1
      || XINT (x3, 1) != 4
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  x7 = XVECEXP (x6, 0, 0);
  operands[1] = x7;
  if (!register_operand (operands[1], E_CCUmode))
    return -1;
  return 0;
}

int
pattern222 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i2))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  return 0;
}

int
pattern233 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !loc_operand (operands[3], i1)
      || !loc_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern239 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_MODE (x4))
    {
    case E_DImode:
      if (!register_operand (operands[1], E_DImode)
          || !register_operand (operands[0], E_DImode))
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      x6 = XEXP (x5, 1);
      if (GET_MODE (x6) != E_DImode)
        return -1;
      return 0;

    case E_SImode:
      if (!register_operand (operands[1], E_SImode)
          || !register_operand (operands[0], E_SImode))
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      x6 = XEXP (x5, 1);
      if (GET_MODE (x6) != E_SImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern252 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1)
      || !general_operand (operands[2], i1)
      || !register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern259 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !nonzero_shift_count_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !nonimmediate_operand (operands[3], i1)
      || !nonzero_shift_count_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern269 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x6 = XEXP (x5, 1);
  if (GET_MODE (x6) != i1
      || !nonimmediate_operand (operands[2], i2))
    return -1;
  x7 = XEXP (x1, 1);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) != i2)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_MODE (x9) != i1)
    return -1;
  x10 = XEXP (x9, 1);
  if (GET_MODE (x10) != i1)
    return -1;
  return 0;
}

int
pattern285 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i2
      || !nonimmediate_operand (operands[2], i1))
    return -1;
  x6 = XEXP (x3, 1);
  if (GET_MODE (x6) != i2)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i1
      || !register_operand (operands[0], i1))
    return -1;
  x8 = XVECEXP (x1, 0, 1);
  x9 = XEXP (x8, 1);
  if (GET_MODE (x9) != i1)
    return -1;
  return 0;
}

int
pattern299 (rtx x1, unsigned int i1, machine_mode i2, unsigned int i3, unsigned int i4, unsigned int i5)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 9);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XVECEXP (x1, 0, 10);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != i5
      || GET_MODE (x5) != i2)
    return -1;
  x6 = XVECEXP (x1, 0, 11);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != i4
      || GET_MODE (x7) != i2)
    return -1;
  x8 = XVECEXP (x1, 0, 12);
  if (GET_CODE (x8) != CLOBBER)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != REG
      || REGNO (x9) != i3
      || GET_MODE (x9) != i2)
    return -1;
  x10 = XVECEXP (x1, 0, 13);
  if (GET_CODE (x10) != CLOBBER)
    return -1;
  x11 = XEXP (x10, 0);
  if (GET_CODE (x11) != REG
      || REGNO (x11) != i1)
    return -1;
  return 0;
}

 int
recog_9 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern28 (x1))
    {
    case 0:
      if (!
#line 1745 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1199; /* vec_widen_smult_odd_v1qi */

    case 1:
      if (!
#line 1745 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1200; /* vec_widen_smult_odd_v2qi */

    case 2:
      if (!
#line 1745 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1201; /* vec_widen_smult_odd_v4qi */

    case 3:
      if (!
#line 1745 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1202; /* vec_widen_smult_odd_v8qi */

    case 4:
      if (!
#line 1745 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1203; /* vec_widen_smult_odd_v16qi */

    case 5:
      if (!
#line 1745 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1204; /* vec_widen_smult_odd_v1hi */

    case 6:
      if (!
#line 1745 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1205; /* vec_widen_smult_odd_v2hi */

    case 7:
      if (!
#line 1745 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1206; /* vec_widen_smult_odd_v4hi */

    case 8:
      if (!
#line 1745 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1207; /* vec_widen_smult_odd_v8hi */

    case 9:
      if (!
#line 1745 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1208; /* vec_widen_smult_odd_v1si */

    case 10:
      if (!
#line 1745 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1209; /* vec_widen_smult_odd_v2si */

    case 11:
      if (!
#line 1745 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1210; /* vec_widen_smult_odd_v4si */

    case 12:
      if (!
#line 1745 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1211; /* vec_widen_smult_odd_v1di */

    case 13:
      if (!(
#line 1745 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 71 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
        return -1;
      return 1212; /* vec_widen_smult_odd_v2di */

    default:
      return -1;
    }
}

 int
recog_15 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  x4 = XVECEXP (x2, 0, 1);
  operands[2] = x4;
  if (!const_mask_operand (operands[2], E_QImode))
    return -1;
  x5 = XVECEXP (x2, 0, 2);
  operands[3] = x5;
  if (!const_mask_operand (operands[3], E_QImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V1SFmode:
      if (!register_operand (operands[0], E_V1SFmode)
          || GET_MODE (x2) != E_V1SFmode
          || !register_operand (operands[1], E_V1SFmode)
          || !(
#line 1843 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 74 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      return 396; /* vec_fpintv1sf */

    case E_V2SFmode:
      if (!register_operand (operands[0], E_V2SFmode)
          || GET_MODE (x2) != E_V2SFmode
          || !register_operand (operands[1], E_V2SFmode)
          || !(
#line 1843 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 74 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      return 397; /* vec_fpintv2sf */

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x2) != E_V4SFmode
          || !register_operand (operands[1], E_V4SFmode)
          || !(
#line 1843 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 74 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      return 398; /* vec_fpintv4sf */

    case E_V1DFmode:
      if (!register_operand (operands[0], E_V1DFmode)
          || GET_MODE (x2) != E_V1DFmode
          || !register_operand (operands[1], E_V1DFmode)
          || !
#line 1843 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 399; /* vec_fpintv1df */

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x2) != E_V2DFmode
          || !register_operand (operands[1], E_V2DFmode)
          || !
#line 1843 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 400; /* vec_fpintv2df */

    case E_V1TFmode:
      if (!register_operand (operands[0], E_V1TFmode)
          || GET_MODE (x2) != E_V1TFmode
          || !register_operand (operands[1], E_V1TFmode)
          || !(
#line 1843 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 76 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      return 401; /* vec_fpintv1tf */

    case E_TFmode:
      if (!register_operand (operands[0], E_TFmode)
          || GET_MODE (x2) != E_TFmode
          || !register_operand (operands[1], E_TFmode)
          || !(
#line 1843 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 76 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      return 402; /* vec_fpinttf */

    default:
      return -1;
    }
}

 int
recog_25 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      res = recog_24 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      switch (GET_MODE (x4))
        {
        case E_DImode:
          if (!general_operand (x3, E_DImode))
            return -1;
          operands[1] = x3;
          operands[0] = x4;
          if (nonimmediate_operand (operands[0], E_DImode))
            {
              if (
#line 1271 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCTmode) && TARGET_ZARCH))
                return 1763; /* *cmpdi_cct */
              if ((
#line 1359 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return 1770; /* *cmpdi_ccs */
              if (
#line 1424 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCUmode) && TARGET_ZARCH))
                return 1776; /* *cmpdi_ccu */
            }
          if (pnum_clobbers == NULL)
            return -1;
          operands[2] = x3;
          operands[1] = x4;
          if (!register_operand (operands[1], E_DImode)
              || !(
#line 6869 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL3mode)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 2263; /* *subdi3_cconly2 */

        case E_SImode:
          if (!general_operand (x3, E_SImode))
            return -1;
          operands[1] = x3;
          operands[0] = x4;
          if (nonimmediate_operand (operands[0], E_SImode))
            {
              if (
#line 1285 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCTmode)))
                return 1764; /* *cmpsi_cct */
              if (
#line 1359 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode)))
                return 1771; /* *cmpsi_ccs */
              if (
#line 1443 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCUmode)))
                return 1777; /* *cmpsi_ccu */
            }
          if (pnum_clobbers == NULL)
            return -1;
          operands[2] = x3;
          operands[1] = x4;
          if (!register_operand (operands[1], E_SImode)
              || !
#line 6869 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL3mode)))
            return -1;
          *pnum_clobbers = 1;
          return 2264; /* *subsi3_cconly2 */

        case E_HImode:
          operands[0] = x4;
          if (!nonimmediate_operand (operands[0], E_HImode))
            return -1;
          operands[1] = x3;
          if (!general_operand (operands[1], E_HImode)
              || !
#line 1463 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCUmode)
   && !register_operand (operands[1], HImode)))
            return -1;
          return 1778; /* *cmphi_ccu */

        case E_QImode:
          operands[0] = x4;
          if (!nonimmediate_operand (operands[0], E_QImode))
            return -1;
          operands[1] = x3;
          if (!general_operand (operands[1], E_QImode)
              || !
#line 1479 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCUmode)
   && !register_operand (operands[1], QImode)))
            return -1;
          return 1779; /* *cmpqi_ccu */

        case E_TFmode:
          operands[0] = x4;
          if (!register_operand (operands[0], E_TFmode))
            return -1;
          operands[1] = x3;
          if (general_operand (operands[1], E_TFmode)
              && (
#line 1585 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 751 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return 1793; /* *cmptf_ccs */
          if (register_operand (operands[1], E_TFmode)
              && 
#line 1600 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode) && TARGET_VXE))
            return 1799; /* *cmptf_ccs */
          if (general_operand (operands[1], E_TFmode)
              && (
#line 1611 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSFPSmode) && TARGET_HARD_FLOAT) && 
#line 751 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return 1800; /* *cmptf_ccsfps */
          if (!register_operand (operands[1], E_TFmode)
              || !
#line 1626 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSFPSmode) && TARGET_VXE))
            return -1;
          return 1806; /* *cmptf_ccsfps */

        case E_FPRX2mode:
          operands[0] = x4;
          if (!register_operand (operands[0], E_FPRX2mode))
            return -1;
          operands[1] = x3;
          if (!general_operand (operands[1], E_FPRX2mode))
            return -1;
          if ((
#line 1585 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 751 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return 1794; /* *cmpfprx2_ccs */
          if (!(
#line 1611 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSFPSmode) && TARGET_HARD_FLOAT) && 
#line 751 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          return 1801; /* *cmpfprx2_ccsfps */

        case E_DFmode:
          operands[0] = x4;
          if (!register_operand (operands[0], E_DFmode))
            return -1;
          operands[1] = x3;
          if (!general_operand (operands[1], E_DFmode))
            return -1;
          if (
#line 1585 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode) && TARGET_HARD_FLOAT))
            return 1795; /* *cmpdf_ccs */
          if (!
#line 1611 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSFPSmode) && TARGET_HARD_FLOAT))
            return -1;
          return 1802; /* *cmpdf_ccsfps */

        case E_SFmode:
          operands[0] = x4;
          if (!register_operand (operands[0], E_SFmode))
            return -1;
          operands[1] = x3;
          if (!general_operand (operands[1], E_SFmode))
            return -1;
          if (
#line 1585 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode) && TARGET_HARD_FLOAT))
            return 1796; /* *cmpsf_ccs */
          if (!
#line 1611 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSFPSmode) && TARGET_HARD_FLOAT))
            return -1;
          return 1803; /* *cmpsf_ccsfps */

        case E_TDmode:
          operands[0] = x4;
          if (!register_operand (operands[0], E_TDmode))
            return -1;
          operands[1] = x3;
          if (!general_operand (operands[1], E_TDmode))
            return -1;
          if ((
#line 1585 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 752 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return 1797; /* *cmptd_ccs */
          if (!(
#line 1611 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSFPSmode) && TARGET_HARD_FLOAT) && 
#line 752 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          return 1804; /* *cmptd_ccsfps */

        case E_DDmode:
          operands[0] = x4;
          if (!register_operand (operands[0], E_DDmode))
            return -1;
          operands[1] = x3;
          if (!general_operand (operands[1], E_DDmode))
            return -1;
          if ((
#line 1585 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 752 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return 1798; /* *cmpdd_ccs */
          if (!(
#line 1611 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSFPSmode) && TARGET_HARD_FLOAT) && 
#line 752 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          return 1805; /* *cmpdd_ccsfps */

        default:
          return -1;
        }

    case NEG:
      if (pnum_clobbers == NULL)
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x5 = XEXP (x3, 0);
      operands[2] = x5;
      switch (GET_MODE (operands[1]))
        {
        case E_DImode:
          if (!nonimmediate_operand (operands[1], E_DImode)
              || GET_MODE (x3) != E_DImode
              || !general_operand (operands[2], E_DImode)
              || !(
#line 6361 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCLmode)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 2217; /* *adddi3_cconly2 */

        case E_SImode:
          if (!nonimmediate_operand (operands[1], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !general_operand (operands[2], E_SImode)
              || !
#line 6361 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCLmode)))
            return -1;
          *pnum_clobbers = 1;
          return 2218; /* *addsi3_cconly2 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_27 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  switch (GET_CODE (x5))
    {
    case ZERO_EXTEND:
      if (GET_MODE (x5) != E_DImode)
        return -1;
      x6 = XEXP (x2, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || GET_MODE (x3) != E_DImode
          || !register_operand (operands[1], E_DImode))
        return -1;
      x7 = XEXP (x5, 0);
      operands[2] = x7;
      if (!general_operand (operands[2], E_SImode)
          || !
#line 6686 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCLmode) && TARGET_ZARCH))
        return -1;
      *pnum_clobbers = 1;
      return 2247; /* *subdi3_zero_cconly */

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[2] = x5;
      x6 = XEXP (x2, 1);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          if (!rtx_equal_p (x6, operands[1]))
            return -1;
          switch (pattern188 (x3))
            {
            case 0:
              if (!(
#line 6800 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL2mode)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              *pnum_clobbers = 1;
              return 2255; /* *subdi3_borrow_cconly */

            case 1:
              if (!
#line 6800 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL2mode)))
                return -1;
              *pnum_clobbers = 1;
              return 2256; /* *subsi3_borrow_cconly */

            default:
              return -1;
            }

        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_DOUBLE:
        case CONST_VECTOR:
          if (x6 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
            {
              switch (pattern188 (x3))
                {
                case 0:
                  if ((
#line 6852 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCLmode)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    {
                      *pnum_clobbers = 1;
                      return 2261; /* *subdi3_cconly */
                    }
                  break;

                case 1:
                  if (
#line 6852 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCLmode)))
                    {
                      *pnum_clobbers = 1;
                      return 2262; /* *subsi3_cconly */
                    }
                  break;

                default:
                  break;
                }
            }
          operands[3] = x6;
          switch (GET_MODE (x3))
            {
            case E_TFmode:
              if (!nonimmediate_operand (operands[1], E_TFmode)
                  || !general_operand (operands[2], E_TFmode)
                  || !const0_operand (operands[3], E_TFmode)
                  || !(
#line 6971 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 751 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              *pnum_clobbers = 1;
              return 2280; /* *subtf3_cconly */

            case E_FPRX2mode:
              if (!nonimmediate_operand (operands[1], E_FPRX2mode)
                  || !general_operand (operands[2], E_FPRX2mode)
                  || !const0_operand (operands[3], E_FPRX2mode)
                  || !(
#line 6971 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 751 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              *pnum_clobbers = 1;
              return 2281; /* *subfprx23_cconly */

            case E_DFmode:
              if (!nonimmediate_operand (operands[1], E_DFmode)
                  || !general_operand (operands[2], E_DFmode)
                  || !const0_operand (operands[3], E_DFmode)
                  || !
#line 6971 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
                return -1;
              *pnum_clobbers = 1;
              return 2282; /* *subdf3_cconly */

            case E_SFmode:
              if (!nonimmediate_operand (operands[1], E_SFmode)
                  || !general_operand (operands[2], E_SFmode)
                  || !const0_operand (operands[3], E_SFmode)
                  || !
#line 6971 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
                return -1;
              *pnum_clobbers = 1;
              return 2283; /* *subsf3_cconly */

            case E_TDmode:
              if (!nonimmediate_operand (operands[1], E_TDmode)
                  || !general_operand (operands[2], E_TDmode)
                  || !const0_operand (operands[3], E_TDmode)
                  || !(
#line 6971 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 752 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
                return -1;
              *pnum_clobbers = 1;
              return 2284; /* *subtd3_cconly */

            case E_DDmode:
              if (!nonimmediate_operand (operands[1], E_DDmode)
                  || !general_operand (operands[2], E_DDmode)
                  || !const0_operand (operands[3], E_DDmode)
                  || !(
#line 6971 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 752 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
                return -1;
              *pnum_clobbers = 1;
              return 2285; /* *subdd3_cconly */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_36 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V1SImode:
      if (pattern108 (x3, 
E_V1SFmode, 
E_V1SImode) != 0)
        return -1;
      if (
#line 2324 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
        return 1396; /* *vec_cmpgev1sf_signaling_nocc */
      if (!(
#line 2332 "../../gcc/config/s390/vector.md"
(TARGET_NONSIGNALING_VECTOR_COMPARE_OK) && 
#line 74 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      return 1403; /* *vec_cmpgev1sf_signaling_finite_nocc */

    case E_V2SImode:
      if (pattern108 (x3, 
E_V2SFmode, 
E_V2SImode) != 0)
        return -1;
      if (
#line 2324 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
        return 1397; /* *vec_cmpgev2sf_signaling_nocc */
      if (!(
#line 2332 "../../gcc/config/s390/vector.md"
(TARGET_NONSIGNALING_VECTOR_COMPARE_OK) && 
#line 74 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      return 1404; /* *vec_cmpgev2sf_signaling_finite_nocc */

    case E_V4SImode:
      if (pattern108 (x3, 
E_V4SFmode, 
E_V4SImode) != 0)
        return -1;
      if (
#line 2324 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
        return 1398; /* *vec_cmpgev4sf_signaling_nocc */
      if (!(
#line 2332 "../../gcc/config/s390/vector.md"
(TARGET_NONSIGNALING_VECTOR_COMPARE_OK) && 
#line 74 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      return 1405; /* *vec_cmpgev4sf_signaling_finite_nocc */

    case E_V1DImode:
      if (pattern108 (x3, 
E_V1DFmode, 
E_V1DImode) != 0)
        return -1;
      if (
#line 2324 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
        return 1399; /* *vec_cmpgev1df_signaling_nocc */
      if (!
#line 2332 "../../gcc/config/s390/vector.md"
(TARGET_NONSIGNALING_VECTOR_COMPARE_OK))
        return -1;
      return 1406; /* *vec_cmpgev1df_signaling_finite_nocc */

    case E_V2DImode:
      if (pattern108 (x3, 
E_V2DFmode, 
E_V2DImode) != 0)
        return -1;
      if (
#line 2324 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
        return 1400; /* *vec_cmpgev2df_signaling_nocc */
      if (!
#line 2332 "../../gcc/config/s390/vector.md"
(TARGET_NONSIGNALING_VECTOR_COMPARE_OK))
        return -1;
      return 1407; /* *vec_cmpgev2df_signaling_finite_nocc */

    case E_V1TImode:
      if (pattern108 (x3, 
E_V1TFmode, 
E_V1TImode) != 0)
        return -1;
      if (
#line 2324 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
        return 1401; /* *vec_cmpgev1tf_signaling_nocc */
      if (!(
#line 2332 "../../gcc/config/s390/vector.md"
(TARGET_NONSIGNALING_VECTOR_COMPARE_OK) && 
#line 76 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      return 1408; /* *vec_cmpgev1tf_signaling_finite_nocc */

    case E_TImode:
      if (pattern108 (x3, 
E_TFmode, 
E_TImode) != 0)
        return -1;
      if (
#line 2324 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
        return 1402; /* *vec_cmpgetf_signaling_nocc */
      if (!(
#line 2332 "../../gcc/config/s390/vector.md"
(TARGET_NONSIGNALING_VECTOR_COMPARE_OK) && 
#line 76 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      return 1409; /* *vec_cmpgetf_signaling_finite_nocc */

    default:
      return -1;
    }
}

 int
recog_40 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  operands[1] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (!nonimmediate_operand (operands[0], E_V16QImode)
          || !general_operand (operands[1], E_V16QImode))
        return -1;
      return 521; /* movv16qi */

    case E_V8HImode:
      if (!nonimmediate_operand (operands[0], E_V8HImode)
          || !general_operand (operands[1], E_V8HImode))
        return -1;
      return 522; /* movv8hi */

    case E_V4SImode:
      if (!nonimmediate_operand (operands[0], E_V4SImode)
          || !general_operand (operands[1], E_V4SImode))
        return -1;
      return 523; /* movv4si */

    case E_V4SFmode:
      if (!nonimmediate_operand (operands[0], E_V4SFmode)
          || !general_operand (operands[1], E_V4SFmode))
        return -1;
      return 524; /* movv4sf */

    case E_V2DImode:
      if (!nonimmediate_operand (operands[0], E_V2DImode)
          || !general_operand (operands[1], E_V2DImode))
        return -1;
      return 525; /* movv2di */

    case E_V2DFmode:
      if (!nonimmediate_operand (operands[0], E_V2DFmode)
          || !general_operand (operands[1], E_V2DFmode))
        return -1;
      return 526; /* movv2df */

    case E_V1TImode:
      if (!nonimmediate_operand (operands[0], E_V1TImode)
          || !general_operand (operands[1], E_V1TImode))
        return -1;
      return 527; /* movv1ti */

    case E_V1TFmode:
      if (!nonimmediate_operand (operands[0], E_V1TFmode)
          || !general_operand (operands[1], E_V1TFmode))
        return -1;
      return 528; /* movv1tf */

    case E_TFmode:
      if (!nonimmediate_operand (operands[0], E_TFmode)
          || !general_operand (operands[1], E_TFmode)
          || !
#line 95 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
        return -1;
      return 529; /* movtf_vr */

    case E_V1QImode:
      if (!nonimmediate_operand (operands[0], E_V1QImode)
          || !general_operand (operands[1], E_V1QImode)
          || !
#line 370 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 530; /* movv1qi */

    case E_V2QImode:
      if (!nonimmediate_operand (operands[0], E_V2QImode)
          || !general_operand (operands[1], E_V2QImode))
        return -1;
      return 531; /* movv2qi */

    case E_V1HImode:
      if (!nonimmediate_operand (operands[0], E_V1HImode)
          || !general_operand (operands[1], E_V1HImode))
        return -1;
      return 532; /* movv1hi */

    case E_V4QImode:
      if (!nonimmediate_operand (operands[0], E_V4QImode)
          || !general_operand (operands[1], E_V4QImode)
          || !
#line 425 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 533; /* movv4qi */

    case E_V2HImode:
      if (!nonimmediate_operand (operands[0], E_V2HImode)
          || !general_operand (operands[1], E_V2HImode)
          || !
#line 425 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 534; /* movv2hi */

    case E_V1SImode:
      if (!nonimmediate_operand (operands[0], E_V1SImode)
          || !general_operand (operands[1], E_V1SImode)
          || !
#line 425 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 535; /* movv1si */

    case E_V1SFmode:
      if (!nonimmediate_operand (operands[0], E_V1SFmode)
          || !general_operand (operands[1], E_V1SFmode)
          || !
#line 425 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 536; /* movv1sf */

    case E_V8QImode:
      if (!nonimmediate_operand (operands[0], E_V8QImode)
          || !general_operand (operands[1], E_V8QImode)
          || !
#line 462 "../../gcc/config/s390/vector.md"
(TARGET_ZARCH))
        return -1;
      return 537; /* movv8qi */

    case E_V4HImode:
      if (!nonimmediate_operand (operands[0], E_V4HImode)
          || !general_operand (operands[1], E_V4HImode)
          || !
#line 462 "../../gcc/config/s390/vector.md"
(TARGET_ZARCH))
        return -1;
      return 538; /* movv4hi */

    case E_V2SImode:
      if (!nonimmediate_operand (operands[0], E_V2SImode)
          || !general_operand (operands[1], E_V2SImode)
          || !
#line 462 "../../gcc/config/s390/vector.md"
(TARGET_ZARCH))
        return -1;
      return 539; /* movv2si */

    case E_V2SFmode:
      if (!nonimmediate_operand (operands[0], E_V2SFmode)
          || !general_operand (operands[1], E_V2SFmode)
          || !
#line 462 "../../gcc/config/s390/vector.md"
(TARGET_ZARCH))
        return -1;
      return 540; /* movv2sf */

    case E_V1DImode:
      if (!nonimmediate_operand (operands[0], E_V1DImode)
          || !general_operand (operands[1], E_V1DImode)
          || !
#line 462 "../../gcc/config/s390/vector.md"
(TARGET_ZARCH))
        return -1;
      return 541; /* movv1di */

    case E_V1DFmode:
      if (!nonimmediate_operand (operands[0], E_V1DFmode)
          || !general_operand (operands[1], E_V1DFmode)
          || !
#line 462 "../../gcc/config/s390/vector.md"
(TARGET_ZARCH))
        return -1;
      return 542; /* movv1df */

    case E_TImode:
      if (!register_operand (operands[0], E_TImode)
          || !reload_const_wide_int_operand (operands[1], E_TImode)
          || !
#line 1761 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
        return -1;
      return 1815; /* *movti_bigconst */

    case E_DImode:
      if (!nonimmediate_operand (operands[0], E_DImode)
          || !general_operand (operands[1], E_DImode))
        return -1;
      if (
#line 1976 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
        return 1817; /* *movdi_64 */
      if (!
#line 2217 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
        return -1;
      return 1850; /* *movdi_31 */

    case E_SImode:
      if (register_operand (operands[0], E_SImode)
          && larl_operand (operands[1], E_SImode)
          && 
#line 2398 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT
   && !FP_REG_P (operands[0])))
        return 1852; /* *movsi_larl */
      if (!nonimmediate_operand (operands[0], E_SImode)
          || !general_operand (operands[1], E_SImode))
        return -1;
      if (
#line 2411 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
        return 1853; /* *movsi_zarch */
      if (!
#line 2502 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
        return -1;
      return 1854; /* *movsi_esa */

    case E_HImode:
      if (!nonimmediate_operand (operands[0], E_HImode)
          || !general_operand (operands[1], E_HImode))
        return -1;
      return 1859; /* *movhi */

    case E_QImode:
      if (!nonimmediate_operand (operands[0], E_QImode)
          || !general_operand (operands[1], E_QImode))
        return -1;
      return 1860; /* *movqi */

    case E_FPRX2mode:
      if (!nonimmediate_operand (operands[0], E_FPRX2mode)
          || !general_operand (operands[1], E_FPRX2mode))
        return -1;
      if ((
#line 2797 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH) && 
#line 764 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
        return 1865; /* *movfprx2_64 */
      if (!(
#line 2814 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH) && 
#line 764 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
        return -1;
      return 1868; /* *movfprx2_31 */

    case E_TDmode:
      if (!nonimmediate_operand (operands[0], E_TDmode)
          || !general_operand (operands[1], E_TDmode))
        return -1;
      if (
#line 2797 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
        return 1866; /* *movtd_64 */
      if (!
#line 2814 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
        return -1;
      return 1869; /* *movtd_31 */

    case E_DFmode:
      if (!nonimmediate_operand (operands[0], E_DFmode)
          || !general_operand (operands[1], E_DFmode))
        return -1;
      if (
#line 2921 "../../gcc/config/s390/s390.md"
(TARGET_DFP))
        return 1870; /* *movdf_64dfp */
      if (
#line 2953 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
        return 1872; /* *movdf_64 */
      if (!
#line 2979 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
        return -1;
      return 1874; /* *movdf_31 */

    case E_DDmode:
      if (!nonimmediate_operand (operands[0], E_DDmode)
          || !general_operand (operands[1], E_DDmode))
        return -1;
      if (
#line 2921 "../../gcc/config/s390/s390.md"
(TARGET_DFP))
        return 1871; /* *movdd_64dfp */
      if (
#line 2953 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
        return 1873; /* *movdd_64 */
      if (!
#line 2979 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
        return -1;
      return 1875; /* *movdd_31 */

    case E_SFmode:
      if (!nonimmediate_operand (operands[0], E_SFmode)
          || !general_operand (operands[1], E_SFmode))
        return -1;
      return 1876; /* movsf */

    case E_SDmode:
      if (!nonimmediate_operand (operands[0], E_SDmode)
          || !general_operand (operands[1], E_SDmode))
        return -1;
      return 1877; /* movsd */

    case E_CCmode:
      if (!nonimmediate_operand (operands[0], E_CCmode)
          || !nonimmediate_operand (operands[1], E_CCmode))
        return -1;
      return 1878; /* movcc */

    default:
      return -1;
    }
}

 int
recog_56 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V1QImode:
          if (!register_operand (operands[0], E_V1QImode)
              || GET_MODE (x3) != E_V1QImode
              || !register_operand (operands[1], E_V1QImode)
              || !
#line 1198 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 738; /* negv1qi2 */

        case E_V2QImode:
          if (!register_operand (operands[0], E_V2QImode)
              || GET_MODE (x3) != E_V2QImode
              || !register_operand (operands[1], E_V2QImode)
              || !
#line 1198 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 739; /* negv2qi2 */

        case E_V4QImode:
          if (!register_operand (operands[0], E_V4QImode)
              || GET_MODE (x3) != E_V4QImode
              || !register_operand (operands[1], E_V4QImode)
              || !
#line 1198 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 740; /* negv4qi2 */

        case E_V8QImode:
          if (!register_operand (operands[0], E_V8QImode)
              || GET_MODE (x3) != E_V8QImode
              || !register_operand (operands[1], E_V8QImode)
              || !
#line 1198 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 741; /* negv8qi2 */

        case E_V16QImode:
          if (!register_operand (operands[0], E_V16QImode)
              || GET_MODE (x3) != E_V16QImode
              || !register_operand (operands[1], E_V16QImode)
              || !
#line 1198 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 742; /* negv16qi2 */

        case E_V1HImode:
          if (!register_operand (operands[0], E_V1HImode)
              || GET_MODE (x3) != E_V1HImode
              || !register_operand (operands[1], E_V1HImode)
              || !
#line 1198 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 743; /* negv1hi2 */

        case E_V2HImode:
          if (!register_operand (operands[0], E_V2HImode)
              || GET_MODE (x3) != E_V2HImode
              || !register_operand (operands[1], E_V2HImode)
              || !
#line 1198 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 744; /* negv2hi2 */

        case E_V4HImode:
          if (!register_operand (operands[0], E_V4HImode)
              || GET_MODE (x3) != E_V4HImode
              || !register_operand (operands[1], E_V4HImode)
              || !
#line 1198 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 745; /* negv4hi2 */

        case E_V8HImode:
          if (!register_operand (operands[0], E_V8HImode)
              || GET_MODE (x3) != E_V8HImode
              || !register_operand (operands[1], E_V8HImode)
              || !
#line 1198 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 746; /* negv8hi2 */

        case E_V1SImode:
          if (!register_operand (operands[0], E_V1SImode)
              || GET_MODE (x3) != E_V1SImode
              || !register_operand (operands[1], E_V1SImode)
              || !
#line 1198 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 747; /* negv1si2 */

        case E_V2SImode:
          if (!register_operand (operands[0], E_V2SImode)
              || GET_MODE (x3) != E_V2SImode
              || !register_operand (operands[1], E_V2SImode)
              || !
#line 1198 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 748; /* negv2si2 */

        case E_V4SImode:
          if (!register_operand (operands[0], E_V4SImode)
              || GET_MODE (x3) != E_V4SImode
              || !register_operand (operands[1], E_V4SImode)
              || !
#line 1198 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 749; /* negv4si2 */

        case E_V1DImode:
          if (!register_operand (operands[0], E_V1DImode)
              || GET_MODE (x3) != E_V1DImode
              || !register_operand (operands[1], E_V1DImode)
              || !
#line 1198 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 750; /* negv1di2 */

        case E_V2DImode:
          if (!register_operand (operands[0], E_V2DImode)
              || GET_MODE (x3) != E_V2DImode
              || !register_operand (operands[1], E_V2DImode)
              || !
#line 1198 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 751; /* negv2di2 */

        case E_V1SFmode:
          if (!register_operand (operands[0], E_V1SFmode)
              || GET_MODE (x3) != E_V1SFmode
              || !register_operand (operands[1], E_V1SFmode)
              || !(
#line 1980 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 74 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1263; /* negv1sf2 */

        case E_V2SFmode:
          if (!register_operand (operands[0], E_V2SFmode)
              || GET_MODE (x3) != E_V2SFmode
              || !register_operand (operands[1], E_V2SFmode)
              || !(
#line 1980 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 74 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1264; /* negv2sf2 */

        case E_V4SFmode:
          if (!register_operand (operands[0], E_V4SFmode)
              || GET_MODE (x3) != E_V4SFmode
              || !register_operand (operands[1], E_V4SFmode)
              || !(
#line 1980 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 74 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1265; /* negv4sf2 */

        case E_V1DFmode:
          if (!register_operand (operands[0], E_V1DFmode)
              || GET_MODE (x3) != E_V1DFmode
              || !register_operand (operands[1], E_V1DFmode)
              || !
#line 1980 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1266; /* negv1df2 */

        case E_V2DFmode:
          if (!register_operand (operands[0], E_V2DFmode)
              || GET_MODE (x3) != E_V2DFmode
              || !register_operand (operands[1], E_V2DFmode)
              || !
#line 1980 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1267; /* negv2df2 */

        case E_V1TFmode:
          if (!register_operand (operands[0], E_V1TFmode)
              || GET_MODE (x3) != E_V1TFmode
              || !register_operand (operands[1], E_V1TFmode)
              || !(
#line 1980 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 76 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1268; /* negv1tf2 */

        case E_TFmode:
          if (!register_operand (operands[0], E_TFmode)
              || GET_MODE (x3) != E_TFmode
              || !register_operand (operands[1], E_TFmode))
            return -1;
          if ((
#line 1980 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 76 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return 1269; /* negtf2_vr */
          if ((
#line 9256 "../../gcc/config/s390/s390.md"
(TARGET_DFP) && 
#line 751 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return 2439; /* *negtf2_nocc */
          if (pnum_clobbers == NULL
              || !(
#line 9268 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 758 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          *pnum_clobbers = 1;
          return 2445; /* *negtf2 */

        case E_DImode:
          if (pattern83 (x3, pnum_clobbers, 
E_DImode) != 0)
            return -1;
          if (
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            {
              *pnum_clobbers = 1;
              return 2428; /* *negdi2 */
            }
          if (!
#line 9145 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
            return -1;
          *pnum_clobbers = 1;
          return 2430; /* *negdi2_31 */

        case E_SImode:
          if (pattern83 (x3, pnum_clobbers, 
E_SImode) != 0)
            return -1;
          *pnum_clobbers = 1;
          return 2429; /* *negsi2 */

        case E_FPRX2mode:
          if (!register_operand (operands[0], E_FPRX2mode)
              || GET_MODE (x3) != E_FPRX2mode
              || !register_operand (operands[1], E_FPRX2mode))
            return -1;
          if ((
#line 9256 "../../gcc/config/s390/s390.md"
(TARGET_DFP) && 
#line 751 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return 2440; /* *negfprx22_nocc */
          if (pnum_clobbers == NULL
              || !(
#line 9268 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 758 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          *pnum_clobbers = 1;
          return 2446; /* *negfprx22 */

        case E_DFmode:
          if (!register_operand (operands[0], E_DFmode)
              || GET_MODE (x3) != E_DFmode
              || !register_operand (operands[1], E_DFmode))
            return -1;
          if (
#line 9256 "../../gcc/config/s390/s390.md"
(TARGET_DFP))
            return 2441; /* *negdf2_nocc */
          if (pnum_clobbers == NULL
              || !
#line 9268 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
            return -1;
          *pnum_clobbers = 1;
          return 2447; /* *negdf2 */

        case E_SFmode:
          if (!register_operand (operands[0], E_SFmode)
              || GET_MODE (x3) != E_SFmode
              || !register_operand (operands[1], E_SFmode))
            return -1;
          if (
#line 9256 "../../gcc/config/s390/s390.md"
(TARGET_DFP))
            return 2442; /* *negsf2_nocc */
          if (pnum_clobbers == NULL
              || !
#line 9268 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
            return -1;
          *pnum_clobbers = 1;
          return 2448; /* *negsf2 */

        case E_TDmode:
          if (!register_operand (operands[0], E_TDmode)
              || GET_MODE (x3) != E_TDmode
              || !register_operand (operands[1], E_TDmode)
              || !(
#line 9256 "../../gcc/config/s390/s390.md"
(TARGET_DFP) && 
#line 752 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          return 2443; /* *negtd2_nocc */

        case E_DDmode:
          if (!register_operand (operands[0], E_DDmode)
              || GET_MODE (x3) != E_DDmode
              || !register_operand (operands[1], E_DDmode)
              || !(
#line 9256 "../../gcc/config/s390/s390.md"
(TARGET_DFP) && 
#line 752 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          return 2444; /* *negdd2_nocc */

        default:
          return -1;
        }

    case FMA:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      x7 = XEXP (x4, 2);
      switch (GET_CODE (x7))
        {
        case REG:
        case SUBREG:
          operands[3] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_V4SFmode:
              if (pattern156 (x3, 
E_V4SFmode) != 0
                  || !(
#line 1961 "../../gcc/config/s390/vector.md"
(TARGET_VXE && s390_fma_allowed_p (V4SFmode)) && 
#line 87 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 1255; /* neg_fmav4sf4 */

            case E_V2DFmode:
              if (pattern156 (x3, 
E_V2DFmode) != 0
                  || !
#line 1961 "../../gcc/config/s390/vector.md"
(TARGET_VXE && s390_fma_allowed_p (V2DFmode)))
                return -1;
              return 1256; /* neg_fmav2df4 */

            case E_V1TFmode:
              if (pattern156 (x3, 
E_V1TFmode) != 0
                  || !(
#line 1961 "../../gcc/config/s390/vector.md"
(TARGET_VXE && s390_fma_allowed_p (V1TFmode)) && 
#line 87 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 1257; /* neg_fmav1tf4 */

            case E_TFmode:
              if (pattern156 (x3, 
E_TFmode) != 0
                  || !(
#line 1961 "../../gcc/config/s390/vector.md"
(TARGET_VXE && s390_fma_allowed_p (TFmode)) && 
#line 88 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 1258; /* neg_fmatf4 */

            default:
              return -1;
            }

        case NEG:
          x8 = XEXP (x7, 0);
          operands[3] = x8;
          switch (GET_MODE (operands[0]))
            {
            case E_V4SFmode:
              if (pattern157 (x3, 
E_V4SFmode) != 0
                  || !(
#line 1972 "../../gcc/config/s390/vector.md"
(TARGET_VXE && s390_fma_allowed_p (V4SFmode)) && 
#line 87 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 1259; /* neg_fmsv4sf4 */

            case E_V2DFmode:
              if (pattern157 (x3, 
E_V2DFmode) != 0
                  || !
#line 1972 "../../gcc/config/s390/vector.md"
(TARGET_VXE && s390_fma_allowed_p (V2DFmode)))
                return -1;
              return 1260; /* neg_fmsv2df4 */

            case E_V1TFmode:
              if (pattern157 (x3, 
E_V1TFmode) != 0
                  || !(
#line 1972 "../../gcc/config/s390/vector.md"
(TARGET_VXE && s390_fma_allowed_p (V1TFmode)) && 
#line 87 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 1261; /* neg_fmsv1tf4 */

            case E_TFmode:
              if (pattern157 (x3, 
E_TFmode) != 0
                  || !(
#line 1972 "../../gcc/config/s390/vector.md"
(TARGET_VXE && s390_fma_allowed_p (TFmode)) && 
#line 88 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 1262; /* neg_fmstf4 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ABS:
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          operands[1] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_V1SFmode:
              if (pattern109 (x3, 
E_V1SFmode) != 0
                  || !(
#line 2008 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 74 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 1277; /* negabsv1sf2 */

            case E_V2SFmode:
              if (pattern109 (x3, 
E_V2SFmode) != 0
                  || !(
#line 2008 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 74 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 1278; /* negabsv2sf2 */

            case E_V4SFmode:
              if (pattern109 (x3, 
E_V4SFmode) != 0
                  || !(
#line 2008 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 74 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 1279; /* negabsv4sf2 */

            case E_V1DFmode:
              if (pattern109 (x3, 
E_V1DFmode) != 0
                  || !
#line 2008 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 1280; /* negabsv1df2 */

            case E_V2DFmode:
              if (pattern109 (x3, 
E_V2DFmode) != 0
                  || !
#line 2008 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 1281; /* negabsv2df2 */

            case E_V1TFmode:
              if (pattern109 (x3, 
E_V1TFmode) != 0
                  || !(
#line 2008 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 76 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 1282; /* negabsv1tf2 */

            case E_TFmode:
              if (pattern109 (x3, 
E_TFmode) != 0)
                return -1;
              if ((
#line 2008 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 76 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return 1283; /* negabstf2 */
              if ((
#line 9520 "../../gcc/config/s390/s390.md"
(TARGET_DFP) && 
#line 751 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return 2491; /* *negabstf2_nocc */
              if (pnum_clobbers == NULL
                  || !(
#line 9531 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 758 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              *pnum_clobbers = 1;
              return 2497; /* *negabstf2 */

            case E_DImode:
              if (pnum_clobbers == NULL
                  || pattern109 (x3, 
E_DImode) != 0
                  || !
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                return -1;
              *pnum_clobbers = 1;
              return 2481; /* *negabsdi2 */

            case E_SImode:
              if (pnum_clobbers == NULL
                  || pattern109 (x3, 
E_SImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 2482; /* *negabssi2 */

            case E_FPRX2mode:
              if (pattern109 (x3, 
E_FPRX2mode) != 0)
                return -1;
              if ((
#line 9520 "../../gcc/config/s390/s390.md"
(TARGET_DFP) && 
#line 751 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return 2492; /* *negabsfprx22_nocc */
              if (pnum_clobbers == NULL
                  || !(
#line 9531 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 758 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              *pnum_clobbers = 1;
              return 2498; /* *negabsfprx22 */

            case E_DFmode:
              if (pattern109 (x3, 
E_DFmode) != 0)
                return -1;
              if (
#line 9520 "../../gcc/config/s390/s390.md"
(TARGET_DFP))
                return 2493; /* *negabsdf2_nocc */
              if (pnum_clobbers == NULL
                  || !
#line 9531 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
                return -1;
              *pnum_clobbers = 1;
              return 2499; /* *negabsdf2 */

            case E_SFmode:
              if (pattern109 (x3, 
E_SFmode) != 0)
                return -1;
              if (
#line 9520 "../../gcc/config/s390/s390.md"
(TARGET_DFP))
                return 2494; /* *negabssf2_nocc */
              if (pnum_clobbers == NULL
                  || !
#line 9531 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
                return -1;
              *pnum_clobbers = 1;
              return 2500; /* *negabssf2 */

            case E_TDmode:
              if (pattern109 (x3, 
E_TDmode) != 0
                  || !(
#line 9520 "../../gcc/config/s390/s390.md"
(TARGET_DFP) && 
#line 752 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
                return -1;
              return 2495; /* *negabstd2_nocc */

            case E_DDmode:
              if (pattern109 (x3, 
E_DDmode) != 0
                  || !(
#line 9520 "../../gcc/config/s390/s390.md"
(TARGET_DFP) && 
#line 752 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
                return -1;
              return 2496; /* *negabsdd2_nocc */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          if (pnum_clobbers == NULL
              || GET_MODE (x5) != E_DImode
              || !register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || GET_MODE (x4) != E_DImode)
            return -1;
          x9 = XEXP (x5, 0);
          operands[1] = x9;
          if (!register_operand (operands[1], E_SImode)
              || !
#line 9451 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return -1;
          *pnum_clobbers = 1;
          return 2476; /* *negabsdi2_sign */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      if (pnum_clobbers == NULL
          || pattern66 (x3, 
E_SImode) != 0
          || !
#line 9103 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
        return -1;
      *pnum_clobbers = 1;
      return 2423; /* *negdi2_sign */

    default:
      return -1;
    }
}

 int
recog_70 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case VEC_SELECT:
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) != PARALLEL)
        return -1;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      switch (XVECLEN (x5, 0))
        {
        case 2:
          x7 = XVECEXP (x5, 0, 0);
          if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x8 = XVECEXP (x5, 0, 1);
          if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 2]
              || pattern140 (x3, 
E_V4SFmode, 
E_V2SFmode, 
E_V2DFmode) != 0
              || !
#line 2840 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1529; /* *vec_extendv4sf */

        case 1:
          x7 = XVECEXP (x5, 0, 0);
          if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || pattern140 (x3, 
E_V2DFmode, 
E_V1DFmode, 
E_V1TFmode) != 0
              || !
#line 2884 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 1530; /* *vec_extendv2df */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_TFmode:
          if (!register_operand (operands[0], E_TFmode)
              || GET_MODE (x3) != E_TFmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_DFmode:
              if (register_operand (operands[1], E_DFmode)
                  && 
#line 3207 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
                return 1564; /* extenddftf2_vr */
              if (!nonimmediate_operand (operands[1], E_DFmode)
                  || !(
#line 5788 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
   && GET_MODE_SIZE (TFmode) > GET_MODE_SIZE (DFmode)
   && (!TARGET_VX || TFmode != DFmode || DFmode != SFmode)) && 
#line 758 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              return 2102; /* *extenddftf2 */

            case E_SFmode:
              if (!nonimmediate_operand (operands[1], E_SFmode)
                  || !(
#line 5788 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
   && GET_MODE_SIZE (TFmode) > GET_MODE_SIZE (SFmode)
   && (!TARGET_VX || TFmode != DFmode || SFmode != SFmode)) && 
#line 758 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              return 2106; /* *extendsftf2 */

            default:
              return -1;
            }

        case E_DFmode:
          if (!register_operand (operands[0], E_DFmode)
              || GET_MODE (x3) != E_DFmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_SFmode:
              if (!nonimmediate_operand (operands[1], E_SFmode))
                return -1;
              if (
#line 5776 "../../gcc/config/s390/s390.md"
(TARGET_VX && TARGET_HARD_FLOAT))
                return 2101; /* *extendsfdf2_z13 */
              if (!
#line 5788 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
   && GET_MODE_SIZE (DFmode) > GET_MODE_SIZE (SFmode)
   && (!TARGET_VX || DFmode != DFmode || SFmode != SFmode)))
                return -1;
              return 2108; /* *extendsfdf2 */

            case E_DFmode:
              if (!nonimmediate_operand (operands[1], E_DFmode)
                  || !
#line 5788 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
   && GET_MODE_SIZE (DFmode) > GET_MODE_SIZE (DFmode)
   && (!TARGET_VX || DFmode != DFmode || DFmode != SFmode)))
                return -1;
              return 2104; /* *extenddfdf2 */

            default:
              return -1;
            }

        case E_FPRX2mode:
          switch (pattern87 (x3, 
E_FPRX2mode))
            {
            case 0:
              if (!(
#line 5788 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
   && GET_MODE_SIZE (FPRX2mode) > GET_MODE_SIZE (DFmode)
   && (!TARGET_VX || FPRX2mode != DFmode || DFmode != SFmode)) && 
#line 758 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              return 2103; /* *extenddffprx22 */

            case 1:
              if (!(
#line 5788 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
   && GET_MODE_SIZE (FPRX2mode) > GET_MODE_SIZE (SFmode)
   && (!TARGET_VX || FPRX2mode != DFmode || SFmode != SFmode)) && 
#line 758 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              return 2107; /* *extendsffprx22 */

            default:
              return -1;
            }

        case E_SFmode:
          switch (pattern87 (x3, 
E_SFmode))
            {
            case 0:
              if (!
#line 5788 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
   && GET_MODE_SIZE (SFmode) > GET_MODE_SIZE (DFmode)
   && (!TARGET_VX || SFmode != DFmode || DFmode != SFmode)))
                return -1;
              return 2105; /* *extenddfsf2 */

            case 1:
              if (!
#line 5788 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
   && GET_MODE_SIZE (SFmode) > GET_MODE_SIZE (SFmode)
   && (!TARGET_VX || SFmode != DFmode || SFmode != SFmode)))
                return -1;
              return 2109; /* *extendsfsf2 */

            default:
              return -1;
            }

        case E_TDmode:
          if (!register_operand (operands[0], E_TDmode)
              || GET_MODE (x3) != E_TDmode
              || !register_operand (operands[1], E_DDmode)
              || !
#line 5810 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          return 2110; /* extendddtd2 */

        case E_DDmode:
          if (!register_operand (operands[0], E_DDmode)
              || GET_MODE (x3) != E_DDmode
              || !register_operand (operands[1], E_SDmode)
              || !
#line 5818 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          return 2111; /* extendsddd2 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_77 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case VEC_CONCAT:
      x5 = XEXP (x4, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x6 = XEXP (x3, 1);
      if (GET_CODE (x6) != VEC_CONCAT)
        return -1;
      x7 = XEXP (x6, 0);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x8 = XEXP (x6, 1);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x9 = XEXP (x4, 0);
      operands[1] = x9;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SImode:
          if (pattern170 (x3, 
E_V2SImode, 
E_SImode, 
E_V4SImode) != 0
              || !
#line 607 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 619; /* *vec_vllezlfv4si */

        case E_V4SFmode:
          if (pattern170 (x3, 
E_V2SFmode, 
E_SFmode, 
E_V4SFmode) != 0
              || !
#line 607 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 620; /* *vec_vllezlfv4sf */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[1] = x4;
      x6 = XEXP (x3, 1);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V2DImode:
          if (pattern108 (x3, 
E_DImode, 
E_V2DImode) != 0
              || !
#line 2446 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1410; /* *vec_load_pairv2di */

        case E_V2DFmode:
          if (pattern108 (x3, 
E_DFmode, 
E_V2DFmode) != 0
              || !
#line 2446 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1411; /* *vec_load_pairv2df */

        default:
          return -1;
        }

    case TRUNCATE:
      switch (pattern33 (x3, 
TRUNCATE))
        {
        case 0:
          if (!
#line 2634 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1498; /* vec_pack_trunc_v8hi */

        case 1:
          if (!
#line 2634 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1499; /* vec_pack_trunc_v4si */

        case 2:
          if (!
#line 2634 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1500; /* vec_pack_trunc_v2di */

        default:
          return -1;
        }

    case SS_TRUNCATE:
      switch (pattern33 (x3, 
SS_TRUNCATE))
        {
        case 0:
          if (!
#line 2646 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1501; /* vec_pack_ssat_v8hi */

        case 1:
          if (!
#line 2646 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1502; /* vec_pack_ssat_v4si */

        case 2:
          if (!
#line 2646 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1503; /* vec_pack_ssat_v2di */

        default:
          return -1;
        }

    case US_TRUNCATE:
      switch (pattern33 (x3, 
US_TRUNCATE))
        {
        case 0:
          if (!
#line 2658 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1504; /* vec_pack_usat_v8hi */

        case 1:
          if (!
#line 2658 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1505; /* vec_pack_usat_v4si */

        case 2:
          if (!
#line 2658 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1506; /* vec_pack_usat_v2di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_88 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case ASHIFTRT:
      if (pattern148 (x1, 
NEG) != 0
          || !
#line 9094 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && s390_match_ccmode (insn, CCAmode)))
        return -1;
      return 2422; /* *negdi2_sign_cc */

    case REG:
    case SUBREG:
      operands[1] = x5;
      x6 = XEXP (x3, 1);
      if (x6 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
        {
          res = recog_84 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[2] = x6;
      switch (pattern179 (x1, 
NEG))
        {
        case 0:
          if (!(
#line 9236 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 758 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          return 2431; /* *negtf2_cc */

        case 1:
          if (!(
#line 9236 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 758 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          return 2432; /* *negfprx22_cc */

        case 2:
          if (!
#line 9236 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
            return -1;
          return 2433; /* *negdf2_cc */

        case 3:
          if (!
#line 9236 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
            return -1;
          return 2434; /* *negsf2_cc */

        case 4:
          if (!(
#line 9247 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 758 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          return 2435; /* *negtf2_cconly */

        case 5:
          if (!(
#line 9247 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 758 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          return 2436; /* *negfprx22_cconly */

        case 6:
          if (!
#line 9247 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
            return -1;
          return 2437; /* *negdf2_cconly */

        case 7:
          if (!
#line 9247 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
            return -1;
          return 2438; /* *negsf2_cconly */

        default:
          return -1;
        }

    case ABS:
      x7 = XEXP (x5, 0);
      switch (GET_CODE (x7))
        {
        case ASHIFTRT:
          if (GET_MODE (x7) != E_DImode)
            return -1;
          x8 = XEXP (x7, 0);
          if (GET_CODE (x8) != ASHIFT
              || GET_MODE (x8) != E_DImode)
            return -1;
          x9 = XEXP (x8, 0);
          if (GET_CODE (x9) != SUBREG
              || maybe_ne (SUBREG_BYTE (x9), 0)
              || GET_MODE (x9) != E_DImode)
            return -1;
          x10 = XEXP (x8, 1);
          if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
            return -1;
          x11 = XEXP (x7, 1);
          if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
            return -1;
          x6 = XEXP (x3, 1);
          if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x12 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x12) != SET)
            return -1;
          x13 = XEXP (x12, 1);
          if (pattern253 (x13, 
ABS, 
NEG) != 0)
            return -1;
          x14 = XEXP (x13, 0);
          x15 = XEXP (x14, 0);
          if (GET_CODE (x15) != SIGN_EXTEND
              || GET_MODE (x15) != E_DImode
              || GET_MODE (x4) != E_DImode
              || GET_MODE (x5) != E_DImode)
            return -1;
          x16 = XEXP (x9, 0);
          operands[1] = x16;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          x17 = XEXP (x12, 0);
          operands[0] = x17;
          if (!register_operand (operands[0], E_DImode))
            return -1;
          x18 = XEXP (x15, 0);
          if (!rtx_equal_p (x18, operands[1])
              || !
#line 9441 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && s390_match_ccmode (insn, CCAmode)))
            return -1;
          return 2475; /* *negabsdi2_sign_cc */

        case REG:
        case SUBREG:
          operands[1] = x7;
          x6 = XEXP (x3, 1);
          if (x6 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
            {
              switch (pattern191 (x1, 
ABS, 
NEG))
                {
                case 0:
                  switch (GET_MODE (x4))
                    {
                    case E_DImode:
                      if (pattern261 (x1, 
E_DImode) == 0
                          && (
#line 9463 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCAmode)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                        return 2477; /* *negabsdi2_cc */
                      break;

                    case E_SImode:
                      if (pattern261 (x1, 
E_SImode) == 0
                          && 
#line 9463 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCAmode)))
                        return 2478; /* *negabssi2_cc */
                      break;

                    default:
                      break;
                    }
                  break;

                case 1:
                  if (GET_MODE (x5) == E_DImode
                      && register_operand (operands[1], E_DImode)
                      && scratch_operand (operands[0], E_DImode)
                      && (
#line 9474 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCAmode)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return 2479; /* *negabsdi2_cconly */
                  break;

                case 2:
                  if (GET_MODE (x5) == E_SImode
                      && register_operand (operands[1], E_SImode)
                      && scratch_operand (operands[0], E_SImode)
                      && 
#line 9474 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCAmode)))
                    return 2480; /* *negabssi2_cconly */
                  break;

                default:
                  break;
                }
            }
          operands[2] = x6;
          x12 = XVECEXP (x1, 0, 1);
          switch (GET_CODE (x12))
            {
            case SET:
              x13 = XEXP (x12, 1);
              if (GET_CODE (x13) != NEG)
                return -1;
              x14 = XEXP (x13, 0);
              if (GET_CODE (x14) != ABS)
                return -1;
              x17 = XEXP (x12, 0);
              operands[0] = x17;
              x15 = XEXP (x14, 0);
              if (!rtx_equal_p (x15, operands[1]))
                return -1;
              switch (GET_MODE (x4))
                {
                case E_TFmode:
                  if (pattern262 (x1, 
E_TFmode) != 0
                      || !(
#line 9500 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 758 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                    return -1;
                  return 2483; /* *negabstf2_cc */

                case E_FPRX2mode:
                  if (pattern262 (x1, 
E_FPRX2mode) != 0
                      || !(
#line 9500 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 758 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                    return -1;
                  return 2484; /* *negabsfprx22_cc */

                case E_DFmode:
                  if (pattern262 (x1, 
E_DFmode) != 0
                      || !
#line 9500 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
                    return -1;
                  return 2485; /* *negabsdf2_cc */

                case E_SFmode:
                  if (pattern262 (x1, 
E_SFmode) != 0
                      || !
#line 9500 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
                    return -1;
                  return 2486; /* *negabssf2_cc */

                default:
                  return -1;
                }

            case CLOBBER:
              x17 = XEXP (x12, 0);
              operands[0] = x17;
              switch (GET_MODE (x4))
                {
                case E_TFmode:
                  if (pattern240 (x5, 
E_TFmode) != 0
                      || !(
#line 9511 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 758 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                    return -1;
                  return 2487; /* *negabstf2_cconly */

                case E_FPRX2mode:
                  if (pattern240 (x5, 
E_FPRX2mode) != 0
                      || !(
#line 9511 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 758 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                    return -1;
                  return 2488; /* *negabsfprx22_cconly */

                case E_DFmode:
                  if (pattern240 (x5, 
E_DFmode) != 0
                      || !
#line 9511 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
                    return -1;
                  return 2489; /* *negabsdf2_cconly */

                case E_SFmode:
                  if (pattern240 (x5, 
E_SFmode) != 0
                      || !
#line 9511 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
                    return -1;
                  return 2490; /* *negabssf2_cconly */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_106 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case AND:
      res = recog_96 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case REG:
    case SUBREG:
    case MEM:
      res = recog_97 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case PLUS:
      res = recog_98 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case MINUS:
      res = recog_99 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case SIGN_EXTEND:
    case ZERO_EXTEND:
      if (pattern38 (x1) == 0)
        {
          switch (GET_CODE (x3))
            {
            case SIGN_EXTEND:
              switch (pattern184 (x3))
                {
                case 0:
                  if (
#line 4211 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                    return 1921; /* *cmpint_sign */
                  break;

                case 1:
                  if ((
#line 5112 "../../gcc/config/s390/s390.md"
(!TARGET_EXTIMM && !TARGET_LONG_DISPLACEMENT) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return 2023; /* *extendqidi2_short_displ */
                  break;

                case 2:
                  if (
#line 5112 "../../gcc/config/s390/s390.md"
(!TARGET_EXTIMM && !TARGET_LONG_DISPLACEMENT))
                    return 2024; /* *extendqisi2_short_displ */
                  break;

                default:
                  break;
                }
              break;

            case ZERO_EXTEND:
              if (GET_MODE (x3) == E_SImode
                  && register_operand (operands[0], E_SImode))
                {
                  x4 = XEXP (x3, 0);
                  operands[1] = x4;
                  if (s_operand (operands[1], E_HImode)
                      && 
#line 5297 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
                    return 2040; /* *zero_extendhisi2_31 */
                }
              break;

            default:
              break;
            }
          operands[1] = x3;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (register_operand (operands[0], E_DImode))
                {
                  if (s390_alc_comparison (operands[1], E_DImode)
                      && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                    return 2304; /* *sconddi */
                  if (s390_slb_comparison (operands[1], E_DImode)
                      && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                    return 2306; /* *sconddi_neg */
                }
              break;

            case E_SImode:
              if (register_operand (operands[0], E_SImode))
                {
                  if (s390_alc_comparison (operands[1], E_SImode))
                    return 2305; /* *scondsi */
                  if (s390_slb_comparison (operands[1], E_SImode))
                    return 2307; /* *scondsi_neg */
                }
              break;

            default:
              break;
            }
        }
      break;

    case MULT:
      res = recog_100 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case CONST_INT:
      if (pnum_clobbers != NULL
          && XWINT (x3, 0) == 0L)
        {
          x5 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x5) == USE)
            {
              x6 = XEXP (x2, 0);
              operands[0] = x6;
              if (memory_operand (operands[0], E_BLKmode))
                {
                  x7 = XEXP (x5, 0);
                  operands[1] = x7;
                  if (const_int_operand (operands[1], E_VOIDmode)
                      && 
#line 9005 "../../gcc/config/s390/s390.md"
(INTVAL (operands[1]) >= 1 && INTVAL (operands[1]) <= 256))
                    {
                      *pnum_clobbers = 1;
                      return 2415; /* *xc_zero */
                    }
                }
            }
        }
      break;

    default:
      break;
    }
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != USE)
    return -1;
  x6 = XEXP (x2, 0);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
      operands[0] = x6;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x7 = XEXP (x5, 0);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      operands[1] = x3;
      if (!address_operand (operands[1], E_QImode)
          || !
#line 2602 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT))
        return -1;
      return 1858; /* force_la_31 */

    case PC:
      x7 = XEXP (x5, 0);
      if (GET_CODE (x7) != LABEL_REF)
        return -1;
      operands[0] = x3;
      x8 = XEXP (x7, 0);
      operands[1] = x8;
      if (address_operand (operands[0], E_VOIDmode)
          && 
#line 10554 "../../gcc/config/s390/s390.md"
(!TARGET_INDIRECT_BRANCH_NOBP_JUMP_THUNK))
        return 2557; /* *casesi_jump */
      if (register_operand (operands[0], E_DImode)
          && (
#line 10573 "../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_JUMP_THUNK
  && TARGET_CPU_Z10) && 
#line 778 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
        return 2558; /* casesi_jump_via_thunkdi_z10 */
      if (register_operand (operands[0], E_SImode)
          && (
#line 10573 "../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_JUMP_THUNK
  && TARGET_CPU_Z10) && 
#line 778 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
        return 2559; /* casesi_jump_via_thunksi_z10 */
      if (pnum_clobbers == NULL)
        return -1;
      if (register_operand (operands[0], E_DImode)
          && (
#line 10591 "../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_JUMP_THUNK
  && !TARGET_CPU_Z10) && 
#line 778 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
        {
          *pnum_clobbers = 1;
          return 2560; /* casesi_jump_via_thunkdi */
        }
      if (!register_operand (operands[0], E_SImode)
          || !(
#line 10591 "../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_JUMP_THUNK
  && !TARGET_CPU_Z10) && 
#line 778 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
        return -1;
      *pnum_clobbers = 1;
      return 2561; /* casesi_jump_via_thunksi */

    default:
      return -1;
    }
}

 int
recog_113 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x2))
    {
    case SET:
      return recog_112 (x1, insn, pnum_clobbers);

    case CLOBBER:
      if (pnum_clobbers == NULL)
        return -1;
      x3 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x3) != SET)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != MEM
          || GET_MODE (x4) != E_BLKmode)
        return -1;
      switch (pattern126 (x1))
        {
        case 0:
          if (!
#line 778 "../../gcc/config/s390/s390.md"
(TARGET_64BIT))
            return -1;
          *pnum_clobbers = 1;
          return 1890; /* *movstr */

        case 1:
          if (!
#line 778 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT))
            return -1;
          *pnum_clobbers = 1;
          return 1891; /* *movstr */

        case 2:
          if (!(
#line 3958 "../../gcc/config/s390/s390.md"
(TARGET_64BIT || !TARGET_ZARCH) && 
#line 778 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 1908; /* *setmem_long */

        case 3:
          if (!(
#line 3958 "../../gcc/config/s390/s390.md"
(TARGET_64BIT || !TARGET_ZARCH) && 
#line 778 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 1909; /* *setmem_long */

        case 4:
          if (!
#line 3986 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT && TARGET_ZARCH))
            return -1;
          *pnum_clobbers = 1;
          return 1912; /* *setmem_long_31z */

        case 5:
          if (!(
#line 3971 "../../gcc/config/s390/s390.md"
((TARGET_64BIT || !TARGET_ZARCH)) && 
#line 778 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 1910; /* *setmem_long_and */

        case 6:
          if (!(
#line 3971 "../../gcc/config/s390/s390.md"
((TARGET_64BIT || !TARGET_ZARCH)) && 
#line 778 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 1911; /* *setmem_long_and */

        case 7:
          if (!
#line 3998 "../../gcc/config/s390/s390.md"
((!TARGET_64BIT && TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 1913; /* *setmem_long_and_31z */

        default:
          return -1;
        }

    case UNSPEC:
      if (pattern14 (x1) != 0)
        return -1;
      x5 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x5) != USE)
        return -1;
      x6 = XEXP (x5, 0);
      if (GET_CODE (x6) != LABEL_REF)
        return -1;
      x7 = XVECEXP (x2, 0, 0);
      x8 = XEXP (x7, 0);
      operands[2] = x8;
      x3 = XVECEXP (x1, 0, 1);
      x9 = XEXP (x3, 1);
      operands[0] = x9;
      x10 = XEXP (x6, 0);
      operands[1] = x10;
      x11 = XVECEXP (x2, 0, 1);
      switch (GET_CODE (x11))
        {
        case CONST_INT:
          if (XWINT (x11, 0) != 0L)
            return -1;
          if (larl_operand (operands[2], E_DImode)
              && register_operand (operands[0], E_DImode)
              && (
#line 10616 "../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_JUMP_INLINE_THUNK
   && TARGET_CPU_Z10) && 
#line 778 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
            return 2562; /* casesi_jump_via_inlinethunkdi_z10 */
          if (!larl_operand (operands[2], E_SImode)
              || !register_operand (operands[0], E_SImode)
              || !(
#line 10616 "../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_JUMP_INLINE_THUNK
   && TARGET_CPU_Z10) && 
#line 778 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
            return -1;
          return 2563; /* casesi_jump_via_inlinethunksi_z10 */

        case REG:
        case SUBREG:
          operands[3] = x11;
          if (register_operand (operands[3], E_DImode)
              && larl_operand (operands[2], E_DImode)
              && register_operand (operands[0], E_DImode)
              && (
#line 10633 "../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_JUMP_INLINE_THUNK
   && !TARGET_CPU_Z10) && 
#line 778 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
            return 2564; /* casesi_jump_via_inlinethunkdi */
          if (!register_operand (operands[3], E_SImode)
              || !larl_operand (operands[2], E_SImode)
              || !register_operand (operands[0], E_SImode)
              || !(
#line 10633 "../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_JUMP_INLINE_THUNK
   && !TARGET_CPU_Z10) && 
#line 778 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
            return -1;
          return 2565; /* casesi_jump_via_inlinethunksi */

        default:
          return -1;
        }

    case CALL:
      x12 = XEXP (x2, 0);
      if (GET_CODE (x12) != MEM
          || GET_MODE (x12) != E_QImode
          || pattern15 (x1, 
CLOBBER) != 0)
        return -1;
      x13 = XEXP (x12, 0);
      operands[0] = x13;
      x14 = XEXP (x2, 1);
      operands[1] = x14;
      if (!const_int_operand (operands[1], E_VOIDmode))
        return -1;
      x3 = XVECEXP (x1, 0, 1);
      x4 = XEXP (x3, 0);
      operands[2] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || !register_operand (operands[2], E_DImode))
            return -1;
          x5 = XVECEXP (x1, 0, 2);
          x6 = XEXP (x5, 0);
          if (GET_MODE (x6) != E_DImode
              || !(
#line 10938 "../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_CALL
   && !TARGET_CPU_Z10
   && !SIBLING_CALL_P (insn)) && 
#line 778 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
            return -1;
          return 2578; /* *basr_via_thunkdi */

        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || !register_operand (operands[2], E_SImode))
            return -1;
          x5 = XVECEXP (x1, 0, 2);
          x6 = XEXP (x5, 0);
          if (GET_MODE (x6) != E_SImode
              || !(
#line 10938 "../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_CALL
   && !TARGET_CPU_Z10
   && !SIBLING_CALL_P (insn)) && 
#line 778 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
            return -1;
          return 2579; /* *basr_via_thunksi */

        default:
          return -1;
        }

    case RETURN:
      if (pattern15 (x1, 
USE) != 0)
        return -1;
      x3 = XVECEXP (x1, 0, 1);
      x4 = XEXP (x3, 0);
      operands[0] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (!register_operand (operands[0], E_DImode))
            return -1;
          x5 = XVECEXP (x1, 0, 2);
          x6 = XEXP (x5, 0);
          if (GET_MODE (x6) != E_DImode
              || !(
#line 11876 "../../gcc/config/s390/s390.md"
(!TARGET_CPU_Z10 && TARGET_INDIRECT_BRANCH_NOBP_RET_OPTION) && 
#line 778 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
            return -1;
          return 2627; /* returndi_prez10 */

        case E_SImode:
          if (!register_operand (operands[0], E_SImode))
            return -1;
          x5 = XVECEXP (x1, 0, 2);
          x6 = XEXP (x5, 0);
          if (GET_MODE (x6) != E_SImode
              || !(
#line 11876 "../../gcc/config/s390/s390.md"
(!TARGET_CPU_Z10 && TARGET_INDIRECT_BRANCH_NOBP_RET_OPTION) && 
#line 778 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
            return -1;
          return 2628; /* returnsi_prez10 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22;
  int res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  switch (GET_CODE (x1))
    {
    case SET:
      return recog_120 (x1, insn, pnum_clobbers);

    case PARALLEL:
      switch (XVECLEN (x1, 0))
        {
        case 2:
          res = recog_110 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 3:
          res = recog_113 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 4:
          res = recog_114 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 6:
          res = recog_115 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 5:
          res = recog_116 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 34:
          res = recog_117 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 18:
          if (pattern6 (x1, 
19, 
E_DFmode, 
18, 
17) == 0
              && pattern298 (x1, 
23, 
E_DFmode, 
22, 
21, 
20) == 0
              && pattern299 (x1, 
27, 
E_DFmode, 
26, 
25, 
24) == 0
              && pattern300 (x1, 
E_DFmode, 
31, 
30, 
29, 
28) == 0)
            {
              x2 = XVECEXP (x1, 0, 0);
              x3 = XEXP (x2, 1);
              x4 = XVECEXP (x3, 0, 0);
              operands[0] = x4;
              if (const_int_operand (operands[0], E_VOIDmode))
                {
                  x5 = XVECEXP (x1, 0, 1);
                  x6 = XEXP (x5, 0);
                  operands[1] = x6;
                  if (memory_operand (operands[1], E_BLKmode))
                    {
                      x7 = XEXP (x5, 1);
                      x8 = XVECEXP (x7, 0, 0);
                      if (rtx_equal_p (x8, operands[0])
                          && 
#line 12412 "../../gcc/config/s390/s390.md"
(TARGET_HTM && INTVAL (operands[0]) >= 0 && INTVAL (operands[0]) <= 0xffff))
                        return 2655; /* tbegin_1 */
                    }
                }
            }
          break;

        default:
          break;
        }
      if (XVECLEN (x1, 0) >= 1)
        {
          operands[0] = x1;
          res = recog_118 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      switch (XVECLEN (x1, 0))
        {
        case 3:
          x2 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x2) != SET)
            return -1;
          x5 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x5) != SET)
            return -1;
          x7 = XEXP (x5, 1);
          if (GET_CODE (x7) != UNSPEC_VOLATILE)
            return -1;
          x9 = XEXP (x2, 0);
          operands[0] = x9;
          x3 = XEXP (x2, 1);
          operands[1] = x3;
          x6 = XEXP (x5, 0);
          if (!rtx_equal_p (x6, operands[1]))
            return -1;
          switch (XVECLEN (x7, 0))
            {
            case 3:
              if (XINT (x7, 1) != 9)
                return -1;
              x10 = XVECEXP (x1, 0, 2);
              if (pattern182 (x10) != 0)
                return -1;
              x11 = XVECEXP (x7, 0, 1);
              operands[2] = x11;
              x12 = XVECEXP (x7, 0, 2);
              operands[3] = x12;
              x8 = XVECEXP (x7, 0, 0);
              if (!rtx_equal_p (x8, operands[1]))
                return -1;
              x13 = XEXP (x10, 1);
              x14 = XEXP (x13, 0);
              if (!rtx_equal_p (x14, operands[1]))
                return -1;
              x15 = XEXP (x13, 1);
              if (!rtx_equal_p (x15, operands[2]))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_DImode:
                  if (pattern279 (x7, 
E_DImode) != 0)
                    return -1;
                  if (
#line 11352 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH
   && s390_match_ccmode (insn, CCZ1mode)))
                    return 2598; /* *atomic_compare_and_swapdi_1 */
                  if (!
#line 11370 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH
   && s390_match_ccmode (insn, CCZ1mode)))
                    return -1;
                  return 2599; /* *atomic_compare_and_swapdi_2 */

                case E_SImode:
                  if (pattern279 (x7, 
E_SImode) != 0
                      || !
#line 11391 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCZ1mode)))
                    return -1;
                  return 2600; /* *atomic_compare_and_swapsi_3 */

                default:
                  return -1;
                }

            case 1:
              if (XINT (x7, 1) != 10)
                return -1;
              x10 = XVECEXP (x1, 0, 2);
              if (GET_CODE (x10) != CLOBBER)
                return -1;
              x16 = XEXP (x10, 0);
              if (GET_CODE (x16) != REG
                  || REGNO (x16) != 33
                  || GET_MODE (x16) != E_CCmode)
                return -1;
              x8 = XVECEXP (x7, 0, 0);
              switch (GET_CODE (x8))
                {
                case AND:
                  switch (pattern218 (x7))
                    {
                    case 0:
                      if (!(
#line 11431 "../../gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                        return -1;
                      return 2601; /* atomic_fetch_anddi_iaf */

                    case 1:
                      if (!
#line 11431 "../../gcc/config/s390/s390.md"
(TARGET_Z196))
                        return -1;
                      return 2605; /* atomic_fetch_andsi_iaf */

                    default:
                      return -1;
                    }

                case IOR:
                  switch (pattern218 (x7))
                    {
                    case 0:
                      if (!(
#line 11431 "../../gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                        return -1;
                      return 2602; /* atomic_fetch_ordi_iaf */

                    case 1:
                      if (!
#line 11431 "../../gcc/config/s390/s390.md"
(TARGET_Z196))
                        return -1;
                      return 2606; /* atomic_fetch_orsi_iaf */

                    default:
                      return -1;
                    }

                case XOR:
                  switch (pattern218 (x7))
                    {
                    case 0:
                      if (!(
#line 11431 "../../gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                        return -1;
                      return 2603; /* atomic_fetch_xordi_iaf */

                    case 1:
                      if (!
#line 11431 "../../gcc/config/s390/s390.md"
(TARGET_Z196))
                        return -1;
                      return 2607; /* atomic_fetch_xorsi_iaf */

                    default:
                      return -1;
                    }

                case PLUS:
                  switch (pattern218 (x7))
                    {
                    case 0:
                      if (!(
#line 11431 "../../gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                        return -1;
                      return 2604; /* atomic_fetch_adddi_iaf */

                    case 1:
                      if (!
#line 11431 "../../gcc/config/s390/s390.md"
(TARGET_Z196))
                        return -1;
                      return 2608; /* atomic_fetch_addsi_iaf */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 2:
          x2 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x2) != SET)
            return -1;
          if (pnum_clobbers != NULL)
            {
              res = recog_119 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
            }
          x9 = XEXP (x2, 0);
          if (GET_CODE (x9) != REG
              || REGNO (x9) != 15
              || GET_MODE (x9) != E_DImode)
            return -1;
          x5 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x5) != CLOBBER)
            return -1;
          x6 = XEXP (x5, 0);
          if (GET_CODE (x6) != MEM
              || GET_MODE (x6) != E_BLKmode)
            return -1;
          x17 = XEXP (x6, 0);
          if (GET_CODE (x17) != SCRATCH)
            return -1;
          x3 = XEXP (x2, 1);
          operands[0] = x3;
          if (!register_operand (operands[0], E_DImode)
              || !
#line 12003 "../../gcc/config/s390/s390.md"
(TARGET_Z10))
            return -1;
          return 2635; /* stack_restore_from_fpr */

        default:
          return -1;
        }

    case TRAP_IF:
      x18 = XEXP (x1, 1);
      if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x19 = XEXP (x1, 0);
      switch (GET_CODE (x19))
        {
        case CONST_INT:
          if (XWINT (x19, 0) != 1L)
            return -1;
          return 2531; /* trap */

        case NE:
        case EQ:
        case GE:
        case GT:
        case LE:
        case LT:
        case LTGT:
        case GEU:
        case GTU:
        case LEU:
        case LTU:
        case UNORDERED:
        case ORDERED:
        case UNEQ:
        case UNGE:
        case UNGT:
        case UNLE:
        case UNLT:
          operands[0] = x19;
          if (s390_comparison (operands[0], E_VOIDmode))
            {
              x20 = XEXP (x19, 1);
              if (x20 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
                {
                  x21 = XEXP (x19, 0);
                  operands[1] = x21;
                  if (cc_reg_operand (operands[1], E_VOIDmode))
                    return 2532; /* condtrap */
                }
            }
          x21 = XEXP (x19, 0);
          operands[1] = x21;
          x20 = XEXP (x19, 1);
          operands[2] = x20;
          if (s390_signed_integer_comparison (operands[0], E_VOIDmode))
            {
              switch (GET_MODE (operands[1]))
                {
                case E_DImode:
                  if (register_operand (operands[1], E_DImode)
                      && nonmemory_operand (operands[2], E_DImode)
                      && (
#line 9971 "../../gcc/config/s390/s390.md"
(TARGET_Z10) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return 2533; /* *cmp_and_trap_signed_intdi */
                  break;

                case E_SImode:
                  if (register_operand (operands[1], E_SImode)
                      && nonmemory_operand (operands[2], E_SImode)
                      && 
#line 9971 "../../gcc/config/s390/s390.md"
(TARGET_Z10))
                    return 2534; /* *cmp_and_trap_signed_intsi */
                  break;

                default:
                  break;
                }
            }
          if (!s390_unsigned_integer_comparison (operands[0], E_VOIDmode))
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_DImode:
              if (!register_operand (operands[1], E_DImode)
                  || !general_operand (operands[2], E_DImode)
                  || !(
#line 9985 "../../gcc/config/s390/s390.md"
(TARGET_Z10) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              return 2535; /* *cmp_and_trap_unsigned_intdi */

            case E_SImode:
              if (!register_operand (operands[1], E_SImode)
                  || !general_operand (operands[2], E_SImode)
                  || !
#line 9985 "../../gcc/config/s390/s390.md"
(TARGET_Z10))
                return -1;
              return 2536; /* *cmp_and_trap_unsigned_intsi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case UNSPEC_VOLATILE:
      switch (XVECLEN (x1, 0))
        {
        case 1:
          switch (XINT (x1, 1))
            {
            case 0:
              x2 = XVECEXP (x1, 0, 0);
              if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 2566; /* blockage */

            case 11:
              x2 = XVECEXP (x1, 0, 0);
              if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 2610; /* nop_lr0 */

            case 12:
              x2 = XVECEXP (x1, 0, 0);
              if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 2611; /* nop_lr1 */

            case 13:
              x2 = XVECEXP (x1, 0, 0);
              if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 2612; /* nop_2_byte */

            case 14:
              x2 = XVECEXP (x1, 0, 0);
              if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 2613; /* nop_4_byte */

            case 15:
              x2 = XVECEXP (x1, 0, 0);
              if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 2614; /* nop_6_byte */

            case 6:
              x2 = XVECEXP (x1, 0, 0);
              operands[0] = x2;
              if (!consttable_operand (operands[0], E_VOIDmode))
                return -1;
              return 2615; /* *pool_entry */

            case 5:
              x2 = XVECEXP (x1, 0, 0);
              operands[0] = x2;
              if (!const_int_operand (operands[0], E_VOIDmode))
                return -1;
              return 2616; /* pool_align */

            case 4:
              x2 = XVECEXP (x1, 0, 0);
              if (GET_CODE (x2) != CONST_INT)
                return -1;
              switch (XWINT (x2, 0))
                {
                case 1L:
                  return 2617; /* pool_section_start */

                case 0L:
                  return 2618; /* pool_section_end */

                default:
                  return -1;
                }

            case 3:
              x2 = XVECEXP (x1, 0, 0);
              operands[0] = x2;
              if (!const_int_operand (operands[0], E_VOIDmode))
                return -1;
              return 2622; /* pool */

            case 20:
              x2 = XVECEXP (x1, 0, 0);
              switch (GET_CODE (x2))
                {
                case CONST_INT:
                case CONST_WIDE_INT:
                case CONST_POLY_INT:
                case CONST_FIXED:
                case CONST_DOUBLE:
                case CONST_VECTOR:
                case CONST:
                case REG:
                case SUBREG:
                case LABEL_REF:
                case SYMBOL_REF:
                case HIGH:
                  operands[0] = x2;
                  if (!nonmemory_operand (operands[0], E_SImode)
                      || !
#line 12481 "../../gcc/config/s390/s390.md"
(TARGET_HTM))
                    return -1;
                  return 2659; /* *tabort_1 */

                case PLUS:
                  if (GET_MODE (x2) != E_SImode)
                    return -1;
                  x9 = XEXP (x2, 0);
                  operands[0] = x9;
                  if (!register_operand (operands[0], E_SImode))
                    return -1;
                  x3 = XEXP (x2, 1);
                  operands[1] = x3;
                  if (!const_int_operand (operands[1], E_SImode)
                      || !
#line 12489 "../../gcc/config/s390/s390.md"
(TARGET_HTM && CONST_OK_FOR_CONSTRAINT_P (INTVAL (operands[1]), 'J', "J")))
                    return -1;
                  return 2660; /* *tabort_1_plus */

                default:
                  return -1;
                }

            case 24:
              x2 = XVECEXP (x1, 0, 0);
              operands[0] = x2;
              if (!register_operand (operands[0], E_SImode)
                  || !
#line 12537 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 2664; /* sfpc */

            case 27:
              x2 = XVECEXP (x1, 0, 0);
              if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 2671; /* osc_break */

            default:
              return -1;
            }

        case 3:
          if (XINT (x1, 1) != 23)
            return -1;
          x2 = XVECEXP (x1, 0, 0);
          operands[0] = x2;
          if (!register_operand (operands[0], E_SImode))
            return -1;
          x5 = XVECEXP (x1, 0, 1);
          operands[1] = x5;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          x10 = XVECEXP (x1, 0, 2);
          operands[2] = x10;
          if (!const_int_operand (operands[2], E_VOIDmode)
              || !
#line 12527 "../../gcc/config/s390/s390.md"
((TARGET_ZEC12 || TARGET_HTM) && INTVAL (operands[2]) < 16))
            return -1;
          return 2663; /* *ppa */

        default:
          return -1;
        }

    case CALL:
      x19 = XEXP (x1, 0);
      if (GET_CODE (x19) != MEM
          || GET_MODE (x19) != E_QImode)
        return -1;
      x18 = XEXP (x1, 1);
      if (!const_int_operand (x18, E_VOIDmode))
        return -1;
      x21 = XEXP (x19, 0);
      switch (GET_CODE (x21))
        {
        case REG:
          if (REGNO (x21) != 1)
            return -1;
          operands[0] = x18;
          if (!
#line 10745 "../../gcc/config/s390/s390.md"
(SIBLING_CALL_P (insn)
   && GET_MODE (XEXP (XEXP (PATTERN (insn), 0), 0)) == Pmode))
            return -1;
          return 2567; /* *sibcall_br */

        case CONST:
        case SYMBOL_REF:
          operands[0] = x21;
          if (!bras_sym_operand (operands[0], E_VOIDmode))
            return -1;
          operands[1] = x18;
          if (
#line 10774 "../../gcc/config/s390/s390.md"
(SIBLING_CALL_P (insn) && TARGET_SMALL_EXEC))
            return 2568; /* *sibcall_brc */
          if (!
#line 10782 "../../gcc/config/s390/s390.md"
(SIBLING_CALL_P (insn)))
            return -1;
          return 2569; /* *sibcall_brcl */

        default:
          return -1;
        }

    case CONST_INT:
      if (XWINT (x1, 0) != 0L)
        return -1;
      return 2609; /* nop */

    case RETURN:
      if (!
#line 11801 "../../gcc/config/s390/s390.md"
(s390_can_use_return_insn ()))
        return -1;
      return 2623; /* return */

    case SIMPLE_RETURN:
      if (!
#line 11801 "../../gcc/config/s390/s390.md"
(s390_can_use_simple_return_insn ()))
        return -1;
      return 2624; /* simple_return */

    case PREFETCH:
      x19 = XEXP (x1, 0);
      operands[0] = x19;
      if (!address_operand (operands[0], E_VOIDmode))
        return -1;
      x18 = XEXP (x1, 1);
      operands[1] = x18;
      if (!const_int_operand (operands[1], E_SImode))
        return -1;
      x22 = XEXP (x1, 2);
      operands[2] = x22;
      if (!const_int_operand (operands[2], E_SImode)
          || !
#line 12015 "../../gcc/config/s390/s390.md"
(TARGET_Z10))
        return -1;
      return 2636; /* prefetch */

    default:
      return -1;
    }
}
