/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern4 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V1QImode:
      return pattern0 (x3, 
E_V1QImode); /* [-1, 0] */

    case E_V2QImode:
      if (pattern0 (x3, 
E_V2QImode) != 0)
        return -1;
      return 1;

    case E_V4QImode:
      if (pattern0 (x3, 
E_V4QImode) != 0)
        return -1;
      return 2;

    case E_V8QImode:
      if (pattern0 (x3, 
E_V8QImode) != 0)
        return -1;
      return 3;

    case E_V16QImode:
      if (pattern0 (x3, 
E_V16QImode) != 0)
        return -1;
      return 4;

    case E_V1HImode:
      if (pattern0 (x3, 
E_V1HImode) != 0)
        return -1;
      return 5;

    case E_V2HImode:
      if (pattern0 (x3, 
E_V2HImode) != 0)
        return -1;
      return 6;

    case E_V4HImode:
      if (pattern0 (x3, 
E_V4HImode) != 0)
        return -1;
      return 7;

    case E_V8HImode:
      if (pattern0 (x3, 
E_V8HImode) != 0)
        return -1;
      return 8;

    case E_V1SImode:
      if (pattern0 (x3, 
E_V1SImode) != 0)
        return -1;
      return 9;

    case E_V2SImode:
      if (pattern0 (x3, 
E_V2SImode) != 0)
        return -1;
      return 10;

    case E_V4SImode:
      if (pattern0 (x3, 
E_V4SImode) != 0)
        return -1;
      return 11;

    case E_V1DImode:
      if (pattern0 (x3, 
E_V1DImode) != 0)
        return -1;
      return 12;

    case E_V2DImode:
      if (pattern0 (x3, 
E_V2DImode) != 0)
        return -1;
      return 13;

    case E_V1TImode:
      if (pattern0 (x3, 
E_V1TImode) != 0)
        return -1;
      return 14;

    case E_TImode:
      if (pattern0 (x3, 
E_TImode) != 0)
        return -1;
      return 15;

    default:
      return -1;
    }
}

int
pattern23 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern22 (x3, 
E_V16QImode); /* [-1, 2] */

    case E_V8HImode:
      res = pattern22 (x3, 
E_V8HImode);
      if (res >= 0)
        return res + 3; /* [3, 5] */
      return -1;

    case E_V4SImode:
      res = pattern22 (x3, 
E_V4SImode);
      if (res >= 0)
        return res + 6; /* [6, 8] */
      return -1;

    case E_V2DImode:
      res = pattern22 (x3, 
E_V2DImode);
      if (res >= 0)
        return res + 9; /* [9, 11] */
      return -1;

    case E_V1TImode:
      res = pattern22 (x3, 
E_V1TImode);
      if (res >= 0)
        return res + 12; /* [12, 14] */
      return -1;

    case E_TImode:
      res = pattern22 (x3, 
E_TImode);
      if (res >= 0)
        return res + 15; /* [15, 17] */
      return -1;

    case E_V4SFmode:
      res = pattern22 (x3, 
E_V4SFmode);
      if (res >= 0)
        return res + 18; /* [18, 20] */
      return -1;

    case E_V2DFmode:
      res = pattern22 (x3, 
E_V2DFmode);
      if (res >= 0)
        return res + 21; /* [21, 23] */
      return -1;

    case E_V1TFmode:
      res = pattern22 (x3, 
E_V1TFmode);
      if (res >= 0)
        return res + 24; /* [24, 26] */
      return -1;

    case E_TFmode:
      res = pattern22 (x3, 
E_TFmode);
      if (res >= 0)
        return res + 27; /* [27, 29] */
      return -1;

    default:
      return -1;
    }
}

int
pattern34 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  if (!s_operand (operands[1], E_QImode))
    return -1;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  if (!nonzero_shift_count_operand (operands[2], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      return 0;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern41 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != CLOBBER)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 33
      || GET_MODE (x2) != E_CCmode)
    return -1;
  return 0;
}

int
pattern46 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 33
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  x8 = XEXP (x6, 1);
  operands[2] = x8;
  switch (GET_MODE (operands[0]))
    {
    case E_TImode:
      return 0;

    case E_DImode:
      return 1;

    default:
      return -1;
    }
}

int
pattern52 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  x3 = XVECEXP (x1, 0, 1);
  operands[2] = x3;
  x4 = XVECEXP (x1, 0, 2);
  operands[3] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern51 (x1, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern51 (x1, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern51 (x1, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V2DImode:
      if (pattern51 (x1, 
E_V2DImode) != 0)
        return -1;
      return 3;

    case E_V1TImode:
      if (pattern51 (x1, 
E_V1TImode) != 0)
        return -1;
      return 4;

    case E_TImode:
      if (pattern51 (x1, 
E_TImode) != 0)
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern60 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_DImode
      || !nonimmediate_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode
      || GET_MODE (x2) != E_DImode)
    return -1;
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  if (!nonimmediate_operand (operands[1], E_DImode))
    return -1;
  x5 = XEXP (x3, 1);
  operands[3] = x5;
  if (!const_int_operand (operands[3], E_DImode))
    return -1;
  return 0;
}

int
pattern71 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      return 0;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern76 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x4, 0);
  if (GET_MODE (x6) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x7 = XEXP (x6, 1);
  if (GET_MODE (x7) != i1
      || !register_operand (operands[2], i2)
      || !nonimmediate_operand (operands[3], i1))
    return -1;
  x8 = XVECEXP (x1, 0, 1);
  x9 = XEXP (x8, 1);
  if (GET_MODE (x9) != i1)
    return -1;
  x10 = XEXP (x9, 1);
  if (GET_MODE (x10) != i1
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern85 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern90 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 33
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[0] = x6;
  return 0;
}

int
pattern96 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 33
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  return pattern95 (x5); /* [-1, 1] */
}

int
pattern103 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x3) != CLOBBER)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 33
      || GET_MODE (x4) != E_CCmode)
    return -1;
  x5 = XVECEXP (x1, 0, 0);
  x6 = XEXP (x5, 0);
  operands[0] = x6;
  if (!memory_operand (operands[0], E_BLKmode))
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 0);
  operands[1] = x8;
  return 0;
}

int
pattern115 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !nonzero_shift_count_operand (operands[2], i1)
      || !contiguous_bitmask_nowrap_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern119 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (maybe_ne (SUBREG_BYTE (x4), 4)
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != ZERO_EXTRACT
      || GET_MODE (x5) != E_DImode)
    return -1;
  x6 = XEXP (x5, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x7) != CLOBBER)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != REG
      || REGNO (x8) != 33
      || GET_MODE (x8) != E_CCmode
      || !nonimmediate_operand (operands[0], E_SImode)
      || GET_MODE (x3) != E_SImode)
    return -1;
  x9 = XEXP (x5, 0);
  operands[1] = x9;
  if (!nonimmediate_operand (operands[1], E_DImode))
    return -1;
  x10 = XEXP (x5, 2);
  operands[2] = x10;
  if (!immediate_operand (operands[2], E_DImode))
    return -1;
  x11 = XEXP (x3, 1);
  operands[3] = x11;
  if (!nonimmediate_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern134 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x1, 1);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[2] = x4;
      switch (GET_MODE (x1))
        {
        case E_DImode:
          if (GET_MODE (x2) != E_DImode
              || !register_operand (operands[1], E_DImode)
              || !register_operand (operands[2], E_DImode))
            return -1;
          return 0;

        case E_SImode:
          if (GET_MODE (x2) != E_SImode
              || !register_operand (operands[1], E_SImode)
              || !register_operand (operands[2], E_SImode))
            return -1;
          return 1;

        default:
          return -1;
        }

    case NOT:
      x5 = XEXP (x4, 0);
      operands[2] = x5;
      switch (GET_MODE (x1))
        {
        case E_DImode:
          if (pattern133 (x1, 
E_DImode) != 0)
            return -1;
          return 2;

        case E_SImode:
          if (pattern133 (x1, 
E_SImode) != 0)
            return -1;
          return 3;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern150 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XVECEXP (x6, 0, 0);
  operands[2] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      return pattern149 (x1); /* [-1, 5] */

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x4) != E_SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_SFmode:
          if (!register_operand (operands[1], E_SFmode))
            return -1;
          switch (GET_MODE (x6))
            {
            case E_DImode:
              if (!immediate_operand (operands[2], E_DImode))
                return -1;
              return 6;

            case E_SImode:
              if (!immediate_operand (operands[2], E_SImode))
                return -1;
              return 7;

            default:
              return -1;
            }

        case E_TFmode:
          if (!register_operand (operands[1], E_TFmode)
              || GET_MODE (x6) != E_SImode
              || !immediate_operand (operands[2], E_SImode))
            return -1;
          return 8;

        case E_FPRX2mode:
          if (!register_operand (operands[1], E_FPRX2mode)
              || GET_MODE (x6) != E_SImode
              || !immediate_operand (operands[2], E_SImode))
            return -1;
          return 9;

        case E_DFmode:
          if (!register_operand (operands[1], E_DFmode)
              || GET_MODE (x6) != E_SImode
              || !immediate_operand (operands[2], E_SImode))
            return -1;
          return 10;

        case E_TDmode:
          if (!register_operand (operands[1], E_TDmode)
              || GET_MODE (x6) != E_SImode
              || !immediate_operand (operands[2], E_SImode))
            return -1;
          return 11;

        case E_DDmode:
          if (!register_operand (operands[1], E_DDmode)
              || GET_MODE (x6) != E_SImode
              || !immediate_operand (operands[2], E_SImode))
            return -1;
          return 12;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern173 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 2);
  if (GET_CODE (x2) != PC)
    return -1;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[3] = x4;
  return pattern172 (); /* [-1, 1] */
}

int
pattern178 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1)
      || !const0_operand (operands[2], i1)
      || !register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern183 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !nonzero_shift_count_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !nonimmediate_operand (operands[3], i1)
      || !nonzero_shift_count_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern192 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  switch (GET_MODE (x6))
    {
    case E_DImode:
      if (!register_operand (operands[1], E_DImode)
          || !scratch_operand (operands[0], E_DImode))
        return -1;
      return 0;

    case E_SImode:
      if (!register_operand (operands[1], E_SImode)
          || !scratch_operand (operands[0], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern198 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern203 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_TImode)
      || GET_MODE (x1) != E_TImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_TImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_TImode)
    return -1;
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  if (!register_operand (operands[1], E_DImode))
    return -1;
  x6 = XEXP (x1, 1);
  if (GET_MODE (x6) != E_TImode)
    return -1;
  return 0;
}

int
pattern214 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern221 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[3], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern234 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || !register_operand (operands[1], E_V16QImode)
          || !scratch_operand (operands[2], E_V16QImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || !register_operand (operands[1], E_V8HImode)
          || !scratch_operand (operands[2], E_V8HImode))
        return -1;
      return 1;

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || !register_operand (operands[1], E_V4SImode)
          || !scratch_operand (operands[2], E_V4SImode))
        return -1;
      return 2;

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || !register_operand (operands[1], E_V2DImode)
          || !scratch_operand (operands[2], E_V2DImode))
        return -1;
      return 3;

    case E_V1TImode:
      if (!register_operand (operands[0], E_V1TImode)
          || !register_operand (operands[1], E_V1TImode)
          || !scratch_operand (operands[2], E_V1TImode))
        return -1;
      return 4;

    case E_TImode:
      if (!register_operand (operands[0], E_TImode)
          || !register_operand (operands[1], E_TImode)
          || !scratch_operand (operands[2], E_TImode))
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern263 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !contiguous_bitmask_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !nonimmediate_operand (operands[3], i1)
      || !const_int_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern272 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[0] = x4;
  if (!bras_sym_operand (operands[0], E_VOIDmode))
    return -1;
  x5 = XVECEXP (x1, 0, 2);
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  x8 = XVECEXP (x1, 0, 3);
  x9 = XEXP (x8, 0);
  operands[3] = x9;
  if (!const_int_operand (operands[3], E_VOIDmode))
    return -1;
  x10 = XVECEXP (x1, 0, 4);
  x11 = XEXP (x10, 0);
  operands[4] = x11;
  if (!const_int_operand (operands[4], E_VOIDmode))
    return -1;
  x12 = XEXP (x2, 0);
  switch (GET_MODE (x12))
    {
    case E_DImode:
      if (GET_MODE (x3) != E_DImode)
        return -1;
      x13 = XVECEXP (x3, 0, 1);
      if (GET_MODE (x13) != E_DImode)
        return -1;
      return 0;

    case E_SImode:
      if (GET_MODE (x3) != E_SImode)
        return -1;
      x13 = XVECEXP (x3, 0, 1);
      if (GET_MODE (x13) != E_SImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern292 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern300 (rtx x1, machine_mode i1, unsigned int i2, unsigned int i3, unsigned int i4, unsigned int i5)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 13);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 14);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != i5
      || GET_MODE (x5) != i1)
    return -1;
  x6 = XVECEXP (x1, 0, 15);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != i4
      || GET_MODE (x7) != i1)
    return -1;
  x8 = XVECEXP (x1, 0, 16);
  if (GET_CODE (x8) != CLOBBER)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != REG
      || REGNO (x9) != i3
      || GET_MODE (x9) != i1)
    return -1;
  x10 = XVECEXP (x1, 0, 17);
  if (GET_CODE (x10) != CLOBBER)
    return -1;
  x11 = XEXP (x10, 0);
  if (GET_CODE (x11) != REG
      || REGNO (x11) != i2
      || GET_MODE (x11) != i1)
    return -1;
  return 0;
}

 int
recog_10 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern28 (x1))
    {
    case 0:
      if (!
#line 1735 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1185; /* vec_widen_umult_even_v1qi */

    case 1:
      if (!
#line 1735 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1186; /* vec_widen_umult_even_v2qi */

    case 2:
      if (!
#line 1735 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1187; /* vec_widen_umult_even_v4qi */

    case 3:
      if (!
#line 1735 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1188; /* vec_widen_umult_even_v8qi */

    case 4:
      if (!
#line 1735 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1189; /* vec_widen_umult_even_v16qi */

    case 5:
      if (!
#line 1735 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1190; /* vec_widen_umult_even_v1hi */

    case 6:
      if (!
#line 1735 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1191; /* vec_widen_umult_even_v2hi */

    case 7:
      if (!
#line 1735 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1192; /* vec_widen_umult_even_v4hi */

    case 8:
      if (!
#line 1735 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1193; /* vec_widen_umult_even_v8hi */

    case 9:
      if (!
#line 1735 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1194; /* vec_widen_umult_even_v1si */

    case 10:
      if (!
#line 1735 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1195; /* vec_widen_umult_even_v2si */

    case 11:
      if (!
#line 1735 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1196; /* vec_widen_umult_even_v4si */

    case 12:
      if (!
#line 1735 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1197; /* vec_widen_umult_even_v1di */

    case 13:
      if (!(
#line 1735 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 71 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
        return -1;
      return 1198; /* vec_widen_umult_even_v2di */

    default:
      return -1;
    }
}

 int
recog_16 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XINT (x2, 1))
    {
    case 63:
      if (GET_MODE (x2) != E_V16QImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V16QImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!memory_operand (operands[1], E_BLKmode))
        return -1;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      if (!const_mask_operand (operands[2], E_QImode)
          || !
#line 201 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && UINTVAL (operands[2]) < 7))
        return -1;
      return 16; /* vlbb */

    case 65:
      if (GET_MODE (x2) != E_V16QImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V16QImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[2] = x4;
      if (!memory_operand (operands[2], E_BLKmode))
        return -1;
      x5 = XVECEXP (x2, 0, 1);
      operands[1] = x5;
      if (!nonmemory_operand (operands[1], E_SImode)
          || !
#line 227 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE))
        return -1;
      return 17; /* *vlrlrv16qi */

    case 66:
      switch (pattern17 (x1))
        {
        case 0:
          if (!
#line 266 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 18; /* vec_packv8hi */

        case 1:
          if (!
#line 266 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 19; /* vec_packv4si */

        case 2:
          if (!
#line 266 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 20; /* vec_packv2di */

        default:
          return -1;
        }

    case 67:
      switch (pattern17 (x1))
        {
        case 0:
          if (!
#line 279 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 21; /* vec_packsv8hi */

        case 1:
          if (!
#line 279 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 22; /* vec_packsv4si */

        case 2:
          if (!
#line 279 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 23; /* vec_packsv2di */

        default:
          return -1;
        }

    case 70:
      switch (pattern17 (x1))
        {
        case 0:
          if (!
#line 325 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 27; /* vec_packsuv8hi */

        case 1:
          if (!
#line 325 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 28; /* vec_packsuv4si */

        case 2:
          if (!
#line 325 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 29; /* vec_packsuv2di */

        default:
          return -1;
        }

    case 75:
      return recog_2 (x1, insn, pnum_clobbers);

    case 76:
      if (GET_MODE (x2) != E_BLKmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[2] = x3;
      if (!memory_operand (operands[2], E_BLKmode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_V16QImode))
        return -1;
      x5 = XVECEXP (x2, 0, 1);
      operands[1] = x5;
      if (!nonmemory_operand (operands[1], E_SImode)
          || !
#line 593 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE))
        return -1;
      return 92; /* *vstrlrv16qi */

    case 77:
      if (pattern18 (x1, 
E_V16QImode, 
E_V2DImode) != 0
          || !
#line 609 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE))
        return -1;
      return 93; /* vbpermv16qi */

    case 82:
      switch (pattern20 (x1))
        {
        case 0:
          if (!
#line 665 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 110; /* vaccb_v16qi */

        case 1:
          if (!
#line 665 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 111; /* vacch_v8hi */

        case 2:
          if (!
#line 665 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 112; /* vaccf_v4si */

        case 3:
          if (!
#line 665 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 113; /* vaccg_v2di */

        case 4:
          if (!
#line 665 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 114; /* vaccq_v1ti */

        case 5:
          if (!
#line 665 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 115; /* vaccq_ti */

        default:
          return -1;
        }

    case 85:
      switch (pattern20 (x1))
        {
        case 0:
          if (!
#line 717 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 127; /* vec_avgv16qi */

        case 1:
          if (!
#line 717 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 128; /* vec_avgv8hi */

        case 2:
          if (!
#line 717 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 129; /* vec_avgv4si */

        case 3:
          if (!
#line 717 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 130; /* vec_avgv2di */

        case 4:
          if (!(
#line 717 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 51 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 131; /* vec_avgv1ti */

        case 5:
          if (!(
#line 717 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 51 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 132; /* vec_avgti */

        default:
          return -1;
        }

    case 86:
      switch (pattern20 (x1))
        {
        case 0:
          if (!
#line 729 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 133; /* vec_avguv16qi */

        case 1:
          if (!
#line 729 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 134; /* vec_avguv8hi */

        case 2:
          if (!
#line 729 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 135; /* vec_avguv4si */

        case 3:
          if (!
#line 729 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 136; /* vec_avguv2di */

        case 4:
          if (!(
#line 729 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 51 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 137; /* vec_avguv1ti */

        case 5:
          if (!(
#line 729 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 51 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 138; /* vec_avguti */

        default:
          return -1;
        }

    case 87:
      if (pattern21 (x1, 
E_V4SImode) != 0
          || !
#line 741 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 139; /* vec_checksum */

    case 88:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          if (pattern19 (x2, 
E_V16QImode) != 0
              || !
#line 850 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 140; /* vec_gfmsumv16qi */

        case E_V8HImode:
          if (pattern19 (x2, 
E_V8HImode) != 0
              || !
#line 850 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 141; /* vec_gfmsumv8hi */

        case E_V4SImode:
          if (pattern19 (x2, 
E_V4SImode) != 0
              || !
#line 850 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 142; /* vec_gfmsumv4si */

        default:
          return -1;
        }

    case 89:
      if (pattern18 (x1, 
E_V2DImode, 
E_V16QImode) != 0
          || !
#line 859 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 143; /* vec_gfmsum_128 */

    case 47:
      switch (pattern20 (x1))
        {
        case 0:
          if (!
#line 989 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 182; /* vec_smulhv16qi */

        case 1:
          if (!
#line 989 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 183; /* vec_smulhv8hi */

        case 2:
          if (!
#line 989 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 184; /* vec_smulhv4si */

        case 3:
          if (!(
#line 989 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 52 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 185; /* vec_smulhv2di */

        case 4:
          if (!(
#line 989 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 52 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 186; /* vec_smulhv1ti */

        case 5:
          if (!(
#line 989 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 52 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 187; /* vec_smulhti */

        default:
          return -1;
        }

    case 48:
      switch (pattern20 (x1))
        {
        case 0:
          if (!
#line 999 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 188; /* vec_umulhv16qi */

        case 1:
          if (!
#line 999 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 189; /* vec_umulhv8hi */

        case 2:
          if (!
#line 999 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 190; /* vec_umulhv4si */

        case 3:
          if (!(
#line 999 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 52 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 191; /* vec_umulhv2di */

        case 4:
          if (!(
#line 999 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 52 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 192; /* vec_umulhv1ti */

        case 5:
          if (!(
#line 999 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 52 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 193; /* vec_umulhti */

        default:
          return -1;
        }

    case 97:
      return recog_6 (x1, insn, pnum_clobbers);

    case 102:
      return recog_5 (x1, insn, pnum_clobbers);

    case 103:
      switch (pattern24 (x1))
        {
        case 0:
          if (!
#line 1130 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 297; /* vec_srabv16qi */

        case 1:
          if (!
#line 1130 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 298; /* vec_srabv8hi */

        case 2:
          if (!
#line 1130 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 299; /* vec_srabv4si */

        case 3:
          if (!
#line 1130 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 300; /* vec_srabv2di */

        case 4:
          if (!
#line 1130 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 301; /* vec_srabv1ti */

        case 5:
          if (!
#line 1130 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 302; /* vec_srabti */

        case 6:
          if (!
#line 1130 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 303; /* vec_srabv4sf */

        case 7:
          if (!
#line 1130 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 304; /* vec_srabv2df */

        case 8:
          if (!
#line 1130 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 305; /* vec_srabv1tf */

        case 9:
          if (!
#line 1130 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 306; /* vec_srabtf */

        default:
          return -1;
        }

    case 104:
      return recog_4 (x1, insn, pnum_clobbers);

    case 106:
      switch (pattern20 (x1))
        {
        case 0:
          if (!
#line 1167 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 337; /* vscbib_v16qi */

        case 1:
          if (!
#line 1167 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 338; /* vscbih_v8hi */

        case 2:
          if (!
#line 1167 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 339; /* vscbif_v4si */

        case 3:
          if (!
#line 1167 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 340; /* vscbig_v2di */

        case 4:
          if (!
#line 1167 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 341; /* vscbiq_v1ti */

        case 5:
          if (!
#line 1167 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 342; /* vscbiq_ti */

        default:
          return -1;
        }

    case 94:
      if (GET_MODE (x2) != E_V2DImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V2DImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[1]))
        {
        case E_V4SImode:
          if (!register_operand (operands[1], E_V4SImode)
              || !register_operand (operands[2], E_V4SImode)
              || !
#line 1215 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 345; /* vec_sum_u128v4si */

        case E_V2DImode:
          if (!register_operand (operands[1], E_V2DImode)
              || !register_operand (operands[2], E_V2DImode)
              || !
#line 1215 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 346; /* vec_sum_u128v2di */

        default:
          return -1;
        }

    case 109:
      return recog_3 (x1, insn, pnum_clobbers);

    case 130:
      return recog_12 (x1, insn, pnum_clobbers);

    case 138:
      if (pattern26 (x1, 
3, 
2, 
1, 
0) != 0
          || !
#line 2224 "../../gcc/config/s390/vx-builtins.md"
(TARGET_NNPA))
        return -1;
      return 501; /* vclfnhs_v8hi */

    case 139:
      if (pattern26 (x1, 
7, 
6, 
5, 
4) != 0
          || !
#line 2235 "../../gcc/config/s390/vx-builtins.md"
(TARGET_NNPA))
        return -1;
      return 502; /* vclfnls_v8hi */

    case 141:
      if (pattern27 (x1) != 0
          || !
#line 2254 "../../gcc/config/s390/vx-builtins.md"
(TARGET_NNPA))
        return -1;
      return 504; /* vcfn_v8hi */

    case 142:
      if (pattern27 (x1) != 0
          || !
#line 2263 "../../gcc/config/s390/vx-builtins.md"
(TARGET_NNPA))
        return -1;
      return 505; /* vcnf_v8hi */

    case 93:
      if (GET_MODE (x2) != E_V2DImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V2DImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[1]))
        {
        case E_V8HImode:
          if (!register_operand (operands[1], E_V8HImode)
              || !register_operand (operands[2], E_V8HImode)
              || !
#line 1240 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 768; /* *vec_sum2v8hi */

        case E_V4SImode:
          if (!register_operand (operands[1], E_V4SImode)
              || !register_operand (operands[2], E_V4SImode)
              || !
#line 1240 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 769; /* *vec_sum2v4si */

        default:
          return -1;
        }

    case 95:
      if (GET_MODE (x2) != E_V4SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V4SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[1]))
        {
        case E_V16QImode:
          if (!register_operand (operands[1], E_V16QImode)
              || !register_operand (operands[2], E_V16QImode)
              || !
#line 1250 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 770; /* *vec_sum4v16qi */

        case E_V8HImode:
          if (!register_operand (operands[1], E_V8HImode)
              || !register_operand (operands[2], E_V8HImode)
              || !
#line 1250 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 771; /* *vec_sum4v8hi */

        default:
          return -1;
        }

    case 105:
      switch (pattern24 (x1))
        {
        case 0:
          if (!
#line 1586 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1087; /* *vec_srbv16qi */

        case 1:
          if (!
#line 1586 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1088; /* *vec_srbv8hi */

        case 2:
          if (!
#line 1586 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1089; /* *vec_srbv4si */

        case 3:
          if (!
#line 1586 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1090; /* *vec_srbv2di */

        case 4:
          if (!
#line 1586 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1091; /* *vec_srbv1ti */

        case 5:
          if (!
#line 1586 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1092; /* *vec_srbti */

        case 6:
          if (!
#line 1586 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1093; /* *vec_srbv4sf */

        case 7:
          if (!
#line 1586 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1094; /* *vec_srbv2df */

        case 8:
          if (!
#line 1586 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1095; /* *vec_srbv1tf */

        case 9:
          if (!
#line 1586 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1096; /* *vec_srbtf */

        default:
          return -1;
        }

    case 98:
      return recog_13 (x1, insn, pnum_clobbers);

    case 50:
      return recog_11 (x1, insn, pnum_clobbers);

    case 51:
      return recog_10 (x1, insn, pnum_clobbers);

    case 52:
      return recog_9 (x1, insn, pnum_clobbers);

    case 53:
      return recog_8 (x1, insn, pnum_clobbers);

    case 64:
      if (GET_MODE (x2) != E_V16QImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V16QImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      if (!memory_operand (operands[2], E_BLKmode)
          || !
#line 2457 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1412; /* vllv16qi */

    case 3:
      if (GET_MODE (x2) != E_BLKmode)
        return -1;
      x5 = XVECEXP (x2, 0, 1);
      if (GET_CODE (x5) != REG
          || REGNO (x5) != 0
          || GET_MODE (x5) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!memory_operand (operands[0], E_BLKmode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!memory_operand (operands[1], E_BLKmode)
          || !
#line 3738 "../../gcc/config/s390/s390.md"
(TARGET_Z15))
        return -1;
      return 1897; /* *mvcrl */

    case 36:
      return recog_7 (x1, insn, pnum_clobbers);

    case 1:
      if (pnum_clobbers == NULL)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!s_operand (operands[1], E_BLKmode))
        return -1;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      if (!const_int_operand (operands[2], E_VOIDmode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode)
            return -1;
          *pnum_clobbers = 1;
          return 1923; /* *sethighpartsi */

        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x2) != E_DImode)
            return -1;
          if (
#line 4264 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            {
              *pnum_clobbers = 1;
              return 1924; /* *sethighpartdi_64 */
            }
          if (!
#line 4274 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
            return -1;
          *pnum_clobbers = 1;
          return 1925; /* *sethighpartdi_31 */

        default:
          return -1;
        }

    case 38:
      if (pattern21 (x1, 
E_DImode) != 0
          || !
#line 4950 "../../gcc/config/s390/s390.md"
(TARGET_Z17 && TARGET_64BIT))
        return -1;
      return 2012; /* bdepg */

    case 39:
      if (pattern21 (x1, 
E_DImode) != 0
          || !
#line 4963 "../../gcc/config/s390/s390.md"
(TARGET_Z17 && TARGET_64BIT))
        return -1;
      return 2013; /* bextg */

    case 29:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x2) != E_DImode
              || !memory_operand (operands[1], E_DImode)
              || !
#line 11094 "../../gcc/config/s390/s390.md"
(TARGET_64BIT))
            return -1;
          return 2587; /* *tls_load_64 */

        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode
              || !memory_operand (operands[1], E_SImode)
              || !
#line 11104 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT))
            return -1;
          return 2588; /* *tls_load_31 */

        default:
          return -1;
        }

    case 34:
      if (pattern25 (x1, 
E_CCZmode) != 0)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (!memory_operand (operands[0], E_DImode)
              || !memory_operand (operands[1], E_DImode))
            return -1;
          return 2631; /* stack_protect_testdi */

        case E_SImode:
          if (!memory_operand (operands[0], E_SImode)
              || !memory_operand (operands[1], E_SImode))
            return -1;
          return 2632; /* stack_protect_testsi */

        default:
          return -1;
        }

    case 2:
      if (GET_MODE (x2) != E_BLKmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!memory_operand (operands[0], E_BLKmode))
        return -1;
      x5 = XVECEXP (x2, 0, 1);
      operands[1] = x5;
      x4 = XVECEXP (x2, 0, 0);
      if (!rtx_equal_p (x4, operands[0]))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_DImode:
          if (!register_operand (operands[1], E_DImode)
              || !
#line 778 "../../gcc/config/s390/s390.md"
(TARGET_64BIT))
            return -1;
          return 2633; /* stack_tiedi */

        case E_SImode:
          if (!register_operand (operands[1], E_SImode)
              || !
#line 778 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT))
            return -1;
          return 2634; /* stack_tiesi */

        default:
          return -1;
        }

    case 46:
      if (pnum_clobbers == NULL
          || GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!address_operand (operands[1], E_VOIDmode))
        return -1;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      if (!immediate_operand (operands[2], E_SImode)
          || !
#line 12554 "../../gcc/config/s390/s390.md"
(TARGET_Z13))
        return -1;
      *pnum_clobbers = 1;
      return 2666; /* lcbb */

    default:
      return -1;
    }
}

 int
recog_45 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  switch (GET_CODE (x2))
    {
    case REG:
    case SUBREG:
    case MEM:
      res = recog_40 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case STRICT_LOW_PART:
      x3 = XEXP (x2, 0);
      operands[0] = x3;
      x4 = XEXP (x1, 1);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (subreg_register_operand (operands[0], E_QImode)
              && memory_operand (operands[1], E_QImode))
            return 1861; /* movstrictqi */
          break;

        case E_HImode:
          if (pnum_clobbers != NULL
              && subreg_register_operand (operands[0], E_HImode)
              && memory_operand (operands[1], E_HImode))
            {
              *pnum_clobbers = 1;
              return 1862; /* movstricthi */
            }
          break;

        case E_SImode:
          if (subreg_register_operand (operands[0], E_SImode)
              && general_operand (operands[1], E_SImode)
              && 
#line 2773 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return 1863; /* movstrictsi */
          break;

        default:
          break;
        }
      break;

    case ZERO_EXTRACT:
      res = recog_43 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    default:
      break;
    }
  x4 = XEXP (x1, 1);
  switch (GET_CODE (x4))
    {
    case SUBREG:
      res = recog_44 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case LABEL_REF:
      if (GET_CODE (x2) == PC)
        {
          x5 = XEXP (x4, 0);
          operands[0] = x5;
          return 2546; /* *jump64 */
        }
      break;

    default:
      break;
    }
  operands[1] = x4;
  operands[0] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_TImode:
      if (!nonimmediate_operand (operands[0], E_TImode)
          || !general_operand (operands[1], E_TImode)
          || !
#line 1769 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
        return -1;
      return 1816; /* movti */

    case E_TFmode:
      if (!nonimmediate_operand (operands[0], E_TFmode)
          || !general_operand (operands[1], E_TFmode))
        return -1;
      if ((
#line 2797 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH) && 
#line 764 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
        return 1864; /* *movtf_64 */
      if (!(
#line 2814 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH) && 
#line 764 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
        return -1;
      return 1867; /* *movtf_31 */

    default:
      return -1;
    }
}

 int
recog_52 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case PLUS:
    case MINUS:
    case MULT:
    case AND:
    case SIGN_EXTEND:
    case ZERO_EXTEND:
    case HIGH:
      operands[1] = x3;
      if (address_operand (operands[1], E_QImode))
        {
          x4 = XEXP (x2, 1);
          if (GET_CODE (x4) == CONST_INT
              && XWINT (x4, 0) == 2147483647L
              && register_operand (operands[0], E_SImode)
              && GET_MODE (x2) == E_SImode)
            {
              if (
#line 2575 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT))
                return 1856; /* *la_31_and */
              if (pnum_clobbers != NULL
                  && 
#line 2589 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT))
                {
                  *pnum_clobbers = 1;
                  return 1857; /* *la_31_and_cc */
                }
            }
        }
      if (GET_CODE (x3) == SUBREG)
        {
          res = recog_51 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[1] = x3;
      x4 = XEXP (x2, 1);
      if (GET_CODE (x4) == CONST_INT
          && XWINT (x4, 0) == 2147483647L)
        {
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (register_operand (operands[0], E_SImode)
                  && GET_MODE (x2) == E_SImode
                  && nonimmediate_operand (operands[1], E_SImode)
                  && 
#line 5189 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                return 2028; /* *llgt_sisi */
              break;

            case E_DImode:
              if (register_operand (operands[0], E_DImode)
                  && GET_MODE (x2) == E_DImode
                  && nonimmediate_operand (operands[1], E_DImode)
                  && 
#line 5200 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                return 2029; /* *llgt_didi */
              break;

            default:
              break;
            }
        }
      if (pnum_clobbers == NULL)
        return -1;
      switch (pattern158 (x2))
        {
        case 0:
          if (!
#line 7961 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
            return -1;
          *pnum_clobbers = 1;
          return 2348; /* *anddi3 */

        case 1:
          if (
#line 8090 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
            {
              *pnum_clobbers = 1;
              return 2359; /* *andsi3_zarch */
            }
          if (!
#line 8124 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
            return -1;
          *pnum_clobbers = 1;
          return 2360; /* *andsi3_esa */

        default:
          return -1;
        }

    case ROTATE:
      if (pattern66 (x2, 
E_DImode) != 0)
        return -1;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      if (!const_int_operand (operands[2], E_DImode))
        return -1;
      x4 = XEXP (x2, 1);
      operands[3] = x4;
      if (!contiguous_bitmask_operand (operands[3], E_DImode))
        return -1;
      if (
#line 4404 "../../gcc/config/s390/s390.md"
(TARGET_ZEC12))
        return 1950; /* *risbgn_di_and_rot */
      if (pnum_clobbers == NULL
          || !
#line 4404 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12))
        return -1;
      *pnum_clobbers = 1;
      return 1951; /* *risbg_di_and_rot */

    case LSHIFTRT:
      switch (pattern116 (x2))
        {
        case 0:
          if ((
#line 8011 "../../gcc/config/s390/s390.md"
(TARGET_ZEC12
   /* Note that even for the SImode pattern, the rotate is always DImode.  */
   && s390_extzv_shift_ok (64, -INTVAL (operands[2]),
			   INTVAL (operands[3]))) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return 2349; /* *extzv_di_srl_nocc */
          if (pnum_clobbers == NULL
              || !(
#line 8011 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   /* Note that even for the SImode pattern, the rotate is always DImode.  */
   && s390_extzv_shift_ok (64, -INTVAL (operands[2]),
			   INTVAL (operands[3]))) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 2350; /* *extzv_di_srl_clobbercc */

        case 1:
          if (
#line 8011 "../../gcc/config/s390/s390.md"
(TARGET_ZEC12
   /* Note that even for the SImode pattern, the rotate is always DImode.  */
   && s390_extzv_shift_ok (32, -INTVAL (operands[2]),
			   INTVAL (operands[3]))))
            return 2351; /* *extzv_si_srl_nocc */
          if (pnum_clobbers == NULL
              || !
#line 8011 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   /* Note that even for the SImode pattern, the rotate is always DImode.  */
   && s390_extzv_shift_ok (32, -INTVAL (operands[2]),
			   INTVAL (operands[3]))))
            return -1;
          *pnum_clobbers = 1;
          return 2352; /* *extzv_si_srl_clobbercc */

        default:
          return -1;
        }

    case ASHIFT:
      switch (pattern116 (x2))
        {
        case 0:
          if ((
#line 8025 "../../gcc/config/s390/s390.md"
(TARGET_ZEC12
   && s390_extzv_shift_ok (64, INTVAL (operands[2]),
			   INTVAL (operands[3]))) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return 2353; /* *extzv_di_sll_nocc */
          if (pnum_clobbers == NULL
              || !(
#line 8025 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && s390_extzv_shift_ok (64, INTVAL (operands[2]),
			   INTVAL (operands[3]))) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 2354; /* *extzv_di_sll_clobbercc */

        case 1:
          if (
#line 8025 "../../gcc/config/s390/s390.md"
(TARGET_ZEC12
   && s390_extzv_shift_ok (32, INTVAL (operands[2]),
			   INTVAL (operands[3]))))
            return 2355; /* *extzv_si_sll_nocc */
          if (pnum_clobbers == NULL
              || !
#line 8025 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && s390_extzv_shift_ok (32, INTVAL (operands[2]),
			   INTVAL (operands[3]))))
            return -1;
          *pnum_clobbers = 1;
          return 2356; /* *extzv_si_sll_clobbercc */

        default:
          return -1;
        }

    case NOT:
      if (pnum_clobbers == NULL)
        return -1;
      x6 = XEXP (x3, 0);
      operands[1] = x6;
      x4 = XEXP (x2, 1);
      switch (GET_CODE (x4))
        {
        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case MEM:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          operands[2] = x4;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (GET_MODE (x2) != E_DImode
                  || GET_MODE (x3) != E_DImode)
                return -1;
              if (nonimmediate_operand (operands[0], E_DImode)
                  && nonimmediate_operand (operands[1], E_DImode)
                  && general_operand (operands[2], E_DImode)
                  && (
#line 8233 "../../gcc/config/s390/s390.md"
(!TARGET_Z15
   && ! reload_completed
   && (GET_CODE (operands[0]) != MEM
      /* Ensure that s390_logical_operator_ok_p will succeed even
	 on the split xor if (b & a) is stored into a pseudo.  */
       || rtx_equal_p (operands[0], operands[2]))) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                {
                  *pnum_clobbers = 1;
                  return 2365; /* *andc_split_di */
                }
              if (!register_operand (operands[0], E_DImode)
                  || !register_operand (operands[1], E_DImode)
                  || !register_operand (operands[2], E_DImode)
                  || !(
#line 8612 "../../gcc/config/s390/s390.md"
(TARGET_Z15) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              *pnum_clobbers = 1;
              return 2387; /* *andcdi */

            case E_SImode:
              if (GET_MODE (x2) != E_SImode
                  || GET_MODE (x3) != E_SImode)
                return -1;
              if (nonimmediate_operand (operands[0], E_SImode)
                  && nonimmediate_operand (operands[1], E_SImode)
                  && general_operand (operands[2], E_SImode)
                  && 
#line 8233 "../../gcc/config/s390/s390.md"
(!TARGET_Z15
   && ! reload_completed
   && (GET_CODE (operands[0]) != MEM
      /* Ensure that s390_logical_operator_ok_p will succeed even
	 on the split xor if (b & a) is stored into a pseudo.  */
       || rtx_equal_p (operands[0], operands[2]))))
                {
                  *pnum_clobbers = 1;
                  return 2366; /* *andc_split_si */
                }
              if (!register_operand (operands[0], E_SImode)
                  || !register_operand (operands[1], E_SImode)
                  || !register_operand (operands[2], E_SImode)
                  || !
#line 8612 "../../gcc/config/s390/s390.md"
(TARGET_Z15))
                return -1;
              *pnum_clobbers = 1;
              return 2389; /* *andcsi */

            default:
              return -1;
            }

        case NOT:
          x7 = XEXP (x4, 0);
          operands[2] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (pattern130 (x2, 
E_DImode) != 0
                  || !(
#line 8652 "../../gcc/config/s390/s390.md"
(TARGET_Z15) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              *pnum_clobbers = 1;
              return 2399; /* *nordi */

            case E_SImode:
              if (pattern130 (x2, 
E_SImode) != 0
                  || !
#line 8652 "../../gcc/config/s390/s390.md"
(TARGET_Z15))
                return -1;
              *pnum_clobbers = 1;
              return 2401; /* *norsi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_61 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      switch (pattern65 (x3, pnum_clobbers))
        {
        case 0:
          if (
#line 1304 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 860; /* xorv1qi3 */
          break;

        case 1:
          if (
#line 1304 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 861; /* xorv2qi3 */
          break;

        case 2:
          if (
#line 1304 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 862; /* xorv4qi3 */
          break;

        case 3:
          if (
#line 1304 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 863; /* xorv8qi3 */
          break;

        case 4:
          if (
#line 1304 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 864; /* xorv16qi3 */
          break;

        case 5:
          if (
#line 1304 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 865; /* xorv1hi3 */
          break;

        case 6:
          if (
#line 1304 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 866; /* xorv2hi3 */
          break;

        case 7:
          if (
#line 1304 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 867; /* xorv4hi3 */
          break;

        case 8:
          if (
#line 1304 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 868; /* xorv8hi3 */
          break;

        case 9:
          if (
#line 1304 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 869; /* xorv1si3 */
          break;

        case 10:
          if (
#line 1304 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 870; /* xorv2si3 */
          break;

        case 11:
          if (
#line 1304 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 871; /* xorv4si3 */
          break;

        case 12:
          if (
#line 1304 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 872; /* xorv1di3 */
          break;

        case 13:
          if (
#line 1304 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 873; /* xorv2di3 */
          break;

        case 14:
          if (
#line 1304 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 874; /* xorv1sf3 */
          break;

        case 15:
          if (
#line 1304 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 875; /* xorv2sf3 */
          break;

        case 16:
          if (
#line 1304 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 876; /* xorv4sf3 */
          break;

        case 17:
          if (
#line 1304 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 877; /* xorv1df3 */
          break;

        case 18:
          if (
#line 1304 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 878; /* xorv2df3 */
          break;

        case 19:
          if (
#line 1304 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 879; /* xorv1tf3 */
          break;

        case 20:
          if (
#line 1304 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 880; /* xorv1ti3 */
          break;

        case 21:
          if (
#line 1304 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 881; /* xorti3 */
          break;

        case 22:
          if (
#line 8792 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
            {
              *pnum_clobbers = 1;
              return 2408; /* *xordi3 */
            }
          break;

        case 23:
          if (
#line 8895 "../../gcc/config/s390/s390.md"
(s390_logical_operator_ok_p (operands)))
            {
              *pnum_clobbers = 1;
              return 2412; /* *xorhi3 */
            }
          break;

        case 24:
          if (
#line 8925 "../../gcc/config/s390/s390.md"
(s390_logical_operator_ok_p (operands)))
            {
              *pnum_clobbers = 1;
              return 2413; /* *xorqi3 */
            }
          break;

        default:
          break;
        }
      if (pnum_clobbers == NULL
          || !nonimmediate_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      if (GET_CODE (x4) == SUBREG
          && pattern131 (x3) == 0
          && 
#line 4792 "../../gcc/config/s390/s390.md"
(TARGET_Z10))
        {
          *pnum_clobbers = 1;
          return 2003; /* *rxsbg_sidi_srl */
        }
      operands[1] = x4;
      if (!nonimmediate_operand (operands[1], E_SImode))
        return -1;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      if (!general_operand (operands[2], E_SImode)
          || !
#line 8862 "../../gcc/config/s390/s390.md"
(s390_logical_operator_ok_p (operands)))
        return -1;
      *pnum_clobbers = 1;
      return 2411; /* *xorsi3 */

    case AND:
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      x7 = XEXP (x4, 0);
      switch (GET_CODE (x7))
        {
        case REG:
        case SUBREG:
        case MEM:
          operands[1] = x7;
          x5 = XEXP (x3, 1);
          operands[3] = x5;
          switch (GET_CODE (operands[2]))
            {
            case REG:
            case SUBREG:
              switch (GET_MODE (operands[0]))
                {
                case E_V1QImode:
                  if (pattern8 (x3, 
E_V1QImode) != 0
                      || !
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                    return -1;
                  return 1585; /* *vevalv1qi_xorand */

                case E_V2QImode:
                  if (pattern8 (x3, 
E_V2QImode) != 0
                      || !
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                    return -1;
                  return 1594; /* *vevalv2qi_xorand */

                case E_V4QImode:
                  if (pattern8 (x3, 
E_V4QImode) != 0
                      || !
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                    return -1;
                  return 1603; /* *vevalv4qi_xorand */

                case E_V8QImode:
                  if (pattern8 (x3, 
E_V8QImode) != 0
                      || !
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                    return -1;
                  return 1612; /* *vevalv8qi_xorand */

                case E_V16QImode:
                  if (pattern8 (x3, 
E_V16QImode) != 0
                      || !
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                    return -1;
                  return 1621; /* *vevalv16qi_xorand */

                case E_V1HImode:
                  if (pattern8 (x3, 
E_V1HImode) != 0
                      || !
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                    return -1;
                  return 1630; /* *vevalv1hi_xorand */

                case E_V2HImode:
                  if (pattern8 (x3, 
E_V2HImode) != 0
                      || !
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                    return -1;
                  return 1639; /* *vevalv2hi_xorand */

                case E_V4HImode:
                  if (pattern8 (x3, 
E_V4HImode) != 0
                      || !
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                    return -1;
                  return 1648; /* *vevalv4hi_xorand */

                case E_V8HImode:
                  if (pattern8 (x3, 
E_V8HImode) != 0
                      || !
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                    return -1;
                  return 1657; /* *vevalv8hi_xorand */

                case E_V1SImode:
                  if (pattern8 (x3, 
E_V1SImode) != 0
                      || !
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                    return -1;
                  return 1666; /* *vevalv1si_xorand */

                case E_V2SImode:
                  if (pattern8 (x3, 
E_V2SImode) != 0
                      || !
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                    return -1;
                  return 1675; /* *vevalv2si_xorand */

                case E_V4SImode:
                  if (pattern8 (x3, 
E_V4SImode) != 0
                      || !
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                    return -1;
                  return 1684; /* *vevalv4si_xorand */

                case E_V1DImode:
                  if (pattern8 (x3, 
E_V1DImode) != 0
                      || !
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                    return -1;
                  return 1693; /* *vevalv1di_xorand */

                case E_V2DImode:
                  if (pattern8 (x3, 
E_V2DImode) != 0
                      || !
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                    return -1;
                  return 1702; /* *vevalv2di_xorand */

                case E_V1TImode:
                  if (pattern8 (x3, 
E_V1TImode) != 0
                      || !
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                    return -1;
                  return 1711; /* *vevalv1ti_xorand */

                case E_TImode:
                  if (pattern8 (x3, 
E_TImode) != 0
                      || !
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                    return -1;
                  return 1720; /* *vevalti_xorand */

                default:
                  return -1;
                }

            case CONST_INT:
              if (pnum_clobbers == NULL)
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_DImode:
                  if (pattern189 (x3, 
E_DImode) != 0
                      || !(
#line 4685 "../../gcc/config/s390/s390.md"
(TARGET_Z10) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 1981; /* *rxsbg_di_noshift */

                case E_SImode:
                  if (pattern189 (x3, 
E_SImode) != 0
                      || !
#line 4685 "../../gcc/config/s390/s390.md"
(TARGET_Z10))
                    return -1;
                  *pnum_clobbers = 1;
                  return 1983; /* *rxsbg_si_noshift */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case ROTATE:
          if (pattern60 (x3, pnum_clobbers) != 0
              || !contiguous_bitmask_operand (operands[2], E_DImode))
            return -1;
          x5 = XEXP (x3, 1);
          operands[4] = x5;
          if (!nonimmediate_operand (operands[4], E_DImode)
              || !
#line 4700 "../../gcc/config/s390/s390.md"
(TARGET_Z10))
            return -1;
          *pnum_clobbers = 1;
          return 1985; /* *rxsbg_di_rotl */

        case LSHIFTRT:
          switch (pattern86 (x3, pnum_clobbers))
            {
            case 0:
              if (!(
#line 4715 "../../gcc/config/s390/s390.md"
(TARGET_Z10
   && s390_extzv_shift_ok (64, 64 - INTVAL (operands[3]),
                           INTVAL (operands[2]))) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              *pnum_clobbers = 1;
              return 1987; /* *rxsbg_di_srl_bitmask */

            case 1:
              if (!
#line 4715 "../../gcc/config/s390/s390.md"
(TARGET_Z10
   && s390_extzv_shift_ok (32, 64 - INTVAL (operands[3]),
                           INTVAL (operands[2]))))
                return -1;
              *pnum_clobbers = 1;
              return 1989; /* *rxsbg_si_srl_bitmask */

            default:
              return -1;
            }

        case ASHIFT:
          switch (pattern86 (x3, pnum_clobbers))
            {
            case 0:
              if (!(
#line 4735 "../../gcc/config/s390/s390.md"
(TARGET_Z10
   && s390_extzv_shift_ok (64, INTVAL (operands[3]),
                           INTVAL (operands[2]))) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              *pnum_clobbers = 1;
              return 1991; /* *rxsbg_di_sll_bitmask */

            case 1:
              if (!
#line 4735 "../../gcc/config/s390/s390.md"
(TARGET_Z10
   && s390_extzv_shift_ok (32, INTVAL (operands[3]),
                           INTVAL (operands[2]))))
                return -1;
              *pnum_clobbers = 1;
              return 1993; /* *rxsbg_si_sll_bitmask */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case IOR:
      switch (pattern29 (x3))
        {
        case 0:
          if (!
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1586; /* *vevalv1qi_xorior */

        case 1:
          if (!
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1595; /* *vevalv2qi_xorior */

        case 2:
          if (!
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1604; /* *vevalv4qi_xorior */

        case 3:
          if (!
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1613; /* *vevalv8qi_xorior */

        case 4:
          if (!
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1622; /* *vevalv16qi_xorior */

        case 5:
          if (!
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1631; /* *vevalv1hi_xorior */

        case 6:
          if (!
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1640; /* *vevalv2hi_xorior */

        case 7:
          if (!
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1649; /* *vevalv4hi_xorior */

        case 8:
          if (!
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1658; /* *vevalv8hi_xorior */

        case 9:
          if (!
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1667; /* *vevalv1si_xorior */

        case 10:
          if (!
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1676; /* *vevalv2si_xorior */

        case 11:
          if (!
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1685; /* *vevalv4si_xorior */

        case 12:
          if (!
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1694; /* *vevalv1di_xorior */

        case 13:
          if (!
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1703; /* *vevalv2di_xorior */

        case 14:
          if (!
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1712; /* *vevalv1ti_xorior */

        case 15:
          if (!
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1721; /* *vevalti_xorior */

        default:
          return -1;
        }

    case XOR:
      switch (pattern29 (x3))
        {
        case 0:
          if (!
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1587; /* *vevalv1qi_xorxor */

        case 1:
          if (!
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1596; /* *vevalv2qi_xorxor */

        case 2:
          if (!
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1605; /* *vevalv4qi_xorxor */

        case 3:
          if (!
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1614; /* *vevalv8qi_xorxor */

        case 4:
          if (!
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1623; /* *vevalv16qi_xorxor */

        case 5:
          if (!
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1632; /* *vevalv1hi_xorxor */

        case 6:
          if (!
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1641; /* *vevalv2hi_xorxor */

        case 7:
          if (!
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1650; /* *vevalv4hi_xorxor */

        case 8:
          if (!
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1659; /* *vevalv8hi_xorxor */

        case 9:
          if (!
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1668; /* *vevalv1si_xorxor */

        case 10:
          if (!
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1677; /* *vevalv2si_xorxor */

        case 11:
          if (!
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1686; /* *vevalv4si_xorxor */

        case 12:
          if (!
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1695; /* *vevalv1di_xorxor */

        case 13:
          if (!
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1704; /* *vevalv2di_xorxor */

        case 14:
          if (!
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1713; /* *vevalv1ti_xorxor */

        case 15:
          if (!
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1722; /* *vevalti_xorxor */

        default:
          return -1;
        }

    case ASHIFT:
      switch (pattern31 (x3, pnum_clobbers))
        {
        case 0:
          if (!(
#line 4753 "../../gcc/config/s390/s390.md"
(TARGET_Z10) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 1995; /* *rxsbg_di_sll */

        case 1:
          if (!
#line 4753 "../../gcc/config/s390/s390.md"
(TARGET_Z10))
            return -1;
          *pnum_clobbers = 1;
          return 1997; /* *rxsbg_si_sll */

        default:
          return -1;
        }

    case LSHIFTRT:
      switch (pattern31 (x3, pnum_clobbers))
        {
        case 0:
          if (!(
#line 4772 "../../gcc/config/s390/s390.md"
(TARGET_Z10) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 1999; /* *rxsbg_di_srl */

        case 1:
          if (!
#line 4772 "../../gcc/config/s390/s390.md"
(TARGET_Z10))
            return -1;
          *pnum_clobbers = 1;
          return 2001; /* *rxsbg_si_srl */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_78 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case LTGT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case UNORDERED:
    case ORDERED:
    case UNEQ:
    case UNGE:
    case UNGT:
    case UNLE:
    case UNLT:
      switch (GET_CODE (x3))
        {
        case NE:
        case EQ:
        case GE:
        case GT:
        case LE:
        case LT:
          res = recog_31 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        default:
          break;
        }
      if (pnum_clobbers != NULL)
        {
          res = recog_32 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      if (!s390_comparison (x3, E_VOIDmode))
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != REG)
        return -1;
      operands[2] = x4;
      if (cc_reg_operand (operands[2], E_VOIDmode))
        {
          res = recog_33 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      if (REGNO (x4) != 33)
        return -1;
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != CONST_INT)
        return -1;
      operands[2] = x5;
      if (const_int_operand (operands[2], E_VOIDmode))
        {
          x6 = XEXP (x1, 0);
          if (GET_CODE (x6) == PC)
            {
              operands[1] = x3;
              x7 = XEXP (x2, 1);
              switch (GET_CODE (x7))
                {
                case LABEL_REF:
                  x8 = XEXP (x2, 2);
                  if (GET_CODE (x8) == PC)
                    {
                      x9 = XEXP (x7, 0);
                      operands[0] = x9;
                      return 2525; /* *cjump_64 */
                    }
                  break;

                case PC:
                  x8 = XEXP (x2, 2);
                  if (GET_CODE (x8) == LABEL_REF)
                    {
                      x10 = XEXP (x8, 0);
                      operands[0] = x10;
                      return 2529; /* *icjump_64 */
                    }
                  break;

                default:
                  break;
                }
            }
        }
      if (XWINT (x5, 0) != 0L)
        return -1;
      x6 = XEXP (x1, 0);
      if (GET_CODE (x6) != PC)
        return -1;
      x7 = XEXP (x2, 1);
      switch (GET_CODE (x7))
        {
        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case MEM:
        case LABEL_REF:
        case SYMBOL_REF:
        case PLUS:
        case MINUS:
        case MULT:
        case AND:
        case SIGN_EXTEND:
        case ZERO_EXTEND:
        case HIGH:
          operands[0] = x7;
          if (!address_operand (operands[0], E_VOIDmode))
            return -1;
          x8 = XEXP (x2, 2);
          if (GET_CODE (x8) != PC)
            return -1;
          operands[1] = x3;
          if (!
#line 9825 "../../gcc/config/s390/s390.md"
(!TARGET_INDIRECT_BRANCH_NOBP_JUMP))
            return -1;
          return 2526; /* *cjump_long */

        case RETURN:
          x8 = XEXP (x2, 2);
          if (GET_CODE (x8) != PC)
            return -1;
          operands[0] = x3;
          if (!
#line 9848 "../../gcc/config/s390/s390.md"
(s390_can_use_return_insn ()))
            return -1;
          return 2527; /* *creturn */

        case SIMPLE_RETURN:
          x8 = XEXP (x2, 2);
          if (GET_CODE (x8) != PC)
            return -1;
          operands[0] = x3;
          if (!
#line 9848 "../../gcc/config/s390/s390.md"
(s390_can_use_simple_return_insn ()))
            return -1;
          return 2528; /* *csimple_return */

        case PC:
          operands[1] = x3;
          x8 = XEXP (x2, 2);
          operands[0] = x8;
          if (!address_operand (operands[0], E_VOIDmode)
              || !
#line 9902 "../../gcc/config/s390/s390.md"
(!TARGET_INDIRECT_BRANCH_NOBP_JUMP))
            return -1;
          return 2530; /* *icjump_long */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_89 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x5))
    {
    case UNSPEC:
      if (XVECLEN (x5, 0) != 1
          || XINT (x5, 1) != 0)
        return -1;
      x6 = XVECEXP (x5, 0, 0);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_DFmode:
          if (!register_operand (operands[0], E_DFmode)
              || GET_MODE (x3) != E_DFmode
              || !register_operand (operands[1], E_TFmode)
              || GET_MODE (x5) != E_DFmode
              || !const_int_operand (operands[2], E_VOIDmode)
              || !
#line 3130 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 1563; /* *trunctfdf2_vr */

        case E_DDmode:
          if (pnum_clobbers == NULL
              || !register_operand (operands[0], E_DDmode)
              || GET_MODE (x3) != E_DDmode
              || !register_operand (operands[1], E_TDmode)
              || GET_MODE (x5) != E_DImode
              || !const_mask_operand (operands[2], E_DImode)
              || !
#line 5742 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 1;
          return 2099; /* *trunctddd2 */

        default:
          return -1;
        }

    case CLOBBER:
      if (!register_operand (operands[1], E_TFmode))
        return -1;
      x7 = XEXP (x5, 0);
      operands[2] = x7;
      if (!scratch_operand (operands[2], E_TFmode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_DFmode:
          if (!register_operand (operands[0], E_DFmode)
              || GET_MODE (x3) != E_DFmode
              || !
#line 5719 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 2097; /* trunctfdf2_fpr */

        case E_SFmode:
          if (!register_operand (operands[0], E_SFmode)
              || GET_MODE (x3) != E_SFmode
              || !
#line 5719 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 2098; /* trunctfsf2_fpr */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_97 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case STRICT_LOW_PART:
      if (pattern90 (x1) != 0
          || !subreg_register_operand (operands[0], E_HImode))
        return -1;
      x4 = XEXP (x2, 1);
      operands[1] = x4;
      if (!memory_operand (operands[1], E_HImode))
        return -1;
      return 1862; /* movstricthi */

    case SUBREG:
    case MEM:
      operands[0] = x3;
      if (!memory_operand (operands[0], E_BLKmode))
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x5) != USE)
        return -1;
      x4 = XEXP (x2, 1);
      operands[1] = x4;
      if (!memory_operand (operands[1], E_BLKmode))
        return -1;
      x6 = XEXP (x5, 0);
      operands[2] = x6;
      if (!const_int_operand (operands[2], E_VOIDmode)
          || !
#line 3113 "../../gcc/config/s390/s390.md"
(INTVAL (operands[2]) >= 1 && INTVAL (operands[2]) <= 256))
        return -1;
      return 1879; /* *mvc */

    case ZERO_EXTRACT:
      if (pattern90 (x1) != 0)
        return -1;
      x7 = XEXP (x3, 1);
      operands[1] = x7;
      if (!const_int_operand (operands[1], E_VOIDmode))
        return -1;
      x8 = XEXP (x3, 2);
      operands[2] = x8;
      if (!const_int_operand (operands[2], E_VOIDmode))
        return -1;
      x4 = XEXP (x2, 1);
      operands[3] = x4;
      switch (GET_MODE (x3))
        {
        case E_DImode:
          if (!nonimmediate_operand (operands[0], E_DImode)
              || !nonimmediate_operand (operands[3], E_DImode)
              || !(
#line 4486 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[1]), INTVAL (operands[2]),
			     GET_MODE_BITSIZE (DImode))
   && (INTVAL (operands[1]) + INTVAL (operands[2])) <= 64) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 1957; /* *insvdi_clobbercc */

        case E_SImode:
          if (!nonimmediate_operand (operands[0], E_SImode)
              || !nonimmediate_operand (operands[3], E_SImode)
              || !
#line 4486 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[1]), INTVAL (operands[2]),
			     GET_MODE_BITSIZE (SImode))
   && (INTVAL (operands[1]) + INTVAL (operands[2])) <= 32))
            return -1;
          return 1959; /* *insvsi_clobbercc */

        default:
          return -1;
        }

    case PC:
      x5 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x5) != CLOBBER)
        return -1;
      x6 = XEXP (x5, 0);
      if (GET_CODE (x6) != REG
          || REGNO (x6) != 1)
        return -1;
      x4 = XEXP (x2, 1);
      operands[0] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x6) != E_DImode
              || !(
#line 10419 "../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_JUMP_THUNK
  && !TARGET_CPU_Z10) && 
#line 778 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
            return -1;
          return 2550; /* indirect_jump_via_thunkdi */

        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x6) != E_SImode
              || !(
#line 10419 "../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_JUMP_THUNK
  && !TARGET_CPU_Z10) && 
#line 778 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
            return -1;
          return 2551; /* indirect_jump_via_thunksi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_101 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 33
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  x8 = XEXP (x6, 1);
  operands[2] = x8;
  if (!const_int_operand (operands[2], E_VOIDmode))
    return -1;
  switch (pattern193 (x6))
    {
    case 0:
      if (!(
#line 4320 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[2]), INTVAL (operands[3]),
			     GET_MODE_BITSIZE (DImode))) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
        return -1;
      return 1927; /* *extzvdi_clobbercc */

    case 1:
      if (!
#line 4320 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[2]), INTVAL (operands[3]),
			     GET_MODE_BITSIZE (SImode))))
        return -1;
      return 1929; /* *extzvsi_clobbercc */

    default:
      return -1;
    }
}

 int
recog_104 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case AND:
      switch (pattern93 (x1))
        {
        case 0:
          x6 = XEXP (x4, 1);
          switch (GET_CODE (x6))
            {
            case ZERO_EXTRACT:
              x7 = XEXP (x6, 0);
              operands[3] = x7;
              x8 = XEXP (x6, 1);
              operands[4] = x8;
              if (!const_int_operand (operands[4], E_VOIDmode))
                return -1;
              x9 = XEXP (x6, 2);
              operands[5] = x9;
              if (!const_int_operand (operands[5], E_VOIDmode))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_DImode:
                  if (pattern278 (x4, 
E_DImode) != 0
                      || !
#line 4352 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[4]), INTVAL (operands[5]), 64)
   && UINTVAL (operands[2]) == (HOST_WIDE_INT_M1U << UINTVAL (operands[4]))))
                    return -1;
                  return 1933; /* *risbg_ior_and_sr_zedi */

                case E_SImode:
                  if (pattern278 (x4, 
E_SImode) != 0
                      || !
#line 4352 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[4]), INTVAL (operands[5]), 32)
   && UINTVAL (operands[2]) == (HOST_WIDE_INT_M1U << UINTVAL (operands[4]))))
                    return -1;
                  return 1935; /* *risbg_ior_and_sr_zesi */

                default:
                  return -1;
                }

            case AND:
              x7 = XEXP (x6, 0);
              operands[3] = x7;
              x8 = XEXP (x6, 1);
              operands[4] = x8;
              switch (GET_MODE (operands[0]))
                {
                case E_DImode:
                  if (pattern263 (x4, 
E_DImode) != 0
                      || !(
#line 4502 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12 && INTVAL (operands[2]) == ~INTVAL (operands[4])) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return -1;
                  return 1961; /* *insvdi_clobbercc_noshift */

                case E_SImode:
                  if (pattern263 (x4, 
E_SImode) != 0
                      || !
#line 4502 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12 && INTVAL (operands[2]) == ~INTVAL (operands[4])))
                    return -1;
                  return 1963; /* *insvsi_clobbercc_noshift */

                default:
                  return -1;
                }

            case ASHIFT:
              x7 = XEXP (x6, 0);
              operands[3] = x7;
              x8 = XEXP (x6, 1);
              operands[4] = x8;
              switch (GET_MODE (operands[0]))
                {
                case E_DImode:
                  if (pattern264 (x4, 
E_DImode) != 0
                      || !(
#line 4556 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && UINTVAL (operands[2]) == (HOST_WIDE_INT_1U << UINTVAL (operands[4])) - 1) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return -1;
                  return 1967; /* *insvdi_clobbercc_appendbitsleft */

                case E_SImode:
                  if (pattern264 (x4, 
E_SImode) != 0
                      || !
#line 4556 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && UINTVAL (operands[2]) == (HOST_WIDE_INT_1U << UINTVAL (operands[4])) - 1))
                    return -1;
                  return 1969; /* *insvsi_clobbercc_appendbitsleft */

                default:
                  return -1;
                }

            case LSHIFTRT:
              x7 = XEXP (x6, 0);
              operands[3] = x7;
              x8 = XEXP (x6, 1);
              operands[4] = x8;
              switch (GET_MODE (operands[0]))
                {
                case E_DImode:
                  if (pattern265 (x4, 
E_DImode) != 0
                      || !(
#line 4571 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12 && UINTVAL (operands[2])
   == (HOST_WIDE_INT_M1U
       << (GET_MODE_BITSIZE (DImode) - UINTVAL (operands[4])))) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return -1;
                  return 1971; /* *risbg_di_ior_and_lshiftrt */

                case E_SImode:
                  if (pattern265 (x4, 
E_SImode) != 0
                      || !
#line 4571 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12 && UINTVAL (operands[2])
   == (HOST_WIDE_INT_M1U
       << (GET_MODE_BITSIZE (SImode) - UINTVAL (operands[4])))))
                    return -1;
                  return 1973; /* *risbg_si_ior_and_lshiftrt */

                default:
                  return -1;
                }

            case REG:
            case SUBREG:
            case MEM:
              if (GET_CODE (x6) == SUBREG
                  && known_eq (SUBREG_BYTE (x6), 4)
                  && GET_MODE (x6) == E_SImode)
                {
                  x7 = XEXP (x6, 0);
                  if (GET_CODE (x7) == LSHIFTRT
                      && GET_MODE (x7) == E_DImode
                      && pattern228 (x4, 
E_SImode) == 0
                      && const_int_operand (operands[2], E_SImode))
                    {
                      x10 = XEXP (x7, 0);
                      operands[3] = x10;
                      if (register_operand (operands[3], E_DImode))
                        {
                          x11 = XEXP (x7, 1);
                          operands[4] = x11;
                          if (nonzero_shift_count_operand (operands[4], E_DImode)
                              && 
#line 4588 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && UINTVAL (operands[2]) == ~(HOST_WIDE_INT_M1U >> UINTVAL (operands[4]))))
                            return 1975; /* *risbg_sidi_ior_and_lshiftrt */
                        }
                    }
                }
              operands[3] = x6;
              switch (GET_MODE (operands[0]))
                {
                case E_DImode:
                  if (pattern250 (x4, 
E_DImode) != 0
                      || !(
#line 4685 "../../gcc/config/s390/s390.md"
(TARGET_Z10) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return -1;
                  return 1980; /* *rosbg_di_noshift */

                case E_SImode:
                  if (pattern250 (x4, 
E_SImode) != 0
                      || !
#line 4685 "../../gcc/config/s390/s390.md"
(TARGET_Z10))
                    return -1;
                  return 1982; /* *rosbg_si_noshift */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 1:
          if (!
#line 4700 "../../gcc/config/s390/s390.md"
(TARGET_Z10))
            return -1;
          return 1984; /* *rosbg_di_rotl */

        case 2:
          if (!(
#line 4715 "../../gcc/config/s390/s390.md"
(TARGET_Z10
   && s390_extzv_shift_ok (64, 64 - INTVAL (operands[3]),
                           INTVAL (operands[2]))) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 1986; /* *rosbg_di_srl_bitmask */

        case 3:
          if (!
#line 4715 "../../gcc/config/s390/s390.md"
(TARGET_Z10
   && s390_extzv_shift_ok (32, 64 - INTVAL (operands[3]),
                           INTVAL (operands[2]))))
            return -1;
          return 1988; /* *rosbg_si_srl_bitmask */

        case 4:
          if (!(
#line 4735 "../../gcc/config/s390/s390.md"
(TARGET_Z10
   && s390_extzv_shift_ok (64, INTVAL (operands[3]),
                           INTVAL (operands[2]))) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 1990; /* *rosbg_di_sll_bitmask */

        case 5:
          if (!
#line 4735 "../../gcc/config/s390/s390.md"
(TARGET_Z10
   && s390_extzv_shift_ok (32, INTVAL (operands[3]),
                           INTVAL (operands[2]))))
            return -1;
          return 1992; /* *rosbg_si_sll_bitmask */

        default:
          return -1;
        }

    case ASHIFT:
      x12 = XVECEXP (x1, 0, 1);
      if (pattern89 (x12) != 0)
        return -1;
      x13 = XEXP (x5, 0);
      switch (GET_CODE (x13))
        {
        case REG:
        case SUBREG:
        case MEM:
          switch (pattern95 (x4))
            {
            case 0:
              if (!(
#line 4753 "../../gcc/config/s390/s390.md"
(TARGET_Z10) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              return 1994; /* *rosbg_di_sll */

            case 1:
              if (!
#line 4753 "../../gcc/config/s390/s390.md"
(TARGET_Z10))
                return -1;
              return 1996; /* *rosbg_si_sll */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          if (GET_MODE (x13) != E_TImode)
            return -1;
          x14 = XEXP (x13, 0);
          if (GET_CODE (x14) != CLZ
              || GET_MODE (x14) != E_DImode)
            return -1;
          x15 = XEXP (x5, 1);
          if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 64])
            return -1;
          x6 = XEXP (x4, 1);
          if (GET_CODE (x6) != ZERO_EXTEND
              || GET_MODE (x6) != E_TImode)
            return -1;
          x7 = XEXP (x6, 0);
          if (GET_CODE (x7) != XOR
              || GET_MODE (x7) != E_DImode)
            return -1;
          x11 = XEXP (x7, 1);
          if (GET_CODE (x11) != LSHIFTRT)
            return -1;
          x16 = XEXP (x11, 1);
          if (GET_CODE (x16) != SUBREG
              || maybe_ne (SUBREG_BYTE (x16), 4)
              || GET_MODE (x16) != E_SImode)
            return -1;
          x17 = XEXP (x16, 0);
          if (GET_CODE (x17) != CLZ
              || GET_MODE (x17) != E_DImode
              || !register_operand (operands[0], E_TImode)
              || GET_MODE (x4) != E_TImode
              || GET_MODE (x5) != E_TImode)
            return -1;
          x18 = XEXP (x14, 0);
          operands[1] = x18;
          if (!register_operand (operands[1], E_DImode))
            return -1;
          x19 = XEXP (x11, 0);
          operands[2] = x19;
          if (!const_int_operand (operands[2], E_DImode))
            return -1;
          x10 = XEXP (x7, 0);
          if (!rtx_equal_p (x10, operands[1]))
            return -1;
          x20 = XEXP (x17, 0);
          if (!rtx_equal_p (x20, operands[1])
              || !
#line 9627 "../../gcc/config/s390/s390.md"
(UINTVAL (operands[2]) == HOST_WIDE_INT_1U << 63
   && TARGET_EXTIMM && TARGET_ZARCH))
            return -1;
          return 2506; /* clztidi2 */

        default:
          return -1;
        }

    case LSHIFTRT:
      switch (pattern96 (x1))
        {
        case 0:
          if (!(
#line 4772 "../../gcc/config/s390/s390.md"
(TARGET_Z10) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 1998; /* *rosbg_di_srl */

        case 1:
          if (!
#line 4772 "../../gcc/config/s390/s390.md"
(TARGET_Z10))
            return -1;
          return 2000; /* *rosbg_si_srl */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
    case MEM:
      if (GET_CODE (x5) == SUBREG
          && pattern119 (x1) == 0
          && 
#line 4792 "../../gcc/config/s390/s390.md"
(TARGET_Z10))
        return 2002; /* *rosbg_sidi_srl */
      if (pnum_clobbers != NULL
          && pattern120 (x1) == 0
          && 
#line 8675 "../../gcc/config/s390/s390.md"
(INTVAL (operands[2]) >= 1 && INTVAL (operands[2]) <= 256))
        {
          *pnum_clobbers = 1;
          return 2405; /* *oc */
        }
      operands[1] = x5;
      switch (pattern122 (x1))
        {
        case 0:
          if (!
#line 8370 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
            return -1;
          return 2370; /* *iordi3 */

        case 1:
          if (
#line 8451 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
            return 2373; /* *iorsi3_zarch */
          if (!
#line 8479 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
            return -1;
          return 2374; /* *iorsi3_esa */

        case 2:
          if (
#line 8507 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
            return 2375; /* *iorhi3_zarch */
          if (!
#line 8523 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
            return -1;
          return 2376; /* *iorhi3_esa */

        case 3:
          if (
#line 8550 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
            return 2377; /* *iorqi3_zarch */
          if (!
#line 8568 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
            return -1;
          return 2378; /* *iorqi3_esa */

        default:
          return -1;
        }

    case NOT:
      x12 = XVECEXP (x1, 0, 1);
      if (pattern89 (x12) != 0)
        return -1;
      x13 = XEXP (x5, 0);
      operands[1] = x13;
      x6 = XEXP (x4, 1);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          operands[2] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (pattern241 (x4, 
E_DImode) != 0
                  || !(
#line 8612 "../../gcc/config/s390/s390.md"
(TARGET_Z15) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              return 2388; /* *orcdi */

            case E_SImode:
              if (pattern241 (x4, 
E_SImode) != 0
                  || !
#line 8612 "../../gcc/config/s390/s390.md"
(TARGET_Z15))
                return -1;
              return 2390; /* *orcsi */

            default:
              return -1;
            }

        case NOT:
          switch (pattern216 (x4))
            {
            case 0:
              if (!(
#line 8652 "../../gcc/config/s390/s390.md"
(TARGET_Z15) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              return 2400; /* *nanddi */

            case 1:
              if (!
#line 8652 "../../gcc/config/s390/s390.md"
(TARGET_Z15))
                return -1;
              return 2402; /* *nandsi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_119 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (pattern44 (x2, 
10, 
1, 
UNSPEC_VOLATILE) != 0)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 0);
  operands[0] = x4;
  x5 = XEXP (x3, 1);
  operands[1] = x5;
  x6 = XEXP (x2, 0);
  if (!rtx_equal_p (x6, operands[1]))
    return -1;
  x7 = XEXP (x2, 1);
  x8 = XVECEXP (x7, 0, 0);
  switch (GET_CODE (x8))
    {
    case AND:
      switch (pattern218 (x7))
        {
        case 0:
          if (!(
#line 11431 "../../gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 2601; /* atomic_fetch_anddi_iaf */

        case 1:
          if (!
#line 11431 "../../gcc/config/s390/s390.md"
(TARGET_Z196))
            return -1;
          *pnum_clobbers = 1;
          return 2605; /* atomic_fetch_andsi_iaf */

        default:
          return -1;
        }

    case IOR:
      switch (pattern218 (x7))
        {
        case 0:
          if (!(
#line 11431 "../../gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 2602; /* atomic_fetch_ordi_iaf */

        case 1:
          if (!
#line 11431 "../../gcc/config/s390/s390.md"
(TARGET_Z196))
            return -1;
          *pnum_clobbers = 1;
          return 2606; /* atomic_fetch_orsi_iaf */

        default:
          return -1;
        }

    case XOR:
      switch (pattern218 (x7))
        {
        case 0:
          if (!(
#line 11431 "../../gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 2603; /* atomic_fetch_xordi_iaf */

        case 1:
          if (!
#line 11431 "../../gcc/config/s390/s390.md"
(TARGET_Z196))
            return -1;
          *pnum_clobbers = 1;
          return 2607; /* atomic_fetch_xorsi_iaf */

        default:
          return -1;
        }

    case PLUS:
      switch (pattern218 (x7))
        {
        case 0:
          if (!(
#line 11431 "../../gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 2604; /* atomic_fetch_adddi_iaf */

        case 1:
          if (!
#line 11431 "../../gcc/config/s390/s390.md"
(TARGET_Z196))
            return -1;
          *pnum_clobbers = 1;
          return 2608; /* atomic_fetch_addsi_iaf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_3 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 1);
  operands[1] = x4;
  x5 = XEXP (x3, 2);
  operands[2] = x5;
  x6 = XEXP (x3, 0);
  switch (GET_CODE (x6))
    {
    case EQ:
      switch (pattern101 (x3))
        {
        case 0:
          if (const0_operand (operands[1], E_V1QImode)
              && all_ones_operand (operands[2], E_V1QImode)
              && 
#line 2528 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return gen_split_56 (insn, operands);
          if (!all_ones_operand (operands[1], E_V1QImode)
              || !const0_operand (operands[2], E_V1QImode)
              || !
#line 2542 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return NULL;
          return gen_split_75 (insn, operands);

        case 1:
          if (const0_operand (operands[1], E_V2QImode)
              && all_ones_operand (operands[2], E_V2QImode)
              && 
#line 2528 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return gen_split_57 (insn, operands);
          if (!all_ones_operand (operands[1], E_V2QImode)
              || !const0_operand (operands[2], E_V2QImode)
              || !
#line 2542 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return NULL;
          return gen_split_76 (insn, operands);

        case 2:
          if (const0_operand (operands[1], E_V4QImode)
              && all_ones_operand (operands[2], E_V4QImode)
              && 
#line 2528 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return gen_split_58 (insn, operands);
          if (!all_ones_operand (operands[1], E_V4QImode)
              || !const0_operand (operands[2], E_V4QImode)
              || !
#line 2542 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return NULL;
          return gen_split_77 (insn, operands);

        case 3:
          if (const0_operand (operands[1], E_V8QImode)
              && all_ones_operand (operands[2], E_V8QImode)
              && 
#line 2528 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return gen_split_59 (insn, operands);
          if (!all_ones_operand (operands[1], E_V8QImode)
              || !const0_operand (operands[2], E_V8QImode)
              || !
#line 2542 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return NULL;
          return gen_split_78 (insn, operands);

        case 4:
          if (const0_operand (operands[1], E_V16QImode)
              && all_ones_operand (operands[2], E_V16QImode)
              && 
#line 2528 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return gen_split_60 (insn, operands);
          if (!all_ones_operand (operands[1], E_V16QImode)
              || !const0_operand (operands[2], E_V16QImode)
              || !
#line 2542 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return NULL;
          return gen_split_79 (insn, operands);

        case 5:
          if (const0_operand (operands[1], E_V1HImode)
              && all_ones_operand (operands[2], E_V1HImode)
              && 
#line 2528 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return gen_split_61 (insn, operands);
          if (!all_ones_operand (operands[1], E_V1HImode)
              || !const0_operand (operands[2], E_V1HImode)
              || !
#line 2542 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return NULL;
          return gen_split_80 (insn, operands);

        case 6:
          if (const0_operand (operands[1], E_V2HImode)
              && all_ones_operand (operands[2], E_V2HImode)
              && 
#line 2528 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return gen_split_62 (insn, operands);
          if (!all_ones_operand (operands[1], E_V2HImode)
              || !const0_operand (operands[2], E_V2HImode)
              || !
#line 2542 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return NULL;
          return gen_split_81 (insn, operands);

        case 7:
          if (const0_operand (operands[1], E_V4HImode)
              && all_ones_operand (operands[2], E_V4HImode)
              && 
#line 2528 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return gen_split_63 (insn, operands);
          if (!all_ones_operand (operands[1], E_V4HImode)
              || !const0_operand (operands[2], E_V4HImode)
              || !
#line 2542 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return NULL;
          return gen_split_82 (insn, operands);

        case 8:
          if (const0_operand (operands[1], E_V8HImode)
              && all_ones_operand (operands[2], E_V8HImode)
              && 
#line 2528 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return gen_split_64 (insn, operands);
          if (!all_ones_operand (operands[1], E_V8HImode)
              || !const0_operand (operands[2], E_V8HImode)
              || !
#line 2542 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return NULL;
          return gen_split_83 (insn, operands);

        case 9:
          if (const0_operand (operands[1], E_V1SImode)
              && all_ones_operand (operands[2], E_V1SImode)
              && 
#line 2528 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return gen_split_65 (insn, operands);
          if (!all_ones_operand (operands[1], E_V1SImode)
              || !const0_operand (operands[2], E_V1SImode)
              || !
#line 2542 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return NULL;
          return gen_split_84 (insn, operands);

        case 10:
          if (const0_operand (operands[1], E_V2SImode)
              && all_ones_operand (operands[2], E_V2SImode)
              && 
#line 2528 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return gen_split_66 (insn, operands);
          if (!all_ones_operand (operands[1], E_V2SImode)
              || !const0_operand (operands[2], E_V2SImode)
              || !
#line 2542 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return NULL;
          return gen_split_85 (insn, operands);

        case 11:
          if (const0_operand (operands[1], E_V4SImode)
              && all_ones_operand (operands[2], E_V4SImode)
              && 
#line 2528 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return gen_split_67 (insn, operands);
          if (!all_ones_operand (operands[1], E_V4SImode)
              || !const0_operand (operands[2], E_V4SImode)
              || !
#line 2542 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return NULL;
          return gen_split_86 (insn, operands);

        case 12:
          if (const0_operand (operands[1], E_V1DImode)
              && all_ones_operand (operands[2], E_V1DImode)
              && 
#line 2528 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return gen_split_68 (insn, operands);
          if (!all_ones_operand (operands[1], E_V1DImode)
              || !const0_operand (operands[2], E_V1DImode)
              || !
#line 2542 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return NULL;
          return gen_split_87 (insn, operands);

        case 13:
          if (const0_operand (operands[1], E_V2DImode)
              && all_ones_operand (operands[2], E_V2DImode)
              && 
#line 2528 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return gen_split_69 (insn, operands);
          if (!all_ones_operand (operands[1], E_V2DImode)
              || !const0_operand (operands[2], E_V2DImode)
              || !
#line 2542 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return NULL;
          return gen_split_88 (insn, operands);

        case 14:
          if (const0_operand (operands[1], E_V1SFmode)
              && all_ones_operand (operands[2], E_V1SFmode)
              && 
#line 2528 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return gen_split_70 (insn, operands);
          if (!all_ones_operand (operands[1], E_V1SFmode)
              || !const0_operand (operands[2], E_V1SFmode)
              || !
#line 2542 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return NULL;
          return gen_split_89 (insn, operands);

        case 15:
          if (const0_operand (operands[1], E_V2SFmode)
              && all_ones_operand (operands[2], E_V2SFmode)
              && 
#line 2528 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return gen_split_71 (insn, operands);
          if (!all_ones_operand (operands[1], E_V2SFmode)
              || !const0_operand (operands[2], E_V2SFmode)
              || !
#line 2542 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return NULL;
          return gen_split_90 (insn, operands);

        case 16:
          if (const0_operand (operands[1], E_V4SFmode)
              && all_ones_operand (operands[2], E_V4SFmode)
              && 
#line 2528 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return gen_split_72 (insn, operands);
          if (!all_ones_operand (operands[1], E_V4SFmode)
              || !const0_operand (operands[2], E_V4SFmode)
              || !
#line 2542 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return NULL;
          return gen_split_91 (insn, operands);

        case 17:
          if (const0_operand (operands[1], E_V1DFmode)
              && all_ones_operand (operands[2], E_V1DFmode)
              && 
#line 2528 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return gen_split_73 (insn, operands);
          if (!all_ones_operand (operands[1], E_V1DFmode)
              || !const0_operand (operands[2], E_V1DFmode)
              || !
#line 2542 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return NULL;
          return gen_split_92 (insn, operands);

        case 18:
          if (const0_operand (operands[1], E_V2DFmode)
              && all_ones_operand (operands[2], E_V2DFmode)
              && 
#line 2528 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return gen_split_74 (insn, operands);
          if (!all_ones_operand (operands[1], E_V2DFmode)
              || !const0_operand (operands[2], E_V2DFmode)
              || !
#line 2542 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return NULL;
          return gen_split_93 (insn, operands);

        default:
          return NULL;
        }

    case NE:
      return split_2 (x1, insn);

    default:
      return NULL;
    }
}

 rtx_insn *
split_insns (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24;
  rtx_insn *res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  switch (GET_CODE (x1))
    {
    case SET:
      return split_7 (x1, insn);

    case PARALLEL:
      switch (XVECLEN (x1, 0))
        {
        case 2:
          return split_6 (x1, insn);

        case 3:
          x2 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x2) != SET)
            return NULL;
          x3 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x3) != CLOBBER)
            return NULL;
          x4 = XEXP (x2, 1);
          switch (GET_CODE (x4))
            {
            case VEC_SELECT:
              if (GET_MODE (x4) != E_V8HImode)
                return NULL;
              x5 = XEXP (x4, 1);
              if (GET_CODE (x5) != PARALLEL
                  || XVECLEN (x5, 0) != 8)
                return NULL;
              x6 = XVECEXP (x5, 0, 0);
              if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 7])
                return NULL;
              x7 = XVECEXP (x5, 0, 1);
              if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
                return NULL;
              x8 = XVECEXP (x5, 0, 2);
              if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
                return NULL;
              x9 = XVECEXP (x5, 0, 3);
              if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
                return NULL;
              x10 = XVECEXP (x5, 0, 4);
              if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
                return NULL;
              x11 = XVECEXP (x5, 0, 5);
              if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
                return NULL;
              x12 = XVECEXP (x5, 0, 6);
              if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
                return NULL;
              x13 = XVECEXP (x5, 0, 7);
              if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return NULL;
              x14 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x14) != CLOBBER
                  || pattern266 (x1) != 0
                  || !(
#line 1046 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 1051 "../../gcc/config/s390/vector.md"
( reload_completed && REG_P (operands[0]) && REG_P (operands[1]))))
                return NULL;
              return gen_split_45 (insn, operands);

            case IF_THEN_ELSE:
              x15 = XEXP (x4, 0);
              if (!s390_brx_operator (x15, E_VOIDmode))
                return NULL;
              operands[6] = x15;
              x16 = XEXP (x15, 0);
              if (GET_CODE (x16) != PLUS)
                return NULL;
              x5 = XEXP (x4, 1);
              if (GET_CODE (x5) != LABEL_REF)
                return NULL;
              x17 = XEXP (x4, 2);
              if (GET_CODE (x17) != PC)
                return NULL;
              x18 = XEXP (x2, 0);
              if (GET_CODE (x18) != PC)
                return NULL;
              x14 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x14) != SET)
                return NULL;
              x19 = XEXP (x14, 1);
              if (GET_CODE (x19) != PLUS)
                return NULL;
              switch (pattern230 (x1))
                {
                case 0:
                  if (!(
#line 10033 "../../gcc/config/s390/s390.md"
(!reload_completed && !reload_in_progress) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return NULL;
                  return gen_split_385 (insn, operands);

                case 1:
                  if (!
#line 10033 "../../gcc/config/s390/s390.md"
(!reload_completed && !reload_in_progress))
                    return NULL;
                  return gen_split_386 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        case 4:
          x2 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x2) != SET)
            return NULL;
          x20 = XVECEXP (x1, 0, 3);
          if (GET_CODE (x20) != CLOBBER)
            return NULL;
          x4 = XEXP (x2, 1);
          switch (GET_CODE (x4))
            {
            case SUBREG:
            case MEM:
              if (pattern74 (x1) != 0)
                return NULL;
              switch (pattern196 (x1))
                {
                case 0:
                  if (!
#line 3605 "../../gcc/config/s390/s390.md"
(reload_completed))
                    return NULL;
                  return gen_split_321 (insn, operands);

                case 1:
                  if (!
#line 3617 "../../gcc/config/s390/s390.md"
(reload_completed))
                    return NULL;
                  return gen_split_322 (insn, operands);

                case 2:
                  if (scratch_operand (operands[3], E_VOIDmode)
                      && 
#line 3631 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && reload_completed))
                    return gen_split_323 (insn, operands);
                  if (!register_operand (operands[3], E_VOIDmode)
                      || !
#line 3645 "../../gcc/config/s390/s390.md"
(reload_completed))
                    return NULL;
                  return gen_split_324 (insn, operands);

                default:
                  return NULL;
                }

            case COMPARE:
              if (pattern73 (x1) != 0)
                return NULL;
              switch (pattern196 (x1))
                {
                case 0:
                  if (!
#line 4055 "../../gcc/config/s390/s390.md"
(reload_completed))
                    return NULL;
                  return gen_split_330 (insn, operands);

                case 1:
                  if (!
#line 4068 "../../gcc/config/s390/s390.md"
(reload_completed))
                    return NULL;
                  return gen_split_331 (insn, operands);

                case 2:
                  if (scratch_operand (operands[3], E_VOIDmode)
                      && 
#line 4083 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && reload_completed))
                    return gen_split_332 (insn, operands);
                  if (!register_operand (operands[3], E_VOIDmode)
                      || !
#line 4098 "../../gcc/config/s390/s390.md"
(reload_completed))
                    return NULL;
                  return gen_split_333 (insn, operands);

                default:
                  return NULL;
                }

            case IF_THEN_ELSE:
              switch (pattern78 (x1))
                {
                case 0:
                  if (!(
#line 10071 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH) && 
#line 10080 "../../gcc/config/s390/s390.md"
( reload_completed
   && (!REG_P (operands[3])
       || !rtx_equal_p (operands[1], operands[3])))))
                    return NULL;
                  return gen_split_387 (insn, operands);

                case 1:
                  if (!(
#line 10157 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH) && 
#line 10166 "../../gcc/config/s390/s390.md"
( reload_completed
   && (!REG_P (operands[3])
       || !rtx_equal_p (operands[1], operands[3])))))
                    return NULL;
                  return gen_split_389 (insn, operands);

                case 2:
                  if (!(
#line 10114 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH) && 
#line 10123 "../../gcc/config/s390/s390.md"
( reload_completed
   && (!REG_P (operands[3])
       || !rtx_equal_p (operands[1], operands[3])))))
                    return NULL;
                  return gen_split_388 (insn, operands);

                case 3:
                  if (!
#line 10222 "../../gcc/config/s390/s390.md"
( reload_completed
   && (! REG_P (operands[2])
       || ! rtx_equal_p (operands[1], operands[2]))))
                    return NULL;
                  return gen_split_390 (insn, operands);

                case 4:
                  if (!(
#line 10255 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH) && 
#line 10264 "../../gcc/config/s390/s390.md"
( reload_completed
   && (! REG_P (operands[2])
       || ! rtx_equal_p (operands[1], operands[2])))))
                    return NULL;
                  return gen_split_391 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        case 5:
          x2 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x2) != SET)
            return NULL;
          x4 = XEXP (x2, 1);
          if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return NULL;
          x14 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x14) != USE)
            return NULL;
          x3 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x3) != USE
              || pattern103 (x1) != 0)
            return NULL;
          switch (GET_CODE (operands[1]))
            {
            case CONST_INT:
              if (!const_int_operand (operands[1], E_VOIDmode))
                return NULL;
              x21 = XEXP (x3, 0);
              operands[2] = x21;
              if (!immediate_operand (operands[2], E_VOIDmode))
                return NULL;
              x20 = XVECEXP (x1, 0, 3);
              x22 = XEXP (x20, 0);
              operands[3] = x22;
              if (!scratch_operand (operands[3], E_VOIDmode)
                  || !
#line 3861 "../../gcc/config/s390/s390.md"
(reload_completed))
                return NULL;
              return gen_split_326 (insn, operands);

            case REG:
            case SUBREG:
              if (!register_operand (operands[1], E_VOIDmode))
                return NULL;
              x21 = XEXP (x3, 0);
              switch (GET_CODE (x21))
                {
                case SUBREG:
                case MEM:
                  operands[2] = x21;
                  if (!memory_operand (operands[2], E_VOIDmode))
                    return NULL;
                  x20 = XVECEXP (x1, 0, 3);
                  x22 = XEXP (x20, 0);
                  operands[3] = x22;
                  if (!scratch_operand (operands[3], E_VOIDmode)
                      || !
#line 3875 "../../gcc/config/s390/s390.md"
(reload_completed))
                    return NULL;
                  return gen_split_327 (insn, operands);

                case CONST:
                  if (GET_MODE (x21) != E_BLKmode)
                    return NULL;
                  x23 = XEXP (x21, 0);
                  if (GET_CODE (x23) != UNSPEC
                      || XVECLEN (x23, 0) != 1
                      || XINT (x23, 1) != 17
                      || GET_MODE (x23) != E_BLKmode)
                    return NULL;
                  x24 = XVECEXP (x23, 0, 0);
                  if (x24 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                    return NULL;
                  x20 = XVECEXP (x1, 0, 3);
                  x22 = XEXP (x20, 0);
                  operands[2] = x22;
                  if (scratch_operand (operands[2], E_VOIDmode)
                      && 
#line 3891 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && reload_completed))
                    return gen_split_328 (insn, operands);
                  if (!register_operand (operands[2], E_VOIDmode)
                      || !
#line 3907 "../../gcc/config/s390/s390.md"
(reload_completed))
                    return NULL;
                  return gen_split_329 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}
