/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern5 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode
          || !register_operand (operands[1], E_V2DFmode))
        return -1;
      return 0;

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !register_operand (operands[1], E_V4SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern15 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != i1)
    return -1;
  x3 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x3) != CLOBBER)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 1)
    return -1;
  return 0;
}

int
pattern17 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern16 (x3, 
E_V8HImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern16 (x3, 
E_V4SImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern16 (x3, 
E_V2DImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern22 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_V16QImode:
      if (!register_operand (operands[2], E_V16QImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!register_operand (operands[2], E_V8HImode))
        return -1;
      return 1;

    case E_V4SImode:
      if (!register_operand (operands[2], E_V4SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern27 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V8HImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_V8HImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_V8HImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!const_mask_operand (operands[2], E_QImode))
    return -1;
  return 0;
}

int
pattern30 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !nonzero_shift_count_operand (operands[2], i1)
      || !nonimmediate_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern32 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern38 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 33
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  return 0;
}

int
pattern42 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != UNSPEC
      || XVECLEN (x2, 0) != 1
      || XINT (x2, 1) != 0)
    return -1;
  x3 = XVECEXP (x1, 0, 2);
  return pattern41 (x3); /* [-1, 0] */
}

int
pattern47 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x1) != E_V16QImode
          || !register_operand (operands[1], E_V16QImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x1) != E_V8HImode
          || !register_operand (operands[1], E_V8HImode))
        return -1;
      return 1;

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x1) != E_V4SImode
          || !register_operand (operands[1], E_V4SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern54 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  x3 = XVECEXP (x1, 0, 1);
  operands[2] = x3;
  x4 = XVECEXP (x1, 0, 2);
  operands[3] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      return pattern53 (x1, 
E_V8HImode, 
E_V16QImode); /* [-1, 0] */

    case E_V4SImode:
      if (pattern53 (x1, 
E_V4SImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V2DImode:
      if (pattern53 (x1, 
E_V2DImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_TImode:
      if (pattern53 (x1, 
E_TImode, 
E_V2DImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern62 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[4] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      return pattern61 (x1, 
E_DImode); /* [-1, 0] */

    case E_SImode:
      if (pattern61 (x1, 
E_SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern66 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_DImode
      || !register_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern74 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  operands[1] = x3;
  if (!memory_operand (operands[1], E_BLKmode))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != USE)
    return -1;
  x5 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x5) != USE)
    return -1;
  x6 = XEXP (x2, 0);
  operands[0] = x6;
  if (!memory_operand (operands[0], E_BLKmode))
    return -1;
  return 0;
}

int
pattern81 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  if (!register_operand (operands[2], i1))
    return -1;
  x4 = XEXP (x1, 1);
  operands[1] = x4;
  if (!register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern86 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[3] = x5;
  return pattern62 (x1); /* [-1, 1] */
}

int
pattern93 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 33
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 1);
  operands[2] = x7;
  x8 = XEXP (x6, 0);
  switch (GET_CODE (x8))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x8;
      return 0;

    case ROTATE:
      if (GET_MODE (x8) != E_DImode
          || !nonimmediate_operand (operands[0], E_DImode)
          || GET_MODE (x5) != E_DImode
          || GET_MODE (x6) != E_DImode)
        return -1;
      x9 = XEXP (x8, 0);
      operands[1] = x9;
      if (!nonimmediate_operand (operands[1], E_DImode))
        return -1;
      x10 = XEXP (x8, 1);
      operands[3] = x10;
      if (!const_int_operand (operands[3], E_DImode)
          || !contiguous_bitmask_operand (operands[2], E_DImode))
        return -1;
      x11 = XEXP (x5, 1);
      operands[4] = x11;
      if (!nonimmediate_operand (operands[4], E_DImode))
        return -1;
      return 1;

    case LSHIFTRT:
      res = pattern92 (x5);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    case ASHIFT:
      res = pattern92 (x5);
      if (res >= 0)
        return res + 4; /* [4, 5] */
      return -1;

    default:
      return -1;
    }
}

int
pattern117 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_DImode:
      if (!register_operand (operands[1], E_DImode)
          || !nonmemory_operand (operands[2], E_DImode))
        return -1;
      return 0;

    case E_SImode:
      if (!register_operand (operands[1], E_SImode)
          || !nonmemory_operand (operands[2], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern124 (rtx x1, machine_mode i1, unsigned int i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  if (GET_MODE (x3) != i3)
    return -1;
  x4 = XEXP (x1, 0);
  x5 = XEXP (x4, 0);
  if (maybe_ne (SUBREG_BYTE (x5), i2)
      || GET_MODE (x5) != i3
      || !register_operand (operands[0], i1)
      || !register_operand (operands[3], i1)
      || !setmem_operand (operands[2], i3)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern128 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1)
      || GET_CODE (x1) != PARALLEL
      || XVECLEN (x1, 0) != 2)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PLUS
      || GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 33
      || GET_MODE (x5) != E_CCmode)
    return -1;
  x6 = XEXP (x3, 1);
  operands[2] = x6;
  if (!nonmemory_operand (operands[2], i1))
    return -1;
  x7 = XEXP (x3, 0);
  if (!rtx_equal_p (x7, operands[0]))
    return -1;
  x8 = XEXP (x2, 0);
  if (!rtx_equal_p (x8, operands[0]))
    return -1;
  return 0;
}

int
pattern140 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern146 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  switch (GET_MODE (x6))
    {
    case E_DImode:
      if (!nonimmediate_operand (operands[1], E_DImode)
          || !general_operand (operands[2], E_DImode)
          || !scratch_operand (operands[0], E_DImode))
        return -1;
      return 0;

    case E_SImode:
      if (!nonimmediate_operand (operands[1], E_SImode)
          || !general_operand (operands[2], E_SImode)
          || !scratch_operand (operands[0], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern152 (rtx x1, machine_mode i1, int i2, rtx_code i3, int i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != i3
      || XVECLEN (x1, 0) != i4
      || XINT (x1, 1) != i2
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern155 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_DImode:
      if (!nonimmediate_operand (operands[1], E_DImode)
          || !general_operand (operands[2], E_DImode))
        return -1;
      return 0;

    case E_SImode:
      if (!nonimmediate_operand (operands[1], E_SImode)
          || !general_operand (operands[2], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern162 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1)
      || !scratch_operand (operands[0], i1))
    return -1;
  return 0;
}

int
pattern167 (rtx x1, int *pnum_clobbers, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || !register_operand (operands[1], E_V16QImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || !register_operand (operands[1], E_V8HImode))
        return -1;
      return 1;

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || !register_operand (operands[1], E_V4SImode))
        return -1;
      return 2;

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || !register_operand (operands[1], E_V2DImode))
        return -1;
      return 3;

    case E_V1TImode:
      if (!register_operand (operands[0], E_V1TImode)
          || !register_operand (operands[1], E_V1TImode))
        return -1;
      return 4;

    case E_TImode:
      if (!register_operand (operands[0], E_TImode)
          || !register_operand (operands[1], E_TImode))
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern184 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  switch (GET_CODE (x2))
    {
    case UNSPEC:
      if (XVECLEN (x2, 0) != 1
          || XINT (x2, 1) != 4
          || GET_MODE (x2) != E_SImode
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      if (!register_operand (operands[1], E_CCUmode))
        return -1;
      return 0;

    case SUBREG:
    case MEM:
      operands[1] = x2;
      if (!s_operand (operands[1], E_QImode))
        return -1;
      res = pattern71 (x1);
      if (res >= 0)
        return res + 1; /* [1, 2] */
      return -1;

    default:
      return -1;
    }
}

int
pattern194 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  if (!nonmemory_operand (operands[2], E_VOIDmode))
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  if (!immediate_operand (operands[3], E_VOIDmode))
    return -1;
  x6 = XVECEXP (x1, 0, 3);
  x7 = XEXP (x6, 0);
  operands[4] = x7;
  switch (GET_MODE (operands[4]))
    {
    case E_DImode:
      if (!scratch_operand (operands[4], E_DImode))
        return -1;
      return 0;

    case E_SImode:
      if (!scratch_operand (operands[4], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern205 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[3], i2)
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern211 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1)
      || !s390_slb_comparison (operands[3], i1))
    return -1;
  return 0;
}

int
pattern220 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern229 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1)
      || !general_operand (operands[2], i1)
      || !register_operand (operands[3], i1)
      || !nonimmediate_operand (operands[4], i1)
      || GET_MODE (x1) != i1
      || !scratch_operand (operands[5], i1))
    return -1;
  return 0;
}

int
pattern238 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !scratch_operand (operands[0], i1))
    return -1;
  return 0;
}

int
pattern242 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !const0_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern247 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !s390_alc_comparison (operands[3], i1)
      || !nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern256 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1)
      || !const0_operand (operands[3], i1)
      || !scratch_operand (operands[0], i1))
    return -1;
  return 0;
}

int
pattern264 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !immediate_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !nonimmediate_operand (operands[3], i1)
      || !nonzero_shift_count_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern273 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern278 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !const_int_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern288 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[1], i1)
      || pattern285 (x1, 
i1, 
i2) != 0)
    return -1;
  return 0;
}

int
pattern295 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

 int
recog_3 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pattern25 (x1, 
E_CCRAWmode) != 0)
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || !register_operand (operands[1], E_V16QImode)
          || !
#line 1244 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 347; /* *vec_test_maskv16qi */

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || !register_operand (operands[1], E_V8HImode)
          || !
#line 1244 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 348; /* *vec_test_maskv8hi */

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || !register_operand (operands[1], E_V4SImode)
          || !
#line 1244 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 349; /* *vec_test_maskv4si */

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || !register_operand (operands[1], E_V2DImode)
          || !
#line 1244 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 350; /* *vec_test_maskv2di */

    case E_V1TImode:
      if (!register_operand (operands[0], E_V1TImode)
          || !register_operand (operands[1], E_V1TImode)
          || !
#line 1244 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 351; /* *vec_test_maskv1ti */

    case E_TImode:
      if (!register_operand (operands[0], E_TImode)
          || !register_operand (operands[1], E_TImode)
          || !
#line 1244 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 352; /* *vec_test_maskti */

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || !register_operand (operands[1], E_V2DImode)
          || !
#line 1244 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 353; /* *vec_test_maskv2df */

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || !register_operand (operands[1], E_V4SImode)
          || !(
#line 1244 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 34 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      return 354; /* *vec_test_maskv4sf */

    case E_V1TFmode:
      if (!register_operand (operands[0], E_V1TFmode)
          || !register_operand (operands[1], E_V1TImode)
          || !(
#line 1244 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 34 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      return 355; /* *vec_test_maskv1tf */

    case E_TFmode:
      if (!register_operand (operands[0], E_TFmode)
          || !register_operand (operands[1], E_TImode)
          || !(
#line 1244 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 35 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      return 356; /* *vec_test_masktf */

    default:
      return -1;
    }
}

 int
recog_13 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern24 (x1))
    {
    case 0:
      if (!
#line 1598 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1097; /* *vec_slbv16qi */

    case 1:
      if (!
#line 1598 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1098; /* *vec_slbv8hi */

    case 2:
      if (!
#line 1598 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1099; /* *vec_slbv4si */

    case 3:
      if (!
#line 1598 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1100; /* *vec_slbv2di */

    case 4:
      if (!
#line 1598 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1101; /* *vec_slbv1ti */

    case 5:
      if (!
#line 1598 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1102; /* *vec_slbti */

    case 6:
      if (!
#line 1598 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1103; /* *vec_slbv4sf */

    case 7:
      if (!
#line 1598 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1104; /* *vec_slbv2df */

    case 8:
      if (!
#line 1598 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1105; /* *vec_slbv1tf */

    case 9:
      if (!
#line 1598 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1106; /* *vec_slbtf */

    default:
      return -1;
    }
}

 int
recog_20 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PARALLEL)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  x5 = XEXP (x2, 0);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  x7 = XEXP (x5, 1);
  operands[2] = x7;
  switch (XVECLEN (x3, 0))
    {
    case 2:
      x8 = XVECEXP (x3, 0, 0);
      if (GET_CODE (x8) != CONST_INT)
        return -1;
      x9 = XVECEXP (x3, 0, 1);
      if (GET_CODE (x9) != CONST_INT)
        return -1;
      switch (XWINT (x8, 0))
        {
        case 0L:
          switch (XWINT (x9, 0))
            {
            case 3L:
              switch (GET_MODE (operands[0]))
                {
                case E_V2DImode:
                  if (pattern220 (x2, 
E_V2DImode, 
E_V4DImode) != 0
                      || !
#line 794 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 657; /* vpdi1v2di */

                case E_V2DFmode:
                  if (pattern220 (x2, 
E_V2DFmode, 
E_V4DFmode) != 0
                      || !
#line 794 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 658; /* vpdi1v2df */

                default:
                  return -1;
                }

            case 2L:
              switch (GET_MODE (operands[0]))
                {
                case E_V2DImode:
                  if (pattern220 (x2, 
E_V2DImode, 
E_V4DImode) != 0
                      || !
#line 921 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 673; /* *vmrhg */

                case E_V2DFmode:
                  if (pattern220 (x2, 
E_V2DFmode, 
E_V4DFmode) != 0
                      || !
#line 921 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 674; /* *vmrhg */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 1L:
          switch (XWINT (x9, 0))
            {
            case 2L:
              switch (GET_MODE (operands[0]))
                {
                case E_V2DImode:
                  if (pattern220 (x2, 
E_V2DImode, 
E_V4DImode) != 0
                      || !
#line 806 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 659; /* vpdi4v2di */

                case E_V2DFmode:
                  if (pattern220 (x2, 
E_V2DFmode, 
E_V4DFmode) != 0
                      || !
#line 806 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 660; /* vpdi4v2df */

                default:
                  return -1;
                }

            case 3L:
              switch (GET_MODE (operands[0]))
                {
                case E_V2DImode:
                  if (pattern220 (x2, 
E_V2DImode, 
E_V4DImode) != 0
                      || !
#line 931 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 675; /* *vmrlg */

                case E_V2DFmode:
                  if (pattern220 (x2, 
E_V2DFmode, 
E_V4DFmode) != 0
                      || !
#line 931 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 676; /* *vmrlg */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 4:
      x8 = XVECEXP (x3, 0, 0);
      if (GET_CODE (x8) != CONST_INT)
        return -1;
      x9 = XVECEXP (x3, 0, 1);
      if (GET_CODE (x9) != CONST_INT)
        return -1;
      x10 = XVECEXP (x3, 0, 2);
      if (GET_CODE (x10) != CONST_INT)
        return -1;
      x11 = XVECEXP (x3, 0, 3);
      if (GET_CODE (x11) != CONST_INT)
        return -1;
      switch (XWINT (x8, 0))
        {
        case 2L:
          switch (XWINT (x9, 0))
            {
            case 3L:
              if (XWINT (x10, 0) != 4L
                  || XWINT (x11, 0) != 5L)
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_V4SImode:
                  if (pattern220 (x2, 
E_V4SImode, 
E_V8SImode) != 0
                      || !
#line 818 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 661; /* vpdi4_2v4si */

                case E_V4SFmode:
                  if (pattern220 (x2, 
E_V4SFmode, 
E_V8SFmode) != 0
                      || !
#line 818 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 662; /* vpdi4_2v4sf */

                default:
                  return -1;
                }

            case 6L:
              if (XWINT (x10, 0) != 3L
                  || XWINT (x11, 0) != 7L)
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_V4SImode:
                  if (pattern220 (x2, 
E_V4SImode, 
E_V8SImode) != 0
                      || !
#line 911 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 671; /* *vmrlf */

                case E_V4SFmode:
                  if (pattern220 (x2, 
E_V4SFmode, 
E_V8SFmode) != 0
                      || !
#line 911 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 672; /* *vmrlf */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 0L:
          if (XWINT (x10, 0) != 1L)
            return -1;
          switch (XWINT (x9, 0))
            {
            case 4L:
              if (XWINT (x11, 0) != 5L)
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_V4SImode:
                  if (pattern220 (x2, 
E_V4SImode, 
E_V8SImode) != 0
                      || !
#line 889 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 667; /* *vmrhf */

                case E_V4SFmode:
                  if (pattern220 (x2, 
E_V4SFmode, 
E_V8SFmode) != 0
                      || !
#line 889 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 668; /* *vmrhf */

                default:
                  return -1;
                }

            case 2L:
              if (XWINT (x11, 0) != 3L)
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_V4SImode:
                  if (pattern107 (x2, 
E_V2SImode, 
E_V4SImode) != 0
                      || !
#line 900 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 669; /* *vmrhf_halfv4si */

                case E_V4SFmode:
                  if (pattern107 (x2, 
E_V2SFmode, 
E_V4SFmode) != 0
                      || !
#line 900 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 670; /* *vmrhf_halfv4sf */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 16:
      if (pattern129 (x3) != 0)
        return -1;
      x12 = XVECEXP (x3, 0, 8);
      if (GET_CODE (x12) != CONST_INT)
        return -1;
      x13 = XVECEXP (x3, 0, 9);
      if (GET_CODE (x13) != CONST_INT)
        return -1;
      x14 = XVECEXP (x3, 0, 10);
      if (GET_CODE (x14) != CONST_INT)
        return -1;
      x15 = XVECEXP (x3, 0, 11);
      if (GET_CODE (x15) != CONST_INT)
        return -1;
      x16 = XVECEXP (x3, 0, 12);
      if (GET_CODE (x16) != CONST_INT)
        return -1;
      x17 = XVECEXP (x3, 0, 13);
      if (GET_CODE (x17) != CONST_INT)
        return -1;
      x18 = XVECEXP (x3, 0, 14);
      if (GET_CODE (x18) != CONST_INT)
        return -1;
      x19 = XVECEXP (x3, 0, 15);
      if (GET_CODE (x19) != CONST_INT
          || pattern220 (x2, 
E_V16QImode, 
E_V32QImode) != 0)
        return -1;
      x8 = XVECEXP (x3, 0, 0);
      switch (XWINT (x8, 0))
        {
        case 0L:
          x9 = XVECEXP (x3, 0, 1);
          if (XWINT (x9, 0) != 16L)
            return -1;
          x10 = XVECEXP (x3, 0, 2);
          if (XWINT (x10, 0) != 1L)
            return -1;
          x11 = XVECEXP (x3, 0, 3);
          if (XWINT (x11, 0) != 17L)
            return -1;
          x20 = XVECEXP (x3, 0, 4);
          if (XWINT (x20, 0) != 2L)
            return -1;
          x21 = XVECEXP (x3, 0, 5);
          if (XWINT (x21, 0) != 18L)
            return -1;
          x22 = XVECEXP (x3, 0, 6);
          if (XWINT (x22, 0) != 3L)
            return -1;
          x23 = XVECEXP (x3, 0, 7);
          if (XWINT (x23, 0) != 19L
              || XWINT (x12, 0) != 4L
              || XWINT (x13, 0) != 20L
              || XWINT (x14, 0) != 5L
              || XWINT (x15, 0) != 21L
              || XWINT (x16, 0) != 6L
              || XWINT (x17, 0) != 22L
              || XWINT (x18, 0) != 7L
              || XWINT (x19, 0) != 23L
              || !
#line 835 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 663; /* *vmrhb */

        case 8L:
          x9 = XVECEXP (x3, 0, 1);
          if (XWINT (x9, 0) != 24L)
            return -1;
          x10 = XVECEXP (x3, 0, 2);
          if (XWINT (x10, 0) != 9L)
            return -1;
          x11 = XVECEXP (x3, 0, 3);
          if (XWINT (x11, 0) != 25L)
            return -1;
          x20 = XVECEXP (x3, 0, 4);
          if (XWINT (x20, 0) != 10L)
            return -1;
          x21 = XVECEXP (x3, 0, 5);
          if (XWINT (x21, 0) != 26L)
            return -1;
          x22 = XVECEXP (x3, 0, 6);
          if (XWINT (x22, 0) != 11L)
            return -1;
          x23 = XVECEXP (x3, 0, 7);
          if (XWINT (x23, 0) != 27L
              || XWINT (x12, 0) != 12L
              || XWINT (x13, 0) != 28L
              || XWINT (x14, 0) != 13L
              || XWINT (x15, 0) != 29L
              || XWINT (x16, 0) != 14L
              || XWINT (x17, 0) != 30L
              || XWINT (x18, 0) != 15L
              || XWINT (x19, 0) != 31L
              || !
#line 852 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 664; /* *vmrlb */

        default:
          return -1;
        }

    case 8:
      if (pattern129 (x3) != 0
          || pattern220 (x2, 
E_V8HImode, 
E_V16HImode) != 0)
        return -1;
      x8 = XVECEXP (x3, 0, 0);
      switch (XWINT (x8, 0))
        {
        case 0L:
          x9 = XVECEXP (x3, 0, 1);
          if (XWINT (x9, 0) != 8L)
            return -1;
          x10 = XVECEXP (x3, 0, 2);
          if (XWINT (x10, 0) != 1L)
            return -1;
          x11 = XVECEXP (x3, 0, 3);
          if (XWINT (x11, 0) != 9L)
            return -1;
          x20 = XVECEXP (x3, 0, 4);
          if (XWINT (x20, 0) != 2L)
            return -1;
          x21 = XVECEXP (x3, 0, 5);
          if (XWINT (x21, 0) != 10L)
            return -1;
          x22 = XVECEXP (x3, 0, 6);
          if (XWINT (x22, 0) != 3L)
            return -1;
          x23 = XVECEXP (x3, 0, 7);
          if (XWINT (x23, 0) != 11L
              || !
#line 865 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 665; /* *vmrhh */

        case 4L:
          x9 = XVECEXP (x3, 0, 1);
          if (XWINT (x9, 0) != 12L)
            return -1;
          x10 = XVECEXP (x3, 0, 2);
          if (XWINT (x10, 0) != 5L)
            return -1;
          x11 = XVECEXP (x3, 0, 3);
          if (XWINT (x11, 0) != 13L)
            return -1;
          x20 = XVECEXP (x3, 0, 4);
          if (XWINT (x20, 0) != 6L)
            return -1;
          x21 = XVECEXP (x3, 0, 5);
          if (XWINT (x21, 0) != 14L)
            return -1;
          x22 = XVECEXP (x3, 0, 6);
          if (XWINT (x22, 0) != 7L)
            return -1;
          x23 = XVECEXP (x3, 0, 7);
          if (XWINT (x23, 0) != 15L
              || !
#line 878 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 666; /* *vmrlh */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_29 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[3] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V1QImode:
      if (pattern204 (x2, 
E_V1QImode) != 0)
        return -1;
      if (const0_operand (operands[4], E_V1QImode)
          && 
#line 2584 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 1419; /* vec_sel0v1qi */
      if (!all_ones_operand (operands[4], E_V1QImode)
          || !
#line 2608 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1460; /* *vec_sel1v1qi */

    case E_V2QImode:
      if (pattern204 (x2, 
E_V2QImode) != 0)
        return -1;
      if (const0_operand (operands[4], E_V2QImode)
          && 
#line 2584 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 1420; /* vec_sel0v2qi */
      if (!all_ones_operand (operands[4], E_V2QImode)
          || !
#line 2608 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1461; /* *vec_sel1v2qi */

    case E_V4QImode:
      if (pattern204 (x2, 
E_V4QImode) != 0)
        return -1;
      if (const0_operand (operands[4], E_V4QImode)
          && 
#line 2584 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 1421; /* vec_sel0v4qi */
      if (!all_ones_operand (operands[4], E_V4QImode)
          || !
#line 2608 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1462; /* *vec_sel1v4qi */

    case E_V8QImode:
      if (pattern204 (x2, 
E_V8QImode) != 0)
        return -1;
      if (const0_operand (operands[4], E_V8QImode)
          && 
#line 2584 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 1422; /* vec_sel0v8qi */
      if (!all_ones_operand (operands[4], E_V8QImode)
          || !
#line 2608 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1463; /* *vec_sel1v8qi */

    case E_V16QImode:
      if (pattern204 (x2, 
E_V16QImode) != 0)
        return -1;
      if (const0_operand (operands[4], E_V16QImode)
          && 
#line 2584 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 1423; /* vec_sel0v16qi */
      if (!all_ones_operand (operands[4], E_V16QImode)
          || !
#line 2608 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1464; /* *vec_sel1v16qi */

    case E_V1HImode:
      if (pattern204 (x2, 
E_V1HImode) != 0)
        return -1;
      if (const0_operand (operands[4], E_V1HImode)
          && 
#line 2584 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 1424; /* vec_sel0v1hi */
      if (!all_ones_operand (operands[4], E_V1HImode)
          || !
#line 2608 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1465; /* *vec_sel1v1hi */

    case E_V2HImode:
      if (pattern204 (x2, 
E_V2HImode) != 0)
        return -1;
      if (const0_operand (operands[4], E_V2HImode)
          && 
#line 2584 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 1425; /* vec_sel0v2hi */
      if (!all_ones_operand (operands[4], E_V2HImode)
          || !
#line 2608 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1466; /* *vec_sel1v2hi */

    case E_V4HImode:
      if (pattern204 (x2, 
E_V4HImode) != 0)
        return -1;
      if (const0_operand (operands[4], E_V4HImode)
          && 
#line 2584 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 1426; /* vec_sel0v4hi */
      if (!all_ones_operand (operands[4], E_V4HImode)
          || !
#line 2608 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1467; /* *vec_sel1v4hi */

    case E_V8HImode:
      if (pattern204 (x2, 
E_V8HImode) != 0)
        return -1;
      if (const0_operand (operands[4], E_V8HImode)
          && 
#line 2584 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 1427; /* vec_sel0v8hi */
      if (!all_ones_operand (operands[4], E_V8HImode)
          || !
#line 2608 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1468; /* *vec_sel1v8hi */

    case E_V1SImode:
      if (pattern204 (x2, 
E_V1SImode) != 0)
        return -1;
      if (const0_operand (operands[4], E_V1SImode)
          && 
#line 2584 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 1428; /* vec_sel0v1si */
      if (!all_ones_operand (operands[4], E_V1SImode)
          || !
#line 2608 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1469; /* *vec_sel1v1si */

    case E_V2SImode:
      if (pattern204 (x2, 
E_V2SImode) != 0)
        return -1;
      if (const0_operand (operands[4], E_V2SImode)
          && 
#line 2584 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 1429; /* vec_sel0v2si */
      if (!all_ones_operand (operands[4], E_V2SImode)
          || !
#line 2608 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1470; /* *vec_sel1v2si */

    case E_V4SImode:
      if (pattern204 (x2, 
E_V4SImode) != 0)
        return -1;
      if (const0_operand (operands[4], E_V4SImode)
          && 
#line 2584 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 1430; /* vec_sel0v4si */
      if (!all_ones_operand (operands[4], E_V4SImode)
          || !
#line 2608 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1471; /* *vec_sel1v4si */

    case E_V1DImode:
      if (pattern204 (x2, 
E_V1DImode) != 0)
        return -1;
      if (const0_operand (operands[4], E_V1DImode)
          && 
#line 2584 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 1431; /* vec_sel0v1di */
      if (!all_ones_operand (operands[4], E_V1DImode)
          || !
#line 2608 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1472; /* *vec_sel1v1di */

    case E_V2DImode:
      if (pattern204 (x2, 
E_V2DImode) != 0)
        return -1;
      if (const0_operand (operands[4], E_V2DImode)
          && 
#line 2584 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 1432; /* vec_sel0v2di */
      if (!all_ones_operand (operands[4], E_V2DImode)
          || !
#line 2608 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1473; /* *vec_sel1v2di */

    case E_V1SFmode:
      if (pattern205 (x2, 
E_V1SFmode, 
E_V1SImode) != 0)
        return -1;
      if (const0_operand (operands[4], E_V1SImode)
          && 
#line 2584 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 1433; /* vec_sel0v1sf */
      if (!all_ones_operand (operands[4], E_V1SImode)
          || !
#line 2608 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1474; /* *vec_sel1v1sf */

    case E_V2SFmode:
      if (pattern205 (x2, 
E_V2SFmode, 
E_V2SImode) != 0)
        return -1;
      if (const0_operand (operands[4], E_V2SImode)
          && 
#line 2584 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 1434; /* vec_sel0v2sf */
      if (!all_ones_operand (operands[4], E_V2SImode)
          || !
#line 2608 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1475; /* *vec_sel1v2sf */

    case E_V4SFmode:
      if (pattern205 (x2, 
E_V4SFmode, 
E_V4SImode) != 0)
        return -1;
      if (const0_operand (operands[4], E_V4SImode)
          && 
#line 2584 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 1435; /* vec_sel0v4sf */
      if (!all_ones_operand (operands[4], E_V4SImode)
          || !
#line 2608 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1476; /* *vec_sel1v4sf */

    case E_V1DFmode:
      if (pattern205 (x2, 
E_V1DFmode, 
E_V1DImode) != 0)
        return -1;
      if (const0_operand (operands[4], E_V1DImode)
          && 
#line 2584 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 1436; /* vec_sel0v1df */
      if (!all_ones_operand (operands[4], E_V1DImode)
          || !
#line 2608 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1477; /* *vec_sel1v1df */

    case E_V2DFmode:
      if (pattern205 (x2, 
E_V2DFmode, 
E_V2DImode) != 0)
        return -1;
      if (const0_operand (operands[4], E_V2DImode)
          && 
#line 2584 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 1437; /* vec_sel0v2df */
      if (!all_ones_operand (operands[4], E_V2DImode)
          || !
#line 2608 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1478; /* *vec_sel1v2df */

    case E_V1TFmode:
      if (!register_operand (operands[0], E_V1TFmode)
          || GET_MODE (x2) != E_V1TFmode
          || !register_operand (operands[3], E_V1TImode)
          || !const0_operand (operands[4], E_V1TImode)
          || !register_operand (operands[1], E_V1TFmode)
          || !register_operand (operands[2], E_V1TFmode)
          || !
#line 2584 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1438; /* vec_sel0v1tf */

    case E_V1TImode:
      if (pattern206 (x2, 
E_V1TImode) != 0
          || !
#line 2584 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1439; /* vec_sel0v1ti */

    case E_TImode:
      if (pattern206 (x2, 
E_TImode) != 0
          || !
#line 2584 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1440; /* vec_sel0ti */

    default:
      return -1;
    }
}

 int
recog_41 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x1, 1);
  operands[3] = x4;
  switch (GET_MODE (x2))
    {
    case E_DImode:
      if (!nonimmediate_operand (operands[0], E_DImode)
          || !nonimmediate_operand (operands[3], E_DImode))
        return -1;
      if ((
#line 4486 "../../gcc/config/s390/s390.md"
(TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[1]), INTVAL (operands[2]),
			     GET_MODE_BITSIZE (DImode))
   && (INTVAL (operands[1]) + INTVAL (operands[2])) <= 64) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
        return 1956; /* *insvdi_nocc */
      if (pnum_clobbers == NULL
          || !(
#line 4486 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[1]), INTVAL (operands[2]),
			     GET_MODE_BITSIZE (DImode))
   && (INTVAL (operands[1]) + INTVAL (operands[2])) <= 64) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
        return -1;
      *pnum_clobbers = 1;
      return 1957; /* *insvdi_clobbercc */

    case E_SImode:
      if (!nonimmediate_operand (operands[0], E_SImode)
          || !nonimmediate_operand (operands[3], E_SImode))
        return -1;
      if (
#line 4486 "../../gcc/config/s390/s390.md"
(TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[1]), INTVAL (operands[2]),
			     GET_MODE_BITSIZE (SImode))
   && (INTVAL (operands[1]) + INTVAL (operands[2])) <= 32))
        return 1958; /* *insvsi_nocc */
      if (pnum_clobbers == NULL
          || !
#line 4486 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[1]), INTVAL (operands[2]),
			     GET_MODE_BITSIZE (SImode))
   && (INTVAL (operands[1]) + INTVAL (operands[2])) <= 32))
        return -1;
      *pnum_clobbers = 1;
      return 1959; /* *insvsi_clobbercc */

    default:
      return -1;
    }
}

 int
recog_46 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_V1QImode:
          if (pattern64 (x3, 
E_V1QImode) != 0
              || !
#line 1136 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 684; /* addv1qi3 */

        case E_V2QImode:
          if (pattern64 (x3, 
E_V2QImode) != 0
              || !
#line 1136 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 685; /* addv2qi3 */

        case E_V4QImode:
          if (pattern64 (x3, 
E_V4QImode) != 0
              || !
#line 1136 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 686; /* addv4qi3 */

        case E_V8QImode:
          if (pattern64 (x3, 
E_V8QImode) != 0
              || !
#line 1136 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 687; /* addv8qi3 */

        case E_V16QImode:
          if (pattern64 (x3, 
E_V16QImode) != 0
              || !
#line 1136 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 688; /* addv16qi3 */

        case E_V1HImode:
          if (pattern64 (x3, 
E_V1HImode) != 0
              || !
#line 1136 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 689; /* addv1hi3 */

        case E_V2HImode:
          if (pattern64 (x3, 
E_V2HImode) != 0
              || !
#line 1136 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 690; /* addv2hi3 */

        case E_V4HImode:
          if (pattern64 (x3, 
E_V4HImode) != 0
              || !
#line 1136 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 691; /* addv4hi3 */

        case E_V8HImode:
          if (pattern64 (x3, 
E_V8HImode) != 0
              || !
#line 1136 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 692; /* addv8hi3 */

        case E_V1SImode:
          if (pattern64 (x3, 
E_V1SImode) != 0
              || !
#line 1136 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 693; /* addv1si3 */

        case E_V2SImode:
          if (pattern64 (x3, 
E_V2SImode) != 0
              || !
#line 1136 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 694; /* addv2si3 */

        case E_V4SImode:
          if (pattern64 (x3, 
E_V4SImode) != 0
              || !
#line 1136 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 695; /* addv4si3 */

        case E_V1DImode:
          if (pattern64 (x3, 
E_V1DImode) != 0
              || !
#line 1136 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 696; /* addv1di3 */

        case E_V2DImode:
          if (pattern64 (x3, 
E_V2DImode) != 0
              || !
#line 1136 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 697; /* addv2di3 */

        case E_V1TImode:
          if (pattern64 (x3, 
E_V1TImode) != 0
              || !
#line 1136 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 698; /* addv1ti3 */

        case E_TImode:
          if (GET_MODE (x3) != E_TImode
              || !nonimmediate_operand (operands[1], E_TImode)
              || !general_operand (operands[2], E_TImode))
            return -1;
          if (nonimmediate_operand (operands[0], E_TImode)
              && 
#line 1136 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 699; /* *addti3 */
          if (pnum_clobbers == NULL
              || !register_operand (operands[0], E_TImode)
              || !
#line 6072 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return -1;
          *pnum_clobbers = 1;
          return 2196; /* *addti3 */

        case E_V4SFmode:
          if (pattern0 (x3, 
E_V4SFmode) != 0
              || !(
#line 1861 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 87 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1227; /* addv4sf3 */

        case E_V2DFmode:
          if (pattern0 (x3, 
E_V2DFmode) != 0
              || !
#line 1861 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1228; /* addv2df3 */

        case E_V1TFmode:
          if (pattern0 (x3, 
E_V1TFmode) != 0
              || !(
#line 1861 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 87 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1229; /* addv1tf3 */

        case E_TFmode:
          if (!register_operand (operands[0], E_TFmode)
              || GET_MODE (x3) != E_TFmode)
            return -1;
          if (register_operand (operands[1], E_TFmode)
              && register_operand (operands[2], E_TFmode)
              && (
#line 1861 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 88 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return 1230; /* addtf3_vr */
          if (pnum_clobbers == NULL
              || !nonimmediate_operand (operands[1], E_TFmode)
              || !general_operand (operands[2], E_TFmode)
              || !(
#line 6490 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 751 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          *pnum_clobbers = 1;
          return 2226; /* addtf3_fpr */

        case E_FPRX2mode:
          if (pnum_clobbers == NULL
              || pattern176 (x3, 
E_FPRX2mode) != 0
              || !(
#line 6490 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 751 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          *pnum_clobbers = 1;
          return 2227; /* addfprx23 */

        case E_DFmode:
          if (pnum_clobbers == NULL
              || pattern176 (x3, 
E_DFmode) != 0
              || !
#line 6490 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
            return -1;
          *pnum_clobbers = 1;
          return 2228; /* adddf3 */

        case E_SFmode:
          if (pnum_clobbers == NULL
              || pattern176 (x3, 
E_SFmode) != 0
              || !
#line 6490 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
            return -1;
          *pnum_clobbers = 1;
          return 2229; /* addsf3 */

        case E_TDmode:
          if (pnum_clobbers == NULL
              || pattern176 (x3, 
E_TDmode) != 0
              || !(
#line 6490 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 752 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          *pnum_clobbers = 1;
          return 2230; /* addtd3 */

        case E_DDmode:
          if (pnum_clobbers == NULL
              || pattern176 (x3, 
E_DDmode) != 0
              || !(
#line 6490 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 752 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          *pnum_clobbers = 1;
          return 2231; /* adddd3 */

        default:
          return -1;
        }

    case ASHIFT:
      if (GET_MODE (x4) != E_DImode)
        return -1;
      x6 = XEXP (x4, 0);
      if (GET_CODE (x6) != SIGN_EXTEND
          || GET_MODE (x6) != E_DImode)
        return -1;
      x7 = XEXP (x4, 1);
      if (GET_CODE (x7) != CONST_INT
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      x5 = XEXP (x3, 1);
      if (!register_operand (x5, E_DImode))
        return -1;
      x8 = XEXP (x6, 0);
      switch (GET_CODE (x8))
        {
        case REG:
        case SUBREG:
          operands[1] = x8;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          operands[2] = x5;
          switch (XWINT (x7, 0))
            {
            case 1L:
              if (!
#line 2086 "../../gcc/config/s390/s390.md"
(TARGET_Z17 && TARGET_64BIT))
                return -1;
              return 1826; /* *lxah_index_base */

            case 2L:
              if (!
#line 2086 "../../gcc/config/s390/s390.md"
(TARGET_Z17 && TARGET_64BIT))
                return -1;
              return 1827; /* *lxaf_index_base */

            case 3L:
              if (!
#line 2086 "../../gcc/config/s390/s390.md"
(TARGET_Z17 && TARGET_64BIT))
                return -1;
              return 1828; /* *lxag_index_base */

            case 4L:
              if (!
#line 2086 "../../gcc/config/s390/s390.md"
(TARGET_Z17 && TARGET_64BIT))
                return -1;
              return 1829; /* *lxaq_index_base */

            default:
              return -1;
            }

        case PLUS:
          if (GET_MODE (x8) != E_SImode)
            return -1;
          x9 = XEXP (x8, 0);
          operands[1] = x9;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          x10 = XEXP (x8, 1);
          operands[2] = x10;
          if (!const_int_operand (operands[2], E_SImode))
            return -1;
          operands[3] = x5;
          switch (XWINT (x7, 0))
            {
            case 1L:
              if (!
#line 2097 "../../gcc/config/s390/s390.md"
(TARGET_Z17 && TARGET_64BIT && INTVAL (operands[2]) >= -0x80000 && INTVAL (operands[2]) <= 0x7FFFF))
                return -1;
              return 1830; /* *lxah_displacement_index_base */

            case 2L:
              if (!
#line 2097 "../../gcc/config/s390/s390.md"
(TARGET_Z17 && TARGET_64BIT && INTVAL (operands[2]) >= -0x80000 && INTVAL (operands[2]) <= 0x7FFFF))
                return -1;
              return 1831; /* *lxaf_displacement_index_base */

            case 3L:
              if (!
#line 2097 "../../gcc/config/s390/s390.md"
(TARGET_Z17 && TARGET_64BIT && INTVAL (operands[2]) >= -0x80000 && INTVAL (operands[2]) <= 0x7FFFF))
                return -1;
              return 1832; /* *lxag_displacement_index_base */

            case 4L:
              if (!
#line 2097 "../../gcc/config/s390/s390.md"
(TARGET_Z17 && TARGET_64BIT && INTVAL (operands[2]) >= -0x80000 && INTVAL (operands[2]) <= 0x7FFFF))
                return -1;
              return 1833; /* *lxaq_displacement_index_base */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SIGN_EXTEND:
      if (pattern112 (x3) != 0
          || !
#line 2106 "../../gcc/config/s390/s390.md"
(TARGET_Z17 && TARGET_64BIT && INTVAL (operands[2]) >= -0x80000 && INTVAL (operands[2]) <= 0x7FFFF))
        return -1;
      return 1834; /* *lxab_displacement_index_base */

    case AND:
      if (GET_MODE (x4) != E_DImode)
        return -1;
      x6 = XEXP (x4, 0);
      if (GET_CODE (x6) != ASHIFT
          || GET_MODE (x6) != E_DImode)
        return -1;
      x11 = XEXP (x6, 1);
      if (GET_CODE (x11) != CONST_INT)
        return -1;
      x7 = XEXP (x4, 1);
      if (GET_CODE (x7) != CONST_INT
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      x8 = XEXP (x6, 0);
      operands[1] = x8;
      if (register_operand (operands[1], E_DImode))
        {
          x5 = XEXP (x3, 1);
          operands[2] = x5;
          if (register_operand (operands[2], E_DImode))
            {
              switch (pattern270 (x4))
                {
                case 0:
                  if (
#line 2134 "../../gcc/config/s390/s390.md"
(TARGET_Z17 && TARGET_64BIT))
                    return 1839; /* *llxah_index_base */
                  break;

                case 1:
                  if (
#line 2134 "../../gcc/config/s390/s390.md"
(TARGET_Z17 && TARGET_64BIT))
                    return 1840; /* *llxaf_index_base */
                  break;

                case 2:
                  if (
#line 2134 "../../gcc/config/s390/s390.md"
(TARGET_Z17 && TARGET_64BIT))
                    return 1841; /* *llxag_index_base */
                  break;

                case 3:
                  if (
#line 2134 "../../gcc/config/s390/s390.md"
(TARGET_Z17 && TARGET_64BIT))
                    return 1842; /* *llxaq_index_base */
                  break;

                default:
                  break;
                }
            }
        }
      if (GET_CODE (x8) != SUBREG
          || maybe_ne (SUBREG_BYTE (x8), 0)
          || GET_MODE (x8) != E_DImode)
        return -1;
      x9 = XEXP (x8, 0);
      if (GET_CODE (x9) != PLUS
          || GET_MODE (x9) != E_SImode)
        return -1;
      x12 = XEXP (x9, 0);
      operands[1] = x12;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x13 = XEXP (x9, 1);
      operands[2] = x13;
      if (!const_int_operand (operands[2], E_SImode))
        return -1;
      x5 = XEXP (x3, 1);
      operands[3] = x5;
      if (!register_operand (operands[3], E_DImode))
        return -1;
      switch (pattern270 (x4))
        {
        case 0:
          if (!
#line 2147 "../../gcc/config/s390/s390.md"
(TARGET_Z17 && TARGET_64BIT && INTVAL (operands[2]) >= -0x80000 && INTVAL (operands[2]) <= 0x7FFFF))
            return -1;
          return 1843; /* *llxah_displacement_index_base */

        case 1:
          if (!
#line 2147 "../../gcc/config/s390/s390.md"
(TARGET_Z17 && TARGET_64BIT && INTVAL (operands[2]) >= -0x80000 && INTVAL (operands[2]) <= 0x7FFFF))
            return -1;
          return 1844; /* *llxaf_displacement_index_base */

        case 2:
          if (!
#line 2147 "../../gcc/config/s390/s390.md"
(TARGET_Z17 && TARGET_64BIT && INTVAL (operands[2]) >= -0x80000 && INTVAL (operands[2]) <= 0x7FFFF))
            return -1;
          return 1845; /* *llxag_displacement_index_base */

        case 3:
          if (!
#line 2147 "../../gcc/config/s390/s390.md"
(TARGET_Z17 && TARGET_64BIT && INTVAL (operands[2]) >= -0x80000 && INTVAL (operands[2]) <= 0x7FFFF))
            return -1;
          return 1846; /* *llxaq_displacement_index_base */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      if (pattern112 (x3) != 0
          || !
#line 2156 "../../gcc/config/s390/s390.md"
(TARGET_Z17 && TARGET_64BIT && INTVAL (operands[2]) >= -0x80000 && INTVAL (operands[2]) <= 0x7FFFF))
        return -1;
      return 1847; /* *llxab_displacement_index_base */

    default:
      return -1;
    }
}

 int
recog_62 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V1QImode:
      if (!register_operand (operands[0], E_V1QImode)
          || GET_MODE (x3) != E_V1QImode
          || !register_operand (operands[1], E_V1QImode))
        return -1;
      if (shift_count_operand_vec (operands[2], E_QImode)
          && 
#line 1524 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V1QImode)) - 1)
  ))
        return 990; /* *ashrv1qi3 */
      if (!register_operand (operands[2], E_V1QImode)
          || !
#line 1565 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1059; /* vashrv1qi3 */

    case E_V2QImode:
      if (!register_operand (operands[0], E_V2QImode)
          || GET_MODE (x3) != E_V2QImode
          || !register_operand (operands[1], E_V2QImode))
        return -1;
      if (shift_count_operand_vec (operands[2], E_QImode)
          && 
#line 1524 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V2QImode)) - 1)
  ))
        return 994; /* *ashrv2qi3 */
      if (!register_operand (operands[2], E_V2QImode)
          || !
#line 1565 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1060; /* vashrv2qi3 */

    case E_V4QImode:
      if (!register_operand (operands[0], E_V4QImode)
          || GET_MODE (x3) != E_V4QImode
          || !register_operand (operands[1], E_V4QImode))
        return -1;
      if (shift_count_operand_vec (operands[2], E_QImode)
          && 
#line 1524 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V4QImode)) - 1)
  ))
        return 998; /* *ashrv4qi3 */
      if (!register_operand (operands[2], E_V4QImode)
          || !
#line 1565 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1061; /* vashrv4qi3 */

    case E_V8QImode:
      if (!register_operand (operands[0], E_V8QImode)
          || GET_MODE (x3) != E_V8QImode
          || !register_operand (operands[1], E_V8QImode))
        return -1;
      if (shift_count_operand_vec (operands[2], E_QImode)
          && 
#line 1524 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V8QImode)) - 1)
  ))
        return 1002; /* *ashrv8qi3 */
      if (!register_operand (operands[2], E_V8QImode)
          || !
#line 1565 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1062; /* vashrv8qi3 */

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !register_operand (operands[1], E_V16QImode))
        return -1;
      if (shift_count_operand_vec (operands[2], E_QImode)
          && 
#line 1524 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V16QImode)) - 1)
  ))
        return 1006; /* *ashrv16qi3 */
      if (!register_operand (operands[2], E_V16QImode)
          || !
#line 1565 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1063; /* vashrv16qi3 */

    case E_V1HImode:
      if (!register_operand (operands[0], E_V1HImode)
          || GET_MODE (x3) != E_V1HImode
          || !register_operand (operands[1], E_V1HImode))
        return -1;
      if (shift_count_operand_vec (operands[2], E_QImode)
          && 
#line 1524 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V1HImode)) - 1)
  ))
        return 1010; /* *ashrv1hi3 */
      if (!register_operand (operands[2], E_V1HImode)
          || !
#line 1565 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1064; /* vashrv1hi3 */

    case E_V2HImode:
      if (!register_operand (operands[0], E_V2HImode)
          || GET_MODE (x3) != E_V2HImode
          || !register_operand (operands[1], E_V2HImode))
        return -1;
      if (shift_count_operand_vec (operands[2], E_QImode)
          && 
#line 1524 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V2HImode)) - 1)
  ))
        return 1014; /* *ashrv2hi3 */
      if (!register_operand (operands[2], E_V2HImode)
          || !
#line 1565 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1065; /* vashrv2hi3 */

    case E_V4HImode:
      if (!register_operand (operands[0], E_V4HImode)
          || GET_MODE (x3) != E_V4HImode
          || !register_operand (operands[1], E_V4HImode))
        return -1;
      if (shift_count_operand_vec (operands[2], E_QImode)
          && 
#line 1524 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V4HImode)) - 1)
  ))
        return 1018; /* *ashrv4hi3 */
      if (!register_operand (operands[2], E_V4HImode)
          || !
#line 1565 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1066; /* vashrv4hi3 */

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode
          || !register_operand (operands[1], E_V8HImode))
        return -1;
      if (shift_count_operand_vec (operands[2], E_QImode)
          && 
#line 1524 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V8HImode)) - 1)
  ))
        return 1022; /* *ashrv8hi3 */
      if (!register_operand (operands[2], E_V8HImode)
          || !
#line 1565 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1067; /* vashrv8hi3 */

    case E_V1SImode:
      if (!register_operand (operands[0], E_V1SImode)
          || GET_MODE (x3) != E_V1SImode
          || !register_operand (operands[1], E_V1SImode))
        return -1;
      if (shift_count_operand_vec (operands[2], E_QImode)
          && 
#line 1524 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V1SImode)) - 1)
  ))
        return 1026; /* *ashrv1si3 */
      if (!register_operand (operands[2], E_V1SImode)
          || !
#line 1565 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1068; /* vashrv1si3 */

    case E_V2SImode:
      if (!register_operand (operands[0], E_V2SImode)
          || GET_MODE (x3) != E_V2SImode
          || !register_operand (operands[1], E_V2SImode))
        return -1;
      if (shift_count_operand_vec (operands[2], E_QImode)
          && 
#line 1524 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V2SImode)) - 1)
  ))
        return 1030; /* *ashrv2si3 */
      if (!register_operand (operands[2], E_V2SImode)
          || !
#line 1565 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1069; /* vashrv2si3 */

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !register_operand (operands[1], E_V4SImode))
        return -1;
      if (shift_count_operand_vec (operands[2], E_QImode)
          && 
#line 1524 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V4SImode)) - 1)
  ))
        return 1034; /* *ashrv4si3 */
      if (!register_operand (operands[2], E_V4SImode)
          || !
#line 1565 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1070; /* vashrv4si3 */

    case E_V1DImode:
      if (!register_operand (operands[0], E_V1DImode)
          || GET_MODE (x3) != E_V1DImode
          || !register_operand (operands[1], E_V1DImode))
        return -1;
      if (shift_count_operand_vec (operands[2], E_QImode)
          && 
#line 1524 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V1DImode)) - 1)
  ))
        return 1038; /* *ashrv1di3 */
      if (!register_operand (operands[2], E_V1DImode)
          || !
#line 1565 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1071; /* vashrv1di3 */

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode
          || !register_operand (operands[1], E_V2DImode))
        return -1;
      if (shift_count_operand_vec (operands[2], E_QImode)
          && 
#line 1524 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V2DImode)) - 1)
  ))
        return 1042; /* *ashrv2di3 */
      if (!register_operand (operands[2], E_V2DImode)
          || !
#line 1565 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1072; /* vashrv2di3 */

    case E_DImode:
      if (pnum_clobbers == NULL
          || pattern10 (x3, 
E_DImode) != 0)
        return -1;
      if (
#line 9734 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
        {
          *pnum_clobbers = 1;
          return 2516; /* *ashrdi3_31 */
        }
      if (!
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
        return -1;
      *pnum_clobbers = 1;
      return 2519; /* *ashrdi3 */

    case E_SImode:
      if (pnum_clobbers == NULL
          || pattern10 (x3, 
E_SImode) != 0)
        return -1;
      *pnum_clobbers = 1;
      return 2522; /* *ashrsi3 */

    default:
      return -1;
    }
}

 int
recog_66 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case VEC_SELECT:
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) != PARALLEL
          || XVECLEN (x5, 0) != 1)
        return -1;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      x7 = XVECEXP (x5, 0, 0);
      operands[2] = x7;
      if (!const_mask_operand (operands[2], E_QImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          if (pattern171 (x3, 
E_V16QImode, 
E_QImode) != 0
              || !
#line 620 "../../gcc/config/s390/vector.md"
(TARGET_VX && UINTVAL (operands[2]) < GET_MODE_NUNITS (V16QImode)))
            return -1;
          return 621; /* *vec_splatv16qi */

        case E_V8HImode:
          if (pattern171 (x3, 
E_V8HImode, 
E_HImode) != 0
              || !
#line 620 "../../gcc/config/s390/vector.md"
(TARGET_VX && UINTVAL (operands[2]) < GET_MODE_NUNITS (V8HImode)))
            return -1;
          return 622; /* *vec_splatv8hi */

        case E_V4SImode:
          if (pattern171 (x3, 
E_V4SImode, 
E_SImode) != 0
              || !
#line 620 "../../gcc/config/s390/vector.md"
(TARGET_VX && UINTVAL (operands[2]) < GET_MODE_NUNITS (V4SImode)))
            return -1;
          return 623; /* *vec_splatv4si */

        case E_V4SFmode:
          if (pattern171 (x3, 
E_V4SFmode, 
E_SFmode) != 0
              || !
#line 620 "../../gcc/config/s390/vector.md"
(TARGET_VX && UINTVAL (operands[2]) < GET_MODE_NUNITS (V4SFmode)))
            return -1;
          return 624; /* *vec_splatv4sf */

        case E_V2DImode:
          if (pattern171 (x3, 
E_V2DImode, 
E_DImode) != 0
              || !
#line 620 "../../gcc/config/s390/vector.md"
(TARGET_VX && UINTVAL (operands[2]) < GET_MODE_NUNITS (V2DImode)))
            return -1;
          return 625; /* *vec_splatv2di */

        case E_V2DFmode:
          if (pattern171 (x3, 
E_V2DFmode, 
E_DFmode) != 0
              || !
#line 620 "../../gcc/config/s390/vector.md"
(TARGET_VX && UINTVAL (operands[2]) < GET_MODE_NUNITS (V2DFmode)))
            return -1;
          return 626; /* *vec_splatv2df */

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          if (!register_operand (operands[0], E_V16QImode)
              || GET_MODE (x3) != E_V16QImode
              || !general_operand (operands[1], E_QImode)
              || !
#line 628 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 627; /* *vec_splatsv16qi */

        case E_V8HImode:
          if (!register_operand (operands[0], E_V8HImode)
              || GET_MODE (x3) != E_V8HImode
              || !general_operand (operands[1], E_HImode)
              || !
#line 628 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 628; /* *vec_splatsv8hi */

        case E_V4SImode:
          if (!register_operand (operands[0], E_V4SImode)
              || GET_MODE (x3) != E_V4SImode
              || !general_operand (operands[1], E_SImode)
              || !
#line 628 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 629; /* *vec_splatsv4si */

        case E_V4SFmode:
          if (!register_operand (operands[0], E_V4SFmode)
              || GET_MODE (x3) != E_V4SFmode
              || !general_operand (operands[1], E_SFmode)
              || !
#line 628 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 630; /* *vec_splatsv4sf */

        case E_V2DImode:
          if (!register_operand (operands[0], E_V2DImode)
              || GET_MODE (x3) != E_V2DImode
              || !general_operand (operands[1], E_DImode)
              || !
#line 628 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 631; /* *vec_splatsv2di */

        case E_V2DFmode:
          if (!register_operand (operands[0], E_V2DFmode)
              || GET_MODE (x3) != E_V2DFmode
              || !general_operand (operands[1], E_DFmode)
              || !
#line 628 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 632; /* *vec_splatsv2df */

        case E_V1TFmode:
          if (!nonimmediate_operand (operands[0], E_V1TFmode)
              || GET_MODE (x3) != E_V1TFmode
              || !general_operand (operands[1], E_TFmode))
            return -1;
          if (
#line 661 "../../gcc/config/s390/vector.md"
(TARGET_VX && !TARGET_VXE))
            return 643; /* *vec_tf_to_v1tf_fpr */
          if (!
#line 674 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 644; /* *vec_tf_to_v1tf_vr */

        case E_V1TImode:
          if (!nonimmediate_operand (operands[0], E_V1TImode)
              || GET_MODE (x3) != E_V1TImode
              || !general_operand (operands[1], E_TImode)
              || !
#line 704 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 646; /* *vec_ti_to_v1ti */

        default:
          return -1;
        }

    case BSWAP:
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HImode:
          if (pattern84 (x3, 
E_HImode, 
E_V8HImode) != 0
              || !
#line 652 "../../gcc/config/s390/vector.md"
(TARGET_VXE2))
            return -1;
          return 638; /* *vec_splats_bswap_elemv8hi */

        case E_V4SImode:
          if (pattern84 (x3, 
E_SImode, 
E_V4SImode) != 0
              || !
#line 652 "../../gcc/config/s390/vector.md"
(TARGET_VXE2))
            return -1;
          return 639; /* *vec_splats_bswap_elemv4si */

        case E_V4SFmode:
          if (pattern84 (x3, 
E_SFmode, 
E_V4SFmode) != 0
              || !(
#line 652 "../../gcc/config/s390/vector.md"
(TARGET_VXE2) && 
#line 44 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 640; /* *vec_splats_bswap_elemv4sf */

        case E_V2DImode:
          if (pattern84 (x3, 
E_DImode, 
E_V2DImode) != 0
              || !
#line 652 "../../gcc/config/s390/vector.md"
(TARGET_VXE2))
            return -1;
          return 641; /* *vec_splats_bswap_elemv2di */

        case E_V2DFmode:
          if (pattern84 (x3, 
E_DFmode, 
E_V2DFmode) != 0
              || !
#line 652 "../../gcc/config/s390/vector.md"
(TARGET_VXE2))
            return -1;
          return 642; /* *vec_splats_bswap_elemv2df */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_76 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  x6 = XEXP (x3, 2);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
      operands[3] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SFmode:
          if (pattern136 (x3, 
E_V4SFmode) != 0
              || !(
#line 1940 "../../gcc/config/s390/vector.md"
(TARGET_VX && s390_fma_allowed_p (V4SFmode)) && 
#line 87 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1247; /* fmav4sf4 */

        case E_V2DFmode:
          if (pattern136 (x3, 
E_V2DFmode) != 0
              || !
#line 1940 "../../gcc/config/s390/vector.md"
(TARGET_VX && s390_fma_allowed_p (V2DFmode)))
            return -1;
          return 1248; /* fmav2df4 */

        case E_V1TFmode:
          if (pattern136 (x3, 
E_V1TFmode) != 0
              || !(
#line 1940 "../../gcc/config/s390/vector.md"
(TARGET_VX && s390_fma_allowed_p (V1TFmode)) && 
#line 87 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1249; /* fmav1tf4 */

        case E_TFmode:
          if (pattern136 (x3, 
E_TFmode) != 0
              || !(
#line 1940 "../../gcc/config/s390/vector.md"
(TARGET_VX && s390_fma_allowed_p (TFmode)) && 
#line 88 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1250; /* fmatf4 */

        case E_DFmode:
          if (pattern137 (x3, 
E_DFmode) != 0
              || !
#line 7598 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT && s390_fma_allowed_p (DFmode)))
            return -1;
          return 2331; /* fmadf4 */

        case E_SFmode:
          if (pattern137 (x3, 
E_SFmode) != 0
              || !
#line 7598 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT && s390_fma_allowed_p (SFmode)))
            return -1;
          return 2332; /* fmasf4 */

        default:
          return -1;
        }

    case NEG:
      x7 = XEXP (x6, 0);
      operands[3] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SFmode:
          if (pattern138 (x3, 
E_V4SFmode) != 0
              || !(
#line 1950 "../../gcc/config/s390/vector.md"
(TARGET_VX && s390_fma_allowed_p (V4SFmode)) && 
#line 87 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1251; /* fmsv4sf4 */

        case E_V2DFmode:
          if (pattern138 (x3, 
E_V2DFmode) != 0
              || !
#line 1950 "../../gcc/config/s390/vector.md"
(TARGET_VX && s390_fma_allowed_p (V2DFmode)))
            return -1;
          return 1252; /* fmsv2df4 */

        case E_V1TFmode:
          if (pattern138 (x3, 
E_V1TFmode) != 0
              || !(
#line 1950 "../../gcc/config/s390/vector.md"
(TARGET_VX && s390_fma_allowed_p (V1TFmode)) && 
#line 87 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1253; /* fmsv1tf4 */

        case E_TFmode:
          if (pattern138 (x3, 
E_TFmode) != 0
              || !(
#line 1950 "../../gcc/config/s390/vector.md"
(TARGET_VX && s390_fma_allowed_p (TFmode)) && 
#line 88 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1254; /* fmstf4 */

        case E_DFmode:
          if (pattern139 (x3, 
E_DFmode) != 0
              || !
#line 7615 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT && s390_fma_allowed_p (DFmode)))
            return -1;
          return 2333; /* fmsdf4 */

        case E_SFmode:
          if (pattern139 (x3, 
E_SFmode) != 0
              || !
#line 7615 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT && s390_fma_allowed_p (SFmode)))
            return -1;
          return 2334; /* fmssf4 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_83 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (pattern213 (x2) != 0)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) == E_CCL1mode)
    {
      x5 = XEXP (x3, 1);
      if (GET_MODE (x5) == E_CCL1mode)
        {
          x6 = XEXP (x5, 1);
          if (rtx_equal_p (x6, operands[1]))
            {
              x7 = XEXP (x5, 0);
              switch (GET_MODE (x7))
                {
                case E_DImode:
                  if (pattern277 (x1, 
E_DImode) == 0
                      && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                    return 2286; /* adddi3_alc_carry1_cc */
                  break;

                case E_SImode:
                  if (pattern277 (x1, 
E_SImode) == 0)
                    return 2287; /* addsi3_alc_carry1_cc */
                  break;

                default:
                  break;
                }
            }
        }
    }
  x5 = XEXP (x3, 1);
  x6 = XEXP (x5, 1);
  if (!rtx_equal_p (x6, operands[2]))
    return -1;
  x7 = XEXP (x5, 0);
  switch (GET_MODE (x7))
    {
    case E_DImode:
      if (pattern277 (x1, 
E_DImode) != 0
          || !(
#line 7060 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL1mode)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
        return -1;
      return 2290; /* *adddi3_alc_carry2_cc */

    case E_SImode:
      if (pattern277 (x1, 
E_SImode) != 0
          || !
#line 7060 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL1mode)))
        return -1;
      return 2291; /* *addsi3_alc_carry2_cc */

    default:
      return -1;
    }
}

 int
recog_91 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != NE)
    return -1;
  x5 = XEXP (x4, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 1);
  if (GET_CODE (x7) != PLUS)
    return -1;
  x8 = XEXP (x7, 1);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + -1])
    return -1;
  x9 = XEXP (x4, 0);
  operands[1] = x9;
  x10 = XEXP (x3, 1);
  x11 = XEXP (x10, 0);
  operands[0] = x11;
  x12 = XEXP (x6, 0);
  operands[2] = x12;
  x13 = XEXP (x7, 0);
  if (!rtx_equal_p (x13, operands[1]))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (!register_operand (operands[1], E_SImode)
          || !nonimmediate_operand (operands[2], E_SImode)
          || GET_MODE (x7) != E_SImode)
        return -1;
      *pnum_clobbers = 2;
      return 2544; /* doloop_si64 */

    case E_DImode:
      if (!register_operand (operands[1], E_DImode)
          || !nonimmediate_operand (operands[2], E_DImode)
          || GET_MODE (x7) != E_DImode
          || !
#line 10255 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
        return -1;
      *pnum_clobbers = 2;
      return 2545; /* doloop_di */

    default:
      return -1;
    }
}

 int
recog_95 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (SUBREG_BYTE (x4))
    {
    case 0:
      if (GET_MODE (x4) != E_DImode
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case ROTATE:
          x6 = XEXP (x5, 0);
          operands[1] = x6;
          x7 = XEXP (x5, 1);
          operands[2] = x7;
          x8 = XEXP (x3, 1);
          operands[3] = x8;
          if (!contiguous_bitmask_operand (operands[3], E_DImode))
            return -1;
          switch (GET_MODE (x5))
            {
            case E_SImode:
              if (!register_operand (operands[1], E_SImode)
                  || !const_int_operand (operands[2], E_SImode))
                return -1;
              if (
#line 4379 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && (UINTVAL (operands[3])
       < (HOST_WIDE_INT_1U << (UINTVAL (operands[2]) & 0x3f)))))
                return 1939; /* *risbg_and_subregdi_rotr */
              if (!
#line 4392 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && !(UINTVAL (operands[3])
	& ((HOST_WIDE_INT_1U << (UINTVAL (operands[2]) & 0x3f)) - 1))))
                return -1;
              return 1945; /* *risbg_and_subregdi_rotl */

            case E_HImode:
              if (!register_operand (operands[1], E_HImode)
                  || !const_int_operand (operands[2], E_HImode))
                return -1;
              if (
#line 4379 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && (UINTVAL (operands[3])
       < (HOST_WIDE_INT_1U << (UINTVAL (operands[2]) & 0x3f)))))
                return 1941; /* *risbg_and_subregdi_rotr */
              if (!
#line 4392 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && !(UINTVAL (operands[3])
	& ((HOST_WIDE_INT_1U << (UINTVAL (operands[2]) & 0x3f)) - 1))))
                return -1;
              return 1947; /* *risbg_and_subregdi_rotl */

            case E_QImode:
              if (!register_operand (operands[1], E_QImode)
                  || !const_int_operand (operands[2], E_QImode))
                return -1;
              if (
#line 4379 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && (UINTVAL (operands[3])
       < (HOST_WIDE_INT_1U << (UINTVAL (operands[2]) & 0x3f)))))
                return 1943; /* *risbg_and_subregdi_rotr */
              if (!
#line 4392 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && !(UINTVAL (operands[3])
	& ((HOST_WIDE_INT_1U << (UINTVAL (operands[2]) & 0x3f)) - 1))))
                return -1;
              return 1949; /* *risbg_and_subregdi_rotl */

            default:
              return -1;
            }

        case SUBREG:
        case MEM:
          operands[1] = x5;
          if (!memory_operand (operands[1], E_SImode))
            return -1;
          x8 = XEXP (x3, 1);
          if (GET_CODE (x8) != CONST_INT
              || XWINT (x8, 0) != 2147483647L
              || !
#line 5177 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return -1;
          return 2027; /* *llgt_sidi_split */

        default:
          return -1;
        }

    case 4:
      if (GET_MODE (x4) != E_SImode
          || !register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      x5 = XEXP (x4, 0);
      if (GET_MODE (x5) != E_DImode)
        return -1;
      x8 = XEXP (x3, 1);
      operands[3] = x8;
      if (!contiguous_bitmask_nowrap_operand (operands[3], E_SImode))
        return -1;
      switch (GET_CODE (x5))
        {
        case LSHIFTRT:
          x6 = XEXP (x5, 0);
          operands[1] = x6;
          if (!register_operand (operands[1], E_DImode))
            return -1;
          x7 = XEXP (x5, 1);
          operands[2] = x7;
          if (!nonzero_shift_count_operand (operands[2], E_DImode)
              || !
#line 4602 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12))
            return -1;
          return 1977; /* *trunc_sidi_and_subreg_lshrt_clobbercc */

        case ZERO_EXTRACT:
          x7 = XEXP (x5, 1);
          if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
            return -1;
          x6 = XEXP (x5, 0);
          operands[1] = x6;
          if (!register_operand (operands[1], E_DImode))
            return -1;
          x9 = XEXP (x5, 2);
          operands[2] = x9;
          if (!nonzero_shift_count_operand (operands[2], E_SImode)
              || !
#line 4616 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12))
            return -1;
          return 1979; /* *trunc_sidi_and_subreg_ze_clobbercc */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_103 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (XVECLEN (x3, 0))
    {
    case 2:
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x3, 0, 1);
      operands[2] = x5;
      switch (XINT (x3, 1))
        {
        case 69:
          switch (pattern143 (x1, 
68))
            {
            case 0:
              if (!
#line 312 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 24; /* *vec_packs_ccv8hi */

            case 1:
              if (!
#line 312 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 25; /* *vec_packs_ccv4si */

            case 2:
              if (!
#line 312 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 26; /* *vec_packs_ccv2di */

            default:
              return -1;
            }

        case 72:
          switch (pattern143 (x1, 
71))
            {
            case 0:
              if (!
#line 387 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 30; /* *vec_packsu_ccv8hi */

            case 1:
              if (!
#line 387 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 31; /* *vec_packsu_ccv4si */

            case 2:
              if (!
#line 387 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 32; /* *vec_packsu_ccv2di */

            default:
              return -1;
            }

        case 130:
          if (GET_MODE (x3) != E_CCRAWmode)
            return -1;
          x6 = XEXP (x2, 0);
          if (GET_CODE (x6) != REG
              || REGNO (x6) != 33
              || GET_MODE (x6) != E_CCRAWmode)
            return -1;
          x7 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x7) != CLOBBER
              || !const_int_operand (operands[2], E_HImode))
            return -1;
          x8 = XEXP (x7, 0);
          operands[0] = x8;
          switch (GET_MODE (operands[1]))
            {
            case E_V4SFmode:
              if (!register_operand (operands[1], E_V4SFmode)
                  || !scratch_operand (operands[0], E_V4SImode)
                  || !(
#line 1927 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && CONST_OK_FOR_CONSTRAINT_P (INTVAL (operands[2]), 'J', "J")) && 
#line 87 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 405; /* *vftciv4sf_cconly */

            case E_V2DFmode:
              if (!register_operand (operands[1], E_V2DFmode)
                  || !scratch_operand (operands[0], E_V2DImode)
                  || !
#line 1927 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && CONST_OK_FOR_CONSTRAINT_P (INTVAL (operands[2]), 'J', "J")))
                return -1;
              return 406; /* *vftciv2df_cconly */

            case E_V1TFmode:
              if (!register_operand (operands[1], E_V1TFmode)
                  || !scratch_operand (operands[0], E_V1TImode)
                  || !(
#line 1927 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && CONST_OK_FOR_CONSTRAINT_P (INTVAL (operands[2]), 'J', "J")) && 
#line 87 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 407; /* *vftciv1tf_cconly */

            case E_TFmode:
              if (!register_operand (operands[1], E_TFmode)
                  || !scratch_operand (operands[0], E_TImode)
                  || !(
#line 1927 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && CONST_OK_FOR_CONSTRAINT_P (INTVAL (operands[2]), 'J', "J")) && 
#line 88 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 408; /* *vftcitf_cconly */

            default:
              return -1;
            }

        case 129:
          x7 = XVECEXP (x1, 0, 1);
          if (pattern44 (x7, 
130, 
2, 
UNSPEC) != 0)
            return -1;
          x9 = XEXP (x7, 1);
          if (GET_MODE (x9) != E_CCRAWmode)
            return -1;
          x8 = XEXP (x7, 0);
          if (GET_CODE (x8) != REG
              || REGNO (x8) != 33
              || GET_MODE (x8) != E_CCRAWmode)
            return -1;
          x6 = XEXP (x2, 0);
          operands[0] = x6;
          if (!const_int_operand (operands[2], E_HImode))
            return -1;
          x10 = XVECEXP (x9, 0, 0);
          if (!rtx_equal_p (x10, operands[1]))
            return -1;
          x11 = XVECEXP (x9, 0, 1);
          if (!rtx_equal_p (x11, operands[2]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V4SFmode:
              if (!register_operand (operands[0], E_V4SFmode)
                  || GET_MODE (x3) != E_V4SFmode
                  || !register_operand (operands[1], E_V4SFmode)
                  || !(
#line 1953 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && CONST_OK_FOR_CONSTRAINT_P (INTVAL (operands[2]), 'J', "J")) && 
#line 87 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 409; /* vftciv4sf */

            case E_V2DFmode:
              if (!register_operand (operands[0], E_V2DFmode)
                  || GET_MODE (x3) != E_V2DFmode
                  || !register_operand (operands[1], E_V2DFmode)
                  || !
#line 1953 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && CONST_OK_FOR_CONSTRAINT_P (INTVAL (operands[2]), 'J', "J")))
                return -1;
              return 410; /* vftciv2df */

            case E_V1TFmode:
              if (!register_operand (operands[0], E_V1TFmode)
                  || GET_MODE (x3) != E_V1TFmode
                  || !register_operand (operands[1], E_V1TFmode)
                  || !(
#line 1953 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && CONST_OK_FOR_CONSTRAINT_P (INTVAL (operands[2]), 'J', "J")) && 
#line 87 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 411; /* vftciv1tf */

            case E_TFmode:
              if (!register_operand (operands[0], E_TFmode)
                  || GET_MODE (x3) != E_TFmode
                  || !register_operand (operands[1], E_TFmode)
                  || !(
#line 1953 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && CONST_OK_FOR_CONSTRAINT_P (INTVAL (operands[2]), 'J', "J")) && 
#line 88 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 412; /* vftcitf */

            default:
              return -1;
            }

        case 1:
          if (pattern38 (x1) != 0
              || !s_operand (operands[1], E_BLKmode)
              || !const_int_operand (operands[2], E_VOIDmode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (!register_operand (operands[0], E_SImode)
                  || GET_MODE (x3) != E_SImode)
                return -1;
              return 1923; /* *sethighpartsi */

            case E_DImode:
              if (!register_operand (operands[0], E_DImode)
                  || GET_MODE (x3) != E_DImode)
                return -1;
              if (
#line 4264 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                return 1924; /* *sethighpartdi_64 */
              if (!
#line 4274 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
                return -1;
              return 1925; /* *sethighpartdi_31 */

            default:
              return -1;
            }

        case 46:
          if (pattern102 (x1) != 0
              || !address_operand (operands[1], E_VOIDmode)
              || !immediate_operand (operands[2], E_SImode)
              || !
#line 12554 "../../gcc/config/s390/s390.md"
(TARGET_Z13))
            return -1;
          return 2666; /* lcbb */

        default:
          return -1;
        }

    case 3:
      if (pattern68 (x1, 
3) != 0
          || !const_mask_operand (operands[3], E_QImode))
        return -1;
      x7 = XVECEXP (x1, 0, 1);
      x9 = XEXP (x7, 1);
      x10 = XVECEXP (x9, 0, 0);
      if (!rtx_equal_p (x10, operands[1]))
        return -1;
      x11 = XVECEXP (x9, 0, 1);
      if (!rtx_equal_p (x11, operands[2]))
        return -1;
      x12 = XVECEXP (x9, 0, 2);
      if (!rtx_equal_p (x12, operands[3]))
        return -1;
      switch (XINT (x3, 1))
        {
        case 110:
          switch (pattern281 (x1, 
111))
            {
            case 0:
              if (!
#line 1311 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 362; /* *vfaesv16qi */

            case 1:
              if (!
#line 1311 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 363; /* *vfaesv8hi */

            case 2:
              if (!
#line 1311 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 364; /* *vfaesv4si */

            default:
              return -1;
            }

        case 112:
          switch (pattern281 (x1, 
113))
            {
            case 0:
              if (!
#line 2474 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 1413; /* vec_vfeesv16qi */

            case 1:
              if (!
#line 2474 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 1414; /* vec_vfeesv8hi */

            case 2:
              if (!
#line 2474 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 1415; /* vec_vfeesv4si */

            default:
              return -1;
            }

        case 114:
          switch (pattern281 (x1, 
115))
            {
            case 0:
              if (!
#line 2500 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 1416; /* vec_vfenesv16qi */

            case 1:
              if (!
#line 2500 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 1417; /* vec_vfenesv8hi */

            case 2:
              if (!
#line 2500 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 1418; /* vec_vfenesv4si */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 1:
      x6 = XEXP (x2, 0);
      operands[0] = x6;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      switch (XINT (x3, 1))
        {
        case 116:
          x7 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x7) != SET)
            return -1;
          x9 = XEXP (x7, 1);
          if (pattern152 (x9, 
E_CCRAWmode, 
117, 
UNSPEC, 
1) != 0)
            return -1;
          x8 = XEXP (x7, 0);
          if (GET_CODE (x8) != REG
              || REGNO (x8) != 33
              || GET_MODE (x8) != E_CCRAWmode)
            return -1;
          x10 = XVECEXP (x9, 0, 0);
          if (!rtx_equal_p (x10, operands[1]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V16QImode:
              if (!register_operand (operands[0], E_V16QImode)
                  || GET_MODE (x3) != E_V16QImode
                  || !register_operand (operands[1], E_V16QImode)
                  || !
#line 1513 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 380; /* *vistrsv16qi */

            case E_V8HImode:
              if (!register_operand (operands[0], E_V8HImode)
                  || GET_MODE (x3) != E_V8HImode
                  || !register_operand (operands[1], E_V8HImode)
                  || !
#line 1513 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 381; /* *vistrsv8hi */

            case E_V4SImode:
              if (!register_operand (operands[0], E_V4SImode)
                  || GET_MODE (x3) != E_V4SImode
                  || !register_operand (operands[1], E_V4SImode)
                  || !
#line 1513 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 382; /* *vistrsv4si */

            default:
              return -1;
            }

        case 4:
          if (GET_MODE (x3) != E_SImode)
            return -1;
          x7 = XVECEXP (x1, 0, 1);
          if (pattern89 (x7) != 0
              || !register_operand (operands[0], E_SImode)
              || !register_operand (operands[1], E_CCUmode))
            return -1;
          return 1919; /* cmpint */

        case 37:
          x7 = XVECEXP (x1, 0, 1);
          if (pattern89 (x7) != 0)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (!register_operand (operands[0], E_DImode)
                  || GET_MODE (x3) != E_DImode
                  || !register_operand (operands[1], E_DImode)
                  || !(
#line 12120 "../../gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 795 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              return 2643; /* *popcountdi_z196 */

            case E_SImode:
              if (!register_operand (operands[0], E_SImode)
                  || GET_MODE (x3) != E_SImode
                  || !register_operand (operands[1], E_SImode)
                  || !
#line 12120 "../../gcc/config/s390/s390.md"
(TARGET_Z196))
                return -1;
              return 2644; /* *popcountsi_z196 */

            case E_HImode:
              if (!register_operand (operands[0], E_HImode)
                  || GET_MODE (x3) != E_HImode
                  || !register_operand (operands[1], E_HImode)
                  || !
#line 12120 "../../gcc/config/s390/s390.md"
(TARGET_Z196))
                return -1;
              return 2645; /* *popcounthi_z196 */

            case E_QImode:
              if (!register_operand (operands[0], E_QImode)
                  || GET_MODE (x3) != E_QImode
                  || !register_operand (operands[1], E_QImode)
                  || !
#line 12120 "../../gcc/config/s390/s390.md"
(TARGET_Z196))
                return -1;
              return 2646; /* *popcountqi_z196 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 4:
      if (pattern68 (x1, 
4) != 0)
        return -1;
      x13 = XVECEXP (x3, 0, 3);
      operands[4] = x13;
      if (!const_mask_operand (operands[4], E_QImode))
        return -1;
      x7 = XVECEXP (x1, 0, 1);
      x9 = XEXP (x7, 1);
      x10 = XVECEXP (x9, 0, 0);
      if (!rtx_equal_p (x10, operands[1]))
        return -1;
      x11 = XVECEXP (x9, 0, 1);
      if (!rtx_equal_p (x11, operands[2]))
        return -1;
      x12 = XVECEXP (x9, 0, 2);
      if (!rtx_equal_p (x12, operands[3]))
        return -1;
      x14 = XVECEXP (x9, 0, 3);
      if (!rtx_equal_p (x14, operands[4]))
        return -1;
      switch (XINT (x3, 1))
        {
        case 118:
          if (XINT (x9, 1) != 119)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V16QImode:
              if (pattern295 (x3, 
E_V16QImode) != 0
                  || !
#line 1570 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 386; /* *vstrcsv16qi */

            case E_V8HImode:
              if (pattern295 (x3, 
E_V8HImode) != 0
                  || !
#line 1570 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 387; /* *vstrcsv8hi */

            case E_V4SImode:
              if (pattern295 (x3, 
E_V4SImode) != 0
                  || !
#line 1570 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 388; /* *vstrcsv4si */

            default:
              return -1;
            }

        case 120:
          if (GET_MODE (x3) != E_V16QImode
              || XINT (x9, 1) != 121
              || !register_operand (operands[0], E_V16QImode)
              || !register_operand (operands[3], E_V16QImode))
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V16QImode:
              if (!register_operand (operands[1], E_V16QImode)
                  || !register_operand (operands[2], E_V16QImode)
                  || !
#line 1691 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
                return -1;
              return 389; /* vec_vstrsv16qi */

            case E_V8HImode:
              if (!register_operand (operands[1], E_V8HImode)
                  || !register_operand (operands[2], E_V8HImode)
                  || !
#line 1691 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
                return -1;
              return 390; /* vec_vstrsv8hi */

            case E_V4SImode:
              if (!register_operand (operands[1], E_V4SImode)
                  || !register_operand (operands[2], E_V4SImode)
                  || !
#line 1691 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
                return -1;
              return 391; /* vec_vstrsv4si */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_1 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (register_operand (operands[0], E_V16QImode)
          && register_operand (operands[1], E_V16QImode)
          && 
#line 293 "../../gcc/config/s390/vector.md"
(TARGET_VX && GENERAL_REG_P (operands[0]) && VECTOR_REG_P (operands[1])))
        return gen_split_1 (insn, operands);
      if (nonimmediate_operand (operands[0], E_V16QImode)
          && general_operand (operands[1], E_V16QImode))
        {
          if (
#line 313 "../../gcc/config/s390/vector.md"
(reload_completed
   && s390_split_ok_p (operands[0], operands[1], V16QImode, 0)))
            return gen_split_10 (insn, operands);
          if (
#line 327 "../../gcc/config/s390/vector.md"
(reload_completed
   && s390_split_ok_p (operands[0], operands[1], V16QImode, 1)))
            return gen_split_19 (insn, operands);
        }
      if (!register_operand (operands[0], E_V16QImode)
          || !memory_operand (operands[1], E_V16QImode)
          || !
#line 347 "../../gcc/config/s390/vector.md"
(TARGET_ZARCH && reload_completed
   && !VECTOR_REG_P (operands[0])
   && !s_operand (operands[1], VOIDmode)))
        return NULL;
      return gen_split_28 (insn, operands);

    case E_V8HImode:
      if (register_operand (operands[0], E_V8HImode)
          && register_operand (operands[1], E_V8HImode)
          && 
#line 293 "../../gcc/config/s390/vector.md"
(TARGET_VX && GENERAL_REG_P (operands[0]) && VECTOR_REG_P (operands[1])))
        return gen_split_2 (insn, operands);
      if (nonimmediate_operand (operands[0], E_V8HImode)
          && general_operand (operands[1], E_V8HImode))
        {
          if (
#line 313 "../../gcc/config/s390/vector.md"
(reload_completed
   && s390_split_ok_p (operands[0], operands[1], V8HImode, 0)))
            return gen_split_11 (insn, operands);
          if (
#line 327 "../../gcc/config/s390/vector.md"
(reload_completed
   && s390_split_ok_p (operands[0], operands[1], V8HImode, 1)))
            return gen_split_20 (insn, operands);
        }
      if (!register_operand (operands[0], E_V8HImode)
          || !memory_operand (operands[1], E_V8HImode)
          || !
#line 347 "../../gcc/config/s390/vector.md"
(TARGET_ZARCH && reload_completed
   && !VECTOR_REG_P (operands[0])
   && !s_operand (operands[1], VOIDmode)))
        return NULL;
      return gen_split_29 (insn, operands);

    case E_V4SImode:
      if (register_operand (operands[0], E_V4SImode)
          && register_operand (operands[1], E_V4SImode)
          && 
#line 293 "../../gcc/config/s390/vector.md"
(TARGET_VX && GENERAL_REG_P (operands[0]) && VECTOR_REG_P (operands[1])))
        return gen_split_3 (insn, operands);
      if (nonimmediate_operand (operands[0], E_V4SImode)
          && general_operand (operands[1], E_V4SImode))
        {
          if (
#line 313 "../../gcc/config/s390/vector.md"
(reload_completed
   && s390_split_ok_p (operands[0], operands[1], V4SImode, 0)))
            return gen_split_12 (insn, operands);
          if (
#line 327 "../../gcc/config/s390/vector.md"
(reload_completed
   && s390_split_ok_p (operands[0], operands[1], V4SImode, 1)))
            return gen_split_21 (insn, operands);
        }
      if (!register_operand (operands[0], E_V4SImode)
          || !memory_operand (operands[1], E_V4SImode)
          || !
#line 347 "../../gcc/config/s390/vector.md"
(TARGET_ZARCH && reload_completed
   && !VECTOR_REG_P (operands[0])
   && !s_operand (operands[1], VOIDmode)))
        return NULL;
      return gen_split_30 (insn, operands);

    case E_V4SFmode:
      if (register_operand (operands[0], E_V4SFmode)
          && register_operand (operands[1], E_V4SFmode)
          && 
#line 293 "../../gcc/config/s390/vector.md"
(TARGET_VX && GENERAL_REG_P (operands[0]) && VECTOR_REG_P (operands[1])))
        return gen_split_4 (insn, operands);
      if (nonimmediate_operand (operands[0], E_V4SFmode)
          && general_operand (operands[1], E_V4SFmode))
        {
          if (
#line 313 "../../gcc/config/s390/vector.md"
(reload_completed
   && s390_split_ok_p (operands[0], operands[1], V4SFmode, 0)))
            return gen_split_13 (insn, operands);
          if (
#line 327 "../../gcc/config/s390/vector.md"
(reload_completed
   && s390_split_ok_p (operands[0], operands[1], V4SFmode, 1)))
            return gen_split_22 (insn, operands);
        }
      if (!register_operand (operands[0], E_V4SFmode)
          || !memory_operand (operands[1], E_V4SFmode)
          || !
#line 347 "../../gcc/config/s390/vector.md"
(TARGET_ZARCH && reload_completed
   && !VECTOR_REG_P (operands[0])
   && !s_operand (operands[1], VOIDmode)))
        return NULL;
      return gen_split_31 (insn, operands);

    case E_V2DImode:
      if (register_operand (operands[0], E_V2DImode)
          && register_operand (operands[1], E_V2DImode)
          && 
#line 293 "../../gcc/config/s390/vector.md"
(TARGET_VX && GENERAL_REG_P (operands[0]) && VECTOR_REG_P (operands[1])))
        return gen_split_5 (insn, operands);
      if (nonimmediate_operand (operands[0], E_V2DImode)
          && general_operand (operands[1], E_V2DImode))
        {
          if (
#line 313 "../../gcc/config/s390/vector.md"
(reload_completed
   && s390_split_ok_p (operands[0], operands[1], V2DImode, 0)))
            return gen_split_14 (insn, operands);
          if (
#line 327 "../../gcc/config/s390/vector.md"
(reload_completed
   && s390_split_ok_p (operands[0], operands[1], V2DImode, 1)))
            return gen_split_23 (insn, operands);
        }
      if (!register_operand (operands[0], E_V2DImode)
          || !memory_operand (operands[1], E_V2DImode)
          || !
#line 347 "../../gcc/config/s390/vector.md"
(TARGET_ZARCH && reload_completed
   && !VECTOR_REG_P (operands[0])
   && !s_operand (operands[1], VOIDmode)))
        return NULL;
      return gen_split_32 (insn, operands);

    case E_V2DFmode:
      if (register_operand (operands[0], E_V2DFmode)
          && register_operand (operands[1], E_V2DFmode)
          && 
#line 293 "../../gcc/config/s390/vector.md"
(TARGET_VX && GENERAL_REG_P (operands[0]) && VECTOR_REG_P (operands[1])))
        return gen_split_6 (insn, operands);
      if (nonimmediate_operand (operands[0], E_V2DFmode)
          && general_operand (operands[1], E_V2DFmode))
        {
          if (
#line 313 "../../gcc/config/s390/vector.md"
(reload_completed
   && s390_split_ok_p (operands[0], operands[1], V2DFmode, 0)))
            return gen_split_15 (insn, operands);
          if (
#line 327 "../../gcc/config/s390/vector.md"
(reload_completed
   && s390_split_ok_p (operands[0], operands[1], V2DFmode, 1)))
            return gen_split_24 (insn, operands);
        }
      if (!register_operand (operands[0], E_V2DFmode)
          || !memory_operand (operands[1], E_V2DFmode)
          || !
#line 347 "../../gcc/config/s390/vector.md"
(TARGET_ZARCH && reload_completed
   && !VECTOR_REG_P (operands[0])
   && !s_operand (operands[1], VOIDmode)))
        return NULL;
      return gen_split_33 (insn, operands);

    case E_V1TImode:
      if (register_operand (operands[0], E_V1TImode)
          && register_operand (operands[1], E_V1TImode)
          && 
#line 293 "../../gcc/config/s390/vector.md"
(TARGET_VX && GENERAL_REG_P (operands[0]) && VECTOR_REG_P (operands[1])))
        return gen_split_7 (insn, operands);
      if (nonimmediate_operand (operands[0], E_V1TImode)
          && general_operand (operands[1], E_V1TImode))
        {
          if (
#line 313 "../../gcc/config/s390/vector.md"
(reload_completed
   && s390_split_ok_p (operands[0], operands[1], V1TImode, 0)))
            return gen_split_16 (insn, operands);
          if (
#line 327 "../../gcc/config/s390/vector.md"
(reload_completed
   && s390_split_ok_p (operands[0], operands[1], V1TImode, 1)))
            return gen_split_25 (insn, operands);
        }
      if (!register_operand (operands[0], E_V1TImode)
          || !memory_operand (operands[1], E_V1TImode)
          || !
#line 347 "../../gcc/config/s390/vector.md"
(TARGET_ZARCH && reload_completed
   && !VECTOR_REG_P (operands[0])
   && !s_operand (operands[1], VOIDmode)))
        return NULL;
      return gen_split_34 (insn, operands);

    case E_V1TFmode:
      if (register_operand (operands[0], E_V1TFmode)
          && register_operand (operands[1], E_V1TFmode)
          && 
#line 293 "../../gcc/config/s390/vector.md"
(TARGET_VX && GENERAL_REG_P (operands[0]) && VECTOR_REG_P (operands[1])))
        return gen_split_8 (insn, operands);
      if (nonimmediate_operand (operands[0], E_V1TFmode)
          && general_operand (operands[1], E_V1TFmode))
        {
          if (
#line 313 "../../gcc/config/s390/vector.md"
(reload_completed
   && s390_split_ok_p (operands[0], operands[1], V1TFmode, 0)))
            return gen_split_17 (insn, operands);
          if (
#line 327 "../../gcc/config/s390/vector.md"
(reload_completed
   && s390_split_ok_p (operands[0], operands[1], V1TFmode, 1)))
            return gen_split_26 (insn, operands);
        }
      if (!register_operand (operands[0], E_V1TFmode)
          || !memory_operand (operands[1], E_V1TFmode)
          || !
#line 347 "../../gcc/config/s390/vector.md"
(TARGET_ZARCH && reload_completed
   && !VECTOR_REG_P (operands[0])
   && !s_operand (operands[1], VOIDmode)))
        return NULL;
      return gen_split_35 (insn, operands);

    case E_TFmode:
      if (register_operand (operands[0], E_TFmode)
          && register_operand (operands[1], E_TFmode)
          && (
#line 293 "../../gcc/config/s390/vector.md"
(TARGET_VX && GENERAL_REG_P (operands[0]) && VECTOR_REG_P (operands[1])) && 
#line 95 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return gen_split_9 (insn, operands);
      if (nonimmediate_operand (operands[0], E_TFmode)
          && general_operand (operands[1], E_TFmode))
        {
          if ((
#line 313 "../../gcc/config/s390/vector.md"
(reload_completed
   && s390_split_ok_p (operands[0], operands[1], TFmode, 0)) && 
#line 95 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return gen_split_18 (insn, operands);
          if ((
#line 327 "../../gcc/config/s390/vector.md"
(reload_completed
   && s390_split_ok_p (operands[0], operands[1], TFmode, 1)) && 
#line 95 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return gen_split_27 (insn, operands);
        }
      if (!register_operand (operands[0], E_TFmode)
          || !memory_operand (operands[1], E_TFmode)
          || !(
#line 347 "../../gcc/config/s390/vector.md"
(TARGET_ZARCH && reload_completed
   && !VECTOR_REG_P (operands[0])
   && !s_operand (operands[1], VOIDmode)) && 
#line 95 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return NULL;
      return gen_split_36 (insn, operands);

    case E_TImode:
      if (nonimmediate_operand (operands[0], E_TImode)
          && general_operand (operands[1], E_TImode))
        {
          if (
#line 1796 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && reload_completed
   && s390_split_ok_p (operands[0], operands[1], TImode, 0)))
            return gen_split_286 (insn, operands);
          if (
#line 1810 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && reload_completed
   && s390_split_ok_p (operands[0], operands[1], TImode, 1)))
            return gen_split_287 (insn, operands);
        }
      if (!register_operand (operands[0], E_TImode))
        return NULL;
      if (memory_operand (operands[1], E_TImode)
          && 
#line 1827 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && reload_completed
   && !VECTOR_REG_P (operands[0])
   && !s_operand (operands[1], VOIDmode)))
        return gen_split_288 (insn, operands);
      if (!register_operand (operands[1], E_TImode)
          || !
#line 1845 "../../gcc/config/s390/s390.md"
(TARGET_VX && reload_completed
   && GENERAL_REG_P (operands[0])
   && VECTOR_REG_P (operands[1])))
        return NULL;
      return gen_split_289 (insn, operands);

    case E_DImode:
      if (register_operand (operands[0], E_DImode))
        {
          if (register_operand (operands[1], E_DImode))
            {
              if (
#line 2192 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && ACCESS_REG_P (operands[0]) && reload_completed
   && dead_or_set_p (insn, operands[1])))
                return gen_split_292 (insn, operands);
              if (
#line 2203 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && ACCESS_REG_P (operands[0]) && reload_completed
   && !dead_or_set_p (insn, operands[1])))
                return gen_split_293 (insn, operands);
            }
          if (memory_operand (operands[1], E_DImode)
              && 
#line 2241 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH && reload_completed && TARGET_Z10
   && larl_operand (XEXP (operands[1], 0), SImode)))
            return gen_split_294 (insn, operands);
        }
      if (nonimmediate_operand (operands[0], E_DImode)
          && general_operand (operands[1], E_DImode))
        {
          if (
#line 2254 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH && reload_completed
   && !s_operand (operands[0], DImode)
   && !s_operand (operands[1], DImode)
   && s390_split_ok_p (operands[0], operands[1], DImode, 0)))
            return gen_split_295 (insn, operands);
          if (
#line 2270 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH && reload_completed
   && !s_operand (operands[0], DImode)
   && !s_operand (operands[1], DImode)
   && s390_split_ok_p (operands[0], operands[1], DImode, 1)))
            return gen_split_296 (insn, operands);
        }
      if (!register_operand (operands[0], E_DImode)
          || !memory_operand (operands[1], E_DImode)
          || !
#line 2286 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH && reload_completed
   && !FP_REG_P (operands[0])
   && !s_operand (operands[1], VOIDmode)))
        return NULL;
      return gen_split_297 (insn, operands);

    case E_FPRX2mode:
      if (nonimmediate_operand (operands[0], E_FPRX2mode)
          && general_operand (operands[1], E_FPRX2mode))
        {
          if ((
#line 2829 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && reload_completed
   && !s_operand (operands[0], FPRX2mode)
   && !s_operand (operands[1], FPRX2mode)
   && s390_split_ok_p (operands[0], operands[1], FPRX2mode, 0)) && 
#line 764 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return gen_split_300 (insn, operands);
          if ((
#line 2845 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && reload_completed
   && !s_operand (operands[0], FPRX2mode)
   && !s_operand (operands[1], FPRX2mode)
   && s390_split_ok_p (operands[0], operands[1], FPRX2mode, 1)) && 
#line 764 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return gen_split_303 (insn, operands);
        }
      if (register_operand (operands[0], E_FPRX2mode)
          && memory_operand (operands[1], E_FPRX2mode))
        {
          if ((
#line 2861 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && reload_completed
   && GENERAL_REG_P (operands[0])
   && !s_operand (operands[1], VOIDmode)) && 
#line 764 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return gen_split_306 (insn, operands);
          if ((
#line 2877 "../../gcc/config/s390/s390.md"
(reload_completed && offsettable_memref_p (operands[1])
   && FP_REG_P (operands[0])) && 
#line 764 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return gen_split_309 (insn, operands);
        }
      if (!memory_operand (operands[0], E_FPRX2mode)
          || !register_operand (operands[1], E_FPRX2mode)
          || !(
#line 2893 "../../gcc/config/s390/s390.md"
(reload_completed && offsettable_memref_p (operands[0])
   && FP_REG_P (operands[1])) && 
#line 764 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
        return NULL;
      return gen_split_312 (insn, operands);

    case E_TDmode:
      if (nonimmediate_operand (operands[0], E_TDmode)
          && general_operand (operands[1], E_TDmode))
        {
          if (
#line 2829 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && reload_completed
   && !s_operand (operands[0], TDmode)
   && !s_operand (operands[1], TDmode)
   && s390_split_ok_p (operands[0], operands[1], TDmode, 0)))
            return gen_split_301 (insn, operands);
          if (
#line 2845 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && reload_completed
   && !s_operand (operands[0], TDmode)
   && !s_operand (operands[1], TDmode)
   && s390_split_ok_p (operands[0], operands[1], TDmode, 1)))
            return gen_split_304 (insn, operands);
        }
      if (register_operand (operands[0], E_TDmode)
          && memory_operand (operands[1], E_TDmode))
        {
          if (
#line 2861 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && reload_completed
   && GENERAL_REG_P (operands[0])
   && !s_operand (operands[1], VOIDmode)))
            return gen_split_307 (insn, operands);
          if (
#line 2877 "../../gcc/config/s390/s390.md"
(reload_completed && offsettable_memref_p (operands[1])
   && FP_REG_P (operands[0])))
            return gen_split_310 (insn, operands);
        }
      if (!memory_operand (operands[0], E_TDmode)
          || !register_operand (operands[1], E_TDmode)
          || !
#line 2893 "../../gcc/config/s390/s390.md"
(reload_completed && offsettable_memref_p (operands[0])
   && FP_REG_P (operands[1])))
        return NULL;
      return gen_split_313 (insn, operands);

    case E_DFmode:
      if (nonimmediate_operand (operands[0], E_DFmode)
          && general_operand (operands[1], E_DFmode))
        {
          if (
#line 3001 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH && reload_completed
   && !s_operand (operands[0], DFmode)
   && !s_operand (operands[1], DFmode)
   && s390_split_ok_p (operands[0], operands[1], DFmode, 0)))
            return gen_split_314 (insn, operands);
          if (
#line 3017 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH && reload_completed
   && !s_operand (operands[0], DFmode)
   && !s_operand (operands[1], DFmode)
   && s390_split_ok_p (operands[0], operands[1], DFmode, 1)))
            return gen_split_316 (insn, operands);
        }
      if (!register_operand (operands[0], E_DFmode)
          || !memory_operand (operands[1], E_DFmode)
          || !
#line 3033 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH && reload_completed
   && !FP_REG_P (operands[0])
   && !s_operand (operands[1], VOIDmode)))
        return NULL;
      return gen_split_318 (insn, operands);

    case E_DDmode:
      if (nonimmediate_operand (operands[0], E_DDmode)
          && general_operand (operands[1], E_DDmode))
        {
          if (
#line 3001 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH && reload_completed
   && !s_operand (operands[0], DDmode)
   && !s_operand (operands[1], DDmode)
   && s390_split_ok_p (operands[0], operands[1], DDmode, 0)))
            return gen_split_315 (insn, operands);
          if (
#line 3017 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH && reload_completed
   && !s_operand (operands[0], DDmode)
   && !s_operand (operands[1], DDmode)
   && s390_split_ok_p (operands[0], operands[1], DDmode, 1)))
            return gen_split_317 (insn, operands);
        }
      if (!register_operand (operands[0], E_DDmode)
          || !memory_operand (operands[1], E_DDmode)
          || !
#line 3033 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH && reload_completed
   && !FP_REG_P (operands[0])
   && !s_operand (operands[1], VOIDmode)))
        return NULL;
      return gen_split_319 (insn, operands);

    case E_QImode:
      if (!memory_operand (operands[0], E_QImode)
          || !memory_operand (operands[1], E_QImode)
          || !
#line 3123 "../../gcc/config/s390/s390.md"
(reload_completed))
        return NULL;
      return gen_split_320 (insn, operands);

    default:
      return NULL;
    }
}
