/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern6 (rtx x1, unsigned int i1, machine_mode i2, unsigned int i3, unsigned int i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != UNSPEC_VOLATILE
      || XVECLEN (x3, 0) != 1
      || XINT (x3, 1) != 16
      || GET_MODE (x3) != E_CCRAWmode)
    return -1;
  x4 = XEXP (x2, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 33
      || GET_MODE (x4) != E_CCRAWmode)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != SET)
    return -1;
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != UNSPEC_VOLATILE
      || XVECLEN (x6, 0) != 1
      || XINT (x6, 1) != 17
      || GET_MODE (x6) != E_BLKmode)
    return -1;
  x7 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x7) != CLOBBER)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != REG
      || REGNO (x8) != 16
      || GET_MODE (x8) != i2)
    return -1;
  x9 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x9) != CLOBBER)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_CODE (x10) != REG
      || REGNO (x10) != i4
      || GET_MODE (x10) != i2)
    return -1;
  x11 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x11) != CLOBBER)
    return -1;
  x12 = XEXP (x11, 0);
  if (GET_CODE (x12) != REG
      || REGNO (x12) != i3
      || GET_MODE (x12) != i2)
    return -1;
  x13 = XVECEXP (x1, 0, 5);
  if (GET_CODE (x13) != CLOBBER)
    return -1;
  x14 = XEXP (x13, 0);
  if (GET_CODE (x14) != REG
      || REGNO (x14) != i1)
    return -1;
  return 0;
}

int
pattern20 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern19 (x3, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern19 (x3, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern19 (x3, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V2DImode:
      if (pattern19 (x3, 
E_V2DImode) != 0)
        return -1;
      return 3;

    case E_V1TImode:
      if (pattern19 (x3, 
E_V1TImode) != 0)
        return -1;
      return 4;

    case E_TImode:
      if (pattern19 (x3, 
E_TImode) != 0)
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern28 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V1HImode:
      if (!register_operand (operands[0], E_V1HImode)
          || GET_MODE (x3) != E_V1HImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V1QImode:
          if (!register_operand (operands[1], E_V1QImode)
              || !register_operand (operands[2], E_V1QImode))
            return -1;
          return 0;

        case E_V2QImode:
          if (!register_operand (operands[1], E_V2QImode)
              || !register_operand (operands[2], E_V2QImode))
            return -1;
          return 1;

        default:
          return -1;
        }

    case E_V2HImode:
      if (pattern16 (x3, 
E_V4QImode, 
E_V2HImode) != 0)
        return -1;
      return 2;

    case E_V4HImode:
      if (pattern16 (x3, 
E_V8QImode, 
E_V4HImode) != 0)
        return -1;
      return 3;

    case E_V8HImode:
      if (pattern16 (x3, 
E_V16QImode, 
E_V8HImode) != 0)
        return -1;
      return 4;

    case E_V1SImode:
      if (!register_operand (operands[0], E_V1SImode)
          || GET_MODE (x3) != E_V1SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V1HImode:
          if (!register_operand (operands[1], E_V1HImode)
              || !register_operand (operands[2], E_V1HImode))
            return -1;
          return 5;

        case E_V2HImode:
          if (!register_operand (operands[1], E_V2HImode)
              || !register_operand (operands[2], E_V2HImode))
            return -1;
          return 6;

        default:
          return -1;
        }

    case E_V2SImode:
      if (pattern16 (x3, 
E_V4HImode, 
E_V2SImode) != 0)
        return -1;
      return 7;

    case E_V4SImode:
      if (pattern16 (x3, 
E_V8HImode, 
E_V4SImode) != 0)
        return -1;
      return 8;

    case E_V1DImode:
      if (!register_operand (operands[0], E_V1DImode)
          || GET_MODE (x3) != E_V1DImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V1SImode:
          if (!register_operand (operands[1], E_V1SImode)
              || !register_operand (operands[2], E_V1SImode))
            return -1;
          return 9;

        case E_V2SImode:
          if (!register_operand (operands[1], E_V2SImode)
              || !register_operand (operands[2], E_V2SImode))
            return -1;
          return 10;

        default:
          return -1;
        }

    case E_V2DImode:
      if (pattern16 (x3, 
E_V4SImode, 
E_V2DImode) != 0)
        return -1;
      return 11;

    case E_V1TImode:
      if (pattern16 (x3, 
E_V1DImode, 
E_V1TImode) != 0)
        return -1;
      return 12;

    case E_TImode:
      if (pattern16 (x3, 
E_V2DImode, 
E_TImode) != 0)
        return -1;
      return 13;

    default:
      return -1;
    }
}

int
pattern55 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  x3 = XVECEXP (x1, 0, 1);
  operands[2] = x3;
  x4 = XVECEXP (x1, 0, 2);
  operands[3] = x4;
  if (!const_int_operand (operands[3], E_QImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern19 (x1, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern19 (x1, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern19 (x1, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V2DImode:
      if (pattern19 (x1, 
E_V2DImode) != 0)
        return -1;
      return 3;

    case E_V1TImode:
      if (pattern19 (x1, 
E_V1TImode) != 0)
        return -1;
      return 4;

    case E_TImode:
      if (pattern19 (x1, 
E_TImode) != 0)
        return -1;
      return 5;

    case E_V2DFmode:
      if (pattern19 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 6;

    case E_V4SFmode:
      if (pattern19 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 7;

    case E_V1TFmode:
      if (pattern19 (x1, 
E_V1TFmode) != 0)
        return -1;
      return 8;

    case E_TFmode:
      if (pattern19 (x1, 
E_TFmode) != 0)
        return -1;
      return 9;

    default:
      return -1;
    }
}

int
pattern73 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_CCUmode)
    return -1;
  x4 = XEXP (x2, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 33
      || GET_MODE (x4) != E_CCUmode)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != USE)
    return -1;
  x6 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x6) != USE)
    return -1;
  x7 = XEXP (x3, 0);
  operands[0] = x7;
  if (!memory_operand (operands[0], E_BLKmode))
    return -1;
  x8 = XEXP (x3, 1);
  operands[1] = x8;
  if (!memory_operand (operands[1], E_BLKmode))
    return -1;
  return 0;
}

int
pattern82 (rtx x1, int *pnum_clobbers, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!register_operand (operands[1], i1))
    return -1;
  x4 = XEXP (x1, 1);
  operands[2] = x4;
  if (!register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern88 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      return 0;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_HImode:
          return 1;

        case E_QImode:
          return 2;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern97 (rtx x1, machine_mode i1, unsigned int i2, rtx_code i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != i2
      || GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern102 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 33
      || GET_MODE (x5) != E_CCmode)
    return -1;
  x6 = XEXP (x2, 0);
  operands[0] = x6;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  return 0;
}

int
pattern112 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != PLUS
      || GET_MODE (x3) != E_SImode
      || !register_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode)
    return -1;
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  if (!const_int_operand (operands[2], E_SImode))
    return -1;
  x6 = XEXP (x1, 1);
  operands[3] = x6;
  if (!register_operand (operands[3], E_DImode))
    return -1;
  return 0;
}

int
pattern123 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[2], i1)
      || !register_operand (operands[1], i1)
      || !register_operand (operands[3], i1)
      || !register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern126 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_BLKmode)
    return -1;
  switch (GET_CODE (x3))
    {
    case MEM:
      x4 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x4) != SET)
        return -1;
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) != UNSPEC
          || XVECLEN (x5, 0) != 3
          || XINT (x5, 1) != 32)
        return -1;
      x6 = XVECEXP (x5, 0, 0);
      if (GET_CODE (x6) != MEM
          || GET_MODE (x6) != E_BLKmode)
        return -1;
      x7 = XVECEXP (x5, 0, 1);
      if (GET_CODE (x7) != MEM
          || GET_MODE (x7) != E_BLKmode)
        return -1;
      x8 = XVECEXP (x5, 0, 2);
      if (GET_CODE (x8) != REG
          || REGNO (x8) != 0
          || GET_MODE (x8) != E_SImode)
        return -1;
      x9 = XVECEXP (x1, 0, 0);
      x10 = XEXP (x9, 0);
      operands[2] = x10;
      x11 = XEXP (x2, 0);
      x12 = XEXP (x11, 0);
      operands[1] = x12;
      x13 = XEXP (x3, 0);
      operands[3] = x13;
      x14 = XEXP (x4, 0);
      operands[0] = x14;
      x15 = XEXP (x6, 0);
      if (!rtx_equal_p (x15, operands[1]))
        return -1;
      x16 = XEXP (x7, 0);
      if (!rtx_equal_p (x16, operands[3]))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_DImode:
          return pattern123 (x5, 
E_DImode); /* [-1, 0] */

        case E_SImode:
          if (pattern123 (x5, 
E_SImode) != 0)
            return -1;
          return 1;

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x3, 0) != 2
          || XINT (x3, 1) != 6)
        return -1;
      x17 = XVECEXP (x3, 0, 1);
      if (GET_CODE (x17) != SUBREG)
        return -1;
      x11 = XEXP (x2, 0);
      x12 = XEXP (x11, 0);
      if (GET_CODE (x12) != SUBREG)
        return -1;
      x4 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x4) != USE)
        return -1;
      x9 = XVECEXP (x1, 0, 0);
      x10 = XEXP (x9, 0);
      operands[0] = x10;
      x18 = XEXP (x12, 0);
      operands[3] = x18;
      x14 = XEXP (x4, 0);
      operands[1] = x14;
      x19 = XEXP (x17, 0);
      if (!rtx_equal_p (x19, operands[3]))
        return -1;
      x20 = XVECEXP (x3, 0, 0);
      switch (GET_CODE (x20))
        {
        case CONST_INT:
        case REG:
        case SUBREG:
        case PLUS:
          operands[2] = x20;
          switch (SUBREG_BYTE (x17))
            {
            case 8:
              if (pattern124 (x2, 
E_TImode, 
0, 
E_DImode) != 0)
                return -1;
              return 2;

            case 4:
              if (pattern124 (x2, 
E_DImode, 
0, 
E_SImode) != 0)
                return -1;
              return 3;

            case 12:
              if (pattern124 (x2, 
E_TImode, 
4, 
E_SImode) != 0)
                return -1;
              return 4;

            default:
              return -1;
            }

        case ZERO_EXTEND:
          x21 = XEXP (x20, 0);
          operands[2] = x21;
          if (!setmem_operand (operands[2], E_QImode))
            return -1;
          switch (SUBREG_BYTE (x17))
            {
            case 8:
              if (pattern125 (x2, 
E_TImode, 
0, 
E_DImode) != 0)
                return -1;
              return 5;

            case 4:
              if (pattern125 (x2, 
E_DImode, 
0, 
E_SImode) != 0)
                return -1;
              return 6;

            case 12:
              if (pattern125 (x2, 
E_TImode, 
4, 
E_SImode) != 0)
                return -1;
              return 7;

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern170 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !memory_operand (operands[1], i2))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  return 0;
}

int
pattern175 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern181 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode
          || !register_operand (operands[1], E_DImode))
        return -1;
      return 0;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 1;

    case E_TFmode:
      if (!register_operand (operands[0], E_TFmode)
          || GET_MODE (x1) != E_TFmode
          || !register_operand (operands[1], E_TFmode))
        return -1;
      return 2;

    case E_FPRX2mode:
      if (!register_operand (operands[0], E_FPRX2mode)
          || GET_MODE (x1) != E_FPRX2mode
          || !register_operand (operands[1], E_FPRX2mode))
        return -1;
      return 3;

    case E_DFmode:
      if (!register_operand (operands[0], E_DFmode)
          || GET_MODE (x1) != E_DFmode
          || !register_operand (operands[1], E_DFmode))
        return -1;
      return 4;

    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x1) != E_SFmode
          || !register_operand (operands[1], E_SFmode))
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern199 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !general_operand (operands[1], i2)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern204 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[3], i1)
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern209 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !s390_alc_comparison (operands[3], i1)
      || !nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern219 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern225 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1))
    return -1;
  operands[3] = x1;
  if (!const0_operand (operands[3], i1)
      || !scratch_operand (operands[0], i1))
    return -1;
  return 0;
}

int
pattern235 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || !register_operand (operands[1], E_V4SFmode)
          || !scratch_operand (operands[2], E_V4SImode))
        return -1;
      return 0;

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || !register_operand (operands[1], E_V2DFmode)
          || !scratch_operand (operands[2], E_V2DImode))
        return -1;
      return 1;

    case E_V1TFmode:
      if (!register_operand (operands[0], E_V1TFmode)
          || !register_operand (operands[1], E_V1TFmode)
          || !scratch_operand (operands[2], E_V1TImode))
        return -1;
      return 2;

    case E_TFmode:
      if (!register_operand (operands[0], E_TFmode)
          || !register_operand (operands[1], E_TFmode)
          || !scratch_operand (operands[2], E_TImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern253 (rtx x1, rtx_code i1, rtx_code i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != i2
      || GET_MODE (x1) != E_DImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != i1
      || GET_MODE (x2) != E_DImode)
    return -1;
  return 0;
}

int
pattern262 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[1], i1)
      || !const0_operand (operands[2], i1)
      || !register_operand (operands[0], i1))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 1);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) != i1)
    return -1;
  return 0;
}

int
pattern271 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[0], i1))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 1);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) != i1)
    return -1;
  return 0;
}

int
pattern281 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (XINT (x3, 1) != i1)
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      return pattern280 (x5, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern280 (x5, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern280 (x5, 
E_V4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern296 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !register_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[2], i1))
    return -1;
  x4 = XEXP (x1, 1);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

 int
recog_4 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern23 (x1))
    {
    case 0:
      if (!
#line 1142 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 307; /* vec_srlv16qiv16qi */

    case 1:
      if (!
#line 1142 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 317; /* vec_srlv16qiv8hi */

    case 2:
      if (!
#line 1142 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 327; /* vec_srlv16qiv4si */

    case 3:
      if (!
#line 1142 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 308; /* vec_srlv8hiv16qi */

    case 4:
      if (!
#line 1142 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 318; /* vec_srlv8hiv8hi */

    case 5:
      if (!
#line 1142 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 328; /* vec_srlv8hiv4si */

    case 6:
      if (!
#line 1142 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 309; /* vec_srlv4siv16qi */

    case 7:
      if (!
#line 1142 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 319; /* vec_srlv4siv8hi */

    case 8:
      if (!
#line 1142 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 329; /* vec_srlv4siv4si */

    case 9:
      if (!
#line 1142 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 310; /* vec_srlv2div16qi */

    case 10:
      if (!
#line 1142 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 320; /* vec_srlv2div8hi */

    case 11:
      if (!
#line 1142 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 330; /* vec_srlv2div4si */

    case 12:
      if (!
#line 1142 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 311; /* vec_srlv1tiv16qi */

    case 13:
      if (!
#line 1142 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 321; /* vec_srlv1tiv8hi */

    case 14:
      if (!
#line 1142 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 331; /* vec_srlv1tiv4si */

    case 15:
      if (!
#line 1142 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 312; /* vec_srltiv16qi */

    case 16:
      if (!
#line 1142 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 322; /* vec_srltiv8hi */

    case 17:
      if (!
#line 1142 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 332; /* vec_srltiv4si */

    case 18:
      if (!
#line 1142 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 313; /* vec_srlv4sfv16qi */

    case 19:
      if (!
#line 1142 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 323; /* vec_srlv4sfv8hi */

    case 20:
      if (!
#line 1142 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 333; /* vec_srlv4sfv4si */

    case 21:
      if (!
#line 1142 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 314; /* vec_srlv2dfv16qi */

    case 22:
      if (!
#line 1142 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 324; /* vec_srlv2dfv8hi */

    case 23:
      if (!
#line 1142 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 334; /* vec_srlv2dfv4si */

    case 24:
      if (!
#line 1142 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 315; /* vec_srlv1tfv16qi */

    case 25:
      if (!
#line 1142 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 325; /* vec_srlv1tfv8hi */

    case 26:
      if (!
#line 1142 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 335; /* vec_srlv1tfv4si */

    case 27:
      if (!
#line 1142 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 316; /* vec_srltfv16qi */

    case 28:
      if (!
#line 1142 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 326; /* vec_srltfv8hi */

    case 29:
      if (!
#line 1142 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 336; /* vec_srltfv4si */

    default:
      return -1;
    }
}

 int
recog_19 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != PLUS)
    return -1;
  x4 = XEXP (x3, 1);
  operands[2] = x4;
  x5 = XEXP (x1, 1);
  x6 = XEXP (x5, 0);
  operands[0] = x6;
  x7 = XEXP (x3, 0);
  switch (GET_CODE (x7))
    {
    case ZERO_EXTEND:
      if (pattern165 (x1, 
E_V4SImode, 
E_DImode, 
E_SImode) != 0)
        return -1;
      switch (GET_MODE (x2))
        {
        case E_SImode:
          if (GET_MODE (x5) != E_SImode
              || !register_operand (operands[0], E_V4SImode)
              || !
#line 450 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && TARGET_64BIT && UINTVAL (operands[3]) < 4))
            return -1;
          return 38; /* vec_scatter_elementv4si_DI */

        case E_SFmode:
          if (GET_MODE (x5) != E_SFmode
              || !register_operand (operands[0], E_V4SFmode)
              || !
#line 450 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && TARGET_64BIT && UINTVAL (operands[3]) < 4))
            return -1;
          return 39; /* vec_scatter_elementv4sf_DI */

        default:
          return -1;
        }

    case SUBREG:
      if (maybe_ne (SUBREG_BYTE (x7), 4)
          || pattern165 (x1, 
E_V2DImode, 
E_SImode, 
E_DImode) != 0)
        return -1;
      switch (GET_MODE (x2))
        {
        case E_DImode:
          if (GET_MODE (x5) != E_DImode
              || !register_operand (operands[0], E_V2DImode)
              || !
#line 466 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && !TARGET_64BIT && UINTVAL (operands[3]) < GET_MODE_NUNITS (V2DImode)))
            return -1;
          return 40; /* vec_scatter_elementv2di_SI */

        case E_DFmode:
          if (GET_MODE (x5) != E_DFmode
              || !register_operand (operands[0], E_V2DFmode)
              || !
#line 466 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && !TARGET_64BIT && UINTVAL (operands[3]) < GET_MODE_NUNITS (V2DFmode)))
            return -1;
          return 41; /* vec_scatter_elementv2df_SI */

        default:
          return -1;
        }

    case VEC_SELECT:
      x8 = XEXP (x7, 1);
      if (GET_CODE (x8) != PARALLEL
          || XVECLEN (x8, 0) != 1)
        return -1;
      x9 = XEXP (x7, 0);
      operands[1] = x9;
      x10 = XVECEXP (x8, 0, 0);
      operands[3] = x10;
      if (!const_mask_operand (operands[3], E_QImode)
          || !address_operand (operands[2], E_DImode))
        return -1;
      x11 = XEXP (x5, 1);
      x12 = XVECEXP (x11, 0, 0);
      if (!rtx_equal_p (x12, operands[3]))
        return -1;
      switch (GET_MODE (x2))
        {
        case E_SImode:
          if (pattern267 (x1, 
E_V4SImode, 
E_SImode) != 0
              || !
#line 482 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && UINTVAL (operands[3]) < GET_MODE_NUNITS (V4SImode)))
            return -1;
          return 42; /* vec_scatter_elementv4si_SI */

        case E_DImode:
          if (pattern267 (x1, 
E_V2DImode, 
E_DImode) != 0
              || !
#line 482 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && UINTVAL (operands[3]) < GET_MODE_NUNITS (V2DImode)))
            return -1;
          return 43; /* vec_scatter_elementv2di_DI */

        case E_DFmode:
          if (pattern268 (x1, 
E_V2DFmode, 
E_DFmode, 
E_V2DImode, 
E_DImode) != 0
              || !
#line 482 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && UINTVAL (operands[3]) < GET_MODE_NUNITS (V2DFmode)))
            return -1;
          return 44; /* vec_scatter_elementv2df_DI */

        case E_SFmode:
          if (pattern268 (x1, 
E_V4SFmode, 
E_SFmode, 
E_V4SImode, 
E_SImode) != 0
              || !(
#line 482 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && UINTVAL (operands[3]) < GET_MODE_NUNITS (V4SFmode)) && 
#line 23 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE)))
            return -1;
          return 45; /* vec_scatter_elementv4sf_SI */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_26 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case ZERO_EXTEND:
      if (GET_MODE (x4) != E_DImode)
        return -1;
      x5 = XEXP (x2, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || GET_MODE (x3) != E_DImode)
        return -1;
      x6 = XEXP (x4, 0);
      operands[2] = x6;
      if (!general_operand (operands[2], E_SImode))
        return -1;
      x7 = XEXP (x3, 1);
      operands[1] = x7;
      if (!register_operand (operands[1], E_DImode)
          || !
#line 6139 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCLmode) && TARGET_ZARCH))
        return -1;
      *pnum_clobbers = 1;
      return 2199; /* *adddi3_zero_cconly */

    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      x7 = XEXP (x3, 1);
      operands[2] = x7;
      switch (GET_MODE (x3))
        {
        case E_DImode:
          if (nonimmediate_operand (operands[1], E_DImode)
              && general_operand (operands[2], E_DImode))
            {
              x5 = XEXP (x2, 1);
              if (rtx_equal_p (x5, operands[1])
                  && (
#line 6265 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL1mode)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                {
                  *pnum_clobbers = 1;
                  return 2207; /* *adddi3_carry1_cconly */
                }
              if (rtx_equal_p (x5, operands[2])
                  && (
#line 6305 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL1mode)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                {
                  *pnum_clobbers = 1;
                  return 2211; /* *adddi3_carry2_cconly */
                }
            }
          break;

        case E_SImode:
          if (nonimmediate_operand (operands[1], E_SImode)
              && general_operand (operands[2], E_SImode))
            {
              x5 = XEXP (x2, 1);
              if (rtx_equal_p (x5, operands[1])
                  && 
#line 6265 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL1mode)))
                {
                  *pnum_clobbers = 1;
                  return 2208; /* *addsi3_carry1_cconly */
                }
              if (rtx_equal_p (x5, operands[2])
                  && 
#line 6305 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL1mode)))
                {
                  *pnum_clobbers = 1;
                  return 2212; /* *addsi3_carry2_cconly */
                }
            }
          break;

        case E_TFmode:
          if (nonimmediate_operand (operands[1], E_TFmode)
              && general_operand (operands[2], E_TFmode))
            {
              x5 = XEXP (x2, 1);
              operands[3] = x5;
              if (const0_operand (operands[3], E_TFmode)
                  && (
#line 6526 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 751 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                {
                  *pnum_clobbers = 1;
                  return 2238; /* *addtf3_cconly */
                }
            }
          break;

        case E_FPRX2mode:
          if (nonimmediate_operand (operands[1], E_FPRX2mode)
              && general_operand (operands[2], E_FPRX2mode))
            {
              x5 = XEXP (x2, 1);
              operands[3] = x5;
              if (const0_operand (operands[3], E_FPRX2mode)
                  && (
#line 6526 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 751 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                {
                  *pnum_clobbers = 1;
                  return 2239; /* *addfprx23_cconly */
                }
            }
          break;

        case E_DFmode:
          if (nonimmediate_operand (operands[1], E_DFmode)
              && general_operand (operands[2], E_DFmode))
            {
              x5 = XEXP (x2, 1);
              operands[3] = x5;
              if (const0_operand (operands[3], E_DFmode)
                  && 
#line 6526 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
                {
                  *pnum_clobbers = 1;
                  return 2240; /* *adddf3_cconly */
                }
            }
          break;

        case E_SFmode:
          if (nonimmediate_operand (operands[1], E_SFmode)
              && general_operand (operands[2], E_SFmode))
            {
              x5 = XEXP (x2, 1);
              operands[3] = x5;
              if (const0_operand (operands[3], E_SFmode)
                  && 
#line 6526 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
                {
                  *pnum_clobbers = 1;
                  return 2241; /* *addsf3_cconly */
                }
            }
          break;

        case E_TDmode:
          if (nonimmediate_operand (operands[1], E_TDmode)
              && general_operand (operands[2], E_TDmode))
            {
              x5 = XEXP (x2, 1);
              operands[3] = x5;
              if (const0_operand (operands[3], E_TDmode)
                  && (
#line 6526 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 752 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
                {
                  *pnum_clobbers = 1;
                  return 2242; /* *addtd3_cconly */
                }
            }
          break;

        case E_DDmode:
          if (nonimmediate_operand (operands[1], E_DDmode)
              && general_operand (operands[2], E_DDmode))
            {
              x5 = XEXP (x2, 1);
              operands[3] = x5;
              if (const0_operand (operands[3], E_DDmode)
                  && (
#line 6526 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 752 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
                {
                  *pnum_clobbers = 1;
                  return 2243; /* *adddd3_cconly */
                }
            }
          break;

        default:
          break;
        }
      x5 = XEXP (x2, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      switch (pattern155 (x3))
        {
        case 0:
          if (!(
#line 6345 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCLmode)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 2215; /* *adddi3_cconly */

        case 1:
          if (!
#line 6345 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCLmode)))
            return -1;
          *pnum_clobbers = 1;
          return 2216; /* *addsi3_cconly */

        default:
          return -1;
        }

    case PLUS:
      x6 = XEXP (x4, 0);
      operands[3] = x6;
      x8 = XEXP (x4, 1);
      operands[1] = x8;
      x7 = XEXP (x3, 1);
      operands[2] = x7;
      switch (GET_MODE (x3))
        {
        case E_DImode:
          if (pattern187 (x4, 
E_DImode) != 0)
            return -1;
          x5 = XEXP (x2, 1);
          if (rtx_equal_p (x5, operands[1])
              && (
#line 7041 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL1mode)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            {
              *pnum_clobbers = 1;
              return 2288; /* *adddi3_alc_carry1_cconly */
            }
          if (!rtx_equal_p (x5, operands[2])
              || !(
#line 7075 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL1mode)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 2292; /* *adddi3_alc_carry2_cconly */

        case E_SImode:
          if (pattern187 (x4, 
E_SImode) != 0)
            return -1;
          x5 = XEXP (x2, 1);
          if (rtx_equal_p (x5, operands[1])
              && 
#line 7041 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL1mode)))
            {
              *pnum_clobbers = 1;
              return 2289; /* *addsi3_alc_carry1_cconly */
            }
          if (!rtx_equal_p (x5, operands[2])
              || !
#line 7075 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL1mode)))
            return -1;
          *pnum_clobbers = 1;
          return 2293; /* *addsi3_alc_carry2_cconly */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_31 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) == EQ)
    {
      res = recog_30 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  if (pnum_clobbers == NULL)
    return -1;
  operands[0] = x3;
  if (!s390_signed_integer_comparison (operands[0], E_VOIDmode))
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != PC)
    return -1;
  x5 = XEXP (x3, 0);
  operands[1] = x5;
  x6 = XEXP (x3, 1);
  operands[2] = x6;
  x7 = XEXP (x2, 1);
  if (GET_CODE (x7) == PC)
    {
      x8 = XEXP (x2, 2);
      switch (pattern174 (x8))
        {
        case 0:
          if ((
#line 1702 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && !TARGET_AVOID_CMP_AND_BRANCH) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            {
              *pnum_clobbers = 1;
              return 1811; /* *icmp_and_br_signed_di */
            }
          break;

        case 1:
          if (
#line 1702 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && !TARGET_AVOID_CMP_AND_BRANCH))
            {
              *pnum_clobbers = 1;
              return 1812; /* *icmp_and_br_signed_si */
            }
          break;

        default:
          break;
        }
    }
  if (GET_CODE (x7) != LABEL_REF)
    return -1;
  switch (pattern173 (x2))
    {
    case 0:
      if (!(
#line 1644 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && !TARGET_AVOID_CMP_AND_BRANCH) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
        return -1;
      *pnum_clobbers = 1;
      return 1807; /* *cmp_and_br_signed_di */

    case 1:
      if (!
#line 1644 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && !TARGET_AVOID_CMP_AND_BRANCH))
        return -1;
      *pnum_clobbers = 1;
      return 1808; /* *cmp_and_br_signed_si */

    default:
      return -1;
    }
}

 int
recog_33 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x4, 1);
  operands[5] = x5;
  if (!const_int_operand (operands[5], E_VOIDmode))
    return -1;
  x6 = XEXP (x3, 1);
  operands[3] = x6;
  x7 = XEXP (x3, 2);
  operands[4] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (pattern233 (x3, 
E_DImode) != 0
          || !(
#line 7370 "../../gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
        return -1;
      return 2311; /* *movdicc */

    case E_SImode:
      if (pattern233 (x3, 
E_SImode) != 0
          || !
#line 7370 "../../gcc/config/s390/s390.md"
(TARGET_Z196))
        return -1;
      return 2312; /* *movsicc */

    default:
      return -1;
    }
}

 int
recog_35 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  switch (pattern13 (x1))
    {
    case 0:
      if (!
#line 2128 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1295; /* *vec_cmpgtv1qiv1qi_nocc */

    case 1:
      if (!
#line 2128 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1298; /* *vec_cmpgtv2qiv2qi_nocc */

    case 2:
      if (!
#line 2128 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1301; /* *vec_cmpgtv4qiv4qi_nocc */

    case 3:
      if (!
#line 2128 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1304; /* *vec_cmpgtv8qiv8qi_nocc */

    case 4:
      if (!
#line 2128 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1307; /* *vec_cmpgtv16qiv16qi_nocc */

    case 5:
      if (!
#line 2128 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1310; /* *vec_cmpgtv1hiv1hi_nocc */

    case 6:
      if (!
#line 2128 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1313; /* *vec_cmpgtv2hiv2hi_nocc */

    case 7:
      if (!
#line 2128 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1316; /* *vec_cmpgtv4hiv4hi_nocc */

    case 8:
      if (!
#line 2128 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1319; /* *vec_cmpgtv8hiv8hi_nocc */

    case 9:
      x2 = XEXP (x1, 0);
      operands[2] = x2;
      x3 = XEXP (x1, 1);
      x4 = XEXP (x3, 0);
      operands[0] = x4;
      if (register_operand (operands[0], E_V1SImode))
        {
          x5 = XEXP (x3, 1);
          operands[1] = x5;
          if (register_operand (operands[1], E_V1SImode)
              && 
#line 2128 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1322; /* *vec_cmpgtv1siv1si_nocc */
        }
      operands[0] = x2;
      operands[1] = x4;
      if (!register_operand (operands[1], E_V1SFmode))
        return -1;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      if (!register_operand (operands[2], E_V1SFmode))
        return -1;
      if (
#line 2307 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
        return 1382; /* *vec_cmpgtv1sf_signaling_nocc */
      if (!(
#line 2315 "../../gcc/config/s390/vector.md"
(TARGET_NONSIGNALING_VECTOR_COMPARE_OK) && 
#line 74 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      return 1389; /* *vec_cmpgtv1sf_signaling_finite_nocc */

    case 10:
      x2 = XEXP (x1, 0);
      operands[2] = x2;
      x3 = XEXP (x1, 1);
      x4 = XEXP (x3, 0);
      operands[0] = x4;
      if (register_operand (operands[0], E_V2SImode))
        {
          x5 = XEXP (x3, 1);
          operands[1] = x5;
          if (register_operand (operands[1], E_V2SImode)
              && 
#line 2128 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1325; /* *vec_cmpgtv2siv2si_nocc */
        }
      operands[0] = x2;
      operands[1] = x4;
      if (!register_operand (operands[1], E_V2SFmode))
        return -1;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      if (!register_operand (operands[2], E_V2SFmode))
        return -1;
      if (
#line 2307 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
        return 1383; /* *vec_cmpgtv2sf_signaling_nocc */
      if (!(
#line 2315 "../../gcc/config/s390/vector.md"
(TARGET_NONSIGNALING_VECTOR_COMPARE_OK) && 
#line 74 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      return 1390; /* *vec_cmpgtv2sf_signaling_finite_nocc */

    case 11:
      x2 = XEXP (x1, 0);
      operands[2] = x2;
      x3 = XEXP (x1, 1);
      x4 = XEXP (x3, 0);
      operands[0] = x4;
      if (register_operand (operands[0], E_V4SImode))
        {
          x5 = XEXP (x3, 1);
          operands[1] = x5;
          if (register_operand (operands[1], E_V4SImode)
              && 
#line 2128 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1328; /* *vec_cmpgtv4siv4si_nocc */
        }
      operands[0] = x2;
      operands[1] = x4;
      if (!register_operand (operands[1], E_V4SFmode))
        return -1;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      if (!register_operand (operands[2], E_V4SFmode))
        return -1;
      if (
#line 2307 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
        return 1384; /* *vec_cmpgtv4sf_signaling_nocc */
      if (!(
#line 2315 "../../gcc/config/s390/vector.md"
(TARGET_NONSIGNALING_VECTOR_COMPARE_OK) && 
#line 74 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      return 1391; /* *vec_cmpgtv4sf_signaling_finite_nocc */

    case 12:
      x2 = XEXP (x1, 0);
      operands[2] = x2;
      x3 = XEXP (x1, 1);
      x4 = XEXP (x3, 0);
      operands[0] = x4;
      if (register_operand (operands[0], E_V1DImode))
        {
          x5 = XEXP (x3, 1);
          operands[1] = x5;
          if (register_operand (operands[1], E_V1DImode)
              && 
#line 2128 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1331; /* *vec_cmpgtv1div1di_nocc */
        }
      operands[0] = x2;
      operands[1] = x4;
      if (!register_operand (operands[1], E_V1DFmode))
        return -1;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      if (!register_operand (operands[2], E_V1DFmode))
        return -1;
      if (
#line 2307 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
        return 1385; /* *vec_cmpgtv1df_signaling_nocc */
      if (!
#line 2315 "../../gcc/config/s390/vector.md"
(TARGET_NONSIGNALING_VECTOR_COMPARE_OK))
        return -1;
      return 1392; /* *vec_cmpgtv1df_signaling_finite_nocc */

    case 13:
      x2 = XEXP (x1, 0);
      operands[2] = x2;
      x3 = XEXP (x1, 1);
      x4 = XEXP (x3, 0);
      operands[0] = x4;
      if (register_operand (operands[0], E_V2DImode))
        {
          x5 = XEXP (x3, 1);
          operands[1] = x5;
          if (register_operand (operands[1], E_V2DImode)
              && 
#line 2128 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1334; /* *vec_cmpgtv2div2di_nocc */
        }
      operands[0] = x2;
      operands[1] = x4;
      if (!register_operand (operands[1], E_V2DFmode))
        return -1;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      if (!register_operand (operands[2], E_V2DFmode))
        return -1;
      if (
#line 2307 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
        return 1386; /* *vec_cmpgtv2df_signaling_nocc */
      if (!
#line 2315 "../../gcc/config/s390/vector.md"
(TARGET_NONSIGNALING_VECTOR_COMPARE_OK))
        return -1;
      return 1393; /* *vec_cmpgtv2df_signaling_finite_nocc */

    case 14:
      x2 = XEXP (x1, 0);
      operands[2] = x2;
      x3 = XEXP (x1, 1);
      x4 = XEXP (x3, 0);
      operands[0] = x4;
      if (register_operand (operands[0], E_V1TImode))
        {
          x5 = XEXP (x3, 1);
          operands[1] = x5;
          if (register_operand (operands[1], E_V1TImode)
              && (
#line 2128 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 69 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return 1337; /* *vec_cmpgtv1tiv1ti_nocc */
        }
      operands[0] = x2;
      switch (pattern110 (x3))
        {
        case 0:
          if (!
#line 2158 "../../gcc/config/s390/vector.md"
(TARGET_VX && !TARGET_VXE3))
            return -1;
          return 1344; /* *vec_cmpgtv1tiv1ti_nocc_emu */

        case 1:
          if (
#line 2307 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return 1387; /* *vec_cmpgtv1tf_signaling_nocc */
          if (!(
#line 2315 "../../gcc/config/s390/vector.md"
(TARGET_NONSIGNALING_VECTOR_COMPARE_OK) && 
#line 76 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1394; /* *vec_cmpgtv1tf_signaling_finite_nocc */

        default:
          return -1;
        }

    case 15:
      x2 = XEXP (x1, 0);
      operands[2] = x2;
      x3 = XEXP (x1, 1);
      x4 = XEXP (x3, 0);
      operands[0] = x4;
      if (register_operand (operands[0], E_TImode))
        {
          x5 = XEXP (x3, 1);
          operands[1] = x5;
          if (register_operand (operands[1], E_TImode)
              && (
#line 2128 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 69 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return 1340; /* *vec_cmpgttiti_nocc */
        }
      operands[0] = x2;
      switch (pattern111 (x3))
        {
        case 0:
          if (!
#line 2158 "../../gcc/config/s390/vector.md"
(TARGET_VX && !TARGET_VXE3))
            return -1;
          return 1345; /* *vec_cmpgttiti_nocc_emu */

        case 1:
          if (
#line 2307 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return 1388; /* *vec_cmpgttf_signaling_nocc */
          if (!(
#line 2315 "../../gcc/config/s390/vector.md"
(TARGET_NONSIGNALING_VECTOR_COMPARE_OK) && 
#line 76 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1395; /* *vec_cmpgttf_signaling_finite_nocc */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_50 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V2HImode:
          if (!register_operand (operands[0], E_V2HImode)
              || GET_MODE (x3) != E_V2HImode
              || !register_operand (operands[1], E_V2QImode)
              || !
#line 2668 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1508; /* zero_extendv2qiv2hi2 */

        case E_V2SImode:
          if (!register_operand (operands[0], E_V2SImode)
              || GET_MODE (x3) != E_V2SImode
              || !register_operand (operands[1], E_V2HImode)
              || !
#line 2668 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1510; /* zero_extendv2hiv2si2 */

        case E_V2DImode:
          if (!register_operand (operands[0], E_V2DImode)
              || GET_MODE (x3) != E_V2DImode
              || !register_operand (operands[1], E_V2SImode)
              || !
#line 2668 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1512; /* zero_extendv2siv2di2 */

        case E_V4HImode:
          if (!register_operand (operands[0], E_V4HImode)
              || GET_MODE (x3) != E_V4HImode
              || !register_operand (operands[1], E_V4QImode)
              || !
#line 2668 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1514; /* zero_extendv4qiv4hi2 */

        case E_V4SImode:
          if (!register_operand (operands[0], E_V4SImode)
              || GET_MODE (x3) != E_V4SImode
              || !register_operand (operands[1], E_V4HImode)
              || !
#line 2668 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1516; /* zero_extendv4hiv4si2 */

        case E_HImode:
          if (!register_operand (operands[0], E_HImode)
              || GET_MODE (x3) != E_HImode
              || !memory_operand (operands[1], E_QImode))
            return -1;
          if (
#line 5333 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && !TARGET_EXTIMM))
            return 2042; /* *zero_extendqihi2_64 */
          if (!
#line 5341 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
            return -1;
          return 2043; /* *zero_extendqihi2_31 */

        default:
          return -1;
        }

    case VEC_SELECT:
      switch (pattern114 (x3))
        {
        case 0:
          if (!
#line 2724 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1519; /* vec_unpacku_hi_v16qi */

        case 1:
          if (!
#line 2735 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1520; /* vec_unpacku_lo_v16qi */

        case 2:
          if (!
#line 2771 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1523; /* vec_unpacku_hi_v8hi */

        case 3:
          if (!
#line 2781 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1524; /* vec_unpacku_lo_v8hi */

        case 4:
          if (!
#line 2817 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1527; /* vec_unpacku_hi_v4si */

        case 5:
          if (!
#line 2827 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1528; /* vec_unpacku_lo_v4si */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_55 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case IOR:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          if (pattern105 (x3, 
E_V16QImode) != 0
              || !
#line 1017 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 194; /* vec_norv16qi3 */

        case E_V8HImode:
          if (pattern105 (x3, 
E_V8HImode) != 0
              || !
#line 1017 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 195; /* vec_norv8hi3 */

        case E_V4SImode:
          if (pattern105 (x3, 
E_V4SImode) != 0
              || !
#line 1017 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 196; /* vec_norv4si3 */

        case E_V2DImode:
          if (pattern105 (x3, 
E_V2DImode) != 0
              || !
#line 1017 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 197; /* vec_norv2di3 */

        case E_V2DFmode:
          if (pattern105 (x3, 
E_V2DFmode) != 0
              || !
#line 1017 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 198; /* vec_norv2df3 */

        case E_V1TImode:
          if (pattern105 (x3, 
E_V1TImode) != 0
              || !
#line 1017 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 199; /* vec_norv1ti3 */

        case E_TImode:
          if (pattern105 (x3, 
E_TImode) != 0
              || !
#line 1017 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 200; /* vec_norti3 */

        case E_V4SFmode:
          if (pattern105 (x3, 
E_V4SFmode) != 0
              || !(
#line 1017 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 47 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 201; /* vec_norv4sf3 */

        case E_V1TFmode:
          if (pattern105 (x3, 
E_V1TFmode) != 0
              || !(
#line 1017 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 47 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 202; /* vec_norv1tf3 */

        default:
          return -1;
        }

    case XOR:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V1QImode:
          if (pattern105 (x3, 
E_V1QImode) != 0
              || !
#line 1314 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 882; /* notxorv1qi3 */

        case E_V2QImode:
          if (pattern105 (x3, 
E_V2QImode) != 0
              || !
#line 1314 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 883; /* notxorv2qi3 */

        case E_V4QImode:
          if (pattern105 (x3, 
E_V4QImode) != 0
              || !
#line 1314 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 884; /* notxorv4qi3 */

        case E_V8QImode:
          if (pattern105 (x3, 
E_V8QImode) != 0
              || !
#line 1314 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 885; /* notxorv8qi3 */

        case E_V16QImode:
          if (pattern105 (x3, 
E_V16QImode) != 0
              || !
#line 1314 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 886; /* notxorv16qi3 */

        case E_V1HImode:
          if (pattern105 (x3, 
E_V1HImode) != 0
              || !
#line 1314 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 887; /* notxorv1hi3 */

        case E_V2HImode:
          if (pattern105 (x3, 
E_V2HImode) != 0
              || !
#line 1314 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 888; /* notxorv2hi3 */

        case E_V4HImode:
          if (pattern105 (x3, 
E_V4HImode) != 0
              || !
#line 1314 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 889; /* notxorv4hi3 */

        case E_V8HImode:
          if (pattern105 (x3, 
E_V8HImode) != 0
              || !
#line 1314 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 890; /* notxorv8hi3 */

        case E_V1SImode:
          if (pattern105 (x3, 
E_V1SImode) != 0
              || !
#line 1314 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 891; /* notxorv1si3 */

        case E_V2SImode:
          if (pattern105 (x3, 
E_V2SImode) != 0
              || !
#line 1314 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 892; /* notxorv2si3 */

        case E_V4SImode:
          if (pattern105 (x3, 
E_V4SImode) != 0
              || !
#line 1314 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 893; /* notxorv4si3 */

        case E_V1DImode:
          if (pattern105 (x3, 
E_V1DImode) != 0
              || !
#line 1314 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 894; /* notxorv1di3 */

        case E_V2DImode:
          if (pattern105 (x3, 
E_V2DImode) != 0
              || !
#line 1314 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 895; /* notxorv2di3 */

        case E_V1SFmode:
          if (pattern105 (x3, 
E_V1SFmode) != 0
              || !
#line 1314 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 896; /* notxorv1sf3 */

        case E_V2SFmode:
          if (pattern105 (x3, 
E_V2SFmode) != 0
              || !
#line 1314 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 897; /* notxorv2sf3 */

        case E_V4SFmode:
          if (pattern105 (x3, 
E_V4SFmode) != 0
              || !
#line 1314 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 898; /* notxorv4sf3 */

        case E_V1DFmode:
          if (pattern105 (x3, 
E_V1DFmode) != 0
              || !
#line 1314 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 899; /* notxorv1df3 */

        case E_V2DFmode:
          if (pattern105 (x3, 
E_V2DFmode) != 0
              || !
#line 1314 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 900; /* notxorv2df3 */

        case E_V1TFmode:
          if (pattern105 (x3, 
E_V1TFmode) != 0
              || !
#line 1314 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 901; /* notxorv1tf3 */

        case E_V1TImode:
          if (pattern105 (x3, 
E_V1TImode) != 0
              || !
#line 1314 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 902; /* notxorv1ti3 */

        case E_TImode:
          if (pattern105 (x3, 
E_TImode) != 0
              || !
#line 1314 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 903; /* notxorti3 */

        case E_DImode:
          if (pnum_clobbers == NULL
              || pattern105 (x3, 
E_DImode) != 0
              || !(
#line 9066 "../../gcc/config/s390/s390.md"
(TARGET_Z15) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 2420; /* *nxordi */

        case E_SImode:
          if (pnum_clobbers == NULL
              || pattern105 (x3, 
E_SImode) != 0
              || !
#line 9066 "../../gcc/config/s390/s390.md"
(TARGET_Z15))
            return -1;
          *pnum_clobbers = 1;
          return 2421; /* *nxorsi */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V1QImode:
          if (!register_operand (operands[0], E_V1QImode)
              || GET_MODE (x3) != E_V1QImode
              || !register_operand (operands[1], E_V1QImode)
              || !
#line 1322 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 904; /* one_cmplv1qi2 */

        case E_V2QImode:
          if (!register_operand (operands[0], E_V2QImode)
              || GET_MODE (x3) != E_V2QImode
              || !register_operand (operands[1], E_V2QImode)
              || !
#line 1322 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 905; /* one_cmplv2qi2 */

        case E_V4QImode:
          if (!register_operand (operands[0], E_V4QImode)
              || GET_MODE (x3) != E_V4QImode
              || !register_operand (operands[1], E_V4QImode)
              || !
#line 1322 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 906; /* one_cmplv4qi2 */

        case E_V8QImode:
          if (!register_operand (operands[0], E_V8QImode)
              || GET_MODE (x3) != E_V8QImode
              || !register_operand (operands[1], E_V8QImode)
              || !
#line 1322 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 907; /* one_cmplv8qi2 */

        case E_V16QImode:
          if (!register_operand (operands[0], E_V16QImode)
              || GET_MODE (x3) != E_V16QImode
              || !register_operand (operands[1], E_V16QImode)
              || !
#line 1322 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 908; /* one_cmplv16qi2 */

        case E_V1HImode:
          if (!register_operand (operands[0], E_V1HImode)
              || GET_MODE (x3) != E_V1HImode
              || !register_operand (operands[1], E_V1HImode)
              || !
#line 1322 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 909; /* one_cmplv1hi2 */

        case E_V2HImode:
          if (!register_operand (operands[0], E_V2HImode)
              || GET_MODE (x3) != E_V2HImode
              || !register_operand (operands[1], E_V2HImode)
              || !
#line 1322 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 910; /* one_cmplv2hi2 */

        case E_V4HImode:
          if (!register_operand (operands[0], E_V4HImode)
              || GET_MODE (x3) != E_V4HImode
              || !register_operand (operands[1], E_V4HImode)
              || !
#line 1322 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 911; /* one_cmplv4hi2 */

        case E_V8HImode:
          if (!register_operand (operands[0], E_V8HImode)
              || GET_MODE (x3) != E_V8HImode
              || !register_operand (operands[1], E_V8HImode)
              || !
#line 1322 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 912; /* one_cmplv8hi2 */

        case E_V1SImode:
          if (!register_operand (operands[0], E_V1SImode)
              || GET_MODE (x3) != E_V1SImode
              || !register_operand (operands[1], E_V1SImode)
              || !
#line 1322 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 913; /* one_cmplv1si2 */

        case E_V2SImode:
          if (!register_operand (operands[0], E_V2SImode)
              || GET_MODE (x3) != E_V2SImode
              || !register_operand (operands[1], E_V2SImode)
              || !
#line 1322 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 914; /* one_cmplv2si2 */

        case E_V4SImode:
          if (!register_operand (operands[0], E_V4SImode)
              || GET_MODE (x3) != E_V4SImode
              || !register_operand (operands[1], E_V4SImode)
              || !
#line 1322 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 915; /* one_cmplv4si2 */

        case E_V1DImode:
          if (!register_operand (operands[0], E_V1DImode)
              || GET_MODE (x3) != E_V1DImode
              || !register_operand (operands[1], E_V1DImode)
              || !
#line 1322 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 916; /* one_cmplv1di2 */

        case E_V2DImode:
          if (!register_operand (operands[0], E_V2DImode)
              || GET_MODE (x3) != E_V2DImode
              || !register_operand (operands[1], E_V2DImode)
              || !
#line 1322 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 917; /* one_cmplv2di2 */

        case E_V1SFmode:
          if (!register_operand (operands[0], E_V1SFmode)
              || GET_MODE (x3) != E_V1SFmode
              || !register_operand (operands[1], E_V1SFmode)
              || !
#line 1322 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 918; /* one_cmplv1sf2 */

        case E_V2SFmode:
          if (!register_operand (operands[0], E_V2SFmode)
              || GET_MODE (x3) != E_V2SFmode
              || !register_operand (operands[1], E_V2SFmode)
              || !
#line 1322 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 919; /* one_cmplv2sf2 */

        case E_V4SFmode:
          if (!register_operand (operands[0], E_V4SFmode)
              || GET_MODE (x3) != E_V4SFmode
              || !register_operand (operands[1], E_V4SFmode)
              || !
#line 1322 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 920; /* one_cmplv4sf2 */

        case E_V1DFmode:
          if (!register_operand (operands[0], E_V1DFmode)
              || GET_MODE (x3) != E_V1DFmode
              || !register_operand (operands[1], E_V1DFmode)
              || !
#line 1322 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 921; /* one_cmplv1df2 */

        case E_V2DFmode:
          if (!register_operand (operands[0], E_V2DFmode)
              || GET_MODE (x3) != E_V2DFmode
              || !register_operand (operands[1], E_V2DFmode)
              || !
#line 1322 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 922; /* one_cmplv2df2 */

        case E_V1TFmode:
          if (!register_operand (operands[0], E_V1TFmode)
              || GET_MODE (x3) != E_V1TFmode
              || !register_operand (operands[1], E_V1TFmode)
              || !
#line 1322 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 923; /* one_cmplv1tf2 */

        case E_V1TImode:
          if (!register_operand (operands[0], E_V1TImode)
              || GET_MODE (x3) != E_V1TImode
              || !register_operand (operands[1], E_V1TImode)
              || !
#line 1322 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 924; /* one_cmplv1ti2 */

        case E_TImode:
          if (!register_operand (operands[0], E_TImode)
              || GET_MODE (x3) != E_TImode
              || !register_operand (operands[1], E_TImode)
              || !
#line 1322 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 925; /* one_cmplti2 */

        case E_DImode:
          if (pattern83 (x3, pnum_clobbers, 
E_DImode) != 0
              || !(
#line 8661 "../../gcc/config/s390/s390.md"
(TARGET_Z15) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 2403; /* *notdi */

        case E_SImode:
          if (pattern83 (x3, pnum_clobbers, 
E_SImode) != 0
              || !
#line 8661 "../../gcc/config/s390/s390.md"
(TARGET_Z15))
            return -1;
          *pnum_clobbers = 1;
          return 2404; /* *notsi */

        default:
          return -1;
        }

    case UNGE:
      x5 = XEXP (x4, 0);
      operands[2] = x5;
      x6 = XEXP (x4, 1);
      operands[1] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V1SImode:
          if (pattern106 (x3, 
E_V1SFmode, 
E_V1SImode) != 0
              || !(
#line 2262 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 74 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1361; /* vec_cmpgtv1sf_quiet_nocc */

        case E_V2SImode:
          if (pattern106 (x3, 
E_V2SFmode, 
E_V2SImode) != 0
              || !(
#line 2262 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 74 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1362; /* vec_cmpgtv2sf_quiet_nocc */

        case E_V4SImode:
          if (pattern106 (x3, 
E_V4SFmode, 
E_V4SImode) != 0
              || !(
#line 2262 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 74 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1363; /* vec_cmpgtv4sf_quiet_nocc */

        case E_V1DImode:
          if (pattern106 (x3, 
E_V1DFmode, 
E_V1DImode) != 0
              || !
#line 2262 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1364; /* vec_cmpgtv1df_quiet_nocc */

        case E_V2DImode:
          if (pattern106 (x3, 
E_V2DFmode, 
E_V2DImode) != 0
              || !
#line 2262 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1365; /* vec_cmpgtv2df_quiet_nocc */

        case E_V1TImode:
          if (pattern106 (x3, 
E_V1TFmode, 
E_V1TImode) != 0
              || !(
#line 2262 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 76 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1366; /* vec_cmpgtv1tf_quiet_nocc */

        case E_TImode:
          if (pattern106 (x3, 
E_TFmode, 
E_TImode) != 0
              || !(
#line 2262 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 76 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1367; /* vec_cmpgttf_quiet_nocc */

        default:
          return -1;
        }

    case UNLT:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V1SImode:
          if (pattern107 (x3, 
E_V1SFmode, 
E_V1SImode) != 0
              || !(
#line 2279 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 74 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1368; /* vec_cmpgev1sf_quiet_nocc */

        case E_V2SImode:
          if (pattern107 (x3, 
E_V2SFmode, 
E_V2SImode) != 0
              || !(
#line 2279 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 74 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1369; /* vec_cmpgev2sf_quiet_nocc */

        case E_V4SImode:
          if (pattern107 (x3, 
E_V4SFmode, 
E_V4SImode) != 0
              || !(
#line 2279 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 74 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1370; /* vec_cmpgev4sf_quiet_nocc */

        case E_V1DImode:
          if (pattern107 (x3, 
E_V1DFmode, 
E_V1DImode) != 0
              || !
#line 2279 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1371; /* vec_cmpgev1df_quiet_nocc */

        case E_V2DImode:
          if (pattern107 (x3, 
E_V2DFmode, 
E_V2DImode) != 0
              || !
#line 2279 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1372; /* vec_cmpgev2df_quiet_nocc */

        case E_V1TImode:
          if (pattern107 (x3, 
E_V1TFmode, 
E_V1TImode) != 0
              || !(
#line 2279 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 76 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1373; /* vec_cmpgev1tf_quiet_nocc */

        case E_TImode:
          if (pattern107 (x3, 
E_TFmode, 
E_TImode) != 0
              || !(
#line 2279 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 76 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1374; /* vec_cmpgetf_quiet_nocc */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_68 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case EQ:
      switch (pattern13 (x1))
        {
        case 0:
          if (
#line 2128 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1294; /* *vec_cmpeqv1qiv1qi_nocc */
          break;

        case 1:
          if (
#line 2128 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1297; /* *vec_cmpeqv2qiv2qi_nocc */
          break;

        case 2:
          if (
#line 2128 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1300; /* *vec_cmpeqv4qiv4qi_nocc */
          break;

        case 3:
          if (
#line 2128 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1303; /* *vec_cmpeqv8qiv8qi_nocc */
          break;

        case 4:
          if (
#line 2128 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1306; /* *vec_cmpeqv16qiv16qi_nocc */
          break;

        case 5:
          if (
#line 2128 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1309; /* *vec_cmpeqv1hiv1hi_nocc */
          break;

        case 6:
          if (
#line 2128 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1312; /* *vec_cmpeqv2hiv2hi_nocc */
          break;

        case 7:
          if (
#line 2128 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1315; /* *vec_cmpeqv4hiv4hi_nocc */
          break;

        case 8:
          if (
#line 2128 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1318; /* *vec_cmpeqv8hiv8hi_nocc */
          break;

        case 9:
          x3 = XEXP (x1, 0);
          operands[2] = x3;
          x4 = XEXP (x2, 0);
          operands[0] = x4;
          if (register_operand (operands[0], E_V1SImode))
            {
              x5 = XEXP (x2, 1);
              operands[1] = x5;
              if (register_operand (operands[1], E_V1SImode)
                  && 
#line 2128 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return 1321; /* *vec_cmpeqv1siv1si_nocc */
            }
          operands[0] = x3;
          operands[1] = x4;
          if (register_operand (operands[1], E_V1SFmode))
            {
              x5 = XEXP (x2, 1);
              operands[2] = x5;
              if (register_operand (operands[2], E_V1SFmode)
                  && (
#line 2252 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 74 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return 1354; /* *vec_cmpeqv1sf_quiet_nocc */
            }
          break;

        case 10:
          x3 = XEXP (x1, 0);
          operands[2] = x3;
          x4 = XEXP (x2, 0);
          operands[0] = x4;
          if (register_operand (operands[0], E_V2SImode))
            {
              x5 = XEXP (x2, 1);
              operands[1] = x5;
              if (register_operand (operands[1], E_V2SImode)
                  && 
#line 2128 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return 1324; /* *vec_cmpeqv2siv2si_nocc */
            }
          operands[0] = x3;
          operands[1] = x4;
          if (register_operand (operands[1], E_V2SFmode))
            {
              x5 = XEXP (x2, 1);
              operands[2] = x5;
              if (register_operand (operands[2], E_V2SFmode)
                  && (
#line 2252 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 74 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return 1355; /* *vec_cmpeqv2sf_quiet_nocc */
            }
          break;

        case 11:
          x3 = XEXP (x1, 0);
          operands[2] = x3;
          x4 = XEXP (x2, 0);
          operands[0] = x4;
          if (register_operand (operands[0], E_V4SImode))
            {
              x5 = XEXP (x2, 1);
              operands[1] = x5;
              if (register_operand (operands[1], E_V4SImode)
                  && 
#line 2128 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return 1327; /* *vec_cmpeqv4siv4si_nocc */
            }
          operands[0] = x3;
          operands[1] = x4;
          if (register_operand (operands[1], E_V4SFmode))
            {
              x5 = XEXP (x2, 1);
              operands[2] = x5;
              if (register_operand (operands[2], E_V4SFmode)
                  && (
#line 2252 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 74 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return 1356; /* *vec_cmpeqv4sf_quiet_nocc */
            }
          break;

        case 12:
          x3 = XEXP (x1, 0);
          operands[2] = x3;
          x4 = XEXP (x2, 0);
          operands[0] = x4;
          if (register_operand (operands[0], E_V1DImode))
            {
              x5 = XEXP (x2, 1);
              operands[1] = x5;
              if (register_operand (operands[1], E_V1DImode)
                  && 
#line 2128 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return 1330; /* *vec_cmpeqv1div1di_nocc */
            }
          operands[0] = x3;
          operands[1] = x4;
          if (register_operand (operands[1], E_V1DFmode))
            {
              x5 = XEXP (x2, 1);
              operands[2] = x5;
              if (register_operand (operands[2], E_V1DFmode)
                  && 
#line 2252 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return 1357; /* *vec_cmpeqv1df_quiet_nocc */
            }
          break;

        case 13:
          x3 = XEXP (x1, 0);
          operands[2] = x3;
          x4 = XEXP (x2, 0);
          operands[0] = x4;
          if (register_operand (operands[0], E_V2DImode))
            {
              x5 = XEXP (x2, 1);
              operands[1] = x5;
              if (register_operand (operands[1], E_V2DImode)
                  && 
#line 2128 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return 1333; /* *vec_cmpeqv2div2di_nocc */
            }
          operands[0] = x3;
          operands[1] = x4;
          if (register_operand (operands[1], E_V2DFmode))
            {
              x5 = XEXP (x2, 1);
              operands[2] = x5;
              if (register_operand (operands[2], E_V2DFmode)
                  && 
#line 2252 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return 1358; /* *vec_cmpeqv2df_quiet_nocc */
            }
          break;

        case 14:
          x3 = XEXP (x1, 0);
          operands[2] = x3;
          x4 = XEXP (x2, 0);
          operands[0] = x4;
          if (register_operand (operands[0], E_V1TImode))
            {
              x5 = XEXP (x2, 1);
              operands[1] = x5;
              if (register_operand (operands[1], E_V1TImode)
                  && (
#line 2128 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 69 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
                return 1336; /* *vec_cmpeqv1tiv1ti_nocc */
            }
          operands[0] = x3;
          switch (pattern110 (x2))
            {
            case 0:
              if (
#line 2136 "../../gcc/config/s390/vector.md"
(TARGET_VX && !TARGET_VXE3))
                return 1342; /* *vec_cmpeqv1tiv1ti_nocc_emu */
              break;

            case 1:
              if ((
#line 2252 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 76 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return 1359; /* *vec_cmpeqv1tf_quiet_nocc */
              break;

            default:
              break;
            }
          break;

        case 15:
          x3 = XEXP (x1, 0);
          operands[2] = x3;
          x4 = XEXP (x2, 0);
          operands[0] = x4;
          if (register_operand (operands[0], E_TImode))
            {
              x5 = XEXP (x2, 1);
              operands[1] = x5;
              if (register_operand (operands[1], E_TImode)
                  && (
#line 2128 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 69 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
                return 1339; /* *vec_cmpeqtiti_nocc */
            }
          operands[0] = x3;
          switch (pattern111 (x2))
            {
            case 0:
              if (
#line 2136 "../../gcc/config/s390/vector.md"
(TARGET_VX && !TARGET_VXE3))
                return 1343; /* *vec_cmpeqtiti_nocc_emu */
              break;

            case 1:
              if ((
#line 2252 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 76 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return 1360; /* *vec_cmpeqtf_quiet_nocc */
              break;

            default:
              break;
            }
          break;

        default:
          break;
        }
      break;

    case GT:
      res = recog_35 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case GE:
      res = recog_36 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case NE:
      res = recog_37 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case PLUS:
    case MINUS:
    case MULT:
    case AND:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case SIGN_EXTEND:
    case ZERO_EXTEND:
    case HIGH:
      res = recog_54 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    default:
      break;
    }
  switch (GET_CODE (x2))
    {
    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case LTGT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case UNORDERED:
    case ORDERED:
    case UNEQ:
    case UNGE:
    case UNGT:
    case UNLE:
    case UNLT:
      operands[1] = x2;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (pattern45 (x2))
        {
        case 0:
          if (!(
#line 7287 "../../gcc/config/s390/s390.md"
(TARGET_Z13) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 2309; /* *cstoreccdi_z13 */

        case 1:
          if (!
#line 7287 "../../gcc/config/s390/s390.md"
(TARGET_Z13))
            return -1;
          return 2310; /* *cstoreccsi_z13 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_84 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x2))
    {
    case SET:
      x3 = XEXP (x2, 1);
      if (GET_CODE (x3) != NEG)
        return -1;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x5 = XEXP (x3, 0);
      if (!rtx_equal_p (x5, operands[1]))
        return -1;
      switch (pattern239 (x1))
        {
        case 0:
          if (!(
#line 9115 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCAmode)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 2424; /* *negdi2_cc */

        case 1:
          if (!
#line 9115 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCAmode)))
            return -1;
          return 2425; /* *negsi2_cc */

        default:
          return -1;
        }

    case CLOBBER:
      switch (pattern192 (x1))
        {
        case 0:
          if (!(
#line 9126 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCAmode)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 2426; /* *negdi2_cconly */

        case 1:
          if (!
#line 9126 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCAmode)))
            return -1;
          return 2427; /* *negsi2_cconly */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_90 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 1);
  operands[2] = x6;
  x7 = XEXP (x4, 1);
  operands[3] = x7;
  x8 = XVECEXP (x1, 0, 1);
  x9 = XEXP (x8, 0);
  operands[4] = x9;
  x10 = XEXP (x8, 1);
  x11 = XEXP (x10, 1);
  if (!rtx_equal_p (x11, operands[2]))
    return -1;
  switch (GET_MODE (x5))
    {
    case E_DImode:
      if (pattern290 (x10, 
E_DImode) != 0
          || !
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
        return -1;
      *pnum_clobbers = 1;
      return 2539; /* *brx_stage1_di */

    case E_SImode:
      if (pattern290 (x10, 
E_SImode) != 0)
        return -1;
      *pnum_clobbers = 1;
      return 2540; /* *brx_stage1_si */

    default:
      return -1;
    }
}

 int
recog_94 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (pattern38 (x1) != 0)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (pattern121 (x3, 
E_HImode) != 0)
        return -1;
      if (
#line 8153 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
        return 2361; /* *andhi3_zarch */
      if (!
#line 8170 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
        return -1;
      return 2362; /* *andhi3_esa */

    case E_QImode:
      if (pattern121 (x3, 
E_QImode) != 0)
        return -1;
      if (
#line 8198 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
        return 2363; /* *andqi3_zarch */
      if (!
#line 8215 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
        return -1;
      return 2364; /* *andqi3_esa */

    default:
      return -1;
    }
}

 int
recog_96 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case PLUS:
    case MINUS:
    case MULT:
    case AND:
    case SIGN_EXTEND:
    case ZERO_EXTEND:
    case HIGH:
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case CONST_INT:
          if (XWINT (x5, 0) == 2147483647L
              && pattern38 (x1) == 0
              && register_operand (operands[0], E_SImode)
              && GET_MODE (x3) == E_SImode)
            {
              operands[1] = x4;
              if (address_operand (operands[1], E_QImode)
                  && 
#line 2589 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT))
                return 1857; /* *la_31_and_cc */
            }
          break;

        case REG:
        case SUBREG:
        case MEM:
          res = recog_93 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        default:
          break;
        }
      operands[1] = x4;
      res = recog_94 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != CLOBBER)
        return -1;
      x7 = XEXP (x6, 0);
      if (GET_CODE (x7) != REG
          || REGNO (x7) != 33
          || GET_MODE (x7) != E_CCmode)
        return -1;
      x8 = XEXP (x2, 0);
      operands[0] = x8;
      if (GET_CODE (x4) == SUBREG)
        {
          res = recog_95 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[1] = x4;
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (pattern121 (x3, 
E_DImode) != 0
              || !
#line 7961 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
            return -1;
          return 2348; /* *anddi3 */

        case E_SImode:
          if (pattern121 (x3, 
E_SImode) != 0)
            return -1;
          if (
#line 8090 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
            return 2359; /* *andsi3_zarch */
          if (!
#line 8124 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
            return -1;
          return 2360; /* *andsi3_esa */

        default:
          return -1;
        }

    case ROTATE:
      if (GET_MODE (x4) != E_DImode
          || pattern38 (x1) != 0
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      x9 = XEXP (x4, 0);
      operands[1] = x9;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      x10 = XEXP (x4, 1);
      operands[2] = x10;
      if (!const_int_operand (operands[2], E_DImode))
        return -1;
      x5 = XEXP (x3, 1);
      operands[3] = x5;
      if (!contiguous_bitmask_operand (operands[3], E_DImode)
          || !
#line 4404 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12))
        return -1;
      return 1951; /* *risbg_di_and_rot */

    case LSHIFTRT:
      x6 = XVECEXP (x1, 0, 1);
      if (pattern89 (x6) != 0)
        return -1;
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
        case MEM:
          operands[4] = x5;
          if (!nonimmediate_operand (operands[4], E_DImode))
            return -1;
          x8 = XEXP (x2, 0);
          if (GET_CODE (x8) != ZERO_EXTRACT
              || GET_MODE (x8) != E_DImode)
            return -1;
          x11 = XEXP (x8, 0);
          operands[0] = x11;
          if (!nonimmediate_operand (operands[0], E_DImode))
            return -1;
          x12 = XEXP (x8, 1);
          operands[1] = x12;
          if (!const_int_operand (operands[1], E_VOIDmode))
            return -1;
          x13 = XEXP (x8, 2);
          operands[2] = x13;
          if (!const_int_operand (operands[2], E_VOIDmode)
              || GET_MODE (x3) != E_DImode
              || GET_MODE (x4) != E_DImode)
            return -1;
          x10 = XEXP (x4, 1);
          operands[3] = x10;
          if (!const_int_operand (operands[3], E_VOIDmode))
            return -1;
          x9 = XEXP (x4, 0);
          if (!rtx_equal_p (x9, operands[0])
              || !
#line 4850 "../../gcc/config/s390/s390.md"
(TARGET_Z10
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[1]), INTVAL (operands[2]), 64)
   && INTVAL (operands[3]) == 64 - INTVAL (operands[1]) - INTVAL (operands[2])))
            return -1;
          return 2005; /* *insv_rnsbg_srl */

        case CONST_INT:
          operands[3] = x5;
          x8 = XEXP (x2, 0);
          operands[0] = x8;
          x9 = XEXP (x4, 0);
          operands[1] = x9;
          x10 = XEXP (x4, 1);
          operands[2] = x10;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (pattern246 (x3, 
E_DImode) != 0
                  || !(
#line 8011 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   /* Note that even for the SImode pattern, the rotate is always DImode.  */
   && s390_extzv_shift_ok (64, -INTVAL (operands[2]),
			   INTVAL (operands[3]))) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              return 2350; /* *extzv_di_srl_clobbercc */

            case E_SImode:
              if (pattern246 (x3, 
E_SImode) != 0
                  || !
#line 8011 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   /* Note that even for the SImode pattern, the rotate is always DImode.  */
   && s390_extzv_shift_ok (32, -INTVAL (operands[2]),
			   INTVAL (operands[3]))))
                return -1;
              return 2352; /* *extzv_si_srl_clobbercc */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ASHIFT:
      x6 = XVECEXP (x1, 0, 1);
      if (pattern39 (x6) != 0)
        return -1;
      x8 = XEXP (x2, 0);
      operands[0] = x8;
      x9 = XEXP (x4, 0);
      operands[1] = x9;
      x10 = XEXP (x4, 1);
      operands[2] = x10;
      x5 = XEXP (x3, 1);
      operands[3] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (pattern246 (x3, 
E_DImode) != 0
              || !(
#line 8025 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && s390_extzv_shift_ok (64, INTVAL (operands[2]),
			   INTVAL (operands[3]))) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 2354; /* *extzv_di_sll_clobbercc */

        case E_SImode:
          if (pattern246 (x3, 
E_SImode) != 0
              || !
#line 8025 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && s390_extzv_shift_ok (32, INTVAL (operands[2]),
			   INTVAL (operands[3]))))
            return -1;
          return 2356; /* *extzv_si_sll_clobbercc */

        default:
          return -1;
        }

    case NOT:
      x6 = XVECEXP (x1, 0, 1);
      if (pattern39 (x6) != 0)
        return -1;
      x8 = XEXP (x2, 0);
      operands[0] = x8;
      x9 = XEXP (x4, 0);
      operands[1] = x9;
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case MEM:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (GET_MODE (x3) != E_DImode
                  || GET_MODE (x4) != E_DImode)
                return -1;
              if (nonimmediate_operand (operands[0], E_DImode)
                  && nonimmediate_operand (operands[1], E_DImode)
                  && general_operand (operands[2], E_DImode)
                  && (
#line 8233 "../../gcc/config/s390/s390.md"
(!TARGET_Z15
   && ! reload_completed
   && (GET_CODE (operands[0]) != MEM
      /* Ensure that s390_logical_operator_ok_p will succeed even
	 on the split xor if (b & a) is stored into a pseudo.  */
       || rtx_equal_p (operands[0], operands[2]))) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return 2365; /* *andc_split_di */
              if (!register_operand (operands[0], E_DImode)
                  || !register_operand (operands[1], E_DImode)
                  || !register_operand (operands[2], E_DImode)
                  || !(
#line 8612 "../../gcc/config/s390/s390.md"
(TARGET_Z15) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              return 2387; /* *andcdi */

            case E_SImode:
              if (GET_MODE (x3) != E_SImode
                  || GET_MODE (x4) != E_SImode)
                return -1;
              if (nonimmediate_operand (operands[0], E_SImode)
                  && nonimmediate_operand (operands[1], E_SImode)
                  && general_operand (operands[2], E_SImode)
                  && 
#line 8233 "../../gcc/config/s390/s390.md"
(!TARGET_Z15
   && ! reload_completed
   && (GET_CODE (operands[0]) != MEM
      /* Ensure that s390_logical_operator_ok_p will succeed even
	 on the split xor if (b & a) is stored into a pseudo.  */
       || rtx_equal_p (operands[0], operands[2]))))
                return 2366; /* *andc_split_si */
              if (!register_operand (operands[0], E_SImode)
                  || !register_operand (operands[1], E_SImode)
                  || !register_operand (operands[2], E_SImode)
                  || !
#line 8612 "../../gcc/config/s390/s390.md"
(TARGET_Z15))
                return -1;
              return 2389; /* *andcsi */

            default:
              return -1;
            }

        case NOT:
          switch (pattern216 (x3))
            {
            case 0:
              if (!(
#line 8652 "../../gcc/config/s390/s390.md"
(TARGET_Z15) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              return 2399; /* *nordi */

            case 1:
              if (!
#line 8652 "../../gcc/config/s390/s390.md"
(TARGET_Z15))
                return -1;
              return 2401; /* *norsi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_108 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case AND:
      switch (pattern93 (x1))
        {
        case 0:
          x6 = XEXP (x4, 1);
          operands[3] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (pattern250 (x4, 
E_DImode) != 0
                  || !(
#line 4685 "../../gcc/config/s390/s390.md"
(TARGET_Z10) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              return 1981; /* *rxsbg_di_noshift */

            case E_SImode:
              if (pattern250 (x4, 
E_SImode) != 0
                  || !
#line 4685 "../../gcc/config/s390/s390.md"
(TARGET_Z10))
                return -1;
              return 1983; /* *rxsbg_si_noshift */

            default:
              return -1;
            }

        case 1:
          if (!
#line 4700 "../../gcc/config/s390/s390.md"
(TARGET_Z10))
            return -1;
          return 1985; /* *rxsbg_di_rotl */

        case 2:
          if (!(
#line 4715 "../../gcc/config/s390/s390.md"
(TARGET_Z10
   && s390_extzv_shift_ok (64, 64 - INTVAL (operands[3]),
                           INTVAL (operands[2]))) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 1987; /* *rxsbg_di_srl_bitmask */

        case 3:
          if (!
#line 4715 "../../gcc/config/s390/s390.md"
(TARGET_Z10
   && s390_extzv_shift_ok (32, 64 - INTVAL (operands[3]),
                           INTVAL (operands[2]))))
            return -1;
          return 1989; /* *rxsbg_si_srl_bitmask */

        case 4:
          if (!(
#line 4735 "../../gcc/config/s390/s390.md"
(TARGET_Z10
   && s390_extzv_shift_ok (64, INTVAL (operands[3]),
                           INTVAL (operands[2]))) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 1991; /* *rxsbg_di_sll_bitmask */

        case 5:
          if (!
#line 4735 "../../gcc/config/s390/s390.md"
(TARGET_Z10
   && s390_extzv_shift_ok (32, INTVAL (operands[3]),
                           INTVAL (operands[2]))))
            return -1;
          return 1993; /* *rxsbg_si_sll_bitmask */

        default:
          return -1;
        }

    case ASHIFT:
      switch (pattern96 (x1))
        {
        case 0:
          if (!(
#line 4753 "../../gcc/config/s390/s390.md"
(TARGET_Z10) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 1995; /* *rxsbg_di_sll */

        case 1:
          if (!
#line 4753 "../../gcc/config/s390/s390.md"
(TARGET_Z10))
            return -1;
          return 1997; /* *rxsbg_si_sll */

        default:
          return -1;
        }

    case LSHIFTRT:
      switch (pattern96 (x1))
        {
        case 0:
          if (!(
#line 4772 "../../gcc/config/s390/s390.md"
(TARGET_Z10) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 1999; /* *rxsbg_di_srl */

        case 1:
          if (!
#line 4772 "../../gcc/config/s390/s390.md"
(TARGET_Z10))
            return -1;
          return 2001; /* *rxsbg_si_srl */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
    case MEM:
      if (GET_CODE (x5) == SUBREG
          && pattern119 (x1) == 0
          && 
#line 4792 "../../gcc/config/s390/s390.md"
(TARGET_Z10))
        return 2003; /* *rxsbg_sidi_srl */
      if (pnum_clobbers != NULL
          && pattern120 (x1) == 0
          && 
#line 8948 "../../gcc/config/s390/s390.md"
(INTVAL (operands[2]) >= 1 && INTVAL (operands[2]) <= 256))
        {
          *pnum_clobbers = 1;
          return 2414; /* *xc */
        }
      operands[1] = x5;
      switch (pattern122 (x1))
        {
        case 0:
          if (!
#line 8792 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
            return -1;
          return 2408; /* *xordi3 */

        case 1:
          if (!
#line 8862 "../../gcc/config/s390/s390.md"
(s390_logical_operator_ok_p (operands)))
            return -1;
          return 2411; /* *xorsi3 */

        case 2:
          if (!
#line 8895 "../../gcc/config/s390/s390.md"
(s390_logical_operator_ok_p (operands)))
            return -1;
          return 2412; /* *xorhi3 */

        case 3:
          if (!
#line 8925 "../../gcc/config/s390/s390.md"
(s390_logical_operator_ok_p (operands)))
            return -1;
          return 2413; /* *xorqi3 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_116 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x2))
    {
    case CLOBBER:
      x3 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x3) != CLOBBER)
        return -1;
      x4 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x4) != SET)
        return -1;
      x5 = XVECEXP (x1, 0, 3);
      if (GET_CODE (x5) != USE)
        return -1;
      x6 = XVECEXP (x1, 0, 4);
      if (GET_CODE (x6) != USE)
        return -1;
      x7 = XEXP (x2, 0);
      operands[0] = x7;
      x8 = XEXP (x3, 0);
      operands[1] = x8;
      x9 = XEXP (x4, 1);
      switch (GET_CODE (x9))
        {
        case MEM:
          if (pnum_clobbers == NULL
              || pattern98 (x4) != 0)
            return -1;
          switch (pattern258 (x1))
            {
            case 0:
              if (!(
#line 3698 "../../gcc/config/s390/s390.md"
(TARGET_64BIT || !TARGET_ZARCH) && 
#line 778 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 1894; /* *cpymem_long */

            case 1:
              if (!(
#line 3698 "../../gcc/config/s390/s390.md"
(TARGET_64BIT || !TARGET_ZARCH) && 
#line 778 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 1895; /* *cpymem_long */

            case 2:
              if (!
#line 3711 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT && TARGET_ZARCH))
                return -1;
              *pnum_clobbers = 1;
              return 1896; /* *cpymem_long_31z */

            default:
              return -1;
            }

        case COMPARE:
          if (GET_MODE (x9) != E_CCUmode)
            return -1;
          x10 = XEXP (x9, 0);
          if (GET_CODE (x10) != MEM
              || GET_MODE (x10) != E_BLKmode)
            return -1;
          x11 = XEXP (x10, 0);
          if (GET_CODE (x11) != SUBREG)
            return -1;
          x12 = XEXP (x9, 1);
          if (GET_CODE (x12) != MEM
              || GET_MODE (x12) != E_BLKmode)
            return -1;
          x13 = XEXP (x12, 0);
          if (GET_CODE (x13) != SUBREG)
            return -1;
          x14 = XEXP (x4, 0);
          if (GET_CODE (x14) != REG
              || REGNO (x14) != 33
              || GET_MODE (x14) != E_CCUmode)
            return -1;
          x15 = XEXP (x11, 0);
          operands[2] = x15;
          x16 = XEXP (x13, 0);
          operands[3] = x16;
          x17 = XEXP (x5, 0);
          if (!rtx_equal_p (x17, operands[2]))
            return -1;
          x18 = XEXP (x6, 0);
          if (!rtx_equal_p (x18, operands[3]))
            return -1;
          switch (SUBREG_BYTE (x11))
            {
            case 0:
              if (maybe_ne (SUBREG_BYTE (x13), 0))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_TImode:
                  if (pattern296 (x9, 
E_TImode, 
E_DImode) != 0
                      || !(
#line 4151 "../../gcc/config/s390/s390.md"
(TARGET_64BIT || !TARGET_ZARCH) && 
#line 778 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
                    return -1;
                  return 1916; /* *cmpmem_long */

                case E_DImode:
                  if (pattern296 (x9, 
E_DImode, 
E_SImode) != 0
                      || !(
#line 4151 "../../gcc/config/s390/s390.md"
(TARGET_64BIT || !TARGET_ZARCH) && 
#line 778 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
                    return -1;
                  return 1917; /* *cmpmem_long */

                default:
                  return -1;
                }

            case 4:
              if (GET_MODE (x11) != E_SImode
                  || maybe_ne (SUBREG_BYTE (x13), 4)
                  || GET_MODE (x13) != E_SImode
                  || !register_operand (operands[0], E_TImode)
                  || !register_operand (operands[1], E_TImode)
                  || !register_operand (operands[2], E_TImode)
                  || !register_operand (operands[3], E_TImode)
                  || !
#line 4164 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT && TARGET_ZARCH))
                return -1;
              return 1918; /* *cmpmem_long_31z */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SET:
      x4 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x4) != USE)
        return -1;
      x19 = XEXP (x2, 1);
      switch (GET_CODE (x19))
        {
        case CONST_INT:
          if (XWINT (x19, 0) != 0L)
            return -1;
          x3 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x3) != USE
              || pattern103 (x1) != 0
              || !nonmemory_operand (operands[1], E_VOIDmode))
            return -1;
          x14 = XEXP (x4, 0);
          operands[2] = x14;
          if (!immediate_operand (operands[2], E_VOIDmode))
            return -1;
          x5 = XVECEXP (x1, 0, 3);
          x17 = XEXP (x5, 0);
          operands[3] = x17;
          switch (GET_MODE (operands[3]))
            {
            case E_DImode:
              if (!scratch_operand (operands[3], E_DImode)
                  || !(
#line 3849 "../../gcc/config/s390/s390.md"
((GET_MODE (operands[1]) == Pmode || GET_MODE (operands[1]) == VOIDmode)) && 
#line 778 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
                return -1;
              return 1906; /* *clrmem_short */

            case E_SImode:
              if (!scratch_operand (operands[3], E_SImode)
                  || !(
#line 3849 "../../gcc/config/s390/s390.md"
((GET_MODE (operands[1]) == Pmode || GET_MODE (operands[1]) == VOIDmode)) && 
#line 778 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
                return -1;
              return 1907; /* *clrmem_short */

            default:
              return -1;
            }

        case LABEL_REF:
          if (pattern79 (x1) != 0)
            return -1;
          x20 = XEXP (x19, 0);
          operands[2] = x20;
          switch (pattern272 (x1))
            {
            case 0:
              if (!
#line 778 "../../gcc/config/s390/s390.md"
(TARGET_64BIT))
                return -1;
              return 2667; /* split_stack_calldi */

            case 1:
              if (!
#line 778 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT))
                return -1;
              return 2668; /* split_stack_callsi */

            default:
              return -1;
            }

        case IF_THEN_ELSE:
          x21 = XEXP (x19, 1);
          if (GET_CODE (x21) != LABEL_REF)
            return -1;
          x22 = XEXP (x19, 2);
          if (GET_CODE (x22) != PC
              || pattern79 (x1) != 0)
            return -1;
          x20 = XEXP (x19, 0);
          operands[5] = x20;
          x23 = XEXP (x21, 0);
          operands[2] = x23;
          switch (pattern272 (x1))
            {
            case 0:
              if (!
#line 778 "../../gcc/config/s390/s390.md"
(TARGET_64BIT))
                return -1;
              return 2669; /* split_stack_cond_calldi */

            case 1:
              if (!
#line 778 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT))
                return -1;
              return 2670; /* split_stack_cond_callsi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_4 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case AND:
      switch (pattern29 (x3))
        {
        case 0:
          if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_144 (insn, operands);

        case 1:
          if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_153 (insn, operands);

        case 2:
          if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_162 (insn, operands);

        case 3:
          if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_171 (insn, operands);

        case 4:
          if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_180 (insn, operands);

        case 5:
          if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_189 (insn, operands);

        case 6:
          if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_198 (insn, operands);

        case 7:
          if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_207 (insn, operands);

        case 8:
          if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_216 (insn, operands);

        case 9:
          if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_225 (insn, operands);

        case 10:
          if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_234 (insn, operands);

        case 11:
          if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_243 (insn, operands);

        case 12:
          if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_252 (insn, operands);

        case 13:
          if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_261 (insn, operands);

        case 14:
          if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_270 (insn, operands);

        case 15:
          if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_279 (insn, operands);

        default:
          return NULL;
        }

    case IOR:
      switch (pattern29 (x3))
        {
        case 0:
          if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_145 (insn, operands);

        case 1:
          if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_154 (insn, operands);

        case 2:
          if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_163 (insn, operands);

        case 3:
          if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_172 (insn, operands);

        case 4:
          if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_181 (insn, operands);

        case 5:
          if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_190 (insn, operands);

        case 6:
          if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_199 (insn, operands);

        case 7:
          if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_208 (insn, operands);

        case 8:
          if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_217 (insn, operands);

        case 9:
          if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_226 (insn, operands);

        case 10:
          if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_235 (insn, operands);

        case 11:
          if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_244 (insn, operands);

        case 12:
          if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_253 (insn, operands);

        case 13:
          if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_262 (insn, operands);

        case 14:
          if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_271 (insn, operands);

        case 15:
          if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_280 (insn, operands);

        default:
          return NULL;
        }

    case XOR:
      switch (pattern29 (x3))
        {
        case 0:
          if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_146 (insn, operands);

        case 1:
          if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_155 (insn, operands);

        case 2:
          if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_164 (insn, operands);

        case 3:
          if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_173 (insn, operands);

        case 4:
          if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_182 (insn, operands);

        case 5:
          if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_191 (insn, operands);

        case 6:
          if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_200 (insn, operands);

        case 7:
          if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_209 (insn, operands);

        case 8:
          if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_218 (insn, operands);

        case 9:
          if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_227 (insn, operands);

        case 10:
          if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_236 (insn, operands);

        case 11:
          if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_245 (insn, operands);

        case 12:
          if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_254 (insn, operands);

        case 13:
          if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_263 (insn, operands);

        case 14:
          if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_272 (insn, operands);

        case 15:
          if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_281 (insn, operands);

        default:
          return NULL;
        }

    case LSHIFTRT:
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != ASHIFT)
        return NULL;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      x7 = XEXP (x4, 1);
      operands[2] = x7;
      x8 = XEXP (x5, 0);
      operands[3] = x8;
      x9 = XEXP (x5, 1);
      operands[4] = x9;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (pattern183 (x3, 
E_DImode) != 0
              || !(
#line 4631 "../../gcc/config/s390/s390.md"
(TARGET_ZEC12 && UINTVAL (operands[2]) + UINTVAL (operands[4]) >= 64) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return NULL;
          return gen_split_342 (insn, operands);

        case E_SImode:
          if (pattern183 (x3, 
E_SImode) != 0
              || !
#line 4631 "../../gcc/config/s390/s390.md"
(TARGET_ZEC12 && UINTVAL (operands[2]) + UINTVAL (operands[4]) >= 32))
            return NULL;
          return gen_split_343 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_1 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], E_BLKmode)
      || !memory_operand (operands[1], E_BLKmode))
    return NULL;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  if (!const_int_operand (operands[2], E_VOIDmode))
    return NULL;
  x4 = PATTERN (peep2_next_insn (1));
  if (pattern197 (x4, 
2) != 0)
    return NULL;
  x5 = XVECEXP (x4, 0, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  if (!memory_operand (operands[3], E_BLKmode))
    return NULL;
  x7 = XEXP (x5, 1);
  operands[4] = x7;
  if (!memory_operand (operands[4], E_BLKmode))
    return NULL;
  x8 = XVECEXP (x4, 0, 1);
  x9 = XEXP (x8, 0);
  operands[5] = x9;
  if (!const_int_operand (operands[5], E_VOIDmode)
      || !
#line 3142 "../../gcc/config/s390/s390.md"
(((INTVAL (operands[2]) > 16 && INTVAL (operands[5]) > 16)
    || (INTVAL (operands[2]) + INTVAL (operands[5]) <= 16))
   && s390_offset_p (operands[0], operands[3], operands[2])
   && s390_offset_p (operands[1], operands[4], operands[2])
   && !s390_overlap_p (operands[0], operands[1],
                       INTVAL (operands[2]) + INTVAL (operands[5]))
   && INTVAL (operands[2]) + INTVAL (operands[5]) <= 256))
    return NULL;
  *pmatch_len_ = 1;
  return gen_peephole2_18 (insn, operands);
}
