/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern7 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V2DFmode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_V2DFmode))
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_V2DFmode))
    return -1;
  x5 = XEXP (x2, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], E_V2DFmode))
    return -1;
  return 0;
}

int
pattern12 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[2] = x2;
  if (!register_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  operands[0] = x4;
  if (!register_operand (operands[0], i1))
    return -1;
  x5 = XEXP (x3, 1);
  operands[1] = x5;
  if (!register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern16 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern19 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern21 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], i1))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], i1))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern25 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 33
      || GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[0] = x4;
  x5 = XVECEXP (x2, 0, 1);
  operands[1] = x5;
  return 0;
}

int
pattern29 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  x5 = XEXP (x1, 1);
  operands[3] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V1QImode:
      return pattern8 (x1, 
E_V1QImode); /* [-1, 0] */

    case E_V2QImode:
      if (pattern8 (x1, 
E_V2QImode) != 0)
        return -1;
      return 1;

    case E_V4QImode:
      if (pattern8 (x1, 
E_V4QImode) != 0)
        return -1;
      return 2;

    case E_V8QImode:
      if (pattern8 (x1, 
E_V8QImode) != 0)
        return -1;
      return 3;

    case E_V16QImode:
      if (pattern8 (x1, 
E_V16QImode) != 0)
        return -1;
      return 4;

    case E_V1HImode:
      if (pattern8 (x1, 
E_V1HImode) != 0)
        return -1;
      return 5;

    case E_V2HImode:
      if (pattern8 (x1, 
E_V2HImode) != 0)
        return -1;
      return 6;

    case E_V4HImode:
      if (pattern8 (x1, 
E_V4HImode) != 0)
        return -1;
      return 7;

    case E_V8HImode:
      if (pattern8 (x1, 
E_V8HImode) != 0)
        return -1;
      return 8;

    case E_V1SImode:
      if (pattern8 (x1, 
E_V1SImode) != 0)
        return -1;
      return 9;

    case E_V2SImode:
      if (pattern8 (x1, 
E_V2SImode) != 0)
        return -1;
      return 10;

    case E_V4SImode:
      if (pattern8 (x1, 
E_V4SImode) != 0)
        return -1;
      return 11;

    case E_V1DImode:
      if (pattern8 (x1, 
E_V1DImode) != 0)
        return -1;
      return 12;

    case E_V2DImode:
      if (pattern8 (x1, 
E_V2DImode) != 0)
        return -1;
      return 13;

    case E_V1TImode:
      if (pattern8 (x1, 
E_V1TImode) != 0)
        return -1;
      return 14;

    case E_TImode:
      if (pattern8 (x1, 
E_TImode) != 0)
        return -1;
      return 15;

    default:
      return -1;
    }
}

int
pattern45 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[2] = x2;
  if (!cc_reg_operand (operands[2], E_VOIDmode))
    return -1;
  x3 = XEXP (x1, 1);
  operands[3] = x3;
  if (!const_int_operand (operands[3], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || !s390_comparison (operands[1], E_DImode))
        return -1;
      return 0;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || !s390_comparison (operands[1], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern53 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i2)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern58 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  x3 = XVECEXP (x1, 0, 1);
  operands[2] = x3;
  x4 = XVECEXP (x1, 0, 2);
  operands[3] = x4;
  if (!const_mask_operand (operands[3], E_QImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SFmode:
      return pattern19 (x1, 
E_V4SFmode); /* [-1, 0] */

    case E_V2DFmode:
      if (pattern19 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 1;

    case E_V1TFmode:
      if (pattern19 (x1, 
E_V1TFmode) != 0)
        return -1;
      return 2;

    case E_TFmode:
      if (pattern19 (x1, 
E_TFmode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern64 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern68 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != i1
      || GET_MODE (x3) != E_CCRAWmode)
    return -1;
  x4 = XEXP (x2, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 33
      || GET_MODE (x4) != E_CCRAWmode)
    return -1;
  x5 = XVECEXP (x1, 0, 0);
  x6 = XEXP (x5, 0);
  operands[0] = x6;
  x7 = XEXP (x5, 1);
  x8 = XVECEXP (x7, 0, 0);
  operands[1] = x8;
  x9 = XVECEXP (x7, 0, 1);
  operands[2] = x9;
  x10 = XVECEXP (x7, 0, 2);
  operands[3] = x10;
  return 0;
}

int
pattern78 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != LABEL_REF)
    return -1;
  x5 = XEXP (x3, 2);
  if (GET_CODE (x5) != PC)
    return -1;
  x6 = XEXP (x2, 0);
  if (GET_CODE (x6) != PC)
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x7) != SET)
    return -1;
  x8 = XEXP (x7, 1);
  if (GET_CODE (x8) != PLUS)
    return -1;
  x9 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x9) != CLOBBER)
    return -1;
  x10 = XVECEXP (x1, 0, 3);
  x11 = XEXP (x10, 0);
  if (GET_CODE (x11) != REG
      || REGNO (x11) != 33
      || GET_MODE (x11) != E_CCmode)
    return -1;
  x12 = XEXP (x4, 0);
  operands[0] = x12;
  x13 = XEXP (x3, 0);
  switch (GET_CODE (x13))
    {
    case GT:
    case LE:
      operands[5] = x13;
      if (!s390_brx_operator (operands[5], E_VOIDmode))
        return -1;
      x14 = XEXP (x13, 0);
      if (GET_CODE (x14) != PLUS)
        return -1;
      x15 = XEXP (x14, 1);
      if (GET_CODE (x15) != SUBREG)
        return -1;
      x16 = XEXP (x13, 1);
      if (GET_CODE (x16) != SUBREG)
        return -1;
      x17 = XEXP (x8, 1);
      if (GET_CODE (x17) != SUBREG)
        return -1;
      x18 = XEXP (x14, 0);
      operands[1] = x18;
      x19 = XEXP (x15, 0);
      operands[2] = x19;
      x20 = XEXP (x7, 0);
      operands[3] = x20;
      x21 = XEXP (x9, 0);
      operands[4] = x21;
      x22 = XEXP (x16, 0);
      if (!rtx_equal_p (x22, operands[2]))
        return -1;
      x23 = XEXP (x8, 0);
      if (!rtx_equal_p (x23, operands[1]))
        return -1;
      x24 = XEXP (x17, 0);
      if (!rtx_equal_p (x24, operands[2]))
        return -1;
      switch (SUBREG_BYTE (x15))
        {
        case 0:
          if (maybe_ne (SUBREG_BYTE (x17), 0))
            return -1;
          switch (SUBREG_BYTE (x16))
            {
            case 8:
              return pattern76 (x1, 
E_DImode, 
E_TImode); /* [-1, 0] */

            case 4:
              if (pattern76 (x1, 
E_SImode, 
E_DImode) != 0)
                return -1;
              return 1;

            default:
              return -1;
            }

        case 4:
          if (GET_MODE (x15) != E_SImode
              || maybe_ne (SUBREG_BYTE (x16), 12)
              || GET_MODE (x16) != E_SImode
              || maybe_ne (SUBREG_BYTE (x17), 4)
              || GET_MODE (x17) != E_SImode
              || GET_MODE (x14) != E_SImode
              || !register_operand (operands[1], E_SImode)
              || !register_operand (operands[2], E_TImode)
              || !nonimmediate_operand (operands[3], E_SImode)
              || GET_MODE (x8) != E_SImode
              || !scratch_operand (operands[4], E_SImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case NE:
      x16 = XEXP (x13, 1);
      if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x17 = XEXP (x8, 1);
      if (x17 != const_int_rtx[MAX_SAVED_CONST_INT + -1])
        return -1;
      x14 = XEXP (x13, 0);
      operands[1] = x14;
      x20 = XEXP (x7, 0);
      operands[2] = x20;
      x21 = XEXP (x9, 0);
      operands[3] = x21;
      x23 = XEXP (x8, 0);
      if (!rtx_equal_p (x23, operands[1]))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_SImode:
          if (pattern77 (x8, 
E_SImode) != 0)
            return -1;
          return 3;

        case E_DImode:
          if (pattern77 (x8, 
E_DImode) != 0)
            return -1;
          return 4;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern129 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != CONST_INT)
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x3) != CONST_INT)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  x5 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  x6 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x6) != CONST_INT)
    return -1;
  x7 = XVECEXP (x1, 0, 5);
  if (GET_CODE (x7) != CONST_INT)
    return -1;
  x8 = XVECEXP (x1, 0, 6);
  if (GET_CODE (x8) != CONST_INT)
    return -1;
  x9 = XVECEXP (x1, 0, 7);
  if (GET_CODE (x9) != CONST_INT)
    return -1;
  return 0;
}

int
pattern139 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1))
    return -1;
  x2 = XEXP (x1, 2);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern147 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  x6 = XEXP (x4, 1);
  operands[2] = x6;
  x7 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x7))
    {
    case SET:
      x8 = XEXP (x7, 1);
      if (GET_CODE (x8) != i1)
        return -1;
      x9 = XEXP (x7, 0);
      operands[0] = x9;
      x10 = XEXP (x8, 0);
      if (!rtx_equal_p (x10, operands[1]))
        return -1;
      x11 = XEXP (x8, 1);
      if (!rtx_equal_p (x11, operands[2]))
        return -1;
      switch (GET_MODE (x4))
        {
        case E_DImode:
          return pattern145 (x8, 
E_DImode); /* [-1, 0] */

        case E_SImode:
          if (pattern145 (x8, 
E_SImode) != 0)
            return -1;
          return 1;

        default:
          return -1;
        }

    case CLOBBER:
      res = pattern146 (x1);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern157 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x2, 2);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern164 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      if (!nonimmediate_operand (operands[0], E_V8HImode)
          || GET_MODE (x1) != E_V8HImode
          || !nonimmediate_operand (operands[1], E_V8HImode))
        return -1;
      return 0;

    case E_V4SImode:
      if (!nonimmediate_operand (operands[0], E_V4SImode)
          || GET_MODE (x1) != E_V4SImode
          || !nonimmediate_operand (operands[1], E_V4SImode))
        return -1;
      return 1;

    case E_V4SFmode:
      if (!nonimmediate_operand (operands[0], E_V4SFmode)
          || GET_MODE (x1) != E_V4SFmode
          || !nonimmediate_operand (operands[1], E_V4SFmode))
        return -1;
      return 2;

    case E_V2DImode:
      if (!nonimmediate_operand (operands[0], E_V2DImode)
          || GET_MODE (x1) != E_V2DImode
          || !nonimmediate_operand (operands[1], E_V2DImode))
        return -1;
      return 3;

    case E_V2DFmode:
      if (!nonimmediate_operand (operands[0], E_V2DFmode)
          || GET_MODE (x1) != E_V2DFmode
          || !nonimmediate_operand (operands[1], E_V2DFmode))
        return -1;
      return 4;

    case E_V1TImode:
      if (!nonimmediate_operand (operands[0], E_V1TImode)
          || GET_MODE (x1) != E_V1TImode
          || !nonimmediate_operand (operands[1], E_V1TImode))
        return -1;
      return 5;

    case E_V1TFmode:
      if (!nonimmediate_operand (operands[0], E_V1TFmode)
          || GET_MODE (x1) != E_V1TFmode
          || !nonimmediate_operand (operands[1], E_V1TFmode))
        return -1;
      return 6;

    case E_TImode:
      if (!nonimmediate_operand (operands[0], E_TImode)
          || GET_MODE (x1) != E_TImode
          || !nonimmediate_operand (operands[1], E_TImode))
        return -1;
      return 7;

    case E_TFmode:
      if (!nonimmediate_operand (operands[0], E_TFmode)
          || GET_MODE (x1) != E_TFmode
          || !nonimmediate_operand (operands[1], E_TFmode))
        return -1;
      return 8;

    default:
      return -1;
    }
}

int
pattern189 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !contiguous_bitmask_operand (operands[2], i1)
      || !nonimmediate_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern197 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != PARALLEL
      || XVECLEN (x1, 0) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x3) != USE)
    return -1;
  return 0;
}

int
pattern201 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !immediate_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !nonimmediate_operand (operands[3], i1)
      || !nonzero_shift_count_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern208 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[3], i2)
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern218 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  x4 = XEXP (x2, 0);
  if (!rtx_equal_p (x4, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      return pattern217 (x1, 
E_DImode); /* [-1, 0] */

    case E_SImode:
      if (pattern217 (x1, 
E_SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern230 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  x7 = XEXP (x5, 1);
  operands[2] = x7;
  x8 = XEXP (x4, 1);
  operands[3] = x8;
  x9 = XEXP (x3, 1);
  x10 = XEXP (x9, 0);
  operands[0] = x10;
  x11 = XVECEXP (x1, 0, 1);
  x12 = XEXP (x11, 0);
  operands[4] = x12;
  x13 = XVECEXP (x1, 0, 2);
  x14 = XEXP (x13, 0);
  operands[5] = x14;
  x15 = XEXP (x11, 1);
  x16 = XEXP (x15, 0);
  if (!rtx_equal_p (x16, operands[1]))
    return -1;
  x17 = XEXP (x15, 1);
  if (!rtx_equal_p (x17, operands[2]))
    return -1;
  switch (GET_MODE (x5))
    {
    case E_DImode:
      return pattern229 (x15, 
E_DImode); /* [-1, 0] */

    case E_SImode:
      if (pattern229 (x15, 
E_SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern249 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1)
      || !s390_slb_comparison (operands[3], i1))
    return -1;
  return 0;
}

int
pattern257 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !register_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[2], i1))
    return -1;
  x4 = XEXP (x1, 1);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern267 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2
      || !register_operand (operands[1], i1))
    return -1;
  x5 = XEXP (x1, 1);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[0], i1))
    return -1;
  return 0;
}

int
pattern275 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1)
      || !nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern280 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern286 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !nonimmediate_operand (operands[1], i1)
      || pattern285 (x1, 
i1, 
i2) != 0)
    return -1;
  return 0;
}

int
pattern294 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != UNSPEC
      || XVECLEN (x4, 0) != 1
      || XINT (x4, 1) != 4
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XVECEXP (x1, 0, 0);
  x6 = XEXP (x5, 1);
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 0);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 0);
  x11 = XVECEXP (x10, 0, 0);
  operands[1] = x11;
  if (!register_operand (operands[1], E_CCUmode))
    return -1;
  return 0;
}

 int
recog_5 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern23 (x1))
    {
    case 0:
      if (!
#line 1118 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 267; /* vec_sralv16qiv16qi */

    case 1:
      if (!
#line 1118 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 277; /* vec_sralv16qiv8hi */

    case 2:
      if (!
#line 1118 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 287; /* vec_sralv16qiv4si */

    case 3:
      if (!
#line 1118 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 268; /* vec_sralv8hiv16qi */

    case 4:
      if (!
#line 1118 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 278; /* vec_sralv8hiv8hi */

    case 5:
      if (!
#line 1118 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 288; /* vec_sralv8hiv4si */

    case 6:
      if (!
#line 1118 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 269; /* vec_sralv4siv16qi */

    case 7:
      if (!
#line 1118 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 279; /* vec_sralv4siv8hi */

    case 8:
      if (!
#line 1118 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 289; /* vec_sralv4siv4si */

    case 9:
      if (!
#line 1118 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 270; /* vec_sralv2div16qi */

    case 10:
      if (!
#line 1118 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 280; /* vec_sralv2div8hi */

    case 11:
      if (!
#line 1118 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 290; /* vec_sralv2div4si */

    case 12:
      if (!
#line 1118 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 271; /* vec_sralv1tiv16qi */

    case 13:
      if (!
#line 1118 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 281; /* vec_sralv1tiv8hi */

    case 14:
      if (!
#line 1118 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 291; /* vec_sralv1tiv4si */

    case 15:
      if (!
#line 1118 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 272; /* vec_sraltiv16qi */

    case 16:
      if (!
#line 1118 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 282; /* vec_sraltiv8hi */

    case 17:
      if (!
#line 1118 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 292; /* vec_sraltiv4si */

    case 18:
      if (!
#line 1118 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 273; /* vec_sralv4sfv16qi */

    case 19:
      if (!
#line 1118 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 283; /* vec_sralv4sfv8hi */

    case 20:
      if (!
#line 1118 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 293; /* vec_sralv4sfv4si */

    case 21:
      if (!
#line 1118 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 274; /* vec_sralv2dfv16qi */

    case 22:
      if (!
#line 1118 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 284; /* vec_sralv2dfv8hi */

    case 23:
      if (!
#line 1118 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 294; /* vec_sralv2dfv4si */

    case 24:
      if (!
#line 1118 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 275; /* vec_sralv1tfv16qi */

    case 25:
      if (!
#line 1118 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 285; /* vec_sralv1tfv8hi */

    case 26:
      if (!
#line 1118 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 295; /* vec_sralv1tfv4si */

    case 27:
      if (!
#line 1118 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 276; /* vec_sraltfv16qi */

    case 28:
      if (!
#line 1118 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 286; /* vec_sraltfv8hi */

    case 29:
      if (!
#line 1118 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 296; /* vec_sraltfv4si */

    default:
      return -1;
    }
}

 int
recog_21 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != LSHIFTRT
      || GET_MODE (x4) != E_DImode
      || pattern109 (x2, 
E_SImode) != 0
      || !const_int_operand (operands[2], E_SImode))
    return -1;
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  if (!register_operand (operands[3], E_DImode))
    return -1;
  x6 = XEXP (x4, 1);
  operands[4] = x6;
  if (!nonzero_shift_count_operand (operands[4], E_DImode))
    return -1;
  if (
#line 4588 "../../gcc/config/s390/s390.md"
(TARGET_ZEC12
   && UINTVAL (operands[2]) == ~(HOST_WIDE_INT_M1U >> UINTVAL (operands[4]))))
    return 1974; /* *risbgn_sidi_ior_and_lshiftrt */
  if (pnum_clobbers == NULL
      || !
#line 4588 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && UINTVAL (operands[2]) == ~(HOST_WIDE_INT_M1U >> UINTVAL (operands[4]))))
    return -1;
  *pnum_clobbers = 1;
  return 1975; /* *risbg_sidi_ior_and_lshiftrt */
}

 int
recog_24 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  operands[1] = x3;
  switch (GET_CODE (operands[1]))
    {
    case REG:
    case SUBREG:
      x4 = XEXP (x1, 0);
      switch (GET_MODE (x4))
        {
        case E_CCVEQmode:
          if (pnum_clobbers == NULL
              || GET_MODE (x2) != E_CCVEQmode)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V16QImode:
              if (!register_operand (operands[0], E_V16QImode)
                  || !register_operand (operands[1], E_V16QImode)
                  || !
#line 1981 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              *pnum_clobbers = 1;
              return 413; /* *vec_cmpeqv16qi_cconly */

            case E_V8HImode:
              if (!register_operand (operands[0], E_V8HImode)
                  || !register_operand (operands[1], E_V8HImode)
                  || !
#line 1981 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              *pnum_clobbers = 1;
              return 416; /* *vec_cmpeqv8hi_cconly */

            case E_V4SImode:
              if (!register_operand (operands[0], E_V4SImode)
                  || !register_operand (operands[1], E_V4SImode)
                  || !
#line 1981 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              *pnum_clobbers = 1;
              return 419; /* *vec_cmpeqv4si_cconly */

            case E_V2DImode:
              if (!register_operand (operands[0], E_V2DImode)
                  || !register_operand (operands[1], E_V2DImode)
                  || !
#line 1981 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              *pnum_clobbers = 1;
              return 422; /* *vec_cmpeqv2di_cconly */

            case E_V1TImode:
              if (!register_operand (operands[0], E_V1TImode)
                  || !register_operand (operands[1], E_V1TImode)
                  || !(
#line 1981 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 51 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
                return -1;
              *pnum_clobbers = 1;
              return 425; /* *vec_cmpeqv1ti_cconly */

            case E_TImode:
              if (!register_operand (operands[0], E_TImode)
                  || !register_operand (operands[1], E_TImode)
                  || !(
#line 1981 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 51 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
                return -1;
              *pnum_clobbers = 1;
              return 428; /* *vec_cmpeqti_cconly */

            case E_V4SFmode:
              if (!register_operand (operands[0], E_V4SFmode)
                  || !register_operand (operands[1], E_V4SFmode)
                  || !(
#line 2064 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 87 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              *pnum_clobbers = 1;
              return 449; /* *vec_cmpeqv4sf_cconly */

            case E_V2DFmode:
              if (!register_operand (operands[0], E_V2DFmode)
                  || !register_operand (operands[1], E_V2DFmode)
                  || !
#line 2064 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              *pnum_clobbers = 1;
              return 450; /* *vec_cmpeqv2df_cconly */

            case E_V1TFmode:
              if (!register_operand (operands[0], E_V1TFmode)
                  || !register_operand (operands[1], E_V1TFmode)
                  || !(
#line 2064 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 87 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              *pnum_clobbers = 1;
              return 451; /* *vec_cmpeqv1tf_cconly */

            case E_TFmode:
              if (!register_operand (operands[0], E_TFmode)
                  || !register_operand (operands[1], E_TFmode)
                  || !(
#line 2064 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 88 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              *pnum_clobbers = 1;
              return 452; /* *vec_cmpeqtf_cconly */

            default:
              return -1;
            }

        case E_CCVIHmode:
          switch (pattern167 (x2, pnum_clobbers, 
E_CCVIHmode))
            {
            case 0:
              if (!
#line 1981 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              *pnum_clobbers = 1;
              return 414; /* *vec_cmphv16qi_cconly */

            case 1:
              if (!
#line 1981 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              *pnum_clobbers = 1;
              return 417; /* *vec_cmphv8hi_cconly */

            case 2:
              if (!
#line 1981 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              *pnum_clobbers = 1;
              return 420; /* *vec_cmphv4si_cconly */

            case 3:
              if (!
#line 1981 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              *pnum_clobbers = 1;
              return 423; /* *vec_cmphv2di_cconly */

            case 4:
              if (!(
#line 1981 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 51 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
                return -1;
              *pnum_clobbers = 1;
              return 426; /* *vec_cmphv1ti_cconly */

            case 5:
              if (!(
#line 1981 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 51 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
                return -1;
              *pnum_clobbers = 1;
              return 429; /* *vec_cmphti_cconly */

            default:
              return -1;
            }

        case E_CCVIHUmode:
          switch (pattern167 (x2, pnum_clobbers, 
E_CCVIHUmode))
            {
            case 0:
              if (!
#line 1981 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              *pnum_clobbers = 1;
              return 415; /* *vec_cmphlv16qi_cconly */

            case 1:
              if (!
#line 1981 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              *pnum_clobbers = 1;
              return 418; /* *vec_cmphlv8hi_cconly */

            case 2:
              if (!
#line 1981 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              *pnum_clobbers = 1;
              return 421; /* *vec_cmphlv4si_cconly */

            case 3:
              if (!
#line 1981 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              *pnum_clobbers = 1;
              return 424; /* *vec_cmphlv2di_cconly */

            case 4:
              if (!(
#line 1981 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 51 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
                return -1;
              *pnum_clobbers = 1;
              return 427; /* *vec_cmphlv1ti_cconly */

            case 5:
              if (!(
#line 1981 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 51 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
                return -1;
              *pnum_clobbers = 1;
              return 430; /* *vec_cmphlti_cconly */

            default:
              return -1;
            }

        case E_CCVFHmode:
          switch (pattern168 (x2, pnum_clobbers, 
E_CCVFHmode))
            {
            case 0:
              if (!(
#line 2064 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 87 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              *pnum_clobbers = 1;
              return 453; /* *vec_cmphv4sf_cconly */

            case 1:
              if (!
#line 2064 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              *pnum_clobbers = 1;
              return 454; /* *vec_cmphv2df_cconly */

            case 2:
              if (!(
#line 2064 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 87 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              *pnum_clobbers = 1;
              return 455; /* *vec_cmphv1tf_cconly */

            case 3:
              if (!(
#line 2064 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 88 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              *pnum_clobbers = 1;
              return 456; /* *vec_cmphtf_cconly */

            default:
              return -1;
            }

        case E_CCVFHEmode:
          switch (pattern168 (x2, pnum_clobbers, 
E_CCVFHEmode))
            {
            case 0:
              if (!(
#line 2064 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 87 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              *pnum_clobbers = 1;
              return 457; /* *vec_cmphev4sf_cconly */

            case 1:
              if (!
#line 2064 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              *pnum_clobbers = 1;
              return 458; /* *vec_cmphev2df_cconly */

            case 2:
              if (!(
#line 2064 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 87 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              *pnum_clobbers = 1;
              return 459; /* *vec_cmphev1tf_cconly */

            case 3:
              if (!(
#line 2064 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 88 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              *pnum_clobbers = 1;
              return 460; /* *vec_cmphetf_cconly */

            default:
              return -1;
            }

        case E_CCSmode:
          if (GET_MODE (x2) != E_CCSmode
              || !register_operand (operands[0], E_TImode)
              || !register_operand (operands[1], E_TImode)
              || !
#line 2238 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1351; /* *vec_cmpti_ccs */

        case E_CCUmode:
          if (GET_MODE (x2) != E_CCUmode
              || !register_operand (operands[0], E_TImode)
              || !register_operand (operands[1], E_TImode)
              || !
#line 2238 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1352; /* *vec_cmpti_ccu */

        case E_CCZmode:
          if (GET_MODE (x2) != E_CCZmode
              || !register_operand (operands[0], E_TImode)
              || !register_operand (operands[1], E_TImode)
              || !
#line 2238 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1353; /* *vec_cmpti_ccz */

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (register_operand (operands[0], E_HImode)
              && immediate_operand (operands[1], E_HImode)
              && 
#line 1062 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, s390_tm_ccmode (constm1_rtx, operands[1], true))))
            return 1742; /* *tmhi_full */
          if (pnum_clobbers != NULL
              && nonimmediate_operand (operands[0], E_HImode)
              && const0_operand (operands[1], E_HImode)
              && 
#line 1215 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCTmode)))
            {
              *pnum_clobbers = 1;
              return 1757; /* *tsthiCCT_cconly */
            }
          if (!s_operand (operands[0], E_HImode))
            return -1;
          if (pnum_clobbers != NULL
              && const0_operand (operands[1], E_HImode)
              && 
#line 1256 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode)))
            {
              *pnum_clobbers = 1;
              return 1761; /* *tsthi_cconly */
            }
          if (!immediate_operand (operands[1], E_HImode)
              || !
#line 1335 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode) && TARGET_Z10))
            return -1;
          return 1767; /* *cmphi_ccs_z10 */

        case E_QImode:
          if (register_operand (operands[0], E_QImode)
              && immediate_operand (operands[1], E_QImode)
              && 
#line 1062 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, s390_tm_ccmode (constm1_rtx, operands[1], true))))
            return 1743; /* *tmqi_full */
          if (!const0_operand (operands[1], E_QImode))
            return -1;
          if (nonimmediate_operand (operands[0], E_QImode)
              && 
#line 1228 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCTmode)))
            return 1758; /* *tstqiCCT_cconly */
          if (pnum_clobbers == NULL
              || !s_operand (operands[0], E_QImode)
              || !
#line 1256 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode)))
            return -1;
          *pnum_clobbers = 1;
          return 1762; /* *tstqi_cconly */

        case E_DImode:
          if (pnum_clobbers != NULL
              && nonimmediate_operand (operands[0], E_DImode)
              && const0_operand (operands[1], E_DImode)
              && (
#line 1127 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode) && TARGET_EXTIMM) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            {
              *pnum_clobbers = 1;
              return 1747; /* *tstdi_cconly_extimm */
            }
          if (!register_operand (operands[0], E_DImode)
              || !const0_operand (operands[1], E_DImode))
            return -1;
          if (
#line 1178 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode) && !TARGET_ZARCH))
            return 1752; /* *tstdi_cconly_31 */
          if (!(
#line 1188 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 1753; /* *tstdi_cconly2 */

        case E_SImode:
          if (pnum_clobbers != NULL
              && nonimmediate_operand (operands[0], E_SImode)
              && const0_operand (operands[1], E_SImode))
            {
              if (
#line 1127 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode) && TARGET_EXTIMM))
                {
                  *pnum_clobbers = 1;
                  return 1748; /* *tstsi_cconly_extimm */
                }
              if (
#line 1165 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode)))
                {
                  *pnum_clobbers = 1;
                  return 1751; /* *tstsi_cconly */
                }
            }
          if (!register_operand (operands[0], E_SImode)
              || !const0_operand (operands[1], E_SImode)
              || !
#line 1188 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode)))
            return -1;
          return 1754; /* *tstsi_cconly2 */

        case E_TFmode:
          if (!register_operand (operands[0], E_TFmode)
              || !const0_operand (operands[1], E_TFmode)
              || !(
#line 1571 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode)
   && TARGET_HARD_FLOAT
   && !flag_trapping_math
   && !flag_signaling_nans) && 
#line 751 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          return 1787; /* *cmptf_ccs_0_fastmath */

        case E_FPRX2mode:
          if (!register_operand (operands[0], E_FPRX2mode)
              || !const0_operand (operands[1], E_FPRX2mode)
              || !(
#line 1571 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode)
   && TARGET_HARD_FLOAT
   && !flag_trapping_math
   && !flag_signaling_nans) && 
#line 751 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          return 1788; /* *cmpfprx2_ccs_0_fastmath */

        case E_DFmode:
          if (!register_operand (operands[0], E_DFmode)
              || !const0_operand (operands[1], E_DFmode)
              || !
#line 1571 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode)
   && TARGET_HARD_FLOAT
   && !flag_trapping_math
   && !flag_signaling_nans))
            return -1;
          return 1789; /* *cmpdf_ccs_0_fastmath */

        case E_SFmode:
          if (!register_operand (operands[0], E_SFmode)
              || !const0_operand (operands[1], E_SFmode)
              || !
#line 1571 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode)
   && TARGET_HARD_FLOAT
   && !flag_trapping_math
   && !flag_signaling_nans))
            return -1;
          return 1790; /* *cmpsf_ccs_0_fastmath */

        case E_TDmode:
          if (!register_operand (operands[0], E_TDmode)
              || !const0_operand (operands[1], E_TDmode)
              || !(
#line 1571 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode)
   && TARGET_HARD_FLOAT
   && !flag_trapping_math
   && !flag_signaling_nans) && 
#line 752 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          return 1791; /* *cmptd_ccs_0_fastmath */

        case E_DDmode:
          if (!register_operand (operands[0], E_DDmode)
              || !const0_operand (operands[1], E_DDmode)
              || !(
#line 1571 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode)
   && TARGET_HARD_FLOAT
   && !flag_trapping_math
   && !flag_signaling_nans) && 
#line 752 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          return 1792; /* *cmpdd_ccs_0_fastmath */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_39 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case NOT:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x5 = XEXP (x3, 0);
      operands[2] = x5;
      x6 = XEXP (x2, 1);
      operands[1] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          if (pattern175 (x2, 
E_V16QImode) != 0
              || !
#line 704 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 118; /* vec_andcv16qi3 */

        case E_V8HImode:
          if (pattern175 (x2, 
E_V8HImode) != 0
              || !
#line 704 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 119; /* vec_andcv8hi3 */

        case E_V4SImode:
          if (pattern175 (x2, 
E_V4SImode) != 0
              || !
#line 704 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 120; /* vec_andcv4si3 */

        case E_V2DImode:
          if (pattern175 (x2, 
E_V2DImode) != 0
              || !
#line 704 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 121; /* vec_andcv2di3 */

        case E_V2DFmode:
          if (pattern175 (x2, 
E_V2DFmode) != 0
              || !
#line 704 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 122; /* vec_andcv2df3 */

        case E_V1TImode:
          if (pattern175 (x2, 
E_V1TImode) != 0
              || !
#line 704 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 123; /* vec_andcv1ti3 */

        case E_TImode:
          if (pattern175 (x2, 
E_TImode) != 0
              || !
#line 704 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 124; /* vec_andcti3 */

        case E_V4SFmode:
          if (pattern175 (x2, 
E_V4SFmode) != 0
              || !(
#line 704 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 47 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 125; /* vec_andcv4sf3 */

        case E_V1TFmode:
          if (pattern175 (x2, 
E_V1TFmode) != 0
              || !(
#line 704 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 47 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 126; /* vec_andcv1tf3 */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
    case MEM:
      x4 = XEXP (x1, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
        case MEM:
          operands[0] = x4;
          operands[1] = x3;
          x6 = XEXP (x2, 1);
          operands[2] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_V1QImode:
              if (pattern0 (x2, 
E_V1QImode) != 0
                  || !
#line 1264 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 772; /* andv1qi3 */

            case E_V2QImode:
              if (pattern0 (x2, 
E_V2QImode) != 0
                  || !
#line 1264 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 773; /* andv2qi3 */

            case E_V4QImode:
              if (pattern0 (x2, 
E_V4QImode) != 0
                  || !
#line 1264 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 774; /* andv4qi3 */

            case E_V8QImode:
              if (pattern0 (x2, 
E_V8QImode) != 0
                  || !
#line 1264 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 775; /* andv8qi3 */

            case E_V16QImode:
              if (pattern0 (x2, 
E_V16QImode) != 0
                  || !
#line 1264 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 776; /* andv16qi3 */

            case E_V1HImode:
              if (pattern0 (x2, 
E_V1HImode) != 0
                  || !
#line 1264 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 777; /* andv1hi3 */

            case E_V2HImode:
              if (pattern0 (x2, 
E_V2HImode) != 0
                  || !
#line 1264 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 778; /* andv2hi3 */

            case E_V4HImode:
              if (pattern0 (x2, 
E_V4HImode) != 0
                  || !
#line 1264 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 779; /* andv4hi3 */

            case E_V8HImode:
              if (pattern0 (x2, 
E_V8HImode) != 0
                  || !
#line 1264 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 780; /* andv8hi3 */

            case E_V1SImode:
              if (pattern0 (x2, 
E_V1SImode) != 0
                  || !
#line 1264 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 781; /* andv1si3 */

            case E_V2SImode:
              if (pattern0 (x2, 
E_V2SImode) != 0
                  || !
#line 1264 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 782; /* andv2si3 */

            case E_V4SImode:
              if (pattern0 (x2, 
E_V4SImode) != 0
                  || !
#line 1264 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 783; /* andv4si3 */

            case E_V1DImode:
              if (pattern0 (x2, 
E_V1DImode) != 0
                  || !
#line 1264 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 784; /* andv1di3 */

            case E_V2DImode:
              if (pattern0 (x2, 
E_V2DImode) != 0
                  || !
#line 1264 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 785; /* andv2di3 */

            case E_V1SFmode:
              if (pattern0 (x2, 
E_V1SFmode) != 0
                  || !
#line 1264 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 786; /* andv1sf3 */

            case E_V2SFmode:
              if (pattern0 (x2, 
E_V2SFmode) != 0
                  || !
#line 1264 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 787; /* andv2sf3 */

            case E_V4SFmode:
              if (pattern0 (x2, 
E_V4SFmode) != 0
                  || !
#line 1264 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 788; /* andv4sf3 */

            case E_V1DFmode:
              if (pattern0 (x2, 
E_V1DFmode) != 0
                  || !
#line 1264 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 789; /* andv1df3 */

            case E_V2DFmode:
              if (pattern0 (x2, 
E_V2DFmode) != 0
                  || !
#line 1264 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 790; /* andv2df3 */

            case E_V1TFmode:
              if (pattern0 (x2, 
E_V1TFmode) != 0
                  || !
#line 1264 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 791; /* andv1tf3 */

            case E_V1TImode:
              if (pattern0 (x2, 
E_V1TImode) != 0
                  || !
#line 1264 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 792; /* andv1ti3 */

            case E_TImode:
              if (pattern0 (x2, 
E_TImode) != 0
                  || !
#line 1264 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 793; /* andti3 */

            case E_HImode:
              if (pnum_clobbers == NULL
                  || pattern64 (x2, 
E_HImode) != 0)
                return -1;
              if (
#line 8153 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
                {
                  *pnum_clobbers = 1;
                  return 2361; /* *andhi3_zarch */
                }
              if (!
#line 8170 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
                return -1;
              *pnum_clobbers = 1;
              return 2362; /* *andhi3_esa */

            case E_QImode:
              if (pnum_clobbers == NULL
                  || pattern64 (x2, 
E_QImode) != 0)
                return -1;
              if (
#line 8198 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
                {
                  *pnum_clobbers = 1;
                  return 2363; /* *andqi3_zarch */
                }
              if (!
#line 8215 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
                return -1;
              *pnum_clobbers = 1;
              return 2364; /* *andqi3_esa */

            default:
              return -1;
            }

        case ZERO_EXTRACT:
          if (pnum_clobbers == NULL
              || pattern141 (x1) != 0)
            return -1;
          x6 = XEXP (x2, 1);
          operands[3] = x6;
          if (!nonimmediate_operand (operands[3], E_DImode)
              || !rtx_equal_p (x3, operands[0])
              || !
#line 4833 "../../gcc/config/s390/s390.md"
(TARGET_Z10
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[1]), INTVAL (operands[2]), 64)
   && INTVAL (operands[1]) + INTVAL (operands[2]) == 64))
            return -1;
          *pnum_clobbers = 1;
          return 2004; /* *insv_rnsbg_noshift */

        default:
          return -1;
        }

    case GE:
      x6 = XEXP (x2, 1);
      if (GET_CODE (x6) != GE)
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x5 = XEXP (x3, 0);
      operands[1] = x5;
      x7 = XEXP (x3, 1);
      operands[2] = x7;
      x8 = XEXP (x6, 0);
      if (!rtx_equal_p (x8, operands[2]))
        return -1;
      x9 = XEXP (x6, 1);
      if (!rtx_equal_p (x9, operands[1]))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V1SImode:
          if (pattern222 (x2, 
E_V1SImode, 
E_V1SFmode) != 0
              || !
#line 2298 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 1375; /* *vec_cmpeqv1sf_signaling_nocc */

        case E_V2SImode:
          if (pattern222 (x2, 
E_V2SImode, 
E_V2SFmode) != 0
              || !
#line 2298 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 1376; /* *vec_cmpeqv2sf_signaling_nocc */

        case E_V4SImode:
          if (pattern222 (x2, 
E_V4SImode, 
E_V4SFmode) != 0
              || !
#line 2298 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 1377; /* *vec_cmpeqv4sf_signaling_nocc */

        case E_V1DImode:
          if (pattern222 (x2, 
E_V1DImode, 
E_V1DFmode) != 0
              || !
#line 2298 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 1378; /* *vec_cmpeqv1df_signaling_nocc */

        case E_V2DImode:
          if (pattern222 (x2, 
E_V2DImode, 
E_V2DFmode) != 0
              || !
#line 2298 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 1379; /* *vec_cmpeqv2df_signaling_nocc */

        case E_V1TImode:
          if (pattern222 (x2, 
E_V1TImode, 
E_V1TFmode) != 0
              || !
#line 2298 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 1380; /* *vec_cmpeqv1tf_signaling_nocc */

        case E_TImode:
          if (pattern222 (x2, 
E_TImode, 
E_TFmode) != 0
              || !
#line 2298 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 1381; /* *vec_cmpeqtf_signaling_nocc */

        default:
          return -1;
        }

    case AND:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      switch (pattern29 (x2))
        {
        case 0:
          if (!
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1579; /* *vevalv1qi_andand */

        case 1:
          if (!
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1588; /* *vevalv2qi_andand */

        case 2:
          if (!
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1597; /* *vevalv4qi_andand */

        case 3:
          if (!
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1606; /* *vevalv8qi_andand */

        case 4:
          if (!
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1615; /* *vevalv16qi_andand */

        case 5:
          if (!
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1624; /* *vevalv1hi_andand */

        case 6:
          if (!
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1633; /* *vevalv2hi_andand */

        case 7:
          if (!
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1642; /* *vevalv4hi_andand */

        case 8:
          if (!
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1651; /* *vevalv8hi_andand */

        case 9:
          if (!
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1660; /* *vevalv1si_andand */

        case 10:
          if (!
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1669; /* *vevalv2si_andand */

        case 11:
          if (!
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1678; /* *vevalv4si_andand */

        case 12:
          if (!
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1687; /* *vevalv1di_andand */

        case 13:
          if (!
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1696; /* *vevalv2di_andand */

        case 14:
          if (!
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1705; /* *vevalv1ti_andand */

        case 15:
          if (!
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1714; /* *vevalti_andand */

        default:
          return -1;
        }

    case IOR:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      switch (pattern29 (x2))
        {
        case 0:
          if (!
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1580; /* *vevalv1qi_andior */

        case 1:
          if (!
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1589; /* *vevalv2qi_andior */

        case 2:
          if (!
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1598; /* *vevalv4qi_andior */

        case 3:
          if (!
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1607; /* *vevalv8qi_andior */

        case 4:
          if (!
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1616; /* *vevalv16qi_andior */

        case 5:
          if (!
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1625; /* *vevalv1hi_andior */

        case 6:
          if (!
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1634; /* *vevalv2hi_andior */

        case 7:
          if (!
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1643; /* *vevalv4hi_andior */

        case 8:
          if (!
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1652; /* *vevalv8hi_andior */

        case 9:
          if (!
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1661; /* *vevalv1si_andior */

        case 10:
          if (!
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1670; /* *vevalv2si_andior */

        case 11:
          if (!
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1679; /* *vevalv4si_andior */

        case 12:
          if (!
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1688; /* *vevalv1di_andior */

        case 13:
          if (!
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1697; /* *vevalv2di_andior */

        case 14:
          if (!
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1706; /* *vevalv1ti_andior */

        case 15:
          if (!
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1715; /* *vevalti_andior */

        default:
          return -1;
        }

    case XOR:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      switch (pattern29 (x2))
        {
        case 0:
          if (!
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1581; /* *vevalv1qi_andxor */

        case 1:
          if (!
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1590; /* *vevalv2qi_andxor */

        case 2:
          if (!
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1599; /* *vevalv4qi_andxor */

        case 3:
          if (!
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1608; /* *vevalv8qi_andxor */

        case 4:
          if (!
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1617; /* *vevalv16qi_andxor */

        case 5:
          if (!
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1626; /* *vevalv1hi_andxor */

        case 6:
          if (!
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1635; /* *vevalv2hi_andxor */

        case 7:
          if (!
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1644; /* *vevalv4hi_andxor */

        case 8:
          if (!
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1653; /* *vevalv8hi_andxor */

        case 9:
          if (!
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1662; /* *vevalv1si_andxor */

        case 10:
          if (!
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1671; /* *vevalv2si_andxor */

        case 11:
          if (!
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1680; /* *vevalv4si_andxor */

        case 12:
          if (!
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1689; /* *vevalv1di_andxor */

        case 13:
          if (!
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1698; /* *vevalv2di_andxor */

        case 14:
          if (!
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1707; /* *vevalv1ti_andxor */

        case 15:
          if (!
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1716; /* *vevalti_andxor */

        default:
          return -1;
        }

    case ASHIFT:
      if (GET_MODE (x3) != E_DImode)
        return -1;
      x5 = XEXP (x3, 0);
      if (GET_CODE (x5) != SUBREG
          || maybe_ne (SUBREG_BYTE (x5), 0)
          || GET_MODE (x5) != E_DImode)
        return -1;
      x10 = XEXP (x5, 0);
      if (GET_CODE (x10) != PLUS
          || GET_MODE (x10) != E_SImode)
        return -1;
      x7 = XEXP (x3, 1);
      if (GET_CODE (x7) != CONST_INT)
        return -1;
      x6 = XEXP (x2, 1);
      if (GET_CODE (x6) != CONST_INT)
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x2) != E_DImode)
        return -1;
      x11 = XEXP (x10, 0);
      operands[1] = x11;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x12 = XEXP (x10, 1);
      operands[2] = x12;
      if (!const_int_operand (operands[2], E_SImode))
        return -1;
      switch (XWINT (x7, 0))
        {
        case 1L:
          if (XWINT (x6, 0) != 8589934590L
              || !
#line 2123 "../../gcc/config/s390/s390.md"
(TARGET_Z17 && TARGET_64BIT && INTVAL (operands[2]) >= -0x80000 && INTVAL (operands[2]) <= 0x7FFFF))
            return -1;
          return 1835; /* *llxah_displacement_index */

        case 2L:
          if (XWINT (x6, 0) != 17179869180L
              || !
#line 2123 "../../gcc/config/s390/s390.md"
(TARGET_Z17 && TARGET_64BIT && INTVAL (operands[2]) >= -0x80000 && INTVAL (operands[2]) <= 0x7FFFF))
            return -1;
          return 1836; /* *llxaf_displacement_index */

        case 3L:
          if (XWINT (x6, 0) != 34359738360L
              || !
#line 2123 "../../gcc/config/s390/s390.md"
(TARGET_Z17 && TARGET_64BIT && INTVAL (operands[2]) >= -0x80000 && INTVAL (operands[2]) <= 0x7FFFF))
            return -1;
          return 1837; /* *llxag_displacement_index */

        case 4L:
          if (XWINT (x6, 0) != 68719476720L
              || !
#line 2123 "../../gcc/config/s390/s390.md"
(TARGET_Z17 && TARGET_64BIT && INTVAL (operands[2]) >= -0x80000 && INTVAL (operands[2]) <= 0x7FFFF))
            return -1;
          return 1838; /* *llxaq_displacement_index */

        default:
          return -1;
        }

    case LSHIFTRT:
      if (pnum_clobbers == NULL
          || GET_MODE (x3) != E_DImode)
        return -1;
      x4 = XEXP (x1, 0);
      if (GET_CODE (x4) != ZERO_EXTRACT
          || pattern141 (x1) != 0)
        return -1;
      x7 = XEXP (x3, 1);
      operands[3] = x7;
      if (!const_int_operand (operands[3], E_VOIDmode))
        return -1;
      x6 = XEXP (x2, 1);
      operands[4] = x6;
      if (!nonimmediate_operand (operands[4], E_DImode))
        return -1;
      x5 = XEXP (x3, 0);
      if (!rtx_equal_p (x5, operands[0])
          || !
#line 4850 "../../gcc/config/s390/s390.md"
(TARGET_Z10
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[1]), INTVAL (operands[2]), 64)
   && INTVAL (operands[3]) == 64 - INTVAL (operands[1]) - INTVAL (operands[2])))
        return -1;
      *pnum_clobbers = 1;
      return 2005; /* *insv_rnsbg_srl */

    default:
      return -1;
    }
}

 int
recog_63 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XVECLEN (x2, 0))
    {
    case 4:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 3);
      operands[4] = x4;
      switch (XINT (x2, 1))
        {
        case 61:
          x5 = XVECEXP (x2, 0, 0);
          operands[1] = x5;
          x6 = XVECEXP (x2, 0, 1);
          operands[2] = x6;
          x7 = XVECEXP (x2, 0, 2);
          operands[3] = x7;
          if (!memory_operand (operands[3], E_BLKmode)
              || !const_mask_operand (operands[4], E_QImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V4SImode:
              if (pattern19 (x2, 
E_V4SImode) != 0
                  || !
#line 83 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && UINTVAL (operands[4]) < GET_MODE_NUNITS (V4SImode)))
                return -1;
              return 1; /* vec_gather_elementv4si */

            case E_V2DImode:
              if (pattern19 (x2, 
E_V2DImode) != 0
                  || !
#line 83 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && UINTVAL (operands[4]) < GET_MODE_NUNITS (V2DImode)))
                return -1;
              return 2; /* vec_gather_elementv2di */

            case E_V2DFmode:
              if (pattern198 (x2, 
E_V2DImode, 
E_V2DFmode) != 0
                  || !
#line 83 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && UINTVAL (operands[4]) < GET_MODE_NUNITS (V2DFmode)))
                return -1;
              return 3; /* vec_gather_elementv2df */

            case E_V4SFmode:
              if (pattern198 (x2, 
E_V4SImode, 
E_V4SFmode) != 0
                  || !(
#line 83 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && UINTVAL (operands[4]) < GET_MODE_NUNITS (V4SFmode)) && 
#line 23 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE)))
                return -1;
              return 4; /* vec_gather_elementv4sf */

            default:
              return -1;
            }

        case 96:
          x5 = XVECEXP (x2, 0, 0);
          operands[1] = x5;
          x6 = XVECEXP (x2, 0, 1);
          operands[2] = x6;
          x7 = XVECEXP (x2, 0, 2);
          operands[3] = x7;
          if (!const_int_operand (operands[4], E_QImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V16QImode:
              if (pattern51 (x2, 
E_V16QImode) != 0
                  || !
#line 1037 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 203; /* verimv16qi */

            case E_V8HImode:
              if (pattern51 (x2, 
E_V8HImode) != 0
                  || !
#line 1037 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 204; /* verimv8hi */

            case E_V4SImode:
              if (pattern51 (x2, 
E_V4SImode) != 0
                  || !
#line 1037 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 205; /* verimv4si */

            case E_V2DImode:
              if (pattern51 (x2, 
E_V2DImode) != 0
                  || !
#line 1037 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 206; /* verimv2di */

            default:
              return -1;
            }

        case 131:
          x5 = XVECEXP (x2, 0, 0);
          operands[1] = x5;
          if (!register_operand (operands[1], E_V2DImode))
            return -1;
          x6 = XVECEXP (x2, 0, 1);
          operands[2] = x6;
          if (!register_operand (operands[2], E_V2DImode))
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          operands[3] = x7;
          if (!const_mask_operand (operands[4], E_QImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V16QImode:
              if (!register_operand (operands[0], E_V16QImode)
                  || GET_MODE (x2) != E_V16QImode
                  || !register_operand (operands[3], E_V16QImode)
                  || !
#line 1258 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE))
                return -1;
              return 357; /* vec_msumv2di */

            case E_TImode:
              if (!register_operand (operands[0], E_TImode)
                  || GET_MODE (x2) != E_TImode
                  || !register_operand (operands[3], E_TImode)
                  || !
#line 1269 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE))
                return -1;
              return 358; /* vmslg */

            default:
              return -1;
            }

        case 118:
          x5 = XVECEXP (x2, 0, 0);
          operands[1] = x5;
          x6 = XVECEXP (x2, 0, 1);
          operands[2] = x6;
          x7 = XVECEXP (x2, 0, 2);
          operands[3] = x7;
          if (!const_mask_operand (operands[4], E_QImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V16QImode:
              if (pattern51 (x2, 
E_V16QImode) != 0
                  || !
#line 1541 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 383; /* vstrcv16qi */

            case E_V8HImode:
              if (pattern51 (x2, 
E_V8HImode) != 0
                  || !
#line 1541 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 384; /* vstrcv8hi */

            case E_V4SImode:
              if (pattern51 (x2, 
E_V4SImode) != 0
                  || !
#line 1541 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 385; /* vstrcv4si */

            default:
              return -1;
            }

        case 135:
          x5 = XVECEXP (x2, 0, 0);
          operands[1] = x5;
          x6 = XVECEXP (x2, 0, 1);
          operands[2] = x6;
          x7 = XVECEXP (x2, 0, 2);
          operands[3] = x7;
          if (!const_int_operand (operands[4], E_QImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V1QImode:
              if (pattern51 (x2, 
E_V1QImode) != 0
                  || !
#line 3451 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                return -1;
              return 1723; /* vevalv1qi */

            case E_V2QImode:
              if (pattern51 (x2, 
E_V2QImode) != 0
                  || !
#line 3451 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                return -1;
              return 1724; /* vevalv2qi */

            case E_V4QImode:
              if (pattern51 (x2, 
E_V4QImode) != 0
                  || !
#line 3451 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                return -1;
              return 1725; /* vevalv4qi */

            case E_V8QImode:
              if (pattern51 (x2, 
E_V8QImode) != 0
                  || !
#line 3451 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                return -1;
              return 1726; /* vevalv8qi */

            case E_V16QImode:
              if (pattern51 (x2, 
E_V16QImode) != 0
                  || !
#line 3451 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                return -1;
              return 1727; /* vevalv16qi */

            case E_V1HImode:
              if (pattern51 (x2, 
E_V1HImode) != 0
                  || !
#line 3451 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                return -1;
              return 1728; /* vevalv1hi */

            case E_V2HImode:
              if (pattern51 (x2, 
E_V2HImode) != 0
                  || !
#line 3451 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                return -1;
              return 1729; /* vevalv2hi */

            case E_V4HImode:
              if (pattern51 (x2, 
E_V4HImode) != 0
                  || !
#line 3451 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                return -1;
              return 1730; /* vevalv4hi */

            case E_V8HImode:
              if (pattern51 (x2, 
E_V8HImode) != 0
                  || !
#line 3451 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                return -1;
              return 1731; /* vevalv8hi */

            case E_V1SImode:
              if (pattern51 (x2, 
E_V1SImode) != 0
                  || !
#line 3451 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                return -1;
              return 1732; /* vevalv1si */

            case E_V2SImode:
              if (pattern51 (x2, 
E_V2SImode) != 0
                  || !
#line 3451 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                return -1;
              return 1733; /* vevalv2si */

            case E_V4SImode:
              if (pattern51 (x2, 
E_V4SImode) != 0
                  || !
#line 3451 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                return -1;
              return 1734; /* vevalv4si */

            case E_V1DImode:
              if (pattern51 (x2, 
E_V1DImode) != 0
                  || !
#line 3451 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                return -1;
              return 1735; /* vevalv1di */

            case E_V2DImode:
              if (pattern51 (x2, 
E_V2DImode) != 0
                  || !
#line 3451 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                return -1;
              return 1736; /* vevalv2di */

            case E_V1TImode:
              if (pattern51 (x2, 
E_V1TImode) != 0
                  || !
#line 3451 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                return -1;
              return 1737; /* vevalv1ti */

            case E_TImode:
              if (pattern51 (x2, 
E_TImode) != 0
                  || !
#line 3451 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                return -1;
              return 1738; /* vevalti */

            default:
              return -1;
            }

        case 31:
          if (pnum_clobbers == NULL)
            return -1;
          x6 = XVECEXP (x2, 0, 1);
          if (GET_CODE (x6) != MEM
              || GET_MODE (x6) != E_BLKmode)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (GET_CODE (x7) != REG
              || REGNO (x7) != 0
              || GET_MODE (x7) != E_SImode)
            return -1;
          x5 = XVECEXP (x2, 0, 0);
          operands[2] = x5;
          x8 = XEXP (x6, 0);
          operands[3] = x8;
          if (!immediate_operand (operands[4], E_VOIDmode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (pattern251 (x2, 
E_DImode) != 0
                  || !
#line 778 "../../gcc/config/s390/s390.md"
(TARGET_64BIT))
                return -1;
              *pnum_clobbers = 2;
              return 1886; /* *strlendi */

            case E_SImode:
              if (pattern251 (x2, 
E_SImode) != 0
                  || !
#line 778 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT))
                return -1;
              *pnum_clobbers = 2;
              return 1887; /* *strlensi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 1:
      return recog_17 (x1, insn, pnum_clobbers);

    case 2:
      return recog_16 (x1, insn, pnum_clobbers);

    case 3:
      return recog_18 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_71 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x3) != E_V2DFmode
          || !register_operand (operands[1], E_V2DImode)
          || !
#line 3002 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1533; /* floatunsv2div2df2 */

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !register_operand (operands[1], E_V4SImode)
          || !(
#line 3002 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 99 "../../gcc/config/s390/vector.md"
(TARGET_VXE2)))
        return -1;
      return 1534; /* floatunsv4siv4sf2 */

    case E_DFmode:
      switch (pattern67 (x3, 
E_DFmode))
        {
        case 0:
          if (
#line 5671 "../../gcc/config/s390/s390.md"
(TARGET_VX && TARGET_HARD_FLOAT))
            return 2082; /* *floatunsdidf2_z13 */
          if (!(
#line 5683 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
   && (!TARGET_VX || DFmode != DFmode || DImode != DImode)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 2088; /* *floatunsdidf2 */

        case 1:
          if (!
#line 5683 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
   && (!TARGET_VX || DFmode != DFmode || SImode != DImode)))
            return -1;
          return 2089; /* *floatunssidf2 */

        default:
          return -1;
        }

    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          if ((
#line 5671 "../../gcc/config/s390/s390.md"
(TARGET_VX && TARGET_HARD_FLOAT) && 
#line 767 "../../gcc/config/s390/s390.md"
(TARGET_VXE2)))
            return 2083; /* *floatunssisf2_z13 */
          if (!
#line 5683 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
   && (!TARGET_VX || SFmode != DFmode || SImode != DImode)))
            return -1;
          return 2091; /* *floatunssisf2 */

        case E_DImode:
          if (!register_operand (operands[1], E_DImode)
              || !(
#line 5683 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
   && (!TARGET_VX || SFmode != DFmode || DImode != DImode)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 2090; /* *floatunsdisf2 */

        default:
          return -1;
        }

    case E_TFmode:
      switch (pattern67 (x3, 
E_TFmode))
        {
        case 0:
          if (!(
#line 5683 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
   && (!TARGET_VX || TFmode != DFmode || DImode != DImode)) && (
#line 751 "../../gcc/config/s390/s390.md"
(!TARGET_VXE) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))))
            return -1;
          return 2084; /* *floatunsditf2 */

        case 1:
          if (!(
#line 5683 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
   && (!TARGET_VX || TFmode != DFmode || SImode != DImode)) && 
#line 751 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          return 2085; /* *floatunssitf2 */

        default:
          return -1;
        }

    case E_FPRX2mode:
      switch (pattern67 (x3, 
E_FPRX2mode))
        {
        case 0:
          if (!(
#line 5683 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
   && (!TARGET_VX || FPRX2mode != DFmode || DImode != DImode)) && (
#line 751 "../../gcc/config/s390/s390.md"
(TARGET_VXE) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))))
            return -1;
          return 2086; /* *floatunsdifprx22 */

        case 1:
          if (!(
#line 5683 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
   && (!TARGET_VX || FPRX2mode != DFmode || SImode != DImode)) && 
#line 751 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          return 2087; /* *floatunssifprx22 */

        default:
          return -1;
        }

    case E_TDmode:
      switch (pattern67 (x3, 
E_TDmode))
        {
        case 0:
          if (!(
#line 5683 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
   && (!TARGET_VX || TDmode != DFmode || DImode != DImode)) && (
#line 752 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))))
            return -1;
          return 2092; /* *floatunsditd2 */

        case 1:
          if (!(
#line 5683 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
   && (!TARGET_VX || TDmode != DFmode || SImode != DImode)) && 
#line 752 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          return 2093; /* *floatunssitd2 */

        default:
          return -1;
        }

    case E_DDmode:
      switch (pattern67 (x3, 
E_DDmode))
        {
        case 0:
          if (!(
#line 5683 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
   && (!TARGET_VX || DDmode != DFmode || DImode != DImode)) && (
#line 752 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))))
            return -1;
          return 2094; /* *floatunsdidd2 */

        case 1:
          if (!(
#line 5683 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
   && (!TARGET_VX || DDmode != DFmode || SImode != DImode)) && 
#line 752 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          return 2095; /* *floatunssidd2 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_86 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case ZERO_EXTEND:
      if (GET_MODE (x5) != E_DImode)
        return -1;
      x6 = XEXP (x3, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || GET_MODE (x4) != E_DImode)
        return -1;
      x7 = XEXP (x5, 0);
      operands[2] = x7;
      if (!general_operand (operands[2], E_SImode))
        return -1;
      x8 = XEXP (x4, 1);
      operands[1] = x8;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      x9 = XVECEXP (x1, 0, 1);
      switch (GET_CODE (x9))
        {
        case SET:
          x10 = XEXP (x9, 1);
          if (pattern253 (x10, 
ZERO_EXTEND, 
PLUS) != 0)
            return -1;
          x11 = XEXP (x9, 0);
          operands[0] = x11;
          if (!register_operand (operands[0], E_DImode))
            return -1;
          x12 = XEXP (x10, 0);
          x13 = XEXP (x12, 0);
          if (!rtx_equal_p (x13, operands[2]))
            return -1;
          x14 = XEXP (x10, 1);
          if (!rtx_equal_p (x14, operands[1])
              || !
#line 6126 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCLmode) && TARGET_ZARCH))
            return -1;
          return 2198; /* *adddi3_zero_cc */

        case CLOBBER:
          x11 = XEXP (x9, 0);
          operands[0] = x11;
          if (!scratch_operand (operands[0], E_DImode)
              || !
#line 6139 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCLmode) && TARGET_ZARCH))
            return -1;
          return 2199; /* *adddi3_zero_cconly */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x5;
      x8 = XEXP (x4, 1);
      operands[2] = x8;
      x9 = XVECEXP (x1, 0, 1);
      switch (GET_CODE (x9))
        {
        case SET:
          res = recog_82 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case CLOBBER:
          x11 = XEXP (x9, 0);
          operands[0] = x11;
          switch (GET_MODE (x4))
            {
            case E_DImode:
              if (nonimmediate_operand (operands[1], E_DImode)
                  && general_operand (operands[2], E_DImode)
                  && scratch_operand (operands[0], E_DImode))
                {
                  x6 = XEXP (x3, 1);
                  if (rtx_equal_p (x6, operands[1])
                      && (
#line 6265 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL1mode)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return 2207; /* *adddi3_carry1_cconly */
                  if (rtx_equal_p (x6, operands[2])
                      && (
#line 6305 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL1mode)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return 2211; /* *adddi3_carry2_cconly */
                }
              break;

            case E_SImode:
              if (nonimmediate_operand (operands[1], E_SImode)
                  && general_operand (operands[2], E_SImode)
                  && scratch_operand (operands[0], E_SImode))
                {
                  x6 = XEXP (x3, 1);
                  if (rtx_equal_p (x6, operands[1])
                      && 
#line 6265 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL1mode)))
                    return 2208; /* *addsi3_carry1_cconly */
                  if (rtx_equal_p (x6, operands[2])
                      && 
#line 6305 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL1mode)))
                    return 2212; /* *addsi3_carry2_cconly */
                }
              break;

            case E_TFmode:
              x6 = XEXP (x3, 1);
              if (pattern225 (x6, 
E_TFmode) == 0
                  && (
#line 6526 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 751 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return 2238; /* *addtf3_cconly */
              break;

            case E_FPRX2mode:
              x6 = XEXP (x3, 1);
              if (pattern225 (x6, 
E_FPRX2mode) == 0
                  && (
#line 6526 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 751 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return 2239; /* *addfprx23_cconly */
              break;

            case E_DFmode:
              x6 = XEXP (x3, 1);
              if (pattern225 (x6, 
E_DFmode) == 0
                  && 
#line 6526 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
                return 2240; /* *adddf3_cconly */
              break;

            case E_SFmode:
              x6 = XEXP (x3, 1);
              if (pattern225 (x6, 
E_SFmode) == 0
                  && 
#line 6526 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
                return 2241; /* *addsf3_cconly */
              break;

            case E_TDmode:
              x6 = XEXP (x3, 1);
              if (pattern225 (x6, 
E_TDmode) == 0
                  && (
#line 6526 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 752 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
                return 2242; /* *addtd3_cconly */
              break;

            case E_DDmode:
              x6 = XEXP (x3, 1);
              if (pattern225 (x6, 
E_DDmode) == 0
                  && (
#line 6526 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 752 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
                return 2243; /* *adddd3_cconly */
              break;

            default:
              break;
            }
          break;

        default:
          break;
        }
      x6 = XEXP (x3, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      switch (GET_CODE (x9))
        {
        case SET:
          x10 = XEXP (x9, 1);
          if (GET_CODE (x10) != PLUS)
            return -1;
          x11 = XEXP (x9, 0);
          operands[0] = x11;
          x12 = XEXP (x10, 0);
          if (!rtx_equal_p (x12, operands[1]))
            return -1;
          x14 = XEXP (x10, 1);
          if (!rtx_equal_p (x14, operands[2]))
            return -1;
          switch (GET_MODE (x4))
            {
            case E_DImode:
              if (!nonimmediate_operand (operands[1], E_DImode)
                  || !nonimmediate_operand (operands[0], E_DImode)
                  || GET_MODE (x10) != E_DImode)
                return -1;
              if (general_operand (operands[2], E_DImode)
                  && (
#line 6323 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCLmode)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return 2213; /* *adddi3_cc */
              if (!const_int_operand (operands[2], E_DImode)
                  || !(
#line 6379 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCAmode)
   && (CONST_OK_FOR_CONSTRAINT_P (INTVAL (operands[2]), 'K', "K")
       || (CONST_OK_FOR_CONSTRAINT_P (INTVAL (operands[2]), 'O', "Os")
           /* Avoid INT32_MIN on 32 bit.  */
           && (!TARGET_ZARCH || INTVAL (operands[2]) != -0x7fffffff - 1)))) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              return 2219; /* *adddi3_imm_cc */

            case E_SImode:
              if (!nonimmediate_operand (operands[1], E_SImode)
                  || !nonimmediate_operand (operands[0], E_SImode)
                  || GET_MODE (x10) != E_SImode)
                return -1;
              if (general_operand (operands[2], E_SImode)
                  && 
#line 6323 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCLmode)))
                return 2214; /* *addsi3_cc */
              if (!const_int_operand (operands[2], E_SImode)
                  || !
#line 6379 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCAmode)
   && (CONST_OK_FOR_CONSTRAINT_P (INTVAL (operands[2]), 'K', "K")
       || (CONST_OK_FOR_CONSTRAINT_P (INTVAL (operands[2]), 'O', "Os")
           /* Avoid INT32_MIN on 32 bit.  */
           && (!TARGET_ZARCH || INTVAL (operands[2]) != -0x7fffffff - 1)))))
                return -1;
              return 2220; /* *addsi3_imm_cc */

            default:
              return -1;
            }

        case CLOBBER:
          switch (pattern146 (x1))
            {
            case 0:
              if (!(
#line 6345 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCLmode)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              return 2215; /* *adddi3_cconly */

            case 1:
              if (!
#line 6345 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCLmode)))
                return -1;
              return 2216; /* *addsi3_cconly */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SIGN_EXTEND:
      x6 = XEXP (x3, 1);
      if (GET_CODE (x6) != SIGN_EXTEND)
        return -1;
      x15 = XEXP (x6, 0);
      if (GET_CODE (x15) != PLUS)
        return -1;
      x9 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x9) != SET)
        return -1;
      x10 = XEXP (x9, 1);
      if (GET_CODE (x10) != PLUS)
        return -1;
      x7 = XEXP (x5, 0);
      operands[1] = x7;
      x11 = XEXP (x9, 0);
      operands[0] = x11;
      x16 = XEXP (x15, 0);
      if (!rtx_equal_p (x16, operands[1]))
        return -1;
      x12 = XEXP (x10, 0);
      if (!rtx_equal_p (x12, operands[1]))
        return -1;
      x8 = XEXP (x4, 1);
      switch (GET_CODE (x8))
        {
        case SIGN_EXTEND:
          x17 = XEXP (x8, 0);
          operands[2] = x17;
          x18 = XEXP (x15, 1);
          if (!rtx_equal_p (x18, operands[2]))
            return -1;
          x14 = XEXP (x10, 1);
          if (!rtx_equal_p (x14, operands[2]))
            return -1;
          switch (GET_MODE (x4))
            {
            case E_TImode:
              if (pattern283 (x1, 
E_DImode, 
E_TImode) != 0
                  || !(
#line 6446 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCOmode)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              return 2222; /* *addvdi3_ccoverflow */

            case E_DImode:
              if (pattern283 (x1, 
E_SImode, 
E_DImode) != 0
                  || !
#line 6446 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCOmode)))
                return -1;
              return 2223; /* *addvsi3_ccoverflow */

            default:
              return -1;
            }

        case CONST_INT:
          operands[2] = x8;
          x18 = XEXP (x15, 1);
          if (!rtx_equal_p (x18, operands[2]))
            return -1;
          x14 = XEXP (x10, 1);
          if (!rtx_equal_p (x14, operands[2]))
            return -1;
          switch (GET_MODE (x4))
            {
            case E_TImode:
              if (pattern284 (x1, 
E_DImode, 
E_TImode) != 0
                  || !(
#line 6469 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCOmode)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              return 2224; /* *addvdi3_ccoverflow_const */

            case E_DImode:
              if (pattern284 (x1, 
E_SImode, 
E_DImode) != 0
                  || !
#line 6469 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCOmode)))
                return -1;
              return 2225; /* *addvsi3_ccoverflow_const */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case PLUS:
      x7 = XEXP (x5, 0);
      operands[3] = x7;
      x19 = XEXP (x5, 1);
      operands[1] = x19;
      x8 = XEXP (x4, 1);
      operands[2] = x8;
      x9 = XVECEXP (x1, 0, 1);
      switch (GET_CODE (x9))
        {
        case SET:
          res = recog_83 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case CLOBBER:
          x11 = XEXP (x9, 0);
          operands[0] = x11;
          switch (GET_MODE (x4))
            {
            case E_DImode:
              if (pattern237 (x5, 
E_DImode) == 0)
                {
                  x6 = XEXP (x3, 1);
                  if (rtx_equal_p (x6, operands[1])
                      && (
#line 7041 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL1mode)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return 2288; /* *adddi3_alc_carry1_cconly */
                  if (rtx_equal_p (x6, operands[2])
                      && (
#line 7075 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL1mode)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return 2292; /* *adddi3_alc_carry2_cconly */
                }
              break;

            case E_SImode:
              if (pattern237 (x5, 
E_SImode) == 0)
                {
                  x6 = XEXP (x3, 1);
                  if (rtx_equal_p (x6, operands[1])
                      && 
#line 7041 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL1mode)))
                    return 2289; /* *addsi3_alc_carry1_cconly */
                  if (rtx_equal_p (x6, operands[2])
                      && 
#line 7075 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL1mode)))
                    return 2293; /* *addsi3_alc_carry2_cconly */
                }
              break;

            default:
              break;
            }
          break;

        default:
          break;
        }
      x6 = XEXP (x3, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || GET_CODE (x9) != SET
          || pattern213 (x9) != 0)
        return -1;
      switch (GET_MODE (x4))
        {
        case E_DImode:
          if (pattern277 (x1, 
E_DImode) != 0
              || !(
#line 7091 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCLmode)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 2294; /* *adddi3_alc_cc */

        case E_SImode:
          if (pattern277 (x1, 
E_SImode) != 0
              || !
#line 7091 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCLmode)))
            return -1;
          return 2295; /* *addsi3_alc_cc */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_110 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x2))
    {
    case SET:
      return recog_109 (x1, insn, pnum_clobbers);

    case TRAP_IF:
      x3 = XEXP (x2, 0);
      if (GET_CODE (x3) != EQ)
        return -1;
      x4 = XEXP (x3, 1);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x5 = XEXP (x2, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != SET)
        return -1;
      x7 = XEXP (x3, 0);
      operands[0] = x7;
      x8 = XEXP (x6, 0);
      operands[1] = x8;
      x9 = XEXP (x6, 1);
      if (!rtx_equal_p (x9, operands[0]))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (!memory_operand (operands[0], E_DImode)
              || !register_operand (operands[1], E_DImode)
              || !(
#line 10002 "../../gcc/config/s390/s390.md"
(TARGET_ZEC12) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 2537; /* *load_and_trapdi */

        case E_SImode:
          if (!memory_operand (operands[0], E_SImode)
              || !register_operand (operands[1], E_SImode)
              || !
#line 10002 "../../gcc/config/s390/s390.md"
(TARGET_ZEC12))
            return -1;
          return 2538; /* *load_and_trapsi */

        default:
          return -1;
        }

    case UNSPEC:
      if (pattern14 (x1) != 0)
        return -1;
      x10 = XVECEXP (x2, 0, 0);
      x11 = XEXP (x10, 0);
      operands[1] = x11;
      x6 = XVECEXP (x1, 0, 1);
      x9 = XEXP (x6, 1);
      operands[0] = x9;
      x12 = XVECEXP (x2, 0, 1);
      switch (GET_CODE (x12))
        {
        case CONST_INT:
          if (XWINT (x12, 0) != 0L)
            return -1;
          if (larl_operand (operands[1], E_DImode)
              && register_operand (operands[0], E_DImode)
              && (
#line 10443 "../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_JUMP_INLINE_THUNK
   && TARGET_CPU_Z10) && 
#line 778 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
            return 2552; /* indirect_jump_via_inlinethunkdi_z10 */
          if (!larl_operand (operands[1], E_SImode)
              || !register_operand (operands[0], E_SImode)
              || !(
#line 10443 "../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_JUMP_INLINE_THUNK
   && TARGET_CPU_Z10) && 
#line 778 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
            return -1;
          return 2553; /* indirect_jump_via_inlinethunksi_z10 */

        case REG:
        case SUBREG:
          operands[2] = x12;
          if (register_operand (operands[2], E_DImode)
              && larl_operand (operands[1], E_DImode)
              && register_operand (operands[0], E_DImode)
              && (
#line 10459 "../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_JUMP_INLINE_THUNK
   && !TARGET_CPU_Z10) && 
#line 778 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
            return 2554; /* indirect_jump_via_inlinethunkdi */
          if (!register_operand (operands[2], E_SImode)
              || !larl_operand (operands[1], E_SImode)
              || !register_operand (operands[0], E_SImode)
              || !(
#line 10459 "../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_JUMP_INLINE_THUNK
   && !TARGET_CPU_Z10) && 
#line 778 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
            return -1;
          return 2555; /* indirect_jump_via_inlinethunksi */

        default:
          return -1;
        }

    case CALL:
      x3 = XEXP (x2, 0);
      if (GET_CODE (x3) != MEM
          || GET_MODE (x3) != E_QImode)
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != CLOBBER)
        return -1;
      x7 = XEXP (x3, 0);
      operands[0] = x7;
      x5 = XEXP (x2, 1);
      operands[1] = x5;
      if (!const_int_operand (operands[1], E_VOIDmode))
        return -1;
      x8 = XEXP (x6, 0);
      operands[2] = x8;
      if (register_operand (operands[2], E_VOIDmode))
        {
          if (bras_sym_operand (operands[0], E_VOIDmode))
            {
              if (
#line 10869 "../../gcc/config/s390/s390.md"
(!SIBLING_CALL_P (insn)
   && TARGET_SMALL_EXEC
   && GET_MODE (operands[2]) == Pmode))
                return 2573; /* *bras */
              if (
#line 10881 "../../gcc/config/s390/s390.md"
(!SIBLING_CALL_P (insn)

   && GET_MODE (operands[2]) == Pmode))
                return 2574; /* *brasl */
            }
          if (address_operand (operands[0], E_VOIDmode)
              && 
#line 10894 "../../gcc/config/s390/s390.md"
(!TARGET_INDIRECT_BRANCH_NOBP_CALL
   && !SIBLING_CALL_P (insn)
   && GET_MODE (operands[2]) == Pmode))
            return 2575; /* *basr */
        }
      if (register_operand (operands[2], E_DImode)
          && register_operand (operands[0], E_DImode))
        {
          if ((
#line 10917 "../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_CALL
   && TARGET_CPU_Z10
   && !SIBLING_CALL_P (insn)) && 
#line 778 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
            return 2576; /* *basr_via_thunkdi_z10 */
          if (pnum_clobbers != NULL
              && (
#line 10938 "../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_CALL
   && !TARGET_CPU_Z10
   && !SIBLING_CALL_P (insn)) && 
#line 778 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
            {
              *pnum_clobbers = 1;
              return 2578; /* *basr_via_thunkdi */
            }
        }
      if (!register_operand (operands[2], E_SImode)
          || !register_operand (operands[0], E_SImode))
        return -1;
      if ((
#line 10917 "../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_CALL
   && TARGET_CPU_Z10
   && !SIBLING_CALL_P (insn)) && 
#line 778 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
        return 2577; /* *basr_via_thunksi_z10 */
      if (pnum_clobbers == NULL
          || !(
#line 10938 "../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_CALL
   && !TARGET_CPU_Z10
   && !SIBLING_CALL_P (insn)) && 
#line 778 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
        return -1;
      *pnum_clobbers = 1;
      return 2579; /* *basr_via_thunksi */

    case RETURN:
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != USE)
        return -1;
      x8 = XEXP (x6, 0);
      operands[0] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (!register_operand (operands[0], E_DImode))
            return -1;
          if ((
#line 11848 "../../gcc/config/s390/s390.md"
(TARGET_CPU_Z10 || !TARGET_INDIRECT_BRANCH_NOBP_RET_OPTION) && 
#line 778 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
            return 2625; /* *returndi */
          if (pnum_clobbers == NULL
              || !(
#line 11876 "../../gcc/config/s390/s390.md"
(!TARGET_CPU_Z10 && TARGET_INDIRECT_BRANCH_NOBP_RET_OPTION) && 
#line 778 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 2627; /* returndi_prez10 */

        case E_SImode:
          if (!register_operand (operands[0], E_SImode))
            return -1;
          if ((
#line 11848 "../../gcc/config/s390/s390.md"
(TARGET_CPU_Z10 || !TARGET_INDIRECT_BRANCH_NOBP_RET_OPTION) && 
#line 778 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
            return 2626; /* *returnsi */
          if (pnum_clobbers == NULL
              || !(
#line 11876 "../../gcc/config/s390/s390.md"
(!TARGET_CPU_Z10 && TARGET_INDIRECT_BRANCH_NOBP_RET_OPTION) && 
#line 778 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 2628; /* returnsi_prez10 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_118 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x2))
    {
    case SET:
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      x4 = XEXP (x2, 1);
      operands[2] = x4;
      if (load_multiple_operation (operands[0], E_VOIDmode))
        {
          switch (GET_MODE (operands[1]))
            {
            case E_DImode:
              if (register_operand (operands[1], E_DImode)
                  && s_operand (operands[2], E_DImode)
                  && 
#line 3246 "../../gcc/config/s390/s390.md"
(reload_completed && TARGET_ZARCH))
                return 1880; /* *load_multiple_di */
              break;

            case E_SImode:
              if (register_operand (operands[1], E_SImode)
                  && s_operand (operands[2], E_SImode)
                  && 
#line 3259 "../../gcc/config/s390/s390.md"
(reload_completed))
                return 1881; /* *load_multiple_si */
              break;

            default:
              break;
            }
        }
      if (!store_multiple_operation (operands[0], E_VOIDmode))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_DImode:
          if (!s_operand (operands[1], E_DImode)
              || !register_operand (operands[2], E_DImode)
              || !
#line 3338 "../../gcc/config/s390/s390.md"
(reload_completed && TARGET_ZARCH))
            return -1;
          return 1882; /* *store_multiple_di */

        case E_SImode:
          if (!s_operand (operands[1], E_SImode)
              || !register_operand (operands[2], E_SImode)
              || !
#line 3352 "../../gcc/config/s390/s390.md"
(reload_completed))
            return -1;
          return 1883; /* *store_multiple_si */

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x2, 0) != 3
          || XINT (x2, 1) != 18
          || !execute_operation (operands[0], E_VOIDmode))
        return -1;
      x5 = XVECEXP (x2, 0, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_VOIDmode))
        return -1;
      x6 = XVECEXP (x2, 0, 1);
      operands[2] = x6;
      x7 = XVECEXP (x2, 0, 2);
      operands[3] = x7;
      if (larl_operand (operands[3], E_SImode)
          && 
#line 3371 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && GET_MODE_CLASS (GET_MODE (operands[1])) == MODE_INT
   && GET_MODE_SIZE (GET_MODE (operands[1])) <= UNITS_PER_WORD))
        return 1884; /* *execute_rl */
      if (!memory_operand (operands[2], E_BLKmode)
          || !
#line 3383 "../../gcc/config/s390/s390.md"
(GET_MODE_CLASS (GET_MODE (operands[1])) == MODE_INT
   && GET_MODE_SIZE (GET_MODE (operands[1])) <= UNITS_PER_WORD))
        return -1;
      return 1885; /* *execute */

    default:
      return -1;
    }
}

 rtx_insn *
split_2 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern101 (x2))
    {
    case 0:
      if (all_ones_operand (operands[1], E_V1QImode)
          && const0_operand (operands[2], E_V1QImode)
          && 
#line 2556 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return gen_split_94 (insn, operands);
      if (!const0_operand (operands[1], E_V1QImode)
          || !all_ones_operand (operands[2], E_V1QImode)
          || !
#line 2570 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return NULL;
      return gen_split_113 (insn, operands);

    case 1:
      if (all_ones_operand (operands[1], E_V2QImode)
          && const0_operand (operands[2], E_V2QImode)
          && 
#line 2556 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return gen_split_95 (insn, operands);
      if (!const0_operand (operands[1], E_V2QImode)
          || !all_ones_operand (operands[2], E_V2QImode)
          || !
#line 2570 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return NULL;
      return gen_split_114 (insn, operands);

    case 2:
      if (all_ones_operand (operands[1], E_V4QImode)
          && const0_operand (operands[2], E_V4QImode)
          && 
#line 2556 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return gen_split_96 (insn, operands);
      if (!const0_operand (operands[1], E_V4QImode)
          || !all_ones_operand (operands[2], E_V4QImode)
          || !
#line 2570 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return NULL;
      return gen_split_115 (insn, operands);

    case 3:
      if (all_ones_operand (operands[1], E_V8QImode)
          && const0_operand (operands[2], E_V8QImode)
          && 
#line 2556 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return gen_split_97 (insn, operands);
      if (!const0_operand (operands[1], E_V8QImode)
          || !all_ones_operand (operands[2], E_V8QImode)
          || !
#line 2570 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return NULL;
      return gen_split_116 (insn, operands);

    case 4:
      if (all_ones_operand (operands[1], E_V16QImode)
          && const0_operand (operands[2], E_V16QImode)
          && 
#line 2556 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return gen_split_98 (insn, operands);
      if (!const0_operand (operands[1], E_V16QImode)
          || !all_ones_operand (operands[2], E_V16QImode)
          || !
#line 2570 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return NULL;
      return gen_split_117 (insn, operands);

    case 5:
      if (all_ones_operand (operands[1], E_V1HImode)
          && const0_operand (operands[2], E_V1HImode)
          && 
#line 2556 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return gen_split_99 (insn, operands);
      if (!const0_operand (operands[1], E_V1HImode)
          || !all_ones_operand (operands[2], E_V1HImode)
          || !
#line 2570 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return NULL;
      return gen_split_118 (insn, operands);

    case 6:
      if (all_ones_operand (operands[1], E_V2HImode)
          && const0_operand (operands[2], E_V2HImode)
          && 
#line 2556 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return gen_split_100 (insn, operands);
      if (!const0_operand (operands[1], E_V2HImode)
          || !all_ones_operand (operands[2], E_V2HImode)
          || !
#line 2570 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return NULL;
      return gen_split_119 (insn, operands);

    case 7:
      if (all_ones_operand (operands[1], E_V4HImode)
          && const0_operand (operands[2], E_V4HImode)
          && 
#line 2556 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return gen_split_101 (insn, operands);
      if (!const0_operand (operands[1], E_V4HImode)
          || !all_ones_operand (operands[2], E_V4HImode)
          || !
#line 2570 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return NULL;
      return gen_split_120 (insn, operands);

    case 8:
      if (all_ones_operand (operands[1], E_V8HImode)
          && const0_operand (operands[2], E_V8HImode)
          && 
#line 2556 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return gen_split_102 (insn, operands);
      if (!const0_operand (operands[1], E_V8HImode)
          || !all_ones_operand (operands[2], E_V8HImode)
          || !
#line 2570 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return NULL;
      return gen_split_121 (insn, operands);

    case 9:
      if (all_ones_operand (operands[1], E_V1SImode)
          && const0_operand (operands[2], E_V1SImode)
          && 
#line 2556 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return gen_split_103 (insn, operands);
      if (!const0_operand (operands[1], E_V1SImode)
          || !all_ones_operand (operands[2], E_V1SImode)
          || !
#line 2570 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return NULL;
      return gen_split_122 (insn, operands);

    case 10:
      if (all_ones_operand (operands[1], E_V2SImode)
          && const0_operand (operands[2], E_V2SImode)
          && 
#line 2556 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return gen_split_104 (insn, operands);
      if (!const0_operand (operands[1], E_V2SImode)
          || !all_ones_operand (operands[2], E_V2SImode)
          || !
#line 2570 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return NULL;
      return gen_split_123 (insn, operands);

    case 11:
      if (all_ones_operand (operands[1], E_V4SImode)
          && const0_operand (operands[2], E_V4SImode)
          && 
#line 2556 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return gen_split_105 (insn, operands);
      if (!const0_operand (operands[1], E_V4SImode)
          || !all_ones_operand (operands[2], E_V4SImode)
          || !
#line 2570 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return NULL;
      return gen_split_124 (insn, operands);

    case 12:
      if (all_ones_operand (operands[1], E_V1DImode)
          && const0_operand (operands[2], E_V1DImode)
          && 
#line 2556 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return gen_split_106 (insn, operands);
      if (!const0_operand (operands[1], E_V1DImode)
          || !all_ones_operand (operands[2], E_V1DImode)
          || !
#line 2570 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return NULL;
      return gen_split_125 (insn, operands);

    case 13:
      if (all_ones_operand (operands[1], E_V2DImode)
          && const0_operand (operands[2], E_V2DImode)
          && 
#line 2556 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return gen_split_107 (insn, operands);
      if (!const0_operand (operands[1], E_V2DImode)
          || !all_ones_operand (operands[2], E_V2DImode)
          || !
#line 2570 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return NULL;
      return gen_split_126 (insn, operands);

    case 14:
      if (all_ones_operand (operands[1], E_V1SFmode)
          && const0_operand (operands[2], E_V1SFmode)
          && 
#line 2556 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return gen_split_108 (insn, operands);
      if (!const0_operand (operands[1], E_V1SFmode)
          || !all_ones_operand (operands[2], E_V1SFmode)
          || !
#line 2570 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return NULL;
      return gen_split_127 (insn, operands);

    case 15:
      if (all_ones_operand (operands[1], E_V2SFmode)
          && const0_operand (operands[2], E_V2SFmode)
          && 
#line 2556 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return gen_split_109 (insn, operands);
      if (!const0_operand (operands[1], E_V2SFmode)
          || !all_ones_operand (operands[2], E_V2SFmode)
          || !
#line 2570 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return NULL;
      return gen_split_128 (insn, operands);

    case 16:
      if (all_ones_operand (operands[1], E_V4SFmode)
          && const0_operand (operands[2], E_V4SFmode)
          && 
#line 2556 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return gen_split_110 (insn, operands);
      if (!const0_operand (operands[1], E_V4SFmode)
          || !all_ones_operand (operands[2], E_V4SFmode)
          || !
#line 2570 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return NULL;
      return gen_split_129 (insn, operands);

    case 17:
      if (all_ones_operand (operands[1], E_V1DFmode)
          && const0_operand (operands[2], E_V1DFmode)
          && 
#line 2556 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return gen_split_111 (insn, operands);
      if (!const0_operand (operands[1], E_V1DFmode)
          || !all_ones_operand (operands[2], E_V1DFmode)
          || !
#line 2570 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return NULL;
      return gen_split_130 (insn, operands);

    case 18:
      if (all_ones_operand (operands[1], E_V2DFmode)
          && const0_operand (operands[2], E_V2DFmode)
          && 
#line 2556 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return gen_split_112 (insn, operands);
      if (!const0_operand (operands[1], E_V2DFmode)
          || !all_ones_operand (operands[2], E_V2DFmode)
          || !
#line 2570 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return NULL;
      return gen_split_131 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_7 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[1] = x2;
      res = split_1 (x1, insn);
      if (res != NULL_RTX)
        return res;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (nonimmediate_operand (operands[0], E_TFmode))
        {
          if (GET_CODE (x2) == SUBREG
              && known_eq (SUBREG_BYTE (x2), 0)
              && GET_MODE (x2) == E_TFmode)
            {
              x4 = XEXP (x2, 0);
              operands[1] = x4;
              if (general_operand (operands[1], E_FPRX2mode)
                  && 
#line 690 "../../gcc/config/s390/vector.md"
(!(MEM_P (operands[0]) && MEM_VOLATILE_P (operands[0]))))
                return gen_split_37 (insn, operands);
            }
          operands[1] = x2;
          if (general_operand (operands[1], E_TFmode))
            {
              if ((
#line 2829 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && reload_completed
   && !s_operand (operands[0], TFmode)
   && !s_operand (operands[1], TFmode)
   && s390_split_ok_p (operands[0], operands[1], TFmode, 0)) && 
#line 764 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return gen_split_299 (insn, operands);
              if ((
#line 2845 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && reload_completed
   && !s_operand (operands[0], TFmode)
   && !s_operand (operands[1], TFmode)
   && s390_split_ok_p (operands[0], operands[1], TFmode, 1)) && 
#line 764 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return gen_split_302 (insn, operands);
            }
        }
      operands[1] = x2;
      if (memory_operand (operands[1], E_TFmode)
          && register_operand (operands[0], E_TFmode))
        {
          if ((
#line 2861 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && reload_completed
   && GENERAL_REG_P (operands[0])
   && !s_operand (operands[1], VOIDmode)) && 
#line 764 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return gen_split_305 (insn, operands);
          if ((
#line 2877 "../../gcc/config/s390/s390.md"
(reload_completed && offsettable_memref_p (operands[1])
   && FP_REG_P (operands[0])) && 
#line 764 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return gen_split_308 (insn, operands);
        }
      if (!register_operand (operands[1], E_TFmode)
          || !memory_operand (operands[0], E_TFmode)
          || !(
#line 2893 "../../gcc/config/s390/s390.md"
(reload_completed && offsettable_memref_p (operands[0])
   && FP_REG_P (operands[1])) && 
#line 764 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
        return NULL;
      return gen_split_311 (insn, operands);

    case VEC_DUPLICATE:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          if (!register_operand (operands[0], E_V16QImode)
              || GET_MODE (x2) != E_V16QImode
              || !register_operand (operands[1], E_QImode)
              || !
#line 721 "../../gcc/config/s390/vector.md"
(TARGET_VX && GENERAL_REG_P (operands[1])))
            return NULL;
          return gen_split_38 (insn, operands);

        case E_V8HImode:
          if (!register_operand (operands[0], E_V8HImode)
              || GET_MODE (x2) != E_V8HImode
              || !register_operand (operands[1], E_HImode)
              || !
#line 721 "../../gcc/config/s390/vector.md"
(TARGET_VX && GENERAL_REG_P (operands[1])))
            return NULL;
          return gen_split_39 (insn, operands);

        case E_V4SImode:
          if (!register_operand (operands[0], E_V4SImode)
              || GET_MODE (x2) != E_V4SImode
              || !register_operand (operands[1], E_SImode)
              || !
#line 721 "../../gcc/config/s390/vector.md"
(TARGET_VX && GENERAL_REG_P (operands[1])))
            return NULL;
          return gen_split_40 (insn, operands);

        case E_V4SFmode:
          if (!register_operand (operands[0], E_V4SFmode)
              || GET_MODE (x2) != E_V4SFmode
              || !register_operand (operands[1], E_SFmode)
              || !
#line 721 "../../gcc/config/s390/vector.md"
(TARGET_VX && GENERAL_REG_P (operands[1])))
            return NULL;
          return gen_split_41 (insn, operands);

        case E_V2DImode:
          if (!register_operand (operands[0], E_V2DImode)
              || GET_MODE (x2) != E_V2DImode
              || !register_operand (operands[1], E_DImode)
              || !
#line 721 "../../gcc/config/s390/vector.md"
(TARGET_VX && GENERAL_REG_P (operands[1])))
            return NULL;
          return gen_split_42 (insn, operands);

        case E_V2DFmode:
          if (!register_operand (operands[0], E_V2DFmode)
              || GET_MODE (x2) != E_V2DFmode
              || !register_operand (operands[1], E_DFmode)
              || !
#line 721 "../../gcc/config/s390/vector.md"
(TARGET_VX && GENERAL_REG_P (operands[1])))
            return NULL;
          return gen_split_43 (insn, operands);

        default:
          return NULL;
        }

    case SMAX:
      if (pattern7 (x1) != 0
          || !(
#line 2032 "../../gcc/config/s390/vector.md"
(TARGET_VX && !TARGET_VXE) && 
#line 2034 "../../gcc/config/s390/vector.md"
( 1)))
        return NULL;
      return gen_split_48 (insn, operands);

    case SMIN:
      if (pattern7 (x1) != 0
          || !(
#line 2068 "../../gcc/config/s390/vector.md"
(TARGET_VX && !TARGET_VXE) && 
#line 2070 "../../gcc/config/s390/vector.md"
( 1)))
        return NULL;
      return gen_split_49 (insn, operands);

    case IF_THEN_ELSE:
      return split_3 (x1, insn);

    case AND:
      switch (pattern9 (x1))
        {
        case 0:
          if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_141 (insn, operands);

        case 1:
          if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_150 (insn, operands);

        case 2:
          if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_159 (insn, operands);

        case 3:
          if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_168 (insn, operands);

        case 4:
          if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_177 (insn, operands);

        case 5:
          if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_186 (insn, operands);

        case 6:
          if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_195 (insn, operands);

        case 7:
          if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_204 (insn, operands);

        case 8:
          if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_213 (insn, operands);

        case 9:
          if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_222 (insn, operands);

        case 10:
          if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_231 (insn, operands);

        case 11:
          if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_240 (insn, operands);

        case 12:
          if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_249 (insn, operands);

        case 13:
          if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_258 (insn, operands);

        case 14:
          if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_267 (insn, operands);

        case 15:
          if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_276 (insn, operands);

        case 16:
          if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_142 (insn, operands);

        case 17:
          if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_151 (insn, operands);

        case 18:
          if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_160 (insn, operands);

        case 19:
          if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_169 (insn, operands);

        case 20:
          if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_178 (insn, operands);

        case 21:
          if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_187 (insn, operands);

        case 22:
          if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_196 (insn, operands);

        case 23:
          if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_205 (insn, operands);

        case 24:
          if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_214 (insn, operands);

        case 25:
          if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_223 (insn, operands);

        case 26:
          if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_232 (insn, operands);

        case 27:
          if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_241 (insn, operands);

        case 28:
          if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_250 (insn, operands);

        case 29:
          if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_259 (insn, operands);

        case 30:
          if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_268 (insn, operands);

        case 31:
          if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_277 (insn, operands);

        case 32:
          if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_143 (insn, operands);

        case 33:
          if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_152 (insn, operands);

        case 34:
          if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_161 (insn, operands);

        case 35:
          if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_170 (insn, operands);

        case 36:
          if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_179 (insn, operands);

        case 37:
          if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_188 (insn, operands);

        case 38:
          if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_197 (insn, operands);

        case 39:
          if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_206 (insn, operands);

        case 40:
          if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_215 (insn, operands);

        case 41:
          if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_224 (insn, operands);

        case 42:
          if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_233 (insn, operands);

        case 43:
          if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_242 (insn, operands);

        case 44:
          if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_251 (insn, operands);

        case 45:
          if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_260 (insn, operands);

        case 46:
          if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_269 (insn, operands);

        case 47:
          if (!(
#line 3430 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3432 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_278 (insn, operands);

        default:
          return NULL;
        }

    case IOR:
      return split_4 (x1, insn);

    case XOR:
      return split_5 (x1, insn);

    case COMPARE:
      x3 = XEXP (x1, 0);
      if (GET_CODE (x3) != REG
          || REGNO (x3) != 33)
        return NULL;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      if (!memory_operand (operands[0], E_VOIDmode))
        return NULL;
      x5 = XEXP (x2, 1);
      operands[1] = x5;
      if (!memory_operand (operands[1], E_VOIDmode)
          || !
#line 1509 "../../gcc/config/s390/s390.md"
(reload_completed
   && s390_match_ccmode (insn, CCUmode)
   && GET_MODE (operands[0]) == GET_MODE (operands[1])
   && GET_MODE_SIZE (GET_MODE (operands[0])) > 0))
        return NULL;
      return gen_split_285 (insn, operands);

    case UNSPEC:
      if (XVECLEN (x2, 0) != 1)
        return NULL;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x6 = XVECEXP (x2, 0, 0);
      operands[1] = x6;
      switch (XINT (x2, 1))
        {
        case 30:
          switch (pattern80 (x2))
            {
            case 0:
              if (!
#line 2171 "../../gcc/config/s390/s390.md"
( reload_completed))
                return NULL;
              return gen_split_290 (insn, operands);

            case 1:
              if (!(
#line 2178 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH) && 
#line 2180 "../../gcc/config/s390/s390.md"
( reload_completed)))
                return NULL;
              return gen_split_291 (insn, operands);

            default:
              return NULL;
            }

        case 5:
          if (GET_MODE (x2) != E_SImode
              || !nonimmediate_operand (operands[0], E_SImode)
              || !register_operand (operands[1], E_VOIDmode)
              || !
#line 3792 "../../gcc/config/s390/s390.md"
(reload_completed))
            return NULL;
          return gen_split_325 (insn, operands);

        default:
          return NULL;
        }

    case ZERO_EXTEND:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!memory_operand (operands[1], E_QImode))
        return NULL;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode
              || !(
#line 5309 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH) && 
#line 5311 "../../gcc/config/s390/s390.md"
( reload_completed)))
            return NULL;
          return gen_split_352 (insn, operands);

        case E_HImode:
          if (!register_operand (operands[0], E_HImode)
              || GET_MODE (x2) != E_HImode
              || !(
#line 5341 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH) && 
#line 5343 "../../gcc/config/s390/s390.md"
( reload_completed)))
            return NULL;
          return gen_split_353 (insn, operands);

        default:
          return NULL;
        }

    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case LTGT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case UNORDERED:
    case ORDERED:
    case UNEQ:
    case UNGE:
    case UNGT:
    case UNLE:
    case UNLT:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      switch (GET_CODE (x2))
        {
        case EQ:
          switch (GET_MODE (operands[0]))
            {
            case E_V1TImode:
              if (pattern0 (x2, 
E_V1TImode) == 0
                  && (
#line 2136 "../../gcc/config/s390/vector.md"
(TARGET_VX && !TARGET_VXE3) && 
#line 2138 "../../gcc/config/s390/vector.md"
( can_create_pseudo_p ())))
                return gen_split_50 (insn, operands);
              break;

            case E_TImode:
              if (pattern0 (x2, 
E_TImode) == 0
                  && (
#line 2136 "../../gcc/config/s390/vector.md"
(TARGET_VX && !TARGET_VXE3) && 
#line 2138 "../../gcc/config/s390/vector.md"
( can_create_pseudo_p ())))
                return gen_split_51 (insn, operands);
              break;

            default:
              break;
            }
          break;

        case GT:
          switch (GET_MODE (operands[0]))
            {
            case E_V1TImode:
              if (pattern0 (x2, 
E_V1TImode) == 0
                  && (
#line 2158 "../../gcc/config/s390/vector.md"
(TARGET_VX && !TARGET_VXE3) && 
#line 2160 "../../gcc/config/s390/vector.md"
( can_create_pseudo_p ())))
                return gen_split_52 (insn, operands);
              break;

            case E_TImode:
              if (pattern0 (x2, 
E_TImode) == 0
                  && (
#line 2158 "../../gcc/config/s390/vector.md"
(TARGET_VX && !TARGET_VXE3) && 
#line 2160 "../../gcc/config/s390/vector.md"
( can_create_pseudo_p ())))
                return gen_split_53 (insn, operands);
              break;

            default:
              break;
            }
          break;

        case GTU:
          switch (GET_MODE (operands[0]))
            {
            case E_V1TImode:
              if (pattern0 (x2, 
E_V1TImode) == 0
                  && (
#line 2192 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 2194 "../../gcc/config/s390/vector.md"
( can_create_pseudo_p ())))
                return gen_split_54 (insn, operands);
              break;

            case E_TImode:
              if (pattern0 (x2, 
E_TImode) == 0
                  && (
#line 2192 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 2194 "../../gcc/config/s390/vector.md"
( can_create_pseudo_p ())))
                return gen_split_55 (insn, operands);
              break;

            default:
              break;
            }
          break;

        default:
          break;
        }
      operands[1] = x2;
      switch (pattern45 (x2))
        {
        case 0:
          if (!(
#line 7289 "../../gcc/config/s390/s390.md"
(reload_completed) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return NULL;
          return gen_split_363 (insn, operands);

        case 1:
          if (!
#line 7289 "../../gcc/config/s390/s390.md"
(reload_completed))
            return NULL;
          return gen_split_364 (insn, operands);

        default:
          return NULL;
        }

    case NOT:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (!nonimmediate_operand (operands[0], E_DImode)
              || GET_MODE (x2) != E_DImode
              || !nonimmediate_operand (operands[1], E_DImode)
              || !
#line 795 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return NULL;
          return gen_split_375 (insn, operands);

        case E_SImode:
          if (!nonimmediate_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode
              || !nonimmediate_operand (operands[1], E_SImode))
            return NULL;
          return gen_split_376 (insn, operands);

        case E_HImode:
          if (!nonimmediate_operand (operands[0], E_HImode)
              || GET_MODE (x2) != E_HImode
              || !nonimmediate_operand (operands[1], E_HImode))
            return NULL;
          return gen_split_377 (insn, operands);

        case E_QImode:
          if (!nonimmediate_operand (operands[0], E_QImode)
              || GET_MODE (x2) != E_QImode
              || !nonimmediate_operand (operands[1], E_QImode))
            return NULL;
          return gen_split_378 (insn, operands);

        default:
          return NULL;
        }

    case BSWAP:
      if (GET_MODE (x2) != E_HImode)
        return NULL;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_HImode))
        return NULL;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_HImode))
        return NULL;
      return gen_split_392 (insn, operands);

    default:
      return NULL;
    }
}
