/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern8 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern11 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_V1QImode:
      if (!register_operand (operands[0], E_V1QImode)
          || GET_MODE (x1) != E_V1QImode
          || !register_operand (operands[1], E_V1QImode))
        return -1;
      return 0;

    case E_V2QImode:
      if (!register_operand (operands[0], E_V2QImode)
          || GET_MODE (x1) != E_V2QImode
          || !register_operand (operands[1], E_V2QImode))
        return -1;
      return 1;

    case E_V4QImode:
      if (!register_operand (operands[0], E_V4QImode)
          || GET_MODE (x1) != E_V4QImode
          || !register_operand (operands[1], E_V4QImode))
        return -1;
      return 2;

    case E_V8QImode:
      if (!register_operand (operands[0], E_V8QImode)
          || GET_MODE (x1) != E_V8QImode
          || !register_operand (operands[1], E_V8QImode))
        return -1;
      return 3;

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x1) != E_V16QImode
          || !register_operand (operands[1], E_V16QImode))
        return -1;
      return 4;

    case E_V1HImode:
      if (!register_operand (operands[0], E_V1HImode)
          || GET_MODE (x1) != E_V1HImode
          || !register_operand (operands[1], E_V1HImode))
        return -1;
      return 5;

    case E_V2HImode:
      if (!register_operand (operands[0], E_V2HImode)
          || GET_MODE (x1) != E_V2HImode
          || !register_operand (operands[1], E_V2HImode))
        return -1;
      return 6;

    case E_V4HImode:
      if (!register_operand (operands[0], E_V4HImode)
          || GET_MODE (x1) != E_V4HImode
          || !register_operand (operands[1], E_V4HImode))
        return -1;
      return 7;

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x1) != E_V8HImode
          || !register_operand (operands[1], E_V8HImode))
        return -1;
      return 8;

    case E_V1SImode:
      if (!register_operand (operands[0], E_V1SImode)
          || GET_MODE (x1) != E_V1SImode
          || !register_operand (operands[1], E_V1SImode))
        return -1;
      return 9;

    case E_V2SImode:
      if (!register_operand (operands[0], E_V2SImode)
          || GET_MODE (x1) != E_V2SImode
          || !register_operand (operands[1], E_V2SImode))
        return -1;
      return 10;

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x1) != E_V4SImode
          || !register_operand (operands[1], E_V4SImode))
        return -1;
      return 11;

    case E_V1DImode:
      if (!register_operand (operands[0], E_V1DImode)
          || GET_MODE (x1) != E_V1DImode
          || !register_operand (operands[1], E_V1DImode))
        return -1;
      return 12;

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x1) != E_V2DImode
          || !register_operand (operands[1], E_V2DImode))
        return -1;
      return 13;

    case E_DImode:
      if (pattern10 (x1, 
E_DImode) != 0)
        return -1;
      return 14;

    case E_SImode:
      if (pattern10 (x1, 
E_SImode) != 0)
        return -1;
      return 15;

    default:
      return -1;
    }
}

int
pattern36 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != PARALLEL)
    return -1;
  x5 = XEXP (x2, 0);
  operands[0] = x5;
  x6 = XEXP (x3, 0);
  operands[1] = x6;
  switch (XVECLEN (x4, 0))
    {
    case 16:
      x7 = XVECEXP (x4, 0, 0);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 15])
        return -1;
      x8 = XVECEXP (x4, 0, 1);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 14])
        return -1;
      x9 = XVECEXP (x4, 0, 2);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 13])
        return -1;
      x10 = XVECEXP (x4, 0, 3);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 12])
        return -1;
      x11 = XVECEXP (x4, 0, 4);
      if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 11])
        return -1;
      x12 = XVECEXP (x4, 0, 5);
      if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 10])
        return -1;
      x13 = XVECEXP (x4, 0, 6);
      if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 9])
        return -1;
      x14 = XVECEXP (x4, 0, 7);
      if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x15 = XVECEXP (x4, 0, 8);
      if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 7])
        return -1;
      x16 = XVECEXP (x4, 0, 9);
      if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
        return -1;
      x17 = XVECEXP (x4, 0, 10);
      if (x17 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
        return -1;
      x18 = XVECEXP (x4, 0, 11);
      if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
        return -1;
      x19 = XVECEXP (x4, 0, 12);
      if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
        return -1;
      x20 = XVECEXP (x4, 0, 13);
      if (x20 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
        return -1;
      x21 = XVECEXP (x4, 0, 14);
      if (x21 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x22 = XVECEXP (x4, 0, 15);
      if (x22 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x23 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x23) != USE
          || !nonimmediate_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !nonimmediate_operand (operands[1], E_V16QImode))
        return -1;
      x24 = XEXP (x23, 0);
      operands[2] = x24;
      if (!permute_pattern_operand (operands[2], E_V16QImode))
        return -1;
      return 0;

    case 4:
      x7 = XVECEXP (x4, 0, 0);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
        return -1;
      x8 = XVECEXP (x4, 0, 1);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
        return -1;
      x9 = XVECEXP (x4, 0, 2);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x10 = XVECEXP (x4, 0, 3);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x23 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x23) != CLOBBER)
        return -1;
      x24 = XEXP (x23, 0);
      operands[2] = x24;
      if (!scratch_operand (operands[2], E_V2DImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SImode:
          if (!nonimmediate_operand (operands[0], E_V4SImode)
              || GET_MODE (x3) != E_V4SImode
              || !nonimmediate_operand (operands[1], E_V4SImode))
            return -1;
          return 1;

        case E_V4SFmode:
          if (!nonimmediate_operand (operands[0], E_V4SFmode)
              || GET_MODE (x3) != E_V4SFmode
              || !nonimmediate_operand (operands[1], E_V4SFmode))
            return -1;
          return 2;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern79 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != PC)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != UNSPEC_VOLATILE
      || XVECLEN (x5, 0) != 2
      || XINT (x5, 1) != 26)
    return -1;
  x6 = XVECEXP (x5, 0, 1);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 1)
    return -1;
  x7 = XEXP (x4, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 1)
    return -1;
  x8 = XVECEXP (x1, 0, 2);
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != LABEL_REF)
    return -1;
  x10 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x10) != USE)
    return -1;
  x11 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x11) != USE)
    return -1;
  return 0;
}

int
pattern92 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[3] = x5;
  x6 = XEXP (x1, 1);
  operands[4] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      return pattern91 (x1, 
E_DImode); /* [-1, 0] */

    case E_SImode:
      if (pattern91 (x1, 
E_SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern98 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_BLKmode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != SUBREG)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != MEM
      || GET_MODE (x4) != E_BLKmode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != SUBREG)
    return -1;
  return 0;
}

int
pattern107 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern113 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_CODE (x3) != ZERO_EXTEND
      || GET_MODE (x3) != i2
      || !register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], i1))
    return -1;
  x5 = XEXP (x3, 0);
  operands[2] = x5;
  if (!nonimmediate_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern121 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern125 (rtx x1, machine_mode i1, unsigned int i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  if (GET_MODE (x3) != i3)
    return -1;
  x4 = XEXP (x1, 0);
  x5 = XEXP (x4, 0);
  if (maybe_ne (SUBREG_BYTE (x5), i2)
      || GET_MODE (x5) != i3
      || !register_operand (operands[0], i1)
      || !register_operand (operands[3], i1))
    return -1;
  x6 = XVECEXP (x2, 0, 0);
  if (GET_MODE (x6) != i3
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern132 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x2, 1);
  if (XWINT (x5, 0) != 64L)
    return -1;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != i1
      || GET_MODE (x7) != E_DImode)
    return -1;
  return 0;
}

int
pattern138 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  x2 = XEXP (x1, 2);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern144 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != SIGN_EXTEND)
    return -1;
  x6 = XEXP (x3, 1);
  if (GET_CODE (x6) != SIGN_EXTEND)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != i1)
    return -1;
  x8 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x8) != SET)
    return -1;
  x9 = XEXP (x8, 1);
  if (GET_CODE (x9) != i1)
    return -1;
  x10 = XEXP (x4, 0);
  x11 = XEXP (x10, 0);
  operands[1] = x11;
  x12 = XEXP (x5, 0);
  operands[2] = x12;
  x13 = XEXP (x8, 0);
  operands[0] = x13;
  x14 = XEXP (x7, 0);
  if (!rtx_equal_p (x14, operands[1]))
    return -1;
  x15 = XEXP (x7, 1);
  if (!rtx_equal_p (x15, operands[2]))
    return -1;
  x16 = XEXP (x9, 0);
  if (!rtx_equal_p (x16, operands[1]))
    return -1;
  x17 = XEXP (x9, 1);
  if (!rtx_equal_p (x17, operands[2]))
    return -1;
  switch (GET_MODE (x4))
    {
    case E_TImode:
      return 0;

    case E_DImode:
      return 1;

    default:
      return -1;
    }
}

int
pattern156 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern160 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !scratch_operand (operands[0], i1))
    return -1;
  return 0;
}

int
pattern166 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern169 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern172 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_DImode:
      if (!register_operand (operands[1], E_DImode)
          || !nonmemory_operand (operands[2], E_DImode))
        return -1;
      return 0;

    case E_SImode:
      if (!register_operand (operands[1], E_SImode)
          || !nonmemory_operand (operands[2], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern182 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != SET)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != COMPARE)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 33)
    return -1;
  return 0;
}

int
pattern186 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1)
      || !register_operand (operands[1], i1))
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern193 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode
          || !register_operand (operands[1], E_DImode))
        return -1;
      return 0;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern200 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !contiguous_bitmask_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !nonimmediate_operand (operands[3], i1)
      || !const_int_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern207 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1)
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern217 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !memory_operand (operands[1], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern226 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x2))
    {
    case SET:
      x3 = XEXP (x2, 1);
      if (GET_CODE (x3) != MINUS)
        return -1;
      return 0;

    case CLOBBER:
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x5 = XVECEXP (x1, 0, 0);
      x6 = XEXP (x5, 1);
      x7 = XEXP (x6, 0);
      switch (GET_MODE (x7))
        {
        case E_DImode:
          if (!register_operand (operands[1], E_DImode)
              || !general_operand (operands[2], E_DImode)
              || !scratch_operand (operands[0], E_DImode))
            return -1;
          return 1;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode)
              || !general_operand (operands[2], E_SImode)
              || !scratch_operand (operands[0], E_SImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern245 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  if (!rtx_equal_p (x5, operands[1]))
    return -1;
  x6 = XEXP (x4, 1);
  if (!rtx_equal_p (x6, operands[2]))
    return -1;
  x7 = XVECEXP (x1, 0, 0);
  x8 = XEXP (x7, 1);
  x9 = XEXP (x8, 0);
  switch (GET_MODE (x9))
    {
    case E_DImode:
      return pattern244 (x4, 
E_DImode); /* [-1, 0] */

    case E_SImode:
      if (pattern244 (x4, 
E_SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern261 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[0], i1))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 1);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) != i1)
    return -1;
  return 0;
}

int
pattern270 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  switch (XWINT (x3, 0))
    {
    case 1L:
      x4 = XEXP (x1, 1);
      if (XWINT (x4, 0) != 8589934590L)
        return -1;
      return 0;

    case 2L:
      x4 = XEXP (x1, 1);
      if (XWINT (x4, 0) != 17179869180L)
        return -1;
      return 1;

    case 3L:
      x4 = XEXP (x1, 1);
      if (XWINT (x4, 0) != 34359738360L)
        return -1;
      return 2;

    case 4L:
      x4 = XEXP (x1, 1);
      if (XWINT (x4, 0) != 68719476720L)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern282 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_MODE (x4) != i2)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !nonimmediate_operand (operands[0], i1))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 1);
  if (GET_MODE (x7) != i1)
    return -1;
  return 0;
}

int
pattern290 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1)
      || !general_operand (operands[2], i1)
      || !register_operand (operands[3], i1)
      || !nonimmediate_operand (operands[4], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern298 (rtx x1, unsigned int i1, machine_mode i2, unsigned int i3, unsigned int i4, unsigned int i5)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 5);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XVECEXP (x1, 0, 6);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != i5
      || GET_MODE (x5) != i2)
    return -1;
  x6 = XVECEXP (x1, 0, 7);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != i4
      || GET_MODE (x7) != i2)
    return -1;
  x8 = XVECEXP (x1, 0, 8);
  if (GET_CODE (x8) != CLOBBER)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != REG
      || REGNO (x9) != i3
      || GET_MODE (x9) != i2)
    return -1;
  x10 = XVECEXP (x1, 0, 9);
  if (GET_CODE (x10) != CLOBBER)
    return -1;
  x11 = XEXP (x10, 0);
  if (GET_CODE (x11) != REG
      || REGNO (x11) != i1)
    return -1;
  return 0;
}

 int
recog_8 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern28 (x1))
    {
    case 0:
      if (!
#line 1755 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1213; /* vec_widen_umult_odd_v1qi */

    case 1:
      if (!
#line 1755 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1214; /* vec_widen_umult_odd_v2qi */

    case 2:
      if (!
#line 1755 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1215; /* vec_widen_umult_odd_v4qi */

    case 3:
      if (!
#line 1755 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1216; /* vec_widen_umult_odd_v8qi */

    case 4:
      if (!
#line 1755 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1217; /* vec_widen_umult_odd_v16qi */

    case 5:
      if (!
#line 1755 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1218; /* vec_widen_umult_odd_v1hi */

    case 6:
      if (!
#line 1755 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1219; /* vec_widen_umult_odd_v2hi */

    case 7:
      if (!
#line 1755 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1220; /* vec_widen_umult_odd_v4hi */

    case 8:
      if (!
#line 1755 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1221; /* vec_widen_umult_odd_v8hi */

    case 9:
      if (!
#line 1755 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1222; /* vec_widen_umult_odd_v1si */

    case 10:
      if (!
#line 1755 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1223; /* vec_widen_umult_odd_v2si */

    case 11:
      if (!
#line 1755 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1224; /* vec_widen_umult_odd_v4si */

    case 12:
      if (!
#line 1755 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1225; /* vec_widen_umult_odd_v1di */

    case 13:
      if (!(
#line 1755 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 71 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
        return -1;
      return 1226; /* vec_widen_umult_odd_v2di */

    default:
      return -1;
    }
}

 int
recog_14 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 2);
  operands[3] = x3;
  x4 = XVECEXP (x2, 0, 0);
  switch (GET_CODE (x4))
    {
    case BSWAP:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x6 = XVECEXP (x2, 0, 1);
      operands[2] = x6;
      if (!const_int_operand (operands[2], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HImode:
          if (pattern185 (x2, 
E_V8HImode, 
E_HImode) != 0
              || !
#line 2169 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2 && UINTVAL (operands[2]) < GET_MODE_NUNITS (V8HImode)))
            return -1;
          return 481; /* *vec_set_bswap_elemv8hi */

        case E_V4SImode:
          if (pattern185 (x2, 
E_V4SImode, 
E_SImode) != 0
              || !
#line 2169 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2 && UINTVAL (operands[2]) < GET_MODE_NUNITS (V4SImode)))
            return -1;
          return 482; /* *vec_set_bswap_elemv4si */

        case E_V4SFmode:
          if (pattern185 (x2, 
E_V4SFmode, 
E_SFmode) != 0
              || !(
#line 2169 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2 && UINTVAL (operands[2]) < GET_MODE_NUNITS (V4SFmode)) && 
#line 44 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 483; /* *vec_set_bswap_elemv4sf */

        case E_V2DImode:
          if (pattern185 (x2, 
E_V2DImode, 
E_DImode) != 0
              || !
#line 2169 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2 && UINTVAL (operands[2]) < GET_MODE_NUNITS (V2DImode)))
            return -1;
          return 484; /* *vec_set_bswap_elemv2di */

        case E_V2DFmode:
          if (pattern185 (x2, 
E_V2DFmode, 
E_DFmode) != 0
              || !
#line 2169 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2 && UINTVAL (operands[2]) < GET_MODE_NUNITS (V2DFmode)))
            return -1;
          return 485; /* *vec_set_bswap_elemv2df */

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[1] = x4;
      x6 = XVECEXP (x2, 0, 1);
      switch (GET_CODE (x6))
        {
        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          operands[2] = x6;
          if (!nonmemory_operand (operands[2], E_SImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V1QImode:
              if (pattern199 (x2, 
E_V1QImode, 
E_QImode) != 0
                  || !
#line 520 "../../gcc/config/s390/vector.md"
(TARGET_VX
   && (!CONST_INT_P (operands[2])
       || UINTVAL (operands[2]) < GET_MODE_NUNITS (V1QImode))))
                return -1;
              return 543; /* *vec_setv1qi */

            case E_V2QImode:
              if (pattern199 (x2, 
E_V2QImode, 
E_QImode) != 0
                  || !
#line 520 "../../gcc/config/s390/vector.md"
(TARGET_VX
   && (!CONST_INT_P (operands[2])
       || UINTVAL (operands[2]) < GET_MODE_NUNITS (V2QImode))))
                return -1;
              return 544; /* *vec_setv2qi */

            case E_V4QImode:
              if (pattern199 (x2, 
E_V4QImode, 
E_QImode) != 0
                  || !
#line 520 "../../gcc/config/s390/vector.md"
(TARGET_VX
   && (!CONST_INT_P (operands[2])
       || UINTVAL (operands[2]) < GET_MODE_NUNITS (V4QImode))))
                return -1;
              return 545; /* *vec_setv4qi */

            case E_V8QImode:
              if (pattern199 (x2, 
E_V8QImode, 
E_QImode) != 0
                  || !
#line 520 "../../gcc/config/s390/vector.md"
(TARGET_VX
   && (!CONST_INT_P (operands[2])
       || UINTVAL (operands[2]) < GET_MODE_NUNITS (V8QImode))))
                return -1;
              return 546; /* *vec_setv8qi */

            case E_V16QImode:
              if (pattern199 (x2, 
E_V16QImode, 
E_QImode) != 0
                  || !
#line 520 "../../gcc/config/s390/vector.md"
(TARGET_VX
   && (!CONST_INT_P (operands[2])
       || UINTVAL (operands[2]) < GET_MODE_NUNITS (V16QImode))))
                return -1;
              return 547; /* *vec_setv16qi */

            case E_V1HImode:
              if (pattern199 (x2, 
E_V1HImode, 
E_HImode) != 0
                  || !
#line 520 "../../gcc/config/s390/vector.md"
(TARGET_VX
   && (!CONST_INT_P (operands[2])
       || UINTVAL (operands[2]) < GET_MODE_NUNITS (V1HImode))))
                return -1;
              return 548; /* *vec_setv1hi */

            case E_V2HImode:
              if (pattern199 (x2, 
E_V2HImode, 
E_HImode) != 0
                  || !
#line 520 "../../gcc/config/s390/vector.md"
(TARGET_VX
   && (!CONST_INT_P (operands[2])
       || UINTVAL (operands[2]) < GET_MODE_NUNITS (V2HImode))))
                return -1;
              return 549; /* *vec_setv2hi */

            case E_V4HImode:
              if (pattern199 (x2, 
E_V4HImode, 
E_HImode) != 0
                  || !
#line 520 "../../gcc/config/s390/vector.md"
(TARGET_VX
   && (!CONST_INT_P (operands[2])
       || UINTVAL (operands[2]) < GET_MODE_NUNITS (V4HImode))))
                return -1;
              return 550; /* *vec_setv4hi */

            case E_V8HImode:
              if (pattern199 (x2, 
E_V8HImode, 
E_HImode) != 0
                  || !
#line 520 "../../gcc/config/s390/vector.md"
(TARGET_VX
   && (!CONST_INT_P (operands[2])
       || UINTVAL (operands[2]) < GET_MODE_NUNITS (V8HImode))))
                return -1;
              return 551; /* *vec_setv8hi */

            case E_V1SImode:
              if (pattern199 (x2, 
E_V1SImode, 
E_SImode) != 0
                  || !
#line 520 "../../gcc/config/s390/vector.md"
(TARGET_VX
   && (!CONST_INT_P (operands[2])
       || UINTVAL (operands[2]) < GET_MODE_NUNITS (V1SImode))))
                return -1;
              return 552; /* *vec_setv1si */

            case E_V2SImode:
              if (pattern199 (x2, 
E_V2SImode, 
E_SImode) != 0
                  || !
#line 520 "../../gcc/config/s390/vector.md"
(TARGET_VX
   && (!CONST_INT_P (operands[2])
       || UINTVAL (operands[2]) < GET_MODE_NUNITS (V2SImode))))
                return -1;
              return 553; /* *vec_setv2si */

            case E_V4SImode:
              if (pattern199 (x2, 
E_V4SImode, 
E_SImode) != 0
                  || !
#line 520 "../../gcc/config/s390/vector.md"
(TARGET_VX
   && (!CONST_INT_P (operands[2])
       || UINTVAL (operands[2]) < GET_MODE_NUNITS (V4SImode))))
                return -1;
              return 554; /* *vec_setv4si */

            case E_V1DImode:
              if (pattern199 (x2, 
E_V1DImode, 
E_DImode) != 0
                  || !
#line 520 "../../gcc/config/s390/vector.md"
(TARGET_VX
   && (!CONST_INT_P (operands[2])
       || UINTVAL (operands[2]) < GET_MODE_NUNITS (V1DImode))))
                return -1;
              return 555; /* *vec_setv1di */

            case E_V2DImode:
              if (pattern199 (x2, 
E_V2DImode, 
E_DImode) != 0
                  || !
#line 520 "../../gcc/config/s390/vector.md"
(TARGET_VX
   && (!CONST_INT_P (operands[2])
       || UINTVAL (operands[2]) < GET_MODE_NUNITS (V2DImode))))
                return -1;
              return 556; /* *vec_setv2di */

            case E_V1SFmode:
              if (pattern199 (x2, 
E_V1SFmode, 
E_SFmode) != 0
                  || !
#line 520 "../../gcc/config/s390/vector.md"
(TARGET_VX
   && (!CONST_INT_P (operands[2])
       || UINTVAL (operands[2]) < GET_MODE_NUNITS (V1SFmode))))
                return -1;
              return 557; /* *vec_setv1sf */

            case E_V2SFmode:
              if (pattern199 (x2, 
E_V2SFmode, 
E_SFmode) != 0
                  || !
#line 520 "../../gcc/config/s390/vector.md"
(TARGET_VX
   && (!CONST_INT_P (operands[2])
       || UINTVAL (operands[2]) < GET_MODE_NUNITS (V2SFmode))))
                return -1;
              return 558; /* *vec_setv2sf */

            case E_V4SFmode:
              if (pattern199 (x2, 
E_V4SFmode, 
E_SFmode) != 0
                  || !
#line 520 "../../gcc/config/s390/vector.md"
(TARGET_VX
   && (!CONST_INT_P (operands[2])
       || UINTVAL (operands[2]) < GET_MODE_NUNITS (V4SFmode))))
                return -1;
              return 559; /* *vec_setv4sf */

            case E_V1DFmode:
              if (pattern199 (x2, 
E_V1DFmode, 
E_DFmode) != 0
                  || !
#line 520 "../../gcc/config/s390/vector.md"
(TARGET_VX
   && (!CONST_INT_P (operands[2])
       || UINTVAL (operands[2]) < GET_MODE_NUNITS (V1DFmode))))
                return -1;
              return 560; /* *vec_setv1df */

            case E_V2DFmode:
              if (pattern199 (x2, 
E_V2DFmode, 
E_DFmode) != 0
                  || !
#line 520 "../../gcc/config/s390/vector.md"
(TARGET_VX
   && (!CONST_INT_P (operands[2])
       || UINTVAL (operands[2]) < GET_MODE_NUNITS (V2DFmode))))
                return -1;
              return 561; /* *vec_setv2df */

            default:
              return -1;
            }

        case PLUS:
          if (GET_MODE (x6) != E_SImode)
            return -1;
          x7 = XEXP (x6, 0);
          operands[2] = x7;
          if (!register_operand (operands[2], E_SImode))
            return -1;
          x8 = XEXP (x6, 1);
          operands[4] = x8;
          if (!const_int_operand (operands[4], E_SImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V1QImode:
              if (pattern199 (x2, 
E_V1QImode, 
E_QImode) != 0
                  || !
#line 537 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 562; /* *vec_setv1qi_plus */

            case E_V2QImode:
              if (pattern199 (x2, 
E_V2QImode, 
E_QImode) != 0
                  || !
#line 537 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 563; /* *vec_setv2qi_plus */

            case E_V4QImode:
              if (pattern199 (x2, 
E_V4QImode, 
E_QImode) != 0
                  || !
#line 537 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 564; /* *vec_setv4qi_plus */

            case E_V8QImode:
              if (pattern199 (x2, 
E_V8QImode, 
E_QImode) != 0
                  || !
#line 537 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 565; /* *vec_setv8qi_plus */

            case E_V16QImode:
              if (pattern199 (x2, 
E_V16QImode, 
E_QImode) != 0
                  || !
#line 537 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 566; /* *vec_setv16qi_plus */

            case E_V1HImode:
              if (pattern199 (x2, 
E_V1HImode, 
E_HImode) != 0
                  || !
#line 537 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 567; /* *vec_setv1hi_plus */

            case E_V2HImode:
              if (pattern199 (x2, 
E_V2HImode, 
E_HImode) != 0
                  || !
#line 537 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 568; /* *vec_setv2hi_plus */

            case E_V4HImode:
              if (pattern199 (x2, 
E_V4HImode, 
E_HImode) != 0
                  || !
#line 537 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 569; /* *vec_setv4hi_plus */

            case E_V8HImode:
              if (pattern199 (x2, 
E_V8HImode, 
E_HImode) != 0
                  || !
#line 537 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 570; /* *vec_setv8hi_plus */

            case E_V1SImode:
              if (pattern199 (x2, 
E_V1SImode, 
E_SImode) != 0
                  || !
#line 537 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 571; /* *vec_setv1si_plus */

            case E_V2SImode:
              if (pattern199 (x2, 
E_V2SImode, 
E_SImode) != 0
                  || !
#line 537 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 572; /* *vec_setv2si_plus */

            case E_V4SImode:
              if (pattern199 (x2, 
E_V4SImode, 
E_SImode) != 0
                  || !
#line 537 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 573; /* *vec_setv4si_plus */

            case E_V1DImode:
              if (pattern199 (x2, 
E_V1DImode, 
E_DImode) != 0
                  || !
#line 537 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 574; /* *vec_setv1di_plus */

            case E_V2DImode:
              if (pattern199 (x2, 
E_V2DImode, 
E_DImode) != 0
                  || !
#line 537 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 575; /* *vec_setv2di_plus */

            case E_V1SFmode:
              if (pattern199 (x2, 
E_V1SFmode, 
E_SFmode) != 0
                  || !
#line 537 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 576; /* *vec_setv1sf_plus */

            case E_V2SFmode:
              if (pattern199 (x2, 
E_V2SFmode, 
E_SFmode) != 0
                  || !
#line 537 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 577; /* *vec_setv2sf_plus */

            case E_V4SFmode:
              if (pattern199 (x2, 
E_V4SFmode, 
E_SFmode) != 0
                  || !
#line 537 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 578; /* *vec_setv4sf_plus */

            case E_V1DFmode:
              if (pattern199 (x2, 
E_V1DFmode, 
E_DFmode) != 0
                  || !
#line 537 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 579; /* *vec_setv1df_plus */

            case E_V2DFmode:
              if (pattern199 (x2, 
E_V2DFmode, 
E_DFmode) != 0
                  || !
#line 537 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 580; /* *vec_setv2df_plus */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_32 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (!s390_unsigned_integer_comparison (x3, E_VOIDmode))
    return -1;
  operands[0] = x3;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != PC)
    return -1;
  x5 = XEXP (x3, 0);
  operands[1] = x5;
  x6 = XEXP (x3, 1);
  operands[2] = x6;
  x7 = XEXP (x2, 1);
  switch (GET_CODE (x7))
    {
    case LABEL_REF:
      switch (pattern173 (x2))
        {
        case 0:
          if (!(
#line 1672 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && !TARGET_AVOID_CMP_AND_BRANCH) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 1809; /* *cmp_and_br_unsigned_di */

        case 1:
          if (!
#line 1672 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && !TARGET_AVOID_CMP_AND_BRANCH))
            return -1;
          *pnum_clobbers = 1;
          return 1810; /* *cmp_and_br_unsigned_si */

        default:
          return -1;
        }

    case PC:
      x8 = XEXP (x2, 2);
      switch (pattern174 (x8))
        {
        case 0:
          if (!(
#line 1730 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && !TARGET_AVOID_CMP_AND_BRANCH) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 1813; /* *icmp_and_br_unsigned_di */

        case 1:
          if (!
#line 1730 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && !TARGET_AVOID_CMP_AND_BRANCH))
            return -1;
          *pnum_clobbers = 1;
          return 1814; /* *icmp_and_br_unsigned_si */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_34 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  if (!const_int_operand (operands[2], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode
          || !register_operand (operands[1], E_DImode))
        return -1;
      if ((
#line 4320 "../../gcc/config/s390/s390.md"
(TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[2]), INTVAL (operands[3]),
			     GET_MODE_BITSIZE (DImode))) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
        return 1926; /* *extzvdi_nocc */
      if (pnum_clobbers == NULL
          || !(
#line 4320 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[2]), INTVAL (operands[3]),
			     GET_MODE_BITSIZE (DImode))) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
        return -1;
      *pnum_clobbers = 1;
      return 1927; /* *extzvdi_clobbercc */

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      if (
#line 4320 "../../gcc/config/s390/s390.md"
(TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[2]), INTVAL (operands[3]),
			     GET_MODE_BITSIZE (SImode))))
        return 1928; /* *extzvsi_nocc */
      if (pnum_clobbers == NULL
          || !
#line 4320 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[2]), INTVAL (operands[3]),
			     GET_MODE_BITSIZE (SImode))))
        return -1;
      *pnum_clobbers = 1;
      return 1929; /* *extzvsi_clobbercc */

    default:
      return -1;
    }
}

 int
recog_37 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  x5 = XEXP (x2, 0);
  switch (GET_CODE (x5))
    {
    case ZERO_EXTRACT:
      if (GET_MODE (x5) != E_DImode)
        return -1;
      x6 = XEXP (x5, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x2) != E_DImode)
        return -1;
      x7 = XEXP (x5, 0);
      operands[1] = x7;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      x8 = XEXP (x5, 2);
      operands[2] = x8;
      if (!const_int_operand (operands[2], E_VOIDmode))
        return -1;
      if (
#line 4367 "../../gcc/config/s390/s390.md"
(TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (1, INTVAL (operands[2]), 64)))
        return 1936; /* *extract1bitdi_nocc */
      if (pnum_clobbers == NULL
          || !
#line 4367 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (1, INTVAL (operands[2]), 64)))
        return -1;
      *pnum_clobbers = 1;
      return 1937; /* *extract1bitdi_clobbercc */

    case REG:
    case SUBREG:
      if (pnum_clobbers == NULL)
        return -1;
      operands[1] = x5;
      if (!register_operand (operands[1], E_CCZ1mode)
          || !register_operand (operands[0], E_SImode)
          || GET_MODE (x2) != E_SImode)
        return -1;
      *pnum_clobbers = 1;
      return 2308; /* sne */

    default:
      return -1;
    }
}

 int
recog_38 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_V1QImode:
      if (pattern12 (x1, 
E_V1QImode) != 0
          || !
#line 2128 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1296; /* *vec_cmpgtuv1qiv1qi_nocc */

    case E_V2QImode:
      if (pattern12 (x1, 
E_V2QImode) != 0
          || !
#line 2128 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1299; /* *vec_cmpgtuv2qiv2qi_nocc */

    case E_V4QImode:
      if (pattern12 (x1, 
E_V4QImode) != 0
          || !
#line 2128 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1302; /* *vec_cmpgtuv4qiv4qi_nocc */

    case E_V8QImode:
      if (pattern12 (x1, 
E_V8QImode) != 0
          || !
#line 2128 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1305; /* *vec_cmpgtuv8qiv8qi_nocc */

    case E_V16QImode:
      if (pattern12 (x1, 
E_V16QImode) != 0
          || !
#line 2128 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1308; /* *vec_cmpgtuv16qiv16qi_nocc */

    case E_V1HImode:
      if (pattern12 (x1, 
E_V1HImode) != 0
          || !
#line 2128 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1311; /* *vec_cmpgtuv1hiv1hi_nocc */

    case E_V2HImode:
      if (pattern12 (x1, 
E_V2HImode) != 0
          || !
#line 2128 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1314; /* *vec_cmpgtuv2hiv2hi_nocc */

    case E_V4HImode:
      if (pattern12 (x1, 
E_V4HImode) != 0
          || !
#line 2128 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1317; /* *vec_cmpgtuv4hiv4hi_nocc */

    case E_V8HImode:
      if (pattern12 (x1, 
E_V8HImode) != 0
          || !
#line 2128 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1320; /* *vec_cmpgtuv8hiv8hi_nocc */

    case E_V1SImode:
      if (pattern12 (x1, 
E_V1SImode) != 0
          || !
#line 2128 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1323; /* *vec_cmpgtuv1siv1si_nocc */

    case E_V2SImode:
      if (pattern12 (x1, 
E_V2SImode) != 0
          || !
#line 2128 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1326; /* *vec_cmpgtuv2siv2si_nocc */

    case E_V4SImode:
      if (pattern12 (x1, 
E_V4SImode) != 0
          || !
#line 2128 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1329; /* *vec_cmpgtuv4siv4si_nocc */

    case E_V1DImode:
      if (pattern12 (x1, 
E_V1DImode) != 0
          || !
#line 2128 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1332; /* *vec_cmpgtuv1div1di_nocc */

    case E_V2DImode:
      if (pattern12 (x1, 
E_V2DImode) != 0
          || !
#line 2128 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1335; /* *vec_cmpgtuv2div2di_nocc */

    case E_V1TImode:
      if (!register_operand (x2, E_V1TImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V1TImode)
        return -1;
      x4 = XEXP (x3, 0);
      if (!register_operand (x4, E_V1TImode))
        return -1;
      operands[0] = x4;
      operands[2] = x2;
      x5 = XEXP (x3, 1);
      operands[1] = x5;
      if (register_operand (operands[1], E_V1TImode)
          && (
#line 2128 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 69 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
        return 1338; /* *vec_cmpgtuv1tiv1ti_nocc */
      operands[1] = x4;
      operands[0] = x2;
      operands[2] = x5;
      if (!register_operand (operands[2], E_V1TImode)
          || !
#line 2192 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1346; /* *vec_cmpgtuv1tiv1ti_nocc_emu */

    case E_TImode:
      if (!register_operand (x2, E_TImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_TImode)
        return -1;
      x4 = XEXP (x3, 0);
      if (!register_operand (x4, E_TImode))
        return -1;
      operands[0] = x4;
      operands[2] = x2;
      x5 = XEXP (x3, 1);
      operands[1] = x5;
      if (register_operand (operands[1], E_TImode)
          && (
#line 2128 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 69 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
        return 1341; /* *vec_cmpgtutiti_nocc */
      operands[1] = x4;
      operands[0] = x2;
      operands[2] = x5;
      if (!register_operand (operands[2], E_TImode)
          || !
#line 2192 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1347; /* *vec_cmpgtutiti_nocc_emu */

    default:
      return -1;
    }
}

 int
recog_44 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (maybe_ne (SUBREG_BYTE (x2), 0))
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 0);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[1] = x4;
      if (!general_operand (operands[1], E_FPRX2mode)
          || !nonimmediate_operand (operands[0], E_TFmode)
          || GET_MODE (x2) != E_TFmode
          || !
#line 686 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
        return -1;
      return 645; /* fprx2_to_tf */

    case UNSPEC:
      if (XVECLEN (x4, 0) != 3
          || XINT (x4, 1) != 73
          || GET_MODE (x4) != E_V16QImode)
        return -1;
      x5 = XVECEXP (x4, 0, 0);
      if (GET_CODE (x5) != SUBREG
          || maybe_ne (SUBREG_BYTE (x5), 0)
          || GET_MODE (x5) != E_V16QImode)
        return -1;
      x6 = XVECEXP (x4, 0, 1);
      if (GET_CODE (x6) != SUBREG
          || maybe_ne (SUBREG_BYTE (x6), 0)
          || GET_MODE (x6) != E_V16QImode)
        return -1;
      x7 = XEXP (x5, 0);
      operands[1] = x7;
      x8 = XEXP (x6, 0);
      operands[2] = x8;
      x9 = XVECEXP (x4, 0, 2);
      operands[3] = x9;
      if (!register_operand (operands[3], E_V16QImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          if (pattern289 (x2, 
E_V16QImode) != 0
              || !
#line 781 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 648; /* *vec_permv16qi */

        case E_V8HImode:
          if (pattern289 (x2, 
E_V8HImode) != 0
              || !
#line 781 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 649; /* *vec_permv8hi */

        case E_V4SImode:
          if (pattern289 (x2, 
E_V4SImode) != 0
              || !
#line 781 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 650; /* *vec_permv4si */

        case E_V2DImode:
          if (pattern289 (x2, 
E_V2DImode) != 0
              || !
#line 781 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 651; /* *vec_permv2di */

        case E_V2DFmode:
          if (pattern289 (x2, 
E_V2DFmode) != 0
              || !
#line 781 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 652; /* *vec_permv2df */

        case E_V1TImode:
          if (pattern289 (x2, 
E_V1TImode) != 0
              || !
#line 781 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 653; /* *vec_permv1ti */

        case E_TImode:
          if (pattern289 (x2, 
E_TImode) != 0
              || !
#line 781 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 654; /* *vec_permti */

        case E_V4SFmode:
          if (pattern289 (x2, 
E_V4SFmode) != 0
              || !(
#line 781 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 47 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 655; /* *vec_permv4sf */

        case E_V1TFmode:
          if (pattern289 (x2, 
E_V1TFmode) != 0
              || !(
#line 781 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 47 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 656; /* *vec_permv1tf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_53 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case AND:
      res = recog_39 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      res = recog_45 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case PLUS:
      res = recog_46 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case MINUS:
      res = recog_47 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case MULT:
      res = recog_48 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case SIGN_EXTEND:
      res = recog_49 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case ZERO_EXTEND:
      res = recog_50 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    default:
      break;
    }
  x3 = XEXP (x1, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      operands[0] = x3;
      operands[1] = x2;
      if (address_operand (operands[1], E_QImode))
        {
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (register_operand (operands[0], E_DImode)
                  && 
#line 2311 "../../gcc/config/s390/s390.md"
(TARGET_64BIT))
                return 1851; /* *la_64 */
              break;

            case E_SImode:
              if (register_operand (operands[0], E_SImode)
                  && 
#line 2538 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT && legitimate_la_operand_p (operands[1])))
                return 1855; /* *la_31 */
              break;

            default:
              break;
            }
        }
      break;

    case PC:
      operands[0] = x2;
      if (address_operand (operands[0], E_VOIDmode)
          && 
#line 10382 "../../gcc/config/s390/s390.md"
(!TARGET_INDIRECT_BRANCH_NOBP_JUMP_THUNK))
        return 2547; /* *indirect_jump */
      if (register_operand (operands[0], E_DImode)
          && (
#line 10401 "../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_JUMP_THUNK
  && TARGET_CPU_Z10) && 
#line 778 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
        return 2548; /* indirect_jump_via_thunkdi_z10 */
      if (register_operand (operands[0], E_SImode)
          && (
#line 10401 "../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_JUMP_THUNK
  && TARGET_CPU_Z10) && 
#line 778 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
        return 2549; /* indirect_jump_via_thunksi_z10 */
      if (pnum_clobbers != NULL)
        {
          if (register_operand (operands[0], E_DImode)
              && (
#line 10419 "../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_JUMP_THUNK
  && !TARGET_CPU_Z10) && 
#line 778 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
            {
              *pnum_clobbers = 1;
              return 2550; /* indirect_jump_via_thunkdi */
            }
          if (register_operand (operands[0], E_SImode)
              && (
#line 10419 "../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_JUMP_THUNK
  && !TARGET_CPU_Z10) && 
#line 778 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
            {
              *pnum_clobbers = 1;
              return 2551; /* indirect_jump_via_thunksi */
            }
        }
      if (nonimmediate_operand (operands[0], E_VOIDmode)
          && 
#line 10475 "../../gcc/config/s390/s390.md"
(!TARGET_INDIRECT_BRANCH_NOBP_JUMP))
        return 2556; /* *indirect2_jump */
      break;

    default:
      break;
    }
  operands[0] = x3;
  switch (GET_CODE (x2))
    {
    case AND:
      return recog_52 (x1, insn, pnum_clobbers);

    case SIGN_EXTEND:
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case UNSPEC:
          if (pnum_clobbers == NULL
              || XVECLEN (x4, 0) != 1
              || XINT (x4, 1) != 4
              || GET_MODE (x4) != E_SImode
              || !register_operand (operands[0], E_DImode)
              || GET_MODE (x2) != E_DImode)
            return -1;
          x5 = XVECEXP (x4, 0, 0);
          operands[1] = x5;
          if (!register_operand (operands[1], E_CCUmode)
              || !
#line 4211 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return -1;
          *pnum_clobbers = 1;
          return 1921; /* *cmpint_sign */

        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case MEM:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          switch (pattern88 (x2))
            {
            case 0:
              if (nonimmediate_operand (operands[1], E_SImode)
                  && 
#line 4990 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                return 2014; /* *extendsidi2 */
              if (general_operand (operands[1], E_HImode)
                  && 
#line 5035 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && TARGET_EXTIMM))
                return 2015; /* *extendhidi2_extimm */
              if (memory_operand (operands[1], E_HImode)
                  && 
#line 5049 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                return 2016; /* *extendhidi2 */
              if (nonimmediate_operand (operands[1], E_QImode)
                  && (
#line 5092 "../../gcc/config/s390/s390.md"
(TARGET_EXTIMM) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return 2019; /* *extendqidi2_extimm */
              if (memory_operand (operands[1], E_QImode)
                  && (
#line 5103 "../../gcc/config/s390/s390.md"
(!TARGET_EXTIMM && TARGET_LONG_DISPLACEMENT) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return 2021; /* *extendqidi2 */
              if (pnum_clobbers == NULL
                  || !s_operand (operands[1], E_QImode)
                  || !(
#line 5112 "../../gcc/config/s390/s390.md"
(!TARGET_EXTIMM && !TARGET_LONG_DISPLACEMENT) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              *pnum_clobbers = 1;
              return 2023; /* *extendqidi2_short_displ */

            case 1:
              if (nonimmediate_operand (operands[1], E_HImode)
                  && 
#line 5061 "../../gcc/config/s390/s390.md"
(TARGET_EXTIMM))
                return 2017; /* *extendhisi2_extimm */
              if (!memory_operand (operands[1], E_HImode)
                  || !
#line 5076 "../../gcc/config/s390/s390.md"
(!TARGET_EXTIMM))
                return -1;
              return 2018; /* *extendhisi2 */

            case 2:
              if (nonimmediate_operand (operands[1], E_QImode)
                  && 
#line 5092 "../../gcc/config/s390/s390.md"
(TARGET_EXTIMM))
                return 2020; /* *extendqisi2_extimm */
              if (memory_operand (operands[1], E_QImode)
                  && 
#line 5103 "../../gcc/config/s390/s390.md"
(!TARGET_EXTIMM && TARGET_LONG_DISPLACEMENT))
                return 2022; /* *extendqisi2 */
              if (pnum_clobbers == NULL
                  || !s_operand (operands[1], E_QImode)
                  || !
#line 5112 "../../gcc/config/s390/s390.md"
(!TARGET_EXTIMM && !TARGET_LONG_DISPLACEMENT))
                return -1;
              *pnum_clobbers = 1;
              return 2024; /* *extendqisi2_short_displ */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ZERO_EXTEND:
      switch (pattern88 (x2))
        {
        case 0:
          switch (GET_MODE (operands[1]))
            {
            case E_SImode:
              if (!nonimmediate_operand (operands[1], E_SImode)
                  || !
#line 5148 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                return -1;
              return 2025; /* *zero_extendsidi2 */

            case E_HImode:
              if (nonimmediate_operand (operands[1], E_HImode))
                {
                  if ((
#line 5262 "../../gcc/config/s390/s390.md"
(TARGET_Z10) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return 2030; /* *zero_extendhidi2_z10 */
                  if ((
#line 5277 "../../gcc/config/s390/s390.md"
(TARGET_EXTIMM) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return 2032; /* *zero_extendhidi2_extimm */
                }
              if (!memory_operand (operands[1], E_HImode)
                  || !(
#line 5288 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && !TARGET_EXTIMM) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              return 2036; /* *zero_extendhidi2 */

            case E_QImode:
              if (nonimmediate_operand (operands[1], E_QImode)
                  && (
#line 5277 "../../gcc/config/s390/s390.md"
(TARGET_EXTIMM) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return 2034; /* *zero_extendqidi2_extimm */
              if (!memory_operand (operands[1], E_QImode)
                  || !(
#line 5288 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && !TARGET_EXTIMM) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              return 2038; /* *zero_extendqidi2 */

            default:
              return -1;
            }

        case 1:
          if (nonimmediate_operand (operands[1], E_HImode))
            {
              if (
#line 5262 "../../gcc/config/s390/s390.md"
(TARGET_Z10))
                return 2031; /* *zero_extendhisi2_z10 */
              if (
#line 5277 "../../gcc/config/s390/s390.md"
(TARGET_EXTIMM))
                return 2033; /* *zero_extendhisi2_extimm */
            }
          if (memory_operand (operands[1], E_HImode)
              && 
#line 5288 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && !TARGET_EXTIMM))
            return 2037; /* *zero_extendhisi2 */
          if (pnum_clobbers == NULL
              || !s_operand (operands[1], E_HImode)
              || !
#line 5297 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
            return -1;
          *pnum_clobbers = 1;
          return 2040; /* *zero_extendhisi2_31 */

        case 2:
          if (nonimmediate_operand (operands[1], E_QImode)
              && 
#line 5277 "../../gcc/config/s390/s390.md"
(TARGET_EXTIMM))
            return 2035; /* *zero_extendqisi2_extimm */
          if (!memory_operand (operands[1], E_QImode))
            return -1;
          if (
#line 5288 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && !TARGET_EXTIMM))
            return 2039; /* *zero_extendqisi2 */
          if (!
#line 5309 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
            return -1;
          return 2041; /* *zero_extendqisi2_31 */

        default:
          return -1;
        }

    case PLUS:
      if (pnum_clobbers == NULL)
        return -1;
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case SIGN_EXTEND:
          x6 = XEXP (x4, 0);
          operands[2] = x6;
          x7 = XEXP (x2, 1);
          operands[1] = x7;
          switch (pattern177 (x2))
            {
            case 0:
              if (general_operand (operands[2], E_SImode)
                  && 
#line 6112 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                {
                  *pnum_clobbers = 1;
                  return 2197; /* *adddi3_sign */
                }
              if (!memory_operand (operands[2], E_HImode)
                  || !
#line 6398 "../../gcc/config/s390/s390.md"
(TARGET_Z14))
                return -1;
              *pnum_clobbers = 1;
              return 2221; /* *adddi3_sign */

            case 1:
              *pnum_clobbers = 1;
              return 2202; /* *addsi3_sign */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          if (GET_MODE (x4) != E_DImode
              || !register_operand (operands[0], E_DImode)
              || GET_MODE (x2) != E_DImode)
            return -1;
          x6 = XEXP (x4, 0);
          operands[2] = x6;
          if (!general_operand (operands[2], E_SImode))
            return -1;
          x7 = XEXP (x2, 1);
          operands[1] = x7;
          if (!register_operand (operands[1], E_DImode)
              || !
#line 6151 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return -1;
          *pnum_clobbers = 1;
          return 2200; /* *adddi3_zero */

        case REG:
        case SUBREG:
        case MEM:
          operands[1] = x4;
          switch (pattern158 (x2))
            {
            case 0:
              if (
#line 6163 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
                {
                  *pnum_clobbers = 1;
                  return 2201; /* *adddi3_31z */
                }
              if (!
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                return -1;
              *pnum_clobbers = 1;
              return 2203; /* *adddi3 */

            case 1:
              *pnum_clobbers = 1;
              return 2204; /* *addsi3 */

            default:
              return -1;
            }

        case PLUS:
          x6 = XEXP (x4, 0);
          operands[3] = x6;
          x8 = XEXP (x4, 1);
          operands[1] = x8;
          x7 = XEXP (x2, 1);
          operands[2] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (pattern209 (x2, 
E_DImode) != 0
                  || !
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                return -1;
              *pnum_clobbers = 1;
              return 2296; /* *adddi3_alc */

            case E_SImode:
              if (pattern209 (x2, 
E_SImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 2297; /* *addsi3_alc */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case MINUS:
      if (pnum_clobbers == NULL)
        return -1;
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
          operands[1] = x4;
          x7 = XEXP (x2, 1);
          switch (GET_CODE (x7))
            {
            case SIGN_EXTEND:
              x9 = XEXP (x7, 0);
              operands[2] = x9;
              switch (GET_MODE (operands[0]))
                {
                case E_DImode:
                  if (pattern210 (x2, 
E_DImode) != 0)
                    return -1;
                  if (general_operand (operands[2], E_SImode)
                      && 
#line 6658 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                    {
                      *pnum_clobbers = 1;
                      return 2245; /* *subdi3_sign */
                    }
                  if (!memory_operand (operands[2], E_HImode)
                      || !
#line 6884 "../../gcc/config/s390/s390.md"
(TARGET_Z14))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2265; /* *subdi3_sign */

                case E_SImode:
                  if (pattern210 (x2, 
E_SImode) != 0
                      || !memory_operand (operands[2], E_HImode))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2250; /* *subsi3_sign */

                default:
                  return -1;
                }

            case ZERO_EXTEND:
              if (GET_MODE (x7) != E_DImode
                  || !register_operand (operands[0], E_DImode)
                  || GET_MODE (x2) != E_DImode
                  || !register_operand (operands[1], E_DImode))
                return -1;
              x9 = XEXP (x7, 0);
              operands[2] = x9;
              if (!general_operand (operands[2], E_SImode)
                  || !
#line 6698 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                return -1;
              *pnum_clobbers = 1;
              return 2248; /* *subdi3_zero */

            case CONST_INT:
            case CONST_WIDE_INT:
            case CONST_POLY_INT:
            case CONST_FIXED:
            case CONST_DOUBLE:
            case CONST_VECTOR:
            case CONST:
            case REG:
            case SUBREG:
            case MEM:
            case LABEL_REF:
            case SYMBOL_REF:
            case HIGH:
              operands[2] = x7;
              switch (GET_MODE (operands[0]))
                {
                case E_DImode:
                  if (pattern85 (x2, 
E_DImode) != 0)
                    return -1;
                  if (
#line 6710 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
                    {
                      *pnum_clobbers = 1;
                      return 2249; /* *subdi3_31z */
                    }
                  if (!
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2251; /* *subdi3 */

                case E_SImode:
                  if (pattern85 (x2, 
E_SImode) != 0)
                    return -1;
                  *pnum_clobbers = 1;
                  return 2252; /* *subsi3 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case MINUS:
          x6 = XEXP (x4, 0);
          operands[1] = x6;
          x8 = XEXP (x4, 1);
          operands[2] = x8;
          x7 = XEXP (x2, 1);
          operands[3] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (pattern211 (x2, 
E_DImode) != 0
                  || !
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                return -1;
              *pnum_clobbers = 1;
              return 2300; /* *subdi3_slb */

            case E_SImode:
              if (pattern211 (x2, 
E_SImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 2301; /* *subsi3_slb */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case MULT:
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case SIGN_EXTEND:
          x7 = XEXP (x2, 1);
          switch (GET_CODE (x7))
            {
            case REG:
            case SUBREG:
              operands[1] = x7;
              x6 = XEXP (x4, 0);
              operands[2] = x6;
              switch (pattern177 (x2))
                {
                case 0:
                  if (general_operand (operands[2], E_SImode)
                      && 
#line 7404 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                    return 2313; /* *muldi3_sign */
                  if (!memory_operand (operands[2], E_HImode)
                      || !
#line 7456 "../../gcc/config/s390/s390.md"
(TARGET_Z14))
                    return -1;
                  return 2317; /* *muldi3_sign */

                case 1:
                  return 2318; /* *mulsi3_sign */

                default:
                  return -1;
                }

            case SIGN_EXTEND:
              if (GET_MODE (x7) != E_DImode
                  || !register_operand (operands[0], E_DImode)
                  || GET_MODE (x2) != E_DImode
                  || GET_MODE (x4) != E_DImode)
                return -1;
              x6 = XEXP (x4, 0);
              operands[1] = x6;
              if (!register_operand (operands[1], E_SImode))
                return -1;
              x9 = XEXP (x7, 0);
              operands[2] = x9;
              if (!nonimmediate_operand (operands[2], E_SImode)
                  || !
#line 7512 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
                return -1;
              return 2320; /* mulsidi3 */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
        case MEM:
          if (pnum_clobbers == NULL)
            return -1;
          operands[1] = x4;
          x7 = XEXP (x2, 1);
          operands[2] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (pattern176 (x2, 
E_DImode) != 0
                  || !
#line 7416 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                return -1;
              *pnum_clobbers = 1;
              return 2314; /* *muldi3 */

            case E_SImode:
              if (pattern176 (x2, 
E_SImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 2319; /* *mulsi3 */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          if (pattern113 (x2, 
E_SImode, 
E_DImode) != 0
              || !
#line 782 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
            return -1;
          return 2324; /* umulsidi3 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_67 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  switch (pattern11 (x3))
    {
    case 0:
      if (register_operand (operands[2], E_V1QImode)
          && 
#line 1465 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 975; /* vrotlv1qi3 */
      if (!shift_count_operand_vec (operands[2], E_QImode)
          || !
#line 1524 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V1QImode)) - 1)
  ))
        return -1;
      return 992; /* *rotlv1qi3 */

    case 1:
      if (register_operand (operands[2], E_V2QImode)
          && 
#line 1465 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 976; /* vrotlv2qi3 */
      if (!shift_count_operand_vec (operands[2], E_QImode)
          || !
#line 1524 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V2QImode)) - 1)
  ))
        return -1;
      return 996; /* *rotlv2qi3 */

    case 2:
      if (register_operand (operands[2], E_V4QImode)
          && 
#line 1465 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 977; /* vrotlv4qi3 */
      if (!shift_count_operand_vec (operands[2], E_QImode)
          || !
#line 1524 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V4QImode)) - 1)
  ))
        return -1;
      return 1000; /* *rotlv4qi3 */

    case 3:
      if (register_operand (operands[2], E_V8QImode)
          && 
#line 1465 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 978; /* vrotlv8qi3 */
      if (!shift_count_operand_vec (operands[2], E_QImode)
          || !
#line 1524 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V8QImode)) - 1)
  ))
        return -1;
      return 1004; /* *rotlv8qi3 */

    case 4:
      if (register_operand (operands[2], E_V16QImode)
          && 
#line 1465 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 979; /* vrotlv16qi3 */
      if (!shift_count_operand_vec (operands[2], E_QImode)
          || !
#line 1524 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V16QImode)) - 1)
  ))
        return -1;
      return 1008; /* *rotlv16qi3 */

    case 5:
      if (register_operand (operands[2], E_V1HImode)
          && 
#line 1465 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 980; /* vrotlv1hi3 */
      if (!shift_count_operand_vec (operands[2], E_QImode)
          || !
#line 1524 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V1HImode)) - 1)
  ))
        return -1;
      return 1012; /* *rotlv1hi3 */

    case 6:
      if (register_operand (operands[2], E_V2HImode)
          && 
#line 1465 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 981; /* vrotlv2hi3 */
      if (!shift_count_operand_vec (operands[2], E_QImode)
          || !
#line 1524 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V2HImode)) - 1)
  ))
        return -1;
      return 1016; /* *rotlv2hi3 */

    case 7:
      if (register_operand (operands[2], E_V4HImode)
          && 
#line 1465 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 982; /* vrotlv4hi3 */
      if (!shift_count_operand_vec (operands[2], E_QImode)
          || !
#line 1524 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V4HImode)) - 1)
  ))
        return -1;
      return 1020; /* *rotlv4hi3 */

    case 8:
      if (register_operand (operands[2], E_V8HImode)
          && 
#line 1465 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 983; /* vrotlv8hi3 */
      if (!shift_count_operand_vec (operands[2], E_QImode)
          || !
#line 1524 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V8HImode)) - 1)
  ))
        return -1;
      return 1024; /* *rotlv8hi3 */

    case 9:
      if (register_operand (operands[2], E_V1SImode)
          && 
#line 1465 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 984; /* vrotlv1si3 */
      if (!shift_count_operand_vec (operands[2], E_QImode)
          || !
#line 1524 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V1SImode)) - 1)
  ))
        return -1;
      return 1028; /* *rotlv1si3 */

    case 10:
      if (register_operand (operands[2], E_V2SImode)
          && 
#line 1465 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 985; /* vrotlv2si3 */
      if (!shift_count_operand_vec (operands[2], E_QImode)
          || !
#line 1524 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V2SImode)) - 1)
  ))
        return -1;
      return 1032; /* *rotlv2si3 */

    case 11:
      if (register_operand (operands[2], E_V4SImode)
          && 
#line 1465 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 986; /* vrotlv4si3 */
      if (!shift_count_operand_vec (operands[2], E_QImode)
          || !
#line 1524 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V4SImode)) - 1)
  ))
        return -1;
      return 1036; /* *rotlv4si3 */

    case 12:
      if (register_operand (operands[2], E_V1DImode)
          && 
#line 1465 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 987; /* vrotlv1di3 */
      if (!shift_count_operand_vec (operands[2], E_QImode)
          || !
#line 1524 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V1DImode)) - 1)
  ))
        return -1;
      return 1040; /* *rotlv1di3 */

    case 13:
      if (register_operand (operands[2], E_V2DImode)
          && 
#line 1465 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 988; /* vrotlv2di3 */
      if (!shift_count_operand_vec (operands[2], E_QImode)
          || !
#line 1524 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V2DImode)) - 1)
  ))
        return -1;
      return 1044; /* *rotlv2di3 */

    case 14:
      if (!
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
        return -1;
      return 2508; /* *rotldi3 */

    case 15:
      return 2509; /* *rotlsi3 */

    default:
      return -1;
    }
}

 int
recog_75 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x3) != E_V2DFmode
          || !register_operand (operands[1], E_V2DImode)
          || !
#line 2972 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1531; /* floatv2div2df2 */

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !register_operand (operands[1], E_V4SImode)
          || !(
#line 2972 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 99 "../../gcc/config/s390/vector.md"
(TARGET_VXE2)))
        return -1;
      return 1532; /* floatv4siv4sf2 */

    case E_TFmode:
      switch (pattern67 (x3, 
E_TFmode))
        {
        case 0:
          if (!(
#line 5633 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && TARGET_HARD_FLOAT) && 
#line 751 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          return 2070; /* floatditf2_fpr */

        case 1:
          if (!(
#line 5646 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 758 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          return 2076; /* floatsitf2_fpr */

        default:
          return -1;
        }

    case E_FPRX2mode:
      switch (pattern67 (x3, 
E_FPRX2mode))
        {
        case 0:
          if (!(
#line 5633 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && TARGET_HARD_FLOAT) && 
#line 751 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          return 2071; /* floatdifprx22 */

        case 1:
          if (!(
#line 5646 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 758 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          return 2077; /* floatsifprx22 */

        default:
          return -1;
        }

    case E_DFmode:
      switch (pattern67 (x3, 
E_DFmode))
        {
        case 0:
          if (!
#line 5633 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && TARGET_HARD_FLOAT))
            return -1;
          return 2072; /* floatdidf2 */

        case 1:
          if (!
#line 5646 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 2078; /* floatsidf2 */

        default:
          return -1;
        }

    case E_SFmode:
      switch (pattern67 (x3, 
E_SFmode))
        {
        case 0:
          if (!
#line 5633 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && TARGET_HARD_FLOAT))
            return -1;
          return 2073; /* floatdisf2 */

        case 1:
          if (!
#line 5646 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 2079; /* floatsisf2 */

        default:
          return -1;
        }

    case E_TDmode:
      switch (pattern67 (x3, 
E_TDmode))
        {
        case 0:
          if (!(
#line 5633 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && TARGET_HARD_FLOAT) && 
#line 752 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          return 2074; /* floatditd2 */

        case 1:
          if (!
#line 5659 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT))
            return -1;
          return 2080; /* floatsitd2 */

        default:
          return -1;
        }

    case E_DDmode:
      switch (pattern67 (x3, 
E_DDmode))
        {
        case 0:
          if (!(
#line 5633 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && TARGET_HARD_FLOAT) && 
#line 752 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          return 2075; /* floatdidd2 */

        case 1:
          if (!
#line 5659 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT))
            return -1;
          return 2081; /* floatsidd2 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_85 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x2))
    {
    case SET:
      x3 = XEXP (x2, 1);
      if (GET_CODE (x3) != ABS
          || !register_operand (operands[1], E_DImode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x5 = XEXP (x3, 0);
      if (!rtx_equal_p (x5, operands[1]))
        return -1;
      x6 = XVECEXP (x1, 0, 0);
      x7 = XEXP (x6, 1);
      x8 = XEXP (x7, 0);
      switch (GET_MODE (x8))
        {
        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || !(
#line 9316 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCAmode)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 2451; /* *absdi2_cc */

        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !
#line 9316 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCAmode)))
            return -1;
          return 2452; /* *abssi2_cc */

        default:
          return -1;
        }

    case CLOBBER:
      switch (pattern192 (x1))
        {
        case 0:
          if (!(
#line 9327 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCAmode)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 2453; /* *absdi2_cconly */

        case 1:
          if (!
#line 9327 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCAmode)))
            return -1;
          return 2454; /* *abssi2_cconly */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_92 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[0] = x4;
  if (s390_signed_integer_comparison (operands[0], E_VOIDmode))
    {
      switch (pattern118 (x1))
        {
        case 0:
          if ((
#line 1644 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && !TARGET_AVOID_CMP_AND_BRANCH) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return 1807; /* *cmp_and_br_signed_di */
          break;

        case 1:
          if (
#line 1644 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && !TARGET_AVOID_CMP_AND_BRANCH))
            return 1808; /* *cmp_and_br_signed_si */
          break;

        case 2:
          if ((
#line 1702 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && !TARGET_AVOID_CMP_AND_BRANCH) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return 1811; /* *icmp_and_br_signed_di */
          break;

        case 3:
          if (
#line 1702 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && !TARGET_AVOID_CMP_AND_BRANCH))
            return 1812; /* *icmp_and_br_signed_si */
          break;

        default:
          break;
        }
    }
  x5 = XEXP (x3, 1);
  if (GET_CODE (x5) != LABEL_REF)
    return -1;
  x6 = XEXP (x3, 2);
  if (GET_CODE (x6) != PC)
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x7) != SET)
    return -1;
  switch (GET_CODE (x4))
    {
    case GT:
    case LE:
      if (pnum_clobbers == NULL
          || !s390_brx_operator (x4, E_VOIDmode))
        return -1;
      x8 = XEXP (x4, 0);
      if (GET_CODE (x8) != PLUS)
        return -1;
      x9 = XEXP (x7, 1);
      if (GET_CODE (x9) != PLUS)
        return -1;
      x10 = XEXP (x8, 0);
      operands[1] = x10;
      x11 = XEXP (x5, 0);
      operands[0] = x11;
      x12 = XEXP (x9, 0);
      if (!rtx_equal_p (x12, operands[1]))
        return -1;
      operands[6] = x4;
      res = recog_90 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      x13 = XEXP (x8, 1);
      if (GET_CODE (x13) != SUBREG)
        return -1;
      x14 = XEXP (x4, 1);
      if (GET_CODE (x14) != SUBREG)
        return -1;
      x15 = XEXP (x9, 1);
      if (GET_CODE (x15) != SUBREG)
        return -1;
      operands[5] = x4;
      x16 = XEXP (x13, 0);
      operands[2] = x16;
      x17 = XEXP (x7, 0);
      operands[3] = x17;
      x18 = XEXP (x14, 0);
      if (!rtx_equal_p (x18, operands[2]))
        return -1;
      x19 = XEXP (x15, 0);
      if (!rtx_equal_p (x19, operands[2]))
        return -1;
      switch (SUBREG_BYTE (x13))
        {
        case 0:
          if (maybe_ne (SUBREG_BYTE (x15), 0))
            return -1;
          switch (SUBREG_BYTE (x14))
            {
            case 8:
              if (pattern297 (x1, 
E_DImode, 
E_TImode) != 0
                  || !
#line 10071 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                return -1;
              *pnum_clobbers = 2;
              return 2541; /* *brxg_64bit */

            case 4:
              if (pattern297 (x1, 
E_SImode, 
E_DImode) != 0
                  || !
#line 10157 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
                return -1;
              *pnum_clobbers = 2;
              return 2543; /* *brx_31bit */

            default:
              return -1;
            }

        case 4:
          if (GET_MODE (x13) != E_SImode
              || maybe_ne (SUBREG_BYTE (x14), 12)
              || GET_MODE (x14) != E_SImode
              || maybe_ne (SUBREG_BYTE (x15), 4)
              || GET_MODE (x15) != E_SImode
              || GET_MODE (x8) != E_SImode
              || !register_operand (operands[1], E_SImode)
              || !register_operand (operands[2], E_TImode)
              || !nonimmediate_operand (operands[3], E_SImode)
              || GET_MODE (x9) != E_SImode
              || !
#line 10114 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return -1;
          *pnum_clobbers = 2;
          return 2542; /* *brx_64bit */

        default:
          return -1;
        }

    case NE:
    case EQ:
      if (pnum_clobbers != NULL)
        {
          res = recog_91 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[0] = x4;
      if (!s390_eqne_operator (operands[0], E_VOIDmode))
        return -1;
      x8 = XEXP (x4, 0);
      if (GET_CODE (x8) != REG
          || REGNO (x8) != 33
          || GET_MODE (x8) != E_CCRAWmode
          || pattern232 (x1) != 0)
        return -1;
      return 2653; /* *ccraw_to_int */

    default:
      return -1;
    }
}

 int
recog_99 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  if (pattern38 (x1) != 0)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case MEM:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_TImode:
              if (pattern219 (x3, 
E_TImode) != 0
                  || !
#line 6619 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                return -1;
              return 2244; /* *subti3 */

            case E_DImode:
              if (pattern219 (x3, 
E_DImode) != 0)
                return -1;
              if (
#line 6710 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
                return 2249; /* *subdi3_31z */
              if (!
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                return -1;
              return 2251; /* *subdi3 */

            case E_SImode:
              if (pattern219 (x3, 
E_SImode) != 0)
                return -1;
              return 2252; /* *subsi3 */

            case E_TFmode:
              if (pattern219 (x3, 
E_TFmode) != 0
                  || !(
#line 6935 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 751 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              return 2268; /* subtf3_fpr */

            case E_FPRX2mode:
              if (pattern219 (x3, 
E_FPRX2mode) != 0
                  || !(
#line 6935 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 751 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              return 2269; /* subfprx23 */

            case E_DFmode:
              if (pattern219 (x3, 
E_DFmode) != 0
                  || !
#line 6935 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 2270; /* subdf3 */

            case E_SFmode:
              if (pattern219 (x3, 
E_SFmode) != 0
                  || !
#line 6935 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 2271; /* subsf3 */

            case E_TDmode:
              if (pattern219 (x3, 
E_TDmode) != 0
                  || !(
#line 6935 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 752 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
                return -1;
              return 2272; /* subtd3 */

            case E_DDmode:
              if (pattern219 (x3, 
E_DDmode) != 0
                  || !(
#line 6935 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 752 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
                return -1;
              return 2273; /* subdd3 */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          x6 = XEXP (x5, 0);
          operands[2] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (pattern248 (x3, 
E_DImode) != 0)
                return -1;
              if (general_operand (operands[2], E_SImode)
                  && 
#line 6658 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                return 2245; /* *subdi3_sign */
              if (!memory_operand (operands[2], E_HImode)
                  || !
#line 6884 "../../gcc/config/s390/s390.md"
(TARGET_Z14))
                return -1;
              return 2265; /* *subdi3_sign */

            case E_SImode:
              if (pattern248 (x3, 
E_SImode) != 0
                  || !memory_operand (operands[2], E_HImode))
                return -1;
              return 2250; /* *subsi3_sign */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          if (GET_MODE (x5) != E_DImode
              || !register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || !register_operand (operands[1], E_DImode))
            return -1;
          x6 = XEXP (x5, 0);
          operands[2] = x6;
          if (!general_operand (operands[2], E_SImode)
              || !
#line 6698 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return -1;
          return 2248; /* *subdi3_zero */

        default:
          return -1;
        }

    case MINUS:
      x7 = XEXP (x4, 0);
      operands[1] = x7;
      x8 = XEXP (x4, 1);
      operands[2] = x8;
      x5 = XEXP (x3, 1);
      operands[3] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (pattern249 (x3, 
E_DImode) != 0
              || !
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return -1;
          return 2300; /* *subdi3_slb */

        case E_SImode:
          if (pattern249 (x3, 
E_SImode) != 0)
            return -1;
          return 2301; /* *subsi3_slb */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_107 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (pattern38 (x1) != 0)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case SIGN_EXTEND:
      if (pattern180 (x3) != 0
          || !
#line 9103 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
        return -1;
      return 2423; /* *negdi2_sign */

    case REG:
    case SUBREG:
      switch (pattern181 (x3))
        {
        case 0:
          if (
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return 2428; /* *negdi2 */
          if (!
#line 9145 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
            return -1;
          return 2430; /* *negdi2_31 */

        case 1:
          return 2429; /* *negsi2 */

        case 2:
          if (!(
#line 9268 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 758 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          return 2445; /* *negtf2 */

        case 3:
          if (!(
#line 9268 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 758 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          return 2446; /* *negfprx22 */

        case 4:
          if (!
#line 9268 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 2447; /* *negdf2 */

        case 5:
          if (!
#line 9268 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 2448; /* *negsf2 */

        default:
          return -1;
        }

    case ABS:
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case SIGN_EXTEND:
          if (GET_MODE (x5) != E_DImode
              || !register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || GET_MODE (x4) != E_DImode)
            return -1;
          x6 = XEXP (x5, 0);
          operands[1] = x6;
          if (!register_operand (operands[1], E_SImode)
              || !
#line 9451 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return -1;
          return 2476; /* *negabsdi2_sign */

        case REG:
        case SUBREG:
          operands[1] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (pattern228 (x3, 
E_DImode) != 0
                  || !
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                return -1;
              return 2481; /* *negabsdi2 */

            case E_SImode:
              if (pattern228 (x3, 
E_SImode) != 0)
                return -1;
              return 2482; /* *negabssi2 */

            case E_TFmode:
              if (pattern228 (x3, 
E_TFmode) != 0
                  || !(
#line 9531 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 758 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              return 2497; /* *negabstf2 */

            case E_FPRX2mode:
              if (pattern228 (x3, 
E_FPRX2mode) != 0
                  || !(
#line 9531 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 758 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              return 2498; /* *negabsfprx22 */

            case E_DFmode:
              if (pattern228 (x3, 
E_DFmode) != 0
                  || !
#line 9531 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 2499; /* *negabsdf2 */

            case E_SFmode:
              if (pattern228 (x3, 
E_SFmode) != 0
                  || !
#line 9531 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 2500; /* *negabssf2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_111 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], E_VOIDmode))
    return -1;
  x2 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 1)
    return -1;
  switch (GET_MODE (x3))
    {
    case E_DImode:
      if (!(
#line 11049 "../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_CALL
   && !TARGET_CPU_Z10
   && !SIBLING_CALL_P (insn)
   && GET_MODE (operands[3]) == Pmode) && 
#line 778 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
        return -1;
      return 2584; /* *basr_r_via_thunk */

    case E_SImode:
      if (!(
#line 11049 "../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_CALL
   && !TARGET_CPU_Z10
   && !SIBLING_CALL_P (insn)
   && GET_MODE (operands[3]) == Pmode) && 
#line 778 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
        return -1;
      return 2585; /* *basr_r_via_thunk */

    default:
      return -1;
    }
}

 int
recog_112 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case VEC_SELECT:
      if (GET_MODE (x3) != E_V8HImode)
        return -1;
      x4 = XEXP (x3, 1);
      if (GET_CODE (x4) != PARALLEL
          || XVECLEN (x4, 0) != 8)
        return -1;
      x5 = XVECEXP (x4, 0, 0);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 7])
        return -1;
      x6 = XVECEXP (x4, 0, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
        return -1;
      x7 = XVECEXP (x4, 0, 2);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
        return -1;
      x8 = XVECEXP (x4, 0, 3);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
        return -1;
      x9 = XVECEXP (x4, 0, 4);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
        return -1;
      x10 = XVECEXP (x4, 0, 5);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
        return -1;
      x11 = XVECEXP (x4, 0, 6);
      if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x12 = XVECEXP (x4, 0, 7);
      if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x13 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x13) != CLOBBER)
        return -1;
      x14 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x14) != CLOBBER
          || pattern266 (x1) != 0
          || !
#line 1046 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 679; /* eltswapv8hi */

    case UNSPEC:
      if (XVECLEN (x3, 0) != 4
          || XINT (x3, 1) != 31)
        return -1;
      x15 = XVECEXP (x3, 0, 1);
      if (GET_CODE (x15) != MEM
          || GET_MODE (x15) != E_BLKmode)
        return -1;
      x16 = XVECEXP (x3, 0, 2);
      if (GET_CODE (x16) != REG
          || REGNO (x16) != 0
          || GET_MODE (x16) != E_SImode)
        return -1;
      x13 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x13) != CLOBBER)
        return -1;
      x14 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x14) != CLOBBER)
        return -1;
      x17 = XEXP (x14, 0);
      if (GET_CODE (x17) != REG
          || REGNO (x17) != 33
          || GET_MODE (x17) != E_CCmode)
        return -1;
      x18 = XEXP (x2, 0);
      operands[0] = x18;
      x19 = XVECEXP (x3, 0, 0);
      operands[2] = x19;
      x20 = XEXP (x15, 0);
      operands[3] = x20;
      x21 = XVECEXP (x3, 0, 3);
      operands[4] = x21;
      if (!immediate_operand (operands[4], E_VOIDmode))
        return -1;
      x22 = XEXP (x13, 0);
      operands[1] = x22;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (pattern291 (x3, 
E_DImode) != 0
              || !
#line 778 "../../gcc/config/s390/s390.md"
(TARGET_64BIT))
            return -1;
          return 1886; /* *strlendi */

        case E_SImode:
          if (pattern291 (x3, 
E_SImode) != 0
              || !
#line 778 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT))
            return -1;
          return 1887; /* *strlensi */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
    case MEM:
      x18 = XEXP (x2, 0);
      switch (GET_CODE (x18))
        {
        case REG:
        case SUBREG:
        case MEM:
          operands[0] = x18;
          operands[1] = x3;
          x13 = XVECEXP (x1, 0, 1);
          switch (GET_CODE (x13))
            {
            case USE:
              if (pnum_clobbers == NULL)
                return -1;
              x14 = XVECEXP (x1, 0, 2);
              if (GET_CODE (x14) != USE
                  || !memory_operand (operands[0], E_BLKmode)
                  || !memory_operand (operands[1], E_BLKmode))
                return -1;
              x22 = XEXP (x13, 0);
              operands[2] = x22;
              if (!nonmemory_operand (operands[2], E_VOIDmode))
                return -1;
              x17 = XEXP (x14, 0);
              operands[3] = x17;
              if (!immediate_operand (operands[3], E_VOIDmode))
                return -1;
              if ((
#line 3594 "../../gcc/config/s390/s390.md"
((GET_MODE (operands[2]) == Pmode || GET_MODE (operands[2]) == VOIDmode)) && 
#line 778 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
                {
                  *pnum_clobbers = 1;
                  return 1892; /* *cpymem_short */
                }
              if (!(
#line 3594 "../../gcc/config/s390/s390.md"
((GET_MODE (operands[2]) == Pmode || GET_MODE (operands[2]) == VOIDmode)) && 
#line 778 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 1893; /* *cpymem_short */

            case SET:
              x23 = XEXP (x13, 1);
              if (pattern152 (x23, 
E_TImode, 
9, 
UNSPEC_VOLATILE, 
3) != 0)
                return -1;
              x14 = XVECEXP (x1, 0, 2);
              if (pattern182 (x14) != 0
                  || !register_operand (operands[0], E_TImode)
                  || !nonsym_memory_operand (operands[1], E_TImode))
                return -1;
              x24 = XVECEXP (x23, 0, 1);
              operands[2] = x24;
              if (!register_operand (operands[2], E_TImode))
                return -1;
              x25 = XVECEXP (x23, 0, 2);
              operands[3] = x25;
              if (!register_operand (operands[3], E_TImode))
                return -1;
              x26 = XVECEXP (x23, 0, 0);
              if (!rtx_equal_p (x26, operands[1]))
                return -1;
              x22 = XEXP (x13, 0);
              if (!rtx_equal_p (x22, operands[1]))
                return -1;
              x27 = XEXP (x14, 1);
              x28 = XEXP (x27, 0);
              if (!rtx_equal_p (x28, operands[1]))
                return -1;
              x29 = XEXP (x27, 1);
              if (!rtx_equal_p (x29, operands[2])
                  || !
#line 11352 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH
   && s390_match_ccmode (insn, CCZ1mode)))
                return -1;
              return 2597; /* *atomic_compare_and_swapti_1 */

            default:
              return -1;
            }

        case PC:
          x13 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x13) != USE)
            return -1;
          x22 = XEXP (x13, 0);
          if (GET_CODE (x22) != LABEL_REF)
            return -1;
          x14 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x14) != CLOBBER)
            return -1;
          x17 = XEXP (x14, 0);
          if (GET_CODE (x17) != REG
              || REGNO (x17) != 1)
            return -1;
          operands[0] = x3;
          x30 = XEXP (x22, 0);
          operands[1] = x30;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (!register_operand (operands[0], E_DImode)
                  || GET_MODE (x17) != E_DImode
                  || !(
#line 10591 "../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_JUMP_THUNK
  && !TARGET_CPU_Z10) && 
#line 778 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
                return -1;
              return 2560; /* casesi_jump_via_thunkdi */

            case E_SImode:
              if (!register_operand (operands[0], E_SImode)
                  || GET_MODE (x17) != E_SImode
                  || !(
#line 10591 "../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_JUMP_THUNK
  && !TARGET_CPU_Z10) && 
#line 778 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
                return -1;
              return 2561; /* casesi_jump_via_thunksi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case CONST_INT:
      if (XWINT (x3, 0) != 0L)
        return -1;
      x13 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x13) != USE)
        return -1;
      x18 = XEXP (x2, 0);
      operands[0] = x18;
      if (!memory_operand (operands[0], E_BLKmode))
        return -1;
      x22 = XEXP (x13, 0);
      operands[1] = x22;
      x14 = XVECEXP (x1, 0, 2);
      switch (GET_CODE (x14))
        {
        case USE:
          if (pnum_clobbers == NULL
              || !nonmemory_operand (operands[1], E_VOIDmode))
            return -1;
          x17 = XEXP (x14, 0);
          operands[2] = x17;
          if (!immediate_operand (operands[2], E_VOIDmode))
            return -1;
          if ((
#line 3849 "../../gcc/config/s390/s390.md"
((GET_MODE (operands[1]) == Pmode || GET_MODE (operands[1]) == VOIDmode)) && 
#line 778 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
            {
              *pnum_clobbers = 2;
              return 1906; /* *clrmem_short */
            }
          if (!(
#line 3849 "../../gcc/config/s390/s390.md"
((GET_MODE (operands[1]) == Pmode || GET_MODE (operands[1]) == VOIDmode)) && 
#line 778 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 2;
          return 1907; /* *clrmem_short */

        case CLOBBER:
          x17 = XEXP (x14, 0);
          if (GET_CODE (x17) != REG
              || REGNO (x17) != 33
              || GET_MODE (x17) != E_CCmode
              || !const_int_operand (operands[1], E_VOIDmode)
              || !
#line 9005 "../../gcc/config/s390/s390.md"
(INTVAL (operands[1]) >= 1 && INTVAL (operands[1]) <= 256))
            return -1;
          return 2415; /* *xc_zero */

        default:
          return -1;
        }

    case COMPARE:
      if (pnum_clobbers == NULL
          || pattern73 (x1) != 0)
        return -1;
      x13 = XVECEXP (x1, 0, 1);
      x22 = XEXP (x13, 0);
      operands[2] = x22;
      if (!nonmemory_operand (operands[2], E_VOIDmode))
        return -1;
      x14 = XVECEXP (x1, 0, 2);
      x17 = XEXP (x14, 0);
      operands[3] = x17;
      if (!immediate_operand (operands[3], E_VOIDmode))
        return -1;
      if ((
#line 4043 "../../gcc/config/s390/s390.md"
((GET_MODE (operands[2]) == Pmode || GET_MODE (operands[2]) == VOIDmode)) && 
#line 778 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
        {
          *pnum_clobbers = 1;
          return 1914; /* *cmpmem_short */
        }
      if (!(
#line 4043 "../../gcc/config/s390/s390.md"
((GET_MODE (operands[2]) == Pmode || GET_MODE (operands[2]) == VOIDmode)) && 
#line 778 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
        return -1;
      *pnum_clobbers = 1;
      return 1915; /* *cmpmem_short */

    case UNSIGNED_FIX:
      if (pattern42 (x1) != 0)
        return -1;
      switch (pattern150 (x1))
        {
        case 0:
          if (
#line 5521 "../../gcc/config/s390/s390.md"
(TARGET_VX && TARGET_HARD_FLOAT))
            return 2044; /* *fixuns_truncdfdi2_z13 */
          if (!(
#line 5536 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
    && (!TARGET_VX || DImode != DImode || DFmode != DFmode)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 2050; /* *fixuns_truncdfdi2_z196 */

        case 1:
          if (!(
#line 5536 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
    && (!TARGET_VX || DImode != DImode || TFmode != DFmode)) && (((
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH) && 
#line 751 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))))
            return -1;
          return 2046; /* *fixuns_trunctfdi2_z196 */

        case 2:
          if (!(
#line 5536 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
    && (!TARGET_VX || DImode != DImode || FPRX2mode != DFmode)) && (((
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH) && 
#line 751 "../../gcc/config/s390/s390.md"
(TARGET_VXE)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))))
            return -1;
          return 2048; /* *fixuns_truncfprx2di2_z196 */

        case 3:
          if (!(
#line 5536 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
    && (!TARGET_VX || DImode != DImode || SFmode != DFmode)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 2052; /* *fixuns_truncsfdi2_z196 */

        case 4:
          if (!(
#line 5536 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
    && (!TARGET_VX || DImode != DImode || TDmode != DFmode)) && (((
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH) && 
#line 752 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))))
            return -1;
          return 2054; /* *fixuns_trunctddi2_z196 */

        case 5:
          if (!(
#line 5536 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
    && (!TARGET_VX || DImode != DImode || DDmode != DFmode)) && (((
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH) && 
#line 752 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))))
            return -1;
          return 2056; /* *fixuns_truncdddi2_z196 */

        case 6:
          if (!(
#line 5521 "../../gcc/config/s390/s390.md"
(TARGET_VX && TARGET_HARD_FLOAT) && 
#line 767 "../../gcc/config/s390/s390.md"
(TARGET_VXE2)))
            return -1;
          return 2045; /* *fixuns_truncsfsi2_z13 */

        case 7:
          if (!
#line 5536 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
    && (!TARGET_VX || SImode != DImode || SFmode != DFmode)))
            return -1;
          return 2053; /* *fixuns_truncsfsi2_z196 */

        case 8:
          if (!(
#line 5536 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
    && (!TARGET_VX || SImode != DImode || TFmode != DFmode)) && 
#line 751 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          return 2047; /* *fixuns_trunctfsi2_z196 */

        case 9:
          if (!(
#line 5536 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
    && (!TARGET_VX || SImode != DImode || FPRX2mode != DFmode)) && 
#line 751 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          return 2049; /* *fixuns_truncfprx2si2_z196 */

        case 10:
          if (!
#line 5536 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
    && (!TARGET_VX || SImode != DImode || DFmode != DFmode)))
            return -1;
          return 2051; /* *fixuns_truncdfsi2_z196 */

        case 11:
          if (!(
#line 5536 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
    && (!TARGET_VX || SImode != DImode || TDmode != DFmode)) && 
#line 752 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          return 2055; /* *fixuns_trunctdsi2_z196 */

        case 12:
          if (!(
#line 5536 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
    && (!TARGET_VX || SImode != DImode || DDmode != DFmode)) && 
#line 752 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          return 2057; /* *fixuns_truncddsi2_z196 */

        default:
          return -1;
        }

    case FIX:
      if (pattern42 (x1) != 0)
        return -1;
      switch (pattern151 (x1))
        {
        case 0:
          if (
#line 5559 "../../gcc/config/s390/s390.md"
(TARGET_VX && TARGET_HARD_FLOAT))
            return 2058; /* *fix_truncdfdi2_bfp_z13 */
          if (!(
#line 5572 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
    && (!TARGET_VX || DImode != DImode || DFmode != DFmode)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 2064; /* *fix_truncdfdi2_bfp */

        case 1:
          if (!(
#line 5572 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
    && (!TARGET_VX || DImode != DImode || TFmode != DFmode)) && (((
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH) && 
#line 758 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))))
            return -1;
          return 2060; /* *fix_trunctfdi2_bfp */

        case 2:
          if (!(
#line 5572 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
    && (!TARGET_VX || DImode != DImode || FPRX2mode != DFmode)) && (((
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH) && 
#line 758 "../../gcc/config/s390/s390.md"
(TARGET_VXE)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))))
            return -1;
          return 2062; /* *fix_truncfprx2di2_bfp */

        case 3:
          if (!(
#line 5572 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
    && (!TARGET_VX || DImode != DImode || SFmode != DFmode)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 2066; /* *fix_truncsfdi2_bfp */

        case 4:
          if (!
#line 5606 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && TARGET_HARD_DFP))
            return -1;
          return 2068; /* fix_trunctddi2_dfp */

        case 5:
          if (!
#line 5606 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && TARGET_HARD_DFP))
            return -1;
          return 2069; /* fix_truncdddi2_dfp */

        case 6:
          if ((
#line 5559 "../../gcc/config/s390/s390.md"
(TARGET_VX && TARGET_HARD_FLOAT) && 
#line 767 "../../gcc/config/s390/s390.md"
(TARGET_VXE2)))
            return 2059; /* *fix_truncsfsi2_bfp_z13 */
          if (!
#line 5572 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
    && (!TARGET_VX || SImode != DImode || SFmode != DFmode)))
            return -1;
          return 2067; /* *fix_truncsfsi2_bfp */

        case 7:
          if (!(
#line 5572 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
    && (!TARGET_VX || SImode != DImode || TFmode != DFmode)) && 
#line 758 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          return 2061; /* *fix_trunctfsi2_bfp */

        case 8:
          if (!(
#line 5572 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
    && (!TARGET_VX || SImode != DImode || FPRX2mode != DFmode)) && 
#line 758 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          return 2063; /* *fix_truncfprx2si2_bfp */

        case 9:
          if (!
#line 5572 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
    && (!TARGET_VX || SImode != DImode || DFmode != DFmode)))
            return -1;
          return 2065; /* *fix_truncdfsi2_bfp */

        default:
          return -1;
        }

    case FLOAT_TRUNCATE:
      if (GET_MODE (x3) != E_DDmode)
        return -1;
      x13 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x13) != UNSPEC
          || XVECLEN (x13, 0) != 1
          || XINT (x13, 1) != 0
          || GET_MODE (x13) != E_DImode)
        return -1;
      x14 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x14) != CLOBBER)
        return -1;
      x18 = XEXP (x2, 0);
      operands[0] = x18;
      if (!register_operand (operands[0], E_DDmode))
        return -1;
      x31 = XEXP (x3, 0);
      operands[1] = x31;
      if (!register_operand (operands[1], E_TDmode))
        return -1;
      x32 = XVECEXP (x13, 0, 0);
      operands[2] = x32;
      if (!const_mask_operand (operands[2], E_DImode))
        return -1;
      x17 = XEXP (x14, 0);
      operands[3] = x17;
      if (!scratch_operand (operands[3], E_TDmode)
          || !
#line 5742 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
        return -1;
      return 2099; /* *trunctddd2 */

    case AND:
      if (pattern43 (x1) != 0
          || !
#line 8265 "../../gcc/config/s390/s390.md"
(INTVAL (operands[2]) >= 1 && INTVAL (operands[2]) <= 256))
        return -1;
      return 2367; /* *nc */

    case IOR:
      if (pattern43 (x1) != 0
          || !
#line 8675 "../../gcc/config/s390/s390.md"
(INTVAL (operands[2]) >= 1 && INTVAL (operands[2]) <= 256))
        return -1;
      return 2405; /* *oc */

    case XOR:
      if (pattern43 (x1) != 0
          || !
#line 8948 "../../gcc/config/s390/s390.md"
(INTVAL (operands[2]) >= 1 && INTVAL (operands[2]) <= 256))
        return -1;
      return 2414; /* *xc */

    case IF_THEN_ELSE:
      x31 = XEXP (x3, 0);
      if (!s390_brx_operator (x31, E_VOIDmode))
        return -1;
      operands[6] = x31;
      x33 = XEXP (x31, 0);
      if (GET_CODE (x33) != PLUS)
        return -1;
      x4 = XEXP (x3, 1);
      if (GET_CODE (x4) != LABEL_REF)
        return -1;
      x34 = XEXP (x3, 2);
      if (GET_CODE (x34) != PC)
        return -1;
      x18 = XEXP (x2, 0);
      if (GET_CODE (x18) != PC)
        return -1;
      x13 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x13) != SET)
        return -1;
      x23 = XEXP (x13, 1);
      if (GET_CODE (x23) != PLUS)
        return -1;
      x14 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x14) != CLOBBER)
        return -1;
      switch (pattern230 (x1))
        {
        case 0:
          if (!
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return -1;
          return 2539; /* *brx_stage1_di */

        case 1:
          return 2540; /* *brx_stage1_si */

        default:
          return -1;
        }

    case CALL:
      x31 = XEXP (x3, 0);
      if (GET_CODE (x31) != MEM
          || GET_MODE (x31) != E_QImode)
        return -1;
      x13 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x13) != CLOBBER)
        return -1;
      x18 = XEXP (x2, 0);
      operands[0] = x18;
      x33 = XEXP (x31, 0);
      operands[1] = x33;
      x4 = XEXP (x3, 1);
      operands[2] = x4;
      if (!const_int_operand (operands[2], E_VOIDmode))
        return -1;
      x22 = XEXP (x13, 0);
      operands[3] = x22;
      if (!register_operand (operands[3], E_VOIDmode))
        return -1;
      switch (GET_CODE (operands[1]))
        {
        case REG:
        case SUBREG:
          res = recog_111 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case CONST:
        case SYMBOL_REF:
          if (bras_sym_operand (operands[1], E_VOIDmode))
            {
              x14 = XVECEXP (x1, 0, 2);
              if (GET_CODE (x14) == USE)
                {
                  x17 = XEXP (x14, 0);
                  operands[4] = x17;
                  if (
#line 11119 "../../gcc/config/s390/s390.md"
(!SIBLING_CALL_P (insn)
   && TARGET_SMALL_EXEC
   && GET_MODE (operands[3]) == Pmode))
                    return 2589; /* *bras_tls */
                  if (
#line 11133 "../../gcc/config/s390/s390.md"
(!SIBLING_CALL_P (insn)

   && GET_MODE (operands[3]) == Pmode))
                    return 2590; /* *brasl_tls */
                }
            }
          break;

        default:
          break;
        }
      x14 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x14) != USE
          || !address_operand (operands[1], E_VOIDmode))
        return -1;
      x17 = XEXP (x14, 0);
      operands[4] = x17;
      if (!
#line 11148 "../../gcc/config/s390/s390.md"
(!SIBLING_CALL_P (insn) && GET_MODE (operands[3]) == Pmode))
        return -1;
      return 2591; /* *basr_tls */

    default:
      return -1;
    }
}

 rtx_insn *
peephole2_insns (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22;
  rtx_insn *res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  switch (GET_CODE (x1))
    {
    case SET:
      x2 = XEXP (x1, 0);
      operands[0] = x2;
      x3 = XEXP (x1, 1);
      switch (GET_CODE (x3))
        {
        case REG:
        case SUBREG:
        case MEM:
          if (peep2_current_count >= 2)
            {
              switch (GET_MODE (operands[0]))
                {
                case E_DImode:
                  if (register_operand (operands[0], E_DImode))
                    {
                      operands[2] = x3;
                      x4 = PATTERN (peep2_next_insn (1));
                      if (pattern127 (x4, 
E_DImode) == 0
                          && (
#line 1112 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (peep2_next_insn (1), CCSmode) && TARGET_EXTIMM
   && GENERAL_REG_P (operands[0])
   && satisfies_constraint_T (operands[2])
   && !contains_constant_pool_address_p (operands[2])) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                        {
                          *pmatch_len_ = 1;
                          res = gen_peephole2_1 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                        }
                      operands[1] = x3;
                      if (pattern128 (x4, 
E_DImode) == 0
                          && 
#line 2338 "../../gcc/config/s390/s390.md"
(TARGET_64BIT
   && !reg_overlap_mentioned_p (operands[0], operands[2])
   && preferred_la_operand_p (operands[1], operands[2])))
                        {
                          *pmatch_len_ = 1;
                          res = gen_peephole2_11 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                        }
                    }
                  break;

                case E_SImode:
                  if (register_operand (operands[0], E_SImode))
                    {
                      operands[2] = x3;
                      x4 = PATTERN (peep2_next_insn (1));
                      if (pattern127 (x4, 
E_SImode) == 0
                          && 
#line 1112 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (peep2_next_insn (1), CCSmode) && TARGET_EXTIMM
   && GENERAL_REG_P (operands[0])
   && satisfies_constraint_T (operands[2])
   && !contains_constant_pool_address_p (operands[2])))
                        {
                          *pmatch_len_ = 1;
                          res = gen_peephole2_2 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                        }
                      operands[1] = x3;
                      if (pattern128 (x4, 
E_SImode) == 0
                          && 
#line 2565 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT
   && !reg_overlap_mentioned_p (operands[0], operands[2])
   && preferred_la_operand_p (operands[1], operands[2])))
                        {
                          *pmatch_len_ = 1;
                          res = gen_peephole2_15 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                        }
                    }
                  break;

                default:
                  break;
                }
            }
          if (GET_CODE (x3) == MEM)
            {
              x5 = XEXP (x3, 0);
              operands[1] = x5;
              if (address_operand (operands[1], E_VOIDmode))
                {
                  switch (GET_MODE (operands[0]))
                    {
                    case E_DImode:
                      if (register_operand (operands[0], E_DImode)
                          && GET_MODE (x3) == E_DImode
                          && 
#line 2299 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH
   && !FP_REG_P (operands[0])
   && GET_CODE (operands[1]) == SYMBOL_REF
   && CONSTANT_POOL_ADDRESS_P (operands[1])
   && get_pool_mode (operands[1]) == DImode
   && legitimate_reload_constant_p (get_pool_constant (operands[1]))))
                        {
                          *pmatch_len_ = 0;
                          res = gen_peephole2_9 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                        }
                      break;

                    case E_SImode:
                      if (register_operand (operands[0], E_SImode)
                          && GET_MODE (x3) == E_SImode
                          && 
#line 2527 "../../gcc/config/s390/s390.md"
(!FP_REG_P (operands[0])
   && GET_CODE (operands[1]) == SYMBOL_REF
   && CONSTANT_POOL_ADDRESS_P (operands[1])
   && get_pool_mode (operands[1]) == SImode
   && legitimate_reload_constant_p (get_pool_constant (operands[1]))))
                        {
                          *pmatch_len_ = 0;
                          res = gen_peephole2_13 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                        }
                      break;

                    case E_HImode:
                      if (register_operand (operands[0], E_HImode)
                          && GET_MODE (x3) == E_HImode
                          && 
#line 2670 "../../gcc/config/s390/s390.md"
(GET_CODE (operands[1]) == SYMBOL_REF
   && CONSTANT_POOL_ADDRESS_P (operands[1])
   && get_pool_mode (operands[1]) == HImode
   && GET_CODE (get_pool_constant (operands[1])) == CONST_INT))
                        {
                          *pmatch_len_ = 0;
                          res = gen_peephole2_16 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                        }
                      break;

                    case E_QImode:
                      if (nonimmediate_operand (operands[0], E_QImode)
                          && GET_MODE (x3) == E_QImode
                          && 
#line 2735 "../../gcc/config/s390/s390.md"
(GET_CODE (operands[1]) == SYMBOL_REF
   && CONSTANT_POOL_ADDRESS_P (operands[1])
   && get_pool_mode (operands[1]) == QImode
   && GET_CODE (get_pool_constant (operands[1])) == CONST_INT))
                        {
                          *pmatch_len_ = 0;
                          res = gen_peephole2_17 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                        }
                      break;

                    default:
                      break;
                    }
                }
            }
          operands[1] = x3;
          if (!memory_operand (operands[1], E_DImode)
              || !register_operand (operands[0], E_DImode)
              || !
#line 2350 "../../gcc/config/s390/s390.md"
(TARGET_64BIT
   && TARGET_EXTIMM
   && GENERAL_REG_P (operands[0])
   && s390_const_int_pool_entry_p (operands[1], nullptr)
   && peep2_reg_dead_p (1, gen_rtx_REG (CCmode, CC_REGNUM))))
            return NULL;
          *pmatch_len_ = 0;
          return gen_peephole2_12 (insn, operands);

        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_DOUBLE:
        case CONST_VECTOR:
          if (peep2_current_count < 2)
            return NULL;
          operands[1] = x3;
          x4 = PATTERN (peep2_next_insn (1));
          if (GET_CODE (x4) != SET)
            return NULL;
          x6 = XEXP (x4, 1);
          if (GET_CODE (x6) != COMPARE
              || GET_MODE (x6) != E_CCZmode)
            return NULL;
          x7 = XEXP (x4, 0);
          if (GET_CODE (x7) != REG
              || REGNO (x7) != 33
              || GET_MODE (x7) != E_CCZmode)
            return NULL;
          x8 = XEXP (x6, 0);
          operands[2] = x8;
          x9 = XEXP (x6, 1);
          operands[3] = x9;
          switch (GET_MODE (operands[0]))
            {
            case E_TFmode:
              if (pattern242 (
E_TFmode) != 0
                  || !(
#line 1545 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
   && FP_REG_P (operands[2])
   && REGNO (operands[0]) == REGNO (operands[3])
   && peep2_reg_dead_p (2, operands[0])
   && peep2_reg_dead_p (2, operands[2])) && 
#line 751 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return NULL;
              *pmatch_len_ = 1;
              return gen_peephole2_3 (insn, operands);

            case E_FPRX2mode:
              if (pattern242 (
E_FPRX2mode) != 0
                  || !(
#line 1545 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
   && FP_REG_P (operands[2])
   && REGNO (operands[0]) == REGNO (operands[3])
   && peep2_reg_dead_p (2, operands[0])
   && peep2_reg_dead_p (2, operands[2])) && 
#line 751 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return NULL;
              *pmatch_len_ = 1;
              return gen_peephole2_4 (insn, operands);

            case E_DFmode:
              if (pattern242 (
E_DFmode) != 0
                  || !
#line 1545 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
   && FP_REG_P (operands[2])
   && REGNO (operands[0]) == REGNO (operands[3])
   && peep2_reg_dead_p (2, operands[0])
   && peep2_reg_dead_p (2, operands[2])))
                return NULL;
              *pmatch_len_ = 1;
              return gen_peephole2_5 (insn, operands);

            case E_SFmode:
              if (pattern242 (
E_SFmode) != 0
                  || !
#line 1545 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
   && FP_REG_P (operands[2])
   && REGNO (operands[0]) == REGNO (operands[3])
   && peep2_reg_dead_p (2, operands[0])
   && peep2_reg_dead_p (2, operands[2])))
                return NULL;
              *pmatch_len_ = 1;
              return gen_peephole2_6 (insn, operands);

            case E_TDmode:
              if (pattern242 (
E_TDmode) != 0
                  || !(
#line 1545 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
   && FP_REG_P (operands[2])
   && REGNO (operands[0]) == REGNO (operands[3])
   && peep2_reg_dead_p (2, operands[0])
   && peep2_reg_dead_p (2, operands[2])) && 
#line 752 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
                return NULL;
              *pmatch_len_ = 1;
              return gen_peephole2_7 (insn, operands);

            case E_DDmode:
              if (pattern242 (
E_DDmode) != 0
                  || !(
#line 1545 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
   && FP_REG_P (operands[2])
   && REGNO (operands[0]) == REGNO (operands[3])
   && peep2_reg_dead_p (2, operands[0])
   && peep2_reg_dead_p (2, operands[2])) && 
#line 752 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
                return NULL;
              *pmatch_len_ = 1;
              return gen_peephole2_8 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case PARALLEL:
      switch (XVECLEN (x1, 0))
        {
        case 2:
          x10 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x10) != SET)
            return NULL;
          x11 = XEXP (x10, 0);
          operands[0] = x11;
          x12 = XEXP (x10, 1);
          operands[1] = x12;
          x13 = XVECEXP (x1, 0, 1);
          switch (GET_CODE (x13))
            {
            case CLOBBER:
              x14 = XEXP (x13, 0);
              if (GET_CODE (x14) != REG
                  || REGNO (x14) != 33
                  || GET_MODE (x14) != E_CCmode
                  || !address_operand (operands[1], E_QImode))
                return NULL;
              switch (GET_MODE (operands[0]))
                {
                case E_DImode:
                  if (!register_operand (operands[0], E_DImode)
                      || !
#line 2325 "../../gcc/config/s390/s390.md"
(TARGET_64BIT
   && preferred_la_operand_p (operands[1], const0_rtx)))
                    return NULL;
                  *pmatch_len_ = 0;
                  return gen_peephole2_10 (insn, operands);

                case E_SImode:
                  if (!register_operand (operands[0], E_SImode)
                      || !
#line 2552 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT
   && preferred_la_operand_p (operands[1], const0_rtx)))
                    return NULL;
                  *pmatch_len_ = 0;
                  return gen_peephole2_14 (insn, operands);

                default:
                  return NULL;
                }

            case USE:
              if (peep2_current_count >= 2)
                {
                  res = peephole2_1 (x1, insn, pmatch_len_);
                  if (res != NULL_RTX)
                    return res;
                }
              if (!plus16_Q_operand (operands[0], E_BLKmode)
                  || !plus16_Q_operand (operands[1], E_BLKmode))
                return NULL;
              x14 = XEXP (x13, 0);
              operands[2] = x14;
              if (!const_int_operand (operands[2], E_VOIDmode)
                  || !
#line 3161 "../../gcc/config/s390/s390.md"
(INTVAL (operands[2]) > 16 && INTVAL (operands[2]) <= 32))
                return NULL;
              *pmatch_len_ = 0;
              return gen_peephole2_19 (insn, operands);

            default:
              return NULL;
            }

        case 3:
          if (peep2_current_count < 2)
            return NULL;
          x10 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x10) != SET)
            return NULL;
          x13 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x13) != USE)
            return NULL;
          x15 = XVECEXP (x1, 0, 2);
          if (pattern41 (x15) != 0)
            return NULL;
          x11 = XEXP (x10, 0);
          operands[0] = x11;
          if (!memory_operand (operands[0], E_BLKmode))
            return NULL;
          x14 = XEXP (x13, 0);
          if (!const_int_operand (x14, E_VOIDmode))
            return NULL;
          x4 = PATTERN (peep2_next_insn (1));
          if (pattern197 (x4, 
3) != 0)
            return NULL;
          x16 = XVECEXP (x4, 0, 2);
          if (GET_CODE (x16) != CLOBBER)
            return NULL;
          x17 = XEXP (x16, 0);
          if (GET_CODE (x17) != REG
              || REGNO (x17) != 33
              || GET_MODE (x17) != E_CCmode)
            return NULL;
          x18 = XVECEXP (x4, 0, 0);
          x19 = XEXP (x18, 0);
          if (!memory_operand (x19, E_BLKmode))
            return NULL;
          x20 = XVECEXP (x4, 0, 1);
          x21 = XEXP (x20, 0);
          if (!const_int_operand (x21, E_VOIDmode))
            return NULL;
          x12 = XEXP (x10, 1);
          switch (GET_CODE (x12))
            {
            case AND:
              if (pattern293 (x1, 
AND) != 0
                  || !
#line 8301 "../../gcc/config/s390/s390.md"
(s390_offset_p (operands[0], operands[3], operands[2])
   && s390_offset_p (operands[1], operands[4], operands[2])
   && !s390_overlap_p (operands[0], operands[1],
                       INTVAL (operands[2]) + INTVAL (operands[5]))
   && INTVAL (operands[2]) + INTVAL (operands[5]) <= 256))
                return NULL;
              *pmatch_len_ = 1;
              return gen_peephole2_20 (insn, operands);

            case IOR:
              if (pattern293 (x1, 
IOR) != 0
                  || !
#line 8711 "../../gcc/config/s390/s390.md"
(s390_offset_p (operands[0], operands[3], operands[2])
   && s390_offset_p (operands[1], operands[4], operands[2])
   && !s390_overlap_p (operands[0], operands[1],
                       INTVAL (operands[2]) + INTVAL (operands[5]))
   && INTVAL (operands[2]) + INTVAL (operands[5]) <= 256))
                return NULL;
              *pmatch_len_ = 1;
              return gen_peephole2_21 (insn, operands);

            case XOR:
              if (pattern293 (x1, 
XOR) != 0
                  || !
#line 8983 "../../gcc/config/s390/s390.md"
(s390_offset_p (operands[0], operands[3], operands[2])
   && s390_offset_p (operands[1], operands[4], operands[2])
   && !s390_overlap_p (operands[0], operands[1],
                       INTVAL (operands[2]) + INTVAL (operands[5]))
   && INTVAL (operands[2]) + INTVAL (operands[5]) <= 256))
                return NULL;
              *pmatch_len_ = 1;
              return gen_peephole2_22 (insn, operands);

            case CONST_INT:
              if (XWINT (x12, 0) != 0L)
                return NULL;
              operands[1] = x14;
              x22 = XEXP (x18, 1);
              if (x22 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return NULL;
              operands[2] = x19;
              operands[3] = x21;
              if (!
#line 9021 "../../gcc/config/s390/s390.md"
(s390_offset_p (operands[0], operands[2], operands[1])
   && INTVAL (operands[1]) + INTVAL (operands[3]) <= 256))
                return NULL;
              *pmatch_len_ = 1;
              return gen_peephole2_23 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}
